/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies). 
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of the License "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
*
*/

#include <e32std.h>
#include <convdata.h>
#include <convgeneratedcpp.h>

#define ARRAY_LENGTH(aArray) (sizeof(aArray)/sizeof((aArray)[0]))

#pragma warning (disable: 4049) // compiler limit : terminating line number emission

_LIT8(KLit8ReplacementForUnconvertibleUnicodeCharacters, "\xa3\xbf");

GLDEF_C const TDesC8& ReplacementForUnconvertibleUnicodeCharacters_internal()
	{
	return KLit8ReplacementForUnconvertibleUnicodeCharacters;
	}

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_1[]=
	{
		{
		0x723b
		},
		{
		0x80b4
		},
		{
		0x9175
		},
		{
		0x9a4d
		},
		{
		0x4faf
		},
		{
		0x5019
		},
		{
		0x539a
		},
		{
		0x540e
		},
		{
		0x543c
		},
		{
		0x5589
		},
		{
		0x55c5
		},
		{
		0x5e3f
		},
		{
		0x5f8c
		},
		{
		0x673d
		},
		{
		0x7166
		},
		{
		0x73dd
		},
		{
		0x9005
		},
		{
		0x52db
		},
		{
		0x52f3
		},
		{
		0x5864
		},
		{
		0x58ce
		},
		{
		0x7104
		},
		{
		0x718f
		},
		{
		0x71fb
		},
		{
		0x85b0
		},
		{
		0x8a13
		},
		{
		0x6688
		},
		{
		0x85a8
		},
		{
		0x55a7
		},
		{
		0x6684
		},
		{
		0x714a
		},
		{
		0x8431
		},
		{
		0x5349
		},
		{
		0x5599
		},
		{
		0x6bc1
		},
		{
		0x5f59
		},
		{
		0x5fbd
		},
		{
		0x63ee
		},
		{
		0x6689
		},
		{
		0x7147
		},
		{
		0x8af1
		},
		{
		0x8f1d
		},
		{
		0x9ebe
		},
		{
		0x4f11
		},
		{
		0x643a
		},
		{
		0x70cb
		},
		{
		0x7566
		},
		{
		0x8667
		},
		{
		0x6064
		},
		{
		0x8b4e
		},
		{
		0x9df8
		},
		{
		0x5147
		},
		{
		0x51f6
		},
		{
		0x5308
		},
		{
		0x6d36
		},
		{
		0x80f8
		},
		{
		0x9ed1
		},
		{
		0x6615
		},
		{
		0x6b23
		},
		{
		0x7098
		},
		{
		0x75d5
		},
		{
		0x5403
		},
		{
		0x5c79
		},
		{
		0x7d07
		},
		{
		0x8a16
		},
		{
		0x6b20
		},
		{
		0x6b3d
		},
		{
		0x6b46
		},
		{
		0x5438
		},
		{
		0x6070
		},
		{
		0x6d3d
		},
		{
		0x7fd5
		},
		{
		0x8208
		},
		{
		0x50d6
		},
		{
		0x51de
		},
		{
		0x559c
		},
		{
		0x566b
		},
		{
		0x56cd
		},
		{
		0x59ec
		},
		{
		0x5b09
		},
		{
		0x5e0c
		},
		{
		0x6199
		},
		{
		0x6198
		},
		{
		0x6231
		},
		{
		0x665e
		},
		{
		0x66e6
		},
		{
		0x7199
		},
		{
		0x71b9
		},
		{
		0x71ba
		},
		{
		0x72a7
		},
		{
		0x79a7
		},
		{
		0x7a00
		},
		{
		0x7fb2
		},
		{
		0x8a70
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_2[]=
	{
		{
		0x798d
		},
		{
		0x79be
		},
		{
		0x82b1
		},
		{
		0x83ef
		},
		{
		0x8a71
		},
		{
		0x8b41
		},
		{
		0x8ca8
		},
		{
		0x9774
		},
		{
		0xfa0b
		},
		{
		0x64f4
		},
		{
		0x652b
		},
		{
		0x78ba
		},
		{
		0x78bb
		},
		{
		0x7a6b
		},
		{
		0x4e38
		},
		{
		0x559a
		},
		{
		0x5950
		},
		{
		0x5ba6
		},
		{
		0x5e7b
		},
		{
		0x60a3
		},
		{
		0x63db
		},
		{
		0x6b61
		},
		{
		0x6665
		},
		{
		0x6853
		},
		{
		0x6e19
		},
		{
		0x7165
		},
		{
		0x74b0
		},
		{
		0x7d08
		},
		{
		0x9084
		},
		{
		0x9a69
		},
		{
		0x9c25
		},
		{
		0x6d3b
		},
		{
		0x6ed1
		},
		{
		0x733e
		},
		{
		0x8c41
		},
		{
		0x95ca
		},
		{
		0x51f0
		},
		{
		0x5e4c
		},
		{
		0x5fa8
		},
		{
		0x604d
		},
		{
		0x60f6
		},
		{
		0x6130
		},
		{
		0x614c
		},
		{
		0x6643
		},
		{
		0x6644
		},
		{
		0x69a5
		},
		{
		0x6cc1
		},
		{
		0x6e5f
		},
		{
		0x6ec9
		},
		{
		0x6f62
		},
		{
		0x714c
		},
		{
		0x749c
		},
		{
		0x7687
		},
		{
		0x7bc1
		},
		{
		0x7c27
		},
		{
		0x8352
		},
		{
		0x8757
		},
		{
		0x9051
		},
		{
		0x968d
		},
		{
		0x9ec3
		},
		{
		0x532f
		},
		{
		0x56de
		},
		{
		0x5efb
		},
		{
		0x5f8a
		},
		{
		0x6062
		},
		{
		0x6094
		},
		{
		0x61f7
		},
		{
		0x6666
		},
		{
		0x6703
		},
		{
		0x6a9c
		},
		{
		0x6dee
		},
		{
		0x6fae
		},
		{
		0x7070
		},
		{
		0x736a
		},
		{
		0x7e6a
		},
		{
		0x81be
		},
		{
		0x8334
		},
		{
		0x86d4
		},
		{
		0x8aa8
		},
		{
		0x8cc4
		},
		{
		0x5283
		},
		{
		0x7372
		},
		{
		0x5b96
		},
		{
		0x6a6b
		},
		{
		0x9404
		},
		{
		0x54ee
		},
		{
		0x5686
		},
		{
		0x5b5d
		},
		{
		0x6548
		},
		{
		0x6585
		},
		{
		0x66c9
		},
		{
		0x689f
		},
		{
		0x6d8d
		},
		{
		0x6dc6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_3[]=
	{
		{
		0x5f62
		},
		{
		0x6cc2
		},
		{
		0x6ece
		},
		{
		0x7005
		},
		{
		0x7050
		},
		{
		0x70af
		},
		{
		0x7192
		},
		{
		0x73e9
		},
		{
		0x7469
		},
		{
		0x834a
		},
		{
		0x87a2
		},
		{
		0x8861
		},
		{
		0x9008
		},
		{
		0x90a2
		},
		{
		0x93a3
		},
		{
		0x99a8
		},
		{
		0x516e
		},
		{
		0x5f57
		},
		{
		0x60e0
		},
		{
		0x6167
		},
		{
		0x66b3
		},
		{
		0x8559
		},
		{
		0x8e4a
		},
		{
		0x91af
		},
		{
		0x978b
		},
		{
		0x4e4e
		},
		{
		0x4e92
		},
		{
		0x547c
		},
		{
		0x58d5
		},
		{
		0x58fa
		},
		{
		0x597d
		},
		{
		0x5cb5
		},
		{
		0x5f27
		},
		{
		0x6236
		},
		{
		0x6248
		},
		{
		0x660a
		},
		{
		0x6667
		},
		{
		0x6beb
		},
		{
		0x6d69
		},
		{
		0x6dcf
		},
		{
		0x6e56
		},
		{
		0x6ef8
		},
		{
		0x6f94
		},
		{
		0x6fe0
		},
		{
		0x6fe9
		},
		{
		0x705d
		},
		{
		0x72d0
		},
		{
		0x7425
		},
		{
		0x745a
		},
		{
		0x74e0
		},
		{
		0x7693
		},
		{
		0x795c
		},
		{
		0x7cca
		},
		{
		0x7e1e
		},
		{
		0x80e1
		},
		{
		0x82a6
		},
		{
		0x846b
		},
		{
		0x84bf
		},
		{
		0x864e
		},
		{
		0x865f
		},
		{
		0x8774
		},
		{
		0x8b77
		},
		{
		0x8c6a
		},
		{
		0x93ac
		},
		{
		0x9800
		},
		{
		0x9865
		},
		{
		0x60d1
		},
		{
		0x6216
		},
		{
		0x9177
		},
		{
		0x5a5a
		},
		{
		0x660f
		},
		{
		0x6df7
		},
		{
		0x6e3e
		},
		{
		0x743f
		},
		{
		0x9b42
		},
		{
		0x5ffd
		},
		{
		0x60da
		},
		{
		0x7b0f
		},
		{
		0x54c4
		},
		{
		0x5f18
		},
		{
		0x6c5e
		},
		{
		0x6cd3
		},
		{
		0x6d2a
		},
		{
		0x70d8
		},
		{
		0x7d05
		},
		{
		0x8679
		},
		{
		0x8a0c
		},
		{
		0x9d3b
		},
		{
		0x5316
		},
		{
		0x548c
		},
		{
		0x5b05
		},
		{
		0x6a3a
		},
		{
		0x706b
		},
		{
		0x7575
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_4[]=
	{
		{
		0xfa08
		},
		{
		0xfa09
		},
		{
		0x9805
		},
		{
		0x4ea5
		},
		{
		0x5055
		},
		{
		0x54b3
		},
		{
		0x5793
		},
		{
		0x595a
		},
		{
		0x5b69
		},
		{
		0x5bb3
		},
		{
		0x61c8
		},
		{
		0x6977
		},
		{
		0x6d77
		},
		{
		0x7023
		},
		{
		0x87f9
		},
		{
		0x89e3
		},
		{
		0x8a72
		},
		{
		0x8ae7
		},
		{
		0x9082
		},
		{
		0x99ed
		},
		{
		0x9ab8
		},
		{
		0x52be
		},
		{
		0x6838
		},
		{
		0x5016
		},
		{
		0x5e78
		},
		{
		0x674f
		},
		{
		0x8347
		},
		{
		0x884c
		},
		{
		0x4eab
		},
		{
		0x5411
		},
		{
		0x56ae
		},
		{
		0x73e6
		},
		{
		0x9115
		},
		{
		0x97ff
		},
		{
		0x9909
		},
		{
		0x9957
		},
		{
		0x9999
		},
		{
		0x5653
		},
		{
		0x589f
		},
		{
		0x865b
		},
		{
		0x8a31
		},
		{
		0x61b2
		},
		{
		0x6af6
		},
		{
		0x737b
		},
		{
		0x8ed2
		},
		{
		0x6b47
		},
		{
		0x96aa
		},
		{
		0x9a57
		},
		{
		0x5955
		},
		{
		0x7200
		},
		{
		0x8d6b
		},
		{
		0x9769
		},
		{
		0x4fd4
		},
		{
		0x5cf4
		},
		{
		0x5f26
		},
		{
		0x61f8
		},
		{
		0x665b
		},
		{
		0x6ceb
		},
		{
		0x70ab
		},
		{
		0x7384
		},
		{
		0x73b9
		},
		{
		0x73fe
		},
		{
		0x7729
		},
		{
		0x774d
		},
		{
		0x7d43
		},
		{
		0x7d62
		},
		{
		0x7e23
		},
		{
		0x8237
		},
		{
		0x8852
		},
		{
		0xfa0a
		},
		{
		0x8ce2
		},
		{
		0x9249
		},
		{
		0x986f
		},
		{
		0x5b51
		},
		{
		0x7a74
		},
		{
		0x8840
		},
		{
		0x9801
		},
		{
		0x5acc
		},
		{
		0x4fe0
		},
		{
		0x5354
		},
		{
		0x593e
		},
		{
		0x5cfd
		},
		{
		0x633e
		},
		{
		0x6d79
		},
		{
		0x72f9
		},
		{
		0x8105
		},
		{
		0x8107
		},
		{
		0x83a2
		},
		{
		0x92cf
		},
		{
		0x9830
		},
		{
		0x4ea8
		},
		{
		0x5144
		},
		{
		0x5211
		},
		{
		0x578b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_5[]=
	{
		{
		0x54c1
		},
		{
		0x7a1f
		},
		{
		0x6953
		},
		{
		0x8af7
		},
		{
		0x8c4a
		},
		{
		0x98a8
		},
		{
		0x99ae
		},
		{
		0x5f7c
		},
		{
		0x62ab
		},
		{
		0x75b2
		},
		{
		0x76ae
		},
		{
		0x88ab
		},
		{
		0x907f
		},
		{
		0x9642
		},
		{
		0x5339
		},
		{
		0x5f3c
		},
		{
		0x5fc5
		},
		{
		0x6ccc
		},
		{
		0x73cc
		},
		{
		0x7562
		},
		{
		0x758b
		},
		{
		0x7b46
		},
		{
		0x82fe
		},
		{
		0x999d
		},
		{
		0x4e4f
		},
		{
		0x903c
		},
		{
		0x4e0b
		},
		{
		0x4f55
		},
		{
		0x53a6
		},
		{
		0x590f
		},
		{
		0x5ec8
		},
		{
		0x6630
		},
		{
		0x6cb3
		},
		{
		0x7455
		},
		{
		0x8377
		},
		{
		0x8766
		},
		{
		0x8cc0
		},
		{
		0x9050
		},
		{
		0x971e
		},
		{
		0x9c15
		},
		{
		0x58d1
		},
		{
		0x5b78
		},
		{
		0x8650
		},
		{
		0x8b14
		},
		{
		0x9db4
		},
		{
		0x5bd2
		},
		{
		0x6068
		},
		{
		0x608d
		},
		{
		0x65f1
		},
		{
		0x6c57
		},
		{
		0x6f22
		},
		{
		0x6fa3
		},
		{
		0x701a
		},
		{
		0x7f55
		},
		{
		0x7ff0
		},
		{
		0x9591
		},
		{
		0x9592
		},
		{
		0x9650
		},
		{
		0x97d3
		},
		{
		0x5272
		},
		{
		0x8f44
		},
		{
		0x51fd
		},
		{
		0x542b
		},
		{
		0x54b8
		},
		{
		0x5563
		},
		{
		0x558a
		},
		{
		0x6abb
		},
		{
		0x6db5
		},
		{
		0x7dd8
		},
		{
		0x8266
		},
		{
		0x929c
		},
		{
		0x9677
		},
		{
		0x9e79
		},
		{
		0x5408
		},
		{
		0x54c8
		},
		{
		0x76d2
		},
		{
		0x86e4
		},
		{
		0x95a4
		},
		{
		0x95d4
		},
		{
		0x965c
		},
		{
		0x4ea2
		},
		{
		0x4f09
		},
		{
		0x59ee
		},
		{
		0x5ae6
		},
		{
		0x5df7
		},
		{
		0x6052
		},
		{
		0x6297
		},
		{
		0x676d
		},
		{
		0x6841
		},
		{
		0x6c86
		},
		{
		0x6e2f
		},
		{
		0x7f38
		},
		{
		0x809b
		},
		{
		0x822a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_6[]=
	{
		{
		0x962a
		},
		{
		0x516b
		},
		{
		0x53ed
		},
		{
		0x634c
		},
		{
		0x4f69
		},
		{
		0x5504
		},
		{
		0x6096
		},
		{
		0x6557
		},
		{
		0x6c9b
		},
		{
		0x6d7f
		},
		{
		0x724c
		},
		{
		0x72fd
		},
		{
		0x7a17
		},
		{
		0x8987
		},
		{
		0x8c9d
		},
		{
		0x5f6d
		},
		{
		0x6f8e
		},
		{
		0x70f9
		},
		{
		0x81a8
		},
		{
		0x610e
		},
		{
		0x4fbf
		},
		{
		0x504f
		},
		{
		0x6241
		},
		{
		0x7247
		},
		{
		0x7bc7
		},
		{
		0x7de8
		},
		{
		0x7fe9
		},
		{
		0x904d
		},
		{
		0x97ad
		},
		{
		0x9a19
		},
		{
		0x8cb6
		},
		{
		0x576a
		},
		{
		0x5e73
		},
		{
		0x67b0
		},
		{
		0x840d
		},
		{
		0x8a55
		},
		{
		0x5420
		},
		{
		0x5b16
		},
		{
		0x5e63
		},
		{
		0x5ee2
		},
		{
		0x5f0a
		},
		{
		0x6583
		},
		{
		0x80ba
		},
		{
		0x853d
		},
		{
		0x9589
		},
		{
		0x965b
		},
		{
		0x4f48
		},
		{
		0x5305
		},
		{
		0x530d
		},
		{
		0x530f
		},
		{
		0x5486
		},
		{
		0x54fa
		},
		{
		0x5703
		},
		{
		0x5e03
		},
		{
		0x6016
		},
		{
		0x629b
		},
		{
		0x62b1
		},
		{
		0x6355
		},
		{
		0xfa06
		},
		{
		0x6ce1
		},
		{
		0x6d66
		},
		{
		0x75b1
		},
		{
		0x7832
		},
		{
		0x80de
		},
		{
		0x812f
		},
		{
		0x82de
		},
		{
		0x8461
		},
		{
		0x84b2
		},
		{
		0x888d
		},
		{
		0x8912
		},
		{
		0x900b
		},
		{
		0x92ea
		},
		{
		0x98fd
		},
		{
		0x9b91
		},
		{
		0x5e45
		},
		{
		0x66b4
		},
		{
		0x66dd
		},
		{
		0x7011
		},
		{
		0x7206
		},
		{
		0xfa07
		},
		{
		0x4ff5
		},
		{
		0x527d
		},
		{
		0x5f6a
		},
		{
		0x6153
		},
		{
		0x6753
		},
		{
		0x6a19
		},
		{
		0x6f02
		},
		{
		0x74e2
		},
		{
		0x7968
		},
		{
		0x8868
		},
		{
		0x8c79
		},
		{
		0x98c7
		},
		{
		0x98c4
		},
		{
		0x9a43
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_7[]=
	{
		{
		0x9438
		},
		{
		0x5451
		},
		{
		0x5606
		},
		{
		0x5766
		},
		{
		0x5f48
		},
		{
		0x619a
		},
		{
		0x6b4e
		},
		{
		0x7058
		},
		{
		0x70ad
		},
		{
		0x7dbb
		},
		{
		0x8a95
		},
		{
		0x596a
		},
		{
		0x812b
		},
		{
		0x63a2
		},
		{
		0x7708
		},
		{
		0x803d
		},
		{
		0x8caa
		},
		{
		0x5854
		},
		{
		0x642d
		},
		{
		0x69bb
		},
		{
		0x5b95
		},
		{
		0x5e11
		},
		{
		0x6e6f
		},
		{
		0xfa03
		},
		{
		0x8569
		},
		{
		0x514c
		},
		{
		0x53f0
		},
		{
		0x592a
		},
		{
		0x6020
		},
		{
		0x614b
		},
		{
		0x6b86
		},
		{
		0x6c70
		},
		{
		0x6cf0
		},
		{
		0x7b1e
		},
		{
		0x80ce
		},
		{
		0x82d4
		},
		{
		0x8dc6
		},
		{
		0x90b0
		},
		{
		0x98b1
		},
		{
		0xfa04
		},
		{
		0x64c7
		},
		{
		0x6fa4
		},
		{
		0x6491
		},
		{
		0x6504
		},
		{
		0x514e
		},
		{
		0x5410
		},
		{
		0x571f
		},
		{
		0x8a0e
		},
		{
		0x615f
		},
		{
		0x6876
		},
		{
		0xfa05
		},
		{
		0x75db
		},
		{
		0x7b52
		},
		{
		0x7d71
		},
		{
		0x901a
		},
		{
		0x5806
		},
		{
		0x69cc
		},
		{
		0x817f
		},
		{
		0x892a
		},
		{
		0x9000
		},
		{
		0x9839
		},
		{
		0x5078
		},
		{
		0x5957
		},
		{
		0x59ac
		},
		{
		0x6295
		},
		{
		0x900f
		},
		{
		0x9b2a
		},
		{
		0x615d
		},
		{
		0x7279
		},
		{
		0x95d6
		},
		{
		0x5761
		},
		{
		0x5a46
		},
		{
		0x5df4
		},
		{
		0x628a
		},
		{
		0x64ad
		},
		{
		0x64fa
		},
		{
		0x6777
		},
		{
		0x6ce2
		},
		{
		0x6d3e
		},
		{
		0x722c
		},
		{
		0x7436
		},
		{
		0x7834
		},
		{
		0x7f77
		},
		{
		0x82ad
		},
		{
		0x8ddb
		},
		{
		0x9817
		},
		{
		0x5224
		},
		{
		0x5742
		},
		{
		0x677f
		},
		{
		0x7248
		},
		{
		0x74e3
		},
		{
		0x8ca9
		},
		{
		0x8fa6
		},
		{
		0x9211
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_8[]=
	{
		{
		0x8d05
		},
		{
		0x53d6
		},
		{
		0x5439
		},
		{
		0x5634
		},
		{
		0x5a36
		},
		{
		0x5c31
		},
		{
		0x708a
		},
		{
		0x7fe0
		},
		{
		0x805a
		},
		{
		0x8106
		},
		{
		0x81ed
		},
		{
		0x8da3
		},
		{
		0x9189
		},
		{
		0x9a5f
		},
		{
		0x9df2
		},
		{
		0x5074
		},
		{
		0x4ec4
		},
		{
		0x53a0
		},
		{
		0x60fb
		},
		{
		0x6e2c
		},
		{
		0x5c64
		},
		{
		0x4f88
		},
		{
		0x5024
		},
		{
		0x55e4
		},
		{
		0x5cd9
		},
		{
		0x5e5f
		},
		{
		0x6065
		},
		{
		0x6894
		},
		{
		0x6cbb
		},
		{
		0x6dc4
		},
		{
		0x71be
		},
		{
		0x75d4
		},
		{
		0x75f4
		},
		{
		0x7661
		},
		{
		0x7a1a
		},
		{
		0x7a49
		},
		{
		0x7dc7
		},
		{
		0x7dfb
		},
		{
		0x7f6e
		},
		{
		0x81f4
		},
		{
		0x86a9
		},
		{
		0x8f1c
		},
		{
		0x96c9
		},
		{
		0x99b3
		},
		{
		0x9f52
		},
		{
		0x5247
		},
		{
		0x52c5
		},
		{
		0x98ed
		},
		{
		0x89aa
		},
		{
		0x4e03
		},
		{
		0x67d2
		},
		{
		0x6f06
		},
		{
		0x4fb5
		},
		{
		0x5be2
		},
		{
		0x6795
		},
		{
		0x6c88
		},
		{
		0x6d78
		},
		{
		0x741b
		},
		{
		0x7827
		},
		{
		0x91dd
		},
		{
		0x937c
		},
		{
		0x87c4
		},
		{
		0x79e4
		},
		{
		0x7a31
		},
		{
		0x5feb
		},
		{
		0x4ed6
		},
		{
		0x54a4
		},
		{
		0x553e
		},
		{
		0x58ae
		},
		{
		0x59a5
		},
		{
		0x60f0
		},
		{
		0x6253
		},
		{
		0x62d6
		},
		{
		0x6736
		},
		{
		0x6955
		},
		{
		0x8235
		},
		{
		0x9640
		},
		{
		0x99b1
		},
		{
		0x99dd
		},
		{
		0x502c
		},
		{
		0x5353
		},
		{
		0x5544
		},
		{
		0x577c
		},
		{
		0xfa01
		},
		{
		0x6258
		},
		{
		0xfa02
		},
		{
		0x64e2
		},
		{
		0x666b
		},
		{
		0x67dd
		},
		{
		0x6fc1
		},
		{
		0x6fef
		},
		{
		0x7422
		},
		{
		0x7438
		},
		{
		0x8a17
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_9[]=
	{
		{
		0x6912
		},
		{
		0x695a
		},
		{
		0x6a35
		},
		{
		0x7092
		},
		{
		0x7126
		},
		{
		0x785d
		},
		{
		0x7901
		},
		{
		0x790e
		},
		{
		0x79d2
		},
		{
		0x7a0d
		},
		{
		0x8096
		},
		{
		0x8278
		},
		{
		0x82d5
		},
		{
		0x8349
		},
		{
		0x8549
		},
		{
		0x8c82
		},
		{
		0x8d85
		},
		{
		0x9162
		},
		{
		0x918b
		},
		{
		0x91ae
		},
		{
		0x4fc3
		},
		{
		0x56d1
		},
		{
		0x71ed
		},
		{
		0x77d7
		},
		{
		0x8700
		},
		{
		0x89f8
		},
		{
		0x5bf8
		},
		{
		0x5fd6
		},
		{
		0x6751
		},
		{
		0x90a8
		},
		{
		0x53e2
		},
		{
		0x585a
		},
		{
		0x5bf5
		},
		{
		0x60a4
		},
		{
		0x6181
		},
		{
		0x6460
		},
		{
		0x7e3d
		},
		{
		0x8070
		},
		{
		0x8525
		},
		{
		0x9283
		},
		{
		0x64ae
		},
		{
		0x50ac
		},
		{
		0x5d14
		},
		{
		0x6700
		},
		{
		0x589c
		},
		{
		0x62bd
		},
		{
		0x63a8
		},
		{
		0x690e
		},
		{
		0x6978
		},
		{
		0x6a1e
		},
		{
		0x6e6b
		},
		{
		0x76ba
		},
		{
		0x79cb
		},
		{
		0x82bb
		},
		{
		0x8429
		},
		{
		0x8acf
		},
		{
		0x8da8
		},
		{
		0x8ffd
		},
		{
		0x9112
		},
		{
		0x914b
		},
		{
		0x919c
		},
		{
		0x9310
		},
		{
		0x9318
		},
		{
		0x939a
		},
		{
		0x96db
		},
		{
		0x9a36
		},
		{
		0x9c0d
		},
		{
		0x4e11
		},
		{
		0x755c
		},
		{
		0x795d
		},
		{
		0x7afa
		},
		{
		0x7b51
		},
		{
		0x7bc9
		},
		{
		0x7e2e
		},
		{
		0x84c4
		},
		{
		0x8e59
		},
		{
		0x8e74
		},
		{
		0x8ef8
		},
		{
		0x9010
		},
		{
		0x6625
		},
		{
		0x693f
		},
		{
		0x7443
		},
		{
		0x51fa
		},
		{
		0x672e
		},
		{
		0x9edc
		},
		{
		0x5145
		},
		{
		0x5fe0
		},
		{
		0x6c96
		},
		{
		0x87f2
		},
		{
		0x885d
		},
		{
		0x8877
		},
		{
		0x60b4
		},
		{
		0x81b5
		},
		{
		0x8403
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_10[]=
	{
		{
		0x8cac
		},
		{
		0x51c4
		},
		{
		0x59bb
		},
		{
		0x60bd
		},
		{
		0x8655
		},
		{
		0x501c
		},
		{
		0xf9ff
		},
		{
		0x5254
		},
		{
		0x5c3a
		},
		{
		0x617d
		},
		{
		0x621a
		},
		{
		0x62d3
		},
		{
		0x64f2
		},
		{
		0x65a5
		},
		{
		0x6ecc
		},
		{
		0x7620
		},
		{
		0x810a
		},
		{
		0x8e60
		},
		{
		0x965f
		},
		{
		0x96bb
		},
		{
		0x4edf
		},
		{
		0x5343
		},
		{
		0x5598
		},
		{
		0x5929
		},
		{
		0x5ddd
		},
		{
		0x64c5
		},
		{
		0x6cc9
		},
		{
		0x6dfa
		},
		{
		0x7394
		},
		{
		0x7a7f
		},
		{
		0x821b
		},
		{
		0x85a6
		},
		{
		0x8ce4
		},
		{
		0x8e10
		},
		{
		0x9077
		},
		{
		0x91e7
		},
		{
		0x95e1
		},
		{
		0x9621
		},
		{
		0x97c6
		},
		{
		0x51f8
		},
		{
		0x54f2
		},
		{
		0x5586
		},
		{
		0x5fb9
		},
		{
		0x64a4
		},
		{
		0x6f88
		},
		{
		0x7db4
		},
		{
		0x8f1f
		},
		{
		0x8f4d
		},
		{
		0x9435
		},
		{
		0x50c9
		},
		{
		0x5c16
		},
		{
		0x6cbe
		},
		{
		0x6dfb
		},
		{
		0x751b
		},
		{
		0x77bb
		},
		{
		0x7c3d
		},
		{
		0x7c64
		},
		{
		0x8a79
		},
		{
		0x8ac2
		},
		{
		0x581e
		},
		{
		0x59be
		},
		{
		0x5e16
		},
		{
		0x6377
		},
		{
		0x7252
		},
		{
		0x758a
		},
		{
		0x776b
		},
		{
		0x8adc
		},
		{
		0x8cbc
		},
		{
		0x8f12
		},
		{
		0x5ef3
		},
		{
		0x6674
		},
		{
		0x6df8
		},
		{
		0x807d
		},
		{
		0x83c1
		},
		{
		0x8acb
		},
		{
		0x9751
		},
		{
		0x9bd6
		},
		{
		0xfa00
		},
		{
		0x5243
		},
		{
		0x66ff
		},
		{
		0x6d95
		},
		{
		0x6eef
		},
		{
		0x7de0
		},
		{
		0x8ae6
		},
		{
		0x902e
		},
		{
		0x905e
		},
		{
		0x9ad4
		},
		{
		0x521d
		},
		{
		0x527f
		},
		{
		0x54e8
		},
		{
		0x6194
		},
		{
		0x6284
		},
		{
		0x62db
		},
		{
		0x68a2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_11[]=
	{
		{
		0x93f6
		},
		{
		0x96c6
		},
		{
		0x5fb5
		},
		{
		0x61f2
		},
		{
		0x6f84
		},
		{
		0x4e14
		},
		{
		0x4f98
		},
		{
		0x501f
		},
		{
		0x53c9
		},
		{
		0x55df
		},
		{
		0x5d6f
		},
		{
		0x5dee
		},
		{
		0x6b21
		},
		{
		0x6b64
		},
		{
		0x78cb
		},
		{
		0x7b9a
		},
		{
		0xf9fe
		},
		{
		0x8e49
		},
		{
		0x8eca
		},
		{
		0x906e
		},
		{
		0x6349
		},
		{
		0x643e
		},
		{
		0x7740
		},
		{
		0x7a84
		},
		{
		0x932f
		},
		{
		0x947f
		},
		{
		0x9f6a
		},
		{
		0x64b0
		},
		{
		0x6faf
		},
		{
		0x71e6
		},
		{
		0x74a8
		},
		{
		0x74da
		},
		{
		0x7ac4
		},
		{
		0x7c12
		},
		{
		0x7e82
		},
		{
		0x7cb2
		},
		{
		0x7e98
		},
		{
		0x8b9a
		},
		{
		0x8d0a
		},
		{
		0x947d
		},
		{
		0x9910
		},
		{
		0x994c
		},
		{
		0x5239
		},
		{
		0x5bdf
		},
		{
		0x64e6
		},
		{
		0x672d
		},
		{
		0x7d2e
		},
		{
		0x50ed
		},
		{
		0x53c3
		},
		{
		0x5879
		},
		{
		0x6158
		},
		{
		0x6159
		},
		{
		0x61fa
		},
		{
		0x65ac
		},
		{
		0x7ad9
		},
		{
		0x8b92
		},
		{
		0x8b96
		},
		{
		0x5009
		},
		{
		0x5021
		},
		{
		0x5275
		},
		{
		0x5531
		},
		{
		0x5a3c
		},
		{
		0x5ee0
		},
		{
		0x5f70
		},
		{
		0x6134
		},
		{
		0x655e
		},
		{
		0x660c
		},
		{
		0x6636
		},
		{
		0x66a2
		},
		{
		0x69cd
		},
		{
		0x6ec4
		},
		{
		0x6f32
		},
		{
		0x7316
		},
		{
		0x7621
		},
		{
		0x7a93
		},
		{
		0x8139
		},
		{
		0x8259
		},
		{
		0x83d6
		},
		{
		0x84bc
		},
		{
		0x50b5
		},
		{
		0x57f0
		},
		{
		0x5bc0
		},
		{
		0x5be8
		},
		{
		0x5f69
		},
		{
		0x63a1
		},
		{
		0x7826
		},
		{
		0x7db5
		},
		{
		0x83dc
		},
		{
		0x8521
		},
		{
		0x91c7
		},
		{
		0x91f5
		},
		{
		0x518a
		},
		{
		0x67f5
		},
		{
		0x7b56
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_12[]=
	{
		{
		0x54ab
		},
		{
		0x5730
		},
		{
		0x5740
		},
		{
		0x5fd7
		},
		{
		0x6301
		},
		{
		0x6307
		},
		{
		0x646f
		},
		{
		0x652f
		},
		{
		0x65e8
		},
		{
		0x667a
		},
		{
		0x679d
		},
		{
		0x67b3
		},
		{
		0x6b62
		},
		{
		0x6c60
		},
		{
		0x6c9a
		},
		{
		0x6f2c
		},
		{
		0x77e5
		},
		{
		0x7825
		},
		{
		0x7949
		},
		{
		0x7957
		},
		{
		0x7d19
		},
		{
		0x80a2
		},
		{
		0x8102
		},
		{
		0x81f3
		},
		{
		0x829d
		},
		{
		0x82b7
		},
		{
		0x8718
		},
		{
		0x8a8c
		},
		{
		0xf9fc
		},
		{
		0x8d04
		},
		{
		0x8dbe
		},
		{
		0x9072
		},
		{
		0x76f4
		},
		{
		0x7a19
		},
		{
		0x7a37
		},
		{
		0x7e54
		},
		{
		0x8077
		},
		{
		0x5507
		},
		{
		0x55d4
		},
		{
		0x5875
		},
		{
		0x632f
		},
		{
		0x6422
		},
		{
		0x6649
		},
		{
		0x664b
		},
		{
		0x686d
		},
		{
		0x699b
		},
		{
		0x6b84
		},
		{
		0x6d25
		},
		{
		0x6eb1
		},
		{
		0x73cd
		},
		{
		0x7468
		},
		{
		0x74a1
		},
		{
		0x755b
		},
		{
		0x75b9
		},
		{
		0x76e1
		},
		{
		0x771e
		},
		{
		0x778b
		},
		{
		0x79e6
		},
		{
		0x7e09
		},
		{
		0x7e1d
		},
		{
		0x81fb
		},
		{
		0x852f
		},
		{
		0x8897
		},
		{
		0x8a3a
		},
		{
		0x8cd1
		},
		{
		0x8eeb
		},
		{
		0x8fb0
		},
		{
		0x9032
		},
		{
		0x93ad
		},
		{
		0x9663
		},
		{
		0x9673
		},
		{
		0x9707
		},
		{
		0x4f84
		},
		{
		0x53f1
		},
		{
		0x59ea
		},
		{
		0x5ac9
		},
		{
		0x5e19
		},
		{
		0x684e
		},
		{
		0x74c6
		},
		{
		0x75be
		},
		{
		0x79e9
		},
		{
		0x7a92
		},
		{
		0x81a3
		},
		{
		0x86ed
		},
		{
		0x8cea
		},
		{
		0x8dcc
		},
		{
		0x8fed
		},
		{
		0x659f
		},
		{
		0x6715
		},
		{
		0xf9fd
		},
		{
		0x57f7
		},
		{
		0x6f57
		},
		{
		0x7ddd
		},
		{
		0x8f2f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_13[]=
	{
		{
		0x8e2a
		},
		{
		0x8e35
		},
		{
		0x937e
		},
		{
		0x9418
		},
		{
		0x4f50
		},
		{
		0x5750
		},
		{
		0x5de6
		},
		{
		0x5ea7
		},
		{
		0x632b
		},
		{
		0x7f6a
		},
		{
		0x4e3b
		},
		{
		0x4f4f
		},
		{
		0x4f8f
		},
		{
		0x505a
		},
		{
		0x59dd
		},
		{
		0x80c4
		},
		{
		0x546a
		},
		{
		0x5468
		},
		{
		0x55fe
		},
		{
		0x594f
		},
		{
		0x5b99
		},
		{
		0x5dde
		},
		{
		0x5eda
		},
		{
		0x665d
		},
		{
		0x6731
		},
		{
		0x67f1
		},
		{
		0x682a
		},
		{
		0x6ce8
		},
		{
		0x6d32
		},
		{
		0x6e4a
		},
		{
		0x6f8d
		},
		{
		0x70b7
		},
		{
		0x73e0
		},
		{
		0x7587
		},
		{
		0x7c4c
		},
		{
		0x7d02
		},
		{
		0x7d2c
		},
		{
		0x7da2
		},
		{
		0x821f
		},
		{
		0x86db
		},
		{
		0x8a3b
		},
		{
		0x8a85
		},
		{
		0x8d70
		},
		{
		0x8e8a
		},
		{
		0x8f33
		},
		{
		0x9031
		},
		{
		0x914e
		},
		{
		0x9152
		},
		{
		0x9444
		},
		{
		0x99d0
		},
		{
		0x7af9
		},
		{
		0x7ca5
		},
		{
		0x4fca
		},
		{
		0x5101
		},
		{
		0x51c6
		},
		{
		0x57c8
		},
		{
		0x5bef
		},
		{
		0x5cfb
		},
		{
		0x6659
		},
		{
		0x6a3d
		},
		{
		0x6d5a
		},
		{
		0x6e96
		},
		{
		0x6fec
		},
		{
		0x710c
		},
		{
		0x756f
		},
		{
		0x7ae3
		},
		{
		0x8822
		},
		{
		0x9021
		},
		{
		0x9075
		},
		{
		0x96cb
		},
		{
		0x99ff
		},
		{
		0x8301
		},
		{
		0x4e2d
		},
		{
		0x4ef2
		},
		{
		0x8846
		},
		{
		0x91cd
		},
		{
		0x537d
		},
		{
		0x6adb
		},
		{
		0x696b
		},
		{
		0x6c41
		},
		{
		0x847a
		},
		{
		0x589e
		},
		{
		0x618e
		},
		{
		0x66fe
		},
		{
		0x62ef
		},
		{
		0x70dd
		},
		{
		0x7511
		},
		{
		0x75c7
		},
		{
		0x7e52
		},
		{
		0x84b8
		},
		{
		0x8b49
		},
		{
		0x8d08
		},
		{
		0x4e4b
		},
		{
		0x53ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_14[]=
	{
		{
		0x975c
		},
		{
		0x9802
		},
		{
		0x9f0e
		},
		{
		0x5236
		},
		{
		0x5291
		},
		{
		0x557c
		},
		{
		0x5824
		},
		{
		0x5e1d
		},
		{
		0x5f1f
		},
		{
		0x608c
		},
		{
		0x63d0
		},
		{
		0x68af
		},
		{
		0x6fdf
		},
		{
		0x796d
		},
		{
		0x7b2c
		},
		{
		0x81cd
		},
		{
		0x85ba
		},
		{
		0x88fd
		},
		{
		0x8af8
		},
		{
		0x8e44
		},
		{
		0x918d
		},
		{
		0x9664
		},
		{
		0x969b
		},
		{
		0x973d
		},
		{
		0x984c
		},
		{
		0x9f4a
		},
		{
		0x4fce
		},
		{
		0x5146
		},
		{
		0x51cb
		},
		{
		0x52a9
		},
		{
		0x5632
		},
		{
		0x5f14
		},
		{
		0x5f6b
		},
		{
		0x63aa
		},
		{
		0x64cd
		},
		{
		0x65e9
		},
		{
		0x6641
		},
		{
		0x66fa
		},
		{
		0x66f9
		},
		{
		0x671d
		},
		{
		0x689d
		},
		{
		0x68d7
		},
		{
		0x69fd
		},
		{
		0x6f15
		},
		{
		0x6f6e
		},
		{
		0x7167
		},
		{
		0x71e5
		},
		{
		0x722a
		},
		{
		0x74aa
		},
		{
		0x773a
		},
		{
		0x7956
		},
		{
		0x795a
		},
		{
		0x79df
		},
		{
		0x7a20
		},
		{
		0x7a95
		},
		{
		0x7c97
		},
		{
		0x7cdf
		},
		{
		0x7d44
		},
		{
		0x7e70
		},
		{
		0x8087
		},
		{
		0x85fb
		},
		{
		0x86a4
		},
		{
		0x8a54
		},
		{
		0x8abf
		},
		{
		0x8d99
		},
		{
		0x8e81
		},
		{
		0x9020
		},
		{
		0x906d
		},
		{
		0x91e3
		},
		{
		0x963b
		},
		{
		0x96d5
		},
		{
		0x9ce5
		},
		{
		0x65cf
		},
		{
		0x7c07
		},
		{
		0x8db3
		},
		{
		0x93c3
		},
		{
		0x5b58
		},
		{
		0x5c0a
		},
		{
		0x5352
		},
		{
		0x62d9
		},
		{
		0x731d
		},
		{
		0x5027
		},
		{
		0x5b97
		},
		{
		0x5f9e
		},
		{
		0x60b0
		},
		{
		0x616b
		},
		{
		0x68d5
		},
		{
		0x6dd9
		},
		{
		0x742e
		},
		{
		0x7a2e
		},
		{
		0x7d42
		},
		{
		0x7d9c
		},
		{
		0x7e31
		},
		{
		0x816b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_15[]=
	{
		{
		0x714e
		},
		{
		0x7420
		},
		{
		0x7530
		},
		{
		0x7538
		},
		{
		0x7551
		},
		{
		0x7672
		},
		{
		0x7b4c
		},
		{
		0x7b8b
		},
		{
		0x7bad
		},
		{
		0x7bc6
		},
		{
		0x7e8f
		},
		{
		0x8a6e
		},
		{
		0x8f3e
		},
		{
		0x8f49
		},
		{
		0x923f
		},
		{
		0x9293
		},
		{
		0x9322
		},
		{
		0x942b
		},
		{
		0x96fb
		},
		{
		0x985a
		},
		{
		0x986b
		},
		{
		0x991e
		},
		{
		0x5207
		},
		{
		0x622a
		},
		{
		0x6298
		},
		{
		0x6d59
		},
		{
		0x7664
		},
		{
		0x7aca
		},
		{
		0x7bc0
		},
		{
		0x7d76
		},
		{
		0x5360
		},
		{
		0x5cbe
		},
		{
		0x5e97
		},
		{
		0x6f38
		},
		{
		0x70b9
		},
		{
		0x7c98
		},
		{
		0x9711
		},
		{
		0x9b8e
		},
		{
		0x9ede
		},
		{
		0x63a5
		},
		{
		0x647a
		},
		{
		0x8776
		},
		{
		0x4e01
		},
		{
		0x4e95
		},
		{
		0x4ead
		},
		{
		0x505c
		},
		{
		0x5075
		},
		{
		0x5448
		},
		{
		0x59c3
		},
		{
		0x5b9a
		},
		{
		0x5e40
		},
		{
		0x5ead
		},
		{
		0x5ef7
		},
		{
		0x5f81
		},
		{
		0x60c5
		},
		{
		0x633a
		},
		{
		0x653f
		},
		{
		0x6574
		},
		{
		0x65cc
		},
		{
		0x6676
		},
		{
		0x6678
		},
		{
		0x67fe
		},
		{
		0x6968
		},
		{
		0x6a89
		},
		{
		0x6b63
		},
		{
		0x6c40
		},
		{
		0x6dc0
		},
		{
		0x6de8
		},
		{
		0x6e1f
		},
		{
		0x6e5e
		},
		{
		0x701e
		},
		{
		0x70a1
		},
		{
		0x738e
		},
		{
		0x73fd
		},
		{
		0x753a
		},
		{
		0x775b
		},
		{
		0x7887
		},
		{
		0x798e
		},
		{
		0x7a0b
		},
		{
		0x7a7d
		},
		{
		0x7cbe
		},
		{
		0x7d8e
		},
		{
		0x8247
		},
		{
		0x8a02
		},
		{
		0x8aea
		},
		{
		0x8c9e
		},
		{
		0x912d
		},
		{
		0x914a
		},
		{
		0x91d8
		},
		{
		0x9266
		},
		{
		0x92cc
		},
		{
		0x9320
		},
		{
		0x9706
		},
		{
		0x9756
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_16[]=
	{
		{
		0x969c
		},
		{
		0x518d
		},
		{
		0x54c9
		},
		{
		0x5728
		},
		{
		0x5bb0
		},
		{
		0x624d
		},
		{
		0x6750
		},
		{
		0x683d
		},
		{
		0x6893
		},
		{
		0x6e3d
		},
		{
		0x6ed3
		},
		{
		0x707d
		},
		{
		0x7e21
		},
		{
		0x88c1
		},
		{
		0x8ca1
		},
		{
		0x8f09
		},
		{
		0x9f4b
		},
		{
		0x9f4e
		},
		{
		0x722d
		},
		{
		0x7b8f
		},
		{
		0x8acd
		},
		{
		0x931a
		},
		{
		0x4f47
		},
		{
		0x4f4e
		},
		{
		0x5132
		},
		{
		0x5480
		},
		{
		0x59d0
		},
		{
		0x5e95
		},
		{
		0x62b5
		},
		{
		0x6775
		},
		{
		0x696e
		},
		{
		0x6a17
		},
		{
		0x6cae
		},
		{
		0x6e1a
		},
		{
		0x72d9
		},
		{
		0x732a
		},
		{
		0x75bd
		},
		{
		0x7bb8
		},
		{
		0x7d35
		},
		{
		0x82e7
		},
		{
		0x83f9
		},
		{
		0x8457
		},
		{
		0x85f7
		},
		{
		0x8a5b
		},
		{
		0x8caf
		},
		{
		0x8e87
		},
		{
		0x9019
		},
		{
		0x90b8
		},
		{
		0x96ce
		},
		{
		0x9f5f
		},
		{
		0x52e3
		},
		{
		0x540a
		},
		{
		0x5ae1
		},
		{
		0x5bc2
		},
		{
		0x6458
		},
		{
		0x6575
		},
		{
		0x6ef4
		},
		{
		0x72c4
		},
		{
		0xf9fb
		},
		{
		0x7684
		},
		{
		0x7a4d
		},
		{
		0x7b1b
		},
		{
		0x7c4d
		},
		{
		0x7e3e
		},
		{
		0x7fdf
		},
		{
		0x837b
		},
		{
		0x8b2b
		},
		{
		0x8cca
		},
		{
		0x8d64
		},
		{
		0x8de1
		},
		{
		0x8e5f
		},
		{
		0x8fea
		},
		{
		0x8ff9
		},
		{
		0x9069
		},
		{
		0x93d1
		},
		{
		0x4f43
		},
		{
		0x4f7a
		},
		{
		0x50b3
		},
		{
		0x5168
		},
		{
		0x5178
		},
		{
		0x524d
		},
		{
		0x526a
		},
		{
		0x5861
		},
		{
		0x587c
		},
		{
		0x5960
		},
		{
		0x5c08
		},
		{
		0x5c55
		},
		{
		0x5edb
		},
		{
		0x609b
		},
		{
		0x6230
		},
		{
		0x6813
		},
		{
		0x6bbf
		},
		{
		0x6c08
		},
		{
		0x6fb1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_17[]=
	{
		{
		0xf9f7
		},
		{
		0xf9f8
		},
		{
		0xf9f9
		},
		{
		0x4ecd
		},
		{
		0x5269
		},
		{
		0x5b55
		},
		{
		0x82bf
		},
		{
		0x4ed4
		},
		{
		0x523a
		},
		{
		0x54a8
		},
		{
		0x59c9
		},
		{
		0x59ff
		},
		{
		0x5b50
		},
		{
		0x5b57
		},
		{
		0x5b5c
		},
		{
		0x6063
		},
		{
		0x6148
		},
		{
		0x6ecb
		},
		{
		0x7099
		},
		{
		0x716e
		},
		{
		0x7386
		},
		{
		0x74f7
		},
		{
		0x75b5
		},
		{
		0x78c1
		},
		{
		0x7d2b
		},
		{
		0x8005
		},
		{
		0x81ea
		},
		{
		0x8328
		},
		{
		0x8517
		},
		{
		0x85c9
		},
		{
		0x8aee
		},
		{
		0x8cc7
		},
		{
		0x96cc
		},
		{
		0x4f5c
		},
		{
		0x52fa
		},
		{
		0x56bc
		},
		{
		0x65ab
		},
		{
		0x6628
		},
		{
		0x707c
		},
		{
		0x70b8
		},
		{
		0x7235
		},
		{
		0x7dbd
		},
		{
		0x828d
		},
		{
		0x914c
		},
		{
		0x96c0
		},
		{
		0x9d72
		},
		{
		0x5b71
		},
		{
		0x68e7
		},
		{
		0x6b98
		},
		{
		0x6f7a
		},
		{
		0x76de
		},
		{
		0x5c91
		},
		{
		0x66ab
		},
		{
		0x6f5b
		},
		{
		0x7bb4
		},
		{
		0x7c2a
		},
		{
		0x8836
		},
		{
		0x96dc
		},
		{
		0x4e08
		},
		{
		0x4ed7
		},
		{
		0x5320
		},
		{
		0x5834
		},
		{
		0x58bb
		},
		{
		0x58ef
		},
		{
		0x596c
		},
		{
		0x5c07
		},
		{
		0x5e33
		},
		{
		0x5e84
		},
		{
		0x5f35
		},
		{
		0x638c
		},
		{
		0x66b2
		},
		{
		0x6756
		},
		{
		0x6a1f
		},
		{
		0x6aa3
		},
		{
		0x6b0c
		},
		{
		0x6f3f
		},
		{
		0x7246
		},
		{
		0xf9fa
		},
		{
		0x7350
		},
		{
		0x748b
		},
		{
		0x7ae0
		},
		{
		0x7ca7
		},
		{
		0x8178
		},
		{
		0x81df
		},
		{
		0x81e7
		},
		{
		0x838a
		},
		{
		0x846c
		},
		{
		0x8523
		},
		{
		0x8594
		},
		{
		0x85cf
		},
		{
		0x88dd
		},
		{
		0x8d13
		},
		{
		0x91ac
		},
		{
		0x9577
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_18[]=
	{
		{
		0x8b70
		},
		{
		0x91ab
		},
		{
		0x4e8c
		},
		{
		0x4ee5
		},
		{
		0x4f0a
		},
		{
		0xf9dd
		},
		{
		0xf9de
		},
		{
		0x5937
		},
		{
		0x59e8
		},
		{
		0xf9df
		},
		{
		0x5df2
		},
		{
		0x5f1b
		},
		{
		0x5f5b
		},
		{
		0x6021
		},
		{
		0xf9e0
		},
		{
		0xf9e1
		},
		{
		0xf9e2
		},
		{
		0xf9e3
		},
		{
		0x723e
		},
		{
		0x73e5
		},
		{
		0xf9e4
		},
		{
		0x7570
		},
		{
		0x75cd
		},
		{
		0xf9e5
		},
		{
		0x79fb
		},
		{
		0xf9e6
		},
		{
		0x800c
		},
		{
		0x8033
		},
		{
		0x8084
		},
		{
		0x82e1
		},
		{
		0x8351
		},
		{
		0xf9e7
		},
		{
		0xf9e8
		},
		{
		0x8cbd
		},
		{
		0x8cb3
		},
		{
		0x9087
		},
		{
		0xf9e9
		},
		{
		0xf9ea
		},
		{
		0x98f4
		},
		{
		0x990c
		},
		{
		0xf9eb
		},
		{
		0xf9ec
		},
		{
		0x7037
		},
		{
		0x76ca
		},
		{
		0x7fca
		},
		{
		0x7fcc
		},
		{
		0x7ffc
		},
		{
		0x8b1a
		},
		{
		0x4eba
		},
		{
		0x4ec1
		},
		{
		0x5203
		},
		{
		0x5370
		},
		{
		0xf9ed
		},
		{
		0x54bd
		},
		{
		0x56e0
		},
		{
		0x59fb
		},
		{
		0x5bc5
		},
		{
		0x5f15
		},
		{
		0x5fcd
		},
		{
		0x6e6e
		},
		{
		0xf9ee
		},
		{
		0xf9ef
		},
		{
		0x7d6a
		},
		{
		0x8335
		},
		{
		0xf9f0
		},
		{
		0x8693
		},
		{
		0x8a8d
		},
		{
		0xf9f1
		},
		{
		0x976d
		},
		{
		0x9777
		},
		{
		0xf9f2
		},
		{
		0xf9f3
		},
		{
		0x4e00
		},
		{
		0x4f5a
		},
		{
		0x4f7e
		},
		{
		0x58f9
		},
		{
		0x65e5
		},
		{
		0x6ea2
		},
		{
		0x9038
		},
		{
		0x93b0
		},
		{
		0x99b9
		},
		{
		0x4efb
		},
		{
		0x58ec
		},
		{
		0x598a
		},
		{
		0x59d9
		},
		{
		0x6041
		},
		{
		0xf9f4
		},
		{
		0xf9f5
		},
		{
		0x7a14
		},
		{
		0xf9f6
		},
		{
		0x834f
		},
		{
		0x8cc3
		},
		{
		0x5165
		},
		{
		0x5344
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_19[]=
	{
		{
		0x6fe1
		},
		{
		0x7336
		},
		{
		0x7337
		},
		{
		0xf9cc
		},
		{
		0x745c
		},
		{
		0x7531
		},
		{
		0xf9cd
		},
		{
		0x7652
		},
		{
		0xf9ce
		},
		{
		0xf9cf
		},
		{
		0x7dad
		},
		{
		0x81fe
		},
		{
		0x8438
		},
		{
		0x88d5
		},
		{
		0x8a98
		},
		{
		0x8adb
		},
		{
		0x8aed
		},
		{
		0x8e30
		},
		{
		0x8e42
		},
		{
		0x904a
		},
		{
		0x903e
		},
		{
		0x907a
		},
		{
		0x9149
		},
		{
		0x91c9
		},
		{
		0x936e
		},
		{
		0xf9d0
		},
		{
		0xf9d1
		},
		{
		0x5809
		},
		{
		0xf9d2
		},
		{
		0x6bd3
		},
		{
		0x8089
		},
		{
		0x80b2
		},
		{
		0xf9d3
		},
		{
		0xf9d4
		},
		{
		0x5141
		},
		{
		0x596b
		},
		{
		0x5c39
		},
		{
		0xf9d5
		},
		{
		0xf9d6
		},
		{
		0x6f64
		},
		{
		0x73a7
		},
		{
		0x80e4
		},
		{
		0x8d07
		},
		{
		0xf9d7
		},
		{
		0x9217
		},
		{
		0x958f
		},
		{
		0xf9d8
		},
		{
		0xf9d9
		},
		{
		0xf9da
		},
		{
		0xf9db
		},
		{
		0x807f
		},
		{
		0x620e
		},
		{
		0x701c
		},
		{
		0x7d68
		},
		{
		0x878d
		},
		{
		0xf9dc
		},
		{
		0x57a0
		},
		{
		0x6069
		},
		{
		0x6147
		},
		{
		0x6bb7
		},
		{
		0x8abe
		},
		{
		0x9280
		},
		{
		0x96b1
		},
		{
		0x4e59
		},
		{
		0x541f
		},
		{
		0x6deb
		},
		{
		0x852d
		},
		{
		0x9670
		},
		{
		0x97f3
		},
		{
		0x98ee
		},
		{
		0x63d6
		},
		{
		0x6ce3
		},
		{
		0x9091
		},
		{
		0x51dd
		},
		{
		0x61c9
		},
		{
		0x81ba
		},
		{
		0x9df9
		},
		{
		0x4f9d
		},
		{
		0x501a
		},
		{
		0x5100
		},
		{
		0x5b9c
		},
		{
		0x610f
		},
		{
		0x61ff
		},
		{
		0x64ec
		},
		{
		0x6905
		},
		{
		0x6bc5
		},
		{
		0x7591
		},
		{
		0x77e3
		},
		{
		0x7fa9
		},
		{
		0x8264
		},
		{
		0x858f
		},
		{
		0x87fb
		},
		{
		0x8863
		},
		{
		0x8abc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_20[]=
	{
		{
		0x904b
		},
		{
		0x9695
		},
		{
		0x96f2
		},
		{
		0x97fb
		},
		{
		0x851a
		},
		{
		0x9b31
		},
		{
		0x4e90
		},
		{
		0x718a
		},
		{
		0x96c4
		},
		{
		0x5143
		},
		{
		0x539f
		},
		{
		0x54e1
		},
		{
		0x5713
		},
		{
		0x5712
		},
		{
		0x57a3
		},
		{
		0x5a9b
		},
		{
		0x5ac4
		},
		{
		0x5bc3
		},
		{
		0x6028
		},
		{
		0x613f
		},
		{
		0x63f4
		},
		{
		0x6c85
		},
		{
		0x6d39
		},
		{
		0x6e72
		},
		{
		0x6e90
		},
		{
		0x7230
		},
		{
		0x733f
		},
		{
		0x7457
		},
		{
		0x82d1
		},
		{
		0x8881
		},
		{
		0x8f45
		},
		{
		0x9060
		},
		{
		0xf9c6
		},
		{
		0x9662
		},
		{
		0x9858
		},
		{
		0x9d1b
		},
		{
		0x6708
		},
		{
		0x8d8a
		},
		{
		0x925e
		},
		{
		0x4f4d
		},
		{
		0x5049
		},
		{
		0x50de
		},
		{
		0x5371
		},
		{
		0x570d
		},
		{
		0x59d4
		},
		{
		0x5a01
		},
		{
		0x5c09
		},
		{
		0x6170
		},
		{
		0x6690
		},
		{
		0x6e2d
		},
		{
		0x7232
		},
		{
		0x744b
		},
		{
		0x7def
		},
		{
		0x80c3
		},
		{
		0x840e
		},
		{
		0x8466
		},
		{
		0x853f
		},
		{
		0x875f
		},
		{
		0x885b
		},
		{
		0x8918
		},
		{
		0x8b02
		},
		{
		0x9055
		},
		{
		0x97cb
		},
		{
		0x9b4f
		},
		{
		0x4e73
		},
		{
		0x4f91
		},
		{
		0x5112
		},
		{
		0x516a
		},
		{
		0xf9c7
		},
		{
		0x552f
		},
		{
		0x55a9
		},
		{
		0x5b7a
		},
		{
		0x5ba5
		},
		{
		0x5e7c
		},
		{
		0x5e7d
		},
		{
		0x5ebe
		},
		{
		0x60a0
		},
		{
		0x60df
		},
		{
		0x6108
		},
		{
		0x6109
		},
		{
		0x63c4
		},
		{
		0x6538
		},
		{
		0x6709
		},
		{
		0xf9c8
		},
		{
		0x67d4
		},
		{
		0x67da
		},
		{
		0xf9c9
		},
		{
		0x6961
		},
		{
		0x6962
		},
		{
		0x6cb9
		},
		{
		0x6d27
		},
		{
		0xf9ca
		},
		{
		0x6e38
		},
		{
		0xf9cb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_21[]=
	{
		{
		0x7a88
		},
		{
		0x7aaf
		},
		{
		0x7e47
		},
		{
		0x7e5e
		},
		{
		0x8000
		},
		{
		0x8170
		},
		{
		0xf9c2
		},
		{
		0x87ef
		},
		{
		0x8981
		},
		{
		0x8b20
		},
		{
		0x9059
		},
		{
		0xf9c3
		},
		{
		0x9080
		},
		{
		0x9952
		},
		{
		0x617e
		},
		{
		0x6b32
		},
		{
		0x6d74
		},
		{
		0x7e1f
		},
		{
		0x8925
		},
		{
		0x8fb1
		},
		{
		0x4fd1
		},
		{
		0x50ad
		},
		{
		0x5197
		},
		{
		0x52c7
		},
		{
		0x57c7
		},
		{
		0x5889
		},
		{
		0x5bb9
		},
		{
		0x5eb8
		},
		{
		0x6142
		},
		{
		0x6995
		},
		{
		0x6d8c
		},
		{
		0x6e67
		},
		{
		0x6eb6
		},
		{
		0x7194
		},
		{
		0x7462
		},
		{
		0x7528
		},
		{
		0x752c
		},
		{
		0x8073
		},
		{
		0x8338
		},
		{
		0x84c9
		},
		{
		0x8e0a
		},
		{
		0x9394
		},
		{
		0x93de
		},
		{
		0xf9c4
		},
		{
		0x4e8e
		},
		{
		0x4f51
		},
		{
		0x5076
		},
		{
		0x512a
		},
		{
		0x53c8
		},
		{
		0x53cb
		},
		{
		0x53f3
		},
		{
		0x5b87
		},
		{
		0x5bd3
		},
		{
		0x5c24
		},
		{
		0x611a
		},
		{
		0x6182
		},
		{
		0x65f4
		},
		{
		0x725b
		},
		{
		0x7397
		},
		{
		0x7440
		},
		{
		0x76c2
		},
		{
		0x7950
		},
		{
		0x7991
		},
		{
		0x79b9
		},
		{
		0x7d06
		},
		{
		0x7fbd
		},
		{
		0x828b
		},
		{
		0x85d5
		},
		{
		0x865e
		},
		{
		0x8fc2
		},
		{
		0x9047
		},
		{
		0x90f5
		},
		{
		0x91ea
		},
		{
		0x9685
		},
		{
		0x96e8
		},
		{
		0x96e9
		},
		{
		0x52d6
		},
		{
		0x5f67
		},
		{
		0x65ed
		},
		{
		0x6631
		},
		{
		0x682f
		},
		{
		0x715c
		},
		{
		0x7a36
		},
		{
		0x90c1
		},
		{
		0x980a
		},
		{
		0x4e91
		},
		{
		0xf9c5
		},
		{
		0x6a52
		},
		{
		0x6b9e
		},
		{
		0x6f90
		},
		{
		0x7189
		},
		{
		0x8018
		},
		{
		0x82b8
		},
		{
		0x8553
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_22[]=
	{
		{
		0x70cf
		},
		{
		0x71ac
		},
		{
		0x7352
		},
		{
		0x7b7d
		},
		{
		0x8708
		},
		{
		0x8aa4
		},
		{
		0x9c32
		},
		{
		0x9f07
		},
		{
		0x5c4b
		},
		{
		0x6c83
		},
		{
		0x7344
		},
		{
		0x7389
		},
		{
		0x923a
		},
		{
		0x6eab
		},
		{
		0x7465
		},
		{
		0x761f
		},
		{
		0x7a69
		},
		{
		0x7e15
		},
		{
		0x860a
		},
		{
		0x5140
		},
		{
		0x58c5
		},
		{
		0x64c1
		},
		{
		0x74ee
		},
		{
		0x7515
		},
		{
		0x7670
		},
		{
		0x7fc1
		},
		{
		0x9095
		},
		{
		0x96cd
		},
		{
		0x9954
		},
		{
		0x6e26
		},
		{
		0x74e6
		},
		{
		0x7aa9
		},
		{
		0x7aaa
		},
		{
		0x81e5
		},
		{
		0x86d9
		},
		{
		0x8778
		},
		{
		0x8a1b
		},
		{
		0x5a49
		},
		{
		0x5b8c
		},
		{
		0x5b9b
		},
		{
		0x68a1
		},
		{
		0x6900
		},
		{
		0x6d63
		},
		{
		0x73a9
		},
		{
		0x7413
		},
		{
		0x742c
		},
		{
		0x7897
		},
		{
		0x7de9
		},
		{
		0x7feb
		},
		{
		0x8118
		},
		{
		0x8155
		},
		{
		0x839e
		},
		{
		0x8c4c
		},
		{
		0x962e
		},
		{
		0x9811
		},
		{
		0x66f0
		},
		{
		0x5f80
		},
		{
		0x65fa
		},
		{
		0x6789
		},
		{
		0x6c6a
		},
		{
		0x738b
		},
		{
		0x502d
		},
		{
		0x5a03
		},
		{
		0x6b6a
		},
		{
		0x77ee
		},
		{
		0x5916
		},
		{
		0x5d6c
		},
		{
		0x5dcd
		},
		{
		0x7325
		},
		{
		0x754f
		},
		{
		0xf9ba
		},
		{
		0xf9bb
		},
		{
		0x50e5
		},
		{
		0x51f9
		},
		{
		0x582f
		},
		{
		0x592d
		},
		{
		0x5996
		},
		{
		0x59da
		},
		{
		0x5be5
		},
		{
		0xf9bc
		},
		{
		0xf9bd
		},
		{
		0x5da2
		},
		{
		0x62d7
		},
		{
		0x6416
		},
		{
		0x6493
		},
		{
		0x64fe
		},
		{
		0xf9be
		},
		{
		0x66dc
		},
		{
		0xf9bf
		},
		{
		0x6a48
		},
		{
		0xf9c0
		},
		{
		0x71ff
		},
		{
		0x7464
		},
		{
		0xf9c1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_23[]=
	{
		{
		0xf9a6
		},
		{
		0x95bb
		},
		{
		0x9ae5
		},
		{
		0x9e7d
		},
		{
		0x66c4
		},
		{
		0xf9a7
		},
		{
		0x71c1
		},
		{
		0x8449
		},
		{
		0xf9a8
		},
		{
		0xf9a9
		},
		{
		0x584b
		},
		{
		0xf9aa
		},
		{
		0xf9ab
		},
		{
		0x5db8
		},
		{
		0x5f71
		},
		{
		0xf9ac
		},
		{
		0x6620
		},
		{
		0x668e
		},
		{
		0x6979
		},
		{
		0x69ae
		},
		{
		0x6c38
		},
		{
		0x6cf3
		},
		{
		0x6e36
		},
		{
		0x6f41
		},
		{
		0x6fda
		},
		{
		0x701b
		},
		{
		0x702f
		},
		{
		0x7150
		},
		{
		0x71df
		},
		{
		0x7370
		},
		{
		0xf9ad
		},
		{
		0x745b
		},
		{
		0xf9ae
		},
		{
		0x74d4
		},
		{
		0x76c8
		},
		{
		0x7a4e
		},
		{
		0x7e93
		},
		{
		0xf9af
		},
		{
		0xf9b0
		},
		{
		0x82f1
		},
		{
		0x8a60
		},
		{
		0x8fce
		},
		{
		0xf9b1
		},
		{
		0x9348
		},
		{
		0xf9b2
		},
		{
		0x9719
		},
		{
		0xf9b3
		},
		{
		0xf9b4
		},
		{
		0x4e42
		},
		{
		0x502a
		},
		{
		0xf9b5
		},
		{
		0x5208
		},
		{
		0x53e1
		},
		{
		0x66f3
		},
		{
		0x6c6d
		},
		{
		0x6fca
		},
		{
		0x730a
		},
		{
		0x777f
		},
		{
		0x7a62
		},
		{
		0x82ae
		},
		{
		0x85dd
		},
		{
		0x8602
		},
		{
		0xf9b6
		},
		{
		0x88d4
		},
		{
		0x8a63
		},
		{
		0x8b7d
		},
		{
		0x8c6b
		},
		{
		0xf9b7
		},
		{
		0x92b3
		},
		{
		0xf9b8
		},
		{
		0x9713
		},
		{
		0x9810
		},
		{
		0x4e94
		},
		{
		0x4f0d
		},
		{
		0x4fc9
		},
		{
		0x50b2
		},
		{
		0x5348
		},
		{
		0x543e
		},
		{
		0x5433
		},
		{
		0x55da
		},
		{
		0x5862
		},
		{
		0x58ba
		},
		{
		0x5967
		},
		{
		0x5a1b
		},
		{
		0x5be4
		},
		{
		0x609f
		},
		{
		0xf9b9
		},
		{
		0x61ca
		},
		{
		0x6556
		},
		{
		0x65ff
		},
		{
		0x6664
		},
		{
		0x68a7
		},
		{
		0x6c5a
		},
		{
		0x6fb3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_24[]=
	{
		{
		0xf983
		},
		{
		0x6b5f
		},
		{
		0x6c5d
		},
		{
		0xf984
		},
		{
		0x74b5
		},
		{
		0x7916
		},
		{
		0xf985
		},
		{
		0x8207
		},
		{
		0x8245
		},
		{
		0x8339
		},
		{
		0x8f3f
		},
		{
		0x8f5d
		},
		{
		0xf986
		},
		{
		0x9918
		},
		{
		0xf987
		},
		{
		0xf988
		},
		{
		0xf989
		},
		{
		0x4ea6
		},
		{
		0xf98a
		},
		{
		0x57df
		},
		{
		0x5f79
		},
		{
		0x6613
		},
		{
		0xf98b
		},
		{
		0xf98c
		},
		{
		0x75ab
		},
		{
		0x7e79
		},
		{
		0x8b6f
		},
		{
		0xf98d
		},
		{
		0x9006
		},
		{
		0x9a5b
		},
		{
		0x56a5
		},
		{
		0x5827
		},
		{
		0x59f8
		},
		{
		0x5a1f
		},
		{
		0x5bb4
		},
		{
		0xf98e
		},
		{
		0x5ef6
		},
		{
		0xf98f
		},
		{
		0xf990
		},
		{
		0x6350
		},
		{
		0x633b
		},
		{
		0xf991
		},
		{
		0x693d
		},
		{
		0x6c87
		},
		{
		0x6cbf
		},
		{
		0x6d8e
		},
		{
		0x6d93
		},
		{
		0x6df5
		},
		{
		0x6f14
		},
		{
		0xf992
		},
		{
		0x70df
		},
		{
		0x7136
		},
		{
		0x7159
		},
		{
		0xf993
		},
		{
		0x71c3
		},
		{
		0x71d5
		},
		{
		0xf994
		},
		{
		0x784f
		},
		{
		0x786f
		},
		{
		0xf995
		},
		{
		0x7b75
		},
		{
		0x7de3
		},
		{
		0xf996
		},
		{
		0x7e2f
		},
		{
		0xf997
		},
		{
		0x884d
		},
		{
		0x8edf
		},
		{
		0xf998
		},
		{
		0xf999
		},
		{
		0xf99a
		},
		{
		0x925b
		},
		{
		0xf99b
		},
		{
		0x9cf6
		},
		{
		0xf99c
		},
		{
		0xf99d
		},
		{
		0xf99e
		},
		{
		0x6085
		},
		{
		0x6d85
		},
		{
		0xf99f
		},
		{
		0x71b1
		},
		{
		0xf9a0
		},
		{
		0xf9a1
		},
		{
		0x95b1
		},
		{
		0x53ad
		},
		{
		0xf9a2
		},
		{
		0xf9a3
		},
		{
		0xf9a4
		},
		{
		0x67d3
		},
		{
		0xf9a5
		},
		{
		0x708e
		},
		{
		0x7130
		},
		{
		0x7430
		},
		{
		0x8276
		},
		{
		0x82d2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_25[]=
	{
		{
		0x6afb
		},
		{
		0x7f4c
		},
		{
		0x9daf
		},
		{
		0x9e1a
		},
		{
		0x4e5f
		},
		{
		0x503b
		},
		{
		0x51b6
		},
		{
		0x591c
		},
		{
		0x60f9
		},
		{
		0x63f6
		},
		{
		0x6930
		},
		{
		0x723a
		},
		{
		0x8036
		},
		{
		0xf974
		},
		{
		0x91ce
		},
		{
		0x5f31
		},
		{
		0xf975
		},
		{
		0xf976
		},
		{
		0x7d04
		},
		{
		0x82e5
		},
		{
		0x846f
		},
		{
		0x84bb
		},
		{
		0x85e5
		},
		{
		0x8e8d
		},
		{
		0xf977
		},
		{
		0x4f6f
		},
		{
		0xf978
		},
		{
		0xf979
		},
		{
		0x58e4
		},
		{
		0x5b43
		},
		{
		0x6059
		},
		{
		0x63da
		},
		{
		0x6518
		},
		{
		0x656d
		},
		{
		0x6698
		},
		{
		0xf97a
		},
		{
		0x694a
		},
		{
		0x6a23
		},
		{
		0x6d0b
		},
		{
		0x7001
		},
		{
		0x716c
		},
		{
		0x75d2
		},
		{
		0x760d
		},
		{
		0x79b3
		},
		{
		0x7a70
		},
		{
		0xf97b
		},
		{
		0x7f8a
		},
		{
		0xf97c
		},
		{
		0x8944
		},
		{
		0xf97d
		},
		{
		0x8b93
		},
		{
		0x91c0
		},
		{
		0x967d
		},
		{
		0xf97e
		},
		{
		0x990a
		},
		{
		0x5704
		},
		{
		0x5fa1
		},
		{
		0x65bc
		},
		{
		0x6f01
		},
		{
		0x7600
		},
		{
		0x79a6
		},
		{
		0x8a9e
		},
		{
		0x99ad
		},
		{
		0x9b5a
		},
		{
		0x9f6c
		},
		{
		0x5104
		},
		{
		0x61b6
		},
		{
		0x6291
		},
		{
		0x6a8d
		},
		{
		0x81c6
		},
		{
		0x5043
		},
		{
		0x5830
		},
		{
		0x5f66
		},
		{
		0x7109
		},
		{
		0x8a00
		},
		{
		0x8afa
		},
		{
		0x5b7c
		},
		{
		0x8616
		},
		{
		0x4ffa
		},
		{
		0x513c
		},
		{
		0x56b4
		},
		{
		0x5944
		},
		{
		0x63a9
		},
		{
		0x6df9
		},
		{
		0x5daa
		},
		{
		0x696d
		},
		{
		0x5186
		},
		{
		0x4e88
		},
		{
		0x4f59
		},
		{
		0xf97f
		},
		{
		0xf980
		},
		{
		0xf981
		},
		{
		0x5982
		},
		{
		0xf982
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_26[]=
	{
		{
		0xf972
		},
		{
		0x6df1
		},
		{
		0x700b
		},
		{
		0x751a
		},
		{
		0x82af
		},
		{
		0x8af6
		},
		{
		0x4ec0
		},
		{
		0x5341
		},
		{
		0xf973
		},
		{
		0x96d9
		},
		{
		0x6c0f
		},
		{
		0x4e9e
		},
		{
		0x4fc4
		},
		{
		0x5152
		},
		{
		0x555e
		},
		{
		0x5a25
		},
		{
		0x5ce8
		},
		{
		0x6211
		},
		{
		0x7259
		},
		{
		0x82bd
		},
		{
		0x83aa
		},
		{
		0x86fe
		},
		{
		0x8859
		},
		{
		0x8a1d
		},
		{
		0x963f
		},
		{
		0x96c5
		},
		{
		0x9913
		},
		{
		0x9d09
		},
		{
		0x9d5d
		},
		{
		0x580a
		},
		{
		0x5cb3
		},
		{
		0x5dbd
		},
		{
		0x5e44
		},
		{
		0x60e1
		},
		{
		0x6115
		},
		{
		0x63e1
		},
		{
		0x6a02
		},
		{
		0x6e25
		},
		{
		0x9102
		},
		{
		0x9354
		},
		{
		0x984e
		},
		{
		0x9c10
		},
		{
		0x9f77
		},
		{
		0x5b89
		},
		{
		0x5cb8
		},
		{
		0x6309
		},
		{
		0x664f
		},
		{
		0x6848
		},
		{
		0x773c
		},
		{
		0x96c1
		},
		{
		0x978d
		},
		{
		0x9854
		},
		{
		0x9b9f
		},
		{
		0x65a1
		},
		{
		0x8b01
		},
		{
		0x8ecb
		},
		{
		0x95bc
		},
		{
		0x5535
		},
		{
		0x5ca9
		},
		{
		0x5dd6
		},
		{
		0x5eb5
		},
		{
		0x6697
		},
		{
		0x764c
		},
		{
		0x83f4
		},
		{
		0x95c7
		},
		{
		0x58d3
		},
		{
		0x62bc
		},
		{
		0x72ce
		},
		{
		0x9d28
		},
		{
		0x4ef0
		},
		{
		0x592e
		},
		{
		0x600f
		},
		{
		0x663b
		},
		{
		0x6b83
		},
		{
		0x79e7
		},
		{
		0x9d26
		},
		{
		0x5393
		},
		{
		0x54c0
		},
		{
		0x57c3
		},
		{
		0x5d16
		},
		{
		0x611b
		},
		{
		0x66d6
		},
		{
		0x6daf
		},
		{
		0x788d
		},
		{
		0x827e
		},
		{
		0x9698
		},
		{
		0x9744
		},
		{
		0x5384
		},
		{
		0x627c
		},
		{
		0x6396
		},
		{
		0x6db2
		},
		{
		0x7e0a
		},
		{
		0x814b
		},
		{
		0x984d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_27[]=
	{
		{
		0x5d69
		},
		{
		0x745f
		},
		{
		0x819d
		},
		{
		0x8768
		},
		{
		0x6fd5
		},
		{
		0x62fe
		},
		{
		0x7fd2
		},
		{
		0x8936
		},
		{
		0x8972
		},
		{
		0x4e1e
		},
		{
		0x4e58
		},
		{
		0x50e7
		},
		{
		0x52dd
		},
		{
		0x5347
		},
		{
		0x627f
		},
		{
		0x6607
		},
		{
		0x7e69
		},
		{
		0x8805
		},
		{
		0x965e
		},
		{
		0x4f8d
		},
		{
		0x5319
		},
		{
		0x5636
		},
		{
		0x59cb
		},
		{
		0x5aa4
		},
		{
		0x5c38
		},
		{
		0x5c4e
		},
		{
		0x5c4d
		},
		{
		0x5e02
		},
		{
		0x5f11
		},
		{
		0x6043
		},
		{
		0x65bd
		},
		{
		0x662f
		},
		{
		0x6642
		},
		{
		0x67be
		},
		{
		0x67f4
		},
		{
		0x731c
		},
		{
		0x77e2
		},
		{
		0x793a
		},
		{
		0x7fc5
		},
		{
		0x8494
		},
		{
		0x84cd
		},
		{
		0x8996
		},
		{
		0x8a66
		},
		{
		0x8a69
		},
		{
		0x8ae1
		},
		{
		0x8c55
		},
		{
		0x8c7a
		},
		{
		0x57f4
		},
		{
		0x5bd4
		},
		{
		0x5f0f
		},
		{
		0x606f
		},
		{
		0x62ed
		},
		{
		0x690d
		},
		{
		0x6b96
		},
		{
		0x6e5c
		},
		{
		0x7184
		},
		{
		0x7bd2
		},
		{
		0x8755
		},
		{
		0x8b58
		},
		{
		0x8efe
		},
		{
		0x98df
		},
		{
		0x98fe
		},
		{
		0x4f38
		},
		{
		0x4f81
		},
		{
		0x4fe1
		},
		{
		0x547b
		},
		{
		0x5a20
		},
		{
		0x5bb8
		},
		{
		0x613c
		},
		{
		0x65b0
		},
		{
		0x6668
		},
		{
		0x71fc
		},
		{
		0x7533
		},
		{
		0x795e
		},
		{
		0x7d33
		},
		{
		0x814e
		},
		{
		0x81e3
		},
		{
		0x8398
		},
		{
		0x85aa
		},
		{
		0x85ce
		},
		{
		0x8703
		},
		{
		0x8a0a
		},
		{
		0x8eab
		},
		{
		0x8f9b
		},
		{
		0xf971
		},
		{
		0x8fc5
		},
		{
		0x5931
		},
		{
		0x5ba4
		},
		{
		0x5be6
		},
		{
		0x6089
		},
		{
		0x5be9
		},
		{
		0x5c0b
		},
		{
		0x5fc3
		},
		{
		0x6c81
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_28[]=
	{
		{
		0x620d
		},
		{
		0x624b
		},
		{
		0x6388
		},
		{
		0x641c
		},
		{
		0x6536
		},
		{
		0x6578
		},
		{
		0x6a39
		},
		{
		0x6b8a
		},
		{
		0x6c34
		},
		{
		0x6d19
		},
		{
		0x6f31
		},
		{
		0x71e7
		},
		{
		0x72e9
		},
		{
		0x7378
		},
		{
		0x7407
		},
		{
		0x74b2
		},
		{
		0x7626
		},
		{
		0x7761
		},
		{
		0x79c0
		},
		{
		0x7a57
		},
		{
		0x7aea
		},
		{
		0x7cb9
		},
		{
		0x7d8f
		},
		{
		0x7dac
		},
		{
		0x7e61
		},
		{
		0x7f9e
		},
		{
		0x8129
		},
		{
		0x8331
		},
		{
		0x8490
		},
		{
		0x84da
		},
		{
		0x85ea
		},
		{
		0x8896
		},
		{
		0x8ab0
		},
		{
		0x8b90
		},
		{
		0x8f38
		},
		{
		0x9042
		},
		{
		0x9083
		},
		{
		0x916c
		},
		{
		0x9296
		},
		{
		0x92b9
		},
		{
		0x968b
		},
		{
		0x96a7
		},
		{
		0x96a8
		},
		{
		0x96d6
		},
		{
		0x9700
		},
		{
		0x9808
		},
		{
		0x9996
		},
		{
		0x9ad3
		},
		{
		0x9b1a
		},
		{
		0x53d4
		},
		{
		0x587e
		},
		{
		0x5919
		},
		{
		0x5b70
		},
		{
		0x5bbf
		},
		{
		0x6dd1
		},
		{
		0x6f5a
		},
		{
		0x719f
		},
		{
		0x7421
		},
		{
		0x74b9
		},
		{
		0x8085
		},
		{
		0x83fd
		},
		{
		0x5de1
		},
		{
		0x5f87
		},
		{
		0x5faa
		},
		{
		0x6042
		},
		{
		0x65ec
		},
		{
		0x6812
		},
		{
		0x696f
		},
		{
		0x6a53
		},
		{
		0x6b89
		},
		{
		0x6d35
		},
		{
		0x6df3
		},
		{
		0x73e3
		},
		{
		0x76fe
		},
		{
		0x77ac
		},
		{
		0x7b4d
		},
		{
		0x7d14
		},
		{
		0x8123
		},
		{
		0x821c
		},
		{
		0x8340
		},
		{
		0x84f4
		},
		{
		0x8563
		},
		{
		0x8a62
		},
		{
		0x8ac4
		},
		{
		0x9187
		},
		{
		0x931e
		},
		{
		0x9806
		},
		{
		0x99b4
		},
		{
		0x620c
		},
		{
		0x8853
		},
		{
		0x8ff0
		},
		{
		0x9265
		},
		{
		0x5d07
		},
		{
		0x5d27
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_29[]=
	{
		{
		0x8056
		},
		{
		0x8072
		},
		{
		0x8165
		},
		{
		0x8aa0
		},
		{
		0x9192
		},
		{
		0x4e16
		},
		{
		0x52e2
		},
		{
		0x6b72
		},
		{
		0x6d17
		},
		{
		0x7a05
		},
		{
		0x7b39
		},
		{
		0x7d30
		},
		{
		0xf96f
		},
		{
		0x8cb0
		},
		{
		0x53ec
		},
		{
		0x562f
		},
		{
		0x5851
		},
		{
		0x5bb5
		},
		{
		0x5c0f
		},
		{
		0x5c11
		},
		{
		0x5de2
		},
		{
		0x6240
		},
		{
		0x6383
		},
		{
		0x6414
		},
		{
		0x662d
		},
		{
		0x68b3
		},
		{
		0x6cbc
		},
		{
		0x6d88
		},
		{
		0x6eaf
		},
		{
		0x701f
		},
		{
		0x70a4
		},
		{
		0x71d2
		},
		{
		0x7526
		},
		{
		0x758f
		},
		{
		0x758e
		},
		{
		0x7619
		},
		{
		0x7b11
		},
		{
		0x7be0
		},
		{
		0x7c2b
		},
		{
		0x7d20
		},
		{
		0x7d39
		},
		{
		0x852c
		},
		{
		0x856d
		},
		{
		0x8607
		},
		{
		0x8a34
		},
		{
		0x900d
		},
		{
		0x9061
		},
		{
		0x90b5
		},
		{
		0x92b7
		},
		{
		0x97f6
		},
		{
		0x9a37
		},
		{
		0x4fd7
		},
		{
		0x5c6c
		},
		{
		0x675f
		},
		{
		0x6d91
		},
		{
		0x7c9f
		},
		{
		0x7e8c
		},
		{
		0x8b16
		},
		{
		0x8d16
		},
		{
		0x901f
		},
		{
		0x5b6b
		},
		{
		0x5dfd
		},
		{
		0x640d
		},
		{
		0x84c0
		},
		{
		0x905c
		},
		{
		0x98e1
		},
		{
		0x7387
		},
		{
		0x5b8b
		},
		{
		0x609a
		},
		{
		0x677e
		},
		{
		0x6dde
		},
		{
		0x8a1f
		},
		{
		0x8aa6
		},
		{
		0x9001
		},
		{
		0x980c
		},
		{
		0x5237
		},
		{
		0xf970
		},
		{
		0x7051
		},
		{
		0x788e
		},
		{
		0x9396
		},
		{
		0x8870
		},
		{
		0x91d7
		},
		{
		0x4fee
		},
		{
		0x53d7
		},
		{
		0x55fd
		},
		{
		0x56da
		},
		{
		0x5782
		},
		{
		0x58fd
		},
		{
		0x5ac2
		},
		{
		0x5b88
		},
		{
		0x5cab
		},
		{
		0x5cc0
		},
		{
		0x5e25
		},
		{
		0x6101
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_30[]=
	{
		{
		0x80e5
		},
		{
		0x8212
		},
		{
		0x85af
		},
		{
		0x897f
		},
		{
		0x8a93
		},
		{
		0x901d
		},
		{
		0x92e4
		},
		{
		0x9ecd
		},
		{
		0x9f20
		},
		{
		0x5915
		},
		{
		0x596d
		},
		{
		0x5e2d
		},
		{
		0x60dc
		},
		{
		0x6614
		},
		{
		0x6673
		},
		{
		0x6790
		},
		{
		0x6c50
		},
		{
		0x6dc5
		},
		{
		0x6f5f
		},
		{
		0x77f3
		},
		{
		0x78a9
		},
		{
		0x84c6
		},
		{
		0x91cb
		},
		{
		0x932b
		},
		{
		0x4ed9
		},
		{
		0x50ca
		},
		{
		0x5148
		},
		{
		0x5584
		},
		{
		0x5b0b
		},
		{
		0x5ba3
		},
		{
		0x6247
		},
		{
		0x657e
		},
		{
		0x65cb
		},
		{
		0x6e32
		},
		{
		0x717d
		},
		{
		0x7401
		},
		{
		0x7444
		},
		{
		0x7487
		},
		{
		0x74bf
		},
		{
		0x766c
		},
		{
		0x79aa
		},
		{
		0x7dda
		},
		{
		0x7e55
		},
		{
		0x7fa8
		},
		{
		0x817a
		},
		{
		0x81b3
		},
		{
		0x8239
		},
		{
		0x861a
		},
		{
		0x87ec
		},
		{
		0x8a75
		},
		{
		0x8de3
		},
		{
		0x9078
		},
		{
		0x9291
		},
		{
		0x9425
		},
		{
		0x994d
		},
		{
		0x9bae
		},
		{
		0x5368
		},
		{
		0x5c51
		},
		{
		0x6954
		},
		{
		0x6cc4
		},
		{
		0x6d29
		},
		{
		0x6e2b
		},
		{
		0x820c
		},
		{
		0x859b
		},
		{
		0x893b
		},
		{
		0x8a2d
		},
		{
		0x8aaa
		},
		{
		0x96ea
		},
		{
		0x9f67
		},
		{
		0x5261
		},
		{
		0x66b9
		},
		{
		0x6bb2
		},
		{
		0x7e96
		},
		{
		0x87fe
		},
		{
		0x8d0d
		},
		{
		0x9583
		},
		{
		0x965d
		},
		{
		0x651d
		},
		{
		0x6d89
		},
		{
		0x71ee
		},
		{
		0xf96e
		},
		{
		0x57ce
		},
		{
		0x59d3
		},
		{
		0x5bac
		},
		{
		0x6027
		},
		{
		0x60fa
		},
		{
		0x6210
		},
		{
		0x661f
		},
		{
		0x665f
		},
		{
		0x7329
		},
		{
		0x73f9
		},
		{
		0x76db
		},
		{
		0x7701
		},
		{
		0x7b6c
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_31[]=
	{
		{
		0x5098
		},
		{
		0x522a
		},
		{
		0x5c71
		},
		{
		0x6563
		},
		{
		0x6c55
		},
		{
		0x73ca
		},
		{
		0x7523
		},
		{
		0x759d
		},
		{
		0x7b97
		},
		{
		0x849c
		},
		{
		0x9178
		},
		{
		0x9730
		},
		{
		0x4e77
		},
		{
		0x6492
		},
		{
		0x6bba
		},
		{
		0x715e
		},
		{
		0x85a9
		},
		{
		0x4e09
		},
		{
		0xf96b
		},
		{
		0x6749
		},
		{
		0x68ee
		},
		{
		0x6e17
		},
		{
		0x829f
		},
		{
		0x8518
		},
		{
		0x886b
		},
		{
		0x63f7
		},
		{
		0x6f81
		},
		{
		0x9212
		},
		{
		0x98af
		},
		{
		0x4e0a
		},
		{
		0x50b7
		},
		{
		0x50cf
		},
		{
		0x511f
		},
		{
		0x5546
		},
		{
		0x55aa
		},
		{
		0x5617
		},
		{
		0x5b40
		},
		{
		0x5c19
		},
		{
		0x5ce0
		},
		{
		0x5e38
		},
		{
		0x5e8a
		},
		{
		0x5ea0
		},
		{
		0x5ec2
		},
		{
		0x60f3
		},
		{
		0x6851
		},
		{
		0x6a61
		},
		{
		0x6e58
		},
		{
		0x723d
		},
		{
		0x7240
		},
		{
		0x72c0
		},
		{
		0x76f8
		},
		{
		0x7965
		},
		{
		0x7bb1
		},
		{
		0x7fd4
		},
		{
		0x88f3
		},
		{
		0x89f4
		},
		{
		0x8a73
		},
		{
		0x8c61
		},
		{
		0x8cde
		},
		{
		0x971c
		},
		{
		0x585e
		},
		{
		0x74bd
		},
		{
		0x8cfd
		},
		{
		0x55c7
		},
		{
		0xf96c
		},
		{
		0x7a61
		},
		{
		0x7d22
		},
		{
		0x8272
		},
		{
		0x7272
		},
		{
		0x751f
		},
		{
		0x7525
		},
		{
		0xf96d
		},
		{
		0x7b19
		},
		{
		0x5885
		},
		{
		0x58fb
		},
		{
		0x5dbc
		},
		{
		0x5e8f
		},
		{
		0x5eb6
		},
		{
		0x5f90
		},
		{
		0x6055
		},
		{
		0x6292
		},
		{
		0x637f
		},
		{
		0x654d
		},
		{
		0x6691
		},
		{
		0x66d9
		},
		{
		0x66f8
		},
		{
		0x6816
		},
		{
		0x68f2
		},
		{
		0x7280
		},
		{
		0x745e
		},
		{
		0x7b6e
		},
		{
		0x7d6e
		},
		{
		0x7dd6
		},
		{
		0x7f72
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_32[]=
	{
		{
		0x813e
		},
		{
		0x81c2
		},
		{
		0x83f2
		},
		{
		0x871a
		},
		{
		0x88e8
		},
		{
		0x8ab9
		},
		{
		0x8b6c
		},
		{
		0x8cbb
		},
		{
		0x9119
		},
		{
		0x975e
		},
		{
		0x98db
		},
		{
		0x9f3b
		},
		{
		0x56ac
		},
		{
		0x5b2a
		},
		{
		0x5f6c
		},
		{
		0x658c
		},
		{
		0x6ab3
		},
		{
		0x6baf
		},
		{
		0x6d5c
		},
		{
		0x6ff1
		},
		{
		0x7015
		},
		{
		0x725d
		},
		{
		0x73ad
		},
		{
		0x8ca7
		},
		{
		0x8cd3
		},
		{
		0x983b
		},
		{
		0x6191
		},
		{
		0x6c37
		},
		{
		0x8058
		},
		{
		0x9a01
		},
		{
		0x4e4d
		},
		{
		0x4e8b
		},
		{
		0x4e9b
		},
		{
		0x4ed5
		},
		{
		0x4f3a
		},
		{
		0x4f3c
		},
		{
		0x4f7f
		},
		{
		0x4fdf
		},
		{
		0x50ff
		},
		{
		0x53f2
		},
		{
		0x53f8
		},
		{
		0x5506
		},
		{
		0x55e3
		},
		{
		0x56db
		},
		{
		0x58eb
		},
		{
		0x5962
		},
		{
		0x5a11
		},
		{
		0x5beb
		},
		{
		0x5bfa
		},
		{
		0x5c04
		},
		{
		0x5df3
		},
		{
		0x5e2b
		},
		{
		0x5f99
		},
		{
		0x601d
		},
		{
		0x6368
		},
		{
		0x659c
		},
		{
		0x65af
		},
		{
		0x67f6
		},
		{
		0x67fb
		},
		{
		0x68ad
		},
		{
		0x6b7b
		},
		{
		0x6c99
		},
		{
		0x6cd7
		},
		{
		0x6e23
		},
		{
		0x7009
		},
		{
		0x7345
		},
		{
		0x7802
		},
		{
		0x793e
		},
		{
		0x7940
		},
		{
		0x7960
		},
		{
		0x79c1
		},
		{
		0x7be9
		},
		{
		0x7d17
		},
		{
		0x7d72
		},
		{
		0x8086
		},
		{
		0x820d
		},
		{
		0x838e
		},
		{
		0x84d1
		},
		{
		0x86c7
		},
		{
		0x88df
		},
		{
		0x8a50
		},
		{
		0x8a5e
		},
		{
		0x8b1d
		},
		{
		0x8cdc
		},
		{
		0x8d66
		},
		{
		0x8fad
		},
		{
		0x90aa
		},
		{
		0x98fc
		},
		{
		0x99df
		},
		{
		0x9e9d
		},
		{
		0x524a
		},
		{
		0xf969
		},
		{
		0x6714
		},
		{
		0xf96a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_33[]=
	{
		{
		0x5b5a
		},
		{
		0x5b75
		},
		{
		0x5bcc
		},
		{
		0x5e9c
		},
		{
		0xf966
		},
		{
		0x6276
		},
		{
		0x6577
		},
		{
		0x65a7
		},
		{
		0x6d6e
		},
		{
		0x6ea5
		},
		{
		0x7236
		},
		{
		0x7b26
		},
		{
		0x7c3f
		},
		{
		0x7f36
		},
		{
		0x8150
		},
		{
		0x8151
		},
		{
		0x819a
		},
		{
		0x8240
		},
		{
		0x8299
		},
		{
		0x83a9
		},
		{
		0x8a03
		},
		{
		0x8ca0
		},
		{
		0x8ce6
		},
		{
		0x8cfb
		},
		{
		0x8d74
		},
		{
		0x8dba
		},
		{
		0x90e8
		},
		{
		0x91dc
		},
		{
		0x961c
		},
		{
		0x9644
		},
		{
		0x99d9
		},
		{
		0x9ce7
		},
		{
		0x5317
		},
		{
		0x5206
		},
		{
		0x5429
		},
		{
		0x5674
		},
		{
		0x58b3
		},
		{
		0x5954
		},
		{
		0x596e
		},
		{
		0x5fff
		},
		{
		0x61a4
		},
		{
		0x626e
		},
		{
		0x6610
		},
		{
		0x6c7e
		},
		{
		0x711a
		},
		{
		0x76c6
		},
		{
		0x7c89
		},
		{
		0x7cde
		},
		{
		0x7d1b
		},
		{
		0x82ac
		},
		{
		0x8cc1
		},
		{
		0x96f0
		},
		{
		0xf967
		},
		{
		0x4f5b
		},
		{
		0x5f17
		},
		{
		0x5f7f
		},
		{
		0x62c2
		},
		{
		0x5d29
		},
		{
		0x670b
		},
		{
		0x68da
		},
		{
		0x787c
		},
		{
		0x7e43
		},
		{
		0x9d6c
		},
		{
		0x4e15
		},
		{
		0x5099
		},
		{
		0x5315
		},
		{
		0x532a
		},
		{
		0x5351
		},
		{
		0x5983
		},
		{
		0x5a62
		},
		{
		0x5e87
		},
		{
		0x60b2
		},
		{
		0x618a
		},
		{
		0x6249
		},
		{
		0x6279
		},
		{
		0x6590
		},
		{
		0x6787
		},
		{
		0x69a7
		},
		{
		0x6bd4
		},
		{
		0x6bd6
		},
		{
		0x6bd7
		},
		{
		0x6bd8
		},
		{
		0x6cb8
		},
		{
		0xf968
		},
		{
		0x7435
		},
		{
		0x75fa
		},
		{
		0x7812
		},
		{
		0x7891
		},
		{
		0x79d5
		},
		{
		0x79d8
		},
		{
		0x7c83
		},
		{
		0x7dcb
		},
		{
		0x7fe1
		},
		{
		0x80a5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_34[]=
	{
		{
		0x78a7
		},
		{
		0x8617
		},
		{
		0x95e2
		},
		{
		0x9739
		},
		{
		0xf965
		},
		{
		0x535e
		},
		{
		0x5f01
		},
		{
		0x8b8a
		},
		{
		0x8fa8
		},
		{
		0x8faf
		},
		{
		0x908a
		},
		{
		0x5225
		},
		{
		0x77a5
		},
		{
		0x9c49
		},
		{
		0x9f08
		},
		{
		0x4e19
		},
		{
		0x5002
		},
		{
		0x5175
		},
		{
		0x5c5b
		},
		{
		0x5e77
		},
		{
		0x661e
		},
		{
		0x663a
		},
		{
		0x67c4
		},
		{
		0x68c5
		},
		{
		0x70b3
		},
		{
		0x7501
		},
		{
		0x75c5
		},
		{
		0x79c9
		},
		{
		0x7add
		},
		{
		0x8f27
		},
		{
		0x9920
		},
		{
		0x9a08
		},
		{
		0x4fdd
		},
		{
		0x5821
		},
		{
		0x5831
		},
		{
		0x5bf6
		},
		{
		0x666e
		},
		{
		0x6b65
		},
		{
		0x6d11
		},
		{
		0x6e7a
		},
		{
		0x6f7d
		},
		{
		0x73e4
		},
		{
		0x752b
		},
		{
		0x83e9
		},
		{
		0x88dc
		},
		{
		0x8913
		},
		{
		0x8b5c
		},
		{
		0x8f14
		},
		{
		0x4f0f
		},
		{
		0x50d5
		},
		{
		0x5310
		},
		{
		0x535c
		},
		{
		0x5b93
		},
		{
		0x5fa9
		},
		{
		0x670d
		},
		{
		0x798f
		},
		{
		0x8179
		},
		{
		0x832f
		},
		{
		0x8514
		},
		{
		0x8907
		},
		{
		0x8986
		},
		{
		0x8f39
		},
		{
		0x8f3b
		},
		{
		0x99a5
		},
		{
		0x9c12
		},
		{
		0x672c
		},
		{
		0x4e76
		},
		{
		0x4ff8
		},
		{
		0x5949
		},
		{
		0x5c01
		},
		{
		0x5cef
		},
		{
		0x5cf0
		},
		{
		0x6367
		},
		{
		0x68d2
		},
		{
		0x70fd
		},
		{
		0x71a2
		},
		{
		0x742b
		},
		{
		0x7e2b
		},
		{
		0x84ec
		},
		{
		0x8702
		},
		{
		0x9022
		},
		{
		0x92d2
		},
		{
		0x9cf3
		},
		{
		0x4e0d
		},
		{
		0x4ed8
		},
		{
		0x4fef
		},
		{
		0x5085
		},
		{
		0x5256
		},
		{
		0x526f
		},
		{
		0x5426
		},
		{
		0x5490
		},
		{
		0x57e0
		},
		{
		0x592b
		},
		{
		0x5a66
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_35[]=
	{
		{
		0x767c
		},
		{
		0x8dcb
		},
		{
		0x91b1
		},
		{
		0x9262
		},
		{
		0x9aee
		},
		{
		0x9b43
		},
		{
		0x5023
		},
		{
		0x508d
		},
		{
		0x574a
		},
		{
		0x59a8
		},
		{
		0x5c28
		},
		{
		0x5e47
		},
		{
		0x5f77
		},
		{
		0x623f
		},
		{
		0x653e
		},
		{
		0x65b9
		},
		{
		0x65c1
		},
		{
		0x6609
		},
		{
		0x678b
		},
		{
		0x699c
		},
		{
		0x6ec2
		},
		{
		0x78c5
		},
		{
		0x7d21
		},
		{
		0x80aa
		},
		{
		0x8180
		},
		{
		0x822b
		},
		{
		0x82b3
		},
		{
		0x84a1
		},
		{
		0x868c
		},
		{
		0x8a2a
		},
		{
		0x8b17
		},
		{
		0x90a6
		},
		{
		0x9632
		},
		{
		0x9f90
		},
		{
		0x500d
		},
		{
		0x4ff3
		},
		{
		0xf963
		},
		{
		0x57f9
		},
		{
		0x5f98
		},
		{
		0x62dc
		},
		{
		0x6392
		},
		{
		0x676f
		},
		{
		0x6e43
		},
		{
		0x7119
		},
		{
		0x76c3
		},
		{
		0x80cc
		},
		{
		0x80da
		},
		{
		0x88f4
		},
		{
		0x88f5
		},
		{
		0x8919
		},
		{
		0x8ce0
		},
		{
		0x8f29
		},
		{
		0x914d
		},
		{
		0x966a
		},
		{
		0x4f2f
		},
		{
		0x4f70
		},
		{
		0x5e1b
		},
		{
		0x67cf
		},
		{
		0x6822
		},
		{
		0x767d
		},
		{
		0x767e
		},
		{
		0x9b44
		},
		{
		0x5e61
		},
		{
		0x6a0a
		},
		{
		0x7169
		},
		{
		0x71d4
		},
		{
		0x756a
		},
		{
		0xf964
		},
		{
		0x7e41
		},
		{
		0x8543
		},
		{
		0x85e9
		},
		{
		0x98dc
		},
		{
		0x4f10
		},
		{
		0x7b4f
		},
		{
		0x7f70
		},
		{
		0x95a5
		},
		{
		0x51e1
		},
		{
		0x5e06
		},
		{
		0x68b5
		},
		{
		0x6c3e
		},
		{
		0x6c4e
		},
		{
		0x6cdb
		},
		{
		0x72af
		},
		{
		0x7bc4
		},
		{
		0x8303
		},
		{
		0x6cd5
		},
		{
		0x743a
		},
		{
		0x50fb
		},
		{
		0x5288
		},
		{
		0x58c1
		},
		{
		0x64d8
		},
		{
		0x6a97
		},
		{
		0x74a7
		},
		{
		0x7656
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_36[]=
	{
		{
		0x6c76
		},
		{
		0x7d0a
		},
		{
		0x7d0b
		},
		{
		0x805e
		},
		{
		0x868a
		},
		{
		0x9580
		},
		{
		0x96ef
		},
		{
		0x52ff
		},
		{
		0x6c95
		},
		{
		0x7269
		},
		{
		0x5473
		},
		{
		0x5a9a
		},
		{
		0x5c3e
		},
		{
		0x5d4b
		},
		{
		0x5f4c
		},
		{
		0x5fae
		},
		{
		0x672a
		},
		{
		0x68b6
		},
		{
		0x6963
		},
		{
		0x6e3c
		},
		{
		0x6e44
		},
		{
		0x7709
		},
		{
		0x7c73
		},
		{
		0x7f8e
		},
		{
		0x8587
		},
		{
		0x8b0e
		},
		{
		0x8ff7
		},
		{
		0x9761
		},
		{
		0x9ef4
		},
		{
		0x5cb7
		},
		{
		0x60b6
		},
		{
		0x610d
		},
		{
		0x61ab
		},
		{
		0x654f
		},
		{
		0x65fb
		},
		{
		0x65fc
		},
		{
		0x6c11
		},
		{
		0x6cef
		},
		{
		0x739f
		},
		{
		0x73c9
		},
		{
		0x7de1
		},
		{
		0x9594
		},
		{
		0x5bc6
		},
		{
		0x871c
		},
		{
		0x8b10
		},
		{
		0x525d
		},
		{
		0x535a
		},
		{
		0x62cd
		},
		{
		0x640f
		},
		{
		0x64b2
		},
		{
		0x6734
		},
		{
		0x6a38
		},
		{
		0x6cca
		},
		{
		0x73c0
		},
		{
		0x749e
		},
		{
		0x7b94
		},
		{
		0x7c95
		},
		{
		0x7e1b
		},
		{
		0x818a
		},
		{
		0x8236
		},
		{
		0x8584
		},
		{
		0x8feb
		},
		{
		0x96f9
		},
		{
		0x99c1
		},
		{
		0x4f34
		},
		{
		0x534a
		},
		{
		0x53cd
		},
		{
		0x53db
		},
		{
		0x62cc
		},
		{
		0x642c
		},
		{
		0x6500
		},
		{
		0x6591
		},
		{
		0x69c3
		},
		{
		0x6cee
		},
		{
		0x6f58
		},
		{
		0x73ed
		},
		{
		0x7554
		},
		{
		0x7622
		},
		{
		0x76e4
		},
		{
		0x76fc
		},
		{
		0x78d0
		},
		{
		0x78fb
		},
		{
		0x792c
		},
		{
		0x7d46
		},
		{
		0x822c
		},
		{
		0x87e0
		},
		{
		0x8fd4
		},
		{
		0x9812
		},
		{
		0x98ef
		},
		{
		0x52c3
		},
		{
		0x62d4
		},
		{
		0x64a5
		},
		{
		0x6e24
		},
		{
		0x6f51
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_37[]=
	{
		{
		0x8511
		},
		{
		0x51a5
		},
		{
		0x540d
		},
		{
		0x547d
		},
		{
		0x660e
		},
		{
		0x669d
		},
		{
		0x6927
		},
		{
		0x6e9f
		},
		{
		0x76bf
		},
		{
		0x7791
		},
		{
		0x8317
		},
		{
		0x84c2
		},
		{
		0x879f
		},
		{
		0x9169
		},
		{
		0x9298
		},
		{
		0x9cf4
		},
		{
		0x8882
		},
		{
		0x4fae
		},
		{
		0x5192
		},
		{
		0x52df
		},
		{
		0x59c6
		},
		{
		0x5e3d
		},
		{
		0x6155
		},
		{
		0x6478
		},
		{
		0x6479
		},
		{
		0x66ae
		},
		{
		0x67d0
		},
		{
		0x6a21
		},
		{
		0x6bcd
		},
		{
		0x6bdb
		},
		{
		0x725f
		},
		{
		0x7261
		},
		{
		0x7441
		},
		{
		0x7738
		},
		{
		0x77db
		},
		{
		0x8017
		},
		{
		0x82bc
		},
		{
		0x8305
		},
		{
		0x8b00
		},
		{
		0x8b28
		},
		{
		0x8c8c
		},
		{
		0x6728
		},
		{
		0x6c90
		},
		{
		0x7267
		},
		{
		0x76ee
		},
		{
		0x7766
		},
		{
		0x7a46
		},
		{
		0x9da9
		},
		{
		0x6b7f
		},
		{
		0x6c92
		},
		{
		0x5922
		},
		{
		0x6726
		},
		{
		0x8499
		},
		{
		0x536f
		},
		{
		0x5893
		},
		{
		0x5999
		},
		{
		0x5edf
		},
		{
		0x63cf
		},
		{
		0x6634
		},
		{
		0x6773
		},
		{
		0x6e3a
		},
		{
		0x732b
		},
		{
		0x7ad7
		},
		{
		0x82d7
		},
		{
		0x9328
		},
		{
		0x52d9
		},
		{
		0x5deb
		},
		{
		0x61ae
		},
		{
		0x61cb
		},
		{
		0x620a
		},
		{
		0x62c7
		},
		{
		0x64ab
		},
		{
		0x65e0
		},
		{
		0x6959
		},
		{
		0x6b66
		},
		{
		0x6bcb
		},
		{
		0x7121
		},
		{
		0x73f7
		},
		{
		0x755d
		},
		{
		0x7e46
		},
		{
		0x821e
		},
		{
		0x8302
		},
		{
		0x856a
		},
		{
		0x8aa3
		},
		{
		0x8cbf
		},
		{
		0x9727
		},
		{
		0x9d61
		},
		{
		0x58a8
		},
		{
		0x9ed8
		},
		{
		0x5011
		},
		{
		0x520e
		},
		{
		0x543b
		},
		{
		0x554f
		},
		{
		0x6587
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_38[]=
	{
		{
		0x7acb
		},
		{
		0x7b20
		},
		{
		0x7c92
		},
		{
		0x6469
		},
		{
		0x746a
		},
		{
		0x75f2
		},
		{
		0x78bc
		},
		{
		0x78e8
		},
		{
		0x99ac
		},
		{
		0x9b54
		},
		{
		0x9ebb
		},
		{
		0x5bde
		},
		{
		0x5e55
		},
		{
		0x6f20
		},
		{
		0x819c
		},
		{
		0x83ab
		},
		{
		0x9088
		},
		{
		0x4e07
		},
		{
		0x534d
		},
		{
		0x5a29
		},
		{
		0x5dd2
		},
		{
		0x5f4e
		},
		{
		0x6162
		},
		{
		0x633d
		},
		{
		0x6669
		},
		{
		0x66fc
		},
		{
		0x6eff
		},
		{
		0x6f2b
		},
		{
		0x7063
		},
		{
		0x779e
		},
		{
		0x842c
		},
		{
		0x8513
		},
		{
		0x883b
		},
		{
		0x8f13
		},
		{
		0x9945
		},
		{
		0x9c3b
		},
		{
		0x551c
		},
		{
		0x62b9
		},
		{
		0x672b
		},
		{
		0x6cab
		},
		{
		0x8309
		},
		{
		0x896a
		},
		{
		0x977a
		},
		{
		0x4ea1
		},
		{
		0x5984
		},
		{
		0x5fd8
		},
		{
		0x5fd9
		},
		{
		0x671b
		},
		{
		0x7db2
		},
		{
		0x7f54
		},
		{
		0x8292
		},
		{
		0x832b
		},
		{
		0x83bd
		},
		{
		0x8f1e
		},
		{
		0x9099
		},
		{
		0x57cb
		},
		{
		0x59b9
		},
		{
		0x5a92
		},
		{
		0x5bd0
		},
		{
		0x6627
		},
		{
		0x679a
		},
		{
		0x6885
		},
		{
		0x6bcf
		},
		{
		0x7164
		},
		{
		0x7f75
		},
		{
		0x8cb7
		},
		{
		0x8ce3
		},
		{
		0x9081
		},
		{
		0x9b45
		},
		{
		0x8108
		},
		{
		0x8c8a
		},
		{
		0x964c
		},
		{
		0x9a40
		},
		{
		0x9ea5
		},
		{
		0x5b5f
		},
		{
		0x6c13
		},
		{
		0x731b
		},
		{
		0x76f2
		},
		{
		0x76df
		},
		{
		0x840c
		},
		{
		0x51aa
		},
		{
		0x8993
		},
		{
		0x514d
		},
		{
		0x5195
		},
		{
		0x52c9
		},
		{
		0x68c9
		},
		{
		0x6c94
		},
		{
		0x7704
		},
		{
		0x7720
		},
		{
		0x7dbf
		},
		{
		0x7dec
		},
		{
		0x9762
		},
		{
		0x9eb5
		},
		{
		0x6ec5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_39[]=
	{
		{
		0x907c
		},
		{
		0x9b27
		},
		{
		0x9f8d
		},
		{
		0x58d8
		},
		{
		0x5a41
		},
		{
		0x5c62
		},
		{
		0x6a13
		},
		{
		0x6dda
		},
		{
		0x6f0f
		},
		{
		0x763b
		},
		{
		0x7d2f
		},
		{
		0x7e37
		},
		{
		0x851e
		},
		{
		0x8938
		},
		{
		0x93e4
		},
		{
		0x964b
		},
		{
		0x5289
		},
		{
		0x65d2
		},
		{
		0x67f3
		},
		{
		0x69b4
		},
		{
		0x6d41
		},
		{
		0x6e9c
		},
		{
		0x700f
		},
		{
		0x7409
		},
		{
		0x7460
		},
		{
		0x7559
		},
		{
		0x7624
		},
		{
		0x786b
		},
		{
		0x8b2c
		},
		{
		0x985e
		},
		{
		0x516d
		},
		{
		0x622e
		},
		{
		0x9678
		},
		{
		0x4f96
		},
		{
		0x502b
		},
		{
		0x5d19
		},
		{
		0x6dea
		},
		{
		0x7db8
		},
		{
		0x8f2a
		},
		{
		0x5f8b
		},
		{
		0x6144
		},
		{
		0x6817
		},
		{
		0xf961
		},
		{
		0x9686
		},
		{
		0x52d2
		},
		{
		0x808b
		},
		{
		0x51dc
		},
		{
		0x51cc
		},
		{
		0x695e
		},
		{
		0x7a1c
		},
		{
		0x7dbe
		},
		{
		0x83f1
		},
		{
		0x9675
		},
		{
		0x4fda
		},
		{
		0x5229
		},
		{
		0x5398
		},
		{
		0x540f
		},
		{
		0x550e
		},
		{
		0x5c65
		},
		{
		0x60a7
		},
		{
		0x674e
		},
		{
		0x68a8
		},
		{
		0x6d6c
		},
		{
		0x7281
		},
		{
		0x72f8
		},
		{
		0x7406
		},
		{
		0x7483
		},
		{
		0xf962
		},
		{
		0x75e2
		},
		{
		0x7c6c
		},
		{
		0x7f79
		},
		{
		0x7fb8
		},
		{
		0x8389
		},
		{
		0x88cf
		},
		{
		0x88e1
		},
		{
		0x91cc
		},
		{
		0x91d0
		},
		{
		0x96e2
		},
		{
		0x9bc9
		},
		{
		0x541d
		},
		{
		0x6f7e
		},
		{
		0x71d0
		},
		{
		0x7498
		},
		{
		0x85fa
		},
		{
		0x8eaa
		},
		{
		0x96a3
		},
		{
		0x9c57
		},
		{
		0x9e9f
		},
		{
		0x6797
		},
		{
		0x6dcb
		},
		{
		0x7433
		},
		{
		0x81e8
		},
		{
		0x9716
		},
		{
		0x782c
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_40[]=
	{
		{
		0x7149
		},
		{
		0x7489
		},
		{
		0x7df4
		},
		{
		0x806f
		},
		{
		0x84ee
		},
		{
		0x8f26
		},
		{
		0x9023
		},
		{
		0x934a
		},
		{
		0x51bd
		},
		{
		0x5217
		},
		{
		0x52a3
		},
		{
		0x6d0c
		},
		{
		0x70c8
		},
		{
		0x88c2
		},
		{
		0x5ec9
		},
		{
		0x6582
		},
		{
		0x6bae
		},
		{
		0x6fc2
		},
		{
		0x7c3e
		},
		{
		0x7375
		},
		{
		0x4ee4
		},
		{
		0x4f36
		},
		{
		0x56f9
		},
		{
		0xf95f
		},
		{
		0x5cba
		},
		{
		0x5dba
		},
		{
		0x601c
		},
		{
		0x73b2
		},
		{
		0x7b2d
		},
		{
		0x7f9a
		},
		{
		0x7fce
		},
		{
		0x8046
		},
		{
		0x901e
		},
		{
		0x9234
		},
		{
		0x96f6
		},
		{
		0x9748
		},
		{
		0x9818
		},
		{
		0x9f61
		},
		{
		0x4f8b
		},
		{
		0x6fa7
		},
		{
		0x79ae
		},
		{
		0x91b4
		},
		{
		0x96b7
		},
		{
		0x52de
		},
		{
		0xf960
		},
		{
		0x6488
		},
		{
		0x64c4
		},
		{
		0x6ad3
		},
		{
		0x6f5e
		},
		{
		0x7018
		},
		{
		0x7210
		},
		{
		0x76e7
		},
		{
		0x8001
		},
		{
		0x8606
		},
		{
		0x865c
		},
		{
		0x8def
		},
		{
		0x8f05
		},
		{
		0x9732
		},
		{
		0x9b6f
		},
		{
		0x9dfa
		},
		{
		0x9e75
		},
		{
		0x788c
		},
		{
		0x797f
		},
		{
		0x7da0
		},
		{
		0x83c9
		},
		{
		0x9304
		},
		{
		0x9e7f
		},
		{
		0x9e93
		},
		{
		0x8ad6
		},
		{
		0x58df
		},
		{
		0x5f04
		},
		{
		0x6727
		},
		{
		0x7027
		},
		{
		0x74cf
		},
		{
		0x7c60
		},
		{
		0x807e
		},
		{
		0x5121
		},
		{
		0x7028
		},
		{
		0x7262
		},
		{
		0x78ca
		},
		{
		0x8cc2
		},
		{
		0x8cda
		},
		{
		0x8cf4
		},
		{
		0x96f7
		},
		{
		0x4e86
		},
		{
		0x50da
		},
		{
		0x5bee
		},
		{
		0x5ed6
		},
		{
		0x6599
		},
		{
		0x71ce
		},
		{
		0x7642
		},
		{
		0x77ad
		},
		{
		0x804a
		},
		{
		0x84fc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_41[]=
	{
		{
		0x863f
		},
		{
		0x87ba
		},
		{
		0x88f8
		},
		{
		0x908f
		},
		{
		0xf95c
		},
		{
		0x6d1b
		},
		{
		0x70d9
		},
		{
		0x73de
		},
		{
		0x7d61
		},
		{
		0x843d
		},
		{
		0xf95d
		},
		{
		0x916a
		},
		{
		0x99f1
		},
		{
		0xf95e
		},
		{
		0x4e82
		},
		{
		0x5375
		},
		{
		0x6b04
		},
		{
		0x6b12
		},
		{
		0x703e
		},
		{
		0x721b
		},
		{
		0x862d
		},
		{
		0x9e1e
		},
		{
		0x524c
		},
		{
		0x8fa3
		},
		{
		0x5d50
		},
		{
		0x64e5
		},
		{
		0x652c
		},
		{
		0x6b16
		},
		{
		0x6feb
		},
		{
		0x7c43
		},
		{
		0x7e9c
		},
		{
		0x85cd
		},
		{
		0x8964
		},
		{
		0x89bd
		},
		{
		0x62c9
		},
		{
		0x81d8
		},
		{
		0x881f
		},
		{
		0x5eca
		},
		{
		0x6717
		},
		{
		0x6d6a
		},
		{
		0x72fc
		},
		{
		0x7405
		},
		{
		0x746f
		},
		{
		0x8782
		},
		{
		0x90de
		},
		{
		0x4f86
		},
		{
		0x5d0d
		},
		{
		0x5fa0
		},
		{
		0x840a
		},
		{
		0x51b7
		},
		{
		0x63a0
		},
		{
		0x7565
		},
		{
		0x4eae
		},
		{
		0x5006
		},
		{
		0x5169
		},
		{
		0x51c9
		},
		{
		0x6881
		},
		{
		0x6a11
		},
		{
		0x7cae
		},
		{
		0x7cb1
		},
		{
		0x7ce7
		},
		{
		0x826f
		},
		{
		0x8ad2
		},
		{
		0x8f1b
		},
		{
		0x91cf
		},
		{
		0x4fb6
		},
		{
		0x5137
		},
		{
		0x52f5
		},
		{
		0x5442
		},
		{
		0x5eec
		},
		{
		0x616e
		},
		{
		0x623e
		},
		{
		0x65c5
		},
		{
		0x6ada
		},
		{
		0x6ffe
		},
		{
		0x792a
		},
		{
		0x85dc
		},
		{
		0x8823
		},
		{
		0x95ad
		},
		{
		0x9a62
		},
		{
		0x9a6a
		},
		{
		0x9e97
		},
		{
		0x9ece
		},
		{
		0x529b
		},
		{
		0x66c6
		},
		{
		0x6b77
		},
		{
		0x701d
		},
		{
		0x792b
		},
		{
		0x8f62
		},
		{
		0x9742
		},
		{
		0x6190
		},
		{
		0x6200
		},
		{
		0x6523
		},
		{
		0x6f23
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_42[]=
	{
		{
		0x68f9
		},
		{
		0x6ac2
		},
		{
		0x6dd8
		},
		{
		0x6e21
		},
		{
		0x6ed4
		},
		{
		0x6fe4
		},
		{
		0x71fe
		},
		{
		0x76dc
		},
		{
		0x7779
		},
		{
		0x79b1
		},
		{
		0x7a3b
		},
		{
		0x8404
		},
		{
		0x89a9
		},
		{
		0x8ced
		},
		{
		0x8df3
		},
		{
		0x8e48
		},
		{
		0x9003
		},
		{
		0x9014
		},
		{
		0x9053
		},
		{
		0x90fd
		},
		{
		0x934d
		},
		{
		0x9676
		},
		{
		0x97dc
		},
		{
		0x6bd2
		},
		{
		0x7006
		},
		{
		0x7258
		},
		{
		0x72a2
		},
		{
		0x7368
		},
		{
		0x7763
		},
		{
		0x79bf
		},
		{
		0x7be4
		},
		{
		0x7e9b
		},
		{
		0x8b80
		},
		{
		0x58a9
		},
		{
		0x60c7
		},
		{
		0x6566
		},
		{
		0x65fd
		},
		{
		0x66be
		},
		{
		0x6c8c
		},
		{
		0x711e
		},
		{
		0x71c9
		},
		{
		0x8c5a
		},
		{
		0x9813
		},
		{
		0x4e6d
		},
		{
		0x7a81
		},
		{
		0x4edd
		},
		{
		0x51ac
		},
		{
		0x51cd
		},
		{
		0x52d5
		},
		{
		0x540c
		},
		{
		0x61a7
		},
		{
		0x6771
		},
		{
		0x6850
		},
		{
		0x68df
		},
		{
		0x6d1e
		},
		{
		0x6f7c
		},
		{
		0x75bc
		},
		{
		0x77b3
		},
		{
		0x7ae5
		},
		{
		0x80f4
		},
		{
		0x8463
		},
		{
		0x9285
		},
		{
		0x515c
		},
		{
		0x6597
		},
		{
		0x675c
		},
		{
		0x6793
		},
		{
		0x75d8
		},
		{
		0x7ac7
		},
		{
		0x8373
		},
		{
		0xf95a
		},
		{
		0x8c46
		},
		{
		0x9017
		},
		{
		0x982d
		},
		{
		0x5c6f
		},
		{
		0x81c0
		},
		{
		0x829a
		},
		{
		0x9041
		},
		{
		0x906f
		},
		{
		0x920d
		},
		{
		0x5f97
		},
		{
		0x5d9d
		},
		{
		0x6a59
		},
		{
		0x71c8
		},
		{
		0x767b
		},
		{
		0x7b49
		},
		{
		0x85e4
		},
		{
		0x8b04
		},
		{
		0x9127
		},
		{
		0x9a30
		},
		{
		0x5587
		},
		{
		0x61f6
		},
		{
		0xf95b
		},
		{
		0x7669
		},
		{
		0x7f85
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_43[]=
	{
		{
		0x4e39
		},
		{
		0x4eb6
		},
		{
		0x4f46
		},
		{
		0x55ae
		},
		{
		0x5718
		},
		{
		0x58c7
		},
		{
		0x5f56
		},
		{
		0x65b7
		},
		{
		0x65e6
		},
		{
		0x6a80
		},
		{
		0x6bb5
		},
		{
		0x6e4d
		},
		{
		0x77ed
		},
		{
		0x7aef
		},
		{
		0x7c1e
		},
		{
		0x7dde
		},
		{
		0x86cb
		},
		{
		0x8892
		},
		{
		0x9132
		},
		{
		0x935b
		},
		{
		0x64bb
		},
		{
		0x6fbe
		},
		{
		0x737a
		},
		{
		0x75b8
		},
		{
		0x9054
		},
		{
		0x5556
		},
		{
		0x574d
		},
		{
		0x61ba
		},
		{
		0x64d4
		},
		{
		0x66c7
		},
		{
		0x6de1
		},
		{
		0x6e5b
		},
		{
		0x6f6d
		},
		{
		0x6fb9
		},
		{
		0x75f0
		},
		{
		0x8043
		},
		{
		0x81bd
		},
		{
		0x8541
		},
		{
		0x8983
		},
		{
		0x8ac7
		},
		{
		0x8b5a
		},
		{
		0x931f
		},
		{
		0x6c93
		},
		{
		0x7553
		},
		{
		0x7b54
		},
		{
		0x8e0f
		},
		{
		0x905d
		},
		{
		0x5510
		},
		{
		0x5802
		},
		{
		0x5858
		},
		{
		0x5e62
		},
		{
		0x6207
		},
		{
		0x649e
		},
		{
		0x68e0
		},
		{
		0x7576
		},
		{
		0x7cd6
		},
		{
		0x87b3
		},
		{
		0x9ee8
		},
		{
		0x4ee3
		},
		{
		0x5788
		},
		{
		0x576e
		},
		{
		0x5927
		},
		{
		0x5c0d
		},
		{
		0x5cb1
		},
		{
		0x5e36
		},
		{
		0x5f85
		},
		{
		0x6234
		},
		{
		0x64e1
		},
		{
		0x73b3
		},
		{
		0x81fa
		},
		{
		0x888b
		},
		{
		0x8cb8
		},
		{
		0x968a
		},
		{
		0x9edb
		},
		{
		0x5b85
		},
		{
		0x5fb7
		},
		{
		0x60b3
		},
		{
		0x5012
		},
		{
		0x5200
		},
		{
		0x5230
		},
		{
		0x5716
		},
		{
		0x5835
		},
		{
		0x5857
		},
		{
		0x5c0e
		},
		{
		0x5c60
		},
		{
		0x5cf6
		},
		{
		0x5d8b
		},
		{
		0x5ea6
		},
		{
		0x5f92
		},
		{
		0x60bc
		},
		{
		0x6311
		},
		{
		0x6389
		},
		{
		0x6417
		},
		{
		0x6843
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_44[]=
	{
		{
		0x80fd
		},
		{
		0xf958
		},
		{
		0xf959
		},
		{
		0x5c3c
		},
		{
		0x6ce5
		},
		{
		0x533f
		},
		{
		0x6eba
		},
		{
		0x591a
		},
		{
		0x8336
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_45[]=
	{
		{
		0x6fc3
		},
		{
		0xf944
		},
		{
		0xf945
		},
		{
		0x81bf
		},
		{
		0x8fb2
		},
		{
		0x60f1
		},
		{
		0xf946
		},
		{
		0xf947
		},
		{
		0x8166
		},
		{
		0xf948
		},
		{
		0xf949
		},
		{
		0x5c3f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_46[]=
	{
		{
		0x4e43
		},
		{
		0xf92d
		},
		{
		0x5167
		},
		{
		0x5948
		},
		{
		0x67f0
		},
		{
		0x8010
		},
		{
		0xf92e
		},
		{
		0x5973
		},
		{
		0x5e74
		},
		{
		0x649a
		},
		{
		0x79ca
		},
		{
		0x5ff5
		},
		{
		0x606c
		},
		{
		0x62c8
		},
		{
		0x637b
		},
		{
		0x5be7
		},
		{
		0x5bd7
		},
		{
		0x52aa
		},
		{
		0xf92f
		},
		{
		0x5974
		},
		{
		0x5f29
		},
		{
		0x6012
		},
		{
		0xf930
		},
		{
		0xf931
		},
		{
		0xf932
		},
		{
		0x7459
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_47[]=
	{
		{
		0x7d0d
		},
		{
		0xf926
		},
		{
		0xf927
		},
		{
		0x8872
		},
		{
		0x56ca
		},
		{
		0x5a18
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_48[]=
	{
		{
		0x8afe
		},
		{
		0xf919
		},
		{
		0xf91a
		},
		{
		0xf91b
		},
		{
		0xf91c
		},
		{
		0x6696
		},
		{
		0xf91d
		},
		{
		0x7156
		},
		{
		0xf91e
		},
		{
		0xf91f
		},
		{
		0x96e3
		},
		{
		0xf920
		},
		{
		0x634f
		},
		{
		0x637a
		},
		{
		0x5357
		},
		{
		0xf921
		},
		{
		0x678f
		},
		{
		0x6960
		},
		{
		0x6e73
		},
		{
		0xf922
		},
		{
		0x7537
		},
		{
		0xf923
		},
		{
		0xf924
		},
		{
		0xf925
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_49[]=
	{
		{
		0x671e
		},
		{
		0x671f
		},
		{
		0x675e
		},
		{
		0x68cb
		},
		{
		0x68c4
		},
		{
		0x6a5f
		},
		{
		0x6b3a
		},
		{
		0x6c23
		},
		{
		0x6c7d
		},
		{
		0x6c82
		},
		{
		0x6dc7
		},
		{
		0x7398
		},
		{
		0x7426
		},
		{
		0x742a
		},
		{
		0x7482
		},
		{
		0x74a3
		},
		{
		0x7578
		},
		{
		0x757f
		},
		{
		0x7881
		},
		{
		0x78ef
		},
		{
		0x7941
		},
		{
		0x7947
		},
		{
		0x7948
		},
		{
		0x797a
		},
		{
		0x7b95
		},
		{
		0x7d00
		},
		{
		0x7dba
		},
		{
		0x7f88
		},
		{
		0x8006
		},
		{
		0x802d
		},
		{
		0x808c
		},
		{
		0x8a18
		},
		{
		0x8b4f
		},
		{
		0x8c48
		},
		{
		0x8d77
		},
		{
		0x9321
		},
		{
		0x9324
		},
		{
		0x98e2
		},
		{
		0x9951
		},
		{
		0x9a0e
		},
		{
		0x9a0f
		},
		{
		0x9a65
		},
		{
		0x9e92
		},
		{
		0x7dca
		},
		{
		0x4f76
		},
		{
		0x5409
		},
		{
		0x62ee
		},
		{
		0x6854
		},
		{
		0x91d1
		},
		{
		0x55ab
		},
		{
		0x513a
		},
		{
		0xf90b
		},
		{
		0xf90c
		},
		{
		0x5a1c
		},
		{
		0x61e6
		},
		{
		0xf90d
		},
		{
		0x62cf
		},
		{
		0x62ff
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_50[]=
	{
		{
		0x9b3c
		},
		{
		0xf907
		},
		{
		0x53eb
		},
		{
		0x572d
		},
		{
		0x594e
		},
		{
		0x63c6
		},
		{
		0x69fb
		},
		{
		0x73ea
		},
		{
		0x7845
		},
		{
		0x7aba
		},
		{
		0x7ac5
		},
		{
		0x7cfe
		},
		{
		0x8475
		},
		{
		0x898f
		},
		{
		0x8d73
		},
		{
		0x9035
		},
		{
		0x95a8
		},
		{
		0x52fb
		},
		{
		0x5747
		},
		{
		0x7547
		},
		{
		0x7b60
		},
		{
		0x83cc
		},
		{
		0x921e
		},
		{
		0xf908
		},
		{
		0x6a58
		},
		{
		0x514b
		},
		{
		0x524b
		},
		{
		0x5287
		},
		{
		0x621f
		},
		{
		0x68d8
		},
		{
		0x6975
		},
		{
		0x9699
		},
		{
		0x50c5
		},
		{
		0x52a4
		},
		{
		0x52e4
		},
		{
		0x61c3
		},
		{
		0x65a4
		},
		{
		0x6839
		},
		{
		0x69ff
		},
		{
		0x747e
		},
		{
		0x7b4b
		},
		{
		0x82b9
		},
		{
		0x83eb
		},
		{
		0x89b2
		},
		{
		0x8b39
		},
		{
		0x8fd1
		},
		{
		0x9949
		},
		{
		0xf909
		},
		{
		0x4eca
		},
		{
		0x5997
		},
		{
		0x64d2
		},
		{
		0x6611
		},
		{
		0x6a8e
		},
		{
		0x7434
		},
		{
		0x7981
		},
		{
		0x79bd
		},
		{
		0x82a9
		},
		{
		0x887e
		},
		{
		0x887f
		},
		{
		0x895f
		},
		{
		0xf90a
		},
		{
		0x9326
		},
		{
		0x4f0b
		},
		{
		0x53ca
		},
		{
		0x6025
		},
		{
		0x6271
		},
		{
		0x6c72
		},
		{
		0x7d1a
		},
		{
		0x7d66
		},
		{
		0x4e98
		},
		{
		0x5162
		},
		{
		0x77dc
		},
		{
		0x80af
		},
		{
		0x4f01
		},
		{
		0x4f0e
		},
		{
		0x5176
		},
		{
		0x5180
		},
		{
		0x55dc
		},
		{
		0x5668
		},
		{
		0x573b
		},
		{
		0x57fa
		},
		{
		0x57fc
		},
		{
		0x5914
		},
		{
		0x5947
		},
		{
		0x5993
		},
		{
		0x5bc4
		},
		{
		0x5c90
		},
		{
		0x5d0e
		},
		{
		0x5df1
		},
		{
		0x5e7e
		},
		{
		0x5fcc
		},
		{
		0x6280
		},
		{
		0x65d7
		},
		{
		0x65e3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_51[]=
	{
		{
		0x5340
		},
		{
		0x53e3
		},
		{
		0x53e5
		},
		{
		0x548e
		},
		{
		0x5614
		},
		{
		0x5775
		},
		{
		0x57a2
		},
		{
		0x5bc7
		},
		{
		0x5d87
		},
		{
		0x5ed0
		},
		{
		0x61fc
		},
		{
		0x62d8
		},
		{
		0x6551
		},
		{
		0x67b8
		},
		{
		0x67e9
		},
		{
		0x69cb
		},
		{
		0x6b50
		},
		{
		0x6bc6
		},
		{
		0x6bec
		},
		{
		0x6c42
		},
		{
		0x6e9d
		},
		{
		0x7078
		},
		{
		0x72d7
		},
		{
		0x7396
		},
		{
		0x7403
		},
		{
		0x77bf
		},
		{
		0x77e9
		},
		{
		0x7a76
		},
		{
		0x7d7f
		},
		{
		0x8009
		},
		{
		0x81fc
		},
		{
		0x8205
		},
		{
		0x820a
		},
		{
		0x82df
		},
		{
		0x8862
		},
		{
		0x8b33
		},
		{
		0x8cfc
		},
		{
		0x8ec0
		},
		{
		0x9011
		},
		{
		0x90b1
		},
		{
		0x9264
		},
		{
		0x92b6
		},
		{
		0x99d2
		},
		{
		0x9a45
		},
		{
		0x9ce9
		},
		{
		0x9dd7
		},
		{
		0x9f9c
		},
		{
		0x570b
		},
		{
		0x5c40
		},
		{
		0x83ca
		},
		{
		0x97a0
		},
		{
		0x97ab
		},
		{
		0x9eb4
		},
		{
		0x541b
		},
		{
		0x7a98
		},
		{
		0x7fa4
		},
		{
		0x88d9
		},
		{
		0x8ecd
		},
		{
		0x90e1
		},
		{
		0x5800
		},
		{
		0x5c48
		},
		{
		0x6398
		},
		{
		0x7a9f
		},
		{
		0x5bae
		},
		{
		0x5f13
		},
		{
		0x7a79
		},
		{
		0x7aae
		},
		{
		0x828e
		},
		{
		0x8eac
		},
		{
		0x5026
		},
		{
		0x5238
		},
		{
		0x52f8
		},
		{
		0x5377
		},
		{
		0x5708
		},
		{
		0x62f3
		},
		{
		0x6372
		},
		{
		0x6b0a
		},
		{
		0x6dc3
		},
		{
		0x7737
		},
		{
		0x53a5
		},
		{
		0x7357
		},
		{
		0x8568
		},
		{
		0x8e76
		},
		{
		0x95d5
		},
		{
		0x673a
		},
		{
		0x6ac3
		},
		{
		0x6f70
		},
		{
		0x8a6d
		},
		{
		0x8ecc
		},
		{
		0x994b
		},
		{
		0xf906
		},
		{
		0x6677
		},
		{
		0x6b78
		},
		{
		0x8cb4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_52[]=
	{
		{
		0x79d1
		},
		{
		0x83d3
		},
		{
		0x8a87
		},
		{
		0x8ab2
		},
		{
		0x8de8
		},
		{
		0x904e
		},
		{
		0x934b
		},
		{
		0x9846
		},
		{
		0x5ed3
		},
		{
		0x69e8
		},
		{
		0x85ff
		},
		{
		0x90ed
		},
		{
		0xf905
		},
		{
		0x51a0
		},
		{
		0x5b98
		},
		{
		0x5bec
		},
		{
		0x6163
		},
		{
		0x68fa
		},
		{
		0x6b3e
		},
		{
		0x704c
		},
		{
		0x742f
		},
		{
		0x74d8
		},
		{
		0x7ba1
		},
		{
		0x7f50
		},
		{
		0x83c5
		},
		{
		0x89c0
		},
		{
		0x8cab
		},
		{
		0x95dc
		},
		{
		0x9928
		},
		{
		0x522e
		},
		{
		0x605d
		},
		{
		0x62ec
		},
		{
		0x9002
		},
		{
		0x4f8a
		},
		{
		0x5149
		},
		{
		0x5321
		},
		{
		0x58d9
		},
		{
		0x5ee3
		},
		{
		0x66e0
		},
		{
		0x6d38
		},
		{
		0x709a
		},
		{
		0x72c2
		},
		{
		0x73d6
		},
		{
		0x7b50
		},
		{
		0x80f1
		},
		{
		0x945b
		},
		{
		0x5366
		},
		{
		0x639b
		},
		{
		0x7f6b
		},
		{
		0x4e56
		},
		{
		0x5080
		},
		{
		0x584a
		},
		{
		0x58de
		},
		{
		0x602a
		},
		{
		0x6127
		},
		{
		0x62d0
		},
		{
		0x69d0
		},
		{
		0x9b41
		},
		{
		0x5b8f
		},
		{
		0x7d18
		},
		{
		0x80b1
		},
		{
		0x8f5f
		},
		{
		0x4ea4
		},
		{
		0x50d1
		},
		{
		0x54ac
		},
		{
		0x55ac
		},
		{
		0x5b0c
		},
		{
		0x5da0
		},
		{
		0x5de7
		},
		{
		0x652a
		},
		{
		0x654e
		},
		{
		0x6821
		},
		{
		0x6a4b
		},
		{
		0x72e1
		},
		{
		0x768e
		},
		{
		0x77ef
		},
		{
		0x7d5e
		},
		{
		0x7ff9
		},
		{
		0x81a0
		},
		{
		0x854e
		},
		{
		0x86df
		},
		{
		0x8f03
		},
		{
		0x8f4e
		},
		{
		0x90ca
		},
		{
		0x9903
		},
		{
		0x9a55
		},
		{
		0x9bab
		},
		{
		0x4e18
		},
		{
		0x4e45
		},
		{
		0x4e5d
		},
		{
		0x4ec7
		},
		{
		0x4ff1
		},
		{
		0x5177
		},
		{
		0x52fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_53[]=
	{
		{
		0x68e8
		},
		{
		0x6eaa
		},
		{
		0x754c
		},
		{
		0x7678
		},
		{
		0x78ce
		},
		{
		0x7a3d
		},
		{
		0x7cfb
		},
		{
		0x7e6b
		},
		{
		0x7e7c
		},
		{
		0x8a08
		},
		{
		0x8aa1
		},
		{
		0x8c3f
		},
		{
		0x968e
		},
		{
		0x9dc4
		},
		{
		0x53e4
		},
		{
		0x53e9
		},
		{
		0x544a
		},
		{
		0x5471
		},
		{
		0x56fa
		},
		{
		0x59d1
		},
		{
		0x5b64
		},
		{
		0x5c3b
		},
		{
		0x5eab
		},
		{
		0x62f7
		},
		{
		0x6537
		},
		{
		0x6545
		},
		{
		0x6572
		},
		{
		0x66a0
		},
		{
		0x67af
		},
		{
		0x69c1
		},
		{
		0x6cbd
		},
		{
		0x75fc
		},
		{
		0x7690
		},
		{
		0x777e
		},
		{
		0x7a3f
		},
		{
		0x7f94
		},
		{
		0x8003
		},
		{
		0x80a1
		},
		{
		0x818f
		},
		{
		0x82e6
		},
		{
		0x82fd
		},
		{
		0x83f0
		},
		{
		0x85c1
		},
		{
		0x8831
		},
		{
		0x88b4
		},
		{
		0x8aa5
		},
		{
		0xf903
		},
		{
		0x8f9c
		},
		{
		0x932e
		},
		{
		0x96c7
		},
		{
		0x9867
		},
		{
		0x9ad8
		},
		{
		0x9f13
		},
		{
		0x54ed
		},
		{
		0x659b
		},
		{
		0x66f2
		},
		{
		0x688f
		},
		{
		0x7a40
		},
		{
		0x8c37
		},
		{
		0x9d60
		},
		{
		0x56f0
		},
		{
		0x5764
		},
		{
		0x5d11
		},
		{
		0x6606
		},
		{
		0x68b1
		},
		{
		0x68cd
		},
		{
		0x6efe
		},
		{
		0x7428
		},
		{
		0x889e
		},
		{
		0x9be4
		},
		{
		0x6c68
		},
		{
		0xf904
		},
		{
		0x9aa8
		},
		{
		0x4f9b
		},
		{
		0x516c
		},
		{
		0x5171
		},
		{
		0x529f
		},
		{
		0x5b54
		},
		{
		0x5de5
		},
		{
		0x6050
		},
		{
		0x606d
		},
		{
		0x62f1
		},
		{
		0x63a7
		},
		{
		0x653b
		},
		{
		0x73d9
		},
		{
		0x7a7a
		},
		{
		0x86a3
		},
		{
		0x8ca2
		},
		{
		0x978f
		},
		{
		0x4e32
		},
		{
		0x5be1
		},
		{
		0x6208
		},
		{
		0x679c
		},
		{
		0x74dc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_54[]=
	{
		{
		0x77bc
		},
		{
		0x9210
		},
		{
		0x9ed4
		},
		{
		0x52ab
		},
		{
		0x602f
		},
		{
		0x8ff2
		},
		{
		0x5048
		},
		{
		0x61a9
		},
		{
		0x63ed
		},
		{
		0x64ca
		},
		{
		0x683c
		},
		{
		0x6a84
		},
		{
		0x6fc0
		},
		{
		0x8188
		},
		{
		0x89a1
		},
		{
		0x9694
		},
		{
		0x5805
		},
		{
		0x727d
		},
		{
		0x72ac
		},
		{
		0x7504
		},
		{
		0x7d79
		},
		{
		0x7e6d
		},
		{
		0x80a9
		},
		{
		0x898b
		},
		{
		0x8b74
		},
		{
		0x9063
		},
		{
		0x9d51
		},
		{
		0x6289
		},
		{
		0x6c7a
		},
		{
		0x6f54
		},
		{
		0x7d50
		},
		{
		0x7f3a
		},
		{
		0x8a23
		},
		{
		0x517c
		},
		{
		0x614a
		},
		{
		0x7b9d
		},
		{
		0x8b19
		},
		{
		0x9257
		},
		{
		0x938c
		},
		{
		0x4eac
		},
		{
		0x4fd3
		},
		{
		0x501e
		},
		{
		0x50be
		},
		{
		0x5106
		},
		{
		0x52c1
		},
		{
		0x52cd
		},
		{
		0x537f
		},
		{
		0x5770
		},
		{
		0x5883
		},
		{
		0x5e9a
		},
		{
		0x5f91
		},
		{
		0x6176
		},
		{
		0x61ac
		},
		{
		0x64ce
		},
		{
		0x656c
		},
		{
		0x666f
		},
		{
		0x66bb
		},
		{
		0x66f4
		},
		{
		0x6897
		},
		{
		0x6d87
		},
		{
		0x7085
		},
		{
		0x70f1
		},
		{
		0x749f
		},
		{
		0x74a5
		},
		{
		0x74ca
		},
		{
		0x75d9
		},
		{
		0x786c
		},
		{
		0x78ec
		},
		{
		0x7adf
		},
		{
		0x7af6
		},
		{
		0x7d45
		},
		{
		0x7d93
		},
		{
		0x8015
		},
		{
		0x803f
		},
		{
		0x811b
		},
		{
		0x8396
		},
		{
		0x8b66
		},
		{
		0x8f15
		},
		{
		0x9015
		},
		{
		0x93e1
		},
		{
		0x9803
		},
		{
		0x9838
		},
		{
		0x9a5a
		},
		{
		0x9be8
		},
		{
		0x4fc2
		},
		{
		0x5553
		},
		{
		0x583a
		},
		{
		0x5951
		},
		{
		0x5b63
		},
		{
		0x5c46
		},
		{
		0x60b8
		},
		{
		0x6212
		},
		{
		0x6842
		},
		{
		0x68b0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_55[]=
	{
		{
		0x5323
		},
		{
		0x5cac
		},
		{
		0x7532
		},
		{
		0x80db
		},
		{
		0x9240
		},
		{
		0x9598
		},
		{
		0x525b
		},
		{
		0x5808
		},
		{
		0x59dc
		},
		{
		0x5ca1
		},
		{
		0x5d17
		},
		{
		0x5eb7
		},
		{
		0x5f3a
		},
		{
		0x5f4a
		},
		{
		0x6177
		},
		{
		0x6c5f
		},
		{
		0x757a
		},
		{
		0x7586
		},
		{
		0x7ce0
		},
		{
		0x7d73
		},
		{
		0x7db1
		},
		{
		0x7f8c
		},
		{
		0x8154
		},
		{
		0x8221
		},
		{
		0x8591
		},
		{
		0x8941
		},
		{
		0x8b1b
		},
		{
		0x92fc
		},
		{
		0x964d
		},
		{
		0x9c47
		},
		{
		0x4ecb
		},
		{
		0x4ef7
		},
		{
		0x500b
		},
		{
		0x51f1
		},
		{
		0x584f
		},
		{
		0x6137
		},
		{
		0x613e
		},
		{
		0x6168
		},
		{
		0x6539
		},
		{
		0x69ea
		},
		{
		0x6f11
		},
		{
		0x75a5
		},
		{
		0x7686
		},
		{
		0x76d6
		},
		{
		0x7b87
		},
		{
		0x82a5
		},
		{
		0x84cb
		},
		{
		0xf900
		},
		{
		0x93a7
		},
		{
		0x958b
		},
		{
		0x5580
		},
		{
		0x5ba2
		},
		{
		0x5751
		},
		{
		0xf901
		},
		{
		0x7cb3
		},
		{
		0x7fb9
		},
		{
		0x91b5
		},
		{
		0x5028
		},
		{
		0x53bb
		},
		{
		0x5c45
		},
		{
		0x5de8
		},
		{
		0x62d2
		},
		{
		0x636e
		},
		{
		0x64da
		},
		{
		0x64e7
		},
		{
		0x6e20
		},
		{
		0x70ac
		},
		{
		0x795b
		},
		{
		0x8ddd
		},
		{
		0x8e1e
		},
		{
		0xf902
		},
		{
		0x907d
		},
		{
		0x9245
		},
		{
		0x92f8
		},
		{
		0x4e7e
		},
		{
		0x4ef6
		},
		{
		0x5065
		},
		{
		0x5dfe
		},
		{
		0x5efa
		},
		{
		0x6106
		},
		{
		0x6957
		},
		{
		0x8171
		},
		{
		0x8654
		},
		{
		0x8e47
		},
		{
		0x9375
		},
		{
		0x9a2b
		},
		{
		0x4e5e
		},
		{
		0x5091
		},
		{
		0x6770
		},
		{
		0x6840
		},
		{
		0x5109
		},
		{
		0x528d
		},
		{
		0x5292
		},
		{
		0x6aa2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_56[]=
	{
		{
		0x4f3d
		},
		{
		0x4f73
		},
		{
		0x5047
		},
		{
		0x50f9
		},
		{
		0x52a0
		},
		{
		0x53ef
		},
		{
		0x5475
		},
		{
		0x54e5
		},
		{
		0x5609
		},
		{
		0x5ac1
		},
		{
		0x5bb6
		},
		{
		0x6687
		},
		{
		0x67b6
		},
		{
		0x67b7
		},
		{
		0x67ef
		},
		{
		0x6b4c
		},
		{
		0x73c2
		},
		{
		0x75c2
		},
		{
		0x7a3c
		},
		{
		0x82db
		},
		{
		0x8304
		},
		{
		0x8857
		},
		{
		0x8888
		},
		{
		0x8a36
		},
		{
		0x8cc8
		},
		{
		0x8dcf
		},
		{
		0x8efb
		},
		{
		0x8fe6
		},
		{
		0x99d5
		},
		{
		0x523b
		},
		{
		0x5374
		},
		{
		0x5404
		},
		{
		0x606a
		},
		{
		0x6164
		},
		{
		0x6bbc
		},
		{
		0x73cf
		},
		{
		0x811a
		},
		{
		0x89ba
		},
		{
		0x89d2
		},
		{
		0x95a3
		},
		{
		0x4f83
		},
		{
		0x520a
		},
		{
		0x58be
		},
		{
		0x5978
		},
		{
		0x59e6
		},
		{
		0x5e72
		},
		{
		0x5e79
		},
		{
		0x61c7
		},
		{
		0x63c0
		},
		{
		0x6746
		},
		{
		0x67ec
		},
		{
		0x687f
		},
		{
		0x6f97
		},
		{
		0x764e
		},
		{
		0x770b
		},
		{
		0x78f5
		},
		{
		0x7a08
		},
		{
		0x7aff
		},
		{
		0x7c21
		},
		{
		0x809d
		},
		{
		0x826e
		},
		{
		0x8271
		},
		{
		0x8aeb
		},
		{
		0x9593
		},
		{
		0x4e6b
		},
		{
		0x559d
		},
		{
		0x66f7
		},
		{
		0x6e34
		},
		{
		0x78a3
		},
		{
		0x7aed
		},
		{
		0x845b
		},
		{
		0x8910
		},
		{
		0x874e
		},
		{
		0x97a8
		},
		{
		0x52d8
		},
		{
		0x574e
		},
		{
		0x582a
		},
		{
		0x5d4c
		},
		{
		0x611f
		},
		{
		0x61be
		},
		{
		0x6221
		},
		{
		0x6562
		},
		{
		0x67d1
		},
		{
		0x6a44
		},
		{
		0x6e1b
		},
		{
		0x7518
		},
		{
		0x75b3
		},
		{
		0x76e3
		},
		{
		0x77b0
		},
		{
		0x7d3a
		},
		{
		0x90af
		},
		{
		0x9451
		},
		{
		0x9452
		},
		{
		0x9f95
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_57[]=
	{
		{
		0xd624
		},
		{
		0xd62d
		},
		{
		0xd638
		},
		{
		0xd639
		},
		{
		0xd63c
		},
		{
		0xd640
		},
		{
		0xd645
		},
		{
		0xd648
		},
		{
		0xd649
		},
		{
		0xd64b
		},
		{
		0xd64d
		},
		{
		0xd651
		},
		{
		0xd654
		},
		{
		0xd655
		},
		{
		0xd658
		},
		{
		0xd65c
		},
		{
		0xd667
		},
		{
		0xd669
		},
		{
		0xd670
		},
		{
		0xd671
		},
		{
		0xd674
		},
		{
		0xd683
		},
		{
		0xd685
		},
		{
		0xd68c
		},
		{
		0xd68d
		},
		{
		0xd690
		},
		{
		0xd694
		},
		{
		0xd69d
		},
		{
		0xd69f
		},
		{
		0xd6a1
		},
		{
		0xd6a8
		},
		{
		0xd6ac
		},
		{
		0xd6b0
		},
		{
		0xd6b9
		},
		{
		0xd6bb
		},
		{
		0xd6c4
		},
		{
		0xd6c5
		},
		{
		0xd6c8
		},
		{
		0xd6cc
		},
		{
		0xd6d1
		},
		{
		0xd6d4
		},
		{
		0xd6d7
		},
		{
		0xd6d9
		},
		{
		0xd6e0
		},
		{
		0xd6e4
		},
		{
		0xd6e8
		},
		{
		0xd6f0
		},
		{
		0xd6f5
		},
		{
		0xd6fc
		},
		{
		0xd6fd
		},
		{
		0xd700
		},
		{
		0xd704
		},
		{
		0xd711
		},
		{
		0xd718
		},
		{
		0xd719
		},
		{
		0xd71c
		},
		{
		0xd720
		},
		{
		0xd728
		},
		{
		0xd729
		},
		{
		0xd72b
		},
		{
		0xd72d
		},
		{
		0xd734
		},
		{
		0xd735
		},
		{
		0xd738
		},
		{
		0xd73c
		},
		{
		0xd744
		},
		{
		0xd747
		},
		{
		0xd749
		},
		{
		0xd750
		},
		{
		0xd751
		},
		{
		0xd754
		},
		{
		0xd756
		},
		{
		0xd757
		},
		{
		0xd758
		},
		{
		0xd759
		},
		{
		0xd760
		},
		{
		0xd761
		},
		{
		0xd763
		},
		{
		0xd765
		},
		{
		0xd769
		},
		{
		0xd76c
		},
		{
		0xd770
		},
		{
		0xd774
		},
		{
		0xd77c
		},
		{
		0xd77d
		},
		{
		0xd781
		},
		{
		0xd788
		},
		{
		0xd789
		},
		{
		0xd78c
		},
		{
		0xd790
		},
		{
		0xd798
		},
		{
		0xd799
		},
		{
		0xd79b
		},
		{
		0xd79d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_58[]=
	{
		{
		0xd408
		},
		{
		0xd41d
		},
		{
		0xd440
		},
		{
		0xd444
		},
		{
		0xd45c
		},
		{
		0xd460
		},
		{
		0xd464
		},
		{
		0xd46d
		},
		{
		0xd46f
		},
		{
		0xd478
		},
		{
		0xd479
		},
		{
		0xd47c
		},
		{
		0xd47f
		},
		{
		0xd480
		},
		{
		0xd482
		},
		{
		0xd488
		},
		{
		0xd489
		},
		{
		0xd48b
		},
		{
		0xd48d
		},
		{
		0xd494
		},
		{
		0xd4a9
		},
		{
		0xd4cc
		},
		{
		0xd4d0
		},
		{
		0xd4d4
		},
		{
		0xd4dc
		},
		{
		0xd4df
		},
		{
		0xd4e8
		},
		{
		0xd4ec
		},
		{
		0xd4f0
		},
		{
		0xd4f8
		},
		{
		0xd4fb
		},
		{
		0xd4fd
		},
		{
		0xd504
		},
		{
		0xd508
		},
		{
		0xd50c
		},
		{
		0xd514
		},
		{
		0xd515
		},
		{
		0xd517
		},
		{
		0xd53c
		},
		{
		0xd53d
		},
		{
		0xd540
		},
		{
		0xd544
		},
		{
		0xd54c
		},
		{
		0xd54d
		},
		{
		0xd54f
		},
		{
		0xd551
		},
		{
		0xd558
		},
		{
		0xd559
		},
		{
		0xd55c
		},
		{
		0xd560
		},
		{
		0xd565
		},
		{
		0xd568
		},
		{
		0xd569
		},
		{
		0xd56b
		},
		{
		0xd56d
		},
		{
		0xd574
		},
		{
		0xd575
		},
		{
		0xd578
		},
		{
		0xd57c
		},
		{
		0xd584
		},
		{
		0xd585
		},
		{
		0xd587
		},
		{
		0xd588
		},
		{
		0xd589
		},
		{
		0xd590
		},
		{
		0xd5a5
		},
		{
		0xd5c8
		},
		{
		0xd5c9
		},
		{
		0xd5cc
		},
		{
		0xd5d0
		},
		{
		0xd5d2
		},
		{
		0xd5d8
		},
		{
		0xd5d9
		},
		{
		0xd5db
		},
		{
		0xd5dd
		},
		{
		0xd5e4
		},
		{
		0xd5e5
		},
		{
		0xd5e8
		},
		{
		0xd5ec
		},
		{
		0xd5f4
		},
		{
		0xd5f5
		},
		{
		0xd5f7
		},
		{
		0xd5f9
		},
		{
		0xd600
		},
		{
		0xd601
		},
		{
		0xd604
		},
		{
		0xd608
		},
		{
		0xd610
		},
		{
		0xd611
		},
		{
		0xd613
		},
		{
		0xd614
		},
		{
		0xd615
		},
		{
		0xd61c
		},
		{
		0xd620
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_59[]=
	{
		{
		0xd264
		},
		{
		0xd280
		},
		{
		0xd281
		},
		{
		0xd284
		},
		{
		0xd288
		},
		{
		0xd290
		},
		{
		0xd291
		},
		{
		0xd295
		},
		{
		0xd29c
		},
		{
		0xd2a0
		},
		{
		0xd2a4
		},
		{
		0xd2ac
		},
		{
		0xd2b1
		},
		{
		0xd2b8
		},
		{
		0xd2b9
		},
		{
		0xd2bc
		},
		{
		0xd2bf
		},
		{
		0xd2c0
		},
		{
		0xd2c2
		},
		{
		0xd2c8
		},
		{
		0xd2c9
		},
		{
		0xd2cb
		},
		{
		0xd2d4
		},
		{
		0xd2d8
		},
		{
		0xd2dc
		},
		{
		0xd2e4
		},
		{
		0xd2e5
		},
		{
		0xd2f0
		},
		{
		0xd2f1
		},
		{
		0xd2f4
		},
		{
		0xd2f8
		},
		{
		0xd300
		},
		{
		0xd301
		},
		{
		0xd303
		},
		{
		0xd305
		},
		{
		0xd30c
		},
		{
		0xd30d
		},
		{
		0xd30e
		},
		{
		0xd310
		},
		{
		0xd314
		},
		{
		0xd316
		},
		{
		0xd31c
		},
		{
		0xd31d
		},
		{
		0xd31f
		},
		{
		0xd320
		},
		{
		0xd321
		},
		{
		0xd325
		},
		{
		0xd328
		},
		{
		0xd329
		},
		{
		0xd32c
		},
		{
		0xd330
		},
		{
		0xd338
		},
		{
		0xd339
		},
		{
		0xd33b
		},
		{
		0xd33c
		},
		{
		0xd33d
		},
		{
		0xd344
		},
		{
		0xd345
		},
		{
		0xd37c
		},
		{
		0xd37d
		},
		{
		0xd380
		},
		{
		0xd384
		},
		{
		0xd38c
		},
		{
		0xd38d
		},
		{
		0xd38f
		},
		{
		0xd390
		},
		{
		0xd391
		},
		{
		0xd398
		},
		{
		0xd399
		},
		{
		0xd39c
		},
		{
		0xd3a0
		},
		{
		0xd3a8
		},
		{
		0xd3a9
		},
		{
		0xd3ab
		},
		{
		0xd3ad
		},
		{
		0xd3b4
		},
		{
		0xd3b8
		},
		{
		0xd3bc
		},
		{
		0xd3c4
		},
		{
		0xd3c5
		},
		{
		0xd3c8
		},
		{
		0xd3c9
		},
		{
		0xd3d0
		},
		{
		0xd3d8
		},
		{
		0xd3e1
		},
		{
		0xd3e3
		},
		{
		0xd3ec
		},
		{
		0xd3ed
		},
		{
		0xd3f0
		},
		{
		0xd3f4
		},
		{
		0xd3fc
		},
		{
		0xd3fd
		},
		{
		0xd3ff
		},
		{
		0xd401
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_60[]=
	{
		{
		0xd78a
		},
		{
		0xd78b
		},
		{
		0xd044
		},
		{
		0xd045
		},
		{
		0xd047
		},
		{
		0xd049
		},
		{
		0xd050
		},
		{
		0xd054
		},
		{
		0xd058
		},
		{
		0xd060
		},
		{
		0xd06c
		},
		{
		0xd06d
		},
		{
		0xd070
		},
		{
		0xd074
		},
		{
		0xd07c
		},
		{
		0xd07d
		},
		{
		0xd081
		},
		{
		0xd0a4
		},
		{
		0xd0a5
		},
		{
		0xd0a8
		},
		{
		0xd0ac
		},
		{
		0xd0b4
		},
		{
		0xd0b5
		},
		{
		0xd0b7
		},
		{
		0xd0b9
		},
		{
		0xd0c0
		},
		{
		0xd0c1
		},
		{
		0xd0c4
		},
		{
		0xd0c8
		},
		{
		0xd0c9
		},
		{
		0xd0d0
		},
		{
		0xd0d1
		},
		{
		0xd0d3
		},
		{
		0xd0d4
		},
		{
		0xd0d5
		},
		{
		0xd0dc
		},
		{
		0xd0dd
		},
		{
		0xd0e0
		},
		{
		0xd0e4
		},
		{
		0xd0ec
		},
		{
		0xd0ed
		},
		{
		0xd0ef
		},
		{
		0xd0f0
		},
		{
		0xd0f1
		},
		{
		0xd0f8
		},
		{
		0xd10d
		},
		{
		0xd130
		},
		{
		0xd131
		},
		{
		0xd134
		},
		{
		0xd138
		},
		{
		0xd13a
		},
		{
		0xd140
		},
		{
		0xd141
		},
		{
		0xd143
		},
		{
		0xd144
		},
		{
		0xd145
		},
		{
		0xd14c
		},
		{
		0xd14d
		},
		{
		0xd150
		},
		{
		0xd154
		},
		{
		0xd15c
		},
		{
		0xd15d
		},
		{
		0xd15f
		},
		{
		0xd161
		},
		{
		0xd168
		},
		{
		0xd16c
		},
		{
		0xd17c
		},
		{
		0xd184
		},
		{
		0xd188
		},
		{
		0xd1a0
		},
		{
		0xd1a1
		},
		{
		0xd1a4
		},
		{
		0xd1a8
		},
		{
		0xd1b0
		},
		{
		0xd1b1
		},
		{
		0xd1b3
		},
		{
		0xd1b5
		},
		{
		0xd1ba
		},
		{
		0xd1bc
		},
		{
		0xd1c0
		},
		{
		0xd1d8
		},
		{
		0xd1f4
		},
		{
		0xd1f8
		},
		{
		0xd207
		},
		{
		0xd209
		},
		{
		0xd210
		},
		{
		0xd22c
		},
		{
		0xd22d
		},
		{
		0xd230
		},
		{
		0xd234
		},
		{
		0xd23c
		},
		{
		0xd23d
		},
		{
		0xd23f
		},
		{
		0xd241
		},
		{
		0xd248
		},
		{
		0xd25c
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_61[]=
	{
		{
		0xd75f
		},
		{
		0xd762
		},
		{
		0xd764
		},
		{
		0xd766
		},
		{
		0xd767
		},
		{
		0xd768
		},
		{
		0xd76a
		},
		{
		0xd76b
		},
		{
		0xd76d
		},
		{
		0xd76e
		},
		{
		0xd76f
		},
		{
		0xd771
		},
		{
		0xd772
		},
		{
		0xd773
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_62[]=
	{
		{
		0xd715
		},
		{
		0xd716
		},
		{
		0xd717
		},
		{
		0xd71a
		},
		{
		0xd71b
		},
		{
		0xd71d
		},
		{
		0xd71e
		},
		{
		0xd71f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_63[]=
	{
		{
		0xd712
		},
		{
		0xd713
		},
		{
		0xd714
		},
		{
		0xce58
		},
		{
		0xce59
		},
		{
		0xce5c
		},
		{
		0xce5f
		},
		{
		0xce60
		},
		{
		0xce61
		},
		{
		0xce68
		},
		{
		0xce69
		},
		{
		0xce6b
		},
		{
		0xce6d
		},
		{
		0xce74
		},
		{
		0xce75
		},
		{
		0xce78
		},
		{
		0xce7c
		},
		{
		0xce84
		},
		{
		0xce85
		},
		{
		0xce87
		},
		{
		0xce89
		},
		{
		0xce90
		},
		{
		0xce91
		},
		{
		0xce94
		},
		{
		0xce98
		},
		{
		0xcea0
		},
		{
		0xcea1
		},
		{
		0xcea3
		},
		{
		0xcea4
		},
		{
		0xcea5
		},
		{
		0xceac
		},
		{
		0xcead
		},
		{
		0xcec1
		},
		{
		0xcee4
		},
		{
		0xcee5
		},
		{
		0xcee8
		},
		{
		0xceeb
		},
		{
		0xceec
		},
		{
		0xcef4
		},
		{
		0xcef5
		},
		{
		0xcef7
		},
		{
		0xcef8
		},
		{
		0xcef9
		},
		{
		0xcf00
		},
		{
		0xcf01
		},
		{
		0xcf04
		},
		{
		0xcf08
		},
		{
		0xcf10
		},
		{
		0xcf11
		},
		{
		0xcf13
		},
		{
		0xcf15
		},
		{
		0xcf1c
		},
		{
		0xcf20
		},
		{
		0xcf24
		},
		{
		0xcf2c
		},
		{
		0xcf2d
		},
		{
		0xcf2f
		},
		{
		0xcf30
		},
		{
		0xcf31
		},
		{
		0xcf38
		},
		{
		0xcf54
		},
		{
		0xcf55
		},
		{
		0xcf58
		},
		{
		0xcf5c
		},
		{
		0xcf64
		},
		{
		0xcf65
		},
		{
		0xcf67
		},
		{
		0xcf69
		},
		{
		0xcf70
		},
		{
		0xcf71
		},
		{
		0xcf74
		},
		{
		0xcf78
		},
		{
		0xcf80
		},
		{
		0xcf85
		},
		{
		0xcf8c
		},
		{
		0xcfa1
		},
		{
		0xcfa8
		},
		{
		0xcfb0
		},
		{
		0xcfc4
		},
		{
		0xcfe0
		},
		{
		0xcfe1
		},
		{
		0xcfe4
		},
		{
		0xcfe8
		},
		{
		0xcff0
		},
		{
		0xcff1
		},
		{
		0xcff3
		},
		{
		0xcff5
		},
		{
		0xcffc
		},
		{
		0xd000
		},
		{
		0xd004
		},
		{
		0xd011
		},
		{
		0xd018
		},
		{
		0xd02d
		},
		{
		0xd034
		},
		{
		0xd035
		},
		{
		0xd038
		},
		{
		0xd03c
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_64[]=
	{
		{
		0xd6fe
		},
		{
		0xd6ff
		},
		{
		0xd701
		},
		{
		0xd702
		},
		{
		0xd703
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_65[]=
	{
		{
		0xd6ee
		},
		{
		0xd6ef
		},
		{
		0xd6f1
		},
		{
		0xd6f2
		},
		{
		0xd6f3
		},
		{
		0xd6f4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_66[]=
	{
		{
		0xd6e1
		},
		{
		0xd6e2
		},
		{
		0xd6e3
		},
		{
		0xd6e5
		},
		{
		0xd6e6
		},
		{
		0xd6e7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_67[]=
	{
		{
		0xd6cd
		},
		{
		0xd6ce
		},
		{
		0xd6cf
		},
		{
		0xd6d0
		},
		{
		0xd6d2
		},
		{
		0xd6d3
		},
		{
		0xd6d5
		},
		{
		0xd6d6
		},
		{
		0xd6d8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_68[]=
	{
		{
		0xd6c6
		},
		{
		0xd6c7
		},
		{
		0xd6c9
		},
		{
		0xd6ca
		},
		{
		0xd6cb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_69[]=
	{
		{
		0xd6a9
		},
		{
		0xd6aa
		},
		{
		0xcc3c
		},
		{
		0xcc3d
		},
		{
		0xcc3e
		},
		{
		0xcc44
		},
		{
		0xcc45
		},
		{
		0xcc48
		},
		{
		0xcc4c
		},
		{
		0xcc54
		},
		{
		0xcc55
		},
		{
		0xcc57
		},
		{
		0xcc58
		},
		{
		0xcc59
		},
		{
		0xcc60
		},
		{
		0xcc64
		},
		{
		0xcc66
		},
		{
		0xcc68
		},
		{
		0xcc70
		},
		{
		0xcc75
		},
		{
		0xcc98
		},
		{
		0xcc99
		},
		{
		0xcc9c
		},
		{
		0xcca0
		},
		{
		0xcca8
		},
		{
		0xcca9
		},
		{
		0xccab
		},
		{
		0xccac
		},
		{
		0xccad
		},
		{
		0xccb4
		},
		{
		0xccb5
		},
		{
		0xccb8
		},
		{
		0xccbc
		},
		{
		0xccc4
		},
		{
		0xccc5
		},
		{
		0xccc7
		},
		{
		0xccc9
		},
		{
		0xccd0
		},
		{
		0xccd4
		},
		{
		0xcce4
		},
		{
		0xccec
		},
		{
		0xccf0
		},
		{
		0xcd01
		},
		{
		0xcd08
		},
		{
		0xcd09
		},
		{
		0xcd0c
		},
		{
		0xcd10
		},
		{
		0xcd18
		},
		{
		0xcd19
		},
		{
		0xcd1b
		},
		{
		0xcd1d
		},
		{
		0xcd24
		},
		{
		0xcd28
		},
		{
		0xcd2c
		},
		{
		0xcd39
		},
		{
		0xcd5c
		},
		{
		0xcd60
		},
		{
		0xcd64
		},
		{
		0xcd6c
		},
		{
		0xcd6d
		},
		{
		0xcd6f
		},
		{
		0xcd71
		},
		{
		0xcd78
		},
		{
		0xcd88
		},
		{
		0xcd94
		},
		{
		0xcd95
		},
		{
		0xcd98
		},
		{
		0xcd9c
		},
		{
		0xcda4
		},
		{
		0xcda5
		},
		{
		0xcda7
		},
		{
		0xcda9
		},
		{
		0xcdb0
		},
		{
		0xcdc4
		},
		{
		0xcdcc
		},
		{
		0xcdd0
		},
		{
		0xcde8
		},
		{
		0xcdec
		},
		{
		0xcdf0
		},
		{
		0xcdf8
		},
		{
		0xcdf9
		},
		{
		0xcdfb
		},
		{
		0xcdfd
		},
		{
		0xce04
		},
		{
		0xce08
		},
		{
		0xce0c
		},
		{
		0xce14
		},
		{
		0xce19
		},
		{
		0xce20
		},
		{
		0xce21
		},
		{
		0xce24
		},
		{
		0xce28
		},
		{
		0xce30
		},
		{
		0xce31
		},
		{
		0xce33
		},
		{
		0xce35
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_70[]=
	{
		{
		0xd68e
		},
		{
		0xd68f
		},
		{
		0xd691
		},
		{
		0xd692
		},
		{
		0xd693
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_71[]=
	{
		{
		0xd63d
		},
		{
		0xd63e
		},
		{
		0xd63f
		},
		{
		0xd641
		},
		{
		0xd642
		},
		{
		0xd643
		},
		{
		0xd644
		},
		{
		0xd646
		},
		{
		0xd647
		},
		{
		0xd64a
		},
		{
		0xd64c
		},
		{
		0xd64e
		},
		{
		0xd64f
		},
		{
		0xd650
		},
		{
		0xd652
		},
		{
		0xd653
		},
		{
		0xd656
		},
		{
		0xd657
		},
		{
		0xd659
		},
		{
		0xd65a
		},
		{
		0xd65b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_72[]=
	{
		{
		0xd63a
		},
		{
		0xd63b
		},
		{
		0xc9d5
		},
		{
		0xc9d6
		},
		{
		0xc9d9
		},
		{
		0xc9da
		},
		{
		0xc9dc
		},
		{
		0xc9dd
		},
		{
		0xc9e0
		},
		{
		0xc9e2
		},
		{
		0xc9e4
		},
		{
		0xc9e7
		},
		{
		0xc9ec
		},
		{
		0xc9ed
		},
		{
		0xc9ef
		},
		{
		0xc9f0
		},
		{
		0xc9f1
		},
		{
		0xc9f8
		},
		{
		0xc9f9
		},
		{
		0xc9fc
		},
		{
		0xca00
		},
		{
		0xca08
		},
		{
		0xca09
		},
		{
		0xca0b
		},
		{
		0xca0c
		},
		{
		0xca0d
		},
		{
		0xca14
		},
		{
		0xca18
		},
		{
		0xca29
		},
		{
		0xca4c
		},
		{
		0xca4d
		},
		{
		0xca50
		},
		{
		0xca54
		},
		{
		0xca5c
		},
		{
		0xca5d
		},
		{
		0xca5f
		},
		{
		0xca60
		},
		{
		0xca61
		},
		{
		0xca68
		},
		{
		0xca7d
		},
		{
		0xca84
		},
		{
		0xca98
		},
		{
		0xcabc
		},
		{
		0xcabd
		},
		{
		0xcac0
		},
		{
		0xcac4
		},
		{
		0xcacc
		},
		{
		0xcacd
		},
		{
		0xcacf
		},
		{
		0xcad1
		},
		{
		0xcad3
		},
		{
		0xcad8
		},
		{
		0xcad9
		},
		{
		0xcae0
		},
		{
		0xcaec
		},
		{
		0xcaf4
		},
		{
		0xcb08
		},
		{
		0xcb10
		},
		{
		0xcb14
		},
		{
		0xcb18
		},
		{
		0xcb20
		},
		{
		0xcb21
		},
		{
		0xcb41
		},
		{
		0xcb48
		},
		{
		0xcb49
		},
		{
		0xcb4c
		},
		{
		0xcb50
		},
		{
		0xcb58
		},
		{
		0xcb59
		},
		{
		0xcb5d
		},
		{
		0xcb64
		},
		{
		0xcb78
		},
		{
		0xcb79
		},
		{
		0xcb9c
		},
		{
		0xcbb8
		},
		{
		0xcbd4
		},
		{
		0xcbe4
		},
		{
		0xcbe7
		},
		{
		0xcbe9
		},
		{
		0xcc0c
		},
		{
		0xcc0d
		},
		{
		0xcc10
		},
		{
		0xcc14
		},
		{
		0xcc1c
		},
		{
		0xcc1d
		},
		{
		0xcc21
		},
		{
		0xcc22
		},
		{
		0xcc27
		},
		{
		0xcc28
		},
		{
		0xcc29
		},
		{
		0xcc2c
		},
		{
		0xcc2e
		},
		{
		0xcc30
		},
		{
		0xcc38
		},
		{
		0xcc39
		},
		{
		0xcc3b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_73[]=
	{
		{
		0xd61d
		},
		{
		0xd61e
		},
		{
		0xd61f
		},
		{
		0xd621
		},
		{
		0xd622
		},
		{
		0xd623
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_74[]=
	{
		{
		0xd602
		},
		{
		0xd603
		},
		{
		0xd605
		},
		{
		0xd606
		},
		{
		0xd607
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_75[]=
	{
		{
		0xd5e6
		},
		{
		0xd5e7
		},
		{
		0xd5e9
		},
		{
		0xd5ea
		},
		{
		0xd5eb
		},
		{
		0xd5ed
		},
		{
		0xd5ee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_76[]=
	{
		{
		0xd5ca
		},
		{
		0xd5cb
		},
		{
		0xd5cd
		},
		{
		0xd5ce
		},
		{
		0xd5cf
		},
		{
		0xd5d1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_77[]=
	{
		{
		0xc810
		},
		{
		0xc811
		},
		{
		0xc813
		},
		{
		0xc815
		},
		{
		0xc816
		},
		{
		0xc81c
		},
		{
		0xc81d
		},
		{
		0xc820
		},
		{
		0xc824
		},
		{
		0xc82c
		},
		{
		0xc82d
		},
		{
		0xc82f
		},
		{
		0xc831
		},
		{
		0xc838
		},
		{
		0xc83c
		},
		{
		0xc840
		},
		{
		0xc848
		},
		{
		0xc849
		},
		{
		0xc84c
		},
		{
		0xc84d
		},
		{
		0xc854
		},
		{
		0xc870
		},
		{
		0xc871
		},
		{
		0xc874
		},
		{
		0xc878
		},
		{
		0xc87a
		},
		{
		0xc880
		},
		{
		0xc881
		},
		{
		0xc883
		},
		{
		0xc885
		},
		{
		0xc886
		},
		{
		0xc887
		},
		{
		0xc88b
		},
		{
		0xc88c
		},
		{
		0xc88d
		},
		{
		0xc894
		},
		{
		0xc89d
		},
		{
		0xc89f
		},
		{
		0xc8a1
		},
		{
		0xc8a8
		},
		{
		0xc8bc
		},
		{
		0xc8bd
		},
		{
		0xc8c4
		},
		{
		0xc8c8
		},
		{
		0xc8cc
		},
		{
		0xc8d4
		},
		{
		0xc8d5
		},
		{
		0xc8d7
		},
		{
		0xc8d9
		},
		{
		0xc8e0
		},
		{
		0xc8e1
		},
		{
		0xc8e4
		},
		{
		0xc8f5
		},
		{
		0xc8fc
		},
		{
		0xc8fd
		},
		{
		0xc900
		},
		{
		0xc904
		},
		{
		0xc905
		},
		{
		0xc906
		},
		{
		0xc90c
		},
		{
		0xc90d
		},
		{
		0xc90f
		},
		{
		0xc911
		},
		{
		0xc918
		},
		{
		0xc92c
		},
		{
		0xc934
		},
		{
		0xc950
		},
		{
		0xc951
		},
		{
		0xc954
		},
		{
		0xc958
		},
		{
		0xc960
		},
		{
		0xc961
		},
		{
		0xc963
		},
		{
		0xc96c
		},
		{
		0xc970
		},
		{
		0xc974
		},
		{
		0xc97c
		},
		{
		0xc988
		},
		{
		0xc989
		},
		{
		0xc98c
		},
		{
		0xc990
		},
		{
		0xc998
		},
		{
		0xc999
		},
		{
		0xc99b
		},
		{
		0xc99d
		},
		{
		0xc9c0
		},
		{
		0xc9c1
		},
		{
		0xc9c4
		},
		{
		0xc9c7
		},
		{
		0xc9c8
		},
		{
		0xc9ca
		},
		{
		0xc9d0
		},
		{
		0xc9d1
		},
		{
		0xc9d3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_78[]=
	{
		{
		0xd576
		},
		{
		0xd577
		},
		{
		0xd579
		},
		{
		0xd57a
		},
		{
		0xd57b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_79[]=
	{
		{
		0xd564
		},
		{
		0xd566
		},
		{
		0xd567
		},
		{
		0xd56a
		},
		{
		0xd56c
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_80[]=
	{
		{
		0xc75c
		},
		{
		0xc760
		},
		{
		0xc768
		},
		{
		0xc76b
		},
		{
		0xc774
		},
		{
		0xc775
		},
		{
		0xc778
		},
		{
		0xc77c
		},
		{
		0xc77d
		},
		{
		0xc77e
		},
		{
		0xc783
		},
		{
		0xc784
		},
		{
		0xc785
		},
		{
		0xc787
		},
		{
		0xc788
		},
		{
		0xc789
		},
		{
		0xc78a
		},
		{
		0xc78e
		},
		{
		0xc790
		},
		{
		0xc791
		},
		{
		0xc794
		},
		{
		0xc796
		},
		{
		0xc797
		},
		{
		0xc798
		},
		{
		0xc79a
		},
		{
		0xc7a0
		},
		{
		0xc7a1
		},
		{
		0xc7a3
		},
		{
		0xc7a4
		},
		{
		0xc7a5
		},
		{
		0xc7a6
		},
		{
		0xc7ac
		},
		{
		0xc7ad
		},
		{
		0xc7b0
		},
		{
		0xc7b4
		},
		{
		0xc7bc
		},
		{
		0xc7bd
		},
		{
		0xc7bf
		},
		{
		0xc7c0
		},
		{
		0xc7c1
		},
		{
		0xc7c8
		},
		{
		0xc7c9
		},
		{
		0xc7cc
		},
		{
		0xc7ce
		},
		{
		0xc7d0
		},
		{
		0xc7d8
		},
		{
		0xc7dd
		},
		{
		0xc7e4
		},
		{
		0xc7e8
		},
		{
		0xc7ec
		},
		{
		0xc800
		},
		{
		0xc801
		},
		{
		0xc804
		},
		{
		0xc808
		},
		{
		0xc80a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_81[]=
	{
		{
		0xd55a
		},
		{
		0xd55b
		},
		{
		0xd55d
		},
		{
		0xd55e
		},
		{
		0xd55f
		},
		{
		0xd561
		},
		{
		0xd562
		},
		{
		0xd563
		},
		{
		0xc6e9
		},
		{
		0xc6ec
		},
		{
		0xc6f0
		},
		{
		0xc6f8
		},
		{
		0xc6f9
		},
		{
		0xc6fd
		},
		{
		0xc704
		},
		{
		0xc705
		},
		{
		0xc708
		},
		{
		0xc70c
		},
		{
		0xc714
		},
		{
		0xc715
		},
		{
		0xc717
		},
		{
		0xc719
		},
		{
		0xc720
		},
		{
		0xc721
		},
		{
		0xc724
		},
		{
		0xc728
		},
		{
		0xc730
		},
		{
		0xc731
		},
		{
		0xc733
		},
		{
		0xc735
		},
		{
		0xc737
		},
		{
		0xc73c
		},
		{
		0xc73d
		},
		{
		0xc740
		},
		{
		0xc744
		},
		{
		0xc74a
		},
		{
		0xc74c
		},
		{
		0xc74d
		},
		{
		0xc74f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_82[]=
	{
		{
		0xd538
		},
		{
		0xd539
		},
		{
		0xd53a
		},
		{
		0xd53b
		},
		{
		0xd53e
		},
		{
		0xd53f
		},
		{
		0xd541
		},
		{
		0xd542
		},
		{
		0xd543
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_83[]=
	{
		{
		0xd505
		},
		{
		0xd506
		},
		{
		0xd507
		},
		{
		0xd509
		},
		{
		0xd50a
		},
		{
		0xd50b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_84[]=
	{
		{
		0xc605
		},
		{
		0xc606
		},
		{
		0xc607
		},
		{
		0xc608
		},
		{
		0xc60c
		},
		{
		0xc610
		},
		{
		0xc618
		},
		{
		0xc619
		},
		{
		0xc61b
		},
		{
		0xc61c
		},
		{
		0xc624
		},
		{
		0xc625
		},
		{
		0xc628
		},
		{
		0xc62c
		},
		{
		0xc62d
		},
		{
		0xc62e
		},
		{
		0xc630
		},
		{
		0xc633
		},
		{
		0xc634
		},
		{
		0xc635
		},
		{
		0xc637
		},
		{
		0xc639
		},
		{
		0xc63b
		},
		{
		0xc640
		},
		{
		0xc641
		},
		{
		0xc644
		},
		{
		0xc648
		},
		{
		0xc650
		},
		{
		0xc651
		},
		{
		0xc653
		},
		{
		0xc654
		},
		{
		0xc655
		},
		{
		0xc65c
		},
		{
		0xc65d
		},
		{
		0xc660
		},
		{
		0xc66c
		},
		{
		0xc66f
		},
		{
		0xc671
		},
		{
		0xc678
		},
		{
		0xc679
		},
		{
		0xc67c
		},
		{
		0xc680
		},
		{
		0xc688
		},
		{
		0xc689
		},
		{
		0xc68b
		},
		{
		0xc68d
		},
		{
		0xc694
		},
		{
		0xc695
		},
		{
		0xc698
		},
		{
		0xc69c
		},
		{
		0xc6a4
		},
		{
		0xc6a5
		},
		{
		0xc6a7
		},
		{
		0xc6a9
		},
		{
		0xc6b0
		},
		{
		0xc6b1
		},
		{
		0xc6b4
		},
		{
		0xc6b8
		},
		{
		0xc6b9
		},
		{
		0xc6ba
		},
		{
		0xc6c0
		},
		{
		0xc6c1
		},
		{
		0xc6c3
		},
		{
		0xc6c5
		},
		{
		0xc6cc
		},
		{
		0xc6cd
		},
		{
		0xc6d0
		},
		{
		0xc6d4
		},
		{
		0xc6dc
		},
		{
		0xc6dd
		},
		{
		0xc6e0
		},
		{
		0xc6e1
		},
		{
		0xc6e8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_85[]=
	{
		{
		0xd4f9
		},
		{
		0xd4fa
		},
		{
		0xd4fc
		},
		{
		0xc5d0
		},
		{
		0xc5d1
		},
		{
		0xc5d4
		},
		{
		0xc5d8
		},
		{
		0xc5e0
		},
		{
		0xc5e1
		},
		{
		0xc5e3
		},
		{
		0xc5e5
		},
		{
		0xc5ec
		},
		{
		0xc5ed
		},
		{
		0xc5ee
		},
		{
		0xc5f0
		},
		{
		0xc5f4
		},
		{
		0xc5f6
		},
		{
		0xc5f7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_86[]=
	{
		{
		0xd4e9
		},
		{
		0xd4ea
		},
		{
		0xd4eb
		},
		{
		0xd4ed
		},
		{
		0xd4ee
		},
		{
		0xd4ef
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_87[]=
	{
		{
		0xd4cd
		},
		{
		0xd4ce
		},
		{
		0xd4cf
		},
		{
		0xd4d1
		},
		{
		0xd4d2
		},
		{
		0xd4d3
		},
		{
		0xd4d5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_88[]=
	{
		{
		0xc434
		},
		{
		0xc43c
		},
		{
		0xc43d
		},
		{
		0xc448
		},
		{
		0xc464
		},
		{
		0xc465
		},
		{
		0xc468
		},
		{
		0xc46c
		},
		{
		0xc474
		},
		{
		0xc475
		},
		{
		0xc479
		},
		{
		0xc480
		},
		{
		0xc494
		},
		{
		0xc49c
		},
		{
		0xc4b8
		},
		{
		0xc4bc
		},
		{
		0xc4e9
		},
		{
		0xc4f0
		},
		{
		0xc4f1
		},
		{
		0xc4f4
		},
		{
		0xc4f8
		},
		{
		0xc4fa
		},
		{
		0xc4ff
		},
		{
		0xc500
		},
		{
		0xc501
		},
		{
		0xc50c
		},
		{
		0xc510
		},
		{
		0xc514
		},
		{
		0xc51c
		},
		{
		0xc528
		},
		{
		0xc529
		},
		{
		0xc52c
		},
		{
		0xc530
		},
		{
		0xc538
		},
		{
		0xc539
		},
		{
		0xc53b
		},
		{
		0xc53d
		},
		{
		0xc544
		},
		{
		0xc545
		},
		{
		0xc548
		},
		{
		0xc549
		},
		{
		0xc54a
		},
		{
		0xc54c
		},
		{
		0xc54d
		},
		{
		0xc54e
		},
		{
		0xc553
		},
		{
		0xc554
		},
		{
		0xc555
		},
		{
		0xc557
		},
		{
		0xc558
		},
		{
		0xc559
		},
		{
		0xc55d
		},
		{
		0xc55e
		},
		{
		0xc560
		},
		{
		0xc561
		},
		{
		0xc564
		},
		{
		0xc568
		},
		{
		0xc570
		},
		{
		0xc571
		},
		{
		0xc573
		},
		{
		0xc574
		},
		{
		0xc575
		},
		{
		0xc57c
		},
		{
		0xc57d
		},
		{
		0xc580
		},
		{
		0xc584
		},
		{
		0xc587
		},
		{
		0xc58c
		},
		{
		0xc58d
		},
		{
		0xc58f
		},
		{
		0xc591
		},
		{
		0xc595
		},
		{
		0xc597
		},
		{
		0xc598
		},
		{
		0xc59c
		},
		{
		0xc5a0
		},
		{
		0xc5a9
		},
		{
		0xc5b4
		},
		{
		0xc5b5
		},
		{
		0xc5b8
		},
		{
		0xc5b9
		},
		{
		0xc5bb
		},
		{
		0xc5bc
		},
		{
		0xc5bd
		},
		{
		0xc5be
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_89[]=
	{
		{
		0xd47a
		},
		{
		0xd47b
		},
		{
		0xd47d
		},
		{
		0xd47e
		},
		{
		0xd481
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_90[]=
	{
		{
		0xd45d
		},
		{
		0xd45e
		},
		{
		0xd45f
		},
		{
		0xd461
		},
		{
		0xd462
		},
		{
		0xd463
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_91[]=
	{
		{
		0xc22f
		},
		{
		0xc231
		},
		{
		0xc232
		},
		{
		0xc234
		},
		{
		0xc248
		},
		{
		0xc250
		},
		{
		0xc251
		},
		{
		0xc254
		},
		{
		0xc258
		},
		{
		0xc260
		},
		{
		0xc265
		},
		{
		0xc26c
		},
		{
		0xc26d
		},
		{
		0xc270
		},
		{
		0xc274
		},
		{
		0xc27c
		},
		{
		0xc27d
		},
		{
		0xc27f
		},
		{
		0xc281
		},
		{
		0xc288
		},
		{
		0xc289
		},
		{
		0xc290
		},
		{
		0xc298
		},
		{
		0xc29b
		},
		{
		0xc29d
		},
		{
		0xc2a4
		},
		{
		0xc2a5
		},
		{
		0xc2a8
		},
		{
		0xc2ac
		},
		{
		0xc2ad
		},
		{
		0xc2b4
		},
		{
		0xc2b5
		},
		{
		0xc2b7
		},
		{
		0xc2b9
		},
		{
		0xc2dc
		},
		{
		0xc2dd
		},
		{
		0xc2e0
		},
		{
		0xc2e3
		},
		{
		0xc2e4
		},
		{
		0xc2eb
		},
		{
		0xc2ec
		},
		{
		0xc2ed
		},
		{
		0xc2ef
		},
		{
		0xc2f1
		},
		{
		0xc2f6
		},
		{
		0xc2f8
		},
		{
		0xc2f9
		},
		{
		0xc2fb
		},
		{
		0xc2fc
		},
		{
		0xc300
		},
		{
		0xc308
		},
		{
		0xc309
		},
		{
		0xc30c
		},
		{
		0xc30d
		},
		{
		0xc313
		},
		{
		0xc314
		},
		{
		0xc315
		},
		{
		0xc318
		},
		{
		0xc31c
		},
		{
		0xc324
		},
		{
		0xc325
		},
		{
		0xc328
		},
		{
		0xc329
		},
		{
		0xc345
		},
		{
		0xc368
		},
		{
		0xc369
		},
		{
		0xc36c
		},
		{
		0xc370
		},
		{
		0xc372
		},
		{
		0xc378
		},
		{
		0xc379
		},
		{
		0xc37c
		},
		{
		0xc37d
		},
		{
		0xc384
		},
		{
		0xc388
		},
		{
		0xc38c
		},
		{
		0xc3c0
		},
		{
		0xc3d8
		},
		{
		0xc3d9
		},
		{
		0xc3dc
		},
		{
		0xc3df
		},
		{
		0xc3e0
		},
		{
		0xc3e2
		},
		{
		0xc3e8
		},
		{
		0xc3e9
		},
		{
		0xc3ed
		},
		{
		0xc3f4
		},
		{
		0xc3f5
		},
		{
		0xc3f8
		},
		{
		0xc408
		},
		{
		0xc410
		},
		{
		0xc424
		},
		{
		0xc42c
		},
		{
		0xc430
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_92[]=
	{
		{
		0xd3f8
		},
		{
		0xd3f9
		},
		{
		0xd3fa
		},
		{
		0xd3fb
		},
		{
		0xd3fe
		},
		{
		0xd400
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_93[]=
	{
		{
		0xd3ee
		},
		{
		0xd3ef
		},
		{
		0xd3f1
		},
		{
		0xd3f2
		},
		{
		0xd3f3
		},
		{
		0xd3f5
		},
		{
		0xd3f6
		},
		{
		0xd3f7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_94[]=
	{
		{
		0xc123
		},
		{
		0xc124
		},
		{
		0xc126
		},
		{
		0xc127
		},
		{
		0xc12c
		},
		{
		0xc12d
		},
		{
		0xc12f
		},
		{
		0xc130
		},
		{
		0xc131
		},
		{
		0xc136
		},
		{
		0xc138
		},
		{
		0xc139
		},
		{
		0xc13c
		},
		{
		0xc140
		},
		{
		0xc148
		},
		{
		0xc149
		},
		{
		0xc14b
		},
		{
		0xc14c
		},
		{
		0xc14d
		},
		{
		0xc154
		},
		{
		0xc155
		},
		{
		0xc158
		},
		{
		0xc15c
		},
		{
		0xc164
		},
		{
		0xc165
		},
		{
		0xc167
		},
		{
		0xc168
		},
		{
		0xc169
		},
		{
		0xc170
		},
		{
		0xc174
		},
		{
		0xc178
		},
		{
		0xc185
		},
		{
		0xc18c
		},
		{
		0xc18d
		},
		{
		0xc18e
		},
		{
		0xc190
		},
		{
		0xc194
		},
		{
		0xc196
		},
		{
		0xc19c
		},
		{
		0xc19d
		},
		{
		0xc19f
		},
		{
		0xc1a1
		},
		{
		0xc1a5
		},
		{
		0xc1a8
		},
		{
		0xc1a9
		},
		{
		0xc1ac
		},
		{
		0xc1b0
		},
		{
		0xc1bd
		},
		{
		0xc1c4
		},
		{
		0xc1c8
		},
		{
		0xc1cc
		},
		{
		0xc1d4
		},
		{
		0xc1d7
		},
		{
		0xc1d8
		},
		{
		0xc1e0
		},
		{
		0xc1e4
		},
		{
		0xc1e8
		},
		{
		0xc1f0
		},
		{
		0xc1f1
		},
		{
		0xc1f3
		},
		{
		0xc1fc
		},
		{
		0xc1fd
		},
		{
		0xc200
		},
		{
		0xc204
		},
		{
		0xc20c
		},
		{
		0xc20d
		},
		{
		0xc20f
		},
		{
		0xc211
		},
		{
		0xc218
		},
		{
		0xc219
		},
		{
		0xc21c
		},
		{
		0xc21f
		},
		{
		0xc220
		},
		{
		0xc228
		},
		{
		0xc229
		},
		{
		0xc22b
		},
		{
		0xc22d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_95[]=
	{
		{
		0xc0e5
		},
		{
		0xc0e8
		},
		{
		0xc0ec
		},
		{
		0xc0f4
		},
		{
		0xc0f5
		},
		{
		0xc0f7
		},
		{
		0xc0f9
		},
		{
		0xc100
		},
		{
		0xc104
		},
		{
		0xc108
		},
		{
		0xc110
		},
		{
		0xc115
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_96[]=
	{
		{
		0xd3b5
		},
		{
		0xd3b6
		},
		{
		0xd3b7
		},
		{
		0xd3b9
		},
		{
		0xd3ba
		},
		{
		0xd3bb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_97[]=
	{
		{
		0xd39a
		},
		{
		0xd39b
		},
		{
		0xd39d
		},
		{
		0xd39e
		},
		{
		0xd39f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_98[]=
	{
		{
		0xd388
		},
		{
		0xd389
		},
		{
		0xd38a
		},
		{
		0xd38b
		},
		{
		0xd38e
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_99[]=
	{
		{
		0xd37e
		},
		{
		0xd37f
		},
		{
		0xd381
		},
		{
		0xd382
		},
		{
		0xd383
		},
		{
		0xd385
		},
		{
		0xd386
		},
		{
		0xd387
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_100[]=
	{
		{
		0xbe68
		},
		{
		0xbe6a
		},
		{
		0xbe70
		},
		{
		0xbe71
		},
		{
		0xbe73
		},
		{
		0xbe74
		},
		{
		0xbe75
		},
		{
		0xbe7b
		},
		{
		0xbe7c
		},
		{
		0xbe7d
		},
		{
		0xbe80
		},
		{
		0xbe84
		},
		{
		0xbe8c
		},
		{
		0xbe8d
		},
		{
		0xbe8f
		},
		{
		0xbe90
		},
		{
		0xbe91
		},
		{
		0xbe98
		},
		{
		0xbe99
		},
		{
		0xbea8
		},
		{
		0xbed0
		},
		{
		0xbed1
		},
		{
		0xbed4
		},
		{
		0xbed7
		},
		{
		0xbed8
		},
		{
		0xbee0
		},
		{
		0xbee3
		},
		{
		0xbee4
		},
		{
		0xbee5
		},
		{
		0xbeec
		},
		{
		0xbf01
		},
		{
		0xbf08
		},
		{
		0xbf09
		},
		{
		0xbf18
		},
		{
		0xbf19
		},
		{
		0xbf1b
		},
		{
		0xbf1c
		},
		{
		0xbf1d
		},
		{
		0xbf40
		},
		{
		0xbf41
		},
		{
		0xbf44
		},
		{
		0xbf48
		},
		{
		0xbf50
		},
		{
		0xbf51
		},
		{
		0xbf55
		},
		{
		0xbf94
		},
		{
		0xbfb0
		},
		{
		0xbfc5
		},
		{
		0xbfcc
		},
		{
		0xbfcd
		},
		{
		0xbfd0
		},
		{
		0xbfd4
		},
		{
		0xbfdc
		},
		{
		0xbfdf
		},
		{
		0xbfe1
		},
		{
		0xc03c
		},
		{
		0xc051
		},
		{
		0xc058
		},
		{
		0xc05c
		},
		{
		0xc060
		},
		{
		0xc068
		},
		{
		0xc069
		},
		{
		0xc090
		},
		{
		0xc091
		},
		{
		0xc094
		},
		{
		0xc098
		},
		{
		0xc0a0
		},
		{
		0xc0a1
		},
		{
		0xc0a3
		},
		{
		0xc0a5
		},
		{
		0xc0ac
		},
		{
		0xc0ad
		},
		{
		0xc0af
		},
		{
		0xc0b0
		},
		{
		0xc0b3
		},
		{
		0xc0b4
		},
		{
		0xc0b5
		},
		{
		0xc0b6
		},
		{
		0xc0bc
		},
		{
		0xc0bd
		},
		{
		0xc0bf
		},
		{
		0xc0c0
		},
		{
		0xc0c1
		},
		{
		0xc0c5
		},
		{
		0xc0c8
		},
		{
		0xc0c9
		},
		{
		0xc0cc
		},
		{
		0xc0d0
		},
		{
		0xc0d8
		},
		{
		0xc0d9
		},
		{
		0xc0db
		},
		{
		0xc0dc
		},
		{
		0xc0dd
		},
		{
		0xc0e4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_101[]=
	{
		{
		0xd324
		},
		{
		0xd326
		},
		{
		0xd327
		},
		{
		0xd32a
		},
		{
		0xd32b
		},
		{
		0xd32d
		},
		{
		0xd32e
		},
		{
		0xd32f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_102[]=
	{
		{
		0xd30f
		},
		{
		0xd311
		},
		{
		0xd312
		},
		{
		0xd313
		},
		{
		0xd315
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_103[]=
	{
		{
		0xd2f2
		},
		{
		0xd2f3
		},
		{
		0xd2f5
		},
		{
		0xd2f6
		},
		{
		0xd2f7
		},
		{
		0xd2f9
		},
		{
		0xd2fa
		},
		{
		0xbc99
		},
		{
		0xbc9a
		},
		{
		0xbca0
		},
		{
		0xbca1
		},
		{
		0xbca4
		},
		{
		0xbca7
		},
		{
		0xbca8
		},
		{
		0xbcb0
		},
		{
		0xbcb1
		},
		{
		0xbcb3
		},
		{
		0xbcb4
		},
		{
		0xbcb5
		},
		{
		0xbcbc
		},
		{
		0xbcbd
		},
		{
		0xbcc0
		},
		{
		0xbcc4
		},
		{
		0xbccd
		},
		{
		0xbccf
		},
		{
		0xbcd0
		},
		{
		0xbcd1
		},
		{
		0xbcd5
		},
		{
		0xbcd8
		},
		{
		0xbcdc
		},
		{
		0xbcf4
		},
		{
		0xbcf5
		},
		{
		0xbcf6
		},
		{
		0xbcf8
		},
		{
		0xbcfc
		},
		{
		0xbd04
		},
		{
		0xbd05
		},
		{
		0xbd07
		},
		{
		0xbd09
		},
		{
		0xbd10
		},
		{
		0xbd14
		},
		{
		0xbd24
		},
		{
		0xbd2c
		},
		{
		0xbd40
		},
		{
		0xbd48
		},
		{
		0xbd49
		},
		{
		0xbd4c
		},
		{
		0xbd50
		},
		{
		0xbd58
		},
		{
		0xbd59
		},
		{
		0xbd64
		},
		{
		0xbd68
		},
		{
		0xbd80
		},
		{
		0xbd81
		},
		{
		0xbd84
		},
		{
		0xbd87
		},
		{
		0xbd88
		},
		{
		0xbd89
		},
		{
		0xbd8a
		},
		{
		0xbd90
		},
		{
		0xbd91
		},
		{
		0xbd93
		},
		{
		0xbd95
		},
		{
		0xbd99
		},
		{
		0xbd9a
		},
		{
		0xbd9c
		},
		{
		0xbda4
		},
		{
		0xbdb0
		},
		{
		0xbdb8
		},
		{
		0xbdd4
		},
		{
		0xbdd5
		},
		{
		0xbdd8
		},
		{
		0xbddc
		},
		{
		0xbde9
		},
		{
		0xbdf0
		},
		{
		0xbdf4
		},
		{
		0xbdf8
		},
		{
		0xbe00
		},
		{
		0xbe03
		},
		{
		0xbe05
		},
		{
		0xbe0c
		},
		{
		0xbe0d
		},
		{
		0xbe10
		},
		{
		0xbe14
		},
		{
		0xbe1c
		},
		{
		0xbe1d
		},
		{
		0xbe1f
		},
		{
		0xbe44
		},
		{
		0xbe45
		},
		{
		0xbe48
		},
		{
		0xbe4c
		},
		{
		0xbe4e
		},
		{
		0xbe54
		},
		{
		0xbe55
		},
		{
		0xbe57
		},
		{
		0xbe59
		},
		{
		0xbe5a
		},
		{
		0xbe5b
		},
		{
		0xbe60
		},
		{
		0xbe61
		},
		{
		0xbe64
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_104[]=
	{
		{
		0xd2d2
		},
		{
		0xd2d3
		},
		{
		0xd2d5
		},
		{
		0xd2d6
		},
		{
		0xd2d7
		},
		{
		0xd2d9
		},
		{
		0xd2da
		},
		{
		0xd2db
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_105[]=
	{
		{
		0xd2ba
		},
		{
		0xd2bb
		},
		{
		0xd2bd
		},
		{
		0xd2be
		},
		{
		0xd2c1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_106[]=
	{
		{
		0xd29d
		},
		{
		0xd29e
		},
		{
		0xd29f
		},
		{
		0xd2a1
		},
		{
		0xd2a2
		},
		{
		0xd2a3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_107[]=
	{
		{
		0xd28d
		},
		{
		0xd28e
		},
		{
		0xd28f
		},
		{
		0xd292
		},
		{
		0xd293
		},
		{
		0xd294
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_108[]=
	{
		{
		0xbc24
		},
		{
		0xbc25
		},
		{
		0xbc27
		},
		{
		0xbc29
		},
		{
		0xbc2d
		},
		{
		0xbc30
		},
		{
		0xbc31
		},
		{
		0xbc34
		},
		{
		0xbc38
		},
		{
		0xbc40
		},
		{
		0xbc41
		},
		{
		0xbc43
		},
		{
		0xbc44
		},
		{
		0xbc45
		},
		{
		0xbc49
		},
		{
		0xbc4c
		},
		{
		0xbc4d
		},
		{
		0xbc50
		},
		{
		0xbc5d
		},
		{
		0xbc84
		},
		{
		0xbc85
		},
		{
		0xbc88
		},
		{
		0xbc8b
		},
		{
		0xbc8c
		},
		{
		0xbc8e
		},
		{
		0xbc94
		},
		{
		0xbc95
		},
		{
		0xbc97
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_109[]=
	{
		{
		0xd282
		},
		{
		0xd283
		},
		{
		0xd285
		},
		{
		0xd286
		},
		{
		0xd287
		},
		{
		0xd289
		},
		{
		0xd28a
		},
		{
		0xd28b
		},
		{
		0xd28c
		},
		{
		0xbb00
		},
		{
		0xbb04
		},
		{
		0xbb0d
		},
		{
		0xbb0f
		},
		{
		0xbb11
		},
		{
		0xbb18
		},
		{
		0xbb1c
		},
		{
		0xbb20
		},
		{
		0xbb29
		},
		{
		0xbb2b
		},
		{
		0xbb34
		},
		{
		0xbb35
		},
		{
		0xbb36
		},
		{
		0xbb38
		},
		{
		0xbb3b
		},
		{
		0xbb3c
		},
		{
		0xbb3d
		},
		{
		0xbb3e
		},
		{
		0xbb44
		},
		{
		0xbb45
		},
		{
		0xbb47
		},
		{
		0xbb49
		},
		{
		0xbb4d
		},
		{
		0xbb4f
		},
		{
		0xbb50
		},
		{
		0xbb54
		},
		{
		0xbb58
		},
		{
		0xbb61
		},
		{
		0xbb63
		},
		{
		0xbb6c
		},
		{
		0xbb88
		},
		{
		0xbb8c
		},
		{
		0xbb90
		},
		{
		0xbba4
		},
		{
		0xbba8
		},
		{
		0xbbac
		},
		{
		0xbbb4
		},
		{
		0xbbb7
		},
		{
		0xbbc0
		},
		{
		0xbbc4
		},
		{
		0xbbc8
		},
		{
		0xbbd0
		},
		{
		0xbbd3
		},
		{
		0xbbf8
		},
		{
		0xbbf9
		},
		{
		0xbbfc
		},
		{
		0xbbff
		},
		{
		0xbc00
		},
		{
		0xbc02
		},
		{
		0xbc08
		},
		{
		0xbc09
		},
		{
		0xbc0b
		},
		{
		0xbc0c
		},
		{
		0xbc0d
		},
		{
		0xbc0f
		},
		{
		0xbc11
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_110[]=
	{
		{
		0xd22a
		},
		{
		0xd22b
		},
		{
		0xd22e
		},
		{
		0xd22f
		},
		{
		0xd231
		},
		{
		0xd232
		},
		{
		0xd233
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_111[]=
	{
		{
		0xb9d8
		},
		{
		0xb9d9
		},
		{
		0xb9db
		},
		{
		0xb9dd
		},
		{
		0xb9de
		},
		{
		0xb9e1
		},
		{
		0xb9e3
		},
		{
		0xb9e4
		},
		{
		0xb9e5
		},
		{
		0xb9e8
		},
		{
		0xb9ec
		},
		{
		0xb9f4
		},
		{
		0xb9f5
		},
		{
		0xb9f7
		},
		{
		0xb9f8
		},
		{
		0xb9f9
		},
		{
		0xb9fa
		},
		{
		0xba00
		},
		{
		0xba01
		},
		{
		0xba08
		},
		{
		0xba15
		},
		{
		0xba38
		},
		{
		0xba39
		},
		{
		0xba3c
		},
		{
		0xba40
		},
		{
		0xba42
		},
		{
		0xba48
		},
		{
		0xba49
		},
		{
		0xba4b
		},
		{
		0xba4d
		},
		{
		0xba4e
		},
		{
		0xba53
		},
		{
		0xba54
		},
		{
		0xba55
		},
		{
		0xba58
		},
		{
		0xba5c
		},
		{
		0xba64
		},
		{
		0xba65
		},
		{
		0xba67
		},
		{
		0xba68
		},
		{
		0xba69
		},
		{
		0xba70
		},
		{
		0xba71
		},
		{
		0xba74
		},
		{
		0xba78
		},
		{
		0xba83
		},
		{
		0xba84
		},
		{
		0xba85
		},
		{
		0xba87
		},
		{
		0xba8c
		},
		{
		0xbaa8
		},
		{
		0xbaa9
		},
		{
		0xbaab
		},
		{
		0xbaac
		},
		{
		0xbab0
		},
		{
		0xbab2
		},
		{
		0xbab8
		},
		{
		0xbab9
		},
		{
		0xbabb
		},
		{
		0xbabd
		},
		{
		0xbac4
		},
		{
		0xbac8
		},
		{
		0xbad8
		},
		{
		0xbad9
		},
		{
		0xbafc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_112[]=
	{
		{
		0xb96b
		},
		{
		0xb96d
		},
		{
		0xb974
		},
		{
		0xb975
		},
		{
		0xb978
		},
		{
		0xb97c
		},
		{
		0xb984
		},
		{
		0xb985
		},
		{
		0xb987
		},
		{
		0xb989
		},
		{
		0xb98a
		},
		{
		0xb98d
		},
		{
		0xb98e
		},
		{
		0xb9ac
		},
		{
		0xb9ad
		},
		{
		0xb9b0
		},
		{
		0xb9b4
		},
		{
		0xb9bc
		},
		{
		0xb9bd
		},
		{
		0xb9bf
		},
		{
		0xb9c1
		},
		{
		0xb9c8
		},
		{
		0xb9c9
		},
		{
		0xb9cc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_113[]=
	{
		{
		0xb798
		},
		{
		0xb799
		},
		{
		0xb79c
		},
		{
		0xb7a0
		},
		{
		0xb7a8
		},
		{
		0xb7a9
		},
		{
		0xb7ab
		},
		{
		0xb7ac
		},
		{
		0xb7ad
		},
		{
		0xb7b4
		},
		{
		0xb7b5
		},
		{
		0xb7b8
		},
		{
		0xb7c7
		},
		{
		0xb7c9
		},
		{
		0xb7ec
		},
		{
		0xb7ed
		},
		{
		0xb7f0
		},
		{
		0xb7f4
		},
		{
		0xb7fc
		},
		{
		0xb7fd
		},
		{
		0xb7ff
		},
		{
		0xb800
		},
		{
		0xb801
		},
		{
		0xb807
		},
		{
		0xb808
		},
		{
		0xb809
		},
		{
		0xb80c
		},
		{
		0xb810
		},
		{
		0xb818
		},
		{
		0xb819
		},
		{
		0xb81b
		},
		{
		0xb81d
		},
		{
		0xb824
		},
		{
		0xb825
		},
		{
		0xb828
		},
		{
		0xb82c
		},
		{
		0xb834
		},
		{
		0xb835
		},
		{
		0xb837
		},
		{
		0xb838
		},
		{
		0xb839
		},
		{
		0xb840
		},
		{
		0xb844
		},
		{
		0xb851
		},
		{
		0xb853
		},
		{
		0xb85c
		},
		{
		0xb85d
		},
		{
		0xb860
		},
		{
		0xb864
		},
		{
		0xb86c
		},
		{
		0xb86d
		},
		{
		0xb86f
		},
		{
		0xb871
		},
		{
		0xb878
		},
		{
		0xb87c
		},
		{
		0xb88d
		},
		{
		0xb8a8
		},
		{
		0xb8b0
		},
		{
		0xb8b4
		},
		{
		0xb8b8
		},
		{
		0xb8c0
		},
		{
		0xb8c1
		},
		{
		0xb8c3
		},
		{
		0xb8c5
		},
		{
		0xb8cc
		},
		{
		0xb8d0
		},
		{
		0xb8d4
		},
		{
		0xb8dd
		},
		{
		0xb8df
		},
		{
		0xb8e1
		},
		{
		0xb8e8
		},
		{
		0xb8e9
		},
		{
		0xb8ec
		},
		{
		0xb8f0
		},
		{
		0xb8f8
		},
		{
		0xb8f9
		},
		{
		0xb8fb
		},
		{
		0xb8fd
		},
		{
		0xb904
		},
		{
		0xb918
		},
		{
		0xb920
		},
		{
		0xb93c
		},
		{
		0xb93d
		},
		{
		0xb940
		},
		{
		0xb944
		},
		{
		0xb94c
		},
		{
		0xb94f
		},
		{
		0xb951
		},
		{
		0xb958
		},
		{
		0xb959
		},
		{
		0xb95c
		},
		{
		0xb960
		},
		{
		0xb968
		},
		{
		0xb969
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_114[]=
	{
		{
		0xd1b2
		},
		{
		0xd1b4
		},
		{
		0xd1b6
		},
		{
		0xd1b7
		},
		{
		0xd1b8
		},
		{
		0xd1b9
		},
		{
		0xd1bb
		},
		{
		0xd1bd
		},
		{
		0xd1be
		},
		{
		0xd1bf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_115[]=
	{
		{
		0xd1a2
		},
		{
		0xd1a3
		},
		{
		0xd1a5
		},
		{
		0xd1a6
		},
		{
		0xd1a7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_116[]=
	{
		{
		0xd185
		},
		{
		0xd186
		},
		{
		0xd187
		},
		{
		0xd189
		},
		{
		0xd18a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_117[]=
	{
		{
		0xd169
		},
		{
		0xd16a
		},
		{
		0xd16b
		},
		{
		0xd16d
		},
		{
		0xb540
		},
		{
		0xb541
		},
		{
		0xb543
		},
		{
		0xb544
		},
		{
		0xb545
		},
		{
		0xb54b
		},
		{
		0xb54c
		},
		{
		0xb54d
		},
		{
		0xb550
		},
		{
		0xb554
		},
		{
		0xb55c
		},
		{
		0xb55d
		},
		{
		0xb55f
		},
		{
		0xb560
		},
		{
		0xb561
		},
		{
		0xb5a0
		},
		{
		0xb5a1
		},
		{
		0xb5a4
		},
		{
		0xb5a8
		},
		{
		0xb5aa
		},
		{
		0xb5ab
		},
		{
		0xb5b0
		},
		{
		0xb5b1
		},
		{
		0xb5b3
		},
		{
		0xb5b4
		},
		{
		0xb5b5
		},
		{
		0xb5bb
		},
		{
		0xb5bc
		},
		{
		0xb5bd
		},
		{
		0xb5c0
		},
		{
		0xb5c4
		},
		{
		0xb5cc
		},
		{
		0xb5cd
		},
		{
		0xb5cf
		},
		{
		0xb5d0
		},
		{
		0xb5d1
		},
		{
		0xb5d8
		},
		{
		0xb5ec
		},
		{
		0xb610
		},
		{
		0xb611
		},
		{
		0xb614
		},
		{
		0xb618
		},
		{
		0xb625
		},
		{
		0xb62c
		},
		{
		0xb634
		},
		{
		0xb648
		},
		{
		0xb664
		},
		{
		0xb668
		},
		{
		0xb69c
		},
		{
		0xb69d
		},
		{
		0xb6a0
		},
		{
		0xb6a4
		},
		{
		0xb6ab
		},
		{
		0xb6ac
		},
		{
		0xb6b1
		},
		{
		0xb6d4
		},
		{
		0xb6f0
		},
		{
		0xb6f4
		},
		{
		0xb6f8
		},
		{
		0xb700
		},
		{
		0xb701
		},
		{
		0xb705
		},
		{
		0xb728
		},
		{
		0xb729
		},
		{
		0xb72c
		},
		{
		0xb72f
		},
		{
		0xb730
		},
		{
		0xb738
		},
		{
		0xb739
		},
		{
		0xb73b
		},
		{
		0xb744
		},
		{
		0xb748
		},
		{
		0xb74c
		},
		{
		0xb754
		},
		{
		0xb755
		},
		{
		0xb760
		},
		{
		0xb764
		},
		{
		0xb768
		},
		{
		0xb770
		},
		{
		0xb771
		},
		{
		0xb773
		},
		{
		0xb775
		},
		{
		0xb77c
		},
		{
		0xb77d
		},
		{
		0xb780
		},
		{
		0xb784
		},
		{
		0xb78c
		},
		{
		0xb78d
		},
		{
		0xb78f
		},
		{
		0xb790
		},
		{
		0xb791
		},
		{
		0xb792
		},
		{
		0xb796
		},
		{
		0xb797
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_118[]=
	{
		{
		0xd14e
		},
		{
		0xd14f
		},
		{
		0xd151
		},
		{
		0xd152
		},
		{
		0xd153
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_119[]=
	{
		{
		0xd132
		},
		{
		0xd133
		},
		{
		0xd135
		},
		{
		0xd136
		},
		{
		0xd137
		},
		{
		0xd139
		},
		{
		0xd13b
		},
		{
		0xd13c
		},
		{
		0xd13d
		},
		{
		0xd13e
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_120[]=
	{
		{
		0xb367
		},
		{
		0xb369
		},
		{
		0xb36b
		},
		{
		0xb36e
		},
		{
		0xb370
		},
		{
		0xb371
		},
		{
		0xb374
		},
		{
		0xb378
		},
		{
		0xb380
		},
		{
		0xb381
		},
		{
		0xb383
		},
		{
		0xb384
		},
		{
		0xb385
		},
		{
		0xb38c
		},
		{
		0xb390
		},
		{
		0xb394
		},
		{
		0xb3a0
		},
		{
		0xb3a1
		},
		{
		0xb3a8
		},
		{
		0xb3ac
		},
		{
		0xb3c4
		},
		{
		0xb3c5
		},
		{
		0xb3c8
		},
		{
		0xb3cb
		},
		{
		0xb3cc
		},
		{
		0xb3ce
		},
		{
		0xb3d0
		},
		{
		0xb3d4
		},
		{
		0xb3d5
		},
		{
		0xb3d7
		},
		{
		0xb3d9
		},
		{
		0xb3db
		},
		{
		0xb3dd
		},
		{
		0xb3e0
		},
		{
		0xb3e4
		},
		{
		0xb3e8
		},
		{
		0xb3fc
		},
		{
		0xb410
		},
		{
		0xb418
		},
		{
		0xb41c
		},
		{
		0xb420
		},
		{
		0xb428
		},
		{
		0xb429
		},
		{
		0xb42b
		},
		{
		0xb434
		},
		{
		0xb450
		},
		{
		0xb451
		},
		{
		0xb454
		},
		{
		0xb458
		},
		{
		0xb460
		},
		{
		0xb461
		},
		{
		0xb463
		},
		{
		0xb465
		},
		{
		0xb46c
		},
		{
		0xb480
		},
		{
		0xb488
		},
		{
		0xb49d
		},
		{
		0xb4a4
		},
		{
		0xb4a8
		},
		{
		0xb4ac
		},
		{
		0xb4b5
		},
		{
		0xb4b7
		},
		{
		0xb4b9
		},
		{
		0xb4c0
		},
		{
		0xb4c4
		},
		{
		0xb4c8
		},
		{
		0xb4d0
		},
		{
		0xb4d5
		},
		{
		0xb4dc
		},
		{
		0xb4dd
		},
		{
		0xb4e0
		},
		{
		0xb4e3
		},
		{
		0xb4e4
		},
		{
		0xb4e6
		},
		{
		0xb4ec
		},
		{
		0xb4ed
		},
		{
		0xb4ef
		},
		{
		0xb4f1
		},
		{
		0xb4f8
		},
		{
		0xb514
		},
		{
		0xb515
		},
		{
		0xb518
		},
		{
		0xb51b
		},
		{
		0xb51c
		},
		{
		0xb524
		},
		{
		0xb525
		},
		{
		0xb527
		},
		{
		0xb528
		},
		{
		0xb529
		},
		{
		0xb52a
		},
		{
		0xb530
		},
		{
		0xb531
		},
		{
		0xb534
		},
		{
		0xb538
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_121[]=
	{
		{
		0xd0db
		},
		{
		0xd0de
		},
		{
		0xd0df
		},
		{
		0xd0e1
		},
		{
		0xd0e2
		},
		{
		0xd0e3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_122[]=
	{
		{
		0xd0c2
		},
		{
		0xd0c3
		},
		{
		0xd0c5
		},
		{
		0xd0c6
		},
		{
		0xd0c7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_123[]=
	{
		{
		0xd0a6
		},
		{
		0xd0a7
		},
		{
		0xd0a9
		},
		{
		0xd0aa
		},
		{
		0xd0ab
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_124[]=
	{
		{
		0xb2ff
		},
		{
		0xb300
		},
		{
		0xb301
		},
		{
		0xb304
		},
		{
		0xb308
		},
		{
		0xb310
		},
		{
		0xb311
		},
		{
		0xb313
		},
		{
		0xb314
		},
		{
		0xb315
		},
		{
		0xb31c
		},
		{
		0xb354
		},
		{
		0xb355
		},
		{
		0xb356
		},
		{
		0xb358
		},
		{
		0xb35b
		},
		{
		0xb35c
		},
		{
		0xb35e
		},
		{
		0xb35f
		},
		{
		0xb364
		},
		{
		0xb365
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_125[]=
	{
		{
		0xb1df
		},
		{
		0xb1e8
		},
		{
		0xb1e9
		},
		{
		0xb1ec
		},
		{
		0xb1f0
		},
		{
		0xb1f9
		},
		{
		0xb1fb
		},
		{
		0xb1fd
		},
		{
		0xb204
		},
		{
		0xb205
		},
		{
		0xb208
		},
		{
		0xb20b
		},
		{
		0xb20c
		},
		{
		0xb214
		},
		{
		0xb215
		},
		{
		0xb217
		},
		{
		0xb219
		},
		{
		0xb220
		},
		{
		0xb234
		},
		{
		0xb23c
		},
		{
		0xb258
		},
		{
		0xb25c
		},
		{
		0xb260
		},
		{
		0xb268
		},
		{
		0xb269
		},
		{
		0xb274
		},
		{
		0xb275
		},
		{
		0xb27c
		},
		{
		0xb284
		},
		{
		0xb285
		},
		{
		0xb289
		},
		{
		0xb290
		},
		{
		0xb291
		},
		{
		0xb294
		},
		{
		0xb298
		},
		{
		0xb299
		},
		{
		0xb29a
		},
		{
		0xb2a0
		},
		{
		0xb2a1
		},
		{
		0xb2a3
		},
		{
		0xb2a5
		},
		{
		0xb2a6
		},
		{
		0xb2aa
		},
		{
		0xb2ac
		},
		{
		0xb2b0
		},
		{
		0xb2b4
		},
		{
		0xb2c8
		},
		{
		0xb2c9
		},
		{
		0xb2cc
		},
		{
		0xb2d0
		},
		{
		0xb2d2
		},
		{
		0xb2d8
		},
		{
		0xb2d9
		},
		{
		0xb2db
		},
		{
		0xb2dd
		},
		{
		0xb2e2
		},
		{
		0xb2e4
		},
		{
		0xb2e5
		},
		{
		0xb2e6
		},
		{
		0xb2e8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_126[]=
	{
		{
		0xd051
		},
		{
		0xd052
		},
		{
		0xd053
		},
		{
		0xd055
		},
		{
		0xd056
		},
		{
		0xd057
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_127[]=
	{
		{
		0xd036
		},
		{
		0xd037
		},
		{
		0xd039
		},
		{
		0xd03a
		},
		{
		0xd03b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_128[]=
	{
		{
		0xb0b1
		},
		{
		0xb0b3
		},
		{
		0xb0b4
		},
		{
		0xb0b5
		},
		{
		0xb0b8
		},
		{
		0xb0bc
		},
		{
		0xb0c4
		},
		{
		0xb0c5
		},
		{
		0xb0c7
		},
		{
		0xb0c8
		},
		{
		0xb0c9
		},
		{
		0xb0d0
		},
		{
		0xb0d1
		},
		{
		0xb0d4
		},
		{
		0xb0d8
		},
		{
		0xb0e0
		},
		{
		0xb0e5
		},
		{
		0xb108
		},
		{
		0xb109
		},
		{
		0xb10b
		},
		{
		0xb10c
		},
		{
		0xb110
		},
		{
		0xb112
		},
		{
		0xb113
		},
		{
		0xb118
		},
		{
		0xb119
		},
		{
		0xb11b
		},
		{
		0xb11c
		},
		{
		0xb11d
		},
		{
		0xb123
		},
		{
		0xb124
		},
		{
		0xb125
		},
		{
		0xb128
		},
		{
		0xb12c
		},
		{
		0xb134
		},
		{
		0xb135
		},
		{
		0xb137
		},
		{
		0xb138
		},
		{
		0xb139
		},
		{
		0xb140
		},
		{
		0xb141
		},
		{
		0xb144
		},
		{
		0xb148
		},
		{
		0xb150
		},
		{
		0xb151
		},
		{
		0xb154
		},
		{
		0xb155
		},
		{
		0xb158
		},
		{
		0xb15c
		},
		{
		0xb160
		},
		{
		0xb178
		},
		{
		0xb179
		},
		{
		0xb17c
		},
		{
		0xb180
		},
		{
		0xb182
		},
		{
		0xb188
		},
		{
		0xb189
		},
		{
		0xb18b
		},
		{
		0xb18d
		},
		{
		0xb192
		},
		{
		0xb193
		},
		{
		0xb194
		},
		{
		0xb198
		},
		{
		0xb19c
		},
		{
		0xb1a8
		},
		{
		0xb1cc
		},
		{
		0xb1d0
		},
		{
		0xb1d4
		},
		{
		0xb1dc
		},
		{
		0xb1dd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_129[]=
	{
		{
		0xb05d
		},
		{
		0xb07c
		},
		{
		0xb07d
		},
		{
		0xb080
		},
		{
		0xb084
		},
		{
		0xb08c
		},
		{
		0xb08d
		},
		{
		0xb08f
		},
		{
		0xb091
		},
		{
		0xb098
		},
		{
		0xb099
		},
		{
		0xb09a
		},
		{
		0xb09c
		},
		{
		0xb09f
		},
		{
		0xb0a0
		},
		{
		0xb0a1
		},
		{
		0xb0a2
		},
		{
		0xb0a8
		},
		{
		0xb0a9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_130[]=
	{
		{
		0xcffd
		},
		{
		0xcffe
		},
		{
		0xcfff
		},
		{
		0xd001
		},
		{
		0xd002
		},
		{
		0xd003
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_131[]=
	{
		{
		0xcfe2
		},
		{
		0xcfe3
		},
		{
		0xcfe5
		},
		{
		0xcfe6
		},
		{
		0xcfe7
		},
		{
		0xcfe9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_132[]=
	{
		{
		0xae79
		},
		{
		0xae7b
		},
		{
		0xae7c
		},
		{
		0xae7d
		},
		{
		0xae84
		},
		{
		0xae85
		},
		{
		0xae8c
		},
		{
		0xaebc
		},
		{
		0xaebd
		},
		{
		0xaebe
		},
		{
		0xaec0
		},
		{
		0xaec4
		},
		{
		0xaecc
		},
		{
		0xaecd
		},
		{
		0xaecf
		},
		{
		0xaed0
		},
		{
		0xaed1
		},
		{
		0xaed8
		},
		{
		0xaed9
		},
		{
		0xaedc
		},
		{
		0xaee8
		},
		{
		0xaeeb
		},
		{
		0xaeed
		},
		{
		0xaef4
		},
		{
		0xaef8
		},
		{
		0xaefc
		},
		{
		0xaf07
		},
		{
		0xaf08
		},
		{
		0xaf0d
		},
		{
		0xaf10
		},
		{
		0xaf2c
		},
		{
		0xaf2d
		},
		{
		0xaf30
		},
		{
		0xaf32
		},
		{
		0xaf34
		},
		{
		0xaf3c
		},
		{
		0xaf3d
		},
		{
		0xaf3f
		},
		{
		0xaf41
		},
		{
		0xaf42
		},
		{
		0xaf43
		},
		{
		0xaf48
		},
		{
		0xaf49
		},
		{
		0xaf50
		},
		{
		0xaf5c
		},
		{
		0xaf5d
		},
		{
		0xaf64
		},
		{
		0xaf65
		},
		{
		0xaf79
		},
		{
		0xaf80
		},
		{
		0xaf84
		},
		{
		0xaf88
		},
		{
		0xaf90
		},
		{
		0xaf91
		},
		{
		0xaf95
		},
		{
		0xaf9c
		},
		{
		0xafb8
		},
		{
		0xafb9
		},
		{
		0xafbc
		},
		{
		0xafc0
		},
		{
		0xafc7
		},
		{
		0xafc8
		},
		{
		0xafc9
		},
		{
		0xafcb
		},
		{
		0xafcd
		},
		{
		0xafce
		},
		{
		0xafd4
		},
		{
		0xafdc
		},
		{
		0xafe8
		},
		{
		0xafe9
		},
		{
		0xaff0
		},
		{
		0xaff1
		},
		{
		0xaff4
		},
		{
		0xaff8
		},
		{
		0xb000
		},
		{
		0xb001
		},
		{
		0xb004
		},
		{
		0xb00c
		},
		{
		0xb010
		},
		{
		0xb014
		},
		{
		0xb01c
		},
		{
		0xb01d
		},
		{
		0xb028
		},
		{
		0xb044
		},
		{
		0xb045
		},
		{
		0xb048
		},
		{
		0xb04a
		},
		{
		0xb04c
		},
		{
		0xb04e
		},
		{
		0xb053
		},
		{
		0xb054
		},
		{
		0xb055
		},
		{
		0xb057
		},
		{
		0xb059
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_133[]=
	{
		{
		0xcf6d
		},
		{
		0xcf6e
		},
		{
		0xcf6f
		},
		{
		0xcf72
		},
		{
		0xcf73
		},
		{
		0xcf75
		},
		{
		0xcf76
		},
		{
		0xcf77
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_134[]=
	{
		{
		0xcf66
		},
		{
		0xcf68
		},
		{
		0xcf6a
		},
		{
		0xcf6b
		},
		{
		0xcf6c
		},
		{
		0xad0c
		},
		{
		0xad0d
		},
		{
		0xad0f
		},
		{
		0xad11
		},
		{
		0xad18
		},
		{
		0xad1c
		},
		{
		0xad20
		},
		{
		0xad29
		},
		{
		0xad2c
		},
		{
		0xad2d
		},
		{
		0xad34
		},
		{
		0xad35
		},
		{
		0xad38
		},
		{
		0xad3c
		},
		{
		0xad44
		},
		{
		0xad45
		},
		{
		0xad47
		},
		{
		0xad49
		},
		{
		0xad50
		},
		{
		0xad54
		},
		{
		0xad58
		},
		{
		0xad61
		},
		{
		0xad63
		},
		{
		0xad6c
		},
		{
		0xad6d
		},
		{
		0xad70
		},
		{
		0xad73
		},
		{
		0xad74
		},
		{
		0xad75
		},
		{
		0xad76
		},
		{
		0xad7b
		},
		{
		0xad7c
		},
		{
		0xad7d
		},
		{
		0xad7f
		},
		{
		0xad81
		},
		{
		0xad82
		},
		{
		0xad88
		},
		{
		0xad89
		},
		{
		0xad8c
		},
		{
		0xad90
		},
		{
		0xad9c
		},
		{
		0xad9d
		},
		{
		0xada4
		},
		{
		0xadb7
		},
		{
		0xadc0
		},
		{
		0xadc1
		},
		{
		0xadc4
		},
		{
		0xadc8
		},
		{
		0xadd0
		},
		{
		0xadd1
		},
		{
		0xadd3
		},
		{
		0xaddc
		},
		{
		0xade0
		},
		{
		0xade4
		},
		{
		0xadf8
		},
		{
		0xadf9
		},
		{
		0xadfc
		},
		{
		0xadff
		},
		{
		0xae00
		},
		{
		0xae01
		},
		{
		0xae08
		},
		{
		0xae09
		},
		{
		0xae0b
		},
		{
		0xae0d
		},
		{
		0xae14
		},
		{
		0xae30
		},
		{
		0xae31
		},
		{
		0xae34
		},
		{
		0xae37
		},
		{
		0xae38
		},
		{
		0xae3a
		},
		{
		0xae40
		},
		{
		0xae41
		},
		{
		0xae43
		},
		{
		0xae45
		},
		{
		0xae46
		},
		{
		0xae4a
		},
		{
		0xae4c
		},
		{
		0xae4d
		},
		{
		0xae4e
		},
		{
		0xae50
		},
		{
		0xae54
		},
		{
		0xae56
		},
		{
		0xae5c
		},
		{
		0xae5d
		},
		{
		0xae5f
		},
		{
		0xae60
		},
		{
		0xae61
		},
		{
		0xae65
		},
		{
		0xae68
		},
		{
		0xae69
		},
		{
		0xae6c
		},
		{
		0xae70
		},
		{
		0xae78
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_135[]=
	{
		{
		0xcf56
		},
		{
		0xcf57
		},
		{
		0xcf59
		},
		{
		0xcf5a
		},
		{
		0xcf5b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_136[]=
	{
		{
		0xcf1d
		},
		{
		0xcf1e
		},
		{
		0xcf1f
		},
		{
		0xcf21
		},
		{
		0xcf22
		},
		{
		0xcf23
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_137[]=
	{
		{
		0xcf02
		},
		{
		0xcf03
		},
		{
		0xcf05
		},
		{
		0xcf06
		},
		{
		0xcf07
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_138[]=
	{
		{
		0xac20
		},
		{
		0xac24
		},
		{
		0xac2c
		},
		{
		0xac2d
		},
		{
		0xac2f
		},
		{
		0xac30
		},
		{
		0xac31
		},
		{
		0xac38
		},
		{
		0xac39
		},
		{
		0xac3c
		},
		{
		0xac40
		},
		{
		0xac4b
		},
		{
		0xac4d
		},
		{
		0xac54
		},
		{
		0xac58
		},
		{
		0xac5c
		},
		{
		0xac70
		},
		{
		0xac71
		},
		{
		0xac74
		},
		{
		0xac77
		},
		{
		0xac78
		},
		{
		0xac7a
		},
		{
		0xac80
		},
		{
		0xac81
		},
		{
		0xac83
		},
		{
		0xac84
		},
		{
		0xac85
		},
		{
		0xac86
		},
		{
		0xac89
		},
		{
		0xac8a
		},
		{
		0xac8b
		},
		{
		0xac8c
		},
		{
		0xac90
		},
		{
		0xac94
		},
		{
		0xac9c
		},
		{
		0xac9d
		},
		{
		0xac9f
		},
		{
		0xaca0
		},
		{
		0xaca1
		},
		{
		0xaca8
		},
		{
		0xaca9
		},
		{
		0xacaa
		},
		{
		0xacac
		},
		{
		0xacaf
		},
		{
		0xacb0
		},
		{
		0xacb8
		},
		{
		0xacb9
		},
		{
		0xacbb
		},
		{
		0xacbc
		},
		{
		0xacbd
		},
		{
		0xacc1
		},
		{
		0xacc4
		},
		{
		0xacc8
		},
		{
		0xaccc
		},
		{
		0xacd5
		},
		{
		0xacd7
		},
		{
		0xace0
		},
		{
		0xace1
		},
		{
		0xace4
		},
		{
		0xace7
		},
		{
		0xace8
		},
		{
		0xacea
		},
		{
		0xacec
		},
		{
		0xacef
		},
		{
		0xacf0
		},
		{
		0xacf1
		},
		{
		0xacf3
		},
		{
		0xacf5
		},
		{
		0xacf6
		},
		{
		0xacfc
		},
		{
		0xacfd
		},
		{
		0xad00
		},
		{
		0xad04
		},
		{
		0xad06
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_139[]=
	{
		{
		0xac00
		},
		{
		0xac01
		},
		{
		0xac04
		},
		{
		0xac07
		},
		{
		0xac08
		},
		{
		0xac09
		},
		{
		0xac0a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_140[]=
	{
		{
		0xce92
		},
		{
		0xce93
		},
		{
		0xce95
		},
		{
		0xce96
		},
		{
		0xce97
		},
		{
		0xce99
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_141[]=
	{
		{
		0xce76
		},
		{
		0xce77
		},
		{
		0xce79
		},
		{
		0xce7a
		},
		{
		0xce7b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_142[]=
	{
		{
		0xce2c
		},
		{
		0xce2d
		},
		{
		0xce2e
		},
		{
		0xce2f
		},
		{
		0xce32
		},
		{
		0xce34
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_143[]=
	{
		{
		0xce22
		},
		{
		0xce23
		},
		{
		0xce25
		},
		{
		0xce26
		},
		{
		0xce27
		},
		{
		0xce29
		},
		{
		0xce2a
		},
		{
		0xce2b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_144[]=
	{
		{
		0xce03
		},
		{
		0xce05
		},
		{
		0xce06
		},
		{
		0xce07
		},
		{
		0xce09
		},
		{
		0xce0a
		},
		{
		0xce0b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_145[]=
	{
		{
		0xcde9
		},
		{
		0xcdea
		},
		{
		0xcdeb
		},
		{
		0xcded
		},
		{
		0xcdee
		},
		{
		0xcdef
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_146[]=
	{
		{
		0xcda0
		},
		{
		0xcda1
		},
		{
		0xcda2
		},
		{
		0xcda3
		},
		{
		0xcda6
		},
		{
		0xcda8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_147[]=
	{
		{
		0xcd96
		},
		{
		0xcd97
		},
		{
		0xcd99
		},
		{
		0xcd9a
		},
		{
		0xcd9b
		},
		{
		0xcd9d
		},
		{
		0xcd9e
		},
		{
		0xcd9f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_148[]=
	{
		{
		0xcd21
		},
		{
		0xcd22
		},
		{
		0xcd23
		},
		{
		0xcd25
		},
		{
		0xcd26
		},
		{
		0xcd27
		},
		{
		0xcd29
		},
		{
		0xcd2a
		},
		{
		0xcd2b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_149[]=
	{
		{
		0xcd1a
		},
		{
		0xcd1c
		},
		{
		0xcd1e
		},
		{
		0xcd1f
		},
		{
		0xcd20
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_150[]=
	{
		{
		0xcd0a
		},
		{
		0xcd0b
		},
		{
		0xcd0d
		},
		{
		0xcd0e
		},
		{
		0xcd0f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_151[]=
	{
		{
		0xcc94
		},
		{
		0xcc95
		},
		{
		0xcc96
		},
		{
		0xcc97
		},
		{
		0xcc9a
		},
		{
		0xcc9b
		},
		{
		0xcc9d
		},
		{
		0xcc9e
		},
		{
		0xcc9f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_152[]=
	{
		{
		0xcc61
		},
		{
		0xcc62
		},
		{
		0xcc63
		},
		{
		0xcc65
		},
		{
		0xcc67
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_153[]=
	{
		{
		0xcc46
		},
		{
		0xcc47
		},
		{
		0xcc49
		},
		{
		0xcc4a
		},
		{
		0xcc4b
		},
		{
		0xcc4d
		},
		{
		0xcc4e
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_154[]=
	{
		{
		0xcc25
		},
		{
		0xcc26
		},
		{
		0xcc2a
		},
		{
		0xcc2b
		},
		{
		0xcc2d
		},
		{
		0xcc2f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_155[]=
	{
		{
		0x00b9
		},
		{
		0x00b2
		},
		{
		0x00b3
		},
		{
		0x2074
		},
		{
		0x207f
		},
		{
		0x2081
		},
		{
		0x2082
		},
		{
		0x2083
		},
		{
		0x2084
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_156[]=
	{
		{
		0xcc1e
		},
		{
		0xcc1f
		},
		{
		0xcc20
		},
		{
		0xcc23
		},
		{
		0xcc24
		},
		{
		0x00e6
		},
		{
		0x0111
		},
		{
		0x00f0
		},
		{
		0x0127
		},
		{
		0x0131
		},
		{
		0x0133
		},
		{
		0x0138
		},
		{
		0x0140
		},
		{
		0x0142
		},
		{
		0x00f8
		},
		{
		0x0153
		},
		{
		0x00df
		},
		{
		0x00fe
		},
		{
		0x0167
		},
		{
		0x014b
		},
		{
		0x0149
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_157[]=
	{
		{
		0xcc0e
		},
		{
		0xcc0f
		},
		{
		0xcc11
		},
		{
		0xcc12
		},
		{
		0xcc13
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_158[]=
	{
		{
		0xcbe0
		},
		{
		0xcbe1
		},
		{
		0xcbe2
		},
		{
		0xcbe3
		},
		{
		0xcbe5
		},
		{
		0xcbe6
		},
		{
		0xcbe8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_159[]=
	{
		{
		0x00bd
		},
		{
		0x2153
		},
		{
		0x2154
		},
		{
		0x00bc
		},
		{
		0x00be
		},
		{
		0x215b
		},
		{
		0x215c
		},
		{
		0x215d
		},
		{
		0x215e
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_160[]=
	{
		{
		0x013f
		},
		{
		0x0141
		},
		{
		0x00d8
		},
		{
		0x0152
		},
		{
		0x00ba
		},
		{
		0x00de
		},
		{
		0x0166
		},
		{
		0x014a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_161[]=
	{
		{
		0x2126
		},
		{
		0x33c0
		},
		{
		0x33c1
		},
		{
		0x338a
		},
		{
		0x338b
		},
		{
		0x338c
		},
		{
		0x33d6
		},
		{
		0x33c5
		},
		{
		0x33ad
		},
		{
		0x33ae
		},
		{
		0x33af
		},
		{
		0x33db
		},
		{
		0x33a9
		},
		{
		0x33aa
		},
		{
		0x33ab
		},
		{
		0x33ac
		},
		{
		0x33dd
		},
		{
		0x33d0
		},
		{
		0x33d3
		},
		{
		0x33c3
		},
		{
		0x33c9
		},
		{
		0x33dc
		},
		{
		0x33c6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_162[]=
	{
		{
		0x33ca
		},
		{
		0x338d
		},
		{
		0x338e
		},
		{
		0x338f
		},
		{
		0x33cf
		},
		{
		0x3388
		},
		{
		0x3389
		},
		{
		0x33c8
		},
		{
		0x33a7
		},
		{
		0x33a8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_163[]=
	{
		{
		0x3395
		},
		{
		0x3396
		},
		{
		0x3397
		},
		{
		0x2113
		},
		{
		0x3398
		},
		{
		0x33c4
		},
		{
		0x33a3
		},
		{
		0x33a4
		},
		{
		0x33a5
		},
		{
		0x33a6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_164[]=
	{
		{
		0xcb45
		},
		{
		0xcb46
		},
		{
		0xcb47
		},
		{
		0xcb4a
		},
		{
		0xcb4b
		},
		{
		0xcb4d
		},
		{
		0xcb4e
		},
		{
		0xcb4f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_165[]=
	{
		{
		0xcb11
		},
		{
		0xcb12
		},
		{
		0xcb13
		},
		{
		0xcb15
		},
		{
		0xcb16
		},
		{
		0xcb17
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_166[]=
	{
		{
		0xcb09
		},
		{
		0xcb0a
		},
		{
		0x2500
		},
		{
		0x2502
		},
		{
		0x250c
		},
		{
		0x2510
		},
		{
		0x2518
		},
		{
		0x2514
		},
		{
		0x251c
		},
		{
		0x252c
		},
		{
		0x2524
		},
		{
		0x2534
		},
		{
		0x253c
		},
		{
		0x2501
		},
		{
		0x2503
		},
		{
		0x250f
		},
		{
		0x2513
		},
		{
		0x251b
		},
		{
		0x2517
		},
		{
		0x2523
		},
		{
		0x2533
		},
		{
		0x252b
		},
		{
		0x253b
		},
		{
		0x254b
		},
		{
		0x2520
		},
		{
		0x252f
		},
		{
		0x2528
		},
		{
		0x2537
		},
		{
		0x253f
		},
		{
		0x251d
		},
		{
		0x2530
		},
		{
		0x2525
		},
		{
		0x2538
		},
		{
		0x2542
		},
		{
		0x2512
		},
		{
		0x2511
		},
		{
		0x251a
		},
		{
		0x2519
		},
		{
		0x2516
		},
		{
		0x2515
		},
		{
		0x250e
		},
		{
		0x250d
		},
		{
		0x251e
		},
		{
		0x251f
		},
		{
		0x2521
		},
		{
		0x2522
		},
		{
		0x2526
		},
		{
		0x2527
		},
		{
		0x2529
		},
		{
		0x252a
		},
		{
		0x252d
		},
		{
		0x252e
		},
		{
		0x2531
		},
		{
		0x2532
		},
		{
		0x2535
		},
		{
		0x2536
		},
		{
		0x2539
		},
		{
		0x253a
		},
		{
		0x253d
		},
		{
		0x253e
		},
		{
		0x2540
		},
		{
		0x2541
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_167[]=
	{
		{
		0xcace
		},
		{
		0xcad0
		},
		{
		0xcad2
		},
		{
		0xcad4
		},
		{
		0xcad5
		},
		{
		0xcad6
		},
		{
		0xcad7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_168[]=
	{
		{
		0xcabe
		},
		{
		0xcabf
		},
		{
		0xcac1
		},
		{
		0xcac2
		},
		{
		0xcac3
		},
		{
		0xcac5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_169[]=
	{
		{
		0xca4e
		},
		{
		0xca4f
		},
		{
		0xca51
		},
		{
		0xca52
		},
		{
		0xca53
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_170[]=
	{
		{
		0xc9fa
		},
		{
		0xc9fb
		},
		{
		0xc9fd
		},
		{
		0xc9fe
		},
		{
		0xc9ff
		},
		{
		0xca01
		},
		{
		0xca02
		},
		{
		0xca03
		},
		{
		0xca04
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_171[]=
	{
		{
		0xc9de
		},
		{
		0xc9df
		},
		{
		0xc9e1
		},
		{
		0xc9e3
		},
		{
		0xc9e5
		},
		{
		0xc9e6
		},
		{
		0xc9e8
		},
		{
		0xc9e9
		},
		{
		0xc9ea
		},
		{
		0xc9eb
		},
		{
		0xc9ee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_172[]=
	{
		{
		0xc9d2
		},
		{
		0xc9d4
		},
		{
		0xc9d7
		},
		{
		0xc9d8
		},
		{
		0xc9db
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_173[]=
	{
		{
		0xc9c2
		},
		{
		0xc9c3
		},
		{
		0xc9c5
		},
		{
		0xc9c6
		},
		{
		0xc9c9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_174[]=
	{
		{
		0xc98a
		},
		{
		0xc98b
		},
		{
		0xc98d
		},
		{
		0xc98e
		},
		{
		0xc98f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_175[]=
	{
		{
		0xc96d
		},
		{
		0xc96e
		},
		{
		0xc96f
		},
		{
		0x21d2
		},
		{
		0x21d4
		},
		{
		0x2200
		},
		{
		0x2203
		},
		{
		0x00b4
		},
		{
		0xff5e
		},
		{
		0x02c7
		},
		{
		0x02d8
		},
		{
		0x02dd
		},
		{
		0x02da
		},
		{
		0x02d9
		},
		{
		0x00b8
		},
		{
		0x02db
		},
		{
		0x00a1
		},
		{
		0x00bf
		},
		{
		0x02d0
		},
		{
		0x222e
		},
		{
		0x2211
		},
		{
		0x220f
		},
		{
		0x00a4
		},
		{
		0x2109
		},
		{
		0x2030
		},
		{
		0x25c1
		},
		{
		0x25c0
		},
		{
		0x25b7
		},
		{
		0x25b6
		},
		{
		0x2664
		},
		{
		0x2660
		},
		{
		0x2661
		},
		{
		0x2665
		},
		{
		0x2667
		},
		{
		0x2663
		},
		{
		0x2299
		},
		{
		0x25c8
		},
		{
		0x25a3
		},
		{
		0x25d0
		},
		{
		0x25d1
		},
		{
		0x2592
		},
		{
		0x25a4
		},
		{
		0x25a5
		},
		{
		0x25a8
		},
		{
		0x25a7
		},
		{
		0x25a6
		},
		{
		0x25a9
		},
		{
		0x2668
		},
		{
		0x260f
		},
		{
		0x260e
		},
		{
		0x261c
		},
		{
		0x261e
		},
		{
		0x00b6
		},
		{
		0x2020
		},
		{
		0x2021
		},
		{
		0x2195
		},
		{
		0x2197
		},
		{
		0x2199
		},
		{
		0x2196
		},
		{
		0x2198
		},
		{
		0x266d
		},
		{
		0x2669
		},
		{
		0x266a
		},
		{
		0x266c
		},
		{
		0x327f
		},
		{
		0x321c
		},
		{
		0x2116
		},
		{
		0x33c7
		},
		{
		0x2122
		},
		{
		0x33c2
		},
		{
		0x33d8
		},
		{
		0x2121
		},
		{
		0x20ac
		},
		{
		0x00ae
		},
		{
		0x327e
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_176[]=
	{
		{
		0xc952
		},
		{
		0xc953
		},
		{
		0xc955
		},
		{
		0xc956
		},
		{
		0xc957
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_177[]=
	{
		{
		0x00b1
		},
		{
		0x00d7
		},
		{
		0x00f7
		},
		{
		0x2260
		},
		{
		0x2264
		},
		{
		0x2265
		},
		{
		0x221e
		},
		{
		0x2234
		},
		{
		0x00b0
		},
		{
		0x2032
		},
		{
		0x2033
		},
		{
		0x2103
		},
		{
		0x212b
		},
		{
		0xffe0
		},
		{
		0xffe1
		},
		{
		0xffe5
		},
		{
		0x2642
		},
		{
		0x2640
		},
		{
		0x2220
		},
		{
		0x22a5
		},
		{
		0x2312
		},
		{
		0x2202
		},
		{
		0x2207
		},
		{
		0x2261
		},
		{
		0x2252
		},
		{
		0x00a7
		},
		{
		0x203b
		},
		{
		0x2606
		},
		{
		0x2605
		},
		{
		0x25cb
		},
		{
		0x25cf
		},
		{
		0x25ce
		},
		{
		0x25c7
		},
		{
		0x25c6
		},
		{
		0x25a1
		},
		{
		0x25a0
		},
		{
		0x25b3
		},
		{
		0x25b2
		},
		{
		0x25bd
		},
		{
		0x25bc
		},
		{
		0x2192
		},
		{
		0x2190
		},
		{
		0x2191
		},
		{
		0x2193
		},
		{
		0x2194
		},
		{
		0x3013
		},
		{
		0x226a
		},
		{
		0x226b
		},
		{
		0x221a
		},
		{
		0x223d
		},
		{
		0x221d
		},
		{
		0x2235
		},
		{
		0x222b
		},
		{
		0x222c
		},
		{
		0x2208
		},
		{
		0x220b
		},
		{
		0x2286
		},
		{
		0x2287
		},
		{
		0x2282
		},
		{
		0x2283
		},
		{
		0x222a
		},
		{
		0x2229
		},
		{
		0x2227
		},
		{
		0x2228
		},
		{
		0xffe2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_178[]=
	{
		{
		0xc90e
		},
		{
		0x3000
		},
		{
		0x3001
		},
		{
		0x3002
		},
		{
		0x00b7
		},
		{
		0x2025
		},
		{
		0x2026
		},
		{
		0x00a8
		},
		{
		0x3003
		},
		{
		0x00ad
		},
		{
		0x2015
		},
		{
		0x2225
		},
		{
		0xff3c
		},
		{
		0x223c
		},
		{
		0x2018
		},
		{
		0x2019
		},
		{
		0x201c
		},
		{
		0x201d
		},
		{
		0x3014
		},
		{
		0x3015
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_179[]=
	{
		{
		0xc8fe
		},
		{
		0xc8ff
		},
		{
		0xc901
		},
		{
		0xc902
		},
		{
		0xc903
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_180[]=
	{
		{
		0xc8c2
		},
		{
		0xc8c3
		},
		{
		0xc8c5
		},
		{
		0xc8c6
		},
		{
		0xc8c7
		},
		{
		0xc8c9
		},
		{
		0xc8ca
		},
		{
		0xc8cb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_181[]=
	{
		{
		0xc89e
		},
		{
		0xc8a0
		},
		{
		0xc8a2
		},
		{
		0xc8a3
		},
		{
		0xc8a4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_182[]=
	{
		{
		0xc882
		},
		{
		0xc884
		},
		{
		0xc888
		},
		{
		0xc889
		},
		{
		0xc88a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_183[]=
	{
		{
		0xc872
		},
		{
		0xc873
		},
		{
		0xc875
		},
		{
		0xc876
		},
		{
		0xc877
		},
		{
		0xc879
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_184[]=
	{
		{
		0xc839
		},
		{
		0xc83a
		},
		{
		0xc83b
		},
		{
		0xc83d
		},
		{
		0xc83e
		},
		{
		0xc83f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_185[]=
	{
		{
		0xc81e
		},
		{
		0xc81f
		},
		{
		0xc821
		},
		{
		0xc822
		},
		{
		0xc823
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_186[]=
	{
		{
		0xc802
		},
		{
		0xc803
		},
		{
		0xc805
		},
		{
		0xc806
		},
		{
		0xc807
		},
		{
		0xc809
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_187[]=
	{
		{
		0xc7e5
		},
		{
		0xc7e6
		},
		{
		0xc7e7
		},
		{
		0xc7e9
		},
		{
		0xc7ea
		},
		{
		0xc7eb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_188[]=
	{
		{
		0xc7b8
		},
		{
		0xc7b9
		},
		{
		0xc7ba
		},
		{
		0xc7bb
		},
		{
		0xc7be
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_189[]=
	{
		{
		0xc7ae
		},
		{
		0xc7af
		},
		{
		0xc7b1
		},
		{
		0xc7b2
		},
		{
		0xc7b3
		},
		{
		0xc7b5
		},
		{
		0xc7b6
		},
		{
		0xc7b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_190[]=
	{
		{
		0xc776
		},
		{
		0xc777
		},
		{
		0xc779
		},
		{
		0xc77a
		},
		{
		0xc77b
		},
		{
		0xc77f
		},
		{
		0xc780
		},
		{
		0xc781
		},
		{
		0xc782
		},
		{
		0xc786
		},
		{
		0xc78b
		},
		{
		0xc78c
		},
		{
		0xc78d
		},
		{
		0xc78f
		},
		{
		0xc792
		},
		{
		0xc793
		},
		{
		0xc795
		},
		{
		0xc799
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_191[]=
	{
		{
		0xc74b
		},
		{
		0xc74e
		},
		{
		0xc750
		},
		{
		0xc759
		},
		{
		0xc75a
		},
		{
		0xc75b
		},
		{
		0xc75d
		},
		{
		0xc75e
		},
		{
		0xc75f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_192[]=
	{
		{
		0xc732
		},
		{
		0xc734
		},
		{
		0xc736
		},
		{
		0xc738
		},
		{
		0xc739
		},
		{
		0xc73a
		},
		{
		0xc73b
		},
		{
		0xc73e
		},
		{
		0xc73f
		},
		{
		0xc741
		},
		{
		0xc742
		},
		{
		0xc743
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_193[]=
	{
		{
		0xc722
		},
		{
		0xc723
		},
		{
		0xc725
		},
		{
		0xc726
		},
		{
		0xc727
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_194[]=
	{
		{
		0xc706
		},
		{
		0xc707
		},
		{
		0xc709
		},
		{
		0xc70a
		},
		{
		0xc70b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_195[]=
	{
		{
		0xc6ea
		},
		{
		0xc6eb
		},
		{
		0xc6ed
		},
		{
		0xc6ee
		},
		{
		0xc6ef
		},
		{
		0xc6f1
		},
		{
		0xc6f2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_196[]=
	{
		{
		0xc6b2
		},
		{
		0xc6b3
		},
		{
		0xc6b5
		},
		{
		0xc6b6
		},
		{
		0xc6b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_197[]=
	{
		{
		0xc696
		},
		{
		0xc697
		},
		{
		0xc699
		},
		{
		0xc69a
		},
		{
		0xc69b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_198[]=
	{
		{
		0xc67a
		},
		{
		0xc67b
		},
		{
		0xc67d
		},
		{
		0xc67e
		},
		{
		0xc67f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_199[]=
	{
		{
		0xc626
		},
		{
		0xc627
		},
		{
		0xc629
		},
		{
		0xc62a
		},
		{
		0xc62b
		},
		{
		0xc62f
		},
		{
		0xc631
		},
		{
		0xc632
		},
		{
		0xc636
		},
		{
		0xc638
		},
		{
		0xc63a
		},
		{
		0xc63c
		},
		{
		0xc63d
		},
		{
		0xc63e
		},
		{
		0xc63f
		},
		{
		0xc642
		},
		{
		0xc643
		},
		{
		0xc645
		},
		{
		0xc646
		},
		{
		0xc647
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_200[]=
	{
		{
		0xc5e8
		},
		{
		0xc5e9
		},
		{
		0xc5ea
		},
		{
		0xc5eb
		},
		{
		0xc5ef
		},
		{
		0xc5f1
		},
		{
		0xc5f2
		},
		{
		0xc5f3
		},
		{
		0xc5f5
		},
		{
		0xc5f8
		},
		{
		0xc5f9
		},
		{
		0xc5fa
		},
		{
		0xc5fb
		},
		{
		0xc602
		},
		{
		0xc603
		},
		{
		0xc604
		},
		{
		0xc609
		},
		{
		0xc60a
		},
		{
		0xc60b
		},
		{
		0xc60d
		},
		{
		0xc60e
		},
		{
		0xc60f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_201[]=
	{
		{
		0xc5cb
		},
		{
		0xc5cd
		},
		{
		0xc5cf
		},
		{
		0xc5d2
		},
		{
		0xc5d3
		},
		{
		0xc5d5
		},
		{
		0xc5d6
		},
		{
		0xc5d7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_202[]=
	{
		{
		0xc596
		},
		{
		0xc599
		},
		{
		0xc59a
		},
		{
		0xc59b
		},
		{
		0xc59d
		},
		{
		0xc59e
		},
		{
		0xc59f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_203[]=
	{
		{
		0xc57e
		},
		{
		0xc57f
		},
		{
		0xc581
		},
		{
		0xc582
		},
		{
		0xc583
		},
		{
		0xc585
		},
		{
		0xc586
		},
		{
		0xc588
		},
		{
		0xc589
		},
		{
		0xc58a
		},
		{
		0xc58b
		},
		{
		0xc58e
		},
		{
		0xc590
		},
		{
		0xc592
		},
		{
		0xc593
		},
		{
		0xc594
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_204[]=
	{
		{
		0xc546
		},
		{
		0xc547
		},
		{
		0xc54b
		},
		{
		0xc54f
		},
		{
		0xc550
		},
		{
		0xc551
		},
		{
		0xc552
		},
		{
		0xc556
		},
		{
		0xc55a
		},
		{
		0xc55b
		},
		{
		0xc55c
		},
		{
		0xc55f
		},
		{
		0xc562
		},
		{
		0xc563
		},
		{
		0xc565
		},
		{
		0xc566
		},
		{
		0xc567
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_205[]=
	{
		{
		0xc52a
		},
		{
		0xc52b
		},
		{
		0xc52d
		},
		{
		0xc52e
		},
		{
		0xc52f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_206[]=
	{
		{
		0xc50d
		},
		{
		0xc50e
		},
		{
		0xc50f
		},
		{
		0xc511
		},
		{
		0xc512
		},
		{
		0xc513
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_207[]=
	{
		{
		0xc4f2
		},
		{
		0xc4f3
		},
		{
		0xc4f5
		},
		{
		0xc4f6
		},
		{
		0xc4f7
		},
		{
		0xc4f9
		},
		{
		0xc4fb
		},
		{
		0xc4fc
		},
		{
		0xc4fd
		},
		{
		0xc4fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_208[]=
	{
		{
		0xc466
		},
		{
		0xc467
		},
		{
		0xc469
		},
		{
		0xc46a
		},
		{
		0xc46b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_209[]=
	{
		{
		0xc42d
		},
		{
		0xc42e
		},
		{
		0xc42f
		},
		{
		0xc431
		},
		{
		0xc432
		},
		{
		0xc433
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_210[]=
	{
		{
		0xc385
		},
		{
		0xc386
		},
		{
		0xc387
		},
		{
		0xc389
		},
		{
		0xc38a
		},
		{
		0xc38b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_211[]=
	{
		{
		0xc36a
		},
		{
		0xc36b
		},
		{
		0xc36d
		},
		{
		0xc36e
		},
		{
		0xc36f
		},
		{
		0xc371
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_212[]=
	{
		{
		0xc310
		},
		{
		0xc311
		},
		{
		0xc312
		},
		{
		0xc316
		},
		{
		0xc317
		},
		{
		0xc319
		},
		{
		0xc31a
		},
		{
		0xc31b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_213[]=
	{
		{
		0xc2ee
		},
		{
		0xc2f0
		},
		{
		0xc2f2
		},
		{
		0xc2f3
		},
		{
		0xc2f4
		},
		{
		0xc2f5
		},
		{
		0xc2f7
		},
		{
		0xc2fa
		},
		{
		0xc2fd
		},
		{
		0xc2fe
		},
		{
		0xc2ff
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_214[]=
	{
		{
		0xc2a6
		},
		{
		0xc2a7
		},
		{
		0xc2a9
		},
		{
		0xc2aa
		},
		{
		0xc2ab
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_215[]=
	{
		{
		0xc26e
		},
		{
		0xc26f
		},
		{
		0xc271
		},
		{
		0xc272
		},
		{
		0xc273
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_216[]=
	{
		{
		0xc261
		},
		{
		0xc262
		},
		{
		0xc263
		},
		{
		0xc264
		},
		{
		0xc266
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_217[]=
	{
		{
		0xc252
		},
		{
		0xc253
		},
		{
		0xc255
		},
		{
		0xc256
		},
		{
		0xc257
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_218[]=
	{
		{
		0xc224
		},
		{
		0xc225
		},
		{
		0xc226
		},
		{
		0xc227
		},
		{
		0xc22a
		},
		{
		0xc22c
		},
		{
		0xc22e
		},
		{
		0xc230
		},
		{
		0xc233
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_219[]=
	{
		{
		0xc21a
		},
		{
		0xc21b
		},
		{
		0xc21d
		},
		{
		0xc21e
		},
		{
		0xc221
		},
		{
		0xc222
		},
		{
		0xc223
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_220[]=
	{
		{
		0xc1fe
		},
		{
		0xc1ff
		},
		{
		0xc201
		},
		{
		0xc202
		},
		{
		0xc203
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_221[]=
	{
		{
		0xc1e1
		},
		{
		0xc1e2
		},
		{
		0xc1e3
		},
		{
		0xc1e5
		},
		{
		0xc1e6
		},
		{
		0xc1e7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_222[]=
	{
		{
		0xc1c5
		},
		{
		0xc1c6
		},
		{
		0xc1c7
		},
		{
		0xc1c9
		},
		{
		0xc1ca
		},
		{
		0xc1cb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_223[]=
	{
		{
		0xc19e
		},
		{
		0xc1a0
		},
		{
		0xc1a2
		},
		{
		0xc1a3
		},
		{
		0xc1a4
		},
		{
		0xc1a6
		},
		{
		0xc1a7
		},
		{
		0xc1aa
		},
		{
		0xc1ab
		},
		{
		0xc1ad
		},
		{
		0xc1ae
		},
		{
		0xc1af
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_224[]=
	{
		{
		0xc18f
		},
		{
		0xc191
		},
		{
		0xc192
		},
		{
		0xc193
		},
		{
		0xc195
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_225[]=
	{
		{
		0xc171
		},
		{
		0xc172
		},
		{
		0xc173
		},
		{
		0xc175
		},
		{
		0xc176
		},
		{
		0xc177
		},
		{
		0xc179
		},
		{
		0xc17a
		},
		{
		0xc17b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_226[]=
	{
		{
		0xc132
		},
		{
		0xc133
		},
		{
		0xc134
		},
		{
		0xc135
		},
		{
		0xc137
		},
		{
		0xc13a
		},
		{
		0xc13b
		},
		{
		0xc13d
		},
		{
		0xc13e
		},
		{
		0xc13f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_227[]=
	{
		{
		0xc121
		},
		{
		0xc122
		},
		{
		0xc125
		},
		{
		0xc128
		},
		{
		0xc129
		},
		{
		0xc12a
		},
		{
		0xc12b
		},
		{
		0xc12e
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_228[]=
	{
		{
		0xc101
		},
		{
		0xc102
		},
		{
		0xc103
		},
		{
		0xc105
		},
		{
		0xc106
		},
		{
		0xc107
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_229[]=
	{
		{
		0xc0e6
		},
		{
		0xc0e7
		},
		{
		0xc0e9
		},
		{
		0xc0ea
		},
		{
		0xc0eb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_230[]=
	{
		{
		0xc0be
		},
		{
		0xc0c2
		},
		{
		0xc0c3
		},
		{
		0xc0c4
		},
		{
		0xc0c6
		},
		{
		0xc0c7
		},
		{
		0xc0ca
		},
		{
		0xc0cb
		},
		{
		0xc0cd
		},
		{
		0xc0ce
		},
		{
		0xc0cf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_231[]=
	{
		{
		0xc092
		},
		{
		0xc093
		},
		{
		0xc095
		},
		{
		0xc096
		},
		{
		0xc097
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_232[]=
	{
		{
		0xbfce
		},
		{
		0xbfcf
		},
		{
		0xbfd1
		},
		{
		0xbfd2
		},
		{
		0xbfd3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_233[]=
	{
		{
		0xbf42
		},
		{
		0xbf43
		},
		{
		0xbf45
		},
		{
		0xbf46
		},
		{
		0xbf47
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_234[]=
	{
		{
		0xbe7e
		},
		{
		0xbe7f
		},
		{
		0xbe81
		},
		{
		0xbe82
		},
		{
		0xbe83
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_235[]=
	{
		{
		0xbe56
		},
		{
		0xbe58
		},
		{
		0xbe5c
		},
		{
		0xbe5d
		},
		{
		0xbe5e
		},
		{
		0xbe5f
		},
		{
		0xbe62
		},
		{
		0xbe63
		},
		{
		0xbe65
		},
		{
		0xbe66
		},
		{
		0xbe67
		},
		{
		0xbe69
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_236[]=
	{
		{
		0xbe46
		},
		{
		0xbe47
		},
		{
		0xbe49
		},
		{
		0xbe4a
		},
		{
		0xbe4b
		},
		{
		0xbe4d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_237[]=
	{
		{
		0xbe0e
		},
		{
		0xbe0f
		},
		{
		0xbe11
		},
		{
		0xbe12
		},
		{
		0xbe13
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_238[]=
	{
		{
		0xbdf2
		},
		{
		0xbdf3
		},
		{
		0xbdf5
		},
		{
		0xbdf6
		},
		{
		0xbdf7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_239[]=
	{
		{
		0xbdd2
		},
		{
		0xbdd3
		},
		{
		0xbdd6
		},
		{
		0xbdd7
		},
		{
		0xbdd9
		},
		{
		0xbdda
		},
		{
		0xbddb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_240[]=
	{
		{
		0xbd92
		},
		{
		0xbd94
		},
		{
		0xbd96
		},
		{
		0xbd97
		},
		{
		0xbd98
		},
		{
		0xbd9b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_241[]=
	{
		{
		0xbd4a
		},
		{
		0xbd4b
		},
		{
		0xbd4d
		},
		{
		0xbd4e
		},
		{
		0xbd4f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_242[]=
	{
		{
		0xbcf7
		},
		{
		0xbcf9
		},
		{
		0xbcfa
		},
		{
		0xbcfb
		},
		{
		0xbcfd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_243[]=
	{
		{
		0xbcce
		},
		{
		0xbcd2
		},
		{
		0xbcd3
		},
		{
		0xbcd4
		},
		{
		0xbcd6
		},
		{
		0xbcd7
		},
		{
		0xbcd9
		},
		{
		0xbcda
		},
		{
		0xbcdb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_244[]=
	{
		{
		0xbcbe
		},
		{
		0xbcbf
		},
		{
		0xbcc1
		},
		{
		0xbcc2
		},
		{
		0xbcc3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_245[]=
	{
		{
		0xbc86
		},
		{
		0xbc87
		},
		{
		0xbc89
		},
		{
		0xbc8a
		},
		{
		0xbc8d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_246[]=
	{
		{
		0xbc42
		},
		{
		0xbc46
		},
		{
		0xbc47
		},
		{
		0xbc48
		},
		{
		0xbc4a
		},
		{
		0xbc4b
		},
		{
		0xbc4e
		},
		{
		0xbc4f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_247[]=
	{
		{
		0xbc0a
		},
		{
		0xbc0e
		},
		{
		0xbc10
		},
		{
		0xbc12
		},
		{
		0xbc13
		},
		{
		0xbc19
		},
		{
		0xbc1a
		},
		{
		0xbc20
		},
		{
		0xbc21
		},
		{
		0xbc22
		},
		{
		0xbc23
		},
		{
		0xbc26
		},
		{
		0xbc28
		},
		{
		0xbc2a
		},
		{
		0xbc2b
		},
		{
		0xbc2c
		},
		{
		0xbc2e
		},
		{
		0xbc2f
		},
		{
		0xbc32
		},
		{
		0xbc33
		},
		{
		0xbc35
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_248[]=
	{
		{
		0xbbfa
		},
		{
		0xbbfb
		},
		{
		0xbbfd
		},
		{
		0xbbfe
		},
		{
		0xbc01
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_249[]=
	{
		{
		0xbbc1
		},
		{
		0xbbc2
		},
		{
		0xbbc3
		},
		{
		0xbbc5
		},
		{
		0xbbc6
		},
		{
		0xbbc7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_250[]=
	{
		{
		0xbba5
		},
		{
		0xbba6
		},
		{
		0xbba7
		},
		{
		0xbba9
		},
		{
		0xbbaa
		},
		{
		0xbbab
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_251[]=
	{
		{
		0xbb89
		},
		{
		0xbb8a
		},
		{
		0xbb8b
		},
		{
		0xbb8d
		},
		{
		0xbb8e
		},
		{
		0xbb8f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_252[]=
	{
		{
		0xbb46
		},
		{
		0xbb48
		},
		{
		0xbb4a
		},
		{
		0xbb4b
		},
		{
		0xbb4c
		},
		{
		0xbb4e
		},
		{
		0xbb51
		},
		{
		0xbb52
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_253[]=
	{
		{
		0xbb19
		},
		{
		0xbb1a
		},
		{
		0xbb1b
		},
		{
		0xbb1d
		},
		{
		0xbb1e
		},
		{
		0xbb1f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_254[]=
	{
		{
		0xbafd
		},
		{
		0xbafe
		},
		{
		0xbaff
		},
		{
		0xbb01
		},
		{
		0xbb02
		},
		{
		0xbb03
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_255[]=
	{
		{
		0xbaaa
		},
		{
		0xbaad
		},
		{
		0xbaae
		},
		{
		0xbaaf
		},
		{
		0xbab1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_256[]=
	{
		{
		0xba86
		},
		{
		0xba88
		},
		{
		0xba89
		},
		{
		0xba8a
		},
		{
		0xba8b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_257[]=
	{
		{
		0xba72
		},
		{
		0xba73
		},
		{
		0xba75
		},
		{
		0xba76
		},
		{
		0xba77
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_258[]=
	{
		{
		0xba47
		},
		{
		0xba4a
		},
		{
		0xba4c
		},
		{
		0xba4f
		},
		{
		0xba50
		},
		{
		0xba51
		},
		{
		0xba52
		},
		{
		0xba56
		},
		{
		0xba57
		},
		{
		0xba59
		},
		{
		0xba5a
		},
		{
		0xba5b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_259[]=
	{
		{
		0xba3a
		},
		{
		0xba3b
		},
		{
		0xba3d
		},
		{
		0xba3e
		},
		{
		0xba3f
		},
		{
		0xba41
		},
		{
		0xba43
		},
		{
		0xba44
		},
		{
		0xba45
		},
		{
		0xba46
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_260[]=
	{
		{
		0xb9da
		},
		{
		0xb9dc
		},
		{
		0xb9df
		},
		{
		0xb9e0
		},
		{
		0xb9e2
		},
		{
		0xb9e6
		},
		{
		0xb9e7
		},
		{
		0xb9e9
		},
		{
		0xb9ea
		},
		{
		0xb9eb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_261[]=
	{
		{
		0xb9ae
		},
		{
		0xb9af
		},
		{
		0xb9b1
		},
		{
		0xb9b2
		},
		{
		0xb9b3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_262[]=
	{
		{
		0xb976
		},
		{
		0xb977
		},
		{
		0xb979
		},
		{
		0xb97a
		},
		{
		0xb97b
		},
		{
		0xb97d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_263[]=
	{
		{
		0xb95a
		},
		{
		0xb95b
		},
		{
		0xb95d
		},
		{
		0xb95e
		},
		{
		0xb95f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_264[]=
	{
		{
		0xb93e
		},
		{
		0xb93f
		},
		{
		0xb941
		},
		{
		0xb942
		},
		{
		0xb943
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_265[]=
	{
		{
		0xb8ea
		},
		{
		0xb8eb
		},
		{
		0xb8ed
		},
		{
		0xb8ee
		},
		{
		0xb8ef
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_266[]=
	{
		{
		0xb8cd
		},
		{
		0xb8ce
		},
		{
		0xb8cf
		},
		{
		0xb8d1
		},
		{
		0xb8d2
		},
		{
		0xb8d3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_267[]=
	{
		{
		0xb8b1
		},
		{
		0xb8b2
		},
		{
		0xb8b3
		},
		{
		0xb8b5
		},
		{
		0xb8b6
		},
		{
		0xb8b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_268[]=
	{
		{
		0xb85e
		},
		{
		0xb85f
		},
		{
		0xb861
		},
		{
		0xb862
		},
		{
		0xb863
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_269[]=
	{
		{
		0xb826
		},
		{
		0xb827
		},
		{
		0xb829
		},
		{
		0xb82a
		},
		{
		0xb82b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_270[]=
	{
		{
		0xb80a
		},
		{
		0xb80b
		},
		{
		0xb80d
		},
		{
		0xb80e
		},
		{
		0xb80f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_271[]=
	{
		{
		0xb7ee
		},
		{
		0xb7ef
		},
		{
		0xb7f1
		},
		{
		0xb7f2
		},
		{
		0xb7f3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_272[]=
	{
		{
		0xb78e
		},
		{
		0xb793
		},
		{
		0xb794
		},
		{
		0xb795
		},
		{
		0xb79a
		},
		{
		0xb79b
		},
		{
		0xb79d
		},
		{
		0xb79e
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_273[]=
	{
		{
		0xb77e
		},
		{
		0xb77f
		},
		{
		0xb781
		},
		{
		0xb782
		},
		{
		0xb783
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_274[]=
	{
		{
		0xb761
		},
		{
		0xb762
		},
		{
		0xb763
		},
		{
		0xb765
		},
		{
		0xb766
		},
		{
		0xb767
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_275[]=
	{
		{
		0xb745
		},
		{
		0xb746
		},
		{
		0xb747
		},
		{
		0xb749
		},
		{
		0xb74a
		},
		{
		0xb74b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_276[]=
	{
		{
		0xb6f1
		},
		{
		0xb6f2
		},
		{
		0xb6f3
		},
		{
		0xb6f5
		},
		{
		0xb6f6
		},
		{
		0xb6f7
		},
		{
		0xb6f9
		},
		{
		0xb6fa
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_277[]=
	{
		{
		0xb69e
		},
		{
		0xb69f
		},
		{
		0xb6a1
		},
		{
		0xb6a2
		},
		{
		0xb6a3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_278[]=
	{
		{
		0xb612
		},
		{
		0xb613
		},
		{
		0xb615
		},
		{
		0xb616
		},
		{
		0xb617
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_279[]=
	{
		{
		0xb5be
		},
		{
		0xb5bf
		},
		{
		0xb5c1
		},
		{
		0xb5c2
		},
		{
		0xb5c3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_280[]=
	{
		{
		0xb5a2
		},
		{
		0xb5a3
		},
		{
		0xb5a5
		},
		{
		0xb5a6
		},
		{
		0xb5a7
		},
		{
		0xb5a9
		},
		{
		0xb5ac
		},
		{
		0xb5ad
		},
		{
		0xb5ae
		},
		{
		0xb5af
		},
		{
		0xb5b2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_281[]=
	{
		{
		0xb547
		},
		{
		0xb548
		},
		{
		0xb549
		},
		{
		0xb54a
		},
		{
		0xb54e
		},
		{
		0xb54f
		},
		{
		0xb551
		},
		{
		0xb552
		},
		{
		0xb553
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_282[]=
	{
		{
		0xb532
		},
		{
		0xb533
		},
		{
		0xb535
		},
		{
		0xb536
		},
		{
		0xb537
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_283[]=
	{
		{
		0xb516
		},
		{
		0xb517
		},
		{
		0xb519
		},
		{
		0xb51a
		},
		{
		0xb51d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_284[]=
	{
		{
		0xb4de
		},
		{
		0xb4df
		},
		{
		0xb4e1
		},
		{
		0xb4e2
		},
		{
		0xb4e5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_285[]=
	{
		{
		0xb4c1
		},
		{
		0xb4c2
		},
		{
		0xb4c3
		},
		{
		0xb4c5
		},
		{
		0xb4c6
		},
		{
		0xb4c7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_286[]=
	{
		{
		0xb4a5
		},
		{
		0xb4a6
		},
		{
		0xb4a7
		},
		{
		0xb4a9
		},
		{
		0xb4aa
		},
		{
		0xb4ab
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_287[]=
	{
		{
		0xb452
		},
		{
		0xb453
		},
		{
		0xb455
		},
		{
		0xb456
		},
		{
		0xb457
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_288[]=
	{
		{
		0xb419
		},
		{
		0xb41a
		},
		{
		0xb41b
		},
		{
		0xb41d
		},
		{
		0xb41e
		},
		{
		0xb41f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_289[]=
	{
		{
		0xb3c6
		},
		{
		0xb3c7
		},
		{
		0xb3c9
		},
		{
		0xb3ca
		},
		{
		0xb3cd
		},
		{
		0xb3cf
		},
		{
		0xb3d1
		},
		{
		0xb3d2
		},
		{
		0xb3d3
		},
		{
		0xb3d6
		},
		{
		0xb3d8
		},
		{
		0xb3da
		},
		{
		0xb3dc
		},
		{
		0xb3de
		},
		{
		0xb3df
		},
		{
		0xb3e1
		},
		{
		0xb3e2
		},
		{
		0xb3e3
		},
		{
		0xb3e5
		},
		{
		0xb3e6
		},
		{
		0xb3e7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_290[]=
	{
		{
		0xb38e
		},
		{
		0xb38f
		},
		{
		0xb391
		},
		{
		0xb392
		},
		{
		0xb393
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_291[]=
	{
		{
		0xb366
		},
		{
		0xb368
		},
		{
		0xb36a
		},
		{
		0xb36c
		},
		{
		0xb36d
		},
		{
		0xb36f
		},
		{
		0xb372
		},
		{
		0xb373
		},
		{
		0xb375
		},
		{
		0xb376
		},
		{
		0xb377
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_292[]=
	{
		{
		0xb357
		},
		{
		0xb359
		},
		{
		0xb35a
		},
		{
		0xb35d
		},
		{
		0xb360
		},
		{
		0xb361
		},
		{
		0xb362
		},
		{
		0xb363
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_293[]=
	{
		{
		0xb2da
		},
		{
		0xb2dc
		},
		{
		0xb2de
		},
		{
		0xb2df
		},
		{
		0xb2e0
		},
		{
		0xb2e1
		},
		{
		0xb2e3
		},
		{
		0xb2e7
		},
		{
		0xb2e9
		},
		{
		0xb2ea
		},
		{
		0xb2f0
		},
		{
		0xb2f1
		},
		{
		0xb2f2
		},
		{
		0xb2f6
		},
		{
		0xb2fc
		},
		{
		0xb2fd
		},
		{
		0xb2fe
		},
		{
		0xb302
		},
		{
		0xb303
		},
		{
		0xb305
		},
		{
		0xb306
		},
		{
		0xb307
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_294[]=
	{
		{
		0xb2ca
		},
		{
		0xb2cb
		},
		{
		0xb2cd
		},
		{
		0xb2ce
		},
		{
		0xb2cf
		},
		{
		0xb2d1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_295[]=
	{
		{
		0xb2a2
		},
		{
		0xb2a4
		},
		{
		0xb2a7
		},
		{
		0xb2a8
		},
		{
		0xb2a9
		},
		{
		0xb2ab
		},
		{
		0xb2ad
		},
		{
		0xb2ae
		},
		{
		0xb2af
		},
		{
		0xb2b1
		},
		{
		0xb2b2
		},
		{
		0xb2b3
		},
		{
		0xb2b5
		},
		{
		0xb2b6
		},
		{
		0xb2b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_296[]=
	{
		{
		0xb28f
		},
		{
		0xb292
		},
		{
		0xb293
		},
		{
		0xb295
		},
		{
		0xb296
		},
		{
		0xb297
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_297[]=
	{
		{
		0xb259
		},
		{
		0xb25a
		},
		{
		0xb25b
		},
		{
		0xb25d
		},
		{
		0xb25e
		},
		{
		0xb25f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_298[]=
	{
		{
		0xb1ea
		},
		{
		0xb1eb
		},
		{
		0xb1ed
		},
		{
		0xb1ee
		},
		{
		0xb1ef
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_299[]=
	{
		{
		0xb1cd
		},
		{
		0xb1ce
		},
		{
		0xb1cf
		},
		{
		0xb1d1
		},
		{
		0xb1d2
		},
		{
		0xb1d3
		},
		{
		0xb1d5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_300[]=
	{
		{
		0xb18a
		},
		{
		0xb18c
		},
		{
		0xb18e
		},
		{
		0xb18f
		},
		{
		0xb190
		},
		{
		0xb191
		},
		{
		0xb195
		},
		{
		0xb196
		},
		{
		0xb197
		},
		{
		0xb199
		},
		{
		0xb19a
		},
		{
		0xb19b
		},
		{
		0xb19d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_301[]=
	{
		{
		0xb17a
		},
		{
		0xb17b
		},
		{
		0xb17d
		},
		{
		0xb17e
		},
		{
		0xb17f
		},
		{
		0xb181
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_302[]=
	{
		{
		0xb152
		},
		{
		0xb153
		},
		{
		0xb156
		},
		{
		0xb157
		},
		{
		0xb159
		},
		{
		0xb15a
		},
		{
		0xb15b
		},
		{
		0xb15d
		},
		{
		0xb15e
		},
		{
		0xb15f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_303[]=
	{
		{
		0xb142
		},
		{
		0xb143
		},
		{
		0xb145
		},
		{
		0xb146
		},
		{
		0xb147
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_304[]=
	{
		{
		0xb126
		},
		{
		0xb127
		},
		{
		0xb129
		},
		{
		0xb12a
		},
		{
		0xb12b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_305[]=
	{
		{
		0xb10a
		},
		{
		0xb10d
		},
		{
		0xb10e
		},
		{
		0xb10f
		},
		{
		0xb111
		},
		{
		0xb114
		},
		{
		0xb115
		},
		{
		0xb116
		},
		{
		0xb117
		},
		{
		0xb11a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_306[]=
	{
		{
		0xb0a5
		},
		{
		0xb0a6
		},
		{
		0xb0a7
		},
		{
		0xb0aa
		},
		{
		0xb0b0
		},
		{
		0xb0b2
		},
		{
		0xb0b6
		},
		{
		0xb0b7
		},
		{
		0xb0b9
		},
		{
		0xb0ba
		},
		{
		0xb0bb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_307[]=
	{
		{
		0xb09b
		},
		{
		0xb09d
		},
		{
		0xb09e
		},
		{
		0xb0a3
		},
		{
		0xb0a4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_308[]=
	{
		{
		0xb07e
		},
		{
		0xb07f
		},
		{
		0xb081
		},
		{
		0xb082
		},
		{
		0xb083
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_309[]=
	{
		{
		0xb046
		},
		{
		0xb047
		},
		{
		0xb049
		},
		{
		0xb04b
		},
		{
		0xb04d
		},
		{
		0xb04f
		},
		{
		0xb050
		},
		{
		0xb051
		},
		{
		0xb052
		},
		{
		0xb056
		},
		{
		0xb058
		},
		{
		0xb05a
		},
		{
		0xb05b
		},
		{
		0xb05c
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_310[]=
	{
		{
		0xb00d
		},
		{
		0xb00e
		},
		{
		0xb00f
		},
		{
		0xb011
		},
		{
		0xb012
		},
		{
		0xb013
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_311[]=
	{
		{
		0xaff2
		},
		{
		0xaff3
		},
		{
		0xaff5
		},
		{
		0xaff6
		},
		{
		0xaff7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_312[]=
	{
		{
		0xaf81
		},
		{
		0xaf82
		},
		{
		0xaf83
		},
		{
		0xaf85
		},
		{
		0xaf86
		},
		{
		0xaf87
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_313[]=
	{
		{
		0xaf3e
		},
		{
		0xaf40
		},
		{
		0xaf44
		},
		{
		0xaf45
		},
		{
		0xaf46
		},
		{
		0xaf47
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_314[]=
	{
		{
		0xaf06
		},
		{
		0xaf09
		},
		{
		0xaf0a
		},
		{
		0xaf0b
		},
		{
		0xaf0c
		},
		{
		0xaf0e
		},
		{
		0xaf0f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_315[]=
	{
		{
		0xaef5
		},
		{
		0xaef6
		},
		{
		0xaef7
		},
		{
		0xaef9
		},
		{
		0xaefa
		},
		{
		0xaefb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_316[]=
	{
		{
		0xaee6
		},
		{
		0xaee7
		},
		{
		0xaee9
		},
		{
		0xaeea
		},
		{
		0xaeec
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_317[]=
	{
		{
		0xae5e
		},
		{
		0xae62
		},
		{
		0xae63
		},
		{
		0xae64
		},
		{
		0xae66
		},
		{
		0xae67
		},
		{
		0xae6a
		},
		{
		0xae6b
		},
		{
		0xae6d
		},
		{
		0xae6e
		},
		{
		0xae6f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_318[]=
	{
		{
		0xae3d
		},
		{
		0xae3e
		},
		{
		0xae3f
		},
		{
		0xae42
		},
		{
		0xae44
		},
		{
		0xae47
		},
		{
		0xae48
		},
		{
		0xae49
		},
		{
		0xae4b
		},
		{
		0xae4f
		},
		{
		0xae51
		},
		{
		0xae52
		},
		{
		0xae53
		},
		{
		0xae55
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_319[]=
	{
		{
		0xae32
		},
		{
		0xae33
		},
		{
		0xae35
		},
		{
		0xae36
		},
		{
		0xae39
		},
		{
		0xae3b
		},
		{
		0xae3c
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_320[]=
	{
		{
		0xaddd
		},
		{
		0xadde
		},
		{
		0xaddf
		},
		{
		0xade1
		},
		{
		0xade2
		},
		{
		0xade3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_321[]=
	{
		{
		0xadc2
		},
		{
		0xadc3
		},
		{
		0xadc5
		},
		{
		0xadc6
		},
		{
		0xadc7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_322[]=
	{
		{
		0xad8a
		},
		{
		0xad8b
		},
		{
		0xad8d
		},
		{
		0xad8e
		},
		{
		0xad8f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_323[]=
	{
		{
		0xad6e
		},
		{
		0xad6f
		},
		{
		0xad71
		},
		{
		0xad72
		},
		{
		0xad77
		},
		{
		0xad78
		},
		{
		0xad79
		},
		{
		0xad7a
		},
		{
		0xad7e
		},
		{
		0xad80
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_324[]=
	{
		{
		0xad51
		},
		{
		0xad52
		},
		{
		0xad53
		},
		{
		0xad55
		},
		{
		0xad56
		},
		{
		0xad57
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_325[]=
	{
		{
		0xad36
		},
		{
		0xad37
		},
		{
		0xad39
		},
		{
		0xad3a
		},
		{
		0xad3b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_326[]=
	{
		{
		0xad14
		},
		{
		0xad15
		},
		{
		0xad16
		},
		{
		0xad17
		},
		{
		0xad19
		},
		{
		0xad1a
		},
		{
		0xad1b
		},
		{
		0xad1d
		},
		{
		0xad1e
		},
		{
		0xad1f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_327[]=
	{
		{
		0xacfe
		},
		{
		0xacff
		},
		{
		0xad01
		},
		{
		0xad02
		},
		{
		0xad03
		},
		{
		0xad05
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_328[]=
	{
		{
		0xace2
		},
		{
		0xace3
		},
		{
		0xace5
		},
		{
		0xace6
		},
		{
		0xace9
		},
		{
		0xaceb
		},
		{
		0xaced
		},
		{
		0xacee
		},
		{
		0xacf2
		},
		{
		0xacf4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_329[]=
	{
		{
		0xacba
		},
		{
		0xacbe
		},
		{
		0xacbf
		},
		{
		0xacc0
		},
		{
		0xacc2
		},
		{
		0xacc3
		},
		{
		0xacc5
		},
		{
		0xacc6
		},
		{
		0xacc7
		},
		{
		0xacc9
		},
		{
		0xacca
		},
		{
		0xaccb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_330[]=
	{
		{
		0xac82
		},
		{
		0xac87
		},
		{
		0xac88
		},
		{
		0xac8d
		},
		{
		0xac8e
		},
		{
		0xac8f
		},
		{
		0xac91
		},
		{
		0xac92
		},
		{
		0xac93
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_331[]=
	{
		{
		0xac72
		},
		{
		0xac73
		},
		{
		0xac75
		},
		{
		0xac76
		},
		{
		0xac79
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_332[]=
	{
		{
		0xac56
		},
		{
		0xac57
		},
		{
		0xac59
		},
		{
		0xac5a
		},
		{
		0xac5b
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_333[]=
	{
		{
		0xac35
		},
		{
		0xac36
		},
		{
		0xac37
		},
		{
		0xac3a
		},
		{
		0xac3b
		},
		{
		0xac3d
		},
		{
		0xac3e
		},
		{
		0xac3f
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_foreignToUnicode_334[]=
	{
		{
		0xac18
		},
		{
		0xac1e
		},
		{
		0xac1f
		},
		{
		0xac21
		},
		{
		0xac22
		},
		{
		0xac23
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SKeyedTable1616::SEntry keyedTable1616_foreignToUnicode_1[]=
	{
		{
		0x8141,
		0xac02
		},
		{
		0x8142,
		0xac03
		},
		{
		0x8143,
		0xac05
		},
		{
		0x8144,
		0xac06
		},
		{
		0x8157,
		0xac2e
		},
		{
		0x8158,
		0xac32
		},
		{
		0x8159,
		0xac33
		},
		{
		0x815a,
		0xac34
		},
		{
		0x8173,
		0xac4c
		},
		{
		0x817a,
		0xac55
		},
		{
		0x81b3,
		0xac9e
		},
		{
		0x81ba,
		0xacab
		},
		{
		0x81bb,
		0xacad
		},
		{
		0x81bc,
		0xacae
		},
		{
		0x81d8,
		0xacd6
		},
		{
		0x81fb,
		0xad0e
		},
		{
		0x81fc,
		0xad10
		},
		{
		0x81fd,
		0xad12
		},
		{
		0x81fe,
		0xad13
		},
		{
		0x8253,
		0xad2a
		},
		{
		0x8254,
		0xad2b
		},
		{
		0x826d,
		0xad46
		},
		{
		0x826e,
		0xad48
		},
		{
		0x8289,
		0xad62
		},
		{
		0x82dd,
		0xadd2
		},
		{
		0x8341,
		0xadfa
		},
		{
		0x8342,
		0xadfb
		},
		{
		0x8343,
		0xadfd
		},
		{
		0x8344,
		0xadfe
		},
		{
		0x834b,
		0xae0a
		},
		{
		0x834c,
		0xae0c
		},
		{
		0x83a6,
		0xae7a
		},
		{
		0x83e2,
		0xaebf
		},
		{
		0x83e3,
		0xaec1
		},
		{
		0x83e4,
		0xaec2
		},
		{
		0x83e5,
		0xaec3
		},
		{
		0x83ed,
		0xaece
		},
		{
		0x83f4,
		0xaeda
		},
		{
		0x83f5,
		0xaedb
		},
		{
		0x8489,
		0xaf2e
		},
		{
		0x848a,
		0xaf2f
		},
		{
		0x848b,
		0xaf31
		},
		{
		0x848c,
		0xaf33
		},
		{
		0x84d7,
		0xaf92
		},
		{
		0x84d8,
		0xaf93
		},
		{
		0x84d9,
		0xaf94
		},
		{
		0x84fb,
		0xafba
		},
		{
		0x84fc,
		0xafbb
		},
		{
		0x84fd,
		0xafbd
		},
		{
		0x84fe,
		0xafbe
		},
		{
		0x8541,
		0xafbf
		},
		{
		0x8548,
		0xafca
		},
		{
		0x8549,
		0xafcc
		},
		{
		0x8579,
		0xb002
		},
		{
		0x857a,
		0xb003
		},
		{
		0x85f2,
		0xb08e
		},
		{
		0x85f3,
		0xb090
		},
		{
		0x8653,
		0xb0c6
		},
		{
		0x865a,
		0xb0d2
		},
		{
		0x8661,
		0xb0d3
		},
		{
		0x8662,
		0xb0d5
		},
		{
		0x8663,
		0xb0d6
		},
		{
		0x8664,
		0xb0d7
		},
		{
		0x866c,
		0xb0e1
		},
		{
		0x866d,
		0xb0e2
		},
		{
		0x866e,
		0xb0e3
		},
		{
		0x866f,
		0xb0e4
		},
		{
		0x86b3,
		0xb136
		},
		{
		0x8787,
		0xb1de
		},
		{
		0x879d,
		0xb1fa
		},
		{
		0x879e,
		0xb1fc
		},
		{
		0x87a5,
		0xb206
		},
		{
		0x87a6,
		0xb207
		},
		{
		0x87a7,
		0xb209
		},
		{
		0x87a8,
		0xb20a
		},
		{
		0x87b0,
		0xb216
		},
		{
		0x87b1,
		0xb218
		},
		{
		0x8853,
		0xb286
		},
		{
		0x8854,
		0xb287
		},
		{
		0x8855,
		0xb288
		},
		{
		0x88b9,
		0xb312
		},
		{
		0x8953,
		0xb382
		},
		{
		0x895a,
		0xb38d
		},
		{
		0x8977,
		0xb3a9
		},
		{
		0x8978,
		0xb3aa
		},
		{
		0x8979,
		0xb3ab
		},
		{
		0x897a,
		0xb3ad
		},
		{
		0x89e6,
		0xb42a
		},
		{
		0x8a58,
		0xb462
		},
		{
		0x8a59,
		0xb464
		},
		{
		0x8a5a,
		0xb466
		},
		{
		0x8a79,
		0xb481
		},
		{
		0x8a7a,
		0xb482
		},
		{
		0x8aae,
		0xb4b6
		},
		{
		0x8aaf,
		0xb4b8
		},
		{
		0x8ac3,
		0xb4d1
		},
		{
		0x8ac4,
		0xb4d2
		},
		{
		0x8ac5,
		0xb4d3
		},
		{
		0x8ac6,
		0xb4d4
		},
		{
		0x8ad7,
		0xb4ee
		},
		{
		0x8ad8,
		0xb4f0
		},
		{
		0x8b47,
		0xb526
		},
		{
		0x8b59,
		0xb542
		},
		{
		0x8b5a,
		0xb546
		},
		{
		0x8b71,
		0xb55e
		},
		{
		0x8bd2,
		0xb5ce
		},
		{
		0x8ca9,
		0xb665
		},
		{
		0x8caa,
		0xb666
		},
		{
		0x8cab,
		0xb667
		},
		{
		0x8cea,
		0xb6ad
		},
		{
		0x8ceb,
		0xb6ae
		},
		{
		0x8cec,
		0xb6af
		},
		{
		0x8ced,
		0xb6b0
		},
		{
		0x8d86,
		0xb702
		},
		{
		0x8d87,
		0xb703
		},
		{
		0x8d88,
		0xb704
		},
		{
		0x8dab,
		0xb72a
		},
		{
		0x8dac,
		0xb72b
		},
		{
		0x8dad,
		0xb72d
		},
		{
		0x8dae,
		0xb72e
		},
		{
		0x8db6,
		0xb73a
		},
		{
		0x8de3,
		0xb772
		},
		{
		0x8de4,
		0xb774
		},
		{
		0x8e41,
		0xb79f
		},
		{
		0x8e49,
		0xb7aa
		},
		{
		0x8e50,
		0xb7b6
		},
		{
		0x8e51,
		0xb7b7
		},
		{
		0x8e66,
		0xb7c8
		},
		{
		0x8e9b,
		0xb7fe
		},
		{
		0x8ead,
		0xb81a
		},
		{
		0x8eae,
		0xb81c
		},
		{
		0x8ec1,
		0xb836
		},
		{
		0x8ec8,
		0xb841
		},
		{
		0x8ec9,
		0xb842
		},
		{
		0x8eca,
		0xb843
		},
		{
		0x8ed7,
		0xb852
		},
		{
		0x8eec,
		0xb86e
		},
		{
		0x8eed,
		0xb870
		},
		{
		0x8ef4,
		0xb879
		},
		{
		0x8ef5,
		0xb87a
		},
		{
		0x8ef6,
		0xb87b
		},
		{
		0x8f81,
		0xb8be
		},
		{
		0x8f82,
		0xb8bf
		},
		{
		0x8f83,
		0xb8c2
		},
		{
		0x8f84,
		0xb8c4
		},
		{
		0x8f99,
		0xb8de
		},
		{
		0x8f9a,
		0xb8e0
		},
		{
		0x8fad,
		0xb8fa
		},
		{
		0x8fae,
		0xb8fc
		},
		{
		0x8ff6,
		0xb94d
		},
		{
		0x8ff7,
		0xb94e
		},
		{
		0x8ff8,
		0xb950
		},
		{
		0x904d,
		0xb96a
		},
		{
		0x904e,
		0xb96c
		},
		{
		0x9067,
		0xb986
		},
		{
		0x9068,
		0xb988
		},
		{
		0x9069,
		0xb98b
		},
		{
		0x906a,
		0xb98c
		},
		{
		0x909a,
		0xb9be
		},
		{
		0x909b,
		0xb9c0
		},
		{
		0x90a2,
		0xb9ca
		},
		{
		0x90a3,
		0xb9cb
		},
		{
		0x90a4,
		0xb9cd
		},
		{
		0x90bb,
		0xb9f6
		},
		{
		0x9154,
		0xba66
		},
		{
		0x91a0,
		0xbaba
		},
		{
		0x91a1,
		0xbabc
		},
		{
		0x91a8,
		0xbac5
		},
		{
		0x91a9,
		0xbac6
		},
		{
		0x91aa,
		0xbac7
		},
		{
		0x91ea,
		0xbb0e
		},
		{
		0x91eb,
		0xbb10
		},
		{
		0x9241,
		0xbb28
		},
		{
		0x9242,
		0xbb2a
		},
		{
		0x924b,
		0xbb37
		},
		{
		0x924c,
		0xbb39
		},
		{
		0x924d,
		0xbb3a
		},
		{
		0x9261,
		0xbb53
		},
		{
		0x9262,
		0xbb55
		},
		{
		0x9263,
		0xbb56
		},
		{
		0x9264,
		0xbb57
		},
		{
		0x926d,
		0xbb62
		},
		{
		0x92bd,
		0xbbb5
		},
		{
		0x92be,
		0xbbb6
		},
		{
		0x92d4,
		0xbbd1
		},
		{
		0x92d5,
		0xbbd2
		},
		{
		0x9361,
		0xbc36
		},
		{
		0x9362,
		0xbc37
		},
		{
		0x9381,
		0xbc5a
		},
		{
		0x9382,
		0xbc5b
		},
		{
		0x9383,
		0xbc5c
		},
		{
		0x93b4,
		0xbc96
		},
		{
		0x93b5,
		0xbc98
		},
		{
		0x93bb,
		0xbca2
		},
		{
		0x93bc,
		0xbca3
		},
		{
		0x93bd,
		0xbca5
		},
		{
		0x93be,
		0xbca6
		},
		{
		0x93c6,
		0xbcb2
		},
		{
		0x9447,
		0xbd06
		},
		{
		0x9448,
		0xbd08
		},
		{
		0x944f,
		0xbd11
		},
		{
		0x9450,
		0xbd12
		},
		{
		0x9451,
		0xbd13
		},
		{
		0x94a4,
		0xbd65
		},
		{
		0x94a5,
		0xbd66
		},
		{
		0x94a6,
		0xbd67
		},
		{
		0x94be,
		0xbd82
		},
		{
		0x94bf,
		0xbd83
		},
		{
		0x94c0,
		0xbd85
		},
		{
		0x94c1,
		0xbd86
		},
		{
		0x955a,
		0xbdf1
		},
		{
		0x956d,
		0xbe01
		},
		{
		0x956e,
		0xbe02
		},
		{
		0x956f,
		0xbe04
		},
		{
		0x9588,
		0xbe1e
		},
		{
		0x95c9,
		0xbe72
		},
		{
		0x95db,
		0xbe8e
		},
		{
		0x9659,
		0xbed2
		},
		{
		0x965a,
		0xbed3
		},
		{
		0x9661,
		0xbed5
		},
		{
		0x9662,
		0xbed6
		},
		{
		0x966a,
		0xbee1
		},
		{
		0x966b,
		0xbee2
		},
		{
		0x96a0,
		0xbf1a
		},
		{
		0x96cf,
		0xbf52
		},
		{
		0x96d0,
		0xbf53
		},
		{
		0x96d1,
		0xbf54
		},
		{
		0x979f,
		0xbfdd
		},
		{
		0x97a0,
		0xbfde
		},
		{
		0x97a1,
		0xbfe0
		},
		{
		0x97fc,
		0xc03d
		},
		{
		0x97fd,
		0xc03e
		},
		{
		0x97fe,
		0xc03f
		},
		{
		0x9858,
		0xc059
		},
		{
		0x9859,
		0xc05a
		},
		{
		0x985a,
		0xc05b
		},
		{
		0x9861,
		0xc05d
		},
		{
		0x9862,
		0xc05e
		},
		{
		0x9863,
		0xc05f
		},
		{
		0x98a3,
		0xc0a2
		},
		{
		0x98a4,
		0xc0a4
		},
		{
		0x98ab,
		0xc0ae
		},
		{
		0x98ac,
		0xc0b1
		},
		{
		0x98ad,
		0xc0b2
		},
		{
		0x98c5,
		0xc0da
		},
		{
		0x98d8,
		0xc0f6
		},
		{
		0x98d9,
		0xc0f8
		},
		{
		0x98ed,
		0xc111
		},
		{
		0x98ee,
		0xc112
		},
		{
		0x98ef,
		0xc113
		},
		{
		0x98f0,
		0xc114
		},
		{
		0x9952,
		0xc14a
		},
		{
		0x9959,
		0xc156
		},
		{
		0x995a,
		0xc157
		},
		{
		0x9961,
		0xc159
		},
		{
		0x9962,
		0xc15a
		},
		{
		0x9963,
		0xc15b
		},
		{
		0x996b,
		0xc166
		},
		{
		0x99c5,
		0xc1d5
		},
		{
		0x99c6,
		0xc1d6
		},
		{
		0x99db,
		0xc1f2
		},
		{
		0x99f0,
		0xc20e
		},
		{
		0x99f1,
		0xc210
		},
		{
		0x9a61,
		0xc246
		},
		{
		0x9a62,
		0xc247
		},
		{
		0x9a92,
		0xc27e
		},
		{
		0x9a93,
		0xc280
		},
		{
		0x9aa7,
		0xc299
		},
		{
		0x9aa8,
		0xc29a
		},
		{
		0x9aa9,
		0xc29c
		},
		{
		0x9abb,
		0xc2b6
		},
		{
		0x9abc,
		0xc2b8
		},
		{
		0x9adf,
		0xc2de
		},
		{
		0x9ae0,
		0xc2df
		},
		{
		0x9ae1,
		0xc2e1
		},
		{
		0x9ae2,
		0xc2e2
		},
		{
		0x9afb,
		0xc30a
		},
		{
		0x9afc,
		0xc30b
		},
		{
		0x9afd,
		0xc30e
		},
		{
		0x9afe,
		0xc30f
		},
		{
		0x9b50,
		0xc326
		},
		{
		0x9b51,
		0xc327
		},
		{
		0x9ba6,
		0xc37a
		},
		{
		0x9ba7,
		0xc37b
		},
		{
		0x9bfe,
		0xc3da
		},
		{
		0x9c41,
		0xc3db
		},
		{
		0x9c42,
		0xc3dd
		},
		{
		0x9c43,
		0xc3de
		},
		{
		0x9c44,
		0xc3e1
		},
		{
		0x9c4a,
		0xc3ea
		},
		{
		0x9c4b,
		0xc3eb
		},
		{
		0x9c4c,
		0xc3ec
		},
		{
		0x9c53,
		0xc3f6
		},
		{
		0x9c54,
		0xc3f7
		},
		{
		0x9ccf,
		0xc476
		},
		{
		0x9cd0,
		0xc477
		},
		{
		0x9cd1,
		0xc478
		},
		{
		0x9d4f,
		0xc4b9
		},
		{
		0x9d50,
		0xc4ba
		},
		{
		0x9d51,
		0xc4bb
		},
		{
		0x9dc8,
		0xc53a
		},
		{
		0x9dc9,
		0xc53c
		},
		{
		0x9de8,
		0xc572
		},
		{
		0x9e5a,
		0xc5b6
		},
		{
		0x9e61,
		0xc5b7
		},
		{
		0x9e62,
		0xc5ba
		},
		{
		0x9e77,
		0xc5e2
		},
		{
		0x9e78,
		0xc5e4
		},
		{
		0x9e79,
		0xc5e6
		},
		{
		0x9e7a,
		0xc5e7
		},
		{
		0x9e9e,
		0xc61a
		},
		{
		0x9ec1,
		0xc652
		},
		{
		0x9ec8,
		0xc65e
		},
		{
		0x9ec9,
		0xc65f
		},
		{
		0x9ed5,
		0xc66d
		},
		{
		0x9ed6,
		0xc66e
		},
		{
		0x9ed7,
		0xc670
		},
		{
		0x9eea,
		0xc68a
		},
		{
		0x9eeb,
		0xc68c
		},
		{
		0x9efe,
		0xc6a6
		},
		{
		0x9f41,
		0xc6a8
		},
		{
		0x9f52,
		0xc6c2
		},
		{
		0x9f53,
		0xc6c4
		},
		{
		0x9f5a,
		0xc6ce
		},
		{
		0x9f61,
		0xc6cf
		},
		{
		0x9f62,
		0xc6d1
		},
		{
		0x9f63,
		0xc6d2
		},
		{
		0x9f64,
		0xc6d3
		},
		{
		0x9f6c,
		0xc6de
		},
		{
		0x9f6d,
		0xc6df
		},
		{
		0x9f86,
		0xc6fa
		},
		{
		0x9f87,
		0xc6fb
		},
		{
		0x9f88,
		0xc6fc
		},
		{
		0x9f9b,
		0xc716
		},
		{
		0x9f9c,
		0xc718
		},
		{
		0x9fd0,
		0xc769
		},
		{
		0x9fd1,
		0xc76a
		},
		{
		0x9ff1,
		0xc7a2
		},
		{
		0xa04c,
		0xc7ca
		},
		{
		0xa04d,
		0xc7cb
		},
		{
		0xa04e,
		0xc7cd
		},
		{
		0xa04f,
		0xc7cf
		},
		{
		0xa057,
		0xc7d9
		},
		{
		0xa058,
		0xc7da
		},
		{
		0xa059,
		0xc7db
		},
		{
		0xa05a,
		0xc7dc
		},
		{
		0xa091,
		0xc812
		},
		{
		0xa092,
		0xc814
		},
		{
		0xa0a4,
		0xc82e
		},
		{
		0xa0a5,
		0xc830
		},
		{
		0xa0b9,
		0xc84a
		},
		{
		0xa0ba,
		0xc84b
		},
		{
		0xa141,
		0xc8a5
		},
		{
		0xa142,
		0xc8a6
		},
		{
		0xa143,
		0xc8a7
		},
		{
		0xa157,
		0xc8be
		},
		{
		0xa158,
		0xc8bf
		},
		{
		0xa159,
		0xc8c0
		},
		{
		0xa15a,
		0xc8c1
		},
		{
		0xa170,
		0xc8d6
		},
		{
		0xa171,
		0xc8d8
		},
		{
		0xa178,
		0xc8e2
		},
		{
		0xa179,
		0xc8e3
		},
		{
		0xa17a,
		0xc8e5
		},
		{
		0xa241,
		0xc910
		},
		{
		0xa295,
		0xc962
		},
		{
		0xa341,
		0xc971
		},
		{
		0xa342,
		0xc972
		},
		{
		0xa343,
		0xc973
		},
		{
		0xa368,
		0xc99a
		},
		{
		0xa369,
		0xc99c
		},
		{
		0xa3dc,
		0xffe6
		},
		{
		0xa3fe,
		0xffe3
		},
		{
		0xa461,
		0xca05
		},
		{
		0xa462,
		0xca06
		},
		{
		0xa463,
		0xca07
		},
		{
		0xa464,
		0xca0a
		},
		{
		0xa46b,
		0xca15
		},
		{
		0xa46c,
		0xca16
		},
		{
		0xa46d,
		0xca17
		},
		{
		0xa481,
		0xca26
		},
		{
		0xa482,
		0xca27
		},
		{
		0xa483,
		0xca28
		},
		{
		0xa552,
		0xca5e
		},
		{
		0xa559,
		0xca69
		},
		{
		0xa55a,
		0xca6a
		},
		{
		0xa579,
		0xca85
		},
		{
		0xa57a,
		0xca86
		},
		{
		0xa681,
		0xcae8
		},
		{
		0xa682,
		0xcae9
		},
		{
		0xa683,
		0xcaea
		},
		{
		0xa684,
		0xcaeb
		},
		{
		0xa778,
		0xcb42
		},
		{
		0xa779,
		0xcb43
		},
		{
		0xa77a,
		0xcb44
		},
		{
		0xa790,
		0xcb5a
		},
		{
		0xa791,
		0xcb5b
		},
		{
		0xa792,
		0xcb5c
		},
		{
		0xa8a1,
		0x00c6
		},
		{
		0xa8a2,
		0x00d0
		},
		{
		0xa8a3,
		0x00aa
		},
		{
		0xa8a4,
		0x0126
		},
		{
		0xa8a6,
		0x0132
		},
		{
		0xaa4e,
		0xcc3a
		},
		{
		0xaa66,
		0xcc56
		},
		{
		0xaa79,
		0xcc71
		},
		{
		0xaa7a,
		0xcc72
		},
		{
		0xaa81,
		0xcc73
		},
		{
		0xaa82,
		0xcc74
		},
		{
		0xab51,
		0xccaa
		},
		{
		0xab58,
		0xccb6
		},
		{
		0xab59,
		0xccb7
		},
		{
		0xab5a,
		0xccb9
		},
		{
		0xab61,
		0xccba
		},
		{
		0xab62,
		0xccbb
		},
		{
		0xab6a,
		0xccc6
		},
		{
		0xab6b,
		0xccc8
		},
		{
		0xab72,
		0xccd1
		},
		{
		0xab73,
		0xccd2
		},
		{
		0xab74,
		0xccd3
		},
		{
		0xab91,
		0xcced
		},
		{
		0xab92,
		0xccee
		},
		{
		0xab93,
		0xccef
		},
		{
		0xac41,
		0xccfe
		},
		{
		0xac42,
		0xccff
		},
		{
		0xac43,
		0xcd00
		},
		{
		0xac9e,
		0xcd5d
		},
		{
		0xac9f,
		0xcd5e
		},
		{
		0xaca0,
		0xcd5f
		},
		{
		0xaca7,
		0x0401
		},
		{
		0xacd7,
		0x0451
		},
		{
		0xad41,
		0xcd61
		},
		{
		0xad42,
		0xcd62
		},
		{
		0xad43,
		0xcd63
		},
		{
		0xad4b,
		0xcd6e
		},
		{
		0xad4c,
		0xcd70
		},
		{
		0xada0,
		0xcdc5
		},
		{
		0xae47,
		0xcdcd
		},
		{
		0xae48,
		0xcdce
		},
		{
		0xae49,
		0xcdcf
		},
		{
		0xae74,
		0xcdfa
		},
		{
		0xae75,
		0xcdfc
		},
		{
		0xae8f,
		0xce15
		},
		{
		0xae90,
		0xce16
		},
		{
		0xae91,
		0xce17
		},
		{
		0xae92,
		0xce18
		},
		{
		0xaf6f,
		0xce5a
		},
		{
		0xaf70,
		0xce5b
		},
		{
		0xaf71,
		0xce5d
		},
		{
		0xaf72,
		0xce5e
		},
		{
		0xaf79,
		0xce6a
		},
		{
		0xaf7a,
		0xce6c
		},
		{
		0xaf93,
		0xce86
		},
		{
		0xaf94,
		0xce88
		},
		{
		0xb047,
		0xcea2
		},
		{
		0xb08f,
		0xcee6
		},
		{
		0xb090,
		0xcee7
		},
		{
		0xb091,
		0xcee9
		},
		{
		0xb092,
		0xceea
		},
		{
		0xb09a,
		0xcef6
		},
		{
		0xb14d,
		0xcf12
		},
		{
		0xb14e,
		0xcf14
		},
		{
		0xb168,
		0xcf2e
		},
		{
		0xb250,
		0xcf81
		},
		{
		0xb251,
		0xcf82
		},
		{
		0xb252,
		0xcf83
		},
		{
		0xb253,
		0xcf84
		},
		{
		0xb25a,
		0xcf8d
		},
		{
		0xb27a,
		0xcfa9
		},
		{
		0xb367,
		0xcff2
		},
		{
		0xb368,
		0xcff4
		},
		{
		0xb453,
		0xd046
		},
		{
		0xb454,
		0xd048
		},
		{
		0xb479,
		0xd06e
		},
		{
		0xb47a,
		0xd06f
		},
		{
		0xb481,
		0xd071
		},
		{
		0xb482,
		0xd072
		},
		{
		0xb483,
		0xd073
		},
		{
		0xb48b,
		0xd07e
		},
		{
		0xb48c,
		0xd07f
		},
		{
		0xb48d,
		0xd080
		},
		{
		0xb4e2,
		0xb2f3
		},
		{
		0xb4e3,
		0xb2f4
		},
		{
		0xb4e4,
		0xb2f5
		},
		{
		0xb561,
		0xd0b3
		},
		{
		0xb562,
		0xd0b6
		},
		{
		0xb563,
		0xd0b8
		},
		{
		0xb575,
		0xd0d2
		},
		{
		0xb58e,
		0xd0ee
		},
		{
		0xb681,
		0xd13f
		},
		{
		0xb682,
		0xd142
		},
		{
		0xb695,
		0xd15e
		},
		{
		0xb696,
		0xd160
		},
		{
		0xb86a,
		0xd1f5
		},
		{
		0xb86b,
		0xd1f6
		},
		{
		0xb86c,
		0xd1f7
		},
		{
		0xb881,
		0xd208
		},
		{
		0xb94f,
		0xd23e
		},
		{
		0xb950,
		0xd240
		},
		{
		0xb957,
		0xd249
		},
		{
		0xb958,
		0xd24a
		},
		{
		0xb959,
		0xd24b
		},
		{
		0xb95a,
		0xd24c
		},
		{
		0xb977,
		0xd265
		},
		{
		0xb978,
		0xd266
		},
		{
		0xb979,
		0xd267
		},
		{
		0xb97a,
		0xd268
		},
		{
		0xba5a,
		0xd2ad
		},
		{
		0xba61,
		0xd2ae
		},
		{
		0xba62,
		0xd2af
		},
		{
		0xba63,
		0xd2b0
		},
		{
		0xba74,
		0xd2ca
		},
		{
		0xbb46,
		0xd302
		},
		{
		0xbb47,
		0xd304
		},
		{
		0xbb58,
		0xd31e
		},
		{
		0xbb59,
		0xd322
		},
		{
		0xbb5a,
		0xd323
		},
		{
		0xbb70,
		0xd33a
		},
		{
		0xbb77,
		0xd346
		},
		{
		0xbb78,
		0xd347
		},
		{
		0xbb79,
		0xd348
		},
		{
		0xbb7a,
		0xd349
		},
		{
		0xbc78,
		0xd3aa
		},
		{
		0xbc79,
		0xd3ac
		},
		{
		0xbc7a,
		0xd3ae
		},
		{
		0xbc93,
		0xd3c6
		},
		{
		0xbc94,
		0xd3c7
		},
		{
		0xbd41,
		0xd3d7
		},
		{
		0xbd4a,
		0xd3e2
		},
		{
		0xbe49,
		0xd441
		},
		{
		0xbe4a,
		0xd442
		},
		{
		0xbe4b,
		0xd443
		},
		{
		0xbe77,
		0xd46e
		},
		{
		0xbe78,
		0xd470
		},
		{
		0xbe79,
		0xd471
		},
		{
		0xbe7a,
		0xd472
		},
		{
		0xbe90,
		0xd48a
		},
		{
		0xbe91,
		0xd48c
		},
		{
		0xbefd,
		0xc5cc
		},
		{
		0xbefe,
		0xc5ce
		},
		{
		0xbf87,
		0xd4dd
		},
		{
		0xbf88,
		0xd4de
		},
		{
		0xc054,
		0xd516
		},
		{
		0xc091,
		0xd54e
		},
		{
		0xc092,
		0xd550
		},
		{
		0xc158,
		0xd586
		},
		{
		0xc159,
		0xd58a
		},
		{
		0xc15a,
		0xd58b
		},
		{
		0xc161,
		0xd58c
		},
		{
		0xc162,
		0xd58d
		},
		{
		0xc163,
		0xd58e
		},
		{
		0xc164,
		0xd58f
		},
		{
		0xc179,
		0xd5a6
		},
		{
		0xc17a,
		0xd5a7
		},
		{
		0xc24c,
		0xd5da
		},
		{
		0xc24d,
		0xd5dc
		},
		{
		0xc266,
		0xd5f6
		},
		{
		0xc267,
		0xd5f8
		},
		{
		0xc27a,
		0xd612
		},
		{
		0xc366,
		0xd668
		},
		{
		0xc36d,
		0xd672
		},
		{
		0xc36e,
		0xd673
		},
		{
		0xc381,
		0xd681
		},
		{
		0xc382,
		0xd682
		},
		{
		0xc383,
		0xd684
		},
		{
		0xc397,
		0xd69e
		},
		{
		0xc398,
		0xd6a0
		},
		{
		0xc441,
		0xd6ab
		},
		{
		0xc442,
		0xd6ad
		},
		{
		0xc443,
		0xd6ae
		},
		{
		0xc444,
		0xd6af
		},
		{
		0xc44d,
		0xd6ba
		},
		{
		0xc550,
		0xd72a
		},
		{
		0xc551,
		0xd72c
		},
		{
		0xc558,
		0xd736
		},
		{
		0xc559,
		0xd737
		},
		{
		0xc55a,
		0xd739
		},
		{
		0xc561,
		0xd73a
		},
		{
		0xc562,
		0xd73b
		},
		{
		0xc56a,
		0xd745
		},
		{
		0xc56b,
		0xd746
		},
		{
		0xc56c,
		0xd748
		},
		{
		0xc573,
		0xd752
		},
		{
		0xc574,
		0xd753
		},
		{
		0xc575,
		0xd755
		},
		{
		0xc596,
		0xd77e
		},
		{
		0xc597,
		0xd77f
		},
		{
		0xc598,
		0xd780
		},
		{
		0xc641,
		0xd78d
		},
		{
		0xc642,
		0xd78e
		},
		{
		0xc643,
		0xd78f
		},
		{
		0xc64b,
		0xd79a
		},
		{
		0xc64c,
		0xd79c
		},
		{
		0xd1e1,
		0x90a3
		},
		{
		0xd2cc,
		0x99d1
		},
		{
		0xd2ec,
		0x5ae9
		},
		{
		0xd2ed,
		0x8a25
		},
		{
		0xd2ee,
		0x677b
		},
		{
		0xd2ef,
		0x7d10
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_1[]=
	{
		{
		0xd2f7
		},
		{
		0xd2f8
		},
		{
		0xd4e6
		},
		{
		0xd4fc
		},
		{
		0xd5a5
		},
		{
		0xd5ab
		},
		{
		0xd5ae
		},
		{
		0xd6b8
		},
		{
		0xd6cd
		},
		{
		0xd7cb
		},
		{
		0xd7e4
		},
		{
		0xdbc5
		},
		{
		0xdbe4
		},
		{
		0xdca5
		},
		{
		0xdda5
		},
		{
		0xddd5
		},
		{
		0xddf4
		},
		{
		0xdefc
		},
		{
		0xdefe
		},
		{
		0xdfb3
		},
		{
		0xdfe1
		},
		{
		0xdfe8
		},
		{
		0xe0f1
		},
		{
		0xe1ad
		},
		{
		0xe1ed
		},
		{
		0xe3f5
		},
		{
		0xe4a1
		},
		{
		0xe4a9
		},
		{
		0xe5ae
		},
		{
		0xe5b1
		},
		{
		0xe5b2
		},
		{
		0xe5b9
		},
		{
		0xe5bb
		},
		{
		0xe5bc
		},
		{
		0xe5c4
		},
		{
		0xe5ce
		},
		{
		0xe5d0
		},
		{
		0xe5d2
		},
		{
		0xe5d6
		},
		{
		0xe5fa
		},
		{
		0xe5fb
		},
		{
		0xe5fc
		},
		{
		0xe5fe
		},
		{
		0xe6a1
		},
		{
		0xe6a4
		},
		{
		0xe6a7
		},
		{
		0xe6ad
		},
		{
		0xe6af
		},
		{
		0xe6b0
		},
		{
		0xe6b1
		},
		{
		0xe6b3
		},
		{
		0xe6b7
		},
		{
		0xe6b8
		},
		{
		0xe6bc
		},
		{
		0xe6c4
		},
		{
		0xe6c6
		},
		{
		0xe6c7
		},
		{
		0xe6ca
		},
		{
		0xe6d2
		},
		{
		0xe6d6
		},
		{
		0xe6d9
		},
		{
		0xe6dc
		},
		{
		0xe6df
		},
		{
		0xe6e1
		},
		{
		0xe6e4
		},
		{
		0xe6e5
		},
		{
		0xe6e6
		},
		{
		0xe6e8
		},
		{
		0xe6ea
		},
		{
		0xe6eb
		},
		{
		0xe6ec
		},
		{
		0xe6ef
		},
		{
		0xe6f1
		},
		{
		0xe6f2
		},
		{
		0xe6f5
		},
		{
		0xe6f6
		},
		{
		0xe6f7
		},
		{
		0xe6f9
		},
		{
		0xe7a1
		},
		{
		0xe7a6
		},
		{
		0xe7a9
		},
		{
		0xe7aa
		},
		{
		0xe7ac
		},
		{
		0xe7ad
		},
		{
		0xe7b0
		},
		{
		0xe7bf
		},
		{
		0xe7c1
		},
		{
		0xe7c6
		},
		{
		0xe7c7
		},
		{
		0xe7cb
		},
		{
		0xe7cd
		},
		{
		0xe7cf
		},
		{
		0xe7d0
		},
		{
		0xe7d3
		},
		{
		0xe7df
		},
		{
		0xe7e4
		},
		{
		0xe7e6
		},
		{
		0xe7f7
		},
		{
		0xe8e7
		},
		{
		0xe8e8
		},
		{
		0xe8f0
		},
		{
		0xe8f1
		},
		{
		0xe8f7
		},
		{
		0xe8f9
		},
		{
		0xe8fb
		},
		{
		0xe8fe
		},
		{
		0xe9a7
		},
		{
		0xe9ac
		},
		{
		0xe9cc
		},
		{
		0xe9f7
		},
		{
		0xeac1
		},
		{
		0xeae5
		},
		{
		0xeaf4
		},
		{
		0xeaf7
		},
		{
		0xeafc
		},
		{
		0xeafe
		},
		{
		0xeba4
		},
		{
		0xeba7
		},
		{
		0xeba9
		},
		{
		0xebaa
		},
		{
		0xebba
		},
		{
		0xebbb
		},
		{
		0xebbd
		},
		{
		0xebc1
		},
		{
		0xebc2
		},
		{
		0xebc6
		},
		{
		0xebc7
		},
		{
		0xebcc
		},
		{
		0xebcf
		},
		{
		0xebd0
		},
		{
		0xebd1
		},
		{
		0xebd2
		},
		{
		0xebd8
		},
		{
		0xeca6
		},
		{
		0xeca7
		},
		{
		0xecaa
		},
		{
		0xecaf
		},
		{
		0xecb0
		},
		{
		0xecb1
		},
		{
		0xecb2
		},
		{
		0xecb5
		},
		{
		0xecb8
		},
		{
		0xecba
		},
		{
		0xecc0
		},
		{
		0xecc1
		},
		{
		0xecc5
		},
		{
		0xecc6
		},
		{
		0xecc9
		},
		{
		0xecca
		},
		{
		0xecd5
		},
		{
		0xecdd
		},
		{
		0xecde
		},
		{
		0xece1
		},
		{
		0xece4
		},
		{
		0xece7
		},
		{
		0xece8
		},
		{
		0xecf7
		},
		{
		0xecf8
		},
		{
		0xecfa
		},
		{
		0xeda1
		},
		{
		0xeda2
		},
		{
		0xeda3
		},
		{
		0xedee
		},
		{
		0xeedb
		},
		{
		0xf2bd
		},
		{
		0xf2fa
		},
		{
		0xf3b1
		},
		{
		0xf4a7
		},
		{
		0xf4ee
		},
		{
		0xf6f4
		},
		{
		0xf6f6
		},
		{
		0xf7b8
		},
		{
		0xf7c8
		},
		{
		0xf7d3
		},
		{
		0xf8db
		},
		{
		0xf8f0
		},
		{
		0xfaa1
		},
		{
		0xfaa2
		},
		{
		0xfae6
		},
		{
		0xfca9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_2[]=
	{
		{
		0xd2d9
		},
		{
		0xd2da
		},
		{
		0xd2de
		},
		{
		0xd2df
		},
		{
		0xd2e1
		},
		{
		0xd2e2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_3[]=
	{
		{
		0xd2ad
		},
		{
		0xd2b2
		},
		{
		0xd2be
		},
		{
		0xd2c2
		},
		{
		0xd2c3
		},
		{
		0xd2c4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_4[]=
	{
		{
		0xd1e8
		},
		{
		0xd1e9
		},
		{
		0xd1ea
		},
		{
		0xd1eb
		},
		{
		0xd1ed
		},
		{
		0xd1ef
		},
		{
		0xd1f0
		},
		{
		0xd1f2
		},
		{
		0xd1f6
		},
		{
		0xd1fa
		},
		{
		0xd1fc
		},
		{
		0xd1fd
		},
		{
		0xd1fe
		},
		{
		0xd2a2
		},
		{
		0xd2a3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_5[]=
	{
		{
		0xcbd0
		},
		{
		0xcbd6
		},
		{
		0xcbe7
		},
		{
		0xcdcf
		},
		{
		0xcde8
		},
		{
		0xcead
		},
		{
		0xcffb
		},
		{
		0xd0a2
		},
		{
		0xd0b8
		},
		{
		0xd0d0
		},
		{
		0xd0dd
		},
		{
		0xd1d4
		},
		{
		0xd1d5
		},
		{
		0xd1d8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_6[]=
	{
		{
		0xc8fb
		},
		{
		0xc8fc
		},
		{
		0xc64b
		},
		{
		0xc8fd
		},
		{
		0xc64c
		},
		{
		0xc8fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_7[]=
	{
		{
		0xc8f7
		},
		{
		0xc8f8
		},
		{
		0xc59f
		},
		{
		0xc5a0
		},
		{
		0xc8f9
		},
		{
		0xc641
		},
		{
		0xc642
		},
		{
		0xc643
		},
		{
		0xc8fa
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_8[]=
	{
		{
		0xc8f4
		},
		{
		0xc8f5
		},
		{
		0xc596
		},
		{
		0xc597
		},
		{
		0xc598
		},
		{
		0xc8f6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_9[]=
	{
		{
		0xc581
		},
		{
		0xc8ec
		},
		{
		0xc8ed
		},
		{
		0xc582
		},
		{
		0xc8ee
		},
		{
		0xc583
		},
		{
		0xc8ef
		},
		{
		0xc584
		},
		{
		0xc585
		},
		{
		0xc586
		},
		{
		0xc8f0
		},
		{
		0xc587
		},
		{
		0xc588
		},
		{
		0xc8f1
		},
		{
		0xc589
		},
		{
		0xc58a
		},
		{
		0xc58b
		},
		{
		0xc8f2
		},
		{
		0xc58c
		},
		{
		0xc58d
		},
		{
		0xc58e
		},
		{
		0xc8f3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_10[]=
	{
		{
		0xc8e5
		},
		{
		0xc8e6
		},
		{
		0xc573
		},
		{
		0xc574
		},
		{
		0xc8e7
		},
		{
		0xc575
		},
		{
		0xc8e8
		},
		{
		0xc8e9
		},
		{
		0xc8ea
		},
		{
		0xc8eb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_11[]=
	{
		{
		0xc8e2
		},
		{
		0xc56a
		},
		{
		0xc56b
		},
		{
		0xc8e3
		},
		{
		0xc56c
		},
		{
		0xc8e4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_12[]=
	{
		{
		0xc8de
		},
		{
		0xc8df
		},
		{
		0xc558
		},
		{
		0xc559
		},
		{
		0xc8e0
		},
		{
		0xc55a
		},
		{
		0xc561
		},
		{
		0xc562
		},
		{
		0xc8e1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_13[]=
	{
		{
		0xc8da
		},
		{
		0xc8db
		},
		{
		0xc550
		},
		{
		0xc8dc
		},
		{
		0xc551
		},
		{
		0xc8dd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_14[]=
	{
		{
		0xc8d5
		},
		{
		0xc49e
		},
		{
		0xc49f
		},
		{
		0xc4a0
		},
		{
		0xc541
		},
		{
		0xc542
		},
		{
		0xc543
		},
		{
		0xc8d6
		},
		{
		0xc8d7
		},
		{
		0xc544
		},
		{
		0xc545
		},
		{
		0xc8d8
		},
		{
		0xc546
		},
		{
		0xc547
		},
		{
		0xc548
		},
		{
		0xc8d9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_15[]=
	{
		{
		0xc8d1
		},
		{
		0xc8d2
		},
		{
		0xc48d
		},
		{
		0xc48e
		},
		{
		0xc8d3
		},
		{
		0xc48f
		},
		{
		0xc490
		},
		{
		0xc491
		},
		{
		0xc8d4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_16[]=
	{
		{
		0xc481
		},
		{
		0xc482
		},
		{
		0xc8cf
		},
		{
		0xc483
		},
		{
		0xc484
		},
		{
		0xc485
		},
		{
		0xc486
		},
		{
		0xc8d0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_17[]=
	{
		{
		0xc8cc
		},
		{
		0xc470
		},
		{
		0xc471
		},
		{
		0xc472
		},
		{
		0xc8cd
		},
		{
		0xc473
		},
		{
		0xc474
		},
		{
		0xc475
		},
		{
		0xc8ce
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_18[]=
	{
		{
		0xc8c4
		},
		{
		0xc8c5
		},
		{
		0xc456
		},
		{
		0xc457
		},
		{
		0xc8c6
		},
		{
		0xc458
		},
		{
		0xc459
		},
		{
		0xc45a
		},
		{
		0xc8c7
		},
		{
		0xc461
		},
		{
		0xc462
		},
		{
		0xc463
		},
		{
		0xc464
		},
		{
		0xc8c8
		},
		{
		0xc465
		},
		{
		0xc466
		},
		{
		0xc8c9
		},
		{
		0xc467
		},
		{
		0xc468
		},
		{
		0xc8ca
		},
		{
		0xc469
		},
		{
		0xc8cb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_19[]=
	{
		{
		0xc8bf
		},
		{
		0xc39f
		},
		{
		0xc3a0
		},
		{
		0xc441
		},
		{
		0xc8c0
		},
		{
		0xc442
		},
		{
		0xc443
		},
		{
		0xc444
		},
		{
		0xc8c1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_20[]=
	{
		{
		0xc8bc
		},
		{
		0xc397
		},
		{
		0xc8bd
		},
		{
		0xc398
		},
		{
		0xc8be
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_21[]=
	{
		{
		0xc8b8
		},
		{
		0xc8b9
		},
		{
		0xc38a
		},
		{
		0xc38b
		},
		{
		0xc8ba
		},
		{
		0xc38c
		},
		{
		0xc38d
		},
		{
		0xc38e
		},
		{
		0xc8bb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_22[]=
	{
		{
		0xc381
		},
		{
		0xc382
		},
		{
		0xc8b6
		},
		{
		0xc383
		},
		{
		0xc8b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_23[]=
	{
		{
		0xc8b3
		},
		{
		0xc8b4
		},
		{
		0xc36d
		},
		{
		0xc36e
		},
		{
		0xc8b5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_24[]=
	{
		{
		0xc8a3
		},
		{
		0xc8a4
		},
		{
		0xc29f
		},
		{
		0xc2a0
		},
		{
		0xc8a5
		},
		{
		0xc341
		},
		{
		0xc342
		},
		{
		0xc343
		},
		{
		0xc8a6
		},
		{
		0xc344
		},
		{
		0xc345
		},
		{
		0xc346
		},
		{
		0xc347
		},
		{
		0xc8a7
		},
		{
		0xc348
		},
		{
		0xc349
		},
		{
		0xc8a8
		},
		{
		0xc8a9
		},
		{
		0xc34a
		},
		{
		0xc8aa
		},
		{
		0xc34b
		},
		{
		0xc8ab
		},
		{
		0xc34c
		},
		{
		0xc34d
		},
		{
		0xc34e
		},
		{
		0xc8ac
		},
		{
		0xc34f
		},
		{
		0xc350
		},
		{
		0xc8ad
		},
		{
		0xc8ae
		},
		{
		0xc351
		},
		{
		0xc352
		},
		{
		0xc8af
		},
		{
		0xc353
		},
		{
		0xc354
		},
		{
		0xc355
		},
		{
		0xc8b0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_25[]=
	{
		{
		0xc7fd
		},
		{
		0xc287
		},
		{
		0xc288
		},
		{
		0xc289
		},
		{
		0xc7fe
		},
		{
		0xc28a
		},
		{
		0xc28b
		},
		{
		0xc28c
		},
		{
		0xc8a1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_26[]=
	{
		{
		0xc7f8
		},
		{
		0xc7f9
		},
		{
		0xc27a
		},
		{
		0xc7fa
		},
		{
		0xc7fb
		},
		{
		0xc7fc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_27[]=
	{
		{
		0xc7f4
		},
		{
		0xc7f5
		},
		{
		0xc26e
		},
		{
		0xc26f
		},
		{
		0xc7f6
		},
		{
		0xc270
		},
		{
		0xc271
		},
		{
		0xc272
		},
		{
		0xc7f7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_28[]=
	{
		{
		0xc7f0
		},
		{
		0xc7f1
		},
		{
		0xc266
		},
		{
		0xc7f2
		},
		{
		0xc267
		},
		{
		0xc7f3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_29[]=
	{
		{
		0xc7ec
		},
		{
		0xc7ed
		},
		{
		0xc254
		},
		{
		0xc255
		},
		{
		0xc7ee
		},
		{
		0xc256
		},
		{
		0xc257
		},
		{
		0xc258
		},
		{
		0xc7ef
		},
		{
		0xc259
		},
		{
		0xc25a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_30[]=
	{
		{
		0xc7e8
		},
		{
		0xc7e9
		},
		{
		0xc24c
		},
		{
		0xc7ea
		},
		{
		0xc24d
		},
		{
		0xc7eb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_31[]=
	{
		{
		0xc7e3
		},
		{
		0xc7e4
		},
		{
		0xc241
		},
		{
		0xc242
		},
		{
		0xc7e5
		},
		{
		0xc243
		},
		{
		0xc244
		},
		{
		0xc245
		},
		{
		0xc7e6
		},
		{
		0xc246
		},
		{
		0xc7e7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_32[]=
	{
		{
		0xc7dc
		},
		{
		0xc7dd
		},
		{
		0xc158
		},
		{
		0xc7de
		},
		{
		0xc7df
		},
		{
		0xc7e0
		},
		{
		0xc159
		},
		{
		0xc15a
		},
		{
		0xc161
		},
		{
		0xc162
		},
		{
		0xc163
		},
		{
		0xc164
		},
		{
		0xc7e1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_33[]=
	{
		{
		0xc7d8
		},
		{
		0xc7d9
		},
		{
		0xc14c
		},
		{
		0xc14d
		},
		{
		0xc7da
		},
		{
		0xc14e
		},
		{
		0xc14f
		},
		{
		0xc150
		},
		{
		0xc7db
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_34[]=
	{
		{
		0xc7cf
		},
		{
		0xc7d0
		},
		{
		0xc099
		},
		{
		0xc09a
		},
		{
		0xc7d1
		},
		{
		0xc09b
		},
		{
		0xc09c
		},
		{
		0xc09d
		},
		{
		0xc7d2
		},
		{
		0xc09e
		},
		{
		0xc09f
		},
		{
		0xc0a0
		},
		{
		0xc141
		},
		{
		0xc7d3
		},
		{
		0xc142
		},
		{
		0xc143
		},
		{
		0xc7d4
		},
		{
		0xc7d5
		},
		{
		0xc144
		},
		{
		0xc7d6
		},
		{
		0xc145
		},
		{
		0xc7d7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_35[]=
	{
		{
		0xc7cb
		},
		{
		0xc7cc
		},
		{
		0xc091
		},
		{
		0xc7cd
		},
		{
		0xc092
		},
		{
		0xc7ce
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_36[]=
	{
		{
		0xc081
		},
		{
		0xc082
		},
		{
		0xc083
		},
		{
		0xc084
		},
		{
		0xc7c7
		},
		{
		0xc7c8
		},
		{
		0xc085
		},
		{
		0xc086
		},
		{
		0xc7c9
		},
		{
		0xc087
		},
		{
		0xc088
		},
		{
		0xc089
		},
		{
		0xc7ca
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_37[]=
	{
		{
		0xc7c1
		},
		{
		0xc047
		},
		{
		0xc048
		},
		{
		0xc049
		},
		{
		0xc7c2
		},
		{
		0xc04a
		},
		{
		0xc04b
		},
		{
		0xc04c
		},
		{
		0xc7c3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_38[]=
	{
		{
		0xc7be
		},
		{
		0xbf9e
		},
		{
		0xbf9f
		},
		{
		0xc7bf
		},
		{
		0xbfa0
		},
		{
		0xc7c0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_39[]=
	{
		{
		0xc7bb
		},
		{
		0xbf91
		},
		{
		0xbf92
		},
		{
		0xbf93
		},
		{
		0xc7bc
		},
		{
		0xbf94
		},
		{
		0xbf95
		},
		{
		0xbf96
		},
		{
		0xc7bd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_40[]=
	{
		{
		0xc7b6
		},
		{
		0xbf74
		},
		{
		0xbf75
		},
		{
		0xbf76
		},
		{
		0xc7b7
		},
		{
		0xbf77
		},
		{
		0xbf78
		},
		{
		0xbf79
		},
		{
		0xc7b8
		},
		{
		0xbf7a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_41[]=
	{
		{
		0xc7b0
		},
		{
		0xc7b1
		},
		{
		0xbe90
		},
		{
		0xc7b2
		},
		{
		0xbe91
		},
		{
		0xc7b3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_42[]=
	{
		{
		0xc7aa
		},
		{
		0xc7ab
		},
		{
		0xbe86
		},
		{
		0xbe87
		},
		{
		0xc7ac
		},
		{
		0xbe88
		},
		{
		0xbe89
		},
		{
		0xc7ad
		},
		{
		0xc7ae
		},
		{
		0xbe8a
		},
		{
		0xc7af
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_43[]=
	{
		{
		0xc7a8
		},
		{
		0xbe77
		},
		{
		0xc7a9
		},
		{
		0xbe78
		},
		{
		0xbe79
		},
		{
		0xbe7a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_44[]=
	{
		{
		0xc7a5
		},
		{
		0xbe69
		},
		{
		0xbe6a
		},
		{
		0xbe6b
		},
		{
		0xc7a6
		},
		{
		0xbe6c
		},
		{
		0xbe6d
		},
		{
		0xbe6e
		},
		{
		0xc7a7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_45[]=
	{
		{
		0xc7a3
		},
		{
		0xbe49
		},
		{
		0xbe4a
		},
		{
		0xbe4b
		},
		{
		0xc7a4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_46[]=
	{
		{
		0xc6f7
		},
		{
		0xc6f8
		},
		{
		0xbd53
		},
		{
		0xbd54
		},
		{
		0xc6f9
		},
		{
		0xbd55
		},
		{
		0xbd56
		},
		{
		0xbd57
		},
		{
		0xc6fa
		},
		{
		0xbd58
		},
		{
		0xbd59
		},
		{
		0xbd5a
		},
		{
		0xbd61
		},
		{
		0xbd62
		},
		{
		0xbd63
		},
		{
		0xbd64
		},
		{
		0xc6fb
		},
		{
		0xc6fc
		},
		{
		0xbd65
		},
		{
		0xc6fd
		},
		{
		0xbd66
		},
		{
		0xc6fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_47[]=
	{
		{
		0xc6ef
		},
		{
		0xc6f0
		},
		{
		0xbc93
		},
		{
		0xbc94
		},
		{
		0xc6f1
		},
		{
		0xc6f2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_48[]=
	{
		{
		0xc6ec
		},
		{
		0xbc86
		},
		{
		0xbc87
		},
		{
		0xbc88
		},
		{
		0xc6ed
		},
		{
		0xbc89
		},
		{
		0xbc8a
		},
		{
		0xbc8b
		},
		{
		0xc6ee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_49[]=
	{
		{
		0xc6e8
		},
		{
		0xc6e9
		},
		{
		0xbc78
		},
		{
		0xc6ea
		},
		{
		0xbc79
		},
		{
		0xc6eb
		},
		{
		0xbc7a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_50[]=
	{
		{
		0xc6e4
		},
		{
		0xc6e5
		},
		{
		0xbc6c
		},
		{
		0xbc6d
		},
		{
		0xc6e6
		},
		{
		0xbc6e
		},
		{
		0xbc6f
		},
		{
		0xbc70
		},
		{
		0xc6e7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_51[]=
	{
		{
		0xc6db
		},
		{
		0xc6dc
		},
		{
		0xbc53
		},
		{
		0xbc54
		},
		{
		0xc6dd
		},
		{
		0xbc55
		},
		{
		0xbc56
		},
		{
		0xbc57
		},
		{
		0xc6de
		},
		{
		0xbc58
		},
		{
		0xbc59
		},
		{
		0xbc5a
		},
		{
		0xbc61
		},
		{
		0xbc62
		},
		{
		0xbc63
		},
		{
		0xbc64
		},
		{
		0xc6df
		},
		{
		0xc6e0
		},
		{
		0xbc65
		},
		{
		0xc6e1
		},
		{
		0xc6e2
		},
		{
		0xc6e3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_52[]=
	{
		{
		0xc6d9
		},
		{
		0xc6da
		},
		{
		0xbb77
		},
		{
		0xbb78
		},
		{
		0xbb79
		},
		{
		0xbb7a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_53[]=
	{
		{
		0xc6d4
		},
		{
		0xc6d5
		},
		{
		0xbb70
		},
		{
		0xc6d6
		},
		{
		0xc6d7
		},
		{
		0xc6d8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_54[]=
	{
		{
		0xc6ca
		},
		{
		0xc6cb
		},
		{
		0xbb58
		},
		{
		0xc6cc
		},
		{
		0xc6cd
		},
		{
		0xc6ce
		},
		{
		0xbb59
		},
		{
		0xbb5a
		},
		{
		0xbb61
		},
		{
		0xc6cf
		},
		{
		0xbb62
		},
		{
		0xbb63
		},
		{
		0xc6d0
		},
		{
		0xc6d1
		},
		{
		0xbb64
		},
		{
		0xbb65
		},
		{
		0xc6d2
		},
		{
		0xbb66
		},
		{
		0xbb67
		},
		{
		0xbb68
		},
		{
		0xc6d3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_55[]=
	{
		{
		0xc6c4
		},
		{
		0xc6c5
		},
		{
		0xc6c6
		},
		{
		0xbb4e
		},
		{
		0xc6c7
		},
		{
		0xbb4f
		},
		{
		0xbb50
		},
		{
		0xbb51
		},
		{
		0xc6c8
		},
		{
		0xbb52
		},
		{
		0xc6c9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_56[]=
	{
		{
		0xc6c0
		},
		{
		0xc6c1
		},
		{
		0xbb46
		},
		{
		0xc6c2
		},
		{
		0xbb47
		},
		{
		0xc6c3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_57[]=
	{
		{
		0xc6bc
		},
		{
		0xc6bd
		},
		{
		0xba9a
		},
		{
		0xba9b
		},
		{
		0xc6be
		},
		{
		0xba9c
		},
		{
		0xba9d
		},
		{
		0xba9e
		},
		{
		0xc6bf
		},
		{
		0xba9f
		},
		{
		0xbaa0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_58[]=
	{
		{
		0xba81
		},
		{
		0xba82
		},
		{
		0xc6b7
		},
		{
		0xba83
		},
		{
		0xba84
		},
		{
		0xba85
		},
		{
		0xc6b8
		},
		{
		0xba86
		},
		{
		0xba87
		},
		{
		0xba88
		},
		{
		0xc6b9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_59[]=
	{
		{
		0xc6ae
		},
		{
		0xc6af
		},
		{
		0xba6a
		},
		{
		0xba6b
		},
		{
		0xc6b0
		},
		{
		0xba6c
		},
		{
		0xba6d
		},
		{
		0xc6b1
		},
		{
		0xc6b2
		},
		{
		0xba6e
		},
		{
		0xc6b3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_60[]=
	{
		{
		0xc6ac
		},
		{
		0xba5a
		},
		{
		0xba61
		},
		{
		0xba62
		},
		{
		0xba63
		},
		{
		0xc6ad
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_61[]=
	{
		{
		0xc6a9
		},
		{
		0xba4d
		},
		{
		0xba4e
		},
		{
		0xba4f
		},
		{
		0xc6aa
		},
		{
		0xba50
		},
		{
		0xba51
		},
		{
		0xba52
		},
		{
		0xc6ab
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_62[]=
	{
		{
		0xc6a2
		},
		{
		0xc6a3
		},
		{
		0xb998
		},
		{
		0xb999
		},
		{
		0xc6a4
		},
		{
		0xb99a
		},
		{
		0xb99b
		},
		{
		0xb99c
		},
		{
		0xc6a5
		},
		{
		0xb99d
		},
		{
		0xb99e
		},
		{
		0xb99f
		},
		{
		0xb9a0
		},
		{
		0xba41
		},
		{
		0xba42
		},
		{
		0xba43
		},
		{
		0xc6a6
		},
		{
		0xc6a7
		},
		{
		0xba44
		},
		{
		0xba45
		},
		{
		0xba46
		},
		{
		0xc6a8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_63[]=
	{
		{
		0xc6a1
		},
		{
		0xb977
		},
		{
		0xb978
		},
		{
		0xb979
		},
		{
		0xb97a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_64[]=
	{
		{
		0xc5fd
		},
		{
		0xb957
		},
		{
		0xb958
		},
		{
		0xb959
		},
		{
		0xb95a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_65[]=
	{
		{
		0xc5f9
		},
		{
		0xc5fa
		},
		{
		0xb94f
		},
		{
		0xc5fb
		},
		{
		0xb950
		},
		{
		0xc5fc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_66[]=
	{
		{
		0xb941
		},
		{
		0xb942
		},
		{
		0xc5f5
		},
		{
		0xc5f6
		},
		{
		0xb943
		},
		{
		0xb944
		},
		{
		0xc5f7
		},
		{
		0xb945
		},
		{
		0xb946
		},
		{
		0xb947
		},
		{
		0xc5f8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_67[]=
	{
		{
		0xc5f0
		},
		{
		0xb86a
		},
		{
		0xb86b
		},
		{
		0xb86c
		},
		{
		0xc5f1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_68[]=
	{
		{
		0xc5e8
		},
		{
		0xc5e9
		},
		{
		0xb788
		},
		{
		0xc5ea
		},
		{
		0xb789
		},
		{
		0xc5eb
		},
		{
		0xb78a
		},
		{
		0xb78b
		},
		{
		0xb78c
		},
		{
		0xb78d
		},
		{
		0xc5ec
		},
		{
		0xb78e
		},
		{
		0xc5ed
		},
		{
		0xb78f
		},
		{
		0xb790
		},
		{
		0xb791
		},
		{
		0xc5ee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_69[]=
	{
		{
		0xc5e4
		},
		{
		0xc5e5
		},
		{
		0xb776
		},
		{
		0xb777
		},
		{
		0xc5e6
		},
		{
		0xb778
		},
		{
		0xb779
		},
		{
		0xb77a
		},
		{
		0xc5e7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_70[]=
	{
		{
		0xc5e2
		},
		{
		0xb756
		},
		{
		0xb757
		},
		{
		0xb758
		},
		{
		0xc5e3
		},
		{
		0xb759
		},
		{
		0xb75a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_71[]=
	{
		{
		0xc5df
		},
		{
		0xb69d
		},
		{
		0xb69e
		},
		{
		0xb69f
		},
		{
		0xc5e0
		},
		{
		0xb6a0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_72[]=
	{
		{
		0xc5db
		},
		{
		0xc5dc
		},
		{
		0xb695
		},
		{
		0xc5dd
		},
		{
		0xb696
		},
		{
		0xc5de
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_73[]=
	{
		{
		0xc5d7
		},
		{
		0xc5d8
		},
		{
		0xb689
		},
		{
		0xb68a
		},
		{
		0xc5d9
		},
		{
		0xb68b
		},
		{
		0xb68c
		},
		{
		0xb68d
		},
		{
		0xc5da
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_74[]=
	{
		{
		0xc5cd
		},
		{
		0xc5ce
		},
		{
		0xb671
		},
		{
		0xb672
		},
		{
		0xc5cf
		},
		{
		0xb673
		},
		{
		0xb674
		},
		{
		0xb675
		},
		{
		0xc5d0
		},
		{
		0xb676
		},
		{
		0xc5d1
		},
		{
		0xb677
		},
		{
		0xb678
		},
		{
		0xb679
		},
		{
		0xb67a
		},
		{
		0xb681
		},
		{
		0xc5d2
		},
		{
		0xc5d3
		},
		{
		0xb682
		},
		{
		0xc5d4
		},
		{
		0xc5d5
		},
		{
		0xc5d6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_75[]=
	{
		{
		0xc5c6
		},
		{
		0xc5c7
		},
		{
		0xb58e
		},
		{
		0xc5c8
		},
		{
		0xc5c9
		},
		{
		0xc5ca
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_76[]=
	{
		{
		0xb581
		},
		{
		0xc5c2
		},
		{
		0xc5c3
		},
		{
		0xb582
		},
		{
		0xb583
		},
		{
		0xc5c4
		},
		{
		0xb584
		},
		{
		0xb585
		},
		{
		0xb586
		},
		{
		0xc5c5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_77[]=
	{
		{
		0xc5bd
		},
		{
		0xc5be
		},
		{
		0xb575
		},
		{
		0xc5bf
		},
		{
		0xc5c0
		},
		{
		0xc5c1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_78[]=
	{
		{
		0xc5b8
		},
		{
		0xc5b9
		},
		{
		0xb56a
		},
		{
		0xb56b
		},
		{
		0xc5ba
		},
		{
		0xb56c
		},
		{
		0xb56d
		},
		{
		0xb56e
		},
		{
		0xc5bb
		},
		{
		0xc5bc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_79[]=
	{
		{
		0xb561
		},
		{
		0xc5b4
		},
		{
		0xc5b5
		},
		{
		0xb562
		},
		{
		0xc5b6
		},
		{
		0xb563
		},
		{
		0xc5b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_80[]=
	{
		{
		0xc5b0
		},
		{
		0xc5b1
		},
		{
		0xb550
		},
		{
		0xb551
		},
		{
		0xc5b2
		},
		{
		0xb552
		},
		{
		0xb553
		},
		{
		0xb554
		},
		{
		0xc5b3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_81[]=
	{
		{
		0xc5ad
		},
		{
		0xc5ae
		},
		{
		0xb48b
		},
		{
		0xb48c
		},
		{
		0xb48d
		},
		{
		0xc5af
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_82[]=
	{
		{
		0xc5a9
		},
		{
		0xc5aa
		},
		{
		0xb479
		},
		{
		0xb47a
		},
		{
		0xc5ab
		},
		{
		0xb481
		},
		{
		0xb482
		},
		{
		0xb483
		},
		{
		0xc5ac
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_83[]=
	{
		{
		0xc5a5
		},
		{
		0xb461
		},
		{
		0xb462
		},
		{
		0xb463
		},
		{
		0xc5a6
		},
		{
		0xb464
		},
		{
		0xb465
		},
		{
		0xb466
		},
		{
		0xc5a7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_84[]=
	{
		{
		0xc5a1
		},
		{
		0xc5a2
		},
		{
		0xb453
		},
		{
		0xc5a3
		},
		{
		0xb454
		},
		{
		0xc5a4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_85[]=
	{
		{
		0xc4fb
		},
		{
		0xc4fc
		},
		{
		0xb447
		},
		{
		0xb448
		},
		{
		0xc4fd
		},
		{
		0xb449
		},
		{
		0xb44a
		},
		{
		0xb44b
		},
		{
		0xc4fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_86[]=
	{
		{
		0xc4f5
		},
		{
		0xb36f
		},
		{
		0xb370
		},
		{
		0xb371
		},
		{
		0xc4f6
		},
		{
		0xb372
		},
		{
		0xb373
		},
		{
		0xb374
		},
		{
		0xc4f7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_87[]=
	{
		{
		0xc4f1
		},
		{
		0xc4f2
		},
		{
		0xb367
		},
		{
		0xc4f3
		},
		{
		0xb368
		},
		{
		0xc4f4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_88[]=
	{
		{
		0xc4ed
		},
		{
		0xc4ee
		},
		{
		0xb355
		},
		{
		0xb356
		},
		{
		0xc4ef
		},
		{
		0xb357
		},
		{
		0xb358
		},
		{
		0xb359
		},
		{
		0xc4f0
		},
		{
		0xb35a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_89[]=
	{
		{
		0xc4e6
		},
		{
		0xb250
		},
		{
		0xb251
		},
		{
		0xb252
		},
		{
		0xb253
		},
		{
		0xc4e7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_90[]=
	{
		{
		0xc4de
		},
		{
		0xc4df
		},
		{
		0xb19c
		},
		{
		0xc4e0
		},
		{
		0xb19d
		},
		{
		0xc4e1
		},
		{
		0xb19e
		},
		{
		0xb19f
		},
		{
		0xb1a0
		},
		{
		0xb241
		},
		{
		0xb242
		},
		{
		0xb243
		},
		{
		0xc4e2
		},
		{
		0xc4e3
		},
		{
		0xb244
		},
		{
		0xb245
		},
		{
		0xc4e4
		},
		{
		0xb246
		},
		{
		0xb247
		},
		{
		0xb248
		},
		{
		0xc4e5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_91[]=
	{
		{
		0xc4da
		},
		{
		0xc4db
		},
		{
		0xb190
		},
		{
		0xb191
		},
		{
		0xc4dc
		},
		{
		0xb192
		},
		{
		0xb193
		},
		{
		0xb194
		},
		{
		0xc4dd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_92[]=
	{
		{
		0xc4d4
		},
		{
		0xc4d5
		},
		{
		0xb168
		},
		{
		0xc4d6
		},
		{
		0xc4d7
		},
		{
		0xc4d8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_93[]=
	{
		{
		0xc4d1
		},
		{
		0xb155
		},
		{
		0xb156
		},
		{
		0xb157
		},
		{
		0xc4d2
		},
		{
		0xb158
		},
		{
		0xb159
		},
		{
		0xb15a
		},
		{
		0xc4d3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_94[]=
	{
		{
		0xc4cd
		},
		{
		0xc4ce
		},
		{
		0xb14d
		},
		{
		0xc4cf
		},
		{
		0xb14e
		},
		{
		0xc4d0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_95[]=
	{
		{
		0xc4c9
		},
		{
		0xc4ca
		},
		{
		0xb141
		},
		{
		0xb142
		},
		{
		0xc4cb
		},
		{
		0xb143
		},
		{
		0xb144
		},
		{
		0xb145
		},
		{
		0xc4cc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_96[]=
	{
		{
		0xc4c4
		},
		{
		0xc4c5
		},
		{
		0xb09a
		},
		{
		0xc4c6
		},
		{
		0xc4c7
		},
		{
		0xc4c8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_97[]=
	{
		{
		0xc4bf
		},
		{
		0xc4c0
		},
		{
		0xb08f
		},
		{
		0xb090
		},
		{
		0xc4c1
		},
		{
		0xb091
		},
		{
		0xb092
		},
		{
		0xc4c2
		},
		{
		0xc4c3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_98[]=
	{
		{
		0xc4b7
		},
		{
		0xc4b8
		},
		{
		0xb047
		},
		{
		0xc4b9
		},
		{
		0xc4ba
		},
		{
		0xc4bb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_99[]=
	{
		{
		0xc4b3
		},
		{
		0xc4b4
		},
		{
		0xaf9b
		},
		{
		0xaf9c
		},
		{
		0xc4b5
		},
		{
		0xaf9d
		},
		{
		0xaf9e
		},
		{
		0xaf9f
		},
		{
		0xc4b6
		},
		{
		0xafa0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_100[]=
	{
		{
		0xc4af
		},
		{
		0xc4b0
		},
		{
		0xaf93
		},
		{
		0xc4b1
		},
		{
		0xaf94
		},
		{
		0xc4b2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_101[]=
	{
		{
		0xc4ab
		},
		{
		0xc4ac
		},
		{
		0xaf87
		},
		{
		0xaf88
		},
		{
		0xc4ad
		},
		{
		0xaf89
		},
		{
		0xaf8a
		},
		{
		0xaf8b
		},
		{
		0xc4ae
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_102[]=
	{
		{
		0xc4a7
		},
		{
		0xc4a8
		},
		{
		0xaf79
		},
		{
		0xc4a9
		},
		{
		0xaf7a
		},
		{
		0xc4aa
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_103[]=
	{
		{
		0xc4a1
		},
		{
		0xc4a2
		},
		{
		0xaf6f
		},
		{
		0xaf70
		},
		{
		0xc4a3
		},
		{
		0xaf71
		},
		{
		0xaf72
		},
		{
		0xc4a4
		},
		{
		0xc4a5
		},
		{
		0xc4a6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_104[]=
	{
		{
		0xc3f7
		},
		{
		0xc3f8
		},
		{
		0xae99
		},
		{
		0xae9a
		},
		{
		0xc3f9
		},
		{
		0xae9b
		},
		{
		0xae9c
		},
		{
		0xae9d
		},
		{
		0xc3fa
		},
		{
		0xae9e
		},
		{
		0xae9f
		},
		{
		0xaea0
		},
		{
		0xaf41
		},
		{
		0xaf42
		},
		{
		0xaf43
		},
		{
		0xaf44
		},
		{
		0xc3fb
		},
		{
		0xc3fc
		},
		{
		0xaf45
		},
		{
		0xc3fd
		},
		{
		0xaf46
		},
		{
		0xc3fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_105[]=
	{
		{
		0xc3f5
		},
		{
		0xae8f
		},
		{
		0xae90
		},
		{
		0xae91
		},
		{
		0xae92
		},
		{
		0xc3f6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_106[]=
	{
		{
		0xae81
		},
		{
		0xc3f2
		},
		{
		0xae82
		},
		{
		0xae83
		},
		{
		0xae84
		},
		{
		0xc3f3
		},
		{
		0xae85
		},
		{
		0xae86
		},
		{
		0xae87
		},
		{
		0xc3f4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_107[]=
	{
		{
		0xc3ee
		},
		{
		0xc3ef
		},
		{
		0xae74
		},
		{
		0xc3f0
		},
		{
		0xae75
		},
		{
		0xc3f1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_108[]=
	{
		{
		0xc3eb
		},
		{
		0xae67
		},
		{
		0xae68
		},
		{
		0xae69
		},
		{
		0xc3ec
		},
		{
		0xae6a
		},
		{
		0xae6b
		},
		{
		0xae6c
		},
		{
		0xc3ed
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_109[]=
	{
		{
		0xc3e9
		},
		{
		0xae47
		},
		{
		0xae48
		},
		{
		0xae49
		},
		{
		0xc3ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_110[]=
	{
		{
		0xc3df
		},
		{
		0xc3e0
		},
		{
		0xad73
		},
		{
		0xad74
		},
		{
		0xc3e1
		},
		{
		0xad75
		},
		{
		0xad76
		},
		{
		0xad77
		},
		{
		0xc3e2
		},
		{
		0xad78
		},
		{
		0xad79
		},
		{
		0xad7a
		},
		{
		0xad81
		},
		{
		0xad82
		},
		{
		0xad83
		},
		{
		0xad84
		},
		{
		0xc3e3
		},
		{
		0xc3e4
		},
		{
		0xad85
		},
		{
		0xc3e5
		},
		{
		0xad86
		},
		{
		0xc3e6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_111[]=
	{
		{
		0xc3d9
		},
		{
		0xc3da
		},
		{
		0xad4b
		},
		{
		0xc3db
		},
		{
		0xad4c
		},
		{
		0xc3dc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_112[]=
	{
		{
		0xc3d6
		},
		{
		0xac9e
		},
		{
		0xac9f
		},
		{
		0xaca0
		},
		{
		0xc3d7
		},
		{
		0xad41
		},
		{
		0xad42
		},
		{
		0xad43
		},
		{
		0xc3d8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_113[]=
	{
		{
		0xc3ce
		},
		{
		0xc3cf
		},
		{
		0xac56
		},
		{
		0xc3d0
		},
		{
		0xac57
		},
		{
		0xc3d1
		},
		{
		0xac58
		},
		{
		0xac59
		},
		{
		0xac5a
		},
		{
		0xac61
		},
		{
		0xac62
		},
		{
		0xac63
		},
		{
		0xc3d2
		},
		{
		0xac64
		},
		{
		0xac65
		},
		{
		0xac66
		},
		{
		0xc3d3
		},
		{
		0xac67
		},
		{
		0xac68
		},
		{
		0xac69
		},
		{
		0xc3d4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_114[]=
	{
		{
		0xc3ca
		},
		{
		0xc3cb
		},
		{
		0xac4a
		},
		{
		0xac4b
		},
		{
		0xc3cc
		},
		{
		0xac4c
		},
		{
		0xac4d
		},
		{
		0xac4e
		},
		{
		0xc3cd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_115[]=
	{
		{
		0xc3c7
		},
		{
		0xab91
		},
		{
		0xab92
		},
		{
		0xab93
		},
		{
		0xc3c8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_116[]=
	{
		{
		0xc3c4
		},
		{
		0xab72
		},
		{
		0xab73
		},
		{
		0xab74
		},
		{
		0xc3c5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_117[]=
	{
		{
		0xc3c0
		},
		{
		0xc3c1
		},
		{
		0xab6a
		},
		{
		0xc3c2
		},
		{
		0xab6b
		},
		{
		0xc3c3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_118[]=
	{
		{
		0xc3bc
		},
		{
		0xc3bd
		},
		{
		0xab58
		},
		{
		0xab59
		},
		{
		0xc3be
		},
		{
		0xab5a
		},
		{
		0xab61
		},
		{
		0xab62
		},
		{
		0xc3bf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_119[]=
	{
		{
		0xc3b7
		},
		{
		0xc3b8
		},
		{
		0xab51
		},
		{
		0xc3b9
		},
		{
		0xc3ba
		},
		{
		0xc3bb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_120[]=
	{
		{
		0xab41
		},
		{
		0xab42
		},
		{
		0xab43
		},
		{
		0xab44
		},
		{
		0xc3b3
		},
		{
		0xc3b4
		},
		{
		0xab45
		},
		{
		0xab46
		},
		{
		0xc3b5
		},
		{
		0xab47
		},
		{
		0xab48
		},
		{
		0xab49
		},
		{
		0xc3b6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_121[]=
	{
		{
		0xc3b1
		},
		{
		0xaa79
		},
		{
		0xaa7a
		},
		{
		0xaa81
		},
		{
		0xaa82
		},
		{
		0xc3b2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_122[]=
	{
		{
		0xc3ad
		},
		{
		0xaa6d
		},
		{
		0xaa6e
		},
		{
		0xaa6f
		},
		{
		0xc3ae
		},
		{
		0xaa70
		},
		{
		0xc3af
		},
		{
		0xaa71
		},
		{
		0xc3b0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_123[]=
	{
		{
		0xc3a8
		},
		{
		0xc3a9
		},
		{
		0xaa66
		},
		{
		0xc3aa
		},
		{
		0xc3ab
		},
		{
		0xc3ac
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_124[]=
	{
		{
		0xc3a4
		},
		{
		0xc3a5
		},
		{
		0xaa54
		},
		{
		0xaa55
		},
		{
		0xc3a6
		},
		{
		0xaa56
		},
		{
		0xaa57
		},
		{
		0xaa58
		},
		{
		0xc3a7
		},
		{
		0xaa59
		},
		{
		0xaa5a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_125[]=
	{
		{
		0xc2fc
		},
		{
		0xc2fd
		},
		{
		0xaa4e
		},
		{
		0xc2fe
		},
		{
		0xc3a1
		},
		{
		0xc3a2
		},
		{
		0xc3a3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_126[]=
	{
		{
		0xc2f2
		},
		{
		0xc2f3
		},
		{
		0xa99c
		},
		{
		0xa99d
		},
		{
		0xa99e
		},
		{
		0xc2f4
		},
		{
		0xc2f5
		},
		{
		0xa99f
		},
		{
		0xa9a0
		},
		{
		0xaa41
		},
		{
		0xaa42
		},
		{
		0xc2f6
		},
		{
		0xc2f7
		},
		{
		0xc2f8
		},
		{
		0xaa43
		},
		{
		0xaa44
		},
		{
		0xc2f9
		},
		{
		0xaa45
		},
		{
		0xc2fa
		},
		{
		0xaa46
		},
		{
		0xc2fb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_127[]=
	{
		{
		0xc2ee
		},
		{
		0xc2ef
		},
		{
		0xa990
		},
		{
		0xa991
		},
		{
		0xc2f0
		},
		{
		0xa992
		},
		{
		0xa993
		},
		{
		0xa994
		},
		{
		0xc2f1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_128[]=
	{
		{
		0xa961
		},
		{
		0xa962
		},
		{
		0xa963
		},
		{
		0xa964
		},
		{
		0xc2eb
		},
		{
		0xa965
		},
		{
		0xa966
		},
		{
		0xc2ec
		},
		{
		0xa967
		},
		{
		0xc2ed
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_129[]=
	{
		{
		0xc2e2
		},
		{
		0xc2e3
		},
		{
		0xa790
		},
		{
		0xa791
		},
		{
		0xa792
		},
		{
		0xc2e4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_130[]=
	{
		{
		0xc2dd
		},
		{
		0xa778
		},
		{
		0xa779
		},
		{
		0xa77a
		},
		{
		0xa781
		},
		{
		0xa782
		},
		{
		0xa783
		},
		{
		0xc2de
		},
		{
		0xc2df
		},
		{
		0xa784
		},
		{
		0xa785
		},
		{
		0xc2e0
		},
		{
		0xa786
		},
		{
		0xa787
		},
		{
		0xa788
		},
		{
		0xc2e1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_131[]=
	{
		{
		0xc2d8
		},
		{
		0xa746
		},
		{
		0xa747
		},
		{
		0xa748
		},
		{
		0xc2d9
		},
		{
		0xa749
		},
		{
		0xa74a
		},
		{
		0xa74b
		},
		{
		0xc2da
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_132[]=
	{
		{
		0xa681
		},
		{
		0xa682
		},
		{
		0xa683
		},
		{
		0xa684
		},
		{
		0xc2d5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_133[]=
	{
		{
		0xc2cd
		},
		{
		0xc2ce
		},
		{
		0xa667
		},
		{
		0xc2cf
		},
		{
		0xa668
		},
		{
		0xc2d0
		},
		{
		0xa669
		},
		{
		0xc2d1
		},
		{
		0xa66a
		},
		{
		0xa66b
		},
		{
		0xa66c
		},
		{
		0xa66d
		},
		{
		0xc2d2
		},
		{
		0xc2d3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_134[]=
	{
		{
		0xc2c9
		},
		{
		0xc2ca
		},
		{
		0xa655
		},
		{
		0xa656
		},
		{
		0xc2cb
		},
		{
		0xa657
		},
		{
		0xa658
		},
		{
		0xa659
		},
		{
		0xc2cc
		},
		{
		0xa65a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_135[]=
	{
		{
		0xc2c0
		},
		{
		0xc2c1
		},
		{
		0xa552
		},
		{
		0xc2c2
		},
		{
		0xc2c3
		},
		{
		0xc2c4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_136[]=
	{
		{
		0xc2bc
		},
		{
		0xc2bd
		},
		{
		0xa546
		},
		{
		0xa547
		},
		{
		0xc2be
		},
		{
		0xa548
		},
		{
		0xa549
		},
		{
		0xa54a
		},
		{
		0xc2bf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_137[]=
	{
		{
		0xc2b9
		},
		{
		0xa46b
		},
		{
		0xa46c
		},
		{
		0xa46d
		},
		{
		0xc2ba
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_138[]=
	{
		{
		0xc2b0
		},
		{
		0xc2b1
		},
		{
		0xa452
		},
		{
		0xa453
		},
		{
		0xc2b2
		},
		{
		0xa454
		},
		{
		0xa455
		},
		{
		0xa456
		},
		{
		0xc2b3
		},
		{
		0xa457
		},
		{
		0xa458
		},
		{
		0xa459
		},
		{
		0xa45a
		},
		{
		0xa461
		},
		{
		0xa462
		},
		{
		0xa463
		},
		{
		0xc2b4
		},
		{
		0xc2b5
		},
		{
		0xa464
		},
		{
		0xc2b6
		},
		{
		0xc2b7
		},
		{
		0xc2b8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_139[]=
	{
		{
		0xc1fc
		},
		{
		0xc1fd
		},
		{
		0xa39c
		},
		{
		0xc1fe
		},
		{
		0xa39d
		},
		{
		0xc2a1
		},
		{
		0xc2a2
		},
		{
		0xa39e
		},
		{
		0xa39f
		},
		{
		0xc2a3
		},
		{
		0xc2a4
		},
		{
		0xa3a0
		},
		{
		0xc2a5
		},
		{
		0xc2a6
		},
		{
		0xa441
		},
		{
		0xa442
		},
		{
		0xc2a7
		},
		{
		0xa443
		},
		{
		0xc2a8
		},
		{
		0xa444
		},
		{
		0xc2a9
		},
		{
		0xa445
		},
		{
		0xa446
		},
		{
		0xc2aa
		},
		{
		0xa447
		},
		{
		0xa448
		},
		{
		0xa449
		},
		{
		0xa44a
		},
		{
		0xc2ab
		},
		{
		0xc2ac
		},
		{
		0xa44b
		},
		{
		0xc2ad
		},
		{
		0xc2ae
		},
		{
		0xc2af
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_140[]=
	{
		{
		0xc1f6
		},
		{
		0xc1f7
		},
		{
		0xa392
		},
		{
		0xa393
		},
		{
		0xc1f8
		},
		{
		0xa394
		},
		{
		0xa395
		},
		{
		0xc1f9
		},
		{
		0xc1fa
		},
		{
		0xa396
		},
		{
		0xc1fb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_141[]=
	{
		{
		0xc1f2
		},
		{
		0xc1f3
		},
		{
		0xa368
		},
		{
		0xc1f4
		},
		{
		0xa369
		},
		{
		0xc1f5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_142[]=
	{
		{
		0xc1ee
		},
		{
		0xc1ef
		},
		{
		0xa356
		},
		{
		0xa357
		},
		{
		0xc1f0
		},
		{
		0xa358
		},
		{
		0xa359
		},
		{
		0xa35a
		},
		{
		0xc1f1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_143[]=
	{
		{
		0xc1ea
		},
		{
		0xa29e
		},
		{
		0xa29f
		},
		{
		0xa2a0
		},
		{
		0xc1eb
		},
		{
		0xa341
		},
		{
		0xa342
		},
		{
		0xa343
		},
		{
		0xc1ec
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_144[]=
	{
		{
		0xc1e3
		},
		{
		0xc1e4
		},
		{
		0xa289
		},
		{
		0xa28a
		},
		{
		0xc1e5
		},
		{
		0xa28b
		},
		{
		0xa28c
		},
		{
		0xa28d
		},
		{
		0xc1e6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_145[]=
	{
		{
		0xc1dc
		},
		{
		0xc1dd
		},
		{
		0xa1a0
		},
		{
		0xc1de
		},
		{
		0xa241
		},
		{
		0xc1df
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_146[]=
	{
		{
		0xc1d6
		},
		{
		0xc1d7
		},
		{
		0xa196
		},
		{
		0xa197
		},
		{
		0xc1d8
		},
		{
		0xa198
		},
		{
		0xa199
		},
		{
		0xa19a
		},
		{
		0xc1d9
		},
		{
		0xc1da
		},
		{
		0xc1db
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_147[]=
	{
		{
		0xc1d2
		},
		{
		0xc1d3
		},
		{
		0xa178
		},
		{
		0xa179
		},
		{
		0xc1d4
		},
		{
		0xa17a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_148[]=
	{
		{
		0xc1ce
		},
		{
		0xc1cf
		},
		{
		0xa170
		},
		{
		0xc1d0
		},
		{
		0xa171
		},
		{
		0xc1d1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_149[]=
	{
		{
		0xc1c9
		},
		{
		0xc1ca
		},
		{
		0xa157
		},
		{
		0xa158
		},
		{
		0xa159
		},
		{
		0xa15a
		},
		{
		0xa161
		},
		{
		0xa162
		},
		{
		0xc1cb
		},
		{
		0xa163
		},
		{
		0xa164
		},
		{
		0xa165
		},
		{
		0xc1cc
		},
		{
		0xa166
		},
		{
		0xa167
		},
		{
		0xa168
		},
		{
		0xc1cd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_150[]=
	{
		{
		0xc1c5
		},
		{
		0xa0fa
		},
		{
		0xc1c6
		},
		{
		0xa0fb
		},
		{
		0xc1c7
		},
		{
		0xa0fc
		},
		{
		0xa0fd
		},
		{
		0xa0fe
		},
		{
		0xa141
		},
		{
		0xa142
		},
		{
		0xa143
		},
		{
		0xc1c8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_151[]=
	{
		{
		0xc1bb
		},
		{
		0xc1bc
		},
		{
		0xa0e7
		},
		{
		0xc1bd
		},
		{
		0xa0e8
		},
		{
		0xc1be
		},
		{
		0xc1bf
		},
		{
		0xc1c0
		},
		{
		0xa0e9
		},
		{
		0xa0ea
		},
		{
		0xa0eb
		},
		{
		0xc1c1
		},
		{
		0xc1c2
		},
		{
		0xc1c3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_152[]=
	{
		{
		0xc1b6
		},
		{
		0xc1b7
		},
		{
		0xa0dc
		},
		{
		0xa0dd
		},
		{
		0xc1b8
		},
		{
		0xa0de
		},
		{
		0xa0df
		},
		{
		0xa0e0
		},
		{
		0xc1b9
		},
		{
		0xa0e1
		},
		{
		0xc1ba
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_153[]=
	{
		{
		0xc1b1
		},
		{
		0xc1b2
		},
		{
		0xa0b9
		},
		{
		0xa0ba
		},
		{
		0xc1b3
		},
		{
		0xc1b4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_154[]=
	{
		{
		0xc1ae
		},
		{
		0xa0ac
		},
		{
		0xa0ad
		},
		{
		0xa0ae
		},
		{
		0xc1af
		},
		{
		0xa0af
		},
		{
		0xa0b0
		},
		{
		0xa0b1
		},
		{
		0xc1b0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_155[]=
	{
		{
		0xc1aa
		},
		{
		0xc1ab
		},
		{
		0xa0a4
		},
		{
		0xc1ac
		},
		{
		0xa0a5
		},
		{
		0xc1ad
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_156[]=
	{
		{
		0xc1a6
		},
		{
		0xc1a7
		},
		{
		0xa098
		},
		{
		0xa099
		},
		{
		0xc1a8
		},
		{
		0xa09a
		},
		{
		0xa09b
		},
		{
		0xa09c
		},
		{
		0xc1a9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_157[]=
	{
		{
		0xc1a1
		},
		{
		0xc1a2
		},
		{
		0xa091
		},
		{
		0xc1a3
		},
		{
		0xa092
		},
		{
		0xc1a4
		},
		{
		0xc1a5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_158[]=
	{
		{
		0xc0fa
		},
		{
		0xc0fb
		},
		{
		0xa086
		},
		{
		0xa087
		},
		{
		0xc0fc
		},
		{
		0xa088
		},
		{
		0xa089
		},
		{
		0xa08a
		},
		{
		0xc0fd
		},
		{
		0xa08b
		},
		{
		0xc0fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_159[]=
	{
		{
		0xc0f7
		},
		{
		0xa067
		},
		{
		0xa068
		},
		{
		0xa069
		},
		{
		0xc0f8
		},
		{
		0xa06a
		},
		{
		0xa06b
		},
		{
		0xa06c
		},
		{
		0xc0f9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_160[]=
	{
		{
		0xc0f5
		},
		{
		0xa057
		},
		{
		0xa058
		},
		{
		0xa059
		},
		{
		0xa05a
		},
		{
		0xc0f6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_161[]=
	{
		{
		0xc0f0
		},
		{
		0xc0f1
		},
		{
		0xa04c
		},
		{
		0xa04d
		},
		{
		0xc0f2
		},
		{
		0xa04e
		},
		{
		0xc0f3
		},
		{
		0xa04f
		},
		{
		0xc0f4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_162[]=
	{
		{
		0xc0e7
		},
		{
		0xc0e8
		},
		{
		0x9ff7
		},
		{
		0x9ff8
		},
		{
		0xc0e9
		},
		{
		0x9ff9
		},
		{
		0x9ffa
		},
		{
		0x9ffb
		},
		{
		0xc0ea
		},
		{
		0x9ffc
		},
		{
		0x9ffd
		},
		{
		0x9ffe
		},
		{
		0xa041
		},
		{
		0xa042
		},
		{
		0xa043
		},
		{
		0xa044
		},
		{
		0xc0eb
		},
		{
		0xc0ec
		},
		{
		0xa045
		},
		{
		0xc0ed
		},
		{
		0xc0ee
		},
		{
		0xc0ef
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_163[]=
	{
		{
		0xc0e1
		},
		{
		0xc0e2
		},
		{
		0x9ff1
		},
		{
		0xc0e3
		},
		{
		0xc0e4
		},
		{
		0xc0e5
		},
		{
		0xc0e6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_164[]=
	{
		{
		0xc0cc
		},
		{
		0xc0cd
		},
		{
		0x9fda
		},
		{
		0x9fdb
		},
		{
		0xc0ce
		},
		{
		0x9fdc
		},
		{
		0x9fdd
		},
		{
		0x9fde
		},
		{
		0xc0cf
		},
		{
		0xc0d0
		},
		{
		0xc0d1
		},
		{
		0x9fdf
		},
		{
		0x9fe0
		},
		{
		0x9fe1
		},
		{
		0x9fe2
		},
		{
		0xc0d2
		},
		{
		0xc0d3
		},
		{
		0xc0d4
		},
		{
		0x9fe3
		},
		{
		0xc0d5
		},
		{
		0xc0d6
		},
		{
		0xc0d7
		},
		{
		0xc0d8
		},
		{
		0x9fe4
		},
		{
		0x9fe5
		},
		{
		0x9fe6
		},
		{
		0xc0d9
		},
		{
		0x9fe7
		},
		{
		0xc0da
		},
		{
		0xc0db
		},
		{
		0x9fe8
		},
		{
		0x9fe9
		},
		{
		0xc0dc
		},
		{
		0x9fea
		},
		{
		0xc0dd
		},
		{
		0xc0de
		},
		{
		0xc0df
		},
		{
		0x9feb
		},
		{
		0xc0e0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_165[]=
	{
		{
		0x9fc3
		},
		{
		0x9fc4
		},
		{
		0x9fc5
		},
		{
		0xc0c8
		},
		{
		0x9fc6
		},
		{
		0x9fc7
		},
		{
		0x9fc8
		},
		{
		0xc0c9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_166[]=
	{
		{
		0xc0bc
		},
		{
		0x9fc0
		},
		{
		0xc0bd
		},
		{
		0xc0be
		},
		{
		0x9fc1
		},
		{
		0xc0bf
		},
		{
		0x9fc2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_167[]=
	{
		{
		0xc0b3
		},
		{
		0xc0b4
		},
		{
		0x9faf
		},
		{
		0xc0b5
		},
		{
		0x9fb0
		},
		{
		0xc0b6
		},
		{
		0x9fb1
		},
		{
		0xc0b7
		},
		{
		0x9fb2
		},
		{
		0x9fb3
		},
		{
		0x9fb4
		},
		{
		0x9fb5
		},
		{
		0xc0b8
		},
		{
		0xc0b9
		},
		{
		0x9fb6
		},
		{
		0x9fb7
		},
		{
		0xc0ba
		},
		{
		0x9fb8
		},
		{
		0x9fb9
		},
		{
		0x9fba
		},
		{
		0xc0bb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_168[]=
	{
		{
		0xc0af
		},
		{
		0xc0b0
		},
		{
		0x9fa3
		},
		{
		0x9fa4
		},
		{
		0xc0b1
		},
		{
		0x9fa5
		},
		{
		0x9fa6
		},
		{
		0x9fa7
		},
		{
		0xc0b2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_169[]=
	{
		{
		0xc0ab
		},
		{
		0xc0ac
		},
		{
		0x9f9b
		},
		{
		0xc0ad
		},
		{
		0x9f9c
		},
		{
		0xc0ae
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_170[]=
	{
		{
		0xc0a7
		},
		{
		0xc0a8
		},
		{
		0x9f8f
		},
		{
		0x9f90
		},
		{
		0xc0a9
		},
		{
		0x9f91
		},
		{
		0x9f92
		},
		{
		0x9f93
		},
		{
		0xc0aa
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_171[]=
	{
		{
		0xc0a4
		},
		{
		0xc0a5
		},
		{
		0x9f86
		},
		{
		0x9f87
		},
		{
		0x9f88
		},
		{
		0xc0a6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_172[]=
	{
		{
		0xbffe
		},
		{
		0xc0a1
		},
		{
		0x9f74
		},
		{
		0x9f75
		},
		{
		0xc0a2
		},
		{
		0x9f76
		},
		{
		0x9f77
		},
		{
		0x9f78
		},
		{
		0xc0a3
		},
		{
		0x9f79
		},
		{
		0x9f7a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_173[]=
	{
		{
		0xbffa
		},
		{
		0xbffb
		},
		{
		0x9f6c
		},
		{
		0x9f6d
		},
		{
		0xbffc
		},
		{
		0xbffd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_174[]=
	{
		{
		0xbff6
		},
		{
		0xbff7
		},
		{
		0x9f5a
		},
		{
		0x9f61
		},
		{
		0xbff8
		},
		{
		0x9f62
		},
		{
		0x9f63
		},
		{
		0x9f64
		},
		{
		0xbff9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_175[]=
	{
		{
		0xbff2
		},
		{
		0xbff3
		},
		{
		0x9f52
		},
		{
		0xbff4
		},
		{
		0x9f53
		},
		{
		0xbff5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_176[]=
	{
		{
		0xbfec
		},
		{
		0xbfed
		},
		{
		0x9f48
		},
		{
		0x9f49
		},
		{
		0xbfee
		},
		{
		0x9f4a
		},
		{
		0x9f4b
		},
		{
		0x9f4c
		},
		{
		0xbfef
		},
		{
		0xbff0
		},
		{
		0xbff1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_177[]=
	{
		{
		0xbfe8
		},
		{
		0xbfe9
		},
		{
		0x9efe
		},
		{
		0xbfea
		},
		{
		0x9f41
		},
		{
		0xbfeb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_178[]=
	{
		{
		0xbfe4
		},
		{
		0xbfe5
		},
		{
		0x9ef2
		},
		{
		0x9ef3
		},
		{
		0xbfe6
		},
		{
		0x9ef4
		},
		{
		0x9ef5
		},
		{
		0x9ef6
		},
		{
		0xbfe7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_179[]=
	{
		{
		0xbfe0
		},
		{
		0xbfe1
		},
		{
		0x9eea
		},
		{
		0xbfe2
		},
		{
		0x9eeb
		},
		{
		0xbfe3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_180[]=
	{
		{
		0xbfdc
		},
		{
		0xbfdd
		},
		{
		0x9ede
		},
		{
		0x9edf
		},
		{
		0xbfde
		},
		{
		0x9ee0
		},
		{
		0x9ee1
		},
		{
		0x9ee2
		},
		{
		0xbfdf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_181[]=
	{
		{
		0xbfd9
		},
		{
		0x9ed5
		},
		{
		0x9ed6
		},
		{
		0xbfda
		},
		{
		0x9ed7
		},
		{
		0xbfdb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_182[]=
	{
		{
		0xbfd6
		},
		{
		0xbfd7
		},
		{
		0x9ec8
		},
		{
		0x9ec9
		},
		{
		0xbfd8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_183[]=
	{
		{
		0xbfd1
		},
		{
		0xbfd2
		},
		{
		0x9ec1
		},
		{
		0xbfd3
		},
		{
		0xbfd4
		},
		{
		0xbfd5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_184[]=
	{
		{
		0xbfc0
		},
		{
		0xbfc1
		},
		{
		0x9ea6
		},
		{
		0x9ea7
		},
		{
		0xbfc2
		},
		{
		0x9ea8
		},
		{
		0x9ea9
		},
		{
		0x9eaa
		},
		{
		0xbfc3
		},
		{
		0xbfc4
		},
		{
		0xbfc5
		},
		{
		0x9eab
		},
		{
		0xbfc6
		},
		{
		0x9eac
		},
		{
		0x9ead
		},
		{
		0xbfc7
		},
		{
		0xbfc8
		},
		{
		0xbfc9
		},
		{
		0x9eae
		},
		{
		0xbfca
		},
		{
		0x9eaf
		},
		{
		0xbfcb
		},
		{
		0x9eb0
		},
		{
		0xbfcc
		},
		{
		0x9eb1
		},
		{
		0x9eb2
		},
		{
		0x9eb3
		},
		{
		0x9eb4
		},
		{
		0xbfcd
		},
		{
		0xbfce
		},
		{
		0x9eb5
		},
		{
		0x9eb6
		},
		{
		0xbfcf
		},
		{
		0x9eb7
		},
		{
		0x9eb8
		},
		{
		0x9eb9
		},
		{
		0xbfd0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_185[]=
	{
		{
		0xbfbc
		},
		{
		0xbfbd
		},
		{
		0x9e9e
		},
		{
		0xbfbe
		},
		{
		0xbfbf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_186[]=
	{
		{
		0x9e8e
		},
		{
		0x9e8f
		},
		{
		0x9e90
		},
		{
		0xbfb6
		},
		{
		0xbfb7
		},
		{
		0xbfb8
		},
		{
		0xbfb9
		},
		{
		0x9e91
		},
		{
		0x9e92
		},
		{
		0x9e93
		},
		{
		0xbfba
		},
		{
		0x9e94
		},
		{
		0x9e95
		},
		{
		0x9e96
		},
		{
		0xbfbb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_187[]=
	{
		{
		0xbfa5
		},
		{
		0xbfa6
		},
		{
		0x9e77
		},
		{
		0xbfa7
		},
		{
		0x9e78
		},
		{
		0xbfa8
		},
		{
		0x9e79
		},
		{
		0x9e7a
		},
		{
		0x9e81
		},
		{
		0x9e82
		},
		{
		0x9e83
		},
		{
		0x9e84
		},
		{
		0xbfa9
		},
		{
		0xbfaa
		},
		{
		0xbfab
		},
		{
		0x9e85
		},
		{
		0xbfac
		},
		{
		0x9e86
		},
		{
		0x9e87
		},
		{
		0x9e88
		},
		{
		0xbfad
		},
		{
		0x9e89
		},
		{
		0xbfae
		},
		{
		0xbfaf
		},
		{
		0x9e8a
		},
		{
		0x9e8b
		},
		{
		0x9e8c
		},
		{
		0x9e8d
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_188[]=
	{
		{
		0x9e68
		},
		{
		0xbefd
		},
		{
		0x9e69
		},
		{
		0xbefe
		},
		{
		0x9e6a
		},
		{
		0xbfa1
		},
		{
		0xbfa2
		},
		{
		0x9e6b
		},
		{
		0x9e6c
		},
		{
		0xbfa3
		},
		{
		0x9e6d
		},
		{
		0x9e6e
		},
		{
		0x9e6f
		},
		{
		0xbfa4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_189[]=
	{
		{
		0xbeee
		},
		{
		0xbeef
		},
		{
		0x9e5a
		},
		{
		0x9e61
		},
		{
		0xbef0
		},
		{
		0xbef1
		},
		{
		0x9e62
		},
		{
		0xbef2
		},
		{
		0xbef3
		},
		{
		0xbef4
		},
		{
		0xbef5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_190[]=
	{
		{
		0xbedf
		},
		{
		0xbee0
		},
		{
		0x9def
		},
		{
		0x9df0
		},
		{
		0xbee1
		},
		{
		0x9df1
		},
		{
		0x9df2
		},
		{
		0x9df3
		},
		{
		0xbee2
		},
		{
		0x9df4
		},
		{
		0x9df5
		},
		{
		0xbee3
		},
		{
		0x9df6
		},
		{
		0x9df7
		},
		{
		0x9df8
		},
		{
		0x9df9
		},
		{
		0xbee4
		},
		{
		0xbee5
		},
		{
		0x9dfa
		},
		{
		0xbee6
		},
		{
		0x9dfb
		},
		{
		0xbee7
		},
		{
		0x9dfc
		},
		{
		0x9dfd
		},
		{
		0x9dfe
		},
		{
		0xbee8
		},
		{
		0x9e41
		},
		{
		0xbee9
		},
		{
		0xbeea
		},
		{
		0x9e42
		},
		{
		0x9e43
		},
		{
		0x9e44
		},
		{
		0xbeeb
		},
		{
		0x9e45
		},
		{
		0x9e46
		},
		{
		0x9e47
		},
		{
		0xbeec
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_191[]=
	{
		{
		0xbeda
		},
		{
		0xbedb
		},
		{
		0x9de8
		},
		{
		0xbedc
		},
		{
		0xbedd
		},
		{
		0xbede
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_192[]=
	{
		{
		0xbec6
		},
		{
		0xbec7
		},
		{
		0x9dd0
		},
		{
		0x9dd1
		},
		{
		0xbec8
		},
		{
		0xbec9
		},
		{
		0xbeca
		},
		{
		0x9dd2
		},
		{
		0xbecb
		},
		{
		0xbecc
		},
		{
		0xbecd
		},
		{
		0x9dd3
		},
		{
		0x9dd4
		},
		{
		0x9dd5
		},
		{
		0x9dd6
		},
		{
		0xbece
		},
		{
		0xbecf
		},
		{
		0xbed0
		},
		{
		0x9dd7
		},
		{
		0xbed1
		},
		{
		0xbed2
		},
		{
		0xbed3
		},
		{
		0x9dd8
		},
		{
		0x9dd9
		},
		{
		0x9dda
		},
		{
		0xbed4
		},
		{
		0xbed5
		},
		{
		0x9ddb
		},
		{
		0xbed6
		},
		{
		0xbed7
		},
		{
		0x9ddc
		},
		{
		0x9ddd
		},
		{
		0xbed8
		},
		{
		0x9dde
		},
		{
		0x9ddf
		},
		{
		0x9de0
		},
		{
		0xbed9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_193[]=
	{
		{
		0xbec2
		},
		{
		0xbec3
		},
		{
		0x9dc8
		},
		{
		0xbec4
		},
		{
		0x9dc9
		},
		{
		0xbec5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_194[]=
	{
		{
		0xbebe
		},
		{
		0xbebf
		},
		{
		0x9dbc
		},
		{
		0x9dbd
		},
		{
		0xbec0
		},
		{
		0x9dbe
		},
		{
		0x9dbf
		},
		{
		0x9dc0
		},
		{
		0xbec1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_195[]=
	{
		{
		0xbeba
		},
		{
		0x9da4
		},
		{
		0x9da5
		},
		{
		0x9da6
		},
		{
		0xbebb
		},
		{
		0x9da7
		},
		{
		0x9da8
		},
		{
		0x9da9
		},
		{
		0xbebc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_196[]=
	{
		{
		0xbeb2
		},
		{
		0xbeb3
		},
		{
		0x9d90
		},
		{
		0x9d91
		},
		{
		0xbeb4
		},
		{
		0x9d92
		},
		{
		0x9d93
		},
		{
		0x9d94
		},
		{
		0xbeb5
		},
		{
		0x9d95
		},
		{
		0xbeb6
		},
		{
		0x9d96
		},
		{
		0x9d97
		},
		{
		0x9d98
		},
		{
		0x9d99
		},
		{
		0xbeb7
		},
		{
		0xbeb8
		},
		{
		0xbeb9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_197[]=
	{
		{
		0xbeaf
		},
		{
		0x9d4f
		},
		{
		0x9d50
		},
		{
		0x9d51
		},
		{
		0xbeb0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_198[]=
	{
		{
		0xbea9
		},
		{
		0xbeaa
		},
		{
		0x9ccf
		},
		{
		0x9cd0
		},
		{
		0x9cd1
		},
		{
		0xbeab
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_199[]=
	{
		{
		0xbea5
		},
		{
		0xbea6
		},
		{
		0x9cc3
		},
		{
		0x9cc4
		},
		{
		0xbea7
		},
		{
		0x9cc5
		},
		{
		0x9cc6
		},
		{
		0x9cc7
		},
		{
		0xbea8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_200[]=
	{
		{
		0xbdfd
		},
		{
		0x9c91
		},
		{
		0x9c92
		},
		{
		0x9c93
		},
		{
		0xbdfe
		},
		{
		0x9c94
		},
		{
		0x9c95
		},
		{
		0x9c96
		},
		{
		0xbea1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_201[]=
	{
		{
		0xbdf7
		},
		{
		0xbdf8
		},
		{
		0x9c53
		},
		{
		0x9c54
		},
		{
		0xbdf9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_202[]=
	{
		{
		0xbdf4
		},
		{
		0xbdf5
		},
		{
		0x9c4a
		},
		{
		0x9c4b
		},
		{
		0x9c4c
		},
		{
		0xbdf6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_203[]=
	{
		{
		0xbdee
		},
		{
		0xbdef
		},
		{
		0x9bfe
		},
		{
		0x9c41
		},
		{
		0xbdf0
		},
		{
		0x9c42
		},
		{
		0x9c43
		},
		{
		0xbdf1
		},
		{
		0xbdf2
		},
		{
		0x9c44
		},
		{
		0xbdf3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_204[]=
	{
		{
		0xbdea
		},
		{
		0x9bae
		},
		{
		0x9baf
		},
		{
		0x9bb0
		},
		{
		0xbdeb
		},
		{
		0x9bb1
		},
		{
		0x9bb2
		},
		{
		0x9bb3
		},
		{
		0xbdec
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_205[]=
	{
		{
		0xbde6
		},
		{
		0xbde7
		},
		{
		0x9ba6
		},
		{
		0x9ba7
		},
		{
		0xbde8
		},
		{
		0xbde9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_206[]=
	{
		{
		0xbde1
		},
		{
		0xbde2
		},
		{
		0x9b9b
		},
		{
		0x9b9c
		},
		{
		0xbde3
		},
		{
		0x9b9d
		},
		{
		0x9b9e
		},
		{
		0x9b9f
		},
		{
		0xbde4
		},
		{
		0x9ba0
		},
		{
		0xbde5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_207[]=
	{
		{
		0xbddc
		},
		{
		0xbddd
		},
		{
		0x9b50
		},
		{
		0x9b51
		},
		{
		0xbdde
		},
		{
		0xbddf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_208[]=
	{
		{
		0xbdd3
		},
		{
		0xbdd4
		},
		{
		0x9afb
		},
		{
		0x9afc
		},
		{
		0xbdd5
		},
		{
		0xbdd6
		},
		{
		0x9afd
		},
		{
		0x9afe
		},
		{
		0x9b41
		},
		{
		0x9b42
		},
		{
		0x9b43
		},
		{
		0xbdd7
		},
		{
		0xbdd8
		},
		{
		0xbdd9
		},
		{
		0x9b44
		},
		{
		0x9b45
		},
		{
		0xbdda
		},
		{
		0x9b46
		},
		{
		0x9b47
		},
		{
		0x9b48
		},
		{
		0xbddb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_209[]=
	{
		{
		0xbdc8
		},
		{
		0xbdc9
		},
		{
		0xbdca
		},
		{
		0x9ae9
		},
		{
		0xbdcb
		},
		{
		0x9aea
		},
		{
		0xbdcc
		},
		{
		0x9aeb
		},
		{
		0x9aec
		},
		{
		0x9aed
		},
		{
		0x9aee
		},
		{
		0xbdcd
		},
		{
		0x9aef
		},
		{
		0xbdce
		},
		{
		0xbdcf
		},
		{
		0x9af0
		},
		{
		0xbdd0
		},
		{
		0xbdd1
		},
		{
		0x9af1
		},
		{
		0x9af2
		},
		{
		0x9af3
		},
		{
		0xbdd2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_210[]=
	{
		{
		0xbdc3
		},
		{
		0xbdc4
		},
		{
		0x9adf
		},
		{
		0x9ae0
		},
		{
		0xbdc5
		},
		{
		0x9ae1
		},
		{
		0x9ae2
		},
		{
		0xbdc6
		},
		{
		0xbdc7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_211[]=
	{
		{
		0xbdbf
		},
		{
		0xbdc0
		},
		{
		0x9abb
		},
		{
		0xbdc1
		},
		{
		0x9abc
		},
		{
		0xbdc2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_212[]=
	{
		{
		0xbdba
		},
		{
		0xbdbb
		},
		{
		0x9ab0
		},
		{
		0x9ab1
		},
		{
		0xbdbc
		},
		{
		0x9ab2
		},
		{
		0x9ab3
		},
		{
		0x9ab4
		},
		{
		0xbdbd
		},
		{
		0xbdbe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_213[]=
	{
		{
		0xbdb7
		},
		{
		0x9aa7
		},
		{
		0x9aa8
		},
		{
		0xbdb8
		},
		{
		0x9aa9
		},
		{
		0xbdb9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_214[]=
	{
		{
		0xbdb0
		},
		{
		0xbdb1
		},
		{
		0x9a92
		},
		{
		0xbdb2
		},
		{
		0x9a93
		},
		{
		0xbdb3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_215[]=
	{
		{
		0xbdac
		},
		{
		0xbdad
		},
		{
		0x9a86
		},
		{
		0x9a87
		},
		{
		0xbdae
		},
		{
		0x9a88
		},
		{
		0x9a89
		},
		{
		0x9a8a
		},
		{
		0xbdaf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_216[]=
	{
		{
		0xbdaa
		},
		{
		0x9a76
		},
		{
		0x9a77
		},
		{
		0x9a78
		},
		{
		0x9a79
		},
		{
		0xbdab
		},
		{
		0x9a7a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_217[]=
	{
		{
		0xbda6
		},
		{
		0xbda7
		},
		{
		0x9a6a
		},
		{
		0x9a6b
		},
		{
		0xbda8
		},
		{
		0x9a6c
		},
		{
		0x9a6d
		},
		{
		0x9a6e
		},
		{
		0xbda9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_218[]=
	{
		{
		0xbcf6
		},
		{
		0xbcf7
		},
		{
		0x99f8
		},
		{
		0x99f9
		},
		{
		0xbcf8
		},
		{
		0x99fa
		},
		{
		0x99fb
		},
		{
		0xbcf9
		},
		{
		0xbcfa
		},
		{
		0x99fc
		},
		{
		0x99fd
		},
		{
		0x99fe
		},
		{
		0x9a41
		},
		{
		0x9a42
		},
		{
		0x9a43
		},
		{
		0x9a44
		},
		{
		0xbcfb
		},
		{
		0xbcfc
		},
		{
		0x9a45
		},
		{
		0xbcfd
		},
		{
		0x9a46
		},
		{
		0xbcfe
		},
		{
		0x9a47
		},
		{
		0xbda1
		},
		{
		0x9a48
		},
		{
		0xbda2
		},
		{
		0xbda3
		},
		{
		0x9a49
		},
		{
		0xbda4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_219[]=
	{
		{
		0xbcf2
		},
		{
		0xbcf3
		},
		{
		0x99f0
		},
		{
		0xbcf4
		},
		{
		0x99f1
		},
		{
		0xbcf5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_220[]=
	{
		{
		0xbcee
		},
		{
		0xbcef
		},
		{
		0x99e4
		},
		{
		0x99e5
		},
		{
		0xbcf0
		},
		{
		0x99e6
		},
		{
		0x99e7
		},
		{
		0x99e8
		},
		{
		0xbcf1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_221[]=
	{
		{
		0xbce8
		},
		{
		0x99ce
		},
		{
		0x99cf
		},
		{
		0x99d0
		},
		{
		0xbce9
		},
		{
		0x99d1
		},
		{
		0x99d2
		},
		{
		0x99d3
		},
		{
		0xbcea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_222[]=
	{
		{
		0xbce5
		},
		{
		0x99c5
		},
		{
		0x99c6
		},
		{
		0xbce6
		},
		{
		0xbce7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_223[]=
	{
		{
		0xbce2
		},
		{
		0x99b8
		},
		{
		0x99b9
		},
		{
		0x99ba
		},
		{
		0xbce3
		},
		{
		0x99bb
		},
		{
		0x99bc
		},
		{
		0x99bd
		},
		{
		0xbce4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_224[]=
	{
		{
		0xbcd8
		},
		{
		0xbcd9
		},
		{
		0x999a
		},
		{
		0xbcda
		},
		{
		0x999b
		},
		{
		0xbcdb
		},
		{
		0x999c
		},
		{
		0x999d
		},
		{
		0x999e
		},
		{
		0xbcdc
		},
		{
		0x999f
		},
		{
		0x99a0
		},
		{
		0xbcdd
		},
		{
		0xbcde
		},
		{
		0x99a1
		},
		{
		0x99a2
		},
		{
		0xbcdf
		},
		{
		0x99a3
		},
		{
		0x99a4
		},
		{
		0x99a5
		},
		{
		0xbce0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_225[]=
	{
		{
		0xbcd2
		},
		{
		0xbcd3
		},
		{
		0xbcd4
		},
		{
		0x9990
		},
		{
		0xbcd5
		},
		{
		0x9991
		},
		{
		0x9992
		},
		{
		0x9993
		},
		{
		0xbcd6
		},
		{
		0x9994
		},
		{
		0xbcd7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_226[]=
	{
		{
		0xbcce
		},
		{
		0x9972
		},
		{
		0x9973
		},
		{
		0x9974
		},
		{
		0xbccf
		},
		{
		0x9975
		},
		{
		0x9976
		},
		{
		0x9977
		},
		{
		0xbcd0
		},
		{
		0x9978
		},
		{
		0x9979
		},
		{
		0x997a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_227[]=
	{
		{
		0xbcc9
		},
		{
		0xbcca
		},
		{
		0x996b
		},
		{
		0xbccb
		},
		{
		0xbccc
		},
		{
		0xbccd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_228[]=
	{
		{
		0xbcc5
		},
		{
		0xbcc6
		},
		{
		0x9959
		},
		{
		0x995a
		},
		{
		0xbcc7
		},
		{
		0x9961
		},
		{
		0x9962
		},
		{
		0x9963
		},
		{
		0xbcc8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_229[]=
	{
		{
		0xbcc0
		},
		{
		0xbcc1
		},
		{
		0x9952
		},
		{
		0xbcc2
		},
		{
		0xbcc3
		},
		{
		0xbcc4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_230[]=
	{
		{
		0x98f7
		},
		{
		0x98f8
		},
		{
		0xbcb2
		},
		{
		0xbcb3
		},
		{
		0x98f9
		},
		{
		0xbcb4
		},
		{
		0xbcb5
		},
		{
		0x98fa
		},
		{
		0x98fb
		},
		{
		0x98fc
		},
		{
		0x98fd
		},
		{
		0xbcb6
		},
		{
		0xbcb7
		},
		{
		0x98fe
		},
		{
		0xbcb8
		},
		{
		0xbcb9
		},
		{
		0xbcba
		},
		{
		0x9941
		},
		{
		0x9942
		},
		{
		0x9943
		},
		{
		0x9944
		},
		{
		0xbcbb
		},
		{
		0x9945
		},
		{
		0xbcbc
		},
		{
		0xbcbd
		},
		{
		0x9946
		},
		{
		0x9947
		},
		{
		0xbcbe
		},
		{
		0x9948
		},
		{
		0x9949
		},
		{
		0x994a
		},
		{
		0xbcbf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_231[]=
	{
		{
		0xbcab
		},
		{
		0x98ed
		},
		{
		0x98ee
		},
		{
		0x98ef
		},
		{
		0x98f0
		},
		{
		0xbcac
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_232[]=
	{
		{
		0xbca8
		},
		{
		0x98e0
		},
		{
		0x98e1
		},
		{
		0x98e2
		},
		{
		0xbca9
		},
		{
		0x98e3
		},
		{
		0x98e4
		},
		{
		0x98e5
		},
		{
		0xbcaa
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_233[]=
	{
		{
		0xbca4
		},
		{
		0xbca5
		},
		{
		0x98d8
		},
		{
		0xbca6
		},
		{
		0x98d9
		},
		{
		0xbca7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_234[]=
	{
		{
		0xbbfe
		},
		{
		0xbca1
		},
		{
		0x98cc
		},
		{
		0x98cd
		},
		{
		0xbca2
		},
		{
		0x98ce
		},
		{
		0x98cf
		},
		{
		0x98d0
		},
		{
		0xbca3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_235[]=
	{
		{
		0xbbf9
		},
		{
		0xbbfa
		},
		{
		0x98c5
		},
		{
		0xbbfb
		},
		{
		0xbbfc
		},
		{
		0xbbfd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_236[]=
	{
		{
		0xbbef
		},
		{
		0xbbf0
		},
		{
		0x98b3
		},
		{
		0xbbf1
		},
		{
		0xbbf2
		},
		{
		0xbbf3
		},
		{
		0x98b4
		},
		{
		0x98b5
		},
		{
		0x98b6
		},
		{
		0xbbf4
		},
		{
		0x98b7
		},
		{
		0x98b8
		},
		{
		0xbbf5
		},
		{
		0xbbf6
		},
		{
		0x98b9
		},
		{
		0x98ba
		},
		{
		0xbbf7
		},
		{
		0x98bb
		},
		{
		0x98bc
		},
		{
		0x98bd
		},
		{
		0xbbf8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_237[]=
	{
		{
		0xbbe7
		},
		{
		0xbbe8
		},
		{
		0x98ab
		},
		{
		0xbbe9
		},
		{
		0xbbea
		},
		{
		0x98ac
		},
		{
		0x98ad
		},
		{
		0xbbeb
		},
		{
		0xbbec
		},
		{
		0xbbed
		},
		{
		0xbbee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_238[]=
	{
		{
		0xbbe3
		},
		{
		0xbbe4
		},
		{
		0x98a3
		},
		{
		0xbbe5
		},
		{
		0x98a4
		},
		{
		0xbbe6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_239[]=
	{
		{
		0xbbdf
		},
		{
		0xbbe0
		},
		{
		0x9897
		},
		{
		0x9898
		},
		{
		0xbbe1
		},
		{
		0x9899
		},
		{
		0x989a
		},
		{
		0x989b
		},
		{
		0xbbe2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_240[]=
	{
		{
		0xbbda
		},
		{
		0x9858
		},
		{
		0x9859
		},
		{
		0x985a
		},
		{
		0xbbdb
		},
		{
		0x9861
		},
		{
		0x9862
		},
		{
		0x9863
		},
		{
		0xbbdc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_241[]=
	{
		{
		0xbbd5
		},
		{
		0x979f
		},
		{
		0x97a0
		},
		{
		0xbbd6
		},
		{
		0x97a1
		},
		{
		0xbbd7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_242[]=
	{
		{
		0xbbd1
		},
		{
		0xbbd2
		},
		{
		0x9793
		},
		{
		0x9794
		},
		{
		0xbbd3
		},
		{
		0x9795
		},
		{
		0x9796
		},
		{
		0x9797
		},
		{
		0xbbd4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_243[]=
	{
		{
		0xbbcb
		},
		{
		0xbbcc
		},
		{
		0x96cf
		},
		{
		0x96d0
		},
		{
		0x96d1
		},
		{
		0xbbcd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_244[]=
	{
		{
		0xbbc7
		},
		{
		0xbbc8
		},
		{
		0x96c3
		},
		{
		0x96c4
		},
		{
		0xbbc9
		},
		{
		0x96c5
		},
		{
		0x96c6
		},
		{
		0x96c7
		},
		{
		0xbbca
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_245[]=
	{
		{
		0xbbc2
		},
		{
		0xbbc3
		},
		{
		0x96a0
		},
		{
		0xbbc4
		},
		{
		0xbbc5
		},
		{
		0xbbc6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_246[]=
	{
		{
		0xbbba
		},
		{
		0x966a
		},
		{
		0x966b
		},
		{
		0xbbbb
		},
		{
		0xbbbc
		},
		{
		0xbbbd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_247[]=
	{
		{
		0xbbb5
		},
		{
		0xbbb6
		},
		{
		0x9659
		},
		{
		0x965a
		},
		{
		0xbbb7
		},
		{
		0x9661
		},
		{
		0x9662
		},
		{
		0xbbb8
		},
		{
		0xbbb9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_248[]=
	{
		{
		0xbbad
		},
		{
		0xbbae
		},
		{
		0x95db
		},
		{
		0xbbaf
		},
		{
		0xbbb0
		},
		{
		0xbbb1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_249[]=
	{
		{
		0xbba8
		},
		{
		0xbba9
		},
		{
		0xbbaa
		},
		{
		0x95cf
		},
		{
		0x95d0
		},
		{
		0xbbab
		},
		{
		0x95d1
		},
		{
		0x95d2
		},
		{
		0x95d3
		},
		{
		0xbbac
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_250[]=
	{
		{
		0xbba3
		},
		{
		0xbba4
		},
		{
		0x95c9
		},
		{
		0xbba5
		},
		{
		0xbba6
		},
		{
		0xbba7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_251[]=
	{
		{
		0xbaf6
		},
		{
		0xbaf7
		},
		{
		0x95b8
		},
		{
		0xbaf8
		},
		{
		0x95b9
		},
		{
		0xbaf9
		},
		{
		0xbafa
		},
		{
		0xbafb
		},
		{
		0x95ba
		},
		{
		0x95bb
		},
		{
		0x95bc
		},
		{
		0x95bd
		},
		{
		0xbafc
		},
		{
		0xbafd
		},
		{
		0x95be
		},
		{
		0x95bf
		},
		{
		0xbafe
		},
		{
		0x95c0
		},
		{
		0x95c1
		},
		{
		0x95c2
		},
		{
		0xbba1
		},
		{
		0x95c3
		},
		{
		0xbba2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_252[]=
	{
		{
		0xbaf1
		},
		{
		0xbaf2
		},
		{
		0x95ad
		},
		{
		0x95ae
		},
		{
		0xbaf3
		},
		{
		0x95af
		},
		{
		0x95b0
		},
		{
		0x95b1
		},
		{
		0xbaf4
		},
		{
		0x95b2
		},
		{
		0xbaf5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_253[]=
	{
		{
		0xbaea
		},
		{
		0xbaeb
		},
		{
		0x9576
		},
		{
		0x9577
		},
		{
		0xbaec
		},
		{
		0x9578
		},
		{
		0x9579
		},
		{
		0x957a
		},
		{
		0xbaed
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_254[]=
	{
		{
		0xbae7
		},
		{
		0x956d
		},
		{
		0x956e
		},
		{
		0xbae8
		},
		{
		0x956f
		},
		{
		0xbae9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_255[]=
	{
		{
		0xbae4
		},
		{
		0x955a
		},
		{
		0x9561
		},
		{
		0x9562
		},
		{
		0xbae5
		},
		{
		0x9563
		},
		{
		0x9564
		},
		{
		0x9565
		},
		{
		0xbae6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_256[]=
	{
		{
		0x9541
		},
		{
		0x9542
		},
		{
		0xbadf
		},
		{
		0xbae0
		},
		{
		0x9543
		},
		{
		0x9544
		},
		{
		0xbae1
		},
		{
		0x9545
		},
		{
		0x9546
		},
		{
		0x9547
		},
		{
		0xbae2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_257[]=
	{
		{
		0xbad5
		},
		{
		0xbad6
		},
		{
		0x94c7
		},
		{
		0xbad7
		},
		{
		0x94c8
		},
		{
		0xbad8
		},
		{
		0x94c9
		},
		{
		0x94ca
		},
		{
		0x94cb
		},
		{
		0xbad9
		},
		{
		0xbada
		},
		{
		0x94cc
		},
		{
		0xbadb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_258[]=
	{
		{
		0xbace
		},
		{
		0xbacf
		},
		{
		0x94be
		},
		{
		0x94bf
		},
		{
		0xbad0
		},
		{
		0x94c0
		},
		{
		0x94c1
		},
		{
		0xbad1
		},
		{
		0xbad2
		},
		{
		0xbad3
		},
		{
		0xbad4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_259[]=
	{
		{
		0xbacc
		},
		{
		0x94a4
		},
		{
		0x94a5
		},
		{
		0x94a6
		},
		{
		0xbacd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_260[]=
	{
		{
		0xbac6
		},
		{
		0xbac7
		},
		{
		0x948e
		},
		{
		0x948f
		},
		{
		0xbac8
		},
		{
		0x9490
		},
		{
		0x9491
		},
		{
		0x9492
		},
		{
		0xbac9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_261[]=
	{
		{
		0xbac1
		},
		{
		0x944f
		},
		{
		0x9450
		},
		{
		0x9451
		},
		{
		0xbac2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_262[]=
	{
		{
		0xbabd
		},
		{
		0xbabe
		},
		{
		0x9447
		},
		{
		0xbabf
		},
		{
		0x9448
		},
		{
		0xbac0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_263[]=
	{
		{
		0xbab8
		},
		{
		0xbab9
		},
		{
		0xbaba
		},
		{
		0x93fa
		},
		{
		0xbabb
		},
		{
		0x93fb
		},
		{
		0x93fc
		},
		{
		0x93fd
		},
		{
		0xbabc
		},
		{
		0x93fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_264[]=
	{
		{
		0xbab1
		},
		{
		0x93da
		},
		{
		0xbab2
		},
		{
		0xbab3
		},
		{
		0xbab4
		},
		{
		0x93db
		},
		{
		0x93dc
		},
		{
		0x93dd
		},
		{
		0xbab5
		},
		{
		0x93de
		},
		{
		0x93df
		},
		{
		0xbab6
		},
		{
		0x93e0
		},
		{
		0x93e1
		},
		{
		0x93e2
		},
		{
		0xbab7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_265[]=
	{
		{
		0xbaad
		},
		{
		0xbaae
		},
		{
		0x93cd
		},
		{
		0x93ce
		},
		{
		0xbaaf
		},
		{
		0x93cf
		},
		{
		0x93d0
		},
		{
		0x93d1
		},
		{
		0xbab0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_266[]=
	{
		{
		0xbaa8
		},
		{
		0xbaa9
		},
		{
		0x93c6
		},
		{
		0xbaaa
		},
		{
		0xbaab
		},
		{
		0xbaac
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_267[]=
	{
		{
		0xbaa3
		},
		{
		0xbaa4
		},
		{
		0x93bb
		},
		{
		0x93bc
		},
		{
		0xbaa5
		},
		{
		0x93bd
		},
		{
		0x93be
		},
		{
		0xbaa6
		},
		{
		0xbaa7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_268[]=
	{
		{
		0xb9fc
		},
		{
		0xb9fd
		},
		{
		0x93b4
		},
		{
		0xb9fe
		},
		{
		0x93b5
		},
		{
		0xbaa1
		},
		{
		0xbaa2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_269[]=
	{
		{
		0xb9f6
		},
		{
		0xb9f7
		},
		{
		0x93aa
		},
		{
		0x93ab
		},
		{
		0xb9f8
		},
		{
		0x93ac
		},
		{
		0x93ad
		},
		{
		0xb9f9
		},
		{
		0xb9fa
		},
		{
		0x93ae
		},
		{
		0xb9fb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_270[]=
	{
		{
		0xb9ec
		},
		{
		0xb9ed
		},
		{
		0x936a
		},
		{
		0xb9ee
		},
		{
		0xb9ef
		},
		{
		0xb9f0
		},
		{
		0x936b
		},
		{
		0x936c
		},
		{
		0x936d
		},
		{
		0xb9f1
		},
		{
		0x936e
		},
		{
		0x936f
		},
		{
		0xb9f2
		},
		{
		0xb9f3
		},
		{
		0x9370
		},
		{
		0x9371
		},
		{
		0xb9f4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_271[]=
	{
		{
		0x934d
		},
		{
		0x934e
		},
		{
		0x934f
		},
		{
		0x9350
		},
		{
		0xb9e3
		},
		{
		0xb9e4
		},
		{
		0x9351
		},
		{
		0xb9e5
		},
		{
		0x9352
		},
		{
		0xb9e6
		},
		{
		0x9353
		},
		{
		0x9354
		},
		{
		0x9355
		},
		{
		0xb9e7
		},
		{
		0x9356
		},
		{
		0x9357
		},
		{
		0xb9e8
		},
		{
		0xb9e9
		},
		{
		0x9358
		},
		{
		0x9359
		},
		{
		0xb9ea
		},
		{
		0x935a
		},
		{
		0x9361
		},
		{
		0x9362
		},
		{
		0xb9eb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_272[]=
	{
		{
		0xb9d2
		},
		{
		0xb9d3
		},
		{
		0x9346
		},
		{
		0xb9d4
		},
		{
		0xb9d5
		},
		{
		0xb9d6
		},
		{
		0x9347
		},
		{
		0xb9d7
		},
		{
		0x9348
		},
		{
		0xb9d8
		},
		{
		0x9349
		},
		{
		0x934a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_273[]=
	{
		{
		0xb9cc
		},
		{
		0xb9cd
		},
		{
		0x92fa
		},
		{
		0x92fb
		},
		{
		0xb9ce
		},
		{
		0x92fc
		},
		{
		0x92fd
		},
		{
		0xb9cf
		},
		{
		0xb9d0
		},
		{
		0x92fe
		},
		{
		0xb9d1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_274[]=
	{
		{
		0xb9c7
		},
		{
		0x92c7
		},
		{
		0x92c8
		},
		{
		0x92c9
		},
		{
		0xb9c8
		},
		{
		0x92ca
		},
		{
		0x92cb
		},
		{
		0x92cc
		},
		{
		0xb9c9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_275[]=
	{
		{
		0xb9c2
		},
		{
		0x92b0
		},
		{
		0x92b1
		},
		{
		0x92b2
		},
		{
		0xb9c3
		},
		{
		0x92b3
		},
		{
		0x92b4
		},
		{
		0x92b5
		},
		{
		0xb9c4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_276[]=
	{
		{
		0xb9bf
		},
		{
		0x9297
		},
		{
		0x9298
		},
		{
		0x9299
		},
		{
		0xb9c0
		},
		{
		0x929a
		},
		{
		0x929b
		},
		{
		0x929c
		},
		{
		0xb9c1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_277[]=
	{
		{
		0xb9b3
		},
		{
		0xb9b4
		},
		{
		0x9253
		},
		{
		0xb9b5
		},
		{
		0x9254
		},
		{
		0xb9b6
		},
		{
		0x9255
		},
		{
		0x9256
		},
		{
		0x9257
		},
		{
		0xb9b7
		},
		{
		0x9258
		},
		{
		0xb9b8
		},
		{
		0xb9b9
		},
		{
		0x9259
		},
		{
		0x925a
		},
		{
		0x9261
		},
		{
		0xb9ba
		},
		{
		0x9262
		},
		{
		0x9263
		},
		{
		0x9264
		},
		{
		0xb9bb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_278[]=
	{
		{
		0xb9ab
		},
		{
		0xb9ac
		},
		{
		0xb9ad
		},
		{
		0x924b
		},
		{
		0xb9ae
		},
		{
		0x924c
		},
		{
		0x924d
		},
		{
		0xb9af
		},
		{
		0xb9b0
		},
		{
		0xb9b1
		},
		{
		0xb9b2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_279[]=
	{
		{
		0xb9a6
		},
		{
		0x91f2
		},
		{
		0x91f3
		},
		{
		0x91f4
		},
		{
		0xb9a7
		},
		{
		0x91f5
		},
		{
		0x91f6
		},
		{
		0x91f7
		},
		{
		0xb9a8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_280[]=
	{
		{
		0xb9a3
		},
		{
		0x91ea
		},
		{
		0xb9a4
		},
		{
		0x91eb
		},
		{
		0xb9a5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_281[]=
	{
		{
		0xb8fe
		},
		{
		0x91dc
		},
		{
		0x91dd
		},
		{
		0x91de
		},
		{
		0xb9a1
		},
		{
		0x91df
		},
		{
		0x91e0
		},
		{
		0x91e1
		},
		{
		0xb9a2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_282[]=
	{
		{
		0xb8fa
		},
		{
		0x91a8
		},
		{
		0x91a9
		},
		{
		0x91aa
		},
		{
		0xb8fb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_283[]=
	{
		{
		0xb8f6
		},
		{
		0xb8f7
		},
		{
		0x91a0
		},
		{
		0xb8f8
		},
		{
		0x91a1
		},
		{
		0xb8f9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_284[]=
	{
		{
		0xb8f0
		},
		{
		0xb8f1
		},
		{
		0x9196
		},
		{
		0xb8f2
		},
		{
		0xb8f3
		},
		{
		0x9197
		},
		{
		0x9198
		},
		{
		0x9199
		},
		{
		0xb8f4
		},
		{
		0x919a
		},
		{
		0xb8f5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_285[]=
	{
		{
		0xb8eb
		},
		{
		0xb8ec
		},
		{
		0xb8ed
		},
		{
		0x9170
		},
		{
		0xb8ee
		},
		{
		0x9171
		},
		{
		0x9172
		},
		{
		0x9173
		},
		{
		0x9174
		},
		{
		0xb8ef
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_286[]=
	{
		{
		0xb8e7
		},
		{
		0xb8e8
		},
		{
		0x9161
		},
		{
		0x9162
		},
		{
		0xb8e9
		},
		{
		0x9163
		},
		{
		0x9164
		},
		{
		0x9165
		},
		{
		0xb8ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_287[]=
	{
		{
		0xb8e2
		},
		{
		0xb8e3
		},
		{
		0x9154
		},
		{
		0xb8e4
		},
		{
		0xb8e5
		},
		{
		0xb8e6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_288[]=
	{
		{
		0xb8d3
		},
		{
		0xb8d4
		},
		{
		0x90f5
		},
		{
		0x90f6
		},
		{
		0xb8d5
		},
		{
		0x90f7
		},
		{
		0x90f8
		},
		{
		0x90f9
		},
		{
		0xb8d6
		},
		{
		0x90fa
		},
		{
		0xb8d7
		},
		{
		0x90fb
		},
		{
		0x90fc
		},
		{
		0x90fd
		},
		{
		0x90fe
		},
		{
		0x9141
		},
		{
		0xb8d8
		},
		{
		0xb8d9
		},
		{
		0x9142
		},
		{
		0xb8da
		},
		{
		0x9143
		},
		{
		0xb8db
		},
		{
		0xb8dc
		},
		{
		0x9144
		},
		{
		0x9145
		},
		{
		0x9146
		},
		{
		0x9147
		},
		{
		0xb8dd
		},
		{
		0xb8de
		},
		{
		0xb8df
		},
		{
		0x9148
		},
		{
		0x9149
		},
		{
		0xb8e0
		},
		{
		0x914a
		},
		{
		0x914b
		},
		{
		0x914c
		},
		{
		0xb8e1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_289[]=
	{
		{
		0xb8c9
		},
		{
		0xb8ca
		},
		{
		0x90bb
		},
		{
		0xb8cb
		},
		{
		0xb8cc
		},
		{
		0xb8cd
		},
		{
		0xb8ce
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_290[]=
	{
		{
		0xb8be
		},
		{
		0xb8bf
		},
		{
		0x90aa
		},
		{
		0xb8c0
		},
		{
		0x90ab
		},
		{
		0xb8c1
		},
		{
		0xb8c2
		},
		{
		0x90ac
		},
		{
		0x90ad
		},
		{
		0xb8c3
		},
		{
		0x90ae
		},
		{
		0xb8c4
		},
		{
		0xb8c5
		},
		{
		0xb8c6
		},
		{
		0x90af
		},
		{
		0x90b0
		},
		{
		0xb8c7
		},
		{
		0x90b1
		},
		{
		0x90b2
		},
		{
		0x90b3
		},
		{
		0xb8c8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_291[]=
	{
		{
		0xb8b6
		},
		{
		0xb8b7
		},
		{
		0x90a2
		},
		{
		0x90a3
		},
		{
		0xb8b8
		},
		{
		0x90a4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_292[]=
	{
		{
		0xb8b2
		},
		{
		0xb8b3
		},
		{
		0x909a
		},
		{
		0xb8b4
		},
		{
		0x909b
		},
		{
		0xb8b5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_293[]=
	{
		{
		0xb8ae
		},
		{
		0xb8af
		},
		{
		0x908e
		},
		{
		0x908f
		},
		{
		0xb8b0
		},
		{
		0x9090
		},
		{
		0x9091
		},
		{
		0x9092
		},
		{
		0xb8b1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_294[]=
	{
		{
		0xb8a7
		},
		{
		0xb8a8
		},
		{
		0x9067
		},
		{
		0xb8a9
		},
		{
		0x9068
		},
		{
		0xb8aa
		},
		{
		0xb8ab
		},
		{
		0x9069
		},
		{
		0x906a
		},
		{
		0xb8ac
		},
		{
		0xb8ad
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_295[]=
	{
		{
		0xb8a3
		},
		{
		0xb8a4
		},
		{
		0x9055
		},
		{
		0x9056
		},
		{
		0xb8a5
		},
		{
		0x9057
		},
		{
		0x9058
		},
		{
		0x9059
		},
		{
		0xb8a6
		},
		{
		0x905a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_296[]=
	{
		{
		0xb7fd
		},
		{
		0xb7fe
		},
		{
		0x904d
		},
		{
		0xb8a1
		},
		{
		0x904e
		},
		{
		0xb8a2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_297[]=
	{
		{
		0xb7f9
		},
		{
		0xb7fa
		},
		{
		0x9041
		},
		{
		0x9042
		},
		{
		0xb7fb
		},
		{
		0x9043
		},
		{
		0x9044
		},
		{
		0x9045
		},
		{
		0xb7fc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_298[]=
	{
		{
		0xb7f6
		},
		{
		0x8ff6
		},
		{
		0x8ff7
		},
		{
		0xb7f7
		},
		{
		0x8ff8
		},
		{
		0xb7f8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_299[]=
	{
		{
		0xb7f2
		},
		{
		0xb7f3
		},
		{
		0x8fea
		},
		{
		0x8feb
		},
		{
		0xb7f4
		},
		{
		0x8fec
		},
		{
		0x8fed
		},
		{
		0x8fee
		},
		{
		0xb7f5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_300[]=
	{
		{
		0xb7eb
		},
		{
		0xb7ec
		},
		{
		0x8fad
		},
		{
		0xb7ed
		},
		{
		0x8fae
		},
		{
		0xb7ee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_301[]=
	{
		{
		0xb7e7
		},
		{
		0xb7e8
		},
		{
		0x8fa1
		},
		{
		0x8fa2
		},
		{
		0xb7e9
		},
		{
		0x8fa3
		},
		{
		0x8fa4
		},
		{
		0x8fa5
		},
		{
		0xb7ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_302[]=
	{
		{
		0xb7e4
		},
		{
		0x8f99
		},
		{
		0xb7e5
		},
		{
		0x8f9a
		},
		{
		0xb7e6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_303[]=
	{
		{
		0xb7e1
		},
		{
		0x8f8b
		},
		{
		0x8f8c
		},
		{
		0x8f8d
		},
		{
		0xb7e2
		},
		{
		0x8f8e
		},
		{
		0x8f8f
		},
		{
		0x8f90
		},
		{
		0xb7e3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_304[]=
	{
		{
		0x8f81
		},
		{
		0x8f82
		},
		{
		0xb7dd
		},
		{
		0xb7de
		},
		{
		0x8f83
		},
		{
		0xb7df
		},
		{
		0x8f84
		},
		{
		0xb7e0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_305[]=
	{
		{
		0xb7da
		},
		{
		0x8f70
		},
		{
		0x8f71
		},
		{
		0x8f72
		},
		{
		0xb7db
		},
		{
		0x8f73
		},
		{
		0x8f74
		},
		{
		0x8f75
		},
		{
		0xb7dc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_306[]=
	{
		{
		0xb7d6
		},
		{
		0x8ef4
		},
		{
		0x8ef5
		},
		{
		0x8ef6
		},
		{
		0xb7d7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_307[]=
	{
		{
		0xb7d2
		},
		{
		0xb7d3
		},
		{
		0x8eec
		},
		{
		0xb7d4
		},
		{
		0x8eed
		},
		{
		0xb7d5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_308[]=
	{
		{
		0xb7ce
		},
		{
		0xb7cf
		},
		{
		0x8ee0
		},
		{
		0x8ee1
		},
		{
		0xb7d0
		},
		{
		0x8ee2
		},
		{
		0x8ee3
		},
		{
		0x8ee4
		},
		{
		0xb7d1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_309[]=
	{
		{
		0xb7ca
		},
		{
		0x8ec8
		},
		{
		0x8ec9
		},
		{
		0x8eca
		},
		{
		0xb7cb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_310[]=
	{
		{
		0xb7c5
		},
		{
		0xb7c6
		},
		{
		0x8ec1
		},
		{
		0xb7c7
		},
		{
		0xb7c8
		},
		{
		0xb7c9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_311[]=
	{
		{
		0xb7c1
		},
		{
		0xb7c2
		},
		{
		0x8eb5
		},
		{
		0x8eb6
		},
		{
		0xb7c3
		},
		{
		0x8eb7
		},
		{
		0x8eb8
		},
		{
		0x8eb9
		},
		{
		0xb7c4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_312[]=
	{
		{
		0xb7bd
		},
		{
		0xb7be
		},
		{
		0x8ead
		},
		{
		0xb7bf
		},
		{
		0x8eae
		},
		{
		0xb7c0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_313[]=
	{
		{
		0xb7b8
		},
		{
		0xb7b9
		},
		{
		0xb7ba
		},
		{
		0x8ea1
		},
		{
		0x8ea2
		},
		{
		0xb7bb
		},
		{
		0x8ea3
		},
		{
		0x8ea4
		},
		{
		0x8ea5
		},
		{
		0xb7bc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_314[]=
	{
		{
		0xb7b3
		},
		{
		0xb7b4
		},
		{
		0x8e9b
		},
		{
		0xb7b5
		},
		{
		0xb7b6
		},
		{
		0xb7b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_315[]=
	{
		{
		0xb7af
		},
		{
		0xb7b0
		},
		{
		0x8e8f
		},
		{
		0x8e90
		},
		{
		0xb7b1
		},
		{
		0x8e91
		},
		{
		0x8e92
		},
		{
		0x8e93
		},
		{
		0xb7b2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_316[]=
	{
		{
		0xb7aa
		},
		{
		0xb7ab
		},
		{
		0x8e50
		},
		{
		0x8e51
		},
		{
		0xb7ac
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_317[]=
	{
		{
		0xb7a5
		},
		{
		0xb7a6
		},
		{
		0x8e49
		},
		{
		0xb7a7
		},
		{
		0xb7a8
		},
		{
		0xb7a9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_318[]=
	{
		{
		0xb6f7
		},
		{
		0xb6f8
		},
		{
		0x8df7
		},
		{
		0xb6f9
		},
		{
		0xb6fa
		},
		{
		0xb6fb
		},
		{
		0xb6fc
		},
		{
		0x8df8
		},
		{
		0x8df9
		},
		{
		0x8dfa
		},
		{
		0xb6fd
		},
		{
		0xb6fe
		},
		{
		0xb7a1
		},
		{
		0xb7a2
		},
		{
		0x8dfb
		},
		{
		0x8dfc
		},
		{
		0xb7a3
		},
		{
		0x8dfd
		},
		{
		0x8dfe
		},
		{
		0x8e41
		},
		{
		0xb7a4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_319[]=
	{
		{
		0xb6f3
		},
		{
		0xb6f4
		},
		{
		0x8deb
		},
		{
		0x8dec
		},
		{
		0xb6f5
		},
		{
		0x8ded
		},
		{
		0x8dee
		},
		{
		0x8def
		},
		{
		0xb6f6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_320[]=
	{
		{
		0xb6ef
		},
		{
		0xb6f0
		},
		{
		0x8de3
		},
		{
		0xb6f1
		},
		{
		0x8de4
		},
		{
		0xb6f2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_321[]=
	{
		{
		0xb6ec
		},
		{
		0x8dd6
		},
		{
		0x8dd7
		},
		{
		0x8dd8
		},
		{
		0xb6ed
		},
		{
		0x8dd9
		},
		{
		0x8dda
		},
		{
		0x8ddb
		},
		{
		0xb6ee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_322[]=
	{
		{
		0xb6e7
		},
		{
		0x8dbf
		},
		{
		0x8dc0
		},
		{
		0x8dc1
		},
		{
		0xb6e8
		},
		{
		0x8dc2
		},
		{
		0x8dc3
		},
		{
		0x8dc4
		},
		{
		0xb6e9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_323[]=
	{
		{
		0xb6df
		},
		{
		0xb6e0
		},
		{
		0x8dab
		},
		{
		0x8dac
		},
		{
		0xb6e1
		},
		{
		0x8dad
		},
		{
		0x8dae
		},
		{
		0xb6e2
		},
		{
		0xb6e3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_324[]=
	{
		{
		0xb6dc
		},
		{
		0xb6dd
		},
		{
		0x8d86
		},
		{
		0x8d87
		},
		{
		0x8d88
		},
		{
		0xb6de
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_325[]=
	{
		{
		0xb6d9
		},
		{
		0x8d73
		},
		{
		0x8d74
		},
		{
		0x8d75
		},
		{
		0xb6da
		},
		{
		0x8d76
		},
		{
		0x8d77
		},
		{
		0x8d78
		},
		{
		0xb6db
		},
		{
		0x8d79
		},
		{
		0x8d7a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_326[]=
	{
		{
		0xb6d5
		},
		{
		0xb6d6
		},
		{
		0x8cea
		},
		{
		0x8ceb
		},
		{
		0x8cec
		},
		{
		0x8ced
		},
		{
		0xb6d7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_327[]=
	{
		{
		0xb6d1
		},
		{
		0xb6d2
		},
		{
		0x8cdf
		},
		{
		0x8ce0
		},
		{
		0xb6d3
		},
		{
		0x8ce1
		},
		{
		0x8ce2
		},
		{
		0x8ce3
		},
		{
		0xb6d4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_328[]=
	{
		{
		0xb6cf
		},
		{
		0x8ca9
		},
		{
		0x8caa
		},
		{
		0x8cab
		},
		{
		0xb6d0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_329[]=
	{
		{
		0xb6c7
		},
		{
		0xb6c8
		},
		{
		0x8c51
		},
		{
		0x8c52
		},
		{
		0xb6c9
		},
		{
		0x8c53
		},
		{
		0x8c54
		},
		{
		0x8c55
		},
		{
		0xb6ca
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_330[]=
	{
		{
		0xb6c0
		},
		{
		0xb6c1
		},
		{
		0x8bd2
		},
		{
		0xb6c2
		},
		{
		0xb6c3
		},
		{
		0xb6c4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_331[]=
	{
		{
		0xb6bb
		},
		{
		0xb6bc
		},
		{
		0xb6bd
		},
		{
		0x8bc6
		},
		{
		0x8bc7
		},
		{
		0xb6be
		},
		{
		0x8bc8
		},
		{
		0x8bc9
		},
		{
		0x8bca
		},
		{
		0xb6bf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_332[]=
	{
		{
		0xb6b0
		},
		{
		0xb6b1
		},
		{
		0x8bb6
		},
		{
		0x8bb7
		},
		{
		0xb6b2
		},
		{
		0x8bb8
		},
		{
		0x8bb9
		},
		{
		0x8bba
		},
		{
		0xb6b3
		},
		{
		0x8bbb
		},
		{
		0xb6b4
		},
		{
		0xb6b5
		},
		{
		0x8bbc
		},
		{
		0x8bbd
		},
		{
		0x8bbe
		},
		{
		0x8bbf
		},
		{
		0xb6b6
		},
		{
		0xb6b7
		},
		{
		0x8bc0
		},
		{
		0xb6b8
		},
		{
		0xb6b9
		},
		{
		0xb6ba
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_333[]=
	{
		{
		0xb6ab
		},
		{
		0xb6ac
		},
		{
		0x8b71
		},
		{
		0xb6ad
		},
		{
		0xb6ae
		},
		{
		0xb6af
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_334[]=
	{
		{
		0xb6a1
		},
		{
		0xb6a2
		},
		{
		0x8b59
		},
		{
		0xb6a3
		},
		{
		0xb6a4
		},
		{
		0xb6a5
		},
		{
		0x8b5a
		},
		{
		0x8b61
		},
		{
		0x8b62
		},
		{
		0x8b63
		},
		{
		0x8b64
		},
		{
		0xb6a6
		},
		{
		0xb6a7
		},
		{
		0xb6a8
		},
		{
		0x8b65
		},
		{
		0x8b66
		},
		{
		0xb6a9
		},
		{
		0x8b67
		},
		{
		0x8b68
		},
		{
		0x8b69
		},
		{
		0xb6aa
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_335[]=
	{
		{
		0xb5fb
		},
		{
		0xb5fc
		},
		{
		0x8b4d
		},
		{
		0x8b4e
		},
		{
		0xb5fd
		},
		{
		0x8b4f
		},
		{
		0x8b50
		},
		{
		0x8b51
		},
		{
		0xb5fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_336[]=
	{
		{
		0xb5f5
		},
		{
		0xb5f6
		},
		{
		0x8b47
		},
		{
		0xb5f7
		},
		{
		0xb5f8
		},
		{
		0xb5f9
		},
		{
		0xb5fa
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_337[]=
	{
		{
		0xb5f0
		},
		{
		0xb5f1
		},
		{
		0x8afa
		},
		{
		0x8afb
		},
		{
		0xb5f2
		},
		{
		0x8afc
		},
		{
		0x8afd
		},
		{
		0xb5f3
		},
		{
		0xb5f4
		},
		{
		0x8afe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_338[]=
	{
		{
		0xb5eb
		},
		{
		0xb5ec
		},
		{
		0x8ad7
		},
		{
		0xb5ed
		},
		{
		0x8ad8
		},
		{
		0xb5ee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_339[]=
	{
		{
		0xb5e5
		},
		{
		0xb5e6
		},
		{
		0x8acd
		},
		{
		0x8ace
		},
		{
		0xb5e7
		},
		{
		0x8acf
		},
		{
		0x8ad0
		},
		{
		0xb5e8
		},
		{
		0xb5e9
		},
		{
		0x8ad1
		},
		{
		0xb5ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_340[]=
	{
		{
		0xb5e3
		},
		{
		0x8ac3
		},
		{
		0x8ac4
		},
		{
		0x8ac5
		},
		{
		0x8ac6
		},
		{
		0xb5e4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_341[]=
	{
		{
		0xb5e0
		},
		{
		0x8ab6
		},
		{
		0x8ab7
		},
		{
		0x8ab8
		},
		{
		0xb5e1
		},
		{
		0x8ab9
		},
		{
		0x8aba
		},
		{
		0x8abb
		},
		{
		0xb5e2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_342[]=
	{
		{
		0xb5dd
		},
		{
		0x8aae
		},
		{
		0xb5de
		},
		{
		0x8aaf
		},
		{
		0xb5df
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_343[]=
	{
		{
		0xb5da
		},
		{
		0x8aa0
		},
		{
		0x8aa1
		},
		{
		0x8aa2
		},
		{
		0xb5db
		},
		{
		0x8aa3
		},
		{
		0x8aa4
		},
		{
		0x8aa5
		},
		{
		0xb5dc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_344[]=
	{
		{
		0xb5d2
		},
		{
		0xb5d3
		},
		{
		0x8a58
		},
		{
		0xb5d4
		},
		{
		0x8a59
		},
		{
		0xb5d5
		},
		{
		0x8a5a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_345[]=
	{
		{
		0xb5ce
		},
		{
		0xb5cf
		},
		{
		0x8a4c
		},
		{
		0x8a4d
		},
		{
		0xb5d0
		},
		{
		0x8a4e
		},
		{
		0x8a4f
		},
		{
		0x8a50
		},
		{
		0xb5d1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_346[]=
	{
		{
		0xb5c7
		},
		{
		0x89d9
		},
		{
		0x89da
		},
		{
		0x89db
		},
		{
		0xb5c8
		},
		{
		0x89dc
		},
		{
		0x89dd
		},
		{
		0x89de
		},
		{
		0xb5c9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_347[]=
	{
		{
		0xb5b5
		},
		{
		0xb5b6
		},
		{
		0x8997
		},
		{
		0x8998
		},
		{
		0xb5b7
		},
		{
		0x8999
		},
		{
		0x899a
		},
		{
		0xb5b8
		},
		{
		0xb5b9
		},
		{
		0x899b
		},
		{
		0xb5ba
		},
		{
		0x899c
		},
		{
		0xb5bb
		},
		{
		0x899d
		},
		{
		0x899e
		},
		{
		0x899f
		},
		{
		0xb5bc
		},
		{
		0xb5bd
		},
		{
		0x89a0
		},
		{
		0xb5be
		},
		{
		0x89a1
		},
		{
		0xb5bf
		},
		{
		0x89a2
		},
		{
		0xb5c0
		},
		{
		0x89a3
		},
		{
		0xb5c1
		},
		{
		0x89a4
		},
		{
		0x89a5
		},
		{
		0xb5c2
		},
		{
		0x89a6
		},
		{
		0x89a7
		},
		{
		0x89a8
		},
		{
		0xb5c3
		},
		{
		0x89a9
		},
		{
		0x89aa
		},
		{
		0x89ab
		},
		{
		0xb5c4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_348[]=
	{
		{
		0xb5b3
		},
		{
		0x8977
		},
		{
		0x8978
		},
		{
		0x8979
		},
		{
		0xb5b4
		},
		{
		0x897a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_349[]=
	{
		{
		0xb5ae
		},
		{
		0x895a
		},
		{
		0x8961
		},
		{
		0x8962
		},
		{
		0xb5af
		},
		{
		0x8963
		},
		{
		0x8964
		},
		{
		0x8965
		},
		{
		0xb5b0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_350[]=
	{
		{
		0xb5a9
		},
		{
		0xb5aa
		},
		{
		0x8953
		},
		{
		0xb5ab
		},
		{
		0xb5ac
		},
		{
		0xb5ad
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_351[]=
	{
		{
		0xb4f5
		},
		{
		0xb4f6
		},
		{
		0xb4f7
		},
		{
		0x88f7
		},
		{
		0xb4f8
		},
		{
		0x88f8
		},
		{
		0x88f9
		},
		{
		0xb4f9
		},
		{
		0xb4fa
		},
		{
		0x88fa
		},
		{
		0xb4fb
		},
		{
		0xb4fc
		},
		{
		0x88fb
		},
		{
		0x88fc
		},
		{
		0x88fd
		},
		{
		0x88fe
		},
		{
		0xb4fd
		},
		{
		0xb4fe
		},
		{
		0x8941
		},
		{
		0xb5a1
		},
		{
		0x8942
		},
		{
		0xb5a2
		},
		{
		0x8943
		},
		{
		0xb5a3
		},
		{
		0x8944
		},
		{
		0x8945
		},
		{
		0xb5a4
		},
		{
		0x8946
		},
		{
		0xb5a5
		},
		{
		0xb5a6
		},
		{
		0x8947
		},
		{
		0x8948
		},
		{
		0xb5a7
		},
		{
		0x8949
		},
		{
		0x894a
		},
		{
		0x894b
		},
		{
		0xb5a8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_352[]=
	{
		{
		0xb4ef
		},
		{
		0xb4f0
		},
		{
		0x88b9
		},
		{
		0xb4f1
		},
		{
		0xb4f2
		},
		{
		0xb4f3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_353[]=
	{
		{
		0x88aa
		},
		{
		0x88ab
		},
		{
		0x88ac
		},
		{
		0xb4ea
		},
		{
		0xb4eb
		},
		{
		0xb4ec
		},
		{
		0x88ad
		},
		{
		0x88ae
		},
		{
		0xb4ed
		},
		{
		0x88af
		},
		{
		0x88b0
		},
		{
		0x88b1
		},
		{
		0xb4ee
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_354[]=
	{
		{
		0x88a6
		},
		{
		0x88a7
		},
		{
		0x88a8
		},
		{
		0xb4e2
		},
		{
		0xb4e3
		},
		{
		0xb4e4
		},
		{
		0x88a9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_355[]=
	{
		{
		0xb4d4
		},
		{
		0xb4d5
		},
		{
		0x889c
		},
		{
		0xb4d6
		},
		{
		0x889d
		},
		{
		0xb4d7
		},
		{
		0x889e
		},
		{
		0x889f
		},
		{
		0x88a0
		},
		{
		0x88a1
		},
		{
		0xb4d8
		},
		{
		0x88a2
		},
		{
		0xb4d9
		},
		{
		0xb4da
		},
		{
		0xb4db
		},
		{
		0x88a3
		},
		{
		0xb4dc
		},
		{
		0x88a4
		},
		{
		0x88a5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_356[]=
	{
		{
		0xb4cf
		},
		{
		0xb4d0
		},
		{
		0x8891
		},
		{
		0x8892
		},
		{
		0xb4d1
		},
		{
		0x8893
		},
		{
		0x8894
		},
		{
		0x8895
		},
		{
		0xb4d2
		},
		{
		0x8896
		},
		{
		0xb4d3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_357[]=
	{
		{
		0xb4c6
		},
		{
		0xb4c7
		},
		{
		0x886c
		},
		{
		0xb4c8
		},
		{
		0x886d
		},
		{
		0xb4c9
		},
		{
		0xb4ca
		},
		{
		0x886e
		},
		{
		0x886f
		},
		{
		0x8870
		},
		{
		0xb4cb
		},
		{
		0x8871
		},
		{
		0xb4cc
		},
		{
		0x8872
		},
		{
		0x8873
		},
		{
		0x8874
		},
		{
		0xb4cd
		},
		{
		0x8875
		},
		{
		0x8876
		},
		{
		0x8877
		},
		{
		0xb4ce
		},
		{
		0x8878
		},
		{
		0x8879
		},
		{
		0x887a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_358[]=
	{
		{
		0x8861
		},
		{
		0xb4c0
		},
		{
		0xb4c1
		},
		{
		0x8862
		},
		{
		0x8863
		},
		{
		0xb4c2
		},
		{
		0x8864
		},
		{
		0x8865
		},
		{
		0x8866
		},
		{
		0xb4c3
		},
		{
		0xb4c4
		},
		{
		0xb4c5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_359[]=
	{
		{
		0xb4bd
		},
		{
		0xb4be
		},
		{
		0x8853
		},
		{
		0x8854
		},
		{
		0x8855
		},
		{
		0xb4bf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_360[]=
	{
		{
		0xb4b5
		},
		{
		0x87ed
		},
		{
		0x87ee
		},
		{
		0x87ef
		},
		{
		0xb4b6
		},
		{
		0x87f0
		},
		{
		0x87f1
		},
		{
		0x87f2
		},
		{
		0xb4b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_361[]=
	{
		{
		0xb4ae
		},
		{
		0xb4af
		},
		{
		0x87b0
		},
		{
		0xb4b0
		},
		{
		0x87b1
		},
		{
		0xb4b1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_362[]=
	{
		{
		0xb4a9
		},
		{
		0xb4aa
		},
		{
		0x87a5
		},
		{
		0x87a6
		},
		{
		0xb4ab
		},
		{
		0x87a7
		},
		{
		0x87a8
		},
		{
		0xb4ac
		},
		{
		0xb4ad
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_363[]=
	{
		{
		0xb4a6
		},
		{
		0x879d
		},
		{
		0xb4a7
		},
		{
		0x879e
		},
		{
		0xb4a8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_364[]=
	{
		{
		0xb4a2
		},
		{
		0xb4a3
		},
		{
		0x8790
		},
		{
		0x8791
		},
		{
		0xb4a4
		},
		{
		0x8792
		},
		{
		0x8793
		},
		{
		0x8794
		},
		{
		0xb4a5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_365[]=
	{
		{
		0xb3fa
		},
		{
		0x8774
		},
		{
		0x8775
		},
		{
		0x8776
		},
		{
		0xb3fb
		},
		{
		0x8777
		},
		{
		0x8778
		},
		{
		0x8779
		},
		{
		0xb3fc
		},
		{
		0x877a
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_366[]=
	{
		{
		0xb3f0
		},
		{
		0xb3f1
		},
		{
		0x86f2
		},
		{
		0xb3f2
		},
		{
		0x86f3
		},
		{
		0xb3f3
		},
		{
		0x86f4
		},
		{
		0x86f5
		},
		{
		0x86f6
		},
		{
		0x86f7
		},
		{
		0xb3f4
		},
		{
		0xb3f5
		},
		{
		0xb3f6
		},
		{
		0x86f8
		},
		{
		0x86f9
		},
		{
		0x86fa
		},
		{
		0xb3f7
		},
		{
		0x86fb
		},
		{
		0x86fc
		},
		{
		0x86fd
		},
		{
		0xb3f8
		},
		{
		0x86fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_367[]=
	{
		{
		0xb3eb
		},
		{
		0xb3ec
		},
		{
		0x86e7
		},
		{
		0x86e8
		},
		{
		0xb3ed
		},
		{
		0x86e9
		},
		{
		0x86ea
		},
		{
		0x86eb
		},
		{
		0xb3ee
		},
		{
		0x86ec
		},
		{
		0xb3ef
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_368[]=
	{
		{
		0xb3e4
		},
		{
		0xb3e5
		},
		{
		0x86c6
		},
		{
		0x86c7
		},
		{
		0xb3e6
		},
		{
		0xb3e7
		},
		{
		0x86c8
		},
		{
		0x86c9
		},
		{
		0xb3e8
		},
		{
		0x86ca
		},
		{
		0x86cb
		},
		{
		0x86cc
		},
		{
		0xb3e9
		},
		{
		0x86cd
		},
		{
		0x86ce
		},
		{
		0x86cf
		},
		{
		0xb3ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_369[]=
	{
		{
		0xb3e0
		},
		{
		0xb3e1
		},
		{
		0x86ba
		},
		{
		0x86bb
		},
		{
		0xb3e2
		},
		{
		0x86bc
		},
		{
		0x86bd
		},
		{
		0x86be
		},
		{
		0xb3e3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_370[]=
	{
		{
		0xb3db
		},
		{
		0xb3dc
		},
		{
		0x86b3
		},
		{
		0xb3dd
		},
		{
		0xb3de
		},
		{
		0xb3df
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_371[]=
	{
		{
		0xb3d6
		},
		{
		0xb3d7
		},
		{
		0xb3d8
		},
		{
		0x86a7
		},
		{
		0x86a8
		},
		{
		0xb3d9
		},
		{
		0x86a9
		},
		{
		0x86aa
		},
		{
		0x86ab
		},
		{
		0xb3da
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_372[]=
	{
		{
		0xb3ca
		},
		{
		0xb3cb
		},
		{
		0x8698
		},
		{
		0xb3cc
		},
		{
		0xb3cd
		},
		{
		0x8699
		},
		{
		0x869a
		},
		{
		0x869b
		},
		{
		0xb3ce
		},
		{
		0x869c
		},
		{
		0xb3cf
		},
		{
		0xb3d0
		},
		{
		0x869d
		},
		{
		0x869e
		},
		{
		0x869f
		},
		{
		0x86a0
		},
		{
		0xb3d1
		},
		{
		0xb3d2
		},
		{
		0x86a1
		},
		{
		0xb3d3
		},
		{
		0xb3d4
		},
		{
		0xb3d5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_373[]=
	{
		{
		0xb3c8
		},
		{
		0x866c
		},
		{
		0x866d
		},
		{
		0x866e
		},
		{
		0x866f
		},
		{
		0xb3c9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_374[]=
	{
		{
		0xb3c4
		},
		{
		0xb3c5
		},
		{
		0x865a
		},
		{
		0x8661
		},
		{
		0xb3c6
		},
		{
		0x8662
		},
		{
		0x8663
		},
		{
		0x8664
		},
		{
		0xb3c7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_375[]=
	{
		{
		0xb3bf
		},
		{
		0xb3c0
		},
		{
		0x8653
		},
		{
		0xb3c1
		},
		{
		0xb3c2
		},
		{
		0xb3c3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_376[]=
	{
		{
		0x8645
		},
		{
		0xb3b9
		},
		{
		0x8646
		},
		{
		0xb3ba
		},
		{
		0xb3bb
		},
		{
		0xb3bc
		},
		{
		0x8647
		},
		{
		0x8648
		},
		{
		0xb3bd
		},
		{
		0x8649
		},
		{
		0x864a
		},
		{
		0x864b
		},
		{
		0xb3be
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_377[]=
	{
		{
		0xb3aa
		},
		{
		0xb3ab
		},
		{
		0xb3ac
		},
		{
		0x85fa
		},
		{
		0xb3ad
		},
		{
		0x85fb
		},
		{
		0x85fc
		},
		{
		0xb3ae
		},
		{
		0xb3af
		},
		{
		0xb3b0
		},
		{
		0xb3b1
		},
		{
		0x85fd
		},
		{
		0x85fe
		},
		{
		0x8641
		},
		{
		0x8642
		},
		{
		0x8643
		},
		{
		0xb3b2
		},
		{
		0xb3b3
		},
		{
		0x8644
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_378[]=
	{
		{
		0xb3a6
		},
		{
		0xb3a7
		},
		{
		0x85f2
		},
		{
		0xb3a8
		},
		{
		0x85f3
		},
		{
		0xb3a9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_379[]=
	{
		{
		0xb3a2
		},
		{
		0xb3a3
		},
		{
		0x85e6
		},
		{
		0x85e7
		},
		{
		0xb3a4
		},
		{
		0x85e8
		},
		{
		0x85e9
		},
		{
		0x85ea
		},
		{
		0xb3a5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_380[]=
	{
		{
		0xb2f4
		},
		{
		0xb2f5
		},
		{
		0x85ba
		},
		{
		0x85bb
		},
		{
		0xb2f6
		},
		{
		0x85bc
		},
		{
		0xb2f7
		},
		{
		0x85bd
		},
		{
		0xb2f8
		},
		{
		0x85be
		},
		{
		0xb2f9
		},
		{
		0x85bf
		},
		{
		0x85c0
		},
		{
		0x85c1
		},
		{
		0x85c2
		},
		{
		0xb2fa
		},
		{
		0xb2fb
		},
		{
		0xb2fc
		},
		{
		0x85c3
		},
		{
		0xb2fd
		},
		{
		0x85c4
		},
		{
		0xb2fe
		},
		{
		0x85c5
		},
		{
		0x85c6
		},
		{
		0x85c7
		},
		{
		0xb3a1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_381[]=
	{
		{
		0xb2ee
		},
		{
		0x8588
		},
		{
		0x8589
		},
		{
		0x858a
		},
		{
		0xb2ef
		},
		{
		0x858b
		},
		{
		0x858c
		},
		{
		0x858d
		},
		{
		0xb2f0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_382[]=
	{
		{
		0xb2eb
		},
		{
		0xb2ec
		},
		{
		0x8579
		},
		{
		0x857a
		},
		{
		0xb2ed
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_383[]=
	{
		{
		0xb2e7
		},
		{
		0xb2e8
		},
		{
		0x856d
		},
		{
		0x856e
		},
		{
		0xb2e9
		},
		{
		0x856f
		},
		{
		0x8570
		},
		{
		0x8571
		},
		{
		0xb2ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_384[]=
	{
		{
		0xb2dd
		},
		{
		0xb2de
		},
		{
		0xb2df
		},
		{
		0x8548
		},
		{
		0xb2e0
		},
		{
		0x8549
		},
		{
		0xb2e1
		},
		{
		0xb2e2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_385[]=
	{
		{
		0xb2d9
		},
		{
		0xb2da
		},
		{
		0x84fb
		},
		{
		0x84fc
		},
		{
		0xb2db
		},
		{
		0x84fd
		},
		{
		0x84fe
		},
		{
		0x8541
		},
		{
		0xb2dc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_386[]=
	{
		{
		0xb2d5
		},
		{
		0xb2d6
		},
		{
		0x84d7
		},
		{
		0x84d8
		},
		{
		0x84d9
		},
		{
		0xb2d7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_387[]=
	{
		{
		0xb2d2
		},
		{
		0x84ca
		},
		{
		0x84cb
		},
		{
		0x84cc
		},
		{
		0xb2d3
		},
		{
		0x84cd
		},
		{
		0x84ce
		},
		{
		0x84cf
		},
		{
		0xb2d4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_388[]=
	{
		{
		0xb2c4
		},
		{
		0xb2c5
		},
		{
		0x8494
		},
		{
		0xb2c6
		},
		{
		0x8495
		},
		{
		0xb2c7
		},
		{
		0xb2c8
		},
		{
		0xb2c9
		},
		{
		0x8496
		},
		{
		0x8497
		},
		{
		0x8498
		},
		{
		0x8499
		},
		{
		0xb2ca
		},
		{
		0xb2cb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_389[]=
	{
		{
		0xb2bf
		},
		{
		0xb2c0
		},
		{
		0x8489
		},
		{
		0x848a
		},
		{
		0xb2c1
		},
		{
		0x848b
		},
		{
		0xb2c2
		},
		{
		0x848c
		},
		{
		0xb2c3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_390[]=
	{
		{
		0x8461
		},
		{
		0xb2bb
		},
		{
		0xb2bc
		},
		{
		0x8462
		},
		{
		0x8463
		},
		{
		0x8464
		},
		{
		0x8465
		},
		{
		0xb2bd
		},
		{
		0x8466
		},
		{
		0x8467
		},
		{
		0xb2be
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_391[]=
	{
		{
		0xb2b8
		},
		{
		0x844c
		},
		{
		0x844d
		},
		{
		0x844e
		},
		{
		0xb2b9
		},
		{
		0x844f
		},
		{
		0x8450
		},
		{
		0x8451
		},
		{
		0xb2ba
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_392[]=
	{
		{
		0x8441
		},
		{
		0x8442
		},
		{
		0xb2b5
		},
		{
		0x8443
		},
		{
		0x8444
		},
		{
		0xb2b6
		},
		{
		0x8445
		},
		{
		0xb2b7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_393[]=
	{
		{
		0xb2b2
		},
		{
		0xb2b3
		},
		{
		0x83f4
		},
		{
		0x83f5
		},
		{
		0xb2b4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_394[]=
	{
		{
		0xb2ad
		},
		{
		0xb2ae
		},
		{
		0x83ed
		},
		{
		0xb2af
		},
		{
		0xb2b0
		},
		{
		0xb2b1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_395[]=
	{
		{
		0xb2a8
		},
		{
		0xb2a9
		},
		{
		0xb2aa
		},
		{
		0x83e2
		},
		{
		0xb2ab
		},
		{
		0x83e3
		},
		{
		0x83e4
		},
		{
		0x83e5
		},
		{
		0xb2ac
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_396[]=
	{
		{
		0xb1fe
		},
		{
		0xb2a1
		},
		{
		0x83a6
		},
		{
		0xb2a2
		},
		{
		0xb2a3
		},
		{
		0xb2a4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_397[]=
	{
		{
		0xb1f4
		},
		{
		0xb1f5
		},
		{
		0x8394
		},
		{
		0xb1f6
		},
		{
		0xb1f7
		},
		{
		0xb1f8
		},
		{
		0x8395
		},
		{
		0x8396
		},
		{
		0x8397
		},
		{
		0xb1f9
		},
		{
		0x8398
		},
		{
		0x8399
		},
		{
		0xb1fa
		},
		{
		0xb1fb
		},
		{
		0x839a
		},
		{
		0x839b
		},
		{
		0xb1fc
		},
		{
		0x839c
		},
		{
		0x839d
		},
		{
		0x839e
		},
		{
		0xb1fd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_398[]=
	{
		{
		0xb1e2
		},
		{
		0xb1e3
		},
		{
		0x8374
		},
		{
		0x8375
		},
		{
		0xb1e4
		},
		{
		0x8376
		},
		{
		0x8377
		},
		{
		0xb1e5
		},
		{
		0xb1e6
		},
		{
		0x8378
		},
		{
		0xb1e7
		},
		{
		0x8379
		},
		{
		0x837a
		},
		{
		0x8381
		},
		{
		0x8382
		},
		{
		0x8383
		},
		{
		0xb1e8
		},
		{
		0xb1e9
		},
		{
		0x8384
		},
		{
		0xb1ea
		},
		{
		0x8385
		},
		{
		0xb1eb
		},
		{
		0xb1ec
		},
		{
		0x8386
		},
		{
		0x8387
		},
		{
		0x8388
		},
		{
		0xb1ed
		},
		{
		0x8389
		},
		{
		0xb1ee
		},
		{
		0xb1ef
		},
		{
		0xb1f0
		},
		{
		0x838a
		},
		{
		0xb1f1
		},
		{
		0x838b
		},
		{
		0x838c
		},
		{
		0x838d
		},
		{
		0xb1f2
		},
		{
		0x838e
		},
		{
		0xb1f3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_399[]=
	{
		{
		0xb1dd
		},
		{
		0xb1de
		},
		{
		0x834b
		},
		{
		0xb1df
		},
		{
		0x834c
		},
		{
		0xb1e0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_400[]=
	{
		{
		0xb1d7
		},
		{
		0xb1d8
		},
		{
		0x8341
		},
		{
		0x8342
		},
		{
		0xb1d9
		},
		{
		0x8343
		},
		{
		0x8344
		},
		{
		0xb1da
		},
		{
		0xb1db
		},
		{
		0xb1dc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_401[]=
	{
		{
		0xb1d4
		},
		{
		0x82e6
		},
		{
		0x82e7
		},
		{
		0x82e8
		},
		{
		0xb1d5
		},
		{
		0x82e9
		},
		{
		0x82ea
		},
		{
		0x82eb
		},
		{
		0xb1d6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_402[]=
	{
		{
		0xb1cd
		},
		{
		0xb1ce
		},
		{
		0x82d1
		},
		{
		0x82d2
		},
		{
		0xb1cf
		},
		{
		0x82d3
		},
		{
		0x82d4
		},
		{
		0x82d5
		},
		{
		0xb1d0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_403[]=
	{
		{
		0xb1c5
		},
		{
		0xb1c6
		},
		{
		0x82a1
		},
		{
		0x82a2
		},
		{
		0xb1c7
		},
		{
		0x82a3
		},
		{
		0x82a4
		},
		{
		0x82a5
		},
		{
		0xb1c8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_404[]=
	{
		{
		0xb1b8
		},
		{
		0xb1b9
		},
		{
		0x8292
		},
		{
		0x8293
		},
		{
		0xb1ba
		},
		{
		0x8294
		},
		{
		0x8295
		},
		{
		0xb1bb
		},
		{
		0xb1bc
		},
		{
		0xb1bd
		},
		{
		0xb1be
		},
		{
		0x8296
		},
		{
		0x8297
		},
		{
		0x8298
		},
		{
		0x8299
		},
		{
		0xb1bf
		},
		{
		0xb1c0
		},
		{
		0xb1c1
		},
		{
		0x829a
		},
		{
		0xb1c2
		},
		{
		0x829b
		},
		{
		0xb1c3
		},
		{
		0xb1c4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_405[]=
	{
		{
		0xb1b3
		},
		{
		0x8275
		},
		{
		0x8276
		},
		{
		0x8277
		},
		{
		0xb1b4
		},
		{
		0x8278
		},
		{
		0x8279
		},
		{
		0x827a
		},
		{
		0xb1b5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_406[]=
	{
		{
		0xb1af
		},
		{
		0xb1b0
		},
		{
		0x826d
		},
		{
		0xb1b1
		},
		{
		0x826e
		},
		{
		0xb1b2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_407[]=
	{
		{
		0xb1ab
		},
		{
		0xb1ac
		},
		{
		0x8261
		},
		{
		0x8262
		},
		{
		0xb1ad
		},
		{
		0x8263
		},
		{
		0x8264
		},
		{
		0x8265
		},
		{
		0xb1ae
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_408[]=
	{
		{
		0xb1a8
		},
		{
		0x8253
		},
		{
		0x8254
		},
		{
		0xb1a9
		},
		{
		0xb1aa
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_409[]=
	{
		{
		0xb1a1
		},
		{
		0xb1a2
		},
		{
		0x81fb
		},
		{
		0xb1a3
		},
		{
		0x81fc
		},
		{
		0xb1a4
		},
		{
		0x81fd
		},
		{
		0x81fe
		},
		{
		0x8241
		},
		{
		0x8242
		},
		{
		0x8243
		},
		{
		0x8244
		},
		{
		0xb1a5
		},
		{
		0x8245
		},
		{
		0x8246
		},
		{
		0x8247
		},
		{
		0xb1a6
		},
		{
		0x8248
		},
		{
		0x8249
		},
		{
		0x824a
		},
		{
		0xb1a7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_410[]=
	{
		{
		0xb0fa
		},
		{
		0xb0fb
		},
		{
		0x81f0
		},
		{
		0x81f1
		},
		{
		0xb0fc
		},
		{
		0x81f2
		},
		{
		0x81f3
		},
		{
		0x81f4
		},
		{
		0xb0fd
		},
		{
		0x81f5
		},
		{
		0xb0fe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_411[]=
	{
		{
		0xb0ed
		},
		{
		0xb0ee
		},
		{
		0x81e1
		},
		{
		0x81e2
		},
		{
		0xb0ef
		},
		{
		0x81e3
		},
		{
		0x81e4
		},
		{
		0xb0f0
		},
		{
		0xb0f1
		},
		{
		0x81e5
		},
		{
		0xb0f2
		},
		{
		0x81e6
		},
		{
		0xb0f3
		},
		{
		0x81e7
		},
		{
		0x81e8
		},
		{
		0xb0f4
		},
		{
		0xb0f5
		},
		{
		0xb0f6
		},
		{
		0x81e9
		},
		{
		0xb0f7
		},
		{
		0x81ea
		},
		{
		0xb0f8
		},
		{
		0xb0f9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_412[]=
	{
		{
		0xb0e2
		},
		{
		0xb0e3
		},
		{
		0x81c4
		},
		{
		0xb0e4
		},
		{
		0xb0e5
		},
		{
		0xb0e6
		},
		{
		0x81c5
		},
		{
		0x81c6
		},
		{
		0x81c7
		},
		{
		0xb0e7
		},
		{
		0x81c8
		},
		{
		0x81c9
		},
		{
		0xb0e8
		},
		{
		0x81ca
		},
		{
		0x81cb
		},
		{
		0x81cc
		},
		{
		0xb0e9
		},
		{
		0x81cd
		},
		{
		0x81ce
		},
		{
		0x81cf
		},
		{
		0xb0ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_413[]=
	{
		{
		0xb0dc
		},
		{
		0xb0dd
		},
		{
		0xb0de
		},
		{
		0x81ba
		},
		{
		0xb0df
		},
		{
		0x81bb
		},
		{
		0x81bc
		},
		{
		0xb0e0
		},
		{
		0xb0e1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_414[]=
	{
		{
		0xb0d7
		},
		{
		0xb0d8
		},
		{
		0x81b3
		},
		{
		0xb0d9
		},
		{
		0xb0da
		},
		{
		0xb0db
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_415[]=
	{
		{
		0xb0cb
		},
		{
		0xb0cc
		},
		{
		0x81a3
		},
		{
		0xb0cd
		},
		{
		0xb0ce
		},
		{
		0xb0cf
		},
		{
		0xb0d0
		},
		{
		0x81a4
		},
		{
		0x81a5
		},
		{
		0xb0d1
		},
		{
		0xb0d2
		},
		{
		0xb0d3
		},
		{
		0xb0d4
		},
		{
		0x81a6
		},
		{
		0x81a7
		},
		{
		0x81a8
		},
		{
		0xb0d5
		},
		{
		0x81a9
		},
		{
		0x81aa
		},
		{
		0x81ab
		},
		{
		0xb0d6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_416[]=
	{
		{
		0xb0c5
		},
		{
		0xb0c6
		},
		{
		0x8199
		},
		{
		0x819a
		},
		{
		0xb0c7
		},
		{
		0x819b
		},
		{
		0x819c
		},
		{
		0xb0c8
		},
		{
		0xb0c9
		},
		{
		0x819d
		},
		{
		0xb0ca
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_417[]=
	{
		{
		0xb0c2
		},
		{
		0x817a
		},
		{
		0x8181
		},
		{
		0x8182
		},
		{
		0xb0c3
		},
		{
		0x8183
		},
		{
		0x8184
		},
		{
		0x8185
		},
		{
		0xb0c4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_418[]=
	{
		{
		0xb0b7
		},
		{
		0xb0b8
		},
		{
		0x8157
		},
		{
		0xb0b9
		},
		{
		0xb0ba
		},
		{
		0xb0bb
		},
		{
		0x8158
		},
		{
		0x8159
		},
		{
		0x815a
		},
		{
		0x8161
		},
		{
		0x8162
		},
		{
		0x8163
		},
		{
		0xb0bc
		},
		{
		0xb0bd
		},
		{
		0x8164
		},
		{
		0x8165
		},
		{
		0xb0be
		},
		{
		0x8166
		},
		{
		0x8167
		},
		{
		0x8168
		},
		{
		0xb0bf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_419[]=
	{
		{
		0x814b
		},
		{
		0x814c
		},
		{
		0xb0b5
		},
		{
		0x814d
		},
		{
		0x814e
		},
		{
		0x814f
		},
		{
		0xb0b6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_420[]=
	{
		{
		0xb0a1
		},
		{
		0xb0a2
		},
		{
		0x8141
		},
		{
		0x8142
		},
		{
		0xb0a3
		},
		{
		0x8143
		},
		{
		0x8144
		},
		{
		0xb0a4
		},
		{
		0xb0a5
		},
		{
		0xb0a6
		},
		{
		0xb0a7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_421[]=
	{
		{
		0xceda
		},
		{
		0xfbeb
		},
		{
		0xdba6
		},
		{
		0xdbde
		},
		{
		0xd8e5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_422[]=
	{
		{
		0xfac2
		},
		{
		0xfbe1
		},
		{
		0xfaed
		},
		{
		0xf0a2
		},
		{
		0xccf1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_423[]=
	{
		{
		0xf8ce
		},
		{
		0xf9f0
		},
		{
		0xe0ed
		},
		{
		0xe3b3
		},
		{
		0xf4b3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_424[]=
	{
		{
		0xe2f6
		},
		{
		0xd3ca
		},
		{
		0xeffc
		},
		{
		0xd1c4
		},
		{
		0xefb1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_425[]=
	{
		{
		0xe0b7
		},
		{
		0xd7ec
		},
		{
		0xf1ec
		},
		{
		0xe5af
		},
		{
		0xd5e1
		},
		{
		0xd7ed
		},
		{
		0xd1d1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_426[]=
	{
		{
		0xebb7
		},
		{
		0xeff8
		},
		{
		0xf5dc
		},
		{
		0xedcc
		},
		{
		0xdbd5
		},
		{
		0xf1cf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_427[]=
	{
		{
		0xf9ad
		},
		{
		0xe9ad
		},
		{
		0xd8e4
		},
		{
		0xfab3
		},
		{
		0xe2c5
		},
		{
		0xfcbd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_428[]=
	{
		{
		0xe0a6
		},
		{
		0xd6c1
		},
		{
		0xe1dc
		},
		{
		0xf0e3
		},
		{
		0xf1e4
		},
		{
		0xdcf1
		},
		{
		0xd6a7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_429[]=
	{
		{
		0xd5e0
		},
		{
		0xf6ca
		},
		{
		0xfdca
		},
		{
		0xd8d6
		},
		{
		0xf4cf
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_430[]=
	{
		{
		0xd9f5
		},
		{
		0xf9c5
		},
		{
		0xddd3
		},
		{
		0xd6f1
		},
		{
		0xecfc
		},
		{
		0xfcf0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_431[]=
	{
		{
		0xdeb8
		},
		{
		0xfca7
		},
		{
		0xf7fc
		},
		{
		0xf7b1
		},
		{
		0xcebb
		},
		{
		0xf4a1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_432[]=
	{
		{
		0xf1e8
		},
		{
		0xd9f2
		},
		{
		0xdbf5
		},
		{
		0xcab5
		},
		{
		0xd9c6
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_433[]=
	{
		{
		0xf0fb
		},
		{
		0xfae1
		},
		{
		0xf0da
		},
		{
		0xcce7
		},
		{
		0xdaf4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_434[]=
	{
		{
		0xdee9
		},
		{
		0xcedc
		},
		{
		0xf2b5
		},
		{
		0xd0e4
		},
		{
		0xddd1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_435[]=
	{
		{
		0xe5b3
		},
		{
		0xfbf5
		},
		{
		0xe9e1
		},
		{
		0xfde0
		},
		{
		0xfcbc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_436[]=
	{
		{
		0xd0d8
		},
		{
		0xfca2
		},
		{
		0xd4be
		},
		{
		0xe2b3
		},
		{
		0xdee7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_437[]=
	{
		{
		0xf0d4
		},
		{
		0xcbe4
		},
		{
		0xfbd4
		},
		{
		0xf5e6
		},
		{
		0xe3ea
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_438[]=
	{
		{
		0xf9d5
		},
		{
		0xe7ba
		},
		{
		0xebd5
		},
		{
		0xd5f7
		},
		{
		0xefe7
		},
		{
		0xe1be
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_439[]=
	{
		{
		0xfbe8
		},
		{
		0xf4e8
		},
		{
		0xe5f4
		},
		{
		0xf4bc
		},
		{
		0xf4d5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_440[]=
	{
		{
		0xcfee
		},
		{
		0xf6be
		},
		{
		0xe0b2
		},
		{
		0xfcfe
		},
		{
		0xd1ab
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_441[]=
	{
		{
		0xf6bd
		},
		{
		0xe1bb
		},
		{
		0xcdbf
		},
		{
		0xf4d4
		},
		{
		0xe6cd
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_442[]=
	{
		{
		0xd9d2
		},
		{
		0xd3cb
		},
		{
		0xd8f7
		},
		{
		0xdaa9
		},
		{
		0xf5f8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_443[]=
	{
		{
		0xfcb6
		},
		{
		0xf2ad
		},
		{
		0xefe1
		},
		{
		0xf3ae
		},
		{
		0xdcc6
		},
		{
		0xd9eb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_444[]=
	{
		{
		0xdbda
		},
		{
		0xd9bb
		},
		{
		0xcaf3
		},
		{
		0xf6d3
		},
		{
		0xe6f8
		},
		{
		0xeaf5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_445[]=
	{
		{
		0xdab1
		},
		{
		0xd8c7
		},
		{
		0xdce2
		},
		{
		0xf3ce
		},
		{
		0xf5f4
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_446[]=
	{
		{
		0xe7fb
		},
		{
		0xfcb7
		},
		{
		0xfce4
		},
		{
		0xfbc5
		},
		{
		0xe3e7
		},
		{
		0xd8b9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_447[]=
	{
		{
		0xcad0
		},
		{
		0xfaab
		},
		{
		0xebeb
		},
		{
		0xe7f8
		},
		{
		0xd9e5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_448[]=
	{
		{
		0xf3f4
		},
		{
		0xf8f3
		},
		{
		0xf0c1
		},
		{
		0xdeaf
		},
		{
		0xf8b0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_449[]=
	{
		{
		0xe3b9
		},
		{
		0xebc5
		},
		{
		0xf4a9
		},
		{
		0xcdb6
		},
		{
		0xd2f9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_450[]=
	{
		{
		0xede2
		},
		{
		0xeef6
		},
		{
		0xeacf
		},
		{
		0xf0ee
		},
		{
		0xe3fc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_451[]=
	{
		{
		0xe7f5
		},
		{
		0xe8ef
		},
		{
		0xe3f9
		},
		{
		0xd2bb
		},
		{
		0xf3f3
		},
		{
		0xe3fb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_452[]=
	{
		{
		0xeed6
		},
		{
		0xeab2
		},
		{
		0xd0f6
		},
		{
		0xecd9
		},
		{
		0xdacb
		},
		{
		0xcfa8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_453[]=
	{
		{
		0xcbd4
		},
		{
		0xe0be
		},
		{
		0xe3f8
		},
		{
		0xeae9
		},
		{
		0xfcb2
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_454[]=
	{
		{
		0xf7b5
		},
		{
		0xfcf3
		},
		{
		0xf0f3
		},
		{
		0xceaf
		},
		{
		0xf1b5
		},
		{
		0xefd2
		},
		{
		0xe8c8
		},
		{
		0xebf1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_455[]=
	{
		{
		0xf7ac
		},
		{
		0xebc4
		},
		{
		0xede1
		},
		{
		0xe0ab
		},
		{
		0xddc7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_456[]=
	{
		{
		0xd4d2
		},
		{
		0xd9a3
		},
		{
		0xfda8
		},
		{
		0xd7d9
		},
		{
		0xf7ce
		},
		{
		0xfabe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_457[]=
	{
		{
		0xcaa6
		},
		{
		0xf7bb
		},
		{
		0xf2ea
		},
		{
		0xdec8
		},
		{
		0xe9d3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_458[]=
	{
		{
		0xcdb0
		},
		{
		0xf1fe
		},
		{
		0xd0a3
		},
		{
		0xe1af
		},
		{
		0xf8a3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_459[]=
	{
		{
		0xe7d5
		},
		{
		0xf5bf
		},
		{
		0xcfa2
		},
		{
		0xcdaf
		},
		{
		0xcfa3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_460[]=
	{
		{
		0xf0a4
		},
		{
		0xe1ec
		},
		{
		0xcfe7
		},
		{
		0xf3cb
		},
		{
		0xeda9
		},
		{
		0xcabe
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_461[]=
	{
		{
		0xd2ae
		},
		{
		0xeeef
		},
		{
		0xd5d7
		},
		{
		0xeae4
		},
		{
		0xf8a2
		},
		{
		0xcdeb
		},
		{
		0xd7bf
		},
		{
		0xfbb1
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_462[]=
	{
		{
		0xeaaa
		},
		{
		0xfafc
		},
		{
		0xf5f6
		},
		{
		0xf0bc
		},
		{
		0xfdd4
		},
		{
		0xe0bb
		},
		{
		0xcec3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_463[]=
	{
		{
		0xeac8
		},
		{
		0xeeb8
		},
		{
		0xf1ac
		},
		{
		0xf1a5
		},
		{
		0xe9ce
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_464[]=
	{
		{
		0xe7ea
		},
		{
		0xd0eb
		},
		{
		0xdcd1
		},
		{
		0xdbe9
		},
		{
		0xfdcc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_465[]=
	{
		{
		0xeda8
		},
		{
		0xdec2
		},
		{
		0xf6e2
		},
		{
		0xeddc
		},
		{
		0xdcf5
		},
		{
		0xe0b9
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_466[]=
	{
		{
		0xd8b2
		},
		{
		0xeddb
		},
		{
		0xdfb2
		},
		{
		0xdfbe
		},
		{
		0xf9bb
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_467[]=
	{
		{
		0xa7da
		},
		{
		0xa7db
		},
		{
		0xa2e3
		},
		{
		0xa7ec
		},
		{
		0xa7a6
		},
		{
		0xa7e0
		},
		{
		0xa7ef
		},
		{
		0xa2e1
		},
		{
		0xa7bc
		},
		{
		0xa7ed
		},
		{
		0xa7b5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_468[]=
	{
		{
		0xa7a7
		},
		{
		0xa7a8
		},
		{
		0xa7a9
		},
		{
		0xa7aa
		},
		{
		0xa7bd
		},
		{
		0xa7be
		},
		{
		0xa7e5
		},
		{
		0xa7e6
		},
		{
		0xa7e7
		},
		{
		0xa7e8
		},
		{
		0xa7e1
		},
		{
		0xa7e2
		},
		{
		0xa7e3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_469[]=
	{
		{
		0xa7ba
		},
		{
		0xa7bb
		},
		{
		0xa7dc
		},
		{
		0xa7dd
		},
		{
		0xa7de
		},
		{
		0xa7b6
		},
		{
		0xa7b7
		},
		{
		0xa7b8
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_470[]=
	{
		{
		0xa2c3
		},
		{
		0xa2c7
		},
		{
		0xa2c8
		},
		{
		0xa2cb
		},
		{
		0xa2ca
		},
		{
		0xa2c9
		},
		{
		0xa2cc
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_471[]=
	{
		{
		0xa6a3
		},
		{
		0xa6c8
		},
		{
		0xa6c7
		},
		{
		0xa6ae
		},
		{
		0xa6a4
		},
		{
		0xa6c2
		},
		{
		0xa6c1
		},
		{
		0xa6af
		},
		{
		0xa6a6
		},
		{
		0xa6c6
		},
		{
		0xa6c5
		},
		{
		0xa6b1
		},
		{
		0xa6a5
		},
		{
		0xa6c4
		},
		{
		0xa6c3
		},
		{
		0xa6b0
		},
		{
		0xa6a7
		},
		{
		0xa6bc
		},
		{
		0xa6c9
		},
		{
		0xa6ca
		},
		{
		0xa6b7
		},
		{
		0xa6cb
		},
		{
		0xa6cc
		},
		{
		0xa6b2
		},
		{
		0xa6a9
		},
		{
		0xa6be
		},
		{
		0xa6cd
		},
		{
		0xa6ce
		},
		{
		0xa6b9
		},
		{
		0xa6cf
		},
		{
		0xa6d0
		},
		{
		0xa6b4
		},
		{
		0xa6a8
		},
		{
		0xa6d1
		},
		{
		0xa6d2
		},
		{
		0xa6b8
		},
		{
		0xa6bd
		},
		{
		0xa6d3
		},
		{
		0xa6d4
		},
		{
		0xa6b3
		},
		{
		0xa6aa
		},
		{
		0xa6d5
		},
		{
		0xa6d6
		},
		{
		0xa6ba
		},
		{
		0xa6bf
		},
		{
		0xa6d7
		},
		{
		0xa6d8
		},
		{
		0xa6b5
		},
		{
		0xa6ab
		},
		{
		0xa6d9
		},
		{
		0xa6da
		},
		{
		0xa6bb
		},
		{
		0xa6db
		},
		{
		0xa6dc
		},
		{
		0xa6c0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_472[]=
	{
		{
		0xa1fc
		},
		{
		0xa1fd
		},
		{
		0xa1fb
		},
		{
		0xa1fa
		},
		{
		0xa1f2
		},
		{
		0xa1f3
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_473[]=
	{
		{
		0xa1e7
		},
		{
		0xa1e8
		},
		{
		0xa1e6
		},
		{
		0xa1e9
		},
		{
		0xa1ea
		},
		{
		0xa2d5
		},
		{
		0xa2d8
		},
		{
		0xa2d6
		},
		{
		0xa2d9
		},
		{
		0xa2d7
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_474[]=
	{
		{
		0xa2d2
		},
		{
		0xa1a4
		},
		{
		0xa2ac
		},
		{
		0xa9f6
		},
		{
		0xa8ac
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SIndexedTable16::SEntry indexedTable16_unicodeToForeign_475[]=
	{
		{
		0xa1c6
		},
		{
		0xa1be
		},
		{
		0xa9f7
		},
		{
		0xa9f8
		},
		{
		0xa2a5
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange::UData::SKeyedTable1616::SEntry keyedTable1616_unicodeToForeign_1[]=
	{
		{
		0x00a1,
		0xa2ae
		},
		{
		0x00a4,
		0xa2b4
		},
		{
		0x00a7,
		0xa1d7
		},
		{
		0x00a8,
		0xa1a7
		},
		{
		0x00aa,
		0xa8a3
		},
		{
		0x00ad,
		0xa1a9
		},
		{
		0x00ae,
		0xa2e7
		},
		{
		0x00bc,
		0xa8f9
		},
		{
		0x00bd,
		0xa8f6
		},
		{
		0x00be,
		0xa8fa
		},
		{
		0x00bf,
		0xa2af
		},
		{
		0x00c6,
		0xa8a1
		},
		{
		0x00d0,
		0xa8a2
		},
		{
		0x00d7,
		0xa1bf
		},
		{
		0x00d8,
		0xa8aa
		},
		{
		0x00de,
		0xa8ad
		},
		{
		0x00df,
		0xa9ac
		},
		{
		0x00e6,
		0xa9a1
		},
		{
		0x00f0,
		0xa9a3
		},
		{
		0x00f7,
		0xa1c0
		},
		{
		0x00f8,
		0xa9aa
		},
		{
		0x00fe,
		0xa9ad
		},
		{
		0x0111,
		0xa9a2
		},
		{
		0x0126,
		0xa8a4
		},
		{
		0x0127,
		0xa9a4
		},
		{
		0x0131,
		0xa9a5
		},
		{
		0x0132,
		0xa8a6
		},
		{
		0x0133,
		0xa9a6
		},
		{
		0x0138,
		0xa9a7
		},
		{
		0x013f,
		0xa8a8
		},
		{
		0x0140,
		0xa9a8
		},
		{
		0x0141,
		0xa8a9
		},
		{
		0x0142,
		0xa9a9
		},
		{
		0x0149,
		0xa9b0
		},
		{
		0x014a,
		0xa8af
		},
		{
		0x014b,
		0xa9af
		},
		{
		0x0152,
		0xa8ab
		},
		{
		0x0153,
		0xa9ab
		},
		{
		0x0166,
		0xa8ae
		},
		{
		0x0167,
		0xa9ae
		},
		{
		0x02c7,
		0xa2a7
		},
		{
		0x02d0,
		0xa2b0
		},
		{
		0x02d8,
		0xa2a8
		},
		{
		0x02d9,
		0xa2ab
		},
		{
		0x02da,
		0xa2aa
		},
		{
		0x02db,
		0xa2ad
		},
		{
		0x02dd,
		0xa2a9
		},
		{
		0x0401,
		0xaca7
		},
		{
		0x0451,
		0xacd7
		},
		{
		0x2015,
		0xa1aa
		},
		{
		0x2018,
		0xa1ae
		},
		{
		0x2019,
		0xa1af
		},
		{
		0x201c,
		0xa1b0
		},
		{
		0x201d,
		0xa1b1
		},
		{
		0x2020,
		0xa2d3
		},
		{
		0x2021,
		0xa2d4
		},
		{
		0x2025,
		0xa1a5
		},
		{
		0x2026,
		0xa1a6
		},
		{
		0x2030,
		0xa2b6
		},
		{
		0x2032,
		0xa1c7
		},
		{
		0x2033,
		0xa1c8
		},
		{
		0x203b,
		0xa1d8
		},
		{
		0x2074,
		0xa9f9
		},
		{
		0x207f,
		0xa9fa
		},
		{
		0x2081,
		0xa9fb
		},
		{
		0x2082,
		0xa9fc
		},
		{
		0x2083,
		0xa9fd
		},
		{
		0x2084,
		0xa9fe
		},
		{
		0x20ac,
		0xa2e6
		},
		{
		0x2103,
		0xa1c9
		},
		{
		0x2109,
		0xa2b5
		},
		{
		0x2113,
		0xa7a4
		},
		{
		0x2116,
		0xa2e0
		},
		{
		0x2121,
		0xa2e5
		},
		{
		0x2122,
		0xa2e2
		},
		{
		0x2126,
		0xa7d9
		},
		{
		0x212b,
		0xa1ca
		},
		{
		0x2153,
		0xa8f7
		},
		{
		0x2154,
		0xa8f8
		},
		{
		0x215b,
		0xa8fb
		},
		{
		0x215c,
		0xa8fc
		},
		{
		0x215d,
		0xa8fd
		},
		{
		0x215e,
		0xa8fe
		},
		{
		0x21d2,
		0xa2a1
		},
		{
		0x21d4,
		0xa2a2
		},
		{
		0x2200,
		0xa2a3
		},
		{
		0x2202,
		0xa1d3
		},
		{
		0x2203,
		0xa2a4
		},
		{
		0x2207,
		0xa1d4
		},
		{
		0x2208,
		0xa1f4
		},
		{
		0x220b,
		0xa1f5
		},
		{
		0x220f,
		0xa2b3
		},
		{
		0x2211,
		0xa2b2
		},
		{
		0x221a,
		0xa1ee
		},
		{
		0x221d,
		0xa1f0
		},
		{
		0x221e,
		0xa1c4
		},
		{
		0x2220,
		0xa1d0
		},
		{
		0x2225,
		0xa1ab
		},
		{
		0x222e,
		0xa2b1
		},
		{
		0x2234,
		0xa1c5
		},
		{
		0x2235,
		0xa1f1
		},
		{
		0x223c,
		0xa1ad
		},
		{
		0x223d,
		0xa1ef
		},
		{
		0x2252,
		0xa1d6
		},
		{
		0x2260,
		0xa1c1
		},
		{
		0x2261,
		0xa1d5
		},
		{
		0x2264,
		0xa1c2
		},
		{
		0x2265,
		0xa1c3
		},
		{
		0x226a,
		0xa1ec
		},
		{
		0x226b,
		0xa1ed
		},
		{
		0x2282,
		0xa1f8
		},
		{
		0x2283,
		0xa1f9
		},
		{
		0x2286,
		0xa1f6
		},
		{
		0x2287,
		0xa1f7
		},
		{
		0x2299,
		0xa2c1
		},
		{
		0x22a5,
		0xa1d1
		},
		{
		0x2312,
		0xa1d2
		},
		{
		0x2500,
		0xa6a1
		},
		{
		0x2501,
		0xa6ac
		},
		{
		0x2502,
		0xa6a2
		},
		{
		0x2503,
		0xa6ad
		},
		{
		0x254b,
		0xa6b6
		},
		{
		0x2592,
		0xa2c6
		},
		{
		0x25a0,
		0xa1e1
		},
		{
		0x25a1,
		0xa1e0
		},
		{
		0x25b2,
		0xa1e3
		},
		{
		0x25b3,
		0xa1e2
		},
		{
		0x25b6,
		0xa2ba
		},
		{
		0x25b7,
		0xa2b9
		},
		{
		0x25bc,
		0xa1e5
		},
		{
		0x25bd,
		0xa1e4
		},
		{
		0x25c0,
		0xa2b8
		},
		{
		0x25c1,
		0xa2b7
		},
		{
		0x25c6,
		0xa1df
		},
		{
		0x25c7,
		0xa1de
		},
		{
		0x25c8,
		0xa2c2
		},
		{
		0x25cb,
		0xa1db
		},
		{
		0x25ce,
		0xa1dd
		},
		{
		0x25cf,
		0xa1dc
		},
		{
		0x25d0,
		0xa2c4
		},
		{
		0x25d1,
		0xa2c5
		},
		{
		0x2605,
		0xa1da
		},
		{
		0x2606,
		0xa1d9
		},
		{
		0x260e,
		0xa2cf
		},
		{
		0x260f,
		0xa2ce
		},
		{
		0x261c,
		0xa2d0
		},
		{
		0x261e,
		0xa2d1
		},
		{
		0x2640,
		0xa1cf
		},
		{
		0x2642,
		0xa1ce
		},
		{
		0x2660,
		0xa2bc
		},
		{
		0x2661,
		0xa2bd
		},
		{
		0x2663,
		0xa2c0
		},
		{
		0x2664,
		0xa2bb
		},
		{
		0x2665,
		0xa2be
		},
		{
		0x2667,
		0xa2bf
		},
		{
		0x2668,
		0xa2cd
		},
		{
		0x2669,
		0xa2db
		},
		{
		0x266a,
		0xa2dc
		},
		{
		0x266c,
		0xa2dd
		},
		{
		0x266d,
		0xa2da
		},
		{
		0x3000,
		0xa1a1
		},
		{
		0x3001,
		0xa1a2
		},
		{
		0x3002,
		0xa1a3
		},
		{
		0x3003,
		0xa1a8
		},
		{
		0x3013,
		0xa1eb
		},
		{
		0x3014,
		0xa1b2
		},
		{
		0x3015,
		0xa1b3
		},
		{
		0x321c,
		0xa2df
		},
		{
		0x327e,
		0xa2e8
		},
		{
		0x327f,
		0xa2de
		},
		{
		0x3395,
		0xa7a1
		},
		{
		0x3396,
		0xa7a2
		},
		{
		0x3397,
		0xa7a3
		},
		{
		0x3398,
		0xa7a5
		},
		{
		0x33cf,
		0xa7b9
		},
		{
		0x33d0,
		0xa7ea
		},
		{
		0x33d3,
		0xa7eb
		},
		{
		0x33d6,
		0xa7df
		},
		{
		0x33d8,
		0xa2e4
		},
		{
		0x33db,
		0xa7e4
		},
		{
		0x33dc,
		0xa7ee
		},
		{
		0x33dd,
		0xa7e9
		},
		{
		0x4e00,
		0xece9
		},
		{
		0x4e01,
		0xefcb
		},
		{
		0x4e03,
		0xf6d2
		},
		{
		0x4e0d,
		0xdcf4
		},
		{
		0x4e11,
		0xf5e4
		},
		{
		0x4e14,
		0xf3a6
		},
		{
		0x4e15,
		0xdde0
		},
		{
		0x4e16,
		0xe1a6
		},
		{
		0x4e18,
		0xcef8
		},
		{
		0x4e19,
		0xdcb0
		},
		{
		0x4e1e,
		0xe3aa
		},
		{
		0x4e2d,
		0xf1e9
		},
		{
		0x4e32,
		0xcdfa
		},
		{
		0x4e38,
		0xfcaf
		},
		{
		0x4e39,
		0xd3a1
		},
		{
		0x4e3b,
		0xf1ab
		},
		{
		0x4e42,
		0xe7d1
		},
		{
		0x4e43,
		0xd2ac
		},
		{
		0x4e45,
		0xcef9
		},
		{
		0x4e4b,
		0xf1fd
		},
		{
		0x4e4d,
		0xdebf
		},
		{
		0x4e4e,
		0xfbba
		},
		{
		0x4e4f,
		0xf9b9
		},
		{
		0x4e56,
		0xced2
		},
		{
		0x4e58,
		0xe3ab
		},
		{
		0x4e59,
		0xebe0
		},
		{
		0x4e5d,
		0xcefa
		},
		{
		0x4e5e,
		0xcbf7
		},
		{
		0x4e5f,
		0xe5a5
		},
		{
		0x4e6b,
		0xcae1
		},
		{
		0x4e6d,
		0xd4cc
		},
		{
		0x4e73,
		0xeae1
		},
		{
		0x4e76,
		0xdce3
		},
		{
		0x4e77,
		0xdfad
		},
		{
		0x4e7e,
		0xcbeb
		},
		{
		0x4e82,
		0xd5af
		},
		{
		0x4e86,
		0xd6f5
		},
		{
		0x4e88,
		0xe5f8
		},
		{
		0x4e8b,
		0xdec0
		},
		{
		0x4e8c,
		0xeca3
		},
		{
		0x4e8e,
		0xe9cd
		},
		{
		0x4e90,
		0xeaa7
		},
		{
		0x4e91,
		0xe9f6
		},
		{
		0x4e92,
		0xfbbb
		},
		{
		0x4e94,
		0xe7e9
		},
		{
		0x4e95,
		0xefcc
		},
		{
		0x4e98,
		0xd0e6
		},
		{
		0x4e9b,
		0xdec1
		},
		{
		0x4e9e,
		0xe4ac
		},
		{
		0x4ea1,
		0xd8cc
		},
		{
		0x4ea2,
		0xf9f1
		},
		{
		0x4ea4,
		0xcedf
		},
		{
		0x4ea5,
		0xfaa4
		},
		{
		0x4ea6,
		0xe6b2
		},
		{
		0x4ea8,
		0xfafb
		},
		{
		0x4eab,
		0xfabd
		},
		{
		0x4eac,
		0xccc8
		},
		{
		0x4ead,
		0xefcd
		},
		{
		0x4eae,
		0xd5d5
		},
		{
		0x4eb6,
		0xd3a2
		},
		{
		0x4eba,
		0xecd1
		},
		{
		0x4ec0,
		0xe4a7
		},
		{
		0x4ec1,
		0xecd2
		},
		{
		0x4ec4,
		0xf6b1
		},
		{
		0x4ec7,
		0xcefb
		},
		{
		0x4eca,
		0xd0d1
		},
		{
		0x4ecb,
		0xcbbf
		},
		{
		0x4ecd,
		0xeda4
		},
		{
		0x4edd,
		0xd4ce
		},
		{
		0x4edf,
		0xf4b5
		},
		{
		0x4ee3,
		0xd3db
		},
		{
		0x4ee4,
		0xd6b5
		},
		{
		0x4ee5,
		0xeca4
		},
		{
		0x4ef0,
		0xe4e6
		},
		{
		0x4ef2,
		0xf1ea
		},
		{
		0x4ef6,
		0xcbec
		},
		{
		0x4ef7,
		0xcbc0
		},
		{
		0x4efb,
		0xecf2
		},
		{
		0x4f01,
		0xd0ea
		},
		{
		0x4f09,
		0xf9f2
		},
		{
		0x4f0a,
		0xeca5
		},
		{
		0x4f0b,
		0xd0df
		},
		{
		0x4f2f,
		0xdbd7
		},
		{
		0x4f34,
		0xdae1
		},
		{
		0x4f36,
		0xd6b6
		},
		{
		0x4f38,
		0xe3df
		},
		{
		0x4f3a,
		0xdec3
		},
		{
		0x4f3c,
		0xdec4
		},
		{
		0x4f3d,
		0xcaa1
		},
		{
		0x4f43,
		0xeeec
		},
		{
		0x4f46,
		0xd3a3
		},
		{
		0x4f47,
		0xeeb7
		},
		{
		0x4f48,
		0xf8cf
		},
		{
		0x4f55,
		0xf9bc
		},
		{
		0x4f59,
		0xe5f9
		},
		{
		0x4f5a,
		0xecea
		},
		{
		0x4f5b,
		0xddd6
		},
		{
		0x4f5c,
		0xedc2
		},
		{
		0x4f69,
		0xf8a5
		},
		{
		0x4f6f,
		0xe5ba
		},
		{
		0x4f70,
		0xdbd8
		},
		{
		0x4f73,
		0xcaa2
		},
		{
		0x4f76,
		0xd1cd
		},
		{
		0x4f7a,
		0xeeed
		},
		{
		0x4f7e,
		0xeceb
		},
		{
		0x4f7f,
		0xdec5
		},
		{
		0x4f81,
		0xe3e0
		},
		{
		0x4f83,
		0xcac9
		},
		{
		0x4f84,
		0xf2e9
		},
		{
		0x4f86,
		0xd5ce
		},
		{
		0x4f88,
		0xf6b6
		},
		{
		0x4f8a,
		0xcec2
		},
		{
		0x4f8b,
		0xd6c7
		},
		{
		0x4f8d,
		0xe3b4
		},
		{
		0x4f8f,
		0xf1ad
		},
		{
		0x4f91,
		0xeae2
		},
		{
		0x4f96,
		0xd7c2
		},
		{
		0x4f98,
		0xf3a7
		},
		{
		0x4f9b,
		0xcdea
		},
		{
		0x4f9d,
		0xebee
		},
		{
		0x4fae,
		0xd9b2
		},
		{
		0x4faf,
		0xfda5
		},
		{
		0x4fb5,
		0xf6d5
		},
		{
		0x4fb6,
		0xd5e2
		},
		{
		0x4fbf,
		0xf8b5
		},
		{
		0x4fc2,
		0xccf5
		},
		{
		0x4fc3,
		0xf5b5
		},
		{
		0x4fc4,
		0xe4ad
		},
		{
		0x4fc9,
		0xe7eb
		},
		{
		0x4fca,
		0xf1d5
		},
		{
		0x4fce,
		0xf0bb
		},
		{
		0x4fd1,
		0xe9b5
		},
		{
		0x4fd3,
		0xccc9
		},
		{
		0x4fd4,
		0xfad5
		},
		{
		0x4fd7,
		0xe1d4
		},
		{
		0x4fda,
		0xd7d6
		},
		{
		0x4fdd,
		0xdcc1
		},
		{
		0x4fdf,
		0xdec6
		},
		{
		0x4fe0,
		0xfaef
		},
		{
		0x4fe1,
		0xe3e1
		},
		{
		0x4fee,
		0xe1f3
		},
		{
		0x4fef,
		0xdcf6
		},
		{
		0x4ff1,
		0xcefc
		},
		{
		0x4ff3,
		0xdbc4
		},
		{
		0x4ff5,
		0xf8f1
		},
		{
		0x4ff8,
		0xdce4
		},
		{
		0x4ffa,
		0xe5ef
		},
		{
		0x5002,
		0xdcb1
		},
		{
		0x5006,
		0xd5d6
		},
		{
		0x5009,
		0xf3da
		},
		{
		0x500b,
		0xcbc1
		},
		{
		0x500d,
		0xdbc3
		},
		{
		0x5011,
		0xd9fa
		},
		{
		0x5012,
		0xd3ee
		},
		{
		0x5016,
		0xfab8
		},
		{
		0x5019,
		0xfda6
		},
		{
		0x501a,
		0xebef
		},
		{
		0x501c,
		0xf4a6
		},
		{
		0x501e,
		0xccca
		},
		{
		0x501f,
		0xf3a8
		},
		{
		0x5021,
		0xf3db
		},
		{
		0x5023,
		0xdba7
		},
		{
		0x5024,
		0xf6b7
		},
		{
		0x5026,
		0xcfe6
		},
		{
		0x5027,
		0xf0f2
		},
		{
		0x5028,
		0xcbda
		},
		{
		0x502a,
		0xe7d2
		},
		{
		0x502b,
		0xd7c3
		},
		{
		0x502c,
		0xf6f0
		},
		{
		0x502d,
		0xe8de
		},
		{
		0x503b,
		0xe5a6
		},
		{
		0x5043,
		0xe5e7
		},
		{
		0x5047,
		0xcaa3
		},
		{
		0x5048,
		0xcca7
		},
		{
		0x5049,
		0xeac9
		},
		{
		0x504f,
		0xf8b6
		},
		{
		0x5055,
		0xfaa5
		},
		{
		0x505a,
		0xf1ae
		},
		{
		0x505c,
		0xefce
		},
		{
		0x5065,
		0xcbed
		},
		{
		0x5074,
		0xf6b0
		},
		{
		0x5075,
		0xefcf
		},
		{
		0x5076,
		0xe9cf
		},
		{
		0x5078,
		0xf7de
		},
		{
		0x5080,
		0xced3
		},
		{
		0x5085,
		0xdcf7
		},
		{
		0x508d,
		0xdba8
		},
		{
		0x5091,
		0xcbf8
		},
		{
		0x5098,
		0xdfa1
		},
		{
		0x5099,
		0xdde1
		},
		{
		0x50ac,
		0xf5ca
		},
		{
		0x50ad,
		0xe9b6
		},
		{
		0x50b2,
		0xe7ec
		},
		{
		0x50b3,
		0xeeee
		},
		{
		0x50b5,
		0xf3f0
		},
		{
		0x50b7,
		0xdfbf
		},
		{
		0x50be,
		0xcccb
		},
		{
		0x50c5,
		0xd0c1
		},
		{
		0x50c9,
		0xf4d2
		},
		{
		0x50ca,
		0xe0ba
		},
		{
		0x50cf,
		0xdfc0
		},
		{
		0x50d1,
		0xcee0
		},
		{
		0x50d5,
		0xdcd2
		},
		{
		0x50d6,
		0xfdea
		},
		{
		0x50da,
		0xd6f6
		},
		{
		0x50de,
		0xeaca
		},
		{
		0x50e5,
		0xe8e9
		},
		{
		0x50e7,
		0xe3ac
		},
		{
		0x50ed,
		0xf3d0
		},
		{
		0x50f9,
		0xcaa4
		},
		{
		0x50fb,
		0xdbf8
		},
		{
		0x50ff,
		0xdec7
		},
		{
		0x5100,
		0xebf0
		},
		{
		0x5101,
		0xf1d6
		},
		{
		0x5104,
		0xe5e2
		},
		{
		0x5106,
		0xcccc
		},
		{
		0x5109,
		0xcbfb
		},
		{
		0x5112,
		0xeae3
		},
		{
		0x511f,
		0xdfc1
		},
		{
		0x5121,
		0xd6ed
		},
		{
		0x512a,
		0xe9d0
		},
		{
		0x5132,
		0xeeb9
		},
		{
		0x5137,
		0xd5e3
		},
		{
		0x513a,
		0xd1d3
		},
		{
		0x513c,
		0xe5f0
		},
		{
		0x5140,
		0xe8b4
		},
		{
		0x5141,
		0xebc3
		},
		{
		0x514b,
		0xd0ba
		},
		{
		0x514c,
		0xf7ba
		},
		{
		0x514d,
		0xd8f3
		},
		{
		0x514e,
		0xf7cd
		},
		{
		0x5152,
		0xe4ae
		},
		{
		0x515c,
		0xd4df
		},
		{
		0x5162,
		0xd0e7
		},
		{
		0x5165,
		0xecfd
		},
		{
		0x5171,
		0xcdec
		},
		{
		0x5175,
		0xdcb2
		},
		{
		0x5176,
		0xd0ec
		},
		{
		0x5177,
		0xcefd
		},
		{
		0x5178,
		0xeef0
		},
		{
		0x517c,
		0xccc2
		},
		{
		0x5180,
		0xd0ed
		},
		{
		0x5186,
		0xe5f7
		},
		{
		0x518a,
		0xf3fc
		},
		{
		0x518d,
		0xeea2
		},
		{
		0x5192,
		0xd9b3
		},
		{
		0x5195,
		0xd8f4
		},
		{
		0x5197,
		0xe9b7
		},
		{
		0x51a0,
		0xceae
		},
		{
		0x51a5,
		0xd9a2
		},
		{
		0x51aa,
		0xd8f1
		},
		{
		0x51ac,
		0xd4cf
		},
		{
		0x51b6,
		0xe5a7
		},
		{
		0x51b7,
		0xd5d2
		},
		{
		0x51bd,
		0xd6a9
		},
		{
		0x51c4,
		0xf4a2
		},
		{
		0x51c6,
		0xf1d7
		},
		{
		0x51c9,
		0xd5d8
		},
		{
		0x51cb,
		0xf0bd
		},
		{
		0x51cc,
		0xd7d0
		},
		{
		0x51cd,
		0xd4d0
		},
		{
		0x51dc,
		0xd7cf
		},
		{
		0x51dd,
		0xebea
		},
		{
		0x51de,
		0xfdeb
		},
		{
		0x51e1,
		0xdbed
		},
		{
		0x51f0,
		0xfcc5
		},
		{
		0x51f1,
		0xcbc2
		},
		{
		0x51f6,
		0xfdd5
		},
		{
		0x51f8,
		0xf4c8
		},
		{
		0x51f9,
		0xe8ea
		},
		{
		0x51fa,
		0xf5f3
		},
		{
		0x51fd,
		0xf9de
		},
		{
		0x5200,
		0xd3ef
		},
		{
		0x5203,
		0xecd3
		},
		{
		0x5206,
		0xddc2
		},
		{
		0x5207,
		0xefb7
		},
		{
		0x5208,
		0xe7d4
		},
		{
		0x520a,
		0xcaca
		},
		{
		0x520e,
		0xd9fb
		},
		{
		0x5211,
		0xfafd
		},
		{
		0x5217,
		0xd6aa
		},
		{
		0x521d,
		0xf4f8
		},
		{
		0x5224,
		0xf7f7
		},
		{
		0x5225,
		0xdcac
		},
		{
		0x5229,
		0xd7d7
		},
		{
		0x522a,
		0xdfa2
		},
		{
		0x522e,
		0xcebe
		},
		{
		0x5230,
		0xd3f0
		},
		{
		0x5243,
		0xf4ef
		},
		{
		0x5247,
		0xf6ce
		},
		{
		0x524a,
		0xdefb
		},
		{
		0x524b,
		0xd0bb
		},
		{
		0x524c,
		0xd5b7
		},
		{
		0x524d,
		0xeef1
		},
		{
		0x5254,
		0xf4a8
		},
		{
		0x5256,
		0xdcf8
		},
		{
		0x525b,
		0xcba7
		},
		{
		0x525d,
		0xdace
		},
		{
		0x5261,
		0xe0e6
		},
		{
		0x5269,
		0xeda5
		},
		{
		0x526a,
		0xeef2
		},
		{
		0x526f,
		0xdcf9
		},
		{
		0x5272,
		0xf9dc
		},
		{
		0x5275,
		0xf3dc
		},
		{
		0x527d,
		0xf8f2
		},
		{
		0x527f,
		0xf4f9
		},
		{
		0x5283,
		0xfcf1
		},
		{
		0x5287,
		0xd0bc
		},
		{
		0x5288,
		0xdbf9
		},
		{
		0x5289,
		0xd7b1
		},
		{
		0x528d,
		0xcbfc
		},
		{
		0x5291,
		0xf0a5
		},
		{
		0x5292,
		0xcbfd
		},
		{
		0x529b,
		0xd5f4
		},
		{
		0x529f,
		0xcded
		},
		{
		0x52a0,
		0xcaa5
		},
		{
		0x52a3,
		0xd6ab
		},
		{
		0x52a4,
		0xd0c2
		},
		{
		0x52a9,
		0xf0be
		},
		{
		0x52aa,
		0xd2bd
		},
		{
		0x52ab,
		0xcca4
		},
		{
		0x52be,
		0xfab6
		},
		{
		0x52c1,
		0xcccd
		},
		{
		0x52c3,
		0xdafa
		},
		{
		0x52c5,
		0xf6cf
		},
		{
		0x52c7,
		0xe9b8
		},
		{
		0x52c9,
		0xd8f5
		},
		{
		0x52cd,
		0xccce
		},
		{
		0x52d2,
		0xd7cd
		},
		{
		0x52d5,
		0xd4d1
		},
		{
		0x52d6,
		0xe9ed
		},
		{
		0x52d8,
		0xcaeb
		},
		{
		0x52d9,
		0xd9e2
		},
		{
		0x52db,
		0xfdb2
		},
		{
		0x52dd,
		0xe3ad
		},
		{
		0x52de,
		0xd6cc
		},
		{
		0x52df,
		0xd9b4
		},
		{
		0x52e2,
		0xe1a7
		},
		{
		0x52e3,
		0xeed3
		},
		{
		0x52e4,
		0xd0c3
		},
		{
		0x52f3,
		0xfdb3
		},
		{
		0x52f5,
		0xd5e4
		},
		{
		0x52f8,
		0xcfe8
		},
		{
		0x52fa,
		0xedc3
		},
		{
		0x52fb,
		0xd0b2
		},
		{
		0x52fe,
		0xcefe
		},
		{
		0x52ff,
		0xdaa8
		},
		{
		0x5305,
		0xf8d0
		},
		{
		0x5308,
		0xfdd6
		},
		{
		0x530d,
		0xf8d1
		},
		{
		0x530f,
		0xf8d2
		},
		{
		0x5310,
		0xdcd3
		},
		{
		0x5315,
		0xdde2
		},
		{
		0x5316,
		0xfbf9
		},
		{
		0x5317,
		0xddc1
		},
		{
		0x5319,
		0xe3b5
		},
		{
		0x5320,
		0xeddd
		},
		{
		0x5321,
		0xcec4
		},
		{
		0x5323,
		0xcba1
		},
		{
		0x532a,
		0xdde3
		},
		{
		0x532f,
		0xfcdd
		},
		{
		0x5339,
		0xf9af
		},
		{
		0x533f,
		0xd2fb
		},
		{
		0x5340,
		0xcfa1
		},
		{
		0x5341,
		0xe4a8
		},
		{
		0x5343,
		0xf4b6
		},
		{
		0x5344,
		0xecfe
		},
		{
		0x5347,
		0xe3ae
		},
		{
		0x5348,
		0xe7ed
		},
		{
		0x5349,
		0xfdc1
		},
		{
		0x534a,
		0xdae2
		},
		{
		0x534d,
		0xd8b3
		},
		{
		0x5351,
		0xdde4
		},
		{
		0x5352,
		0xf0ef
		},
		{
		0x5353,
		0xf6f1
		},
		{
		0x5354,
		0xfaf0
		},
		{
		0x5357,
		0xd1f5
		},
		{
		0x535a,
		0xdacf
		},
		{
		0x535c,
		0xdcd4
		},
		{
		0x535e,
		0xdca6
		},
		{
		0x5360,
		0xefbf
		},
		{
		0x5366,
		0xcecf
		},
		{
		0x5368,
		0xe0d9
		},
		{
		0x536f,
		0xd9d6
		},
		{
		0x5370,
		0xecd4
		},
		{
		0x5371,
		0xeacb
		},
		{
		0x5374,
		0xcabf
		},
		{
		0x5375,
		0xd5b0
		},
		{
		0x5377,
		0xcfe9
		},
		{
		0x537d,
		0xf1ed
		},
		{
		0x537f,
		0xcccf
		},
		{
		0x5384,
		0xe4f8
		},
		{
		0x5393,
		0xe4ed
		},
		{
		0x5398,
		0xd7d8
		},
		{
		0x539a,
		0xfda7
		},
		{
		0x539f,
		0xeaab
		},
		{
		0x53a0,
		0xf6b2
		},
		{
		0x53a5,
		0xcff0
		},
		{
		0x53a6,
		0xf9bd
		},
		{
		0x53ad,
		0xe6f4
		},
		{
		0x53bb,
		0xcbdb
		},
		{
		0x53c3,
		0xf3d1
		},
		{
		0x53c8,
		0xe9d1
		},
		{
		0x53c9,
		0xf3a9
		},
		{
		0x53ca,
		0xd0e0
		},
		{
		0x53cb,
		0xe9d2
		},
		{
		0x53cd,
		0xdae3
		},
		{
		0x53d4,
		0xe2d2
		},
		{
		0x53d6,
		0xf6a2
		},
		{
		0x53d7,
		0xe1f4
		},
		{
		0x53db,
		0xdae4
		},
		{
		0x53f8,
		0xdec9
		},
		{
		0x5403,
		0xfdde
		},
		{
		0x5404,
		0xcac0
		},
		{
		0x5408,
		0xf9ea
		},
		{
		0x5409,
		0xd1ce
		},
		{
		0x540a,
		0xeed4
		},
		{
		0x541b,
		0xcfd6
		},
		{
		0x541d,
		0xd7f0
		},
		{
		0x541f,
		0xebe1
		},
		{
		0x5420,
		0xf8c5
		},
		{
		0x5426,
		0xdcfa
		},
		{
		0x5429,
		0xddc3
		},
		{
		0x542b,
		0xf9df
		},
		{
		0x5433,
		0xe7ef
		},
		{
		0x5438,
		0xfde5
		},
		{
		0x5439,
		0xf6a3
		},
		{
		0x543b,
		0xd9fc
		},
		{
		0x543c,
		0xfda9
		},
		{
		0x543e,
		0xe7ee
		},
		{
		0x5442,
		0xd5e5
		},
		{
		0x5448,
		0xefd0
		},
		{
		0x544a,
		0xcdb1
		},
		{
		0x5451,
		0xf7a2
		},
		{
		0x5468,
		0xf1b2
		},
		{
		0x546a,
		0xf1b1
		},
		{
		0x5471,
		0xcdb2
		},
		{
		0x5473,
		0xdaab
		},
		{
		0x5475,
		0xcaa7
		},
		{
		0x547b,
		0xe3e2
		},
		{
		0x547c,
		0xfbbc
		},
		{
		0x547d,
		0xd9a4
		},
		{
		0x5480,
		0xeeba
		},
		{
		0x5486,
		0xf8d3
		},
		{
		0x548c,
		0xfbfa
		},
		{
		0x548e,
		0xcfa4
		},
		{
		0x5490,
		0xdcfb
		},
		{
		0x54a4,
		0xf6e3
		},
		{
		0x54a8,
		0xedaa
		},
		{
		0x54ab,
		0xf2a1
		},
		{
		0x54ac,
		0xcee1
		},
		{
		0x54b3,
		0xfaa6
		},
		{
		0x54b8,
		0xf9e0
		},
		{
		0x54bd,
		0xecd6
		},
		{
		0x54c0,
		0xe4ee
		},
		{
		0x54c1,
		0xf9a1
		},
		{
		0x54c4,
		0xfbef
		},
		{
		0x54c8,
		0xf9eb
		},
		{
		0x54c9,
		0xeea3
		},
		{
		0x54e1,
		0xeaac
		},
		{
		0x54e5,
		0xcaa8
		},
		{
		0x54e8,
		0xf4fa
		},
		{
		0x54ed,
		0xcdd6
		},
		{
		0x54ee,
		0xfcf6
		},
		{
		0x54f2,
		0xf4c9
		},
		{
		0x54fa,
		0xf8d4
		},
		{
		0x5504,
		0xf8a6
		},
		{
		0x5506,
		0xdeca
		},
		{
		0x5507,
		0xf2c6
		},
		{
		0x550e,
		0xd7da
		},
		{
		0x5510,
		0xd3d0
		},
		{
		0x551c,
		0xd8c5
		},
		{
		0x552f,
		0xeae6
		},
		{
		0x5531,
		0xf3dd
		},
		{
		0x5535,
		0xe4da
		},
		{
		0x553e,
		0xf6e4
		},
		{
		0x5544,
		0xf6f2
		},
		{
		0x5546,
		0xdfc2
		},
		{
		0x554f,
		0xd9fd
		},
		{
		0x5553,
		0xccf6
		},
		{
		0x5556,
		0xd3ba
		},
		{
		0x555e,
		0xe4af
		},
		{
		0x5563,
		0xf9e1
		},
		{
		0x557c,
		0xf0a6
		},
		{
		0x5580,
		0xcbd3
		},
		{
		0x5584,
		0xe0bc
		},
		{
		0x5586,
		0xf4ca
		},
		{
		0x5587,
		0xd4fa
		},
		{
		0x5589,
		0xfdaa
		},
		{
		0x558a,
		0xf9e2
		},
		{
		0x5598,
		0xf4b7
		},
		{
		0x5599,
		0xfdc2
		},
		{
		0x559a,
		0xfcb0
		},
		{
		0x559c,
		0xfdec
		},
		{
		0x559d,
		0xcae2
		},
		{
		0x55a7,
		0xfdbd
		},
		{
		0x55a9,
		0xeae7
		},
		{
		0x55aa,
		0xdfc3
		},
		{
		0x55ab,
		0xd1d2
		},
		{
		0x55ac,
		0xcee2
		},
		{
		0x55ae,
		0xd3a4
		},
		{
		0x55c5,
		0xfdab
		},
		{
		0x55c7,
		0xdfe0
		},
		{
		0x55d4,
		0xf2c7
		},
		{
		0x55da,
		0xe7f0
		},
		{
		0x55dc,
		0xd0ee
		},
		{
		0x55df,
		0xf3aa
		},
		{
		0x55e3,
		0xdecb
		},
		{
		0x55e4,
		0xf6b8
		},
		{
		0x55fd,
		0xe1f5
		},
		{
		0x55fe,
		0xf1b3
		},
		{
		0x5606,
		0xf7a3
		},
		{
		0x5609,
		0xcaa9
		},
		{
		0x5614,
		0xcfa5
		},
		{
		0x5617,
		0xdfc4
		},
		{
		0x562f,
		0xe1b0
		},
		{
		0x5632,
		0xf0bf
		},
		{
		0x5634,
		0xf6a4
		},
		{
		0x5636,
		0xe3b6
		},
		{
		0x5653,
		0xfac6
		},
		{
		0x5668,
		0xd0ef
		},
		{
		0x566b,
		0xfded
		},
		{
		0x5674,
		0xddc4
		},
		{
		0x5686,
		0xfcf7
		},
		{
		0x56a5,
		0xe6bf
		},
		{
		0x56ac,
		0xdead
		},
		{
		0x56ae,
		0xfabf
		},
		{
		0x56b4,
		0xe5f1
		},
		{
		0x56bc,
		0xedc4
		},
		{
		0x56ca,
		0xd2a5
		},
		{
		0x56cd,
		0xfdee
		},
		{
		0x56d1,
		0xf5b6
		},
		{
		0x56da,
		0xe1f6
		},
		{
		0x56db,
		0xdecc
		},
		{
		0x56de,
		0xfcde
		},
		{
		0x56e0,
		0xecd7
		},
		{
		0x56f0,
		0xcddd
		},
		{
		0x56f9,
		0xd6b7
		},
		{
		0x56fa,
		0xcdb3
		},
		{
		0x5703,
		0xf8d5
		},
		{
		0x5704,
		0xe5d8
		},
		{
		0x5708,
		0xcfea
		},
		{
		0x570b,
		0xcfd0
		},
		{
		0x570d,
		0xeacc
		},
		{
		0x5712,
		0xeaae
		},
		{
		0x5713,
		0xeaad
		},
		{
		0x5716,
		0xd3f1
		},
		{
		0x5718,
		0xd3a5
		},
		{
		0x571f,
		0xf7cf
		},
		{
		0x5728,
		0xeea4
		},
		{
		0x572d,
		0xd0a4
		},
		{
		0x5730,
		0xf2a2
		},
		{
		0x573b,
		0xd0f0
		},
		{
		0x5740,
		0xf2a3
		},
		{
		0x5742,
		0xf7f8
		},
		{
		0x5747,
		0xd0b3
		},
		{
		0x574a,
		0xdba9
		},
		{
		0x574d,
		0xd3bb
		},
		{
		0x574e,
		0xcaec
		},
		{
		0x5750,
		0xf1a6
		},
		{
		0x5751,
		0xcbd5
		},
		{
		0x5761,
		0xf7e7
		},
		{
		0x5764,
		0xcdde
		},
		{
		0x5766,
		0xf7a4
		},
		{
		0x576a,
		0xf8c0
		},
		{
		0x576e,
		0xd3dd
		},
		{
		0x5770,
		0xccd0
		},
		{
		0x5775,
		0xcfa6
		},
		{
		0x577c,
		0xf6f3
		},
		{
		0x5782,
		0xe1f7
		},
		{
		0x5788,
		0xd3dc
		},
		{
		0x578b,
		0xfafe
		},
		{
		0x5793,
		0xfaa7
		},
		{
		0x57a0,
		0xebd9
		},
		{
		0x57a2,
		0xcfa7
		},
		{
		0x57a3,
		0xeaaf
		},
		{
		0x57c3,
		0xe4ef
		},
		{
		0x57c7,
		0xe9b9
		},
		{
		0x57c8,
		0xf1d8
		},
		{
		0x57cb,
		0xd8d8
		},
		{
		0x57ce,
		0xe0f2
		},
		{
		0x57df,
		0xe6b4
		},
		{
		0x57e0,
		0xdcfc
		},
		{
		0x57f0,
		0xf3f1
		},
		{
		0x57f4,
		0xe3d0
		},
		{
		0x57f7,
		0xf2fb
		},
		{
		0x57f9,
		0xdbc6
		},
		{
		0x57fa,
		0xd0f1
		},
		{
		0x57fc,
		0xd0f2
		},
		{
		0x5800,
		0xcfdc
		},
		{
		0x5802,
		0xd3d1
		},
		{
		0x5805,
		0xccb1
		},
		{
		0x5806,
		0xf7d8
		},
		{
		0x5808,
		0xcba8
		},
		{
		0x5809,
		0xebbc
		},
		{
		0x580a,
		0xe4be
		},
		{
		0x581e,
		0xf4dc
		},
		{
		0x5821,
		0xdcc2
		},
		{
		0x5824,
		0xf0a7
		},
		{
		0x5827,
		0xe6c0
		},
		{
		0x582a,
		0xcaed
		},
		{
		0x582f,
		0xe8eb
		},
		{
		0x5830,
		0xe5e8
		},
		{
		0x5831,
		0xdcc3
		},
		{
		0x5834,
		0xedde
		},
		{
		0x5835,
		0xd3f2
		},
		{
		0x583a,
		0xccf7
		},
		{
		0x584a,
		0xced4
		},
		{
		0x584b,
		0xe7ab
		},
		{
		0x584f,
		0xcbc3
		},
		{
		0x5851,
		0xe1b1
		},
		{
		0x5854,
		0xf7b2
		},
		{
		0x5857,
		0xd3f3
		},
		{
		0x5858,
		0xd3d2
		},
		{
		0x585a,
		0xf5c0
		},
		{
		0x585e,
		0xdfdd
		},
		{
		0x5861,
		0xeef3
		},
		{
		0x5862,
		0xe7f1
		},
		{
		0x5864,
		0xfdb4
		},
		{
		0x5875,
		0xf2c8
		},
		{
		0x5879,
		0xf3d2
		},
		{
		0x587c,
		0xeef4
		},
		{
		0x587e,
		0xe2d3
		},
		{
		0x5883,
		0xccd1
		},
		{
		0x5885,
		0xdfea
		},
		{
		0x5889,
		0xe9ba
		},
		{
		0x5893,
		0xd9d7
		},
		{
		0x589c,
		0xf5cd
		},
		{
		0x589e,
		0xf1f2
		},
		{
		0x589f,
		0xfac7
		},
		{
		0x58a8,
		0xd9f8
		},
		{
		0x58a9,
		0xd4c2
		},
		{
		0x58ae,
		0xf6e5
		},
		{
		0x58b3,
		0xddc5
		},
		{
		0x58ba,
		0xe7f2
		},
		{
		0x58bb,
		0xeddf
		},
		{
		0x58be,
		0xcacb
		},
		{
		0x58c1,
		0xdbfa
		},
		{
		0x58c5,
		0xe8b5
		},
		{
		0x58c7,
		0xd3a6
		},
		{
		0x58ce,
		0xfdb5
		},
		{
		0x58d1,
		0xf9c9
		},
		{
		0x58d3,
		0xe4e2
		},
		{
		0x58d5,
		0xfbbd
		},
		{
		0x58d8,
		0xd7a4
		},
		{
		0x58d9,
		0xcec5
		},
		{
		0x58de,
		0xced5
		},
		{
		0x58df,
		0xd6e6
		},
		{
		0x58e4,
		0xe5bd
		},
		{
		0x58eb,
		0xdecd
		},
		{
		0x58ec,
		0xecf3
		},
		{
		0x58ef,
		0xede0
		},
		{
		0x58f9,
		0xecec
		},
		{
		0x58fa,
		0xfbbe
		},
		{
		0x58fb,
		0xdfeb
		},
		{
		0x58fd,
		0xe1f8
		},
		{
		0x590f,
		0xf9be
		},
		{
		0x5914,
		0xd0f3
		},
		{
		0x5915,
		0xe0aa
		},
		{
		0x5916,
		0xe8e2
		},
		{
		0x5919,
		0xe2d4
		},
		{
		0x591a,
		0xd2fd
		},
		{
		0x591c,
		0xe5a8
		},
		{
		0x5922,
		0xd9d3
		},
		{
		0x5927,
		0xd3de
		},
		{
		0x5929,
		0xf4b8
		},
		{
		0x592a,
		0xf7bc
		},
		{
		0x592b,
		0xdcfd
		},
		{
		0x592d,
		0xe8ec
		},
		{
		0x592e,
		0xe4e7
		},
		{
		0x5931,
		0xe3f7
		},
		{
		0x5937,
		0xeca8
		},
		{
		0x593e,
		0xfaf1
		},
		{
		0x5944,
		0xe5f2
		},
		{
		0x5947,
		0xd0f4
		},
		{
		0x5948,
		0xd2af
		},
		{
		0x5949,
		0xdce5
		},
		{
		0x594e,
		0xd0a5
		},
		{
		0x594f,
		0xf1b4
		},
		{
		0x5950,
		0xfcb1
		},
		{
		0x5951,
		0xccf8
		},
		{
		0x5954,
		0xddc6
		},
		{
		0x5955,
		0xfad1
		},
		{
		0x5957,
		0xf7df
		},
		{
		0x595a,
		0xfaa8
		},
		{
		0x5960,
		0xeef5
		},
		{
		0x5962,
		0xdece
		},
		{
		0x5967,
		0xe7f3
		},
		{
		0x5973,
		0xd2b3
		},
		{
		0x5974,
		0xd2bf
		},
		{
		0x5978,
		0xcacc
		},
		{
		0x597d,
		0xfbbf
		},
		{
		0x5982,
		0xe5fd
		},
		{
		0x5983,
		0xdde5
		},
		{
		0x5984,
		0xd8cd
		},
		{
		0x598a,
		0xecf4
		},
		{
		0x5993,
		0xd0f5
		},
		{
		0x5996,
		0xe8ed
		},
		{
		0x5997,
		0xd0d2
		},
		{
		0x5999,
		0xd9d8
		},
		{
		0x59a5,
		0xf6e6
		},
		{
		0x59a8,
		0xdbaa
		},
		{
		0x59ac,
		0xf7e0
		},
		{
		0x59b9,
		0xd8d9
		},
		{
		0x59bb,
		0xf4a3
		},
		{
		0x59be,
		0xf4dd
		},
		{
		0x59c3,
		0xefd1
		},
		{
		0x59c6,
		0xd9b5
		},
		{
		0x59c9,
		0xedab
		},
		{
		0x59cb,
		0xe3b7
		},
		{
		0x59d0,
		0xeebb
		},
		{
		0x59d1,
		0xcdb4
		},
		{
		0x59d3,
		0xe0f3
		},
		{
		0x59d4,
		0xeacd
		},
		{
		0x59d9,
		0xecf5
		},
		{
		0x59da,
		0xe8ee
		},
		{
		0x59dc,
		0xcba9
		},
		{
		0x59dd,
		0xf1af
		},
		{
		0x59e6,
		0xcacd
		},
		{
		0x59e8,
		0xeca9
		},
		{
		0x59ea,
		0xf2eb
		},
		{
		0x59ec,
		0xfdef
		},
		{
		0x59ee,
		0xf9f3
		},
		{
		0x59f8,
		0xe6c1
		},
		{
		0x59fb,
		0xecd8
		},
		{
		0x59ff,
		0xedac
		},
		{
		0x5a01,
		0xeace
		},
		{
		0x5a03,
		0xe8df
		},
		{
		0x5a11,
		0xdecf
		},
		{
		0x5a18,
		0xd2a6
		},
		{
		0x5a1b,
		0xe7f4
		},
		{
		0x5a1c,
		0xd1d6
		},
		{
		0x5a1f,
		0xe6c2
		},
		{
		0x5a20,
		0xe3e3
		},
		{
		0x5a25,
		0xe4b0
		},
		{
		0x5a29,
		0xd8b4
		},
		{
		0x5a36,
		0xf6a5
		},
		{
		0x5a3c,
		0xf3de
		},
		{
		0x5a41,
		0xd7a5
		},
		{
		0x5a46,
		0xf7e8
		},
		{
		0x5a49,
		0xe8c6
		},
		{
		0x5a5a,
		0xfbe6
		},
		{
		0x5a62,
		0xdde6
		},
		{
		0x5a66,
		0xdcfe
		},
		{
		0x5a92,
		0xd8da
		},
		{
		0x5a9a,
		0xdaac
		},
		{
		0x5a9b,
		0xeab0
		},
		{
		0x5aa4,
		0xe3b8
		},
		{
		0x5ac1,
		0xcaaa
		},
		{
		0x5ac2,
		0xe1f9
		},
		{
		0x5ac4,
		0xeab1
		},
		{
		0x5ac9,
		0xf2ec
		},
		{
		0x5acc,
		0xfaee
		},
		{
		0x5ae1,
		0xeed5
		},
		{
		0x5ae6,
		0xf9f4
		},
		{
		0x5ae9,
		0xd2ec
		},
		{
		0x5b05,
		0xfbfb
		},
		{
		0x5b09,
		0xfdf0
		},
		{
		0x5b0b,
		0xe0bd
		},
		{
		0x5b0c,
		0xcee3
		},
		{
		0x5b16,
		0xf8c6
		},
		{
		0x5b2a,
		0xdeae
		},
		{
		0x5b40,
		0xdfc5
		},
		{
		0x5b43,
		0xe5be
		},
		{
		0x5b50,
		0xedad
		},
		{
		0x5b51,
		0xfaea
		},
		{
		0x5b54,
		0xcdee
		},
		{
		0x5b55,
		0xeda6
		},
		{
		0x5b57,
		0xedae
		},
		{
		0x5b58,
		0xf0ed
		},
		{
		0x5b5a,
		0xdda1
		},
		{
		0x5b5c,
		0xedaf
		},
		{
		0x5b5d,
		0xfcf8
		},
		{
		0x5b5f,
		0xd8eb
		},
		{
		0x5b63,
		0xccf9
		},
		{
		0x5b64,
		0xcdb5
		},
		{
		0x5b69,
		0xfaa9
		},
		{
		0x5b6b,
		0xe1dd
		},
		{
		0x5b70,
		0xe2d5
		},
		{
		0x5b71,
		0xedcf
		},
		{
		0x5b75,
		0xdda2
		},
		{
		0x5b78,
		0xf9ca
		},
		{
		0x5b7a,
		0xeae8
		},
		{
		0x5b7c,
		0xe5ed
		},
		{
		0x5b85,
		0xd3eb
		},
		{
		0x5b87,
		0xe9d4
		},
		{
		0x5b88,
		0xe1fa
		},
		{
		0x5b89,
		0xe4cc
		},
		{
		0x5b8b,
		0xe1e4
		},
		{
		0x5b8c,
		0xe8c7
		},
		{
		0x5b8f,
		0xcedb
		},
		{
		0x5b93,
		0xdcd5
		},
		{
		0x5bac,
		0xe0f4
		},
		{
		0x5bae,
		0xcfe0
		},
		{
		0x5bb0,
		0xeea5
		},
		{
		0x5bb3,
		0xfaaa
		},
		{
		0x5bb4,
		0xe6c3
		},
		{
		0x5bb5,
		0xe1b2
		},
		{
		0x5bb6,
		0xcaab
		},
		{
		0x5bb8,
		0xe3e4
		},
		{
		0x5bb9,
		0xe9bb
		},
		{
		0x5bbf,
		0xe2d6
		},
		{
		0x5bc0,
		0xf3f2
		},
		{
		0x5bcc,
		0xdda3
		},
		{
		0x5bd0,
		0xd8db
		},
		{
		0x5bd2,
		0xf9ce
		},
		{
		0x5bd3,
		0xe9d5
		},
		{
		0x5bd4,
		0xe3d1
		},
		{
		0x5bd7,
		0xd2bc
		},
		{
		0x5bde,
		0xd8ac
		},
		{
		0x5bdf,
		0xf3cc
		},
		{
		0x5be1,
		0xcdfb
		},
		{
		0x5be2,
		0xf6d6
		},
		{
		0x5beb,
		0xded0
		},
		{
		0x5bec,
		0xceb0
		},
		{
		0x5bee,
		0xd6f7
		},
		{
		0x5bef,
		0xf1d9
		},
		{
		0x5bf5,
		0xf5c1
		},
		{
		0x5bf6,
		0xdcc4
		},
		{
		0x5bf8,
		0xf5bb
		},
		{
		0x5bfa,
		0xded1
		},
		{
		0x5c01,
		0xdce6
		},
		{
		0x5c04,
		0xded2
		},
		{
		0x5c0d,
		0xd3df
		},
		{
		0x5c0e,
		0xd3f4
		},
		{
		0x5c0f,
		0xe1b3
		},
		{
		0x5c11,
		0xe1b4
		},
		{
		0x5c16,
		0xf4d3
		},
		{
		0x5c19,
		0xdfc6
		},
		{
		0x5c24,
		0xe9d6
		},
		{
		0x5c28,
		0xdbab
		},
		{
		0x5c31,
		0xf6a6
		},
		{
		0x5c3e,
		0xdaad
		},
		{
		0x5c3f,
		0xd2e3
		},
		{
		0x5c40,
		0xcfd1
		},
		{
		0x5c45,
		0xcbdc
		},
		{
		0x5c46,
		0xccfa
		},
		{
		0x5c48,
		0xcfdd
		},
		{
		0x5c4b,
		0xe8a9
		},
		{
		0x5c4d,
		0xe3bb
		},
		{
		0x5c4e,
		0xe3ba
		},
		{
		0x5c51,
		0xe0da
		},
		{
		0x5c55,
		0xeef7
		},
		{
		0x5c5b,
		0xdcb3
		},
		{
		0x5c60,
		0xd3f5
		},
		{
		0x5c62,
		0xd7a6
		},
		{
		0x5c64,
		0xf6b5
		},
		{
		0x5c65,
		0xd7db
		},
		{
		0x5c6c,
		0xe1d5
		},
		{
		0x5c6f,
		0xd4ea
		},
		{
		0x5c71,
		0xdfa3
		},
		{
		0x5c79,
		0xfddf
		},
		{
		0x5c90,
		0xd0f7
		},
		{
		0x5c91,
		0xedd4
		},
		{
		0x5ca1,
		0xcbaa
		},
		{
		0x5ca9,
		0xe4db
		},
		{
		0x5cab,
		0xe1fb
		},
		{
		0x5cac,
		0xcba2
		},
		{
		0x5cb1,
		0xd3e0
		},
		{
		0x5cb3,
		0xe4bf
		},
		{
		0x5cb5,
		0xfbc0
		},
		{
		0x5cb7,
		0xdabe
		},
		{
		0x5cb8,
		0xe4cd
		},
		{
		0x5cba,
		0xd6b9
		},
		{
		0x5cbe,
		0xefc0
		},
		{
		0x5cc0,
		0xe1fc
		},
		{
		0x5cd9,
		0xf6b9
		},
		{
		0x5ce0,
		0xdfc7
		},
		{
		0x5ce8,
		0xe4b1
		},
		{
		0x5cef,
		0xdce7
		},
		{
		0x5cf0,
		0xdce8
		},
		{
		0x5cf4,
		0xfad6
		},
		{
		0x5cf6,
		0xd3f6
		},
		{
		0x5cfb,
		0xf1da
		},
		{
		0x5cfd,
		0xfaf2
		},
		{
		0x5d07,
		0xe2fd
		},
		{
		0x5d0d,
		0xd5cf
		},
		{
		0x5d0e,
		0xd0f8
		},
		{
		0x5d11,
		0xcddf
		},
		{
		0x5d14,
		0xf5cb
		},
		{
		0x5d16,
		0xe4f0
		},
		{
		0x5d17,
		0xcbab
		},
		{
		0x5d19,
		0xd7c4
		},
		{
		0x5d27,
		0xe2fe
		},
		{
		0x5d29,
		0xddda
		},
		{
		0x5d4b,
		0xdaae
		},
		{
		0x5d4c,
		0xcaee
		},
		{
		0x5d50,
		0xd5b9
		},
		{
		0x5d69,
		0xe3a1
		},
		{
		0x5d6c,
		0xe8e3
		},
		{
		0x5d6f,
		0xf3ab
		},
		{
		0x5d87,
		0xcfa9
		},
		{
		0x5d8b,
		0xd3f7
		},
		{
		0x5d9d,
		0xd4f1
		},
		{
		0x5da0,
		0xcee4
		},
		{
		0x5da2,
		0xe8f2
		},
		{
		0x5daa,
		0xe5f5
		},
		{
		0x5db8,
		0xe7ae
		},
		{
		0x5dba,
		0xd6ba
		},
		{
		0x5dbc,
		0xdfec
		},
		{
		0x5dbd,
		0xe4c0
		},
		{
		0x5dcd,
		0xe8e4
		},
		{
		0x5dd2,
		0xd8b5
		},
		{
		0x5dd6,
		0xe4dc
		},
		{
		0x5ddd,
		0xf4b9
		},
		{
		0x5dde,
		0xf1b6
		},
		{
		0x5de1,
		0xe2de
		},
		{
		0x5de2,
		0xe1b5
		},
		{
		0x5de5,
		0xcdef
		},
		{
		0x5de6,
		0xf1a7
		},
		{
		0x5de7,
		0xcee5
		},
		{
		0x5de8,
		0xcbdd
		},
		{
		0x5deb,
		0xd9e3
		},
		{
		0x5dee,
		0xf3ac
		},
		{
		0x5df1,
		0xd0f9
		},
		{
		0x5df2,
		0xecab
		},
		{
		0x5df3,
		0xded3
		},
		{
		0x5df4,
		0xf7e9
		},
		{
		0x5df7,
		0xf9f5
		},
		{
		0x5dfd,
		0xe1de
		},
		{
		0x5dfe,
		0xcbee
		},
		{
		0x5e02,
		0xe3bc
		},
		{
		0x5e03,
		0xf8d6
		},
		{
		0x5e06,
		0xdbee
		},
		{
		0x5e0c,
		0xfdf1
		},
		{
		0x5e11,
		0xf7b6
		},
		{
		0x5e16,
		0xf4de
		},
		{
		0x5e19,
		0xf2ed
		},
		{
		0x5e1b,
		0xdbd9
		},
		{
		0x5e1d,
		0xf0a8
		},
		{
		0x5e25,
		0xe1fd
		},
		{
		0x5e2b,
		0xded4
		},
		{
		0x5e2d,
		0xe0ac
		},
		{
		0x5e33,
		0xede3
		},
		{
		0x5e36,
		0xd3e1
		},
		{
		0x5e38,
		0xdfc8
		},
		{
		0x5e3d,
		0xd9b6
		},
		{
		0x5e3f,
		0xfdac
		},
		{
		0x5e40,
		0xefd3
		},
		{
		0x5e44,
		0xe4c1
		},
		{
		0x5e45,
		0xf8eb
		},
		{
		0x5e47,
		0xdbac
		},
		{
		0x5e4c,
		0xfcc6
		},
		{
		0x5e55,
		0xd8ad
		},
		{
		0x5e5f,
		0xf6ba
		},
		{
		0x5e61,
		0xdbdf
		},
		{
		0x5e62,
		0xd3d3
		},
		{
		0x5e63,
		0xf8c7
		},
		{
		0x5e72,
		0xcace
		},
		{
		0x5e73,
		0xf8c1
		},
		{
		0x5e74,
		0xd2b4
		},
		{
		0x5e77,
		0xdcb4
		},
		{
		0x5e78,
		0xfab9
		},
		{
		0x5e79,
		0xcacf
		},
		{
		0x5e7b,
		0xfcb3
		},
		{
		0x5e7c,
		0xeaea
		},
		{
		0x5e7d,
		0xeaeb
		},
		{
		0x5e7e,
		0xd0fa
		},
		{
		0x5e84,
		0xede4
		},
		{
		0x5e87,
		0xdde7
		},
		{
		0x5e8a,
		0xdfc9
		},
		{
		0x5e8f,
		0xdfed
		},
		{
		0x5e95,
		0xeebc
		},
		{
		0x5e97,
		0xefc1
		},
		{
		0x5e9a,
		0xccd2
		},
		{
		0x5e9c,
		0xdda4
		},
		{
		0x5ea0,
		0xdfca
		},
		{
		0x5ea6,
		0xd3f8
		},
		{
		0x5ea7,
		0xf1a8
		},
		{
		0x5eab,
		0xcdb7
		},
		{
		0x5ead,
		0xefd4
		},
		{
		0x5eb5,
		0xe4dd
		},
		{
		0x5eb6,
		0xdfee
		},
		{
		0x5eb7,
		0xcbac
		},
		{
		0x5eb8,
		0xe9bc
		},
		{
		0x5ebe,
		0xeaec
		},
		{
		0x5ec2,
		0xdfcb
		},
		{
		0x5ec8,
		0xf9bf
		},
		{
		0x5ec9,
		0xd6af
		},
		{
		0x5eca,
		0xd5c6
		},
		{
		0x5ed0,
		0xcfaa
		},
		{
		0x5ed3,
		0xcea9
		},
		{
		0x5ed6,
		0xd6f8
		},
		{
		0x5eda,
		0xf1b7
		},
		{
		0x5edb,
		0xeef8
		},
		{
		0x5edf,
		0xd9d9
		},
		{
		0x5ee0,
		0xf3df
		},
		{
		0x5ee2,
		0xf8c8
		},
		{
		0x5ee3,
		0xcec6
		},
		{
		0x5eec,
		0xd5e6
		},
		{
		0x5ef3,
		0xf4e6
		},
		{
		0x5ef6,
		0xe6c5
		},
		{
		0x5ef7,
		0xefd5
		},
		{
		0x5efa,
		0xcbef
		},
		{
		0x5efb,
		0xfcdf
		},
		{
		0x5f01,
		0xdca7
		},
		{
		0x5f04,
		0xd6e7
		},
		{
		0x5f0a,
		0xf8c9
		},
		{
		0x5f0f,
		0xe3d2
		},
		{
		0x5f11,
		0xe3bd
		},
		{
		0x5f13,
		0xcfe1
		},
		{
		0x5f14,
		0xf0c0
		},
		{
		0x5f15,
		0xecda
		},
		{
		0x5f17,
		0xddd7
		},
		{
		0x5f18,
		0xfbf0
		},
		{
		0x5f1b,
		0xecac
		},
		{
		0x5f1f,
		0xf0a9
		},
		{
		0x5f26,
		0xfad7
		},
		{
		0x5f27,
		0xfbc1
		},
		{
		0x5f29,
		0xd2c0
		},
		{
		0x5f31,
		0xe5b0
		},
		{
		0x5f35,
		0xede5
		},
		{
		0x5f3a,
		0xcbad
		},
		{
		0x5f3c,
		0xf9b0
		},
		{
		0x5f48,
		0xf7a5
		},
		{
		0x5f4a,
		0xcbae
		},
		{
		0x5f4c,
		0xdaaf
		},
		{
		0x5f4e,
		0xd8b6
		},
		{
		0x5f56,
		0xd3a7
		},
		{
		0x5f57,
		0xfbb2
		},
		{
		0x5f59,
		0xfdc4
		},
		{
		0x5f5b,
		0xecad
		},
		{
		0x5f62,
		0xfba1
		},
		{
		0x5f66,
		0xe5e9
		},
		{
		0x5f67,
		0xe9ee
		},
		{
		0x5f70,
		0xf3e0
		},
		{
		0x5f71,
		0xe7af
		},
		{
		0x5f77,
		0xdbad
		},
		{
		0x5f79,
		0xe6b5
		},
		{
		0x5f7c,
		0xf9a8
		},
		{
		0x5f7f,
		0xddd8
		},
		{
		0x5f80,
		0xe8d9
		},
		{
		0x5f81,
		0xefd6
		},
		{
		0x5f85,
		0xd3e2
		},
		{
		0x5f87,
		0xe2df
		},
		{
		0x5f8a,
		0xfce0
		},
		{
		0x5f8b,
		0xd7c8
		},
		{
		0x5f8c,
		0xfdad
		},
		{
		0x5f90,
		0xdfef
		},
		{
		0x5f91,
		0xccd3
		},
		{
		0x5f92,
		0xd3f9
		},
		{
		0x5f97,
		0xd4f0
		},
		{
		0x5f98,
		0xdbc7
		},
		{
		0x5f99,
		0xded5
		},
		{
		0x5f9e,
		0xf0f4
		},
		{
		0x5fa0,
		0xd5d0
		},
		{
		0x5fa1,
		0xe5d9
		},
		{
		0x5fa8,
		0xfcc7
		},
		{
		0x5fa9,
		0xdcd6
		},
		{
		0x5faa,
		0xe2e0
		},
		{
		0x5fae,
		0xdab0
		},
		{
		0x5fb5,
		0xf3a3
		},
		{
		0x5fb7,
		0xd3ec
		},
		{
		0x5fb9,
		0xf4cb
		},
		{
		0x5fbd,
		0xfdc5
		},
		{
		0x5fc3,
		0xe3fd
		},
		{
		0x5fc5,
		0xf9b1
		},
		{
		0x5fcc,
		0xd0fb
		},
		{
		0x5fcd,
		0xecdb
		},
		{
		0x5fd6,
		0xf5bc
		},
		{
		0x5fd7,
		0xf2a4
		},
		{
		0x5fd8,
		0xd8ce
		},
		{
		0x5fd9,
		0xd8cf
		},
		{
		0x5fe0,
		0xf5f7
		},
		{
		0x5feb,
		0xf6e1
		},
		{
		0x5ff5,
		0xd2b7
		},
		{
		0x5ffd,
		0xfbec
		},
		{
		0x5fff,
		0xddc8
		},
		{
		0x600f,
		0xe4e8
		},
		{
		0x6012,
		0xd2c1
		},
		{
		0x6016,
		0xf8d7
		},
		{
		0x601c,
		0xd6bb
		},
		{
		0x601d,
		0xded6
		},
		{
		0x6020,
		0xf7bd
		},
		{
		0x6021,
		0xecae
		},
		{
		0x6025,
		0xd0e1
		},
		{
		0x6027,
		0xe0f5
		},
		{
		0x6028,
		0xeab3
		},
		{
		0x602a,
		0xced6
		},
		{
		0x602f,
		0xcca5
		},
		{
		0x6041,
		0xecf6
		},
		{
		0x6042,
		0xe2e1
		},
		{
		0x6043,
		0xe3be
		},
		{
		0x604d,
		0xfcc8
		},
		{
		0x6050,
		0xcdf0
		},
		{
		0x6052,
		0xf9f6
		},
		{
		0x6055,
		0xdff0
		},
		{
		0x6059,
		0xe5bf
		},
		{
		0x605d,
		0xcebf
		},
		{
		0x6062,
		0xfce1
		},
		{
		0x6063,
		0xedb0
		},
		{
		0x6064,
		0xfdd1
		},
		{
		0x6065,
		0xf6bb
		},
		{
		0x6068,
		0xf9cf
		},
		{
		0x6069,
		0xebda
		},
		{
		0x606a,
		0xcac1
		},
		{
		0x606c,
		0xd2b8
		},
		{
		0x606d,
		0xcdf1
		},
		{
		0x606f,
		0xe3d3
		},
		{
		0x6070,
		0xfde6
		},
		{
		0x6085,
		0xe6ed
		},
		{
		0x6089,
		0xe3fa
		},
		{
		0x608c,
		0xf0aa
		},
		{
		0x608d,
		0xf9d0
		},
		{
		0x6094,
		0xfce2
		},
		{
		0x6096,
		0xf8a7
		},
		{
		0x609a,
		0xe1e5
		},
		{
		0x609b,
		0xeef9
		},
		{
		0x609f,
		0xe7f6
		},
		{
		0x60a0,
		0xeaed
		},
		{
		0x60a3,
		0xfcb4
		},
		{
		0x60a4,
		0xf5c2
		},
		{
		0x60a7,
		0xd7dc
		},
		{
		0x60b0,
		0xf0f5
		},
		{
		0x60b2,
		0xdde8
		},
		{
		0x60b3,
		0xd3ed
		},
		{
		0x60b4,
		0xf5fc
		},
		{
		0x60b6,
		0xdabf
		},
		{
		0x60b8,
		0xccfb
		},
		{
		0x60bc,
		0xd3fa
		},
		{
		0x60bd,
		0xf4a4
		},
		{
		0x60c5,
		0xefd7
		},
		{
		0x60c7,
		0xd4c3
		},
		{
		0x60d1,
		0xfbe3
		},
		{
		0x60da,
		0xfbed
		},
		{
		0x60dc,
		0xe0ad
		},
		{
		0x60df,
		0xeaee
		},
		{
		0x60e0,
		0xfbb3
		},
		{
		0x60e1,
		0xe4c2
		},
		{
		0x60f0,
		0xf6e7
		},
		{
		0x60f1,
		0xd2dd
		},
		{
		0x60f3,
		0xdfcc
		},
		{
		0x60f6,
		0xfcc9
		},
		{
		0x60f9,
		0xe5a9
		},
		{
		0x60fa,
		0xe0f6
		},
		{
		0x60fb,
		0xf6b3
		},
		{
		0x6101,
		0xe1fe
		},
		{
		0x6106,
		0xcbf0
		},
		{
		0x6108,
		0xeaef
		},
		{
		0x6109,
		0xeaf0
		},
		{
		0x610d,
		0xdac0
		},
		{
		0x610e,
		0xf8b4
		},
		{
		0x610f,
		0xebf2
		},
		{
		0x6115,
		0xe4c3
		},
		{
		0x611a,
		0xe9d7
		},
		{
		0x611b,
		0xe4f1
		},
		{
		0x611f,
		0xcaef
		},
		{
		0x6127,
		0xced7
		},
		{
		0x6130,
		0xfcca
		},
		{
		0x6134,
		0xf3e1
		},
		{
		0x6137,
		0xcbc4
		},
		{
		0x613c,
		0xe3e5
		},
		{
		0x613e,
		0xcbc5
		},
		{
		0x613f,
		0xeab4
		},
		{
		0x6142,
		0xe9bd
		},
		{
		0x6144,
		0xd7c9
		},
		{
		0x6147,
		0xebdb
		},
		{
		0x6148,
		0xedb1
		},
		{
		0x614a,
		0xccc3
		},
		{
		0x614b,
		0xf7be
		},
		{
		0x614c,
		0xfccb
		},
		{
		0x6153,
		0xf8f4
		},
		{
		0x6155,
		0xd9b7
		},
		{
		0x6158,
		0xf3d3
		},
		{
		0x6159,
		0xf3d4
		},
		{
		0x615d,
		0xf7e4
		},
		{
		0x615f,
		0xf7d1
		},
		{
		0x6162,
		0xd8b7
		},
		{
		0x6163,
		0xceb1
		},
		{
		0x6164,
		0xcac2
		},
		{
		0x6167,
		0xfbb4
		},
		{
		0x6168,
		0xcbc6
		},
		{
		0x616b,
		0xf0f6
		},
		{
		0x616e,
		0xd5e7
		},
		{
		0x6170,
		0xead0
		},
		{
		0x6176,
		0xccd4
		},
		{
		0x6177,
		0xcbaf
		},
		{
		0x617d,
		0xf4aa
		},
		{
		0x617e,
		0xe9af
		},
		{
		0x6181,
		0xf5c3
		},
		{
		0x6182,
		0xe9d8
		},
		{
		0x618a,
		0xdde9
		},
		{
		0x618e,
		0xf1f3
		},
		{
		0x6190,
		0xd5fb
		},
		{
		0x6191,
		0xdebb
		},
		{
		0x6194,
		0xf4fb
		},
		{
		0x6198,
		0xfdf3
		},
		{
		0x6199,
		0xfdf2
		},
		{
		0x619a,
		0xf7a6
		},
		{
		0x61a4,
		0xddc9
		},
		{
		0x61a7,
		0xd4d3
		},
		{
		0x61a9,
		0xcca8
		},
		{
		0x61ab,
		0xdac1
		},
		{
		0x61ac,
		0xccd5
		},
		{
		0x61ae,
		0xd9e4
		},
		{
		0x61b2,
		0xfaca
		},
		{
		0x61b6,
		0xe5e3
		},
		{
		0x61ba,
		0xd3bc
		},
		{
		0x61be,
		0xcaf0
		},
		{
		0x61c3,
		0xd0c4
		},
		{
		0x61e6,
		0xd1d7
		},
		{
		0x61f2,
		0xf3a4
		},
		{
		0x61f6,
		0xd4fb
		},
		{
		0x61f7,
		0xfce3
		},
		{
		0x61f8,
		0xfad8
		},
		{
		0x61fa,
		0xf3d5
		},
		{
		0x61fc,
		0xcfab
		},
		{
		0x61ff,
		0xebf3
		},
		{
		0x6200,
		0xd5fc
		},
		{
		0x6207,
		0xd3d4
		},
		{
		0x6208,
		0xcdfc
		},
		{
		0x620a,
		0xd9e6
		},
		{
		0x620c,
		0xe2f9
		},
		{
		0x620d,
		0xe2a1
		},
		{
		0x620e,
		0xebd4
		},
		{
		0x6210,
		0xe0f7
		},
		{
		0x6211,
		0xe4b2
		},
		{
		0x6212,
		0xccfc
		},
		{
		0x6216,
		0xfbe4
		},
		{
		0x621a,
		0xf4ab
		},
		{
		0x621f,
		0xd0bd
		},
		{
		0x6221,
		0xcaf1
		},
		{
		0x622a,
		0xefb8
		},
		{
		0x622e,
		0xd7c0
		},
		{
		0x6230,
		0xeefa
		},
		{
		0x6231,
		0xfdf4
		},
		{
		0x6234,
		0xd3e3
		},
		{
		0x6236,
		0xfbc2
		},
		{
		0x623e,
		0xd5e8
		},
		{
		0x623f,
		0xdbae
		},
		{
		0x6240,
		0xe1b6
		},
		{
		0x6241,
		0xf8b7
		},
		{
		0x6247,
		0xe0bf
		},
		{
		0x6248,
		0xfbc3
		},
		{
		0x6249,
		0xddea
		},
		{
		0x624b,
		0xe2a2
		},
		{
		0x624d,
		0xeea6
		},
		{
		0x6253,
		0xf6e8
		},
		{
		0x6258,
		0xf6f5
		},
		{
		0x626e,
		0xddca
		},
		{
		0x6271,
		0xd0e2
		},
		{
		0x6276,
		0xdda6
		},
		{
		0x6279,
		0xddeb
		},
		{
		0x627c,
		0xe4f9
		},
		{
		0x627f,
		0xe3af
		},
		{
		0x6280,
		0xd0fc
		},
		{
		0x6284,
		0xf4fc
		},
		{
		0x6289,
		0xccbc
		},
		{
		0x628a,
		0xf7ea
		},
		{
		0x6291,
		0xe5e4
		},
		{
		0x6292,
		0xdff1
		},
		{
		0x6295,
		0xf7e1
		},
		{
		0x6297,
		0xf9f7
		},
		{
		0x6298,
		0xefb9
		},
		{
		0x629b,
		0xf8d8
		},
		{
		0x62ab,
		0xf9a9
		},
		{
		0x62b1,
		0xf8d9
		},
		{
		0x62b5,
		0xeebd
		},
		{
		0x62b9,
		0xd8c6
		},
		{
		0x62bc,
		0xe4e3
		},
		{
		0x62bd,
		0xf5ce
		},
		{
		0x62c2,
		0xddd9
		},
		{
		0x62c7,
		0xd9e7
		},
		{
		0x62c8,
		0xd2b9
		},
		{
		0x62c9,
		0xd5c3
		},
		{
		0x62cc,
		0xdae5
		},
		{
		0x62cd,
		0xdad0
		},
		{
		0x62cf,
		0xd1d9
		},
		{
		0x62d0,
		0xced8
		},
		{
		0x62d2,
		0xcbde
		},
		{
		0x62d3,
		0xf4ac
		},
		{
		0x62d4,
		0xdafb
		},
		{
		0x62d6,
		0xf6e9
		},
		{
		0x62d7,
		0xe8f3
		},
		{
		0x62d8,
		0xcfac
		},
		{
		0x62d9,
		0xf0f0
		},
		{
		0x62db,
		0xf4fd
		},
		{
		0x62dc,
		0xdbc8
		},
		{
		0x62ec,
		0xcec0
		},
		{
		0x62ed,
		0xe3d4
		},
		{
		0x62ee,
		0xd1cf
		},
		{
		0x62ef,
		0xf1f5
		},
		{
		0x62f1,
		0xcdf2
		},
		{
		0x62f3,
		0xcfeb
		},
		{
		0x62f7,
		0xcdb8
		},
		{
		0x62fe,
		0xe3a6
		},
		{
		0x62ff,
		0xd1da
		},
		{
		0x6301,
		0xf2a5
		},
		{
		0x6307,
		0xf2a6
		},
		{
		0x6309,
		0xe4ce
		},
		{
		0x6311,
		0xd3fb
		},
		{
		0x632b,
		0xf1a9
		},
		{
		0x632f,
		0xf2c9
		},
		{
		0x633a,
		0xefd8
		},
		{
		0x633b,
		0xe6c9
		},
		{
		0x633d,
		0xd8b8
		},
		{
		0x633e,
		0xfaf3
		},
		{
		0x6349,
		0xf3b5
		},
		{
		0x634c,
		0xf8a4
		},
		{
		0x634f,
		0xd1f3
		},
		{
		0x6350,
		0xe6c8
		},
		{
		0x6355,
		0xf8da
		},
		{
		0x6367,
		0xdce9
		},
		{
		0x6368,
		0xded7
		},
		{
		0x636e,
		0xcbdf
		},
		{
		0x6372,
		0xcfec
		},
		{
		0x6377,
		0xf4df
		},
		{
		0x637a,
		0xd1f4
		},
		{
		0x637b,
		0xd2ba
		},
		{
		0x637f,
		0xdff2
		},
		{
		0x6383,
		0xe1b7
		},
		{
		0x6388,
		0xe2a3
		},
		{
		0x6389,
		0xd3fc
		},
		{
		0x638c,
		0xede6
		},
		{
		0x6392,
		0xdbc9
		},
		{
		0x6396,
		0xe4fa
		},
		{
		0x6398,
		0xcfde
		},
		{
		0x639b,
		0xced0
		},
		{
		0x63a0,
		0xd5d3
		},
		{
		0x63a1,
		0xf3f5
		},
		{
		0x63a2,
		0xf7ae
		},
		{
		0x63a5,
		0xefc8
		},
		{
		0x63a7,
		0xcdf3
		},
		{
		0x63a8,
		0xf5cf
		},
		{
		0x63a9,
		0xe5f3
		},
		{
		0x63aa,
		0xf0c2
		},
		{
		0x63c0,
		0xcad1
		},
		{
		0x63c4,
		0xeaf1
		},
		{
		0x63c6,
		0xd0a6
		},
		{
		0x63cf,
		0xd9da
		},
		{
		0x63d0,
		0xf0ab
		},
		{
		0x63d6,
		0xebe7
		},
		{
		0x63da,
		0xe5c0
		},
		{
		0x63db,
		0xfcb5
		},
		{
		0x63e1,
		0xe4c4
		},
		{
		0x63ed,
		0xcca9
		},
		{
		0x63ee,
		0xfdc6
		},
		{
		0x63f4,
		0xeab5
		},
		{
		0x63f6,
		0xe5aa
		},
		{
		0x63f7,
		0xdfba
		},
		{
		0x640d,
		0xe1df
		},
		{
		0x640f,
		0xdad1
		},
		{
		0x6414,
		0xe1b8
		},
		{
		0x6416,
		0xe8f4
		},
		{
		0x6417,
		0xd3fd
		},
		{
		0x641c,
		0xe2a4
		},
		{
		0x6422,
		0xf2ca
		},
		{
		0x642c,
		0xdae6
		},
		{
		0x642d,
		0xf7b3
		},
		{
		0x643a,
		0xfdcd
		},
		{
		0x643e,
		0xf3b6
		},
		{
		0x6458,
		0xeed7
		},
		{
		0x6460,
		0xf5c4
		},
		{
		0x6469,
		0xd8a4
		},
		{
		0x646f,
		0xf2a7
		},
		{
		0x6478,
		0xd9b8
		},
		{
		0x6479,
		0xd9b9
		},
		{
		0x647a,
		0xefc9
		},
		{
		0x6488,
		0xd6ce
		},
		{
		0x6491,
		0xf7cb
		},
		{
		0x6492,
		0xdfae
		},
		{
		0x6493,
		0xe8f5
		},
		{
		0x649a,
		0xd2b5
		},
		{
		0x649e,
		0xd3d5
		},
		{
		0x64a4,
		0xf4cc
		},
		{
		0x64a5,
		0xdafc
		},
		{
		0x64ab,
		0xd9e8
		},
		{
		0x64ad,
		0xf7eb
		},
		{
		0x64ae,
		0xf5c9
		},
		{
		0x64b0,
		0xf3bc
		},
		{
		0x64b2,
		0xdad2
		},
		{
		0x64bb,
		0xd3b5
		},
		{
		0x64c1,
		0xe8b6
		},
		{
		0x64c4,
		0xd6cf
		},
		{
		0x64c5,
		0xf4ba
		},
		{
		0x64c7,
		0xf7c9
		},
		{
		0x64ca,
		0xccaa
		},
		{
		0x64cd,
		0xf0c3
		},
		{
		0x64ce,
		0xccd6
		},
		{
		0x64d2,
		0xd0d3
		},
		{
		0x64d4,
		0xd3bd
		},
		{
		0x64d8,
		0xdbfb
		},
		{
		0x64da,
		0xcbe0
		},
		{
		0x64e1,
		0xd3e4
		},
		{
		0x64e2,
		0xf6f7
		},
		{
		0x64e5,
		0xd5ba
		},
		{
		0x64e6,
		0xf3cd
		},
		{
		0x64e7,
		0xcbe1
		},
		{
		0x64ec,
		0xebf4
		},
		{
		0x64f2,
		0xf4ad
		},
		{
		0x64f4,
		0xfcaa
		},
		{
		0x64fa,
		0xf7ec
		},
		{
		0x64fe,
		0xe8f6
		},
		{
		0x6500,
		0xdae7
		},
		{
		0x6504,
		0xf7cc
		},
		{
		0x6518,
		0xe5c1
		},
		{
		0x651d,
		0xe0ee
		},
		{
		0x6523,
		0xd5fd
		},
		{
		0x652a,
		0xcee6
		},
		{
		0x652b,
		0xfcab
		},
		{
		0x652c,
		0xd5bb
		},
		{
		0x652f,
		0xf2a8
		},
		{
		0x6536,
		0xe2a5
		},
		{
		0x6537,
		0xcdb9
		},
		{
		0x6538,
		0xeaf2
		},
		{
		0x6539,
		0xcbc7
		},
		{
		0x653b,
		0xcdf4
		},
		{
		0x653e,
		0xdbaf
		},
		{
		0x653f,
		0xefd9
		},
		{
		0x6545,
		0xcdba
		},
		{
		0x6548,
		0xfcf9
		},
		{
		0x654d,
		0xdff3
		},
		{
		0x654e,
		0xcee7
		},
		{
		0x654f,
		0xdac2
		},
		{
		0x6551,
		0xcfad
		},
		{
		0x6556,
		0xe7f9
		},
		{
		0x6557,
		0xf8a8
		},
		{
		0x655e,
		0xf3e2
		},
		{
		0x6562,
		0xcaf2
		},
		{
		0x6563,
		0xdfa4
		},
		{
		0x6566,
		0xd4c4
		},
		{
		0x656c,
		0xccd7
		},
		{
		0x656d,
		0xe5c2
		},
		{
		0x6572,
		0xcdbb
		},
		{
		0x6574,
		0xefda
		},
		{
		0x6575,
		0xeed8
		},
		{
		0x6577,
		0xdda7
		},
		{
		0x6578,
		0xe2a6
		},
		{
		0x657e,
		0xe0c0
		},
		{
		0x6582,
		0xd6b0
		},
		{
		0x6583,
		0xf8ca
		},
		{
		0x6585,
		0xfcfa
		},
		{
		0x6587,
		0xd9fe
		},
		{
		0x658c,
		0xdeb0
		},
		{
		0x6590,
		0xddec
		},
		{
		0x6591,
		0xdae8
		},
		{
		0x6597,
		0xd4e0
		},
		{
		0x6599,
		0xd6f9
		},
		{
		0x659b,
		0xcdd7
		},
		{
		0x659c,
		0xded8
		},
		{
		0x659f,
		0xf2f8
		},
		{
		0x65a1,
		0xe4d6
		},
		{
		0x65a4,
		0xd0c5
		},
		{
		0x65a5,
		0xf4ae
		},
		{
		0x65a7,
		0xdda8
		},
		{
		0x65ab,
		0xedc5
		},
		{
		0x65ac,
		0xf3d6
		},
		{
		0x65af,
		0xded9
		},
		{
		0x65b0,
		0xe3e6
		},
		{
		0x65b7,
		0xd3a8
		},
		{
		0x65b9,
		0xdbb0
		},
		{
		0x65bc,
		0xe5da
		},
		{
		0x65bd,
		0xe3bf
		},
		{
		0x65c1,
		0xdbb1
		},
		{
		0x65c5,
		0xd5e9
		},
		{
		0x65cb,
		0xe0c1
		},
		{
		0x65cc,
		0xefdb
		},
		{
		0x65cf,
		0xf0e9
		},
		{
		0x65d2,
		0xd7b2
		},
		{
		0x65d7,
		0xd0fd
		},
		{
		0x65e0,
		0xd9e9
		},
		{
		0x65e3,
		0xd0fe
		},
		{
		0x65e5,
		0xeced
		},
		{
		0x65e6,
		0xd3a9
		},
		{
		0x65e8,
		0xf2a9
		},
		{
		0x65e9,
		0xf0c4
		},
		{
		0x65ec,
		0xe2e2
		},
		{
		0x65ed,
		0xe9ef
		},
		{
		0x65f1,
		0xf9d1
		},
		{
		0x65f4,
		0xe9d9
		},
		{
		0x65fa,
		0xe8da
		},
		{
		0x65fb,
		0xdac3
		},
		{
		0x65fc,
		0xdac4
		},
		{
		0x65fd,
		0xd4c5
		},
		{
		0x65ff,
		0xe7fa
		},
		{
		0x6606,
		0xcde0
		},
		{
		0x6607,
		0xe3b0
		},
		{
		0x6609,
		0xdbb2
		},
		{
		0x660a,
		0xfbc4
		},
		{
		0x660c,
		0xf3e3
		},
		{
		0x660e,
		0xd9a5
		},
		{
		0x660f,
		0xfbe7
		},
		{
		0x6610,
		0xddcb
		},
		{
		0x6611,
		0xd0d4
		},
		{
		0x6613,
		0xe6b6
		},
		{
		0x6614,
		0xe0ae
		},
		{
		0x6615,
		0xfdda
		},
		{
		0x661e,
		0xdcb5
		},
		{
		0x661f,
		0xe0f8
		},
		{
		0x6620,
		0xe7b1
		},
		{
		0x6625,
		0xf5f0
		},
		{
		0x6627,
		0xd8dc
		},
		{
		0x6628,
		0xedc6
		},
		{
		0x662d,
		0xe1b9
		},
		{
		0x662f,
		0xe3c0
		},
		{
		0x6630,
		0xf9c0
		},
		{
		0x6631,
		0xe9f0
		},
		{
		0x6634,
		0xd9db
		},
		{
		0x6636,
		0xf3e4
		},
		{
		0x663a,
		0xdcb6
		},
		{
		0x663b,
		0xe4e9
		},
		{
		0x6641,
		0xf0c5
		},
		{
		0x6642,
		0xe3c1
		},
		{
		0x6643,
		0xfccc
		},
		{
		0x6644,
		0xfccd
		},
		{
		0x6649,
		0xf2cb
		},
		{
		0x664b,
		0xf2cc
		},
		{
		0x664f,
		0xe4cf
		},
		{
		0x6659,
		0xf1db
		},
		{
		0x665b,
		0xfad9
		},
		{
		0x665d,
		0xf1b8
		},
		{
		0x665e,
		0xfdf5
		},
		{
		0x665f,
		0xe0f9
		},
		{
		0x666b,
		0xf6f8
		},
		{
		0x666e,
		0xdcc5
		},
		{
		0x666f,
		0xccd8
		},
		{
		0x6673,
		0xe0af
		},
		{
		0x6674,
		0xf4e7
		},
		{
		0x6676,
		0xefdc
		},
		{
		0x6677,
		0xcffc
		},
		{
		0x6678,
		0xefdd
		},
		{
		0x667a,
		0xf2aa
		},
		{
		0x6684,
		0xfdbe
		},
		{
		0x6687,
		0xcaac
		},
		{
		0x6688,
		0xfdbb
		},
		{
		0x6689,
		0xfdc7
		},
		{
		0x668e,
		0xe7b2
		},
		{
		0x6690,
		0xead1
		},
		{
		0x6691,
		0xdff4
		},
		{
		0x6696,
		0xd1ec
		},
		{
		0x6697,
		0xe4de
		},
		{
		0x6698,
		0xe5c3
		},
		{
		0x669d,
		0xd9a6
		},
		{
		0x66a0,
		0xcdbc
		},
		{
		0x66a2,
		0xf3e5
		},
		{
		0x66ab,
		0xedd5
		},
		{
		0x66ae,
		0xd9ba
		},
		{
		0x66b2,
		0xede7
		},
		{
		0x66b3,
		0xfbb5
		},
		{
		0x66b4,
		0xf8ec
		},
		{
		0x66b9,
		0xe0e7
		},
		{
		0x66bb,
		0xccd9
		},
		{
		0x66be,
		0xd4c6
		},
		{
		0x66c4,
		0xe7a5
		},
		{
		0x66c6,
		0xd5f5
		},
		{
		0x66c7,
		0xd3be
		},
		{
		0x66c9,
		0xfcfb
		},
		{
		0x66d6,
		0xe4f2
		},
		{
		0x66d9,
		0xdff5
		},
		{
		0x66dc,
		0xe8f8
		},
		{
		0x66dd,
		0xf8ed
		},
		{
		0x66e0,
		0xcec7
		},
		{
		0x66e6,
		0xfdf6
		},
		{
		0x66f0,
		0xe8d8
		},
		{
		0x66f2,
		0xcdd8
		},
		{
		0x66f3,
		0xe7d6
		},
		{
		0x66f4,
		0xccda
		},
		{
		0x66f7,
		0xcae3
		},
		{
		0x66f8,
		0xdff6
		},
		{
		0x66f9,
		0xf0c7
		},
		{
		0x66fa,
		0xf0c6
		},
		{
		0x66fc,
		0xd8ba
		},
		{
		0x66fe,
		0xf1f4
		},
		{
		0x66ff,
		0xf4f0
		},
		{
		0x6700,
		0xf5cc
		},
		{
		0x6703,
		0xfce5
		},
		{
		0x6708,
		0xeac5
		},
		{
		0x6709,
		0xeaf3
		},
		{
		0x670b,
		0xdddb
		},
		{
		0x670d,
		0xdcd7
		},
		{
		0x6714,
		0xdefd
		},
		{
		0x6715,
		0xf2f9
		},
		{
		0x6717,
		0xd5c7
		},
		{
		0x671b,
		0xd8d0
		},
		{
		0x671d,
		0xf0c8
		},
		{
		0x671e,
		0xd1a1
		},
		{
		0x671f,
		0xd1a2
		},
		{
		0x6726,
		0xd9d4
		},
		{
		0x6727,
		0xd6e8
		},
		{
		0x6728,
		0xd9ca
		},
		{
		0x6731,
		0xf1b9
		},
		{
		0x6734,
		0xdad3
		},
		{
		0x6736,
		0xf6ea
		},
		{
		0x673a,
		0xcff5
		},
		{
		0x673d,
		0xfdae
		},
		{
		0x6746,
		0xcad2
		},
		{
		0x6749,
		0xdfb4
		},
		{
		0x674e,
		0xd7dd
		},
		{
		0x674f,
		0xfaba
		},
		{
		0x6750,
		0xeea7
		},
		{
		0x6751,
		0xf5bd
		},
		{
		0x6753,
		0xf8f5
		},
		{
		0x6756,
		0xede8
		},
		{
		0x675c,
		0xd4e1
		},
		{
		0x675e,
		0xd1a3
		},
		{
		0x675f,
		0xe1d6
		},
		{
		0x676d,
		0xf9f8
		},
		{
		0x676f,
		0xdbca
		},
		{
		0x6770,
		0xcbf9
		},
		{
		0x6771,
		0xd4d4
		},
		{
		0x6773,
		0xd9dc
		},
		{
		0x6775,
		0xeebe
		},
		{
		0x6777,
		0xf7ed
		},
		{
		0x677b,
		0xd2ee
		},
		{
		0x677e,
		0xe1e6
		},
		{
		0x677f,
		0xf7f9
		},
		{
		0x6787,
		0xdded
		},
		{
		0x6789,
		0xe8db
		},
		{
		0x678b,
		0xdbb3
		},
		{
		0x678f,
		0xd1f7
		},
		{
		0x6790,
		0xe0b0
		},
		{
		0x6793,
		0xd4e2
		},
		{
		0x6795,
		0xf6d7
		},
		{
		0x6797,
		0xd7f9
		},
		{
		0x679a,
		0xd8dd
		},
		{
		0x679c,
		0xcdfd
		},
		{
		0x679d,
		0xf2ab
		},
		{
		0x67af,
		0xcdbd
		},
		{
		0x67b0,
		0xf8c2
		},
		{
		0x67b3,
		0xf2ac
		},
		{
		0x67b6,
		0xcaad
		},
		{
		0x67b7,
		0xcaae
		},
		{
		0x67b8,
		0xcfae
		},
		{
		0x67be,
		0xe3c2
		},
		{
		0x67c4,
		0xdcb7
		},
		{
		0x67da,
		0xeaf6
		},
		{
		0x67dd,
		0xf6f9
		},
		{
		0x67e9,
		0xcfaf
		},
		{
		0x67ec,
		0xcad3
		},
		{
		0x67ef,
		0xcaaf
		},
		{
		0x67f0,
		0xd2b0
		},
		{
		0x67f1,
		0xf1ba
		},
		{
		0x67f3,
		0xd7b3
		},
		{
		0x67f4,
		0xe3c3
		},
		{
		0x67f5,
		0xf3fd
		},
		{
		0x67f6,
		0xdeda
		},
		{
		0x67fb,
		0xdedb
		},
		{
		0x67fe,
		0xefde
		},
		{
		0x6812,
		0xe2e3
		},
		{
		0x6813,
		0xeefb
		},
		{
		0x6816,
		0xdff7
		},
		{
		0x6817,
		0xd7ca
		},
		{
		0x6821,
		0xcee8
		},
		{
		0x6822,
		0xdbdb
		},
		{
		0x682a,
		0xf1bb
		},
		{
		0x682f,
		0xe9f1
		},
		{
		0x6838,
		0xfab7
		},
		{
		0x6839,
		0xd0c6
		},
		{
		0x683c,
		0xccab
		},
		{
		0x683d,
		0xeea8
		},
		{
		0x6840,
		0xcbfa
		},
		{
		0x6841,
		0xf9f9
		},
		{
		0x6842,
		0xccfd
		},
		{
		0x6843,
		0xd3fe
		},
		{
		0x6848,
		0xe4d0
		},
		{
		0x684e,
		0xf2ee
		},
		{
		0x6850,
		0xd4d5
		},
		{
		0x6851,
		0xdfcd
		},
		{
		0x6853,
		0xfcb8
		},
		{
		0x6854,
		0xd1d0
		},
		{
		0x686d,
		0xf2cd
		},
		{
		0x6876,
		0xf7d2
		},
		{
		0x687f,
		0xcad4
		},
		{
		0x6881,
		0xd5d9
		},
		{
		0x6885,
		0xd8de
		},
		{
		0x688f,
		0xcdd9
		},
		{
		0x6893,
		0xeea9
		},
		{
		0x6894,
		0xf6bc
		},
		{
		0x6897,
		0xccdb
		},
		{
		0x689d,
		0xf0c9
		},
		{
		0x689f,
		0xfcfc
		},
		{
		0x68a1,
		0xe8c9
		},
		{
		0x68a2,
		0xf4fe
		},
		{
		0x68a7,
		0xe7fc
		},
		{
		0x68a8,
		0xd7de
		},
		{
		0x68ad,
		0xdedc
		},
		{
		0x68af,
		0xf0ac
		},
		{
		0x68b0,
		0xccfe
		},
		{
		0x68b1,
		0xcde1
		},
		{
		0x68b3,
		0xe1ba
		},
		{
		0x68b5,
		0xdbef
		},
		{
		0x68b6,
		0xdab2
		},
		{
		0x68c4,
		0xd1a5
		},
		{
		0x68c5,
		0xdcb8
		},
		{
		0x68c9,
		0xd8f6
		},
		{
		0x68cb,
		0xd1a4
		},
		{
		0x68cd,
		0xcde2
		},
		{
		0x68d2,
		0xdcea
		},
		{
		0x68d5,
		0xf0f7
		},
		{
		0x68d7,
		0xf0ca
		},
		{
		0x68d8,
		0xd0be
		},
		{
		0x68da,
		0xdddc
		},
		{
		0x68df,
		0xd4d6
		},
		{
		0x68e0,
		0xd3d6
		},
		{
		0x68e7,
		0xedd0
		},
		{
		0x68e8,
		0xcda1
		},
		{
		0x68ee,
		0xdfb5
		},
		{
		0x68f2,
		0xdff8
		},
		{
		0x68f9,
		0xd4a1
		},
		{
		0x68fa,
		0xceb2
		},
		{
		0x6900,
		0xe8ca
		},
		{
		0x6905,
		0xebf5
		},
		{
		0x690d,
		0xe3d5
		},
		{
		0x690e,
		0xf5d0
		},
		{
		0x6912,
		0xf5a1
		},
		{
		0x6927,
		0xd9a7
		},
		{
		0x6930,
		0xe5ab
		},
		{
		0x693d,
		0xe6cb
		},
		{
		0x693f,
		0xf5f1
		},
		{
		0x694a,
		0xe5c5
		},
		{
		0x6953,
		0xf9a3
		},
		{
		0x6954,
		0xe0db
		},
		{
		0x6955,
		0xf6eb
		},
		{
		0x6957,
		0xcbf1
		},
		{
		0x6959,
		0xd9ea
		},
		{
		0x695a,
		0xf5a2
		},
		{
		0x695e,
		0xd7d1
		},
		{
		0x6960,
		0xd1f8
		},
		{
		0x6961,
		0xeaf8
		},
		{
		0x6962,
		0xeaf9
		},
		{
		0x6963,
		0xdab3
		},
		{
		0x6968,
		0xefdf
		},
		{
		0x696b,
		0xf1ef
		},
		{
		0x696d,
		0xe5f6
		},
		{
		0x696e,
		0xeebf
		},
		{
		0x696f,
		0xe2e4
		},
		{
		0x6975,
		0xd0bf
		},
		{
		0x6977,
		0xfaac
		},
		{
		0x6978,
		0xf5d1
		},
		{
		0x6979,
		0xe7b3
		},
		{
		0x6995,
		0xe9be
		},
		{
		0x699b,
		0xf2ce
		},
		{
		0x699c,
		0xdbb4
		},
		{
		0x69a5,
		0xfcce
		},
		{
		0x69a7,
		0xddee
		},
		{
		0x69ae,
		0xe7b4
		},
		{
		0x69b4,
		0xd7b4
		},
		{
		0x69bb,
		0xf7b4
		},
		{
		0x69c1,
		0xcdbe
		},
		{
		0x69c3,
		0xdae9
		},
		{
		0x69cb,
		0xcfb0
		},
		{
		0x69cc,
		0xf7d9
		},
		{
		0x69cd,
		0xf3e6
		},
		{
		0x69d0,
		0xced9
		},
		{
		0x69e8,
		0xceaa
		},
		{
		0x69ea,
		0xcbc8
		},
		{
		0x69fb,
		0xd0a7
		},
		{
		0x69fd,
		0xf0cb
		},
		{
		0x69ff,
		0xd0c7
		},
		{
		0x6a02,
		0xe4c5
		},
		{
		0x6a0a,
		0xdbe0
		},
		{
		0x6a11,
		0xd5da
		},
		{
		0x6a13,
		0xd7a7
		},
		{
		0x6a17,
		0xeec0
		},
		{
		0x6a19,
		0xf8f6
		},
		{
		0x6a1e,
		0xf5d2
		},
		{
		0x6a1f,
		0xede9
		},
		{
		0x6a21,
		0xd9bc
		},
		{
		0x6a23,
		0xe5c6
		},
		{
		0x6a35,
		0xf5a3
		},
		{
		0x6a38,
		0xdad4
		},
		{
		0x6a39,
		0xe2a7
		},
		{
		0x6a3a,
		0xfbfc
		},
		{
		0x6a3d,
		0xf1dc
		},
		{
		0x6a44,
		0xcaf4
		},
		{
		0x6a48,
		0xe8fa
		},
		{
		0x6a4b,
		0xcee9
		},
		{
		0x6a52,
		0xe9f8
		},
		{
		0x6a53,
		0xe2e5
		},
		{
		0x6a58,
		0xd0b9
		},
		{
		0x6a59,
		0xd4f2
		},
		{
		0x6a5f,
		0xd1a6
		},
		{
		0x6a61,
		0xdfce
		},
		{
		0x6a6b,
		0xfcf4
		},
		{
		0x6a80,
		0xd3aa
		},
		{
		0x6a84,
		0xccac
		},
		{
		0x6a89,
		0xefe0
		},
		{
		0x6a8d,
		0xe5e5
		},
		{
		0x6a8e,
		0xd0d5
		},
		{
		0x6a97,
		0xdbfc
		},
		{
		0x6a9c,
		0xfce6
		},
		{
		0x6aa2,
		0xcbfe
		},
		{
		0x6aa3,
		0xedea
		},
		{
		0x6ab3,
		0xdeb1
		},
		{
		0x6abb,
		0xf9e3
		},
		{
		0x6ac2,
		0xd4a2
		},
		{
		0x6ac3,
		0xcff6
		},
		{
		0x6ad3,
		0xd6d0
		},
		{
		0x6ada,
		0xd5ea
		},
		{
		0x6adb,
		0xf1ee
		},
		{
		0x6af6,
		0xfacb
		},
		{
		0x6afb,
		0xe5a1
		},
		{
		0x6b04,
		0xd5b1
		},
		{
		0x6b0a,
		0xcfed
		},
		{
		0x6b0c,
		0xedeb
		},
		{
		0x6b12,
		0xd5b2
		},
		{
		0x6b16,
		0xd5bc
		},
		{
		0x6b20,
		0xfde2
		},
		{
		0x6b21,
		0xf3ad
		},
		{
		0x6b23,
		0xfddb
		},
		{
		0x6b32,
		0xe9b0
		},
		{
		0x6b3a,
		0xd1a7
		},
		{
		0x6b3d,
		0xfde3
		},
		{
		0x6b3e,
		0xceb3
		},
		{
		0x6b46,
		0xfde4
		},
		{
		0x6b47,
		0xface
		},
		{
		0x6b4c,
		0xcab0
		},
		{
		0x6b4e,
		0xf7a7
		},
		{
		0x6b50,
		0xcfb1
		},
		{
		0x6b5f,
		0xe6a2
		},
		{
		0x6b6a,
		0xe8e0
		},
		{
		0x6b72,
		0xe1a8
		},
		{
		0x6b77,
		0xd5f6
		},
		{
		0x6b78,
		0xcffd
		},
		{
		0x6b7b,
		0xdedd
		},
		{
		0x6b7f,
		0xd9d1
		},
		{
		0x6b83,
		0xe4ea
		},
		{
		0x6b84,
		0xf2cf
		},
		{
		0x6b86,
		0xf7bf
		},
		{
		0x6b89,
		0xe2e6
		},
		{
		0x6b8a,
		0xe2a8
		},
		{
		0x6b96,
		0xe3d6
		},
		{
		0x6b98,
		0xedd1
		},
		{
		0x6b9e,
		0xe9f9
		},
		{
		0x6bae,
		0xd6b1
		},
		{
		0x6baf,
		0xdeb2
		},
		{
		0x6bb2,
		0xe0e8
		},
		{
		0x6bb5,
		0xd3ab
		},
		{
		0x6bb7,
		0xebdc
		},
		{
		0x6bba,
		0xdfaf
		},
		{
		0x6bbc,
		0xcac3
		},
		{
		0x6bbf,
		0xeefc
		},
		{
		0x6bc1,
		0xfdc3
		},
		{
		0x6bc5,
		0xebf6
		},
		{
		0x6bc6,
		0xcfb2
		},
		{
		0x6bcb,
		0xd9ec
		},
		{
		0x6bcd,
		0xd9bd
		},
		{
		0x6bcf,
		0xd8df
		},
		{
		0x6bd2,
		0xd4b8
		},
		{
		0x6bd3,
		0xebbe
		},
		{
		0x6bd4,
		0xddef
		},
		{
		0x6bd6,
		0xddf0
		},
		{
		0x6bd7,
		0xddf1
		},
		{
		0x6bd8,
		0xddf2
		},
		{
		0x6bdb,
		0xd9be
		},
		{
		0x6beb,
		0xfbc6
		},
		{
		0x6bec,
		0xcfb3
		},
		{
		0x6c08,
		0xeefd
		},
		{
		0x6c0f,
		0xe4ab
		},
		{
		0x6c11,
		0xdac5
		},
		{
		0x6c13,
		0xd8ec
		},
		{
		0x6c23,
		0xd1a8
		},
		{
		0x6c34,
		0xe2a9
		},
		{
		0x6c37,
		0xdebc
		},
		{
		0x6c38,
		0xe7b5
		},
		{
		0x6c3e,
		0xdbf0
		},
		{
		0x6c40,
		0xefe2
		},
		{
		0x6c41,
		0xf1f0
		},
		{
		0x6c42,
		0xcfb4
		},
		{
		0x6c4e,
		0xdbf1
		},
		{
		0x6c50,
		0xe0b1
		},
		{
		0x6c55,
		0xdfa5
		},
		{
		0x6c57,
		0xf9d2
		},
		{
		0x6c5a,
		0xe7fd
		},
		{
		0x6c5d,
		0xe6a3
		},
		{
		0x6c5e,
		0xfbf1
		},
		{
		0x6c5f,
		0xcbb0
		},
		{
		0x6c60,
		0xf2ae
		},
		{
		0x6c68,
		0xcde7
		},
		{
		0x6c6a,
		0xe8dc
		},
		{
		0x6c6d,
		0xe7d7
		},
		{
		0x6c70,
		0xf7c0
		},
		{
		0x6c72,
		0xd0e3
		},
		{
		0x6c76,
		0xdaa1
		},
		{
		0x6c7a,
		0xccbd
		},
		{
		0x6c7d,
		0xd1a9
		},
		{
		0x6c7e,
		0xddcc
		},
		{
		0x6c81,
		0xe3fe
		},
		{
		0x6c82,
		0xd1aa
		},
		{
		0x6c83,
		0xe8aa
		},
		{
		0x6c85,
		0xeab6
		},
		{
		0x6c86,
		0xf9fa
		},
		{
		0x6c87,
		0xe6cc
		},
		{
		0x6c88,
		0xf6d8
		},
		{
		0x6c8c,
		0xd4c7
		},
		{
		0x6c90,
		0xd9cb
		},
		{
		0x6c99,
		0xdede
		},
		{
		0x6c9a,
		0xf2af
		},
		{
		0x6c9b,
		0xf8a9
		},
		{
		0x6cab,
		0xd8c8
		},
		{
		0x6cae,
		0xeec1
		},
		{
		0x6cb3,
		0xf9c1
		},
		{
		0x6cb8,
		0xddf3
		},
		{
		0x6cb9,
		0xeafa
		},
		{
		0x6cc1,
		0xfccf
		},
		{
		0x6cc2,
		0xfba2
		},
		{
		0x6cc4,
		0xe0dc
		},
		{
		0x6cc9,
		0xf4bb
		},
		{
		0x6cca,
		0xdad5
		},
		{
		0x6ccc,
		0xf9b2
		},
		{
		0x6cd3,
		0xfbf2
		},
		{
		0x6cd5,
		0xdbf6
		},
		{
		0x6cd7,
		0xdedf
		},
		{
		0x6cdb,
		0xdbf2
		},
		{
		0x6ce1,
		0xf8dc
		},
		{
		0x6ce2,
		0xf7ee
		},
		{
		0x6ce3,
		0xebe8
		},
		{
		0x6ce5,
		0xd2fa
		},
		{
		0x6ce8,
		0xf1bc
		},
		{
		0x6ceb,
		0xfada
		},
		{
		0x6cee,
		0xdaea
		},
		{
		0x6cef,
		0xdac6
		},
		{
		0x6cf0,
		0xf7c1
		},
		{
		0x6cf3,
		0xe7b6
		},
		{
		0x6d0b,
		0xe5c7
		},
		{
		0x6d0c,
		0xd6ac
		},
		{
		0x6d11,
		0xdcc7
		},
		{
		0x6d17,
		0xe1a9
		},
		{
		0x6d19,
		0xe2aa
		},
		{
		0x6d1b,
		0xd5a6
		},
		{
		0x6d1e,
		0xd4d7
		},
		{
		0x6d25,
		0xf2d0
		},
		{
		0x6d27,
		0xeafb
		},
		{
		0x6d29,
		0xe0dd
		},
		{
		0x6d2a,
		0xfbf3
		},
		{
		0x6d32,
		0xf1bd
		},
		{
		0x6d35,
		0xe2e7
		},
		{
		0x6d36,
		0xfdd7
		},
		{
		0x6d38,
		0xcec8
		},
		{
		0x6d39,
		0xeab7
		},
		{
		0x6d3b,
		0xfcc0
		},
		{
		0x6d3d,
		0xfde7
		},
		{
		0x6d3e,
		0xf7ef
		},
		{
		0x6d41,
		0xd7b5
		},
		{
		0x6d59,
		0xefba
		},
		{
		0x6d5a,
		0xf1dd
		},
		{
		0x6d5c,
		0xdeb3
		},
		{
		0x6d63,
		0xe8cb
		},
		{
		0x6d66,
		0xf8dd
		},
		{
		0x6d69,
		0xfbc7
		},
		{
		0x6d6a,
		0xd5c8
		},
		{
		0x6d6c,
		0xd7df
		},
		{
		0x6d6e,
		0xdda9
		},
		{
		0x6d74,
		0xe9b1
		},
		{
		0x6d77,
		0xfaad
		},
		{
		0x6d78,
		0xf6d9
		},
		{
		0x6d79,
		0xfaf4
		},
		{
		0x6d7f,
		0xf8aa
		},
		{
		0x6d85,
		0xe6ee
		},
		{
		0x6d87,
		0xccdc
		},
		{
		0x6d88,
		0xe1bc
		},
		{
		0x6d89,
		0xe0ef
		},
		{
		0x6d8c,
		0xe9bf
		},
		{
		0x6d8d,
		0xfcfd
		},
		{
		0x6d8e,
		0xe6ce
		},
		{
		0x6d91,
		0xe1d7
		},
		{
		0x6d93,
		0xe6cf
		},
		{
		0x6d95,
		0xf4f1
		},
		{
		0x6daf,
		0xe4f3
		},
		{
		0x6db2,
		0xe4fb
		},
		{
		0x6db5,
		0xf9e4
		},
		{
		0x6dc0,
		0xefe3
		},
		{
		0x6dcb,
		0xd7fa
		},
		{
		0x6dcf,
		0xfbc8
		},
		{
		0x6dd1,
		0xe2d7
		},
		{
		0x6dd8,
		0xd4a3
		},
		{
		0x6dd9,
		0xf0f8
		},
		{
		0x6dda,
		0xd7a8
		},
		{
		0x6dde,
		0xe1e7
		},
		{
		0x6de1,
		0xd3bf
		},
		{
		0x6de8,
		0xefe4
		},
		{
		0x6dea,
		0xd7c5
		},
		{
		0x6deb,
		0xebe2
		},
		{
		0x6dee,
		0xfce7
		},
		{
		0x6df1,
		0xe4a2
		},
		{
		0x6df3,
		0xe2e8
		},
		{
		0x6df5,
		0xe6d0
		},
		{
		0x6e17,
		0xdfb6
		},
		{
		0x6e19,
		0xfcb9
		},
		{
		0x6e1a,
		0xeec2
		},
		{
		0x6e1b,
		0xcaf5
		},
		{
		0x6e1f,
		0xefe5
		},
		{
		0x6e20,
		0xcbe2
		},
		{
		0x6e21,
		0xd4a4
		},
		{
		0x6e23,
		0xdee0
		},
		{
		0x6e24,
		0xdafd
		},
		{
		0x6e25,
		0xe4c6
		},
		{
		0x6e26,
		0xe8be
		},
		{
		0x6e2b,
		0xe0de
		},
		{
		0x6e2c,
		0xf6b4
		},
		{
		0x6e2d,
		0xead2
		},
		{
		0x6e2f,
		0xf9fb
		},
		{
		0x6e32,
		0xe0c2
		},
		{
		0x6e34,
		0xcae4
		},
		{
		0x6e36,
		0xe7b7
		},
		{
		0x6e38,
		0xeafd
		},
		{
		0x6e3a,
		0xd9dd
		},
		{
		0x6e3c,
		0xdab4
		},
		{
		0x6e3d,
		0xeeaa
		},
		{
		0x6e3e,
		0xfbe9
		},
		{
		0x6e43,
		0xdbcb
		},
		{
		0x6e44,
		0xdab5
		},
		{
		0x6e4a,
		0xf1be
		},
		{
		0x6e4d,
		0xd3ac
		},
		{
		0x6e56,
		0xfbc9
		},
		{
		0x6e58,
		0xdfcf
		},
		{
		0x6e5b,
		0xd3c0
		},
		{
		0x6e5c,
		0xe3d7
		},
		{
		0x6e5e,
		0xefe6
		},
		{
		0x6e5f,
		0xfcd0
		},
		{
		0x6e67,
		0xe9c0
		},
		{
		0x6e6b,
		0xf5d3
		},
		{
		0x6e6e,
		0xecdc
		},
		{
		0x6e6f,
		0xf7b7
		},
		{
		0x6e72,
		0xeab8
		},
		{
		0x6e73,
		0xd1f9
		},
		{
		0x6e7a,
		0xdcc8
		},
		{
		0x6e90,
		0xeab9
		},
		{
		0x6e96,
		0xf1de
		},
		{
		0x6e9c,
		0xd7b6
		},
		{
		0x6e9d,
		0xcfb5
		},
		{
		0x6e9f,
		0xd9a8
		},
		{
		0x6ea2,
		0xecee
		},
		{
		0x6ea5,
		0xddaa
		},
		{
		0x6eaa,
		0xcda2
		},
		{
		0x6eab,
		0xe8ae
		},
		{
		0x6eaf,
		0xe1bd
		},
		{
		0x6eb1,
		0xf2d1
		},
		{
		0x6eb6,
		0xe9c1
		},
		{
		0x6eba,
		0xd2fc
		},
		{
		0x6ec2,
		0xdbb5
		},
		{
		0x6ec4,
		0xf3e7
		},
		{
		0x6ec5,
		0xd8fe
		},
		{
		0x6ec9,
		0xfcd1
		},
		{
		0x6ecb,
		0xedb2
		},
		{
		0x6ecc,
		0xf4af
		},
		{
		0x6ece,
		0xfba3
		},
		{
		0x6ed1,
		0xfcc1
		},
		{
		0x6ed3,
		0xeeab
		},
		{
		0x6ed4,
		0xd4a5
		},
		{
		0x6eef,
		0xf4f2
		},
		{
		0x6ef4,
		0xeed9
		},
		{
		0x6ef8,
		0xfbca
		},
		{
		0x6efe,
		0xcde3
		},
		{
		0x6eff,
		0xd8bb
		},
		{
		0x6f01,
		0xe5db
		},
		{
		0x6f02,
		0xf8f7
		},
		{
		0x6f06,
		0xf6d4
		},
		{
		0x6f0f,
		0xd7a9
		},
		{
		0x6f11,
		0xcbc9
		},
		{
		0x6f14,
		0xe6d1
		},
		{
		0x6f15,
		0xf0cc
		},
		{
		0x6f20,
		0xd8ae
		},
		{
		0x6f22,
		0xf9d3
		},
		{
		0x6f23,
		0xd5fe
		},
		{
		0x6f2b,
		0xd8bc
		},
		{
		0x6f2c,
		0xf2b0
		},
		{
		0x6f31,
		0xe2ab
		},
		{
		0x6f32,
		0xf3e8
		},
		{
		0x6f38,
		0xefc2
		},
		{
		0x6f3f,
		0xedec
		},
		{
		0x6f41,
		0xe7b8
		},
		{
		0x6f51,
		0xdafe
		},
		{
		0x6f54,
		0xccbe
		},
		{
		0x6f57,
		0xf2fc
		},
		{
		0x6f58,
		0xdaeb
		},
		{
		0x6f5a,
		0xe2d8
		},
		{
		0x6f5b,
		0xedd6
		},
		{
		0x6f5e,
		0xd6d1
		},
		{
		0x6f5f,
		0xe0b3
		},
		{
		0x6f62,
		0xfcd2
		},
		{
		0x6f64,
		0xebc8
		},
		{
		0x6f6d,
		0xd3c1
		},
		{
		0x6f6e,
		0xf0cd
		},
		{
		0x6f70,
		0xcff7
		},
		{
		0x6f7a,
		0xedd2
		},
		{
		0x6f7c,
		0xd4d8
		},
		{
		0x6f7d,
		0xdcc9
		},
		{
		0x6f7e,
		0xd7f1
		},
		{
		0x6f81,
		0xdfbb
		},
		{
		0x6f84,
		0xf3a5
		},
		{
		0x6f88,
		0xf4cd
		},
		{
		0x6f8d,
		0xf1bf
		},
		{
		0x6f8e,
		0xf8b1
		},
		{
		0x6f90,
		0xe9fa
		},
		{
		0x6f94,
		0xfbcb
		},
		{
		0x6f97,
		0xcad5
		},
		{
		0x6fa3,
		0xf9d4
		},
		{
		0x6fa4,
		0xf7ca
		},
		{
		0x6fa7,
		0xd6c8
		},
		{
		0x6fae,
		0xfce8
		},
		{
		0x6faf,
		0xf3bd
		},
		{
		0x6fb1,
		0xeefe
		},
		{
		0x6fb3,
		0xe7fe
		},
		{
		0x6fb9,
		0xd3c2
		},
		{
		0x6fbe,
		0xd3b6
		},
		{
		0x6fc0,
		0xccad
		},
		{
		0x6fc1,
		0xf6fa
		},
		{
		0x6fc2,
		0xd6b2
		},
		{
		0x6fc3,
		0xd2d8
		},
		{
		0x6fca,
		0xe7d8
		},
		{
		0x6fd5,
		0xe3a5
		},
		{
		0x6fda,
		0xe7b9
		},
		{
		0x6fdf,
		0xf0ad
		},
		{
		0x6fe0,
		0xfbcc
		},
		{
		0x6fe1,
		0xeba1
		},
		{
		0x6fe4,
		0xd4a6
		},
		{
		0x6fe9,
		0xfbcd
		},
		{
		0x6feb,
		0xd5bd
		},
		{
		0x6fec,
		0xf1df
		},
		{
		0x6fef,
		0xf6fb
		},
		{
		0x6ff1,
		0xdeb4
		},
		{
		0x6ffe,
		0xd5eb
		},
		{
		0x7001,
		0xe5c8
		},
		{
		0x7005,
		0xfba4
		},
		{
		0x7006,
		0xd4b9
		},
		{
		0x7009,
		0xdee1
		},
		{
		0x700b,
		0xe4a3
		},
		{
		0x700f,
		0xd7b7
		},
		{
		0x7011,
		0xf8ee
		},
		{
		0x7015,
		0xdeb5
		},
		{
		0x7018,
		0xd6d2
		},
		{
		0x7023,
		0xfaae
		},
		{
		0x7027,
		0xd6e9
		},
		{
		0x7028,
		0xd6ee
		},
		{
		0x702f,
		0xe7bb
		},
		{
		0x7037,
		0xeccb
		},
		{
		0x703e,
		0xd5b3
		},
		{
		0x704c,
		0xceb4
		},
		{
		0x7050,
		0xfba5
		},
		{
		0x7051,
		0xe1ee
		},
		{
		0x7058,
		0xf7a8
		},
		{
		0x705d,
		0xfbce
		},
		{
		0x7063,
		0xd8bd
		},
		{
		0x706b,
		0xfbfd
		},
		{
		0x7070,
		0xfce9
		},
		{
		0x7078,
		0xcfb6
		},
		{
		0x707c,
		0xedc7
		},
		{
		0x707d,
		0xeeac
		},
		{
		0x7085,
		0xccdd
		},
		{
		0x708a,
		0xf6a7
		},
		{
		0x708e,
		0xe6fa
		},
		{
		0x7092,
		0xf5a4
		},
		{
		0x7098,
		0xfddc
		},
		{
		0x7099,
		0xedb3
		},
		{
		0x709a,
		0xcec9
		},
		{
		0x70a1,
		0xefe8
		},
		{
		0x70a4,
		0xe1bf
		},
		{
		0x70ab,
		0xfadb
		},
		{
		0x70ac,
		0xcbe3
		},
		{
		0x70ad,
		0xf7a9
		},
		{
		0x70af,
		0xfba6
		},
		{
		0x70b3,
		0xdcb9
		},
		{
		0x70b7,
		0xf1c0
		},
		{
		0x70b8,
		0xedc8
		},
		{
		0x70b9,
		0xefc3
		},
		{
		0x70c8,
		0xd6ad
		},
		{
		0x70cb,
		0xfdce
		},
		{
		0x70cf,
		0xe8a1
		},
		{
		0x70d8,
		0xfbf4
		},
		{
		0x70d9,
		0xd5a7
		},
		{
		0x70dd,
		0xf1f6
		},
		{
		0x70df,
		0xe6d3
		},
		{
		0x70f1,
		0xccde
		},
		{
		0x70f9,
		0xf8b2
		},
		{
		0x70fd,
		0xdceb
		},
		{
		0x7104,
		0xfdb6
		},
		{
		0x7109,
		0xe5ea
		},
		{
		0x710c,
		0xf1e0
		},
		{
		0x7119,
		0xdbcc
		},
		{
		0x711a,
		0xddcd
		},
		{
		0x711e,
		0xd4c8
		},
		{
		0x7121,
		0xd9ed
		},
		{
		0x7126,
		0xf5a5
		},
		{
		0x7130,
		0xe6fb
		},
		{
		0x7136,
		0xe6d4
		},
		{
		0x7147,
		0xfdc8
		},
		{
		0x7149,
		0xd6a1
		},
		{
		0x714a,
		0xfdbf
		},
		{
		0x714c,
		0xfcd3
		},
		{
		0x714e,
		0xefa1
		},
		{
		0x7150,
		0xe7bc
		},
		{
		0x7156,
		0xd1ee
		},
		{
		0x7159,
		0xe6d5
		},
		{
		0x715c,
		0xe9f2
		},
		{
		0x715e,
		0xdfb0
		},
		{
		0x7164,
		0xd8e0
		},
		{
		0x7165,
		0xfcba
		},
		{
		0x7166,
		0xfdaf
		},
		{
		0x7167,
		0xf0ce
		},
		{
		0x7169,
		0xdbe1
		},
		{
		0x716c,
		0xe5c9
		},
		{
		0x716e,
		0xedb4
		},
		{
		0x717d,
		0xe0c3
		},
		{
		0x7184,
		0xe3d8
		},
		{
		0x7189,
		0xe9fb
		},
		{
		0x718a,
		0xeaa8
		},
		{
		0x718f,
		0xfdb7
		},
		{
		0x7192,
		0xfba7
		},
		{
		0x7194,
		0xe9c2
		},
		{
		0x7199,
		0xfdf7
		},
		{
		0x719f,
		0xe2d9
		},
		{
		0x71a2,
		0xdcec
		},
		{
		0x71ac,
		0xe8a2
		},
		{
		0x71b1,
		0xe6f0
		},
		{
		0x71b9,
		0xfdf8
		},
		{
		0x71ba,
		0xfdf9
		},
		{
		0x71be,
		0xf6bf
		},
		{
		0x71c1,
		0xe7a7
		},
		{
		0x71c3,
		0xe6d7
		},
		{
		0x71c8,
		0xd4f3
		},
		{
		0x71c9,
		0xd4c9
		},
		{
		0x71ce,
		0xd6fa
		},
		{
		0x71d0,
		0xd7f2
		},
		{
		0x71d2,
		0xe1c0
		},
		{
		0x71d4,
		0xdbe2
		},
		{
		0x71d5,
		0xe6d8
		},
		{
		0x71df,
		0xe7bd
		},
		{
		0x71e5,
		0xf0cf
		},
		{
		0x71e6,
		0xf3be
		},
		{
		0x71e7,
		0xe2ac
		},
		{
		0x71ed,
		0xf5b7
		},
		{
		0x71ee,
		0xe0f0
		},
		{
		0x71fb,
		0xfdb8
		},
		{
		0x71fc,
		0xe3e8
		},
		{
		0x71fe,
		0xd4a7
		},
		{
		0x71ff,
		0xe8fc
		},
		{
		0x7200,
		0xfad2
		},
		{
		0x7206,
		0xf8ef
		},
		{
		0x7210,
		0xd6d3
		},
		{
		0x721b,
		0xd5b4
		},
		{
		0x722a,
		0xf0d0
		},
		{
		0x722c,
		0xf7f0
		},
		{
		0x722d,
		0xeeb3
		},
		{
		0x7230,
		0xeaba
		},
		{
		0x7232,
		0xead3
		},
		{
		0x7235,
		0xedc9
		},
		{
		0x7236,
		0xddab
		},
		{
		0x723a,
		0xe5ac
		},
		{
		0x723b,
		0xfda1
		},
		{
		0x723d,
		0xdfd0
		},
		{
		0x723e,
		0xecb3
		},
		{
		0x7240,
		0xdfd1
		},
		{
		0x7246,
		0xeded
		},
		{
		0x7247,
		0xf8b8
		},
		{
		0x7248,
		0xf7fa
		},
		{
		0x724c,
		0xf8ab
		},
		{
		0x7252,
		0xf4e0
		},
		{
		0x7258,
		0xd4ba
		},
		{
		0x7259,
		0xe4b3
		},
		{
		0x725b,
		0xe9da
		},
		{
		0x725d,
		0xdeb6
		},
		{
		0x725f,
		0xd9bf
		},
		{
		0x7261,
		0xd9c0
		},
		{
		0x7262,
		0xd6ef
		},
		{
		0x7267,
		0xd9cc
		},
		{
		0x7269,
		0xdaaa
		},
		{
		0x7272,
		0xdfe5
		},
		{
		0x7279,
		0xf7e5
		},
		{
		0x727d,
		0xccb2
		},
		{
		0x7280,
		0xdff9
		},
		{
		0x7281,
		0xd7e0
		},
		{
		0x72a2,
		0xd4bb
		},
		{
		0x72a7,
		0xfdfa
		},
		{
		0x72ac,
		0xccb3
		},
		{
		0x72af,
		0xdbf3
		},
		{
		0x72c0,
		0xdfd2
		},
		{
		0x72c2,
		0xceca
		},
		{
		0x72c4,
		0xeeda
		},
		{
		0x72ce,
		0xe4e4
		},
		{
		0x72d0,
		0xfbcf
		},
		{
		0x72d7,
		0xcfb7
		},
		{
		0x72d9,
		0xeec3
		},
		{
		0x72e1,
		0xceea
		},
		{
		0x72e9,
		0xe2ad
		},
		{
		0x72f8,
		0xd7e1
		},
		{
		0x72f9,
		0xfaf5
		},
		{
		0x72fc,
		0xd5c9
		},
		{
		0x72fd,
		0xf8ac
		},
		{
		0x730a,
		0xe7d9
		},
		{
		0x7316,
		0xf3e9
		},
		{
		0x731b,
		0xd8ed
		},
		{
		0x731c,
		0xe3c4
		},
		{
		0x731d,
		0xf0f1
		},
		{
		0x7325,
		0xe8e5
		},
		{
		0x7329,
		0xe0fa
		},
		{
		0x732a,
		0xeec4
		},
		{
		0x732b,
		0xd9de
		},
		{
		0x7336,
		0xeba2
		},
		{
		0x7337,
		0xeba3
		},
		{
		0x733e,
		0xfcc2
		},
		{
		0x733f,
		0xeabb
		},
		{
		0x7344,
		0xe8ab
		},
		{
		0x7345,
		0xdee2
		},
		{
		0x7350,
		0xedef
		},
		{
		0x7352,
		0xe8a3
		},
		{
		0x7357,
		0xcff1
		},
		{
		0x7368,
		0xd4bc
		},
		{
		0x736a,
		0xfcea
		},
		{
		0x7370,
		0xe7be
		},
		{
		0x7372,
		0xfcf2
		},
		{
		0x7375,
		0xd6b4
		},
		{
		0x7378,
		0xe2ae
		},
		{
		0x737a,
		0xd3b7
		},
		{
		0x737b,
		0xfacc
		},
		{
		0x7384,
		0xfadc
		},
		{
		0x7386,
		0xedb5
		},
		{
		0x7387,
		0xe1e3
		},
		{
		0x7389,
		0xe8ac
		},
		{
		0x738b,
		0xe8dd
		},
		{
		0x738e,
		0xefe9
		},
		{
		0x7394,
		0xf4bd
		},
		{
		0x7396,
		0xcfb8
		},
		{
		0x7397,
		0xe9db
		},
		{
		0x7398,
		0xd1ac
		},
		{
		0x739f,
		0xdac7
		},
		{
		0x73a7,
		0xebc9
		},
		{
		0x73a9,
		0xe8cc
		},
		{
		0x73ad,
		0xdeb7
		},
		{
		0x73b2,
		0xd6bc
		},
		{
		0x73b3,
		0xd3e5
		},
		{
		0x73b9,
		0xfadd
		},
		{
		0x73c0,
		0xdad6
		},
		{
		0x73c2,
		0xcab1
		},
		{
		0x73c9,
		0xdac8
		},
		{
		0x73ca,
		0xdfa6
		},
		{
		0x73cc,
		0xf9b3
		},
		{
		0x73cd,
		0xf2d2
		},
		{
		0x73cf,
		0xcac4
		},
		{
		0x73d6,
		0xcecb
		},
		{
		0x73d9,
		0xcdf5
		},
		{
		0x73dd,
		0xfdb0
		},
		{
		0x73de,
		0xd5a8
		},
		{
		0x73e0,
		0xf1c1
		},
		{
		0x73e3,
		0xe2e9
		},
		{
		0x73e4,
		0xdcca
		},
		{
		0x73e5,
		0xecb4
		},
		{
		0x73e6,
		0xfac0
		},
		{
		0x73e9,
		0xfba8
		},
		{
		0x73ea,
		0xd0a8
		},
		{
		0x73ed,
		0xdaec
		},
		{
		0x73f7,
		0xd9ee
		},
		{
		0x73f9,
		0xe0fb
		},
		{
		0x73fd,
		0xefea
		},
		{
		0x73fe,
		0xfade
		},
		{
		0x7401,
		0xe0c4
		},
		{
		0x7403,
		0xcfb9
		},
		{
		0x7405,
		0xd5ca
		},
		{
		0x7406,
		0xd7e2
		},
		{
		0x7407,
		0xe2af
		},
		{
		0x7409,
		0xd7b8
		},
		{
		0x7413,
		0xe8cd
		},
		{
		0x741b,
		0xf6da
		},
		{
		0x7420,
		0xefa2
		},
		{
		0x7421,
		0xe2da
		},
		{
		0x7422,
		0xf6fc
		},
		{
		0x7425,
		0xfbd0
		},
		{
		0x7426,
		0xd1ad
		},
		{
		0x7428,
		0xcde4
		},
		{
		0x742a,
		0xd1ae
		},
		{
		0x742b,
		0xdced
		},
		{
		0x742c,
		0xe8ce
		},
		{
		0x742e,
		0xf0f9
		},
		{
		0x742f,
		0xceb5
		},
		{
		0x7430,
		0xe6fc
		},
		{
		0x7433,
		0xd7fb
		},
		{
		0x7434,
		0xd0d6
		},
		{
		0x7435,
		0xddf5
		},
		{
		0x7436,
		0xf7f1
		},
		{
		0x7438,
		0xf6fd
		},
		{
		0x743a,
		0xdbf7
		},
		{
		0x743f,
		0xfbea
		},
		{
		0x7440,
		0xe9dc
		},
		{
		0x7441,
		0xd9c1
		},
		{
		0x7443,
		0xf5f2
		},
		{
		0x7444,
		0xe0c5
		},
		{
		0x744b,
		0xead4
		},
		{
		0x7455,
		0xf9c2
		},
		{
		0x7457,
		0xeabc
		},
		{
		0x7459,
		0xd2c5
		},
		{
		0x745a,
		0xfbd1
		},
		{
		0x745b,
		0xe7c0
		},
		{
		0x745c,
		0xeba5
		},
		{
		0x745e,
		0xdffa
		},
		{
		0x745f,
		0xe3a2
		},
		{
		0x7460,
		0xd7b9
		},
		{
		0x7462,
		0xe9c3
		},
		{
		0x7464,
		0xe8fd
		},
		{
		0x7465,
		0xe8af
		},
		{
		0x7468,
		0xf2d3
		},
		{
		0x7469,
		0xfba9
		},
		{
		0x746a,
		0xd8a5
		},
		{
		0x746f,
		0xd5cb
		},
		{
		0x747e,
		0xd0c8
		},
		{
		0x7482,
		0xd1af
		},
		{
		0x7483,
		0xd7e3
		},
		{
		0x7487,
		0xe0c6
		},
		{
		0x7489,
		0xd6a2
		},
		{
		0x748b,
		0xedf0
		},
		{
		0x7498,
		0xd7f3
		},
		{
		0x749c,
		0xfcd4
		},
		{
		0x749e,
		0xdad7
		},
		{
		0x749f,
		0xccdf
		},
		{
		0x74a1,
		0xf2d4
		},
		{
		0x74a3,
		0xd1b0
		},
		{
		0x74a5,
		0xcce0
		},
		{
		0x74a7,
		0xdbfd
		},
		{
		0x74a8,
		0xf3bf
		},
		{
		0x74aa,
		0xf0d1
		},
		{
		0x74b0,
		0xfcbb
		},
		{
		0x74b2,
		0xe2b0
		},
		{
		0x74b5,
		0xe6a5
		},
		{
		0x74b9,
		0xe2db
		},
		{
		0x74bd,
		0xdfde
		},
		{
		0x74bf,
		0xe0c7
		},
		{
		0x74c6,
		0xf2ef
		},
		{
		0x74ca,
		0xcce1
		},
		{
		0x74cf,
		0xd6ea
		},
		{
		0x74d4,
		0xe7c2
		},
		{
		0x74d8,
		0xceb6
		},
		{
		0x74da,
		0xf3c0
		},
		{
		0x74dc,
		0xcdfe
		},
		{
		0x74e0,
		0xfbd2
		},
		{
		0x74e2,
		0xf8f8
		},
		{
		0x74e3,
		0xf7fb
		},
		{
		0x74e6,
		0xe8bf
		},
		{
		0x74ee,
		0xe8b7
		},
		{
		0x74f7,
		0xedb6
		},
		{
		0x7501,
		0xdcba
		},
		{
		0x7504,
		0xccb4
		},
		{
		0x7511,
		0xf1f7
		},
		{
		0x7515,
		0xe8b8
		},
		{
		0x7518,
		0xcaf6
		},
		{
		0x751a,
		0xe4a4
		},
		{
		0x751b,
		0xf4d6
		},
		{
		0x751f,
		0xdfe6
		},
		{
		0x7523,
		0xdfa7
		},
		{
		0x7525,
		0xdfe7
		},
		{
		0x7526,
		0xe1c1
		},
		{
		0x7528,
		0xe9c4
		},
		{
		0x752b,
		0xdccb
		},
		{
		0x752c,
		0xe9c5
		},
		{
		0x7530,
		0xefa3
		},
		{
		0x7531,
		0xeba6
		},
		{
		0x7532,
		0xcba3
		},
		{
		0x7533,
		0xe3e9
		},
		{
		0x7537,
		0xd1fb
		},
		{
		0x7538,
		0xefa4
		},
		{
		0x753a,
		0xefeb
		},
		{
		0x7547,
		0xd0b4
		},
		{
		0x754c,
		0xcda3
		},
		{
		0x754f,
		0xe8e6
		},
		{
		0x7551,
		0xefa5
		},
		{
		0x7553,
		0xd3cc
		},
		{
		0x7554,
		0xdaed
		},
		{
		0x7559,
		0xd7ba
		},
		{
		0x755b,
		0xf2d5
		},
		{
		0x755c,
		0xf5e5
		},
		{
		0x755d,
		0xd9ef
		},
		{
		0x7562,
		0xf9b4
		},
		{
		0x7565,
		0xd5d4
		},
		{
		0x7566,
		0xfdcf
		},
		{
		0x756a,
		0xdbe3
		},
		{
		0x756f,
		0xf1e1
		},
		{
		0x7570,
		0xecb6
		},
		{
		0x7575,
		0xfbfe
		},
		{
		0x7576,
		0xd3d7
		},
		{
		0x7578,
		0xd1b1
		},
		{
		0x757a,
		0xcbb1
		},
		{
		0x757f,
		0xd1b2
		},
		{
		0x7586,
		0xcbb2
		},
		{
		0x7587,
		0xf1c2
		},
		{
		0x758a,
		0xf4e1
		},
		{
		0x758b,
		0xf9b5
		},
		{
		0x758e,
		0xe1c3
		},
		{
		0x758f,
		0xe1c2
		},
		{
		0x7591,
		0xebf7
		},
		{
		0x759d,
		0xdfa8
		},
		{
		0x75a5,
		0xcbca
		},
		{
		0x75ab,
		0xe6b9
		},
		{
		0x75b1,
		0xf8de
		},
		{
		0x75b2,
		0xf9aa
		},
		{
		0x75b3,
		0xcaf7
		},
		{
		0x75b5,
		0xedb7
		},
		{
		0x75b8,
		0xd3b8
		},
		{
		0x75b9,
		0xf2d6
		},
		{
		0x75bc,
		0xd4d9
		},
		{
		0x75bd,
		0xeec5
		},
		{
		0x75be,
		0xf2f0
		},
		{
		0x75c2,
		0xcab2
		},
		{
		0x75c5,
		0xdcbb
		},
		{
		0x75c7,
		0xf1f8
		},
		{
		0x75cd,
		0xecb7
		},
		{
		0x75d2,
		0xe5ca
		},
		{
		0x75d4,
		0xf6c0
		},
		{
		0x75d5,
		0xfddd
		},
		{
		0x75d8,
		0xd4e3
		},
		{
		0x75d9,
		0xcce2
		},
		{
		0x75db,
		0xf7d4
		},
		{
		0x75e2,
		0xd7e5
		},
		{
		0x75f0,
		0xd3c3
		},
		{
		0x75f2,
		0xd8a6
		},
		{
		0x75f4,
		0xf6c1
		},
		{
		0x75fa,
		0xddf6
		},
		{
		0x75fc,
		0xcdc0
		},
		{
		0x7600,
		0xe5dc
		},
		{
		0x760d,
		0xe5cb
		},
		{
		0x7619,
		0xe1c4
		},
		{
		0x761f,
		0xe8b0
		},
		{
		0x7620,
		0xf4b0
		},
		{
		0x7621,
		0xf3ea
		},
		{
		0x7622,
		0xdaee
		},
		{
		0x7624,
		0xd7bb
		},
		{
		0x7626,
		0xe2b1
		},
		{
		0x763b,
		0xd7aa
		},
		{
		0x7642,
		0xd6fb
		},
		{
		0x764c,
		0xe4df
		},
		{
		0x764e,
		0xcad6
		},
		{
		0x7652,
		0xeba8
		},
		{
		0x7656,
		0xdbfe
		},
		{
		0x7661,
		0xf6c2
		},
		{
		0x7664,
		0xefbb
		},
		{
		0x7669,
		0xd4fd
		},
		{
		0x766c,
		0xe0c8
		},
		{
		0x7670,
		0xe8b9
		},
		{
		0x7672,
		0xefa6
		},
		{
		0x7678,
		0xcda4
		},
		{
		0x767b,
		0xd4f4
		},
		{
		0x767c,
		0xdba1
		},
		{
		0x767d,
		0xdbdc
		},
		{
		0x767e,
		0xdbdd
		},
		{
		0x7684,
		0xeedc
		},
		{
		0x7686,
		0xcbcb
		},
		{
		0x7687,
		0xfcd5
		},
		{
		0x768e,
		0xceeb
		},
		{
		0x7690,
		0xcdc1
		},
		{
		0x7693,
		0xfbd3
		},
		{
		0x76ae,
		0xf9ab
		},
		{
		0x76ba,
		0xf5d4
		},
		{
		0x76bf,
		0xd9a9
		},
		{
		0x76c2,
		0xe9dd
		},
		{
		0x76c3,
		0xdbcd
		},
		{
		0x76c6,
		0xddce
		},
		{
		0x76c8,
		0xe7c3
		},
		{
		0x76ca,
		0xeccc
		},
		{
		0x76d2,
		0xf9ec
		},
		{
		0x76d6,
		0xcbcc
		},
		{
		0x76db,
		0xe0fc
		},
		{
		0x76dc,
		0xd4a8
		},
		{
		0x76de,
		0xedd3
		},
		{
		0x76df,
		0xd8ef
		},
		{
		0x76e1,
		0xf2d7
		},
		{
		0x76e3,
		0xcaf8
		},
		{
		0x76e4,
		0xdaef
		},
		{
		0x76e7,
		0xd6d4
		},
		{
		0x76ee,
		0xd9cd
		},
		{
		0x76f2,
		0xd8ee
		},
		{
		0x76f4,
		0xf2c1
		},
		{
		0x76f8,
		0xdfd3
		},
		{
		0x76fc,
		0xdaf0
		},
		{
		0x76fe,
		0xe2ea
		},
		{
		0x7701,
		0xe0fd
		},
		{
		0x7704,
		0xd8f8
		},
		{
		0x7708,
		0xf7af
		},
		{
		0x7709,
		0xdab6
		},
		{
		0x770b,
		0xcad7
		},
		{
		0x771e,
		0xf2d8
		},
		{
		0x7720,
		0xd8f9
		},
		{
		0x7729,
		0xfadf
		},
		{
		0x7737,
		0xcfef
		},
		{
		0x7738,
		0xd9c2
		},
		{
		0x773a,
		0xf0d2
		},
		{
		0x773c,
		0xe4d1
		},
		{
		0x7740,
		0xf3b7
		},
		{
		0x774d,
		0xfae0
		},
		{
		0x775b,
		0xefec
		},
		{
		0x7761,
		0xe2b2
		},
		{
		0x7763,
		0xd4bd
		},
		{
		0x7766,
		0xd9ce
		},
		{
		0x776b,
		0xf4e2
		},
		{
		0x7779,
		0xd4a9
		},
		{
		0x777e,
		0xcdc2
		},
		{
		0x777f,
		0xe7da
		},
		{
		0x778b,
		0xf2d9
		},
		{
		0x7791,
		0xd9aa
		},
		{
		0x779e,
		0xd8be
		},
		{
		0x77a5,
		0xdcad
		},
		{
		0x77ac,
		0xe2eb
		},
		{
		0x77ad,
		0xd6fc
		},
		{
		0x77b0,
		0xcaf9
		},
		{
		0x77b3,
		0xd4da
		},
		{
		0x77bb,
		0xf4d7
		},
		{
		0x77bc,
		0xcca1
		},
		{
		0x77bf,
		0xcfba
		},
		{
		0x77d7,
		0xf5b8
		},
		{
		0x77db,
		0xd9c3
		},
		{
		0x77dc,
		0xd0e8
		},
		{
		0x77e2,
		0xe3c5
		},
		{
		0x77e3,
		0xebf8
		},
		{
		0x77e5,
		0xf2b1
		},
		{
		0x77e9,
		0xcfbb
		},
		{
		0x77ed,
		0xd3ad
		},
		{
		0x77ee,
		0xe8e1
		},
		{
		0x77ef,
		0xceec
		},
		{
		0x77f3,
		0xe0b4
		},
		{
		0x7802,
		0xdee3
		},
		{
		0x7812,
		0xddf7
		},
		{
		0x7825,
		0xf2b2
		},
		{
		0x7826,
		0xf3f6
		},
		{
		0x7827,
		0xf6db
		},
		{
		0x782c,
		0xd7fe
		},
		{
		0x7832,
		0xf8df
		},
		{
		0x7834,
		0xf7f2
		},
		{
		0x7845,
		0xd0a9
		},
		{
		0x784f,
		0xe6da
		},
		{
		0x785d,
		0xf5a6
		},
		{
		0x786b,
		0xd7bc
		},
		{
		0x786c,
		0xcce3
		},
		{
		0x786f,
		0xe6db
		},
		{
		0x787c,
		0xdddd
		},
		{
		0x7881,
		0xd1b3
		},
		{
		0x7887,
		0xefed
		},
		{
		0x788c,
		0xd6de
		},
		{
		0x788d,
		0xe4f4
		},
		{
		0x788e,
		0xe1ef
		},
		{
		0x7891,
		0xddf8
		},
		{
		0x7897,
		0xe8cf
		},
		{
		0x78a3,
		0xcae5
		},
		{
		0x78a7,
		0xdca1
		},
		{
		0x78a9,
		0xe0b5
		},
		{
		0x78ba,
		0xfcac
		},
		{
		0x78bb,
		0xfcad
		},
		{
		0x78bc,
		0xd8a7
		},
		{
		0x78c1,
		0xedb8
		},
		{
		0x78c5,
		0xdbb6
		},
		{
		0x78ca,
		0xd6f0
		},
		{
		0x78cb,
		0xf3af
		},
		{
		0x78ce,
		0xcda5
		},
		{
		0x78d0,
		0xdaf1
		},
		{
		0x78e8,
		0xd8a8
		},
		{
		0x78ec,
		0xcce4
		},
		{
		0x78ef,
		0xd1b4
		},
		{
		0x78f5,
		0xcad8
		},
		{
		0x78fb,
		0xdaf2
		},
		{
		0x7901,
		0xf5a7
		},
		{
		0x790e,
		0xf5a8
		},
		{
		0x7916,
		0xe6a6
		},
		{
		0x792a,
		0xd5ec
		},
		{
		0x792b,
		0xd5f8
		},
		{
		0x792c,
		0xdaf3
		},
		{
		0x793a,
		0xe3c6
		},
		{
		0x793e,
		0xdee4
		},
		{
		0x7940,
		0xdee5
		},
		{
		0x7941,
		0xd1b5
		},
		{
		0x7947,
		0xd1b6
		},
		{
		0x7948,
		0xd1b7
		},
		{
		0x7949,
		0xf2b3
		},
		{
		0x7950,
		0xe9de
		},
		{
		0x7956,
		0xf0d3
		},
		{
		0x7957,
		0xf2b4
		},
		{
		0x7960,
		0xdee6
		},
		{
		0x7965,
		0xdfd4
		},
		{
		0x7968,
		0xf8f9
		},
		{
		0x796d,
		0xf0ae
		},
		{
		0x797a,
		0xd1b8
		},
		{
		0x797f,
		0xd6df
		},
		{
		0x7981,
		0xd0d7
		},
		{
		0x798d,
		0xfca1
		},
		{
		0x798e,
		0xefee
		},
		{
		0x798f,
		0xdcd8
		},
		{
		0x7991,
		0xe9df
		},
		{
		0x79a6,
		0xe5dd
		},
		{
		0x79a7,
		0xfdfb
		},
		{
		0x79aa,
		0xe0c9
		},
		{
		0x79ae,
		0xd6c9
		},
		{
		0x79b1,
		0xd4aa
		},
		{
		0x79b3,
		0xe5cc
		},
		{
		0x79b9,
		0xe9e0
		},
		{
		0x79c9,
		0xdcbc
		},
		{
		0x79ca,
		0xd2b6
		},
		{
		0x79cb,
		0xf5d5
		},
		{
		0x79d1,
		0xcea1
		},
		{
		0x79d2,
		0xf5a9
		},
		{
		0x79d5,
		0xddf9
		},
		{
		0x79d8,
		0xddfa
		},
		{
		0x79df,
		0xf0d5
		},
		{
		0x79e4,
		0xf6df
		},
		{
		0x79e6,
		0xf2da
		},
		{
		0x79e7,
		0xe4eb
		},
		{
		0x79e9,
		0xf2f1
		},
		{
		0x79fb,
		0xecb9
		},
		{
		0x7a00,
		0xfdfc
		},
		{
		0x7a05,
		0xe1aa
		},
		{
		0x7a08,
		0xcad9
		},
		{
		0x7a0b,
		0xefef
		},
		{
		0x7a0d,
		0xf5aa
		},
		{
		0x7a14,
		0xecf9
		},
		{
		0x7a17,
		0xf8ad
		},
		{
		0x7a19,
		0xf2c2
		},
		{
		0x7a1a,
		0xf6c3
		},
		{
		0x7a1c,
		0xd7d2
		},
		{
		0x7a1f,
		0xf9a2
		},
		{
		0x7a20,
		0xf0d6
		},
		{
		0x7a2e,
		0xf0fa
		},
		{
		0x7a31,
		0xf6e0
		},
		{
		0x7a36,
		0xe9f3
		},
		{
		0x7a37,
		0xf2c3
		},
		{
		0x7a3b,
		0xd4ab
		},
		{
		0x7a3c,
		0xcab3
		},
		{
		0x7a3d,
		0xcda6
		},
		{
		0x7a3f,
		0xcdc3
		},
		{
		0x7a40,
		0xcdda
		},
		{
		0x7a46,
		0xd9cf
		},
		{
		0x7a49,
		0xf6c4
		},
		{
		0x7a4d,
		0xeedd
		},
		{
		0x7a4e,
		0xe7c4
		},
		{
		0x7a57,
		0xe2b4
		},
		{
		0x7a61,
		0xdfe2
		},
		{
		0x7a62,
		0xe7db
		},
		{
		0x7a69,
		0xe8b1
		},
		{
		0x7a6b,
		0xfcae
		},
		{
		0x7a70,
		0xe5cd
		},
		{
		0x7a74,
		0xfaeb
		},
		{
		0x7a76,
		0xcfbc
		},
		{
		0x7a79,
		0xcfe2
		},
		{
		0x7a7a,
		0xcdf6
		},
		{
		0x7a7d,
		0xeff0
		},
		{
		0x7a7f,
		0xf4be
		},
		{
		0x7a81,
		0xd4cd
		},
		{
		0x7a84,
		0xf3b8
		},
		{
		0x7a88,
		0xe9a1
		},
		{
		0x7a92,
		0xf2f2
		},
		{
		0x7a93,
		0xf3eb
		},
		{
		0x7a95,
		0xf0d7
		},
		{
		0x7a98,
		0xcfd7
		},
		{
		0x7a9f,
		0xcfdf
		},
		{
		0x7aa9,
		0xe8c0
		},
		{
		0x7aaa,
		0xe8c1
		},
		{
		0x7aae,
		0xcfe3
		},
		{
		0x7aaf,
		0xe9a2
		},
		{
		0x7aba,
		0xd0aa
		},
		{
		0x7ac4,
		0xf3c1
		},
		{
		0x7ac5,
		0xd0ab
		},
		{
		0x7ac7,
		0xd4e4
		},
		{
		0x7aca,
		0xefbc
		},
		{
		0x7acb,
		0xd8a1
		},
		{
		0x7ad7,
		0xd9df
		},
		{
		0x7ad9,
		0xf3d7
		},
		{
		0x7add,
		0xdcbd
		},
		{
		0x7adf,
		0xcce5
		},
		{
		0x7ae0,
		0xedf1
		},
		{
		0x7ae3,
		0xf1e2
		},
		{
		0x7ae5,
		0xd4db
		},
		{
		0x7aea,
		0xe2b5
		},
		{
		0x7aed,
		0xcae6
		},
		{
		0x7aef,
		0xd3ae
		},
		{
		0x7af6,
		0xcce6
		},
		{
		0x7af9,
		0xf1d3
		},
		{
		0x7afa,
		0xf5e7
		},
		{
		0x7aff,
		0xcada
		},
		{
		0x7b0f,
		0xfbee
		},
		{
		0x7b11,
		0xe1c5
		},
		{
		0x7b19,
		0xdfe9
		},
		{
		0x7b1b,
		0xeede
		},
		{
		0x7b1e,
		0xf7c2
		},
		{
		0x7b20,
		0xd8a2
		},
		{
		0x7b26,
		0xddac
		},
		{
		0x7b2c,
		0xf0af
		},
		{
		0x7b2d,
		0xd6bd
		},
		{
		0x7b39,
		0xe1ab
		},
		{
		0x7b46,
		0xf9b6
		},
		{
		0x7b49,
		0xd4f5
		},
		{
		0x7b4b,
		0xd0c9
		},
		{
		0x7b4c,
		0xefa7
		},
		{
		0x7b4d,
		0xe2ec
		},
		{
		0x7b4f,
		0xdbea
		},
		{
		0x7b50,
		0xcecc
		},
		{
		0x7b51,
		0xf5e8
		},
		{
		0x7b52,
		0xf7d5
		},
		{
		0x7b54,
		0xd3cd
		},
		{
		0x7b56,
		0xf3fe
		},
		{
		0x7b60,
		0xd0b5
		},
		{
		0x7b6c,
		0xe0fe
		},
		{
		0x7b6e,
		0xdffb
		},
		{
		0x7b75,
		0xe6dd
		},
		{
		0x7b7d,
		0xe8a4
		},
		{
		0x7b87,
		0xcbcd
		},
		{
		0x7b8b,
		0xefa8
		},
		{
		0x7b8f,
		0xeeb4
		},
		{
		0x7b94,
		0xdad8
		},
		{
		0x7b95,
		0xd1b9
		},
		{
		0x7b97,
		0xdfa9
		},
		{
		0x7b9a,
		0xf3b0
		},
		{
		0x7b9d,
		0xccc4
		},
		{
		0x7ba1,
		0xceb7
		},
		{
		0x7bad,
		0xefa9
		},
		{
		0x7bb1,
		0xdfd5
		},
		{
		0x7bb4,
		0xedd7
		},
		{
		0x7bb8,
		0xeec6
		},
		{
		0x7bc0,
		0xefbd
		},
		{
		0x7bc1,
		0xfcd6
		},
		{
		0x7bc4,
		0xdbf4
		},
		{
		0x7bc6,
		0xefaa
		},
		{
		0x7bc7,
		0xf8b9
		},
		{
		0x7bc9,
		0xf5e9
		},
		{
		0x7bd2,
		0xe3d9
		},
		{
		0x7be0,
		0xe1c6
		},
		{
		0x7be4,
		0xd4bf
		},
		{
		0x7be9,
		0xdee8
		},
		{
		0x7c07,
		0xf0ea
		},
		{
		0x7c12,
		0xf3c2
		},
		{
		0x7c1e,
		0xd3af
		},
		{
		0x7c21,
		0xcadb
		},
		{
		0x7c27,
		0xfcd7
		},
		{
		0x7c2a,
		0xedd8
		},
		{
		0x7c2b,
		0xe1c7
		},
		{
		0x7c3d,
		0xf4d8
		},
		{
		0x7c3e,
		0xd6b3
		},
		{
		0x7c3f,
		0xddad
		},
		{
		0x7c43,
		0xd5be
		},
		{
		0x7c4c,
		0xf1c3
		},
		{
		0x7c4d,
		0xeedf
		},
		{
		0x7c60,
		0xd6eb
		},
		{
		0x7c64,
		0xf4d9
		},
		{
		0x7c6c,
		0xd7e6
		},
		{
		0x7c73,
		0xdab7
		},
		{
		0x7c83,
		0xddfb
		},
		{
		0x7c89,
		0xddcf
		},
		{
		0x7c92,
		0xd8a3
		},
		{
		0x7c95,
		0xdad9
		},
		{
		0x7c97,
		0xf0d8
		},
		{
		0x7c98,
		0xefc4
		},
		{
		0x7c9f,
		0xe1d8
		},
		{
		0x7ca5,
		0xf1d4
		},
		{
		0x7ca7,
		0xedf2
		},
		{
		0x7cae,
		0xd5db
		},
		{
		0x7cb1,
		0xd5dc
		},
		{
		0x7cb2,
		0xf3c4
		},
		{
		0x7cb3,
		0xcbd7
		},
		{
		0x7cb9,
		0xe2b6
		},
		{
		0x7cbe,
		0xeff1
		},
		{
		0x7cca,
		0xfbd5
		},
		{
		0x7cd6,
		0xd3d8
		},
		{
		0x7cde,
		0xddd0
		},
		{
		0x7cdf,
		0xf0d9
		},
		{
		0x7ce0,
		0xcbb3
		},
		{
		0x7ce7,
		0xd5dd
		},
		{
		0x7cfb,
		0xcda7
		},
		{
		0x7cfe,
		0xd0ac
		},
		{
		0x7d00,
		0xd1ba
		},
		{
		0x7d02,
		0xf1c4
		},
		{
		0x7d0a,
		0xdaa2
		},
		{
		0x7d0b,
		0xdaa3
		},
		{
		0x7d0d,
		0xd2a1
		},
		{
		0x7d10,
		0xd2ef
		},
		{
		0x7d14,
		0xe2ed
		},
		{
		0x7d20,
		0xe1c8
		},
		{
		0x7d21,
		0xdbb7
		},
		{
		0x7d22,
		0xdfe3
		},
		{
		0x7d2b,
		0xedb9
		},
		{
		0x7d2c,
		0xf1c5
		},
		{
		0x7d2e,
		0xf3cf
		},
		{
		0x7d2f,
		0xd7ab
		},
		{
		0x7d30,
		0xe1ac
		},
		{
		0x7d33,
		0xe3eb
		},
		{
		0x7d35,
		0xeec7
		},
		{
		0x7d39,
		0xe1c9
		},
		{
		0x7d3a,
		0xcafa
		},
		{
		0x7d50,
		0xccbf
		},
		{
		0x7d5e,
		0xceed
		},
		{
		0x7d61,
		0xd5a9
		},
		{
		0x7d62,
		0xfae2
		},
		{
		0x7d66,
		0xd0e5
		},
		{
		0x7d68,
		0xebd6
		},
		{
		0x7d6a,
		0xecdf
		},
		{
		0x7d6e,
		0xdffc
		},
		{
		0x7d71,
		0xf7d6
		},
		{
		0x7d72,
		0xdeea
		},
		{
		0x7d73,
		0xcbb4
		},
		{
		0x7d76,
		0xefbe
		},
		{
		0x7d79,
		0xccb5
		},
		{
		0x7d7f,
		0xcfbd
		},
		{
		0x7d8e,
		0xeff2
		},
		{
		0x7d8f,
		0xe2b7
		},
		{
		0x7d93,
		0xcce8
		},
		{
		0x7d9c,
		0xf0fc
		},
		{
		0x7da0,
		0xd6e0
		},
		{
		0x7da2,
		0xf1c6
		},
		{
		0x7dac,
		0xe2b8
		},
		{
		0x7dad,
		0xebab
		},
		{
		0x7db1,
		0xcbb5
		},
		{
		0x7db2,
		0xd8d1
		},
		{
		0x7db4,
		0xf4ce
		},
		{
		0x7db5,
		0xf3f7
		},
		{
		0x7db8,
		0xd7c6
		},
		{
		0x7dba,
		0xd1bb
		},
		{
		0x7dbb,
		0xf7aa
		},
		{
		0x7dbd,
		0xedca
		},
		{
		0x7dbe,
		0xd7d3
		},
		{
		0x7dbf,
		0xd8fa
		},
		{
		0x7dc7,
		0xf6c5
		},
		{
		0x7dca,
		0xd1cc
		},
		{
		0x7dcb,
		0xddfc
		},
		{
		0x7dd6,
		0xdffd
		},
		{
		0x7dd8,
		0xf9e5
		},
		{
		0x7dda,
		0xe0ca
		},
		{
		0x7ddd,
		0xf2fd
		},
		{
		0x7dde,
		0xd3b0
		},
		{
		0x7de0,
		0xf4f3
		},
		{
		0x7de1,
		0xdac9
		},
		{
		0x7de3,
		0xe6de
		},
		{
		0x7de8,
		0xf8ba
		},
		{
		0x7de9,
		0xe8d0
		},
		{
		0x7dec,
		0xd8fb
		},
		{
		0x7def,
		0xead5
		},
		{
		0x7df4,
		0xd6a3
		},
		{
		0x7dfb,
		0xf6c6
		},
		{
		0x7e09,
		0xf2db
		},
		{
		0x7e0a,
		0xe4fc
		},
		{
		0x7e15,
		0xe8b2
		},
		{
		0x7e1b,
		0xdada
		},
		{
		0x7e1d,
		0xf2dc
		},
		{
		0x7e1e,
		0xfbd6
		},
		{
		0x7e1f,
		0xe9b2
		},
		{
		0x7e21,
		0xeead
		},
		{
		0x7e23,
		0xfae3
		},
		{
		0x7e2b,
		0xdcee
		},
		{
		0x7e2e,
		0xf5ea
		},
		{
		0x7e2f,
		0xe6e0
		},
		{
		0x7e31,
		0xf0fd
		},
		{
		0x7e37,
		0xd7ac
		},
		{
		0x7e3d,
		0xf5c5
		},
		{
		0x7e3e,
		0xeee0
		},
		{
		0x7e41,
		0xdbe5
		},
		{
		0x7e43,
		0xddde
		},
		{
		0x7e46,
		0xd9f0
		},
		{
		0x7e47,
		0xe9a3
		},
		{
		0x7e52,
		0xf1f9
		},
		{
		0x7e54,
		0xf2c4
		},
		{
		0x7e55,
		0xe0cb
		},
		{
		0x7e5e,
		0xe9a4
		},
		{
		0x7e61,
		0xe2b9
		},
		{
		0x7e69,
		0xe3b1
		},
		{
		0x7e6a,
		0xfceb
		},
		{
		0x7e6b,
		0xcda8
		},
		{
		0x7e6d,
		0xccb6
		},
		{
		0x7e70,
		0xf0db
		},
		{
		0x7e79,
		0xe6ba
		},
		{
		0x7e7c,
		0xcda9
		},
		{
		0x7e82,
		0xf3c3
		},
		{
		0x7e8c,
		0xe1d9
		},
		{
		0x7e8f,
		0xefab
		},
		{
		0x7e93,
		0xe7c5
		},
		{
		0x7e96,
		0xe0e9
		},
		{
		0x7e98,
		0xf3c5
		},
		{
		0x7e9b,
		0xd4c0
		},
		{
		0x7e9c,
		0xd5bf
		},
		{
		0x7f36,
		0xddae
		},
		{
		0x7f38,
		0xf9fc
		},
		{
		0x7f3a,
		0xccc0
		},
		{
		0x7f4c,
		0xe5a2
		},
		{
		0x7f50,
		0xceb8
		},
		{
		0x7f54,
		0xd8d2
		},
		{
		0x7f55,
		0xf9d6
		},
		{
		0x7f6a,
		0xf1aa
		},
		{
		0x7f6b,
		0xced1
		},
		{
		0x7f6e,
		0xf6c7
		},
		{
		0x7f70,
		0xdbeb
		},
		{
		0x7f72,
		0xdffe
		},
		{
		0x7f75,
		0xd8e1
		},
		{
		0x7f77,
		0xf7f3
		},
		{
		0x7f79,
		0xd7e7
		},
		{
		0x7f85,
		0xd4fe
		},
		{
		0x7f88,
		0xd1bc
		},
		{
		0x7f8a,
		0xe5cf
		},
		{
		0x7f8c,
		0xcbb6
		},
		{
		0x7f8e,
		0xdab8
		},
		{
		0x7f94,
		0xcdc4
		},
		{
		0x7f9a,
		0xd6be
		},
		{
		0x7f9e,
		0xe2ba
		},
		{
		0x7fa4,
		0xcfd8
		},
		{
		0x7fa8,
		0xe0cc
		},
		{
		0x7fa9,
		0xebf9
		},
		{
		0x7fb2,
		0xfdfd
		},
		{
		0x7fb8,
		0xd7e8
		},
		{
		0x7fb9,
		0xcbd8
		},
		{
		0x7fbd,
		0xe9e2
		},
		{
		0x7fc1,
		0xe8ba
		},
		{
		0x7fc5,
		0xe3c7
		},
		{
		0x7fca,
		0xeccd
		},
		{
		0x7fcc,
		0xecce
		},
		{
		0x7fce,
		0xd6bf
		},
		{
		0x7fd2,
		0xe3a7
		},
		{
		0x7fd4,
		0xdfd6
		},
		{
		0x7fd5,
		0xfde8
		},
		{
		0x7fdf,
		0xeee1
		},
		{
		0x7fe0,
		0xf6a8
		},
		{
		0x7fe1,
		0xddfd
		},
		{
		0x7fe9,
		0xf8bb
		},
		{
		0x7feb,
		0xe8d1
		},
		{
		0x7ff0,
		0xf9d7
		},
		{
		0x7ff9,
		0xceee
		},
		{
		0x7ffc,
		0xeccf
		},
		{
		0x8000,
		0xe9a5
		},
		{
		0x8001,
		0xd6d5
		},
		{
		0x8003,
		0xcdc5
		},
		{
		0x8005,
		0xedba
		},
		{
		0x8006,
		0xd1bd
		},
		{
		0x8009,
		0xcfbe
		},
		{
		0x800c,
		0xecbb
		},
		{
		0x8010,
		0xd2b1
		},
		{
		0x8015,
		0xcce9
		},
		{
		0x8017,
		0xd9c4
		},
		{
		0x8018,
		0xe9fc
		},
		{
		0x802d,
		0xd1be
		},
		{
		0x8033,
		0xecbc
		},
		{
		0x8036,
		0xe5ad
		},
		{
		0x803d,
		0xf7b0
		},
		{
		0x803f,
		0xccea
		},
		{
		0x8043,
		0xd3c4
		},
		{
		0x8046,
		0xd6c0
		},
		{
		0x804a,
		0xd6fd
		},
		{
		0x8056,
		0xe1a1
		},
		{
		0x8058,
		0xdebd
		},
		{
		0x805a,
		0xf6a9
		},
		{
		0x805e,
		0xdaa4
		},
		{
		0x806f,
		0xd6a4
		},
		{
		0x8070,
		0xf5c6
		},
		{
		0x8072,
		0xe1a2
		},
		{
		0x8073,
		0xe9c6
		},
		{
		0x8077,
		0xf2c5
		},
		{
		0x807d,
		0xf4e9
		},
		{
		0x807e,
		0xd6ec
		},
		{
		0x807f,
		0xebd3
		},
		{
		0x8084,
		0xecbd
		},
		{
		0x8085,
		0xe2dc
		},
		{
		0x8086,
		0xdeeb
		},
		{
		0x8087,
		0xf0dc
		},
		{
		0x8089,
		0xebbf
		},
		{
		0x808b,
		0xd7ce
		},
		{
		0x808c,
		0xd1bf
		},
		{
		0x8096,
		0xf5ab
		},
		{
		0x809b,
		0xf9fd
		},
		{
		0x809d,
		0xcadc
		},
		{
		0x80a1,
		0xcdc6
		},
		{
		0x80a2,
		0xf2b6
		},
		{
		0x80a5,
		0xddfe
		},
		{
		0x80a9,
		0xccb7
		},
		{
		0x80aa,
		0xdbb8
		},
		{
		0x80af,
		0xd0e9
		},
		{
		0x80b1,
		0xcedd
		},
		{
		0x80b2,
		0xebc0
		},
		{
		0x80b4,
		0xfda2
		},
		{
		0x80ba,
		0xf8cb
		},
		{
		0x80c3,
		0xead6
		},
		{
		0x80c4,
		0xf1b0
		},
		{
		0x80cc,
		0xdbce
		},
		{
		0x80ce,
		0xf7c3
		},
		{
		0x80da,
		0xdbcf
		},
		{
		0x80db,
		0xcba4
		},
		{
		0x80de,
		0xf8e0
		},
		{
		0x80e1,
		0xfbd7
		},
		{
		0x80e4,
		0xebca
		},
		{
		0x80e5,
		0xe0a1
		},
		{
		0x80f1,
		0xcecd
		},
		{
		0x80f4,
		0xd4dc
		},
		{
		0x80f8,
		0xfdd8
		},
		{
		0x80fd,
		0xd2f6
		},
		{
		0x8102,
		0xf2b7
		},
		{
		0x8105,
		0xfaf6
		},
		{
		0x8106,
		0xf6aa
		},
		{
		0x8107,
		0xfaf7
		},
		{
		0x8108,
		0xd8e6
		},
		{
		0x810a,
		0xf4b1
		},
		{
		0x8118,
		0xe8d2
		},
		{
		0x811a,
		0xcac5
		},
		{
		0x811b,
		0xcceb
		},
		{
		0x8123,
		0xe2ee
		},
		{
		0x8129,
		0xe2bb
		},
		{
		0x812b,
		0xf7ad
		},
		{
		0x812f,
		0xf8e1
		},
		{
		0x8139,
		0xf3ec
		},
		{
		0x813e,
		0xdea1
		},
		{
		0x814b,
		0xe4fd
		},
		{
		0x814e,
		0xe3ec
		},
		{
		0x8150,
		0xddaf
		},
		{
		0x8151,
		0xddb0
		},
		{
		0x8154,
		0xcbb7
		},
		{
		0x8155,
		0xe8d3
		},
		{
		0x8165,
		0xe1a3
		},
		{
		0x8166,
		0xd2e0
		},
		{
		0x816b,
		0xf0fe
		},
		{
		0x8170,
		0xe9a6
		},
		{
		0x8171,
		0xcbf2
		},
		{
		0x8178,
		0xedf3
		},
		{
		0x8179,
		0xdcd9
		},
		{
		0x817a,
		0xe0cd
		},
		{
		0x817f,
		0xf7da
		},
		{
		0x8180,
		0xdbb9
		},
		{
		0x8188,
		0xccae
		},
		{
		0x818a,
		0xdadb
		},
		{
		0x818f,
		0xcdc7
		},
		{
		0x819a,
		0xddb1
		},
		{
		0x819c,
		0xd8af
		},
		{
		0x819d,
		0xe3a3
		},
		{
		0x81a0,
		0xceef
		},
		{
		0x81a3,
		0xf2f3
		},
		{
		0x81a8,
		0xf8b3
		},
		{
		0x81b3,
		0xe0ce
		},
		{
		0x81b5,
		0xf5fd
		},
		{
		0x81ba,
		0xebec
		},
		{
		0x81bd,
		0xd3c5
		},
		{
		0x81be,
		0xfcec
		},
		{
		0x81bf,
		0xd2db
		},
		{
		0x81c0,
		0xd4eb
		},
		{
		0x81c2,
		0xdea2
		},
		{
		0x81c6,
		0xe5e6
		},
		{
		0x81cd,
		0xf0b0
		},
		{
		0x81d8,
		0xd5c4
		},
		{
		0x81df,
		0xedf4
		},
		{
		0x81e3,
		0xe3ed
		},
		{
		0x81e5,
		0xe8c2
		},
		{
		0x81e7,
		0xedf5
		},
		{
		0x81e8,
		0xd7fc
		},
		{
		0x81ea,
		0xedbb
		},
		{
		0x81ed,
		0xf6ab
		},
		{
		0x81f3,
		0xf2b8
		},
		{
		0x81f4,
		0xf6c8
		},
		{
		0x81fa,
		0xd3e6
		},
		{
		0x81fb,
		0xf2dd
		},
		{
		0x81fc,
		0xcfbf
		},
		{
		0x81fe,
		0xebac
		},
		{
		0x8205,
		0xcfc0
		},
		{
		0x8207,
		0xe6a8
		},
		{
		0x8208,
		0xfde9
		},
		{
		0x820a,
		0xcfc1
		},
		{
		0x820c,
		0xe0df
		},
		{
		0x820d,
		0xdeec
		},
		{
		0x8212,
		0xe0a2
		},
		{
		0x821b,
		0xf4bf
		},
		{
		0x821c,
		0xe2ef
		},
		{
		0x821e,
		0xd9f1
		},
		{
		0x821f,
		0xf1c7
		},
		{
		0x8221,
		0xcbb8
		},
		{
		0x822a,
		0xf9fe
		},
		{
		0x822b,
		0xdbba
		},
		{
		0x822c,
		0xdaf5
		},
		{
		0x8235,
		0xf6ec
		},
		{
		0x8236,
		0xdadc
		},
		{
		0x8237,
		0xfae4
		},
		{
		0x8239,
		0xe0cf
		},
		{
		0x8240,
		0xddb2
		},
		{
		0x8245,
		0xe6a9
		},
		{
		0x8247,
		0xeff3
		},
		{
		0x8259,
		0xf3ed
		},
		{
		0x8264,
		0xebfa
		},
		{
		0x8266,
		0xf9e6
		},
		{
		0x826e,
		0xcadd
		},
		{
		0x826f,
		0xd5de
		},
		{
		0x8271,
		0xcade
		},
		{
		0x8272,
		0xdfe4
		},
		{
		0x8276,
		0xe6fd
		},
		{
		0x8278,
		0xf5ac
		},
		{
		0x827e,
		0xe4f5
		},
		{
		0x828b,
		0xe9e3
		},
		{
		0x828d,
		0xedcb
		},
		{
		0x828e,
		0xcfe4
		},
		{
		0x8292,
		0xd8d3
		},
		{
		0x8299,
		0xddb3
		},
		{
		0x829a,
		0xd4ec
		},
		{
		0x829d,
		0xf2b9
		},
		{
		0x829f,
		0xdfb7
		},
		{
		0x82a5,
		0xcbce
		},
		{
		0x82a6,
		0xfbd8
		},
		{
		0x82a9,
		0xd0d9
		},
		{
		0x82ac,
		0xddd2
		},
		{
		0x82ad,
		0xf7f4
		},
		{
		0x82ae,
		0xe7dc
		},
		{
		0x82af,
		0xe4a5
		},
		{
		0x82b1,
		0xfca3
		},
		{
		0x82b3,
		0xdbbb
		},
		{
		0x82b7,
		0xf2ba
		},
		{
		0x82b8,
		0xe9fd
		},
		{
		0x82b9,
		0xd0ca
		},
		{
		0x82bb,
		0xf5d6
		},
		{
		0x82bc,
		0xd9c5
		},
		{
		0x82bd,
		0xe4b4
		},
		{
		0x82bf,
		0xeda7
		},
		{
		0x82d1,
		0xeabd
		},
		{
		0x82d2,
		0xe6fe
		},
		{
		0x82d4,
		0xf7c4
		},
		{
		0x82d5,
		0xf5ad
		},
		{
		0x82d7,
		0xd9e0
		},
		{
		0x82db,
		0xcab4
		},
		{
		0x82de,
		0xf8e2
		},
		{
		0x82df,
		0xcfc2
		},
		{
		0x82e1,
		0xecbe
		},
		{
		0x82e5,
		0xe5b4
		},
		{
		0x82e6,
		0xcdc8
		},
		{
		0x82e7,
		0xeec8
		},
		{
		0x82f1,
		0xe7c8
		},
		{
		0x82fd,
		0xcdc9
		},
		{
		0x82fe,
		0xf9b7
		},
		{
		0x8309,
		0xd8c9
		},
		{
		0x8317,
		0xd9ab
		},
		{
		0x8328,
		0xedbc
		},
		{
		0x832b,
		0xd8d4
		},
		{
		0x832f,
		0xdcda
		},
		{
		0x8331,
		0xe2bc
		},
		{
		0x8334,
		0xfced
		},
		{
		0x8335,
		0xece0
		},
		{
		0x8336,
		0xd2fe
		},
		{
		0x8338,
		0xe9c7
		},
		{
		0x8339,
		0xe6aa
		},
		{
		0x8340,
		0xe2f0
		},
		{
		0x8347,
		0xfabb
		},
		{
		0x8349,
		0xf5ae
		},
		{
		0x834a,
		0xfbaa
		},
		{
		0x834f,
		0xecfb
		},
		{
		0x8351,
		0xecbf
		},
		{
		0x8352,
		0xfcd8
		},
		{
		0x8373,
		0xd4e5
		},
		{
		0x8377,
		0xf9c3
		},
		{
		0x837b,
		0xeee2
		},
		{
		0x8389,
		0xd7e9
		},
		{
		0x838a,
		0xedf6
		},
		{
		0x838e,
		0xdeed
		},
		{
		0x8396,
		0xccec
		},
		{
		0x8398,
		0xe3ee
		},
		{
		0x839e,
		0xe8d4
		},
		{
		0x83a2,
		0xfaf8
		},
		{
		0x83a9,
		0xddb4
		},
		{
		0x83aa,
		0xe4b5
		},
		{
		0x83ab,
		0xd8b0
		},
		{
		0x83bd,
		0xd8d5
		},
		{
		0x83c1,
		0xf4ea
		},
		{
		0x83c5,
		0xceb9
		},
		{
		0x83c9,
		0xd6e1
		},
		{
		0x83ca,
		0xcfd2
		},
		{
		0x83cc,
		0xd0b6
		},
		{
		0x83d3,
		0xcea2
		},
		{
		0x83d6,
		0xf3ee
		},
		{
		0x83dc,
		0xf3f8
		},
		{
		0x83e9,
		0xdccc
		},
		{
		0x83eb,
		0xd0cb
		},
		{
		0x83ef,
		0xfca4
		},
		{
		0x83f0,
		0xcdca
		},
		{
		0x83f1,
		0xd7d4
		},
		{
		0x83f2,
		0xdea3
		},
		{
		0x83f4,
		0xe4e0
		},
		{
		0x83f9,
		0xeec9
		},
		{
		0x83fd,
		0xe2dd
		},
		{
		0x8403,
		0xf5fe
		},
		{
		0x8404,
		0xd4ac
		},
		{
		0x840a,
		0xd5d1
		},
		{
		0x840c,
		0xd8f0
		},
		{
		0x840d,
		0xf8c3
		},
		{
		0x840e,
		0xead7
		},
		{
		0x8429,
		0xf5d7
		},
		{
		0x842c,
		0xd8bf
		},
		{
		0x8431,
		0xfdc0
		},
		{
		0x8438,
		0xebad
		},
		{
		0x843d,
		0xd5aa
		},
		{
		0x8449,
		0xe7a8
		},
		{
		0x8457,
		0xeeca
		},
		{
		0x845b,
		0xcae7
		},
		{
		0x8461,
		0xf8e3
		},
		{
		0x8463,
		0xd4dd
		},
		{
		0x8466,
		0xead8
		},
		{
		0x846b,
		0xfbd9
		},
		{
		0x846c,
		0xedf7
		},
		{
		0x846f,
		0xe5b5
		},
		{
		0x8475,
		0xd0ad
		},
		{
		0x847a,
		0xf1f1
		},
		{
		0x8490,
		0xe2bd
		},
		{
		0x8494,
		0xe3c8
		},
		{
		0x8499,
		0xd9d5
		},
		{
		0x849c,
		0xdfaa
		},
		{
		0x84a1,
		0xdbbc
		},
		{
		0x84b2,
		0xf8e4
		},
		{
		0x84b8,
		0xf1fa
		},
		{
		0x84bb,
		0xe5b6
		},
		{
		0x84bc,
		0xf3ef
		},
		{
		0x84bf,
		0xfbda
		},
		{
		0x84c0,
		0xe1e0
		},
		{
		0x84c2,
		0xd9ac
		},
		{
		0x84c4,
		0xf5eb
		},
		{
		0x84c6,
		0xe0b6
		},
		{
		0x84c9,
		0xe9c8
		},
		{
		0x84cb,
		0xcbcf
		},
		{
		0x84cd,
		0xe3c9
		},
		{
		0x84d1,
		0xdeee
		},
		{
		0x84da,
		0xe2be
		},
		{
		0x84ec,
		0xdcef
		},
		{
		0x84ee,
		0xd6a5
		},
		{
		0x84f4,
		0xe2f1
		},
		{
		0x84fc,
		0xd6fe
		},
		{
		0x8511,
		0xd9a1
		},
		{
		0x8513,
		0xd8c0
		},
		{
		0x8514,
		0xdcdb
		},
		{
		0x8517,
		0xedbd
		},
		{
		0x8518,
		0xdfb8
		},
		{
		0x851a,
		0xeaa5
		},
		{
		0x851e,
		0xd7ad
		},
		{
		0x8521,
		0xf3f9
		},
		{
		0x8523,
		0xedf8
		},
		{
		0x8525,
		0xf5c7
		},
		{
		0x852c,
		0xe1ca
		},
		{
		0x852d,
		0xebe3
		},
		{
		0x852f,
		0xf2de
		},
		{
		0x853d,
		0xf8cc
		},
		{
		0x853f,
		0xead9
		},
		{
		0x8541,
		0xd3c6
		},
		{
		0x8543,
		0xdbe6
		},
		{
		0x8549,
		0xf5af
		},
		{
		0x854e,
		0xcef0
		},
		{
		0x8553,
		0xe9fe
		},
		{
		0x8559,
		0xfbb6
		},
		{
		0x8563,
		0xe2f2
		},
		{
		0x8568,
		0xcff2
		},
		{
		0x8569,
		0xf7b9
		},
		{
		0x856a,
		0xd9f3
		},
		{
		0x856d,
		0xe1cb
		},
		{
		0x8584,
		0xdadd
		},
		{
		0x8587,
		0xdab9
		},
		{
		0x858f,
		0xebfb
		},
		{
		0x8591,
		0xcbb9
		},
		{
		0x8594,
		0xedf9
		},
		{
		0x859b,
		0xe0e0
		},
		{
		0x85a6,
		0xf4c0
		},
		{
		0x85a8,
		0xfdbc
		},
		{
		0x85a9,
		0xdfb1
		},
		{
		0x85aa,
		0xe3ef
		},
		{
		0x85af,
		0xe0a3
		},
		{
		0x85b0,
		0xfdb9
		},
		{
		0x85ba,
		0xf0b1
		},
		{
		0x85c1,
		0xcdcb
		},
		{
		0x85c9,
		0xedbe
		},
		{
		0x85cd,
		0xd5c0
		},
		{
		0x85ce,
		0xe3f0
		},
		{
		0x85cf,
		0xedfa
		},
		{
		0x85d5,
		0xe9e4
		},
		{
		0x85dc,
		0xd5ed
		},
		{
		0x85dd,
		0xe7dd
		},
		{
		0x85e4,
		0xd4f6
		},
		{
		0x85e5,
		0xe5b7
		},
		{
		0x85e9,
		0xdbe7
		},
		{
		0x85ea,
		0xe2bf
		},
		{
		0x85f7,
		0xeecb
		},
		{
		0x85fa,
		0xd7f4
		},
		{
		0x85fb,
		0xf0dd
		},
		{
		0x85ff,
		0xceab
		},
		{
		0x8602,
		0xe7de
		},
		{
		0x8606,
		0xd6d6
		},
		{
		0x8607,
		0xe1cc
		},
		{
		0x860a,
		0xe8b3
		},
		{
		0x8616,
		0xe5ee
		},
		{
		0x8617,
		0xdca2
		},
		{
		0x861a,
		0xe0d0
		},
		{
		0x862d,
		0xd5b5
		},
		{
		0x863f,
		0xd5a1
		},
		{
		0x864e,
		0xfbdb
		},
		{
		0x8650,
		0xf9cb
		},
		{
		0x8654,
		0xcbf3
		},
		{
		0x8655,
		0xf4a5
		},
		{
		0x865b,
		0xfac8
		},
		{
		0x865c,
		0xd6d7
		},
		{
		0x865e,
		0xe9e5
		},
		{
		0x865f,
		0xfbdc
		},
		{
		0x8667,
		0xfdd0
		},
		{
		0x8679,
		0xfbf6
		},
		{
		0x868a,
		0xdaa5
		},
		{
		0x868c,
		0xdbbd
		},
		{
		0x8693,
		0xece2
		},
		{
		0x86a3,
		0xcdf7
		},
		{
		0x86a4,
		0xf0de
		},
		{
		0x86a9,
		0xf6c9
		},
		{
		0x86c7,
		0xdeef
		},
		{
		0x86cb,
		0xd3b1
		},
		{
		0x86d4,
		0xfcee
		},
		{
		0x86d9,
		0xe8c3
		},
		{
		0x86db,
		0xf1c8
		},
		{
		0x86df,
		0xcef1
		},
		{
		0x86e4,
		0xf9ed
		},
		{
		0x86ed,
		0xf2f4
		},
		{
		0x86fe,
		0xe4b6
		},
		{
		0x8700,
		0xf5b9
		},
		{
		0x8702,
		0xdcf0
		},
		{
		0x8703,
		0xe3f1
		},
		{
		0x8708,
		0xe8a5
		},
		{
		0x8718,
		0xf2bb
		},
		{
		0x871a,
		0xdea4
		},
		{
		0x871c,
		0xdacc
		},
		{
		0x874e,
		0xcae9
		},
		{
		0x8755,
		0xe3da
		},
		{
		0x8757,
		0xfcd9
		},
		{
		0x875f,
		0xeada
		},
		{
		0x8766,
		0xf9c4
		},
		{
		0x8768,
		0xe3a4
		},
		{
		0x8774,
		0xfbdd
		},
		{
		0x8776,
		0xefca
		},
		{
		0x8778,
		0xe8c4
		},
		{
		0x8782,
		0xd5cc
		},
		{
		0x878d,
		0xebd7
		},
		{
		0x879f,
		0xd9ad
		},
		{
		0x87a2,
		0xfbab
		},
		{
		0x87b3,
		0xd3d9
		},
		{
		0x87ba,
		0xd5a2
		},
		{
		0x87c4,
		0xf6de
		},
		{
		0x87e0,
		0xdaf6
		},
		{
		0x87ec,
		0xe0d1
		},
		{
		0x87ef,
		0xe9a8
		},
		{
		0x87f2,
		0xf5f9
		},
		{
		0x87f9,
		0xfaaf
		},
		{
		0x87fb,
		0xebfc
		},
		{
		0x87fe,
		0xe0ea
		},
		{
		0x8805,
		0xe3b2
		},
		{
		0x881f,
		0xd5c5
		},
		{
		0x8822,
		0xf1e3
		},
		{
		0x8823,
		0xd5ee
		},
		{
		0x8831,
		0xcdcc
		},
		{
		0x8836,
		0xedd9
		},
		{
		0x883b,
		0xd8c1
		},
		{
		0x8840,
		0xfaec
		},
		{
		0x8846,
		0xf1eb
		},
		{
		0x884c,
		0xfabc
		},
		{
		0x884d,
		0xe6e2
		},
		{
		0x8852,
		0xfae5
		},
		{
		0x8853,
		0xe2fa
		},
		{
		0x8857,
		0xcab6
		},
		{
		0x8859,
		0xe4b7
		},
		{
		0x885b,
		0xeadb
		},
		{
		0x885d,
		0xf5fa
		},
		{
		0x8861,
		0xfbac
		},
		{
		0x8862,
		0xcfc3
		},
		{
		0x8863,
		0xebfd
		},
		{
		0x8868,
		0xf8fa
		},
		{
		0x886b,
		0xdfb9
		},
		{
		0x8870,
		0xe1f1
		},
		{
		0x8872,
		0xd2a4
		},
		{
		0x8877,
		0xf5fb
		},
		{
		0x887e,
		0xd0da
		},
		{
		0x887f,
		0xd0db
		},
		{
		0x8881,
		0xeabe
		},
		{
		0x8882,
		0xd9b1
		},
		{
		0x8888,
		0xcab7
		},
		{
		0x888b,
		0xd3e7
		},
		{
		0x888d,
		0xf8e5
		},
		{
		0x8892,
		0xd3b2
		},
		{
		0x8896,
		0xe2c0
		},
		{
		0x8897,
		0xf2df
		},
		{
		0x889e,
		0xcde5
		},
		{
		0x88ab,
		0xf9ac
		},
		{
		0x88b4,
		0xcdcd
		},
		{
		0x88c1,
		0xeeae
		},
		{
		0x88c2,
		0xd6ae
		},
		{
		0x88cf,
		0xd7ea
		},
		{
		0x88d4,
		0xe7e0
		},
		{
		0x88d5,
		0xebae
		},
		{
		0x88d9,
		0xcfd9
		},
		{
		0x88dc,
		0xdccd
		},
		{
		0x88dd,
		0xedfb
		},
		{
		0x88df,
		0xdef0
		},
		{
		0x88e1,
		0xd7eb
		},
		{
		0x88e8,
		0xdea5
		},
		{
		0x88f3,
		0xdfd7
		},
		{
		0x88f4,
		0xdbd0
		},
		{
		0x88f5,
		0xdbd1
		},
		{
		0x88f8,
		0xd5a3
		},
		{
		0x88fd,
		0xf0b2
		},
		{
		0x8907,
		0xdcdc
		},
		{
		0x8910,
		0xcae8
		},
		{
		0x8912,
		0xf8e6
		},
		{
		0x8913,
		0xdcce
		},
		{
		0x8918,
		0xeadc
		},
		{
		0x8919,
		0xdbd2
		},
		{
		0x8925,
		0xe9b3
		},
		{
		0x892a,
		0xf7db
		},
		{
		0x8936,
		0xe3a8
		},
		{
		0x8938,
		0xd7ae
		},
		{
		0x893b,
		0xe0e1
		},
		{
		0x8941,
		0xcbba
		},
		{
		0x8944,
		0xe5d1
		},
		{
		0x895f,
		0xd0dc
		},
		{
		0x8964,
		0xd5c1
		},
		{
		0x896a,
		0xd8ca
		},
		{
		0x8972,
		0xe3a9
		},
		{
		0x897f,
		0xe0a4
		},
		{
		0x8981,
		0xe9a9
		},
		{
		0x8983,
		0xd3c7
		},
		{
		0x8986,
		0xdcdd
		},
		{
		0x8987,
		0xf8ae
		},
		{
		0x898b,
		0xccb8
		},
		{
		0x898f,
		0xd0ae
		},
		{
		0x8993,
		0xd8f2
		},
		{
		0x8996,
		0xe3ca
		},
		{
		0x89a1,
		0xccaf
		},
		{
		0x89a9,
		0xd4ad
		},
		{
		0x89aa,
		0xf6d1
		},
		{
		0x89b2,
		0xd0cc
		},
		{
		0x89ba,
		0xcac6
		},
		{
		0x89bd,
		0xd5c2
		},
		{
		0x89c0,
		0xceba
		},
		{
		0x89d2,
		0xcac7
		},
		{
		0x89e3,
		0xfab0
		},
		{
		0x89f4,
		0xdfd8
		},
		{
		0x89f8,
		0xf5ba
		},
		{
		0x8a00,
		0xe5eb
		},
		{
		0x8a02,
		0xeff4
		},
		{
		0x8a03,
		0xddb5
		},
		{
		0x8a08,
		0xcdaa
		},
		{
		0x8a0a,
		0xe3f2
		},
		{
		0x8a0c,
		0xfbf7
		},
		{
		0x8a0e,
		0xf7d0
		},
		{
		0x8a13,
		0xfdba
		},
		{
		0x8a16,
		0xfde1
		},
		{
		0x8a17,
		0xf6fe
		},
		{
		0x8a18,
		0xd1c0
		},
		{
		0x8a1b,
		0xe8c5
		},
		{
		0x8a1d,
		0xe4b8
		},
		{
		0x8a1f,
		0xe1e8
		},
		{
		0x8a23,
		0xccc1
		},
		{
		0x8a25,
		0xd2ed
		},
		{
		0x8a2a,
		0xdbbe
		},
		{
		0x8a2d,
		0xe0e2
		},
		{
		0x8a31,
		0xfac9
		},
		{
		0x8a34,
		0xe1cd
		},
		{
		0x8a36,
		0xcab8
		},
		{
		0x8a3a,
		0xf2e0
		},
		{
		0x8a3b,
		0xf1c9
		},
		{
		0x8a50,
		0xdef1
		},
		{
		0x8a54,
		0xf0df
		},
		{
		0x8a55,
		0xf8c4
		},
		{
		0x8a5b,
		0xeecc
		},
		{
		0x8a5e,
		0xdef2
		},
		{
		0x8a60,
		0xe7c9
		},
		{
		0x8a62,
		0xe2f3
		},
		{
		0x8a63,
		0xe7e1
		},
		{
		0x8a66,
		0xe3cb
		},
		{
		0x8a69,
		0xe3cc
		},
		{
		0x8a6d,
		0xcff8
		},
		{
		0x8a6e,
		0xefac
		},
		{
		0x8a70,
		0xfdfe
		},
		{
		0x8a71,
		0xfca5
		},
		{
		0x8a72,
		0xfab1
		},
		{
		0x8a73,
		0xdfd9
		},
		{
		0x8a75,
		0xe0d2
		},
		{
		0x8a79,
		0xf4da
		},
		{
		0x8a85,
		0xf1ca
		},
		{
		0x8a87,
		0xcea3
		},
		{
		0x8a8c,
		0xf2bc
		},
		{
		0x8a8d,
		0xece3
		},
		{
		0x8a93,
		0xe0a5
		},
		{
		0x8a95,
		0xf7ab
		},
		{
		0x8a98,
		0xebaf
		},
		{
		0x8a9e,
		0xe5de
		},
		{
		0x8aa0,
		0xe1a4
		},
		{
		0x8aa1,
		0xcdab
		},
		{
		0x8aa3,
		0xd9f4
		},
		{
		0x8aa4,
		0xe8a6
		},
		{
		0x8aa5,
		0xcdce
		},
		{
		0x8aa6,
		0xe1e9
		},
		{
		0x8aa8,
		0xfcef
		},
		{
		0x8aaa,
		0xe0e3
		},
		{
		0x8ab0,
		0xe2c1
		},
		{
		0x8ab2,
		0xcea4
		},
		{
		0x8ab9,
		0xdea6
		},
		{
		0x8abc,
		0xebfe
		},
		{
		0x8abe,
		0xebdd
		},
		{
		0x8abf,
		0xf0e0
		},
		{
		0x8ac2,
		0xf4db
		},
		{
		0x8ac4,
		0xe2f4
		},
		{
		0x8ac7,
		0xd3c8
		},
		{
		0x8acb,
		0xf4eb
		},
		{
		0x8acd,
		0xeeb5
		},
		{
		0x8acf,
		0xf5d8
		},
		{
		0x8ad2,
		0xd5df
		},
		{
		0x8ad6,
		0xd6e5
		},
		{
		0x8adb,
		0xebb0
		},
		{
		0x8adc,
		0xf4e3
		},
		{
		0x8ae1,
		0xe3cd
		},
		{
		0x8ae6,
		0xf4f4
		},
		{
		0x8ae7,
		0xfab2
		},
		{
		0x8aea,
		0xeff5
		},
		{
		0x8aeb,
		0xcadf
		},
		{
		0x8aed,
		0xebb1
		},
		{
		0x8aee,
		0xedbf
		},
		{
		0x8af1,
		0xfdc9
		},
		{
		0x8af6,
		0xe4a6
		},
		{
		0x8af7,
		0xf9a4
		},
		{
		0x8af8,
		0xf0b3
		},
		{
		0x8afa,
		0xe5ec
		},
		{
		0x8afe,
		0xd1e7
		},
		{
		0x8b00,
		0xd9c7
		},
		{
		0x8b01,
		0xe4d7
		},
		{
		0x8b02,
		0xeadd
		},
		{
		0x8b04,
		0xd4f7
		},
		{
		0x8b0e,
		0xdaba
		},
		{
		0x8b10,
		0xdacd
		},
		{
		0x8b14,
		0xf9cc
		},
		{
		0x8b16,
		0xe1da
		},
		{
		0x8b17,
		0xdbbf
		},
		{
		0x8b19,
		0xccc5
		},
		{
		0x8b1a,
		0xecd0
		},
		{
		0x8b1b,
		0xcbbb
		},
		{
		0x8b1d,
		0xdef3
		},
		{
		0x8b20,
		0xe9aa
		},
		{
		0x8b28,
		0xd9c8
		},
		{
		0x8b2b,
		0xeee3
		},
		{
		0x8b2c,
		0xd7bd
		},
		{
		0x8b33,
		0xcfc4
		},
		{
		0x8b39,
		0xd0cd
		},
		{
		0x8b41,
		0xfca6
		},
		{
		0x8b49,
		0xf1fb
		},
		{
		0x8b4e,
		0xfdd2
		},
		{
		0x8b4f,
		0xd1c1
		},
		{
		0x8b58,
		0xe3db
		},
		{
		0x8b5a,
		0xd3c9
		},
		{
		0x8b5c,
		0xdccf
		},
		{
		0x8b66,
		0xcced
		},
		{
		0x8b6c,
		0xdea7
		},
		{
		0x8b6f,
		0xe6bb
		},
		{
		0x8b70,
		0xeca1
		},
		{
		0x8b74,
		0xccb9
		},
		{
		0x8b77,
		0xfbde
		},
		{
		0x8b7d,
		0xe7e2
		},
		{
		0x8b80,
		0xd4c1
		},
		{
		0x8b8a,
		0xdca8
		},
		{
		0x8b90,
		0xe2c2
		},
		{
		0x8b92,
		0xf3d8
		},
		{
		0x8b93,
		0xe5d3
		},
		{
		0x8b96,
		0xf3d9
		},
		{
		0x8b9a,
		0xf3c6
		},
		{
		0x8c37,
		0xcddb
		},
		{
		0x8c3f,
		0xcdac
		},
		{
		0x8c41,
		0xfcc3
		},
		{
		0x8c46,
		0xd4e7
		},
		{
		0x8c48,
		0xd1c2
		},
		{
		0x8c4a,
		0xf9a5
		},
		{
		0x8c4c,
		0xe8d5
		},
		{
		0x8c55,
		0xe3ce
		},
		{
		0x8c5a,
		0xd4ca
		},
		{
		0x8c61,
		0xdfda
		},
		{
		0x8c6a,
		0xfbdf
		},
		{
		0x8c6b,
		0xe7e3
		},
		{
		0x8c79,
		0xf8fb
		},
		{
		0x8c7a,
		0xe3cf
		},
		{
		0x8c82,
		0xf5b0
		},
		{
		0x8c8a,
		0xd8e7
		},
		{
		0x8c8c,
		0xd9c9
		},
		{
		0x8c9d,
		0xf8af
		},
		{
		0x8c9e,
		0xeff6
		},
		{
		0x8ca0,
		0xddb6
		},
		{
		0x8ca1,
		0xeeaf
		},
		{
		0x8ca2,
		0xcdf8
		},
		{
		0x8caf,
		0xeecd
		},
		{
		0x8cb0,
		0xe1ae
		},
		{
		0x8cb3,
		0xecc3
		},
		{
		0x8cb4,
		0xcffe
		},
		{
		0x8cb6,
		0xf8bf
		},
		{
		0x8cb7,
		0xd8e2
		},
		{
		0x8cb8,
		0xd3e8
		},
		{
		0x8cbb,
		0xdea8
		},
		{
		0x8cbc,
		0xf4e4
		},
		{
		0x8cbd,
		0xecc2
		},
		{
		0x8cc7,
		0xedc0
		},
		{
		0x8cc8,
		0xcab9
		},
		{
		0x8cca,
		0xeee4
		},
		{
		0x8cd1,
		0xf2e1
		},
		{
		0x8cd3,
		0xdeb9
		},
		{
		0x8cda,
		0xd6f2
		},
		{
		0x8cdc,
		0xdef4
		},
		{
		0x8cde,
		0xdfdb
		},
		{
		0x8ce0,
		0xdbd3
		},
		{
		0x8ce2,
		0xfae7
		},
		{
		0x8ce3,
		0xd8e3
		},
		{
		0x8ce4,
		0xf4c1
		},
		{
		0x8ce6,
		0xddb7
		},
		{
		0x8cea,
		0xf2f5
		},
		{
		0x8ced,
		0xd4ae
		},
		{
		0x8cf4,
		0xd6f3
		},
		{
		0x8cfb,
		0xddb8
		},
		{
		0x8cfc,
		0xcfc5
		},
		{
		0x8cfd,
		0xdfdf
		},
		{
		0x8d04,
		0xf2be
		},
		{
		0x8d05,
		0xf6a1
		},
		{
		0x8d07,
		0xebcb
		},
		{
		0x8d08,
		0xf1fc
		},
		{
		0x8d0a,
		0xf3c7
		},
		{
		0x8d0d,
		0xe0eb
		},
		{
		0x8d13,
		0xedfc
		},
		{
		0x8d16,
		0xe1db
		},
		{
		0x8d64,
		0xeee5
		},
		{
		0x8d66,
		0xdef5
		},
		{
		0x8d6b,
		0xfad3
		},
		{
		0x8d70,
		0xf1cb
		},
		{
		0x8d73,
		0xd0af
		},
		{
		0x8d74,
		0xddb9
		},
		{
		0x8d77,
		0xd1c3
		},
		{
		0x8d85,
		0xf5b1
		},
		{
		0x8d8a,
		0xeac6
		},
		{
		0x8d99,
		0xf0e1
		},
		{
		0x8da3,
		0xf6ac
		},
		{
		0x8da8,
		0xf5d9
		},
		{
		0x8db3,
		0xf0eb
		},
		{
		0x8dba,
		0xddba
		},
		{
		0x8dbe,
		0xf2bf
		},
		{
		0x8dc6,
		0xf7c5
		},
		{
		0x8dcb,
		0xdba2
		},
		{
		0x8dcc,
		0xf2f6
		},
		{
		0x8dcf,
		0xcaba
		},
		{
		0x8ddb,
		0xf7f5
		},
		{
		0x8ddd,
		0xcbe5
		},
		{
		0x8de1,
		0xeee6
		},
		{
		0x8de3,
		0xe0d3
		},
		{
		0x8de8,
		0xcea5
		},
		{
		0x8def,
		0xd6d8
		},
		{
		0x8df3,
		0xd4af
		},
		{
		0x8e0a,
		0xe9c9
		},
		{
		0x8e0f,
		0xd3ce
		},
		{
		0x8e10,
		0xf4c2
		},
		{
		0x8e1e,
		0xcbe6
		},
		{
		0x8e2a,
		0xf1a1
		},
		{
		0x8e30,
		0xebb2
		},
		{
		0x8e35,
		0xf1a2
		},
		{
		0x8e42,
		0xebb3
		},
		{
		0x8e44,
		0xf0b4
		},
		{
		0x8e47,
		0xcbf4
		},
		{
		0x8e48,
		0xd4b0
		},
		{
		0x8e49,
		0xf3b2
		},
		{
		0x8e4a,
		0xfbb7
		},
		{
		0x8e59,
		0xf5ec
		},
		{
		0x8e5f,
		0xeee7
		},
		{
		0x8e60,
		0xf4b2
		},
		{
		0x8e74,
		0xf5ed
		},
		{
		0x8e76,
		0xcff3
		},
		{
		0x8e81,
		0xf0e2
		},
		{
		0x8e87,
		0xeece
		},
		{
		0x8e8a,
		0xf1cc
		},
		{
		0x8e8d,
		0xe5b8
		},
		{
		0x8eaa,
		0xd7f5
		},
		{
		0x8eab,
		0xe3f3
		},
		{
		0x8eac,
		0xcfe5
		},
		{
		0x8ec0,
		0xcfc6
		},
		{
		0x8eca,
		0xf3b3
		},
		{
		0x8ecb,
		0xe4d8
		},
		{
		0x8ecc,
		0xcff9
		},
		{
		0x8ecd,
		0xcfda
		},
		{
		0x8ed2,
		0xfacd
		},
		{
		0x8edf,
		0xe6e3
		},
		{
		0x8eeb,
		0xf2e2
		},
		{
		0x8ef8,
		0xf5ee
		},
		{
		0x8efb,
		0xcabb
		},
		{
		0x8efe,
		0xe3dc
		},
		{
		0x8f03,
		0xcef2
		},
		{
		0x8f05,
		0xd6d9
		},
		{
		0x8f09,
		0xeeb0
		},
		{
		0x8f12,
		0xf4e5
		},
		{
		0x8f13,
		0xd8c2
		},
		{
		0x8f14,
		0xdcd0
		},
		{
		0x8f15,
		0xccee
		},
		{
		0x8f26,
		0xd6a6
		},
		{
		0x8f27,
		0xdcbe
		},
		{
		0x8f29,
		0xdbd4
		},
		{
		0x8f2a,
		0xd7c7
		},
		{
		0x8f2f,
		0xf2fe
		},
		{
		0x8f33,
		0xf1cd
		},
		{
		0x8f38,
		0xe2c3
		},
		{
		0x8f39,
		0xdcde
		},
		{
		0x8f3b,
		0xdcdf
		},
		{
		0x8f3e,
		0xefad
		},
		{
		0x8f3f,
		0xe6ab
		},
		{
		0x8f44,
		0xf9dd
		},
		{
		0x8f45,
		0xeabf
		},
		{
		0x8f49,
		0xefae
		},
		{
		0x8f4d,
		0xf4d0
		},
		{
		0x8f4e,
		0xcef3
		},
		{
		0x8f5d,
		0xe6ac
		},
		{
		0x8f5f,
		0xcede
		},
		{
		0x8f62,
		0xd5f9
		},
		{
		0x8f9b,
		0xe3f4
		},
		{
		0x8f9c,
		0xcdd0
		},
		{
		0x8fa3,
		0xd5b8
		},
		{
		0x8fa6,
		0xf7fd
		},
		{
		0x8fa8,
		0xdca9
		},
		{
		0x8fad,
		0xdef6
		},
		{
		0x8faf,
		0xdcaa
		},
		{
		0x8fb0,
		0xf2e3
		},
		{
		0x8fb1,
		0xe9b4
		},
		{
		0x8fb2,
		0xd2dc
		},
		{
		0x8fc2,
		0xe9e6
		},
		{
		0x8fc5,
		0xe3f6
		},
		{
		0x8fce,
		0xe7ca
		},
		{
		0x8fd1,
		0xd0ce
		},
		{
		0x8fd4,
		0xdaf7
		},
		{
		0x8fe6,
		0xcabc
		},
		{
		0x8fea,
		0xeee8
		},
		{
		0x8feb,
		0xdade
		},
		{
		0x8fed,
		0xf2f7
		},
		{
		0x8ff0,
		0xe2fb
		},
		{
		0x8ff2,
		0xcca6
		},
		{
		0x8ff7,
		0xdabb
		},
		{
		0x8ff9,
		0xeee9
		},
		{
		0x8ffd,
		0xf5da
		},
		{
		0x9000,
		0xf7dc
		},
		{
		0x9001,
		0xe1ea
		},
		{
		0x9002,
		0xcec1
		},
		{
		0x9003,
		0xd4b1
		},
		{
		0x9005,
		0xfdb1
		},
		{
		0x9006,
		0xe6bd
		},
		{
		0x9008,
		0xfbad
		},
		{
		0x900b,
		0xf8e7
		},
		{
		0x900d,
		0xe1ce
		},
		{
		0x900f,
		0xf7e2
		},
		{
		0x9010,
		0xf5ef
		},
		{
		0x9011,
		0xcfc7
		},
		{
		0x9014,
		0xd4b2
		},
		{
		0x9015,
		0xccef
		},
		{
		0x9017,
		0xd4e8
		},
		{
		0x9019,
		0xeecf
		},
		{
		0x901a,
		0xf7d7
		},
		{
		0x902e,
		0xf4f5
		},
		{
		0x9031,
		0xf1ce
		},
		{
		0x9032,
		0xf2e4
		},
		{
		0x9035,
		0xd0b0
		},
		{
		0x9038,
		0xecef
		},
		{
		0x903c,
		0xf9ba
		},
		{
		0x903e,
		0xebb5
		},
		{
		0x9041,
		0xd4ed
		},
		{
		0x9042,
		0xe2c4
		},
		{
		0x9047,
		0xe9e7
		},
		{
		0x904a,
		0xebb4
		},
		{
		0x904b,
		0xeaa1
		},
		{
		0x904d,
		0xf8bc
		},
		{
		0x904e,
		0xcea6
		},
		{
		0x9050,
		0xf9c6
		},
		{
		0x9051,
		0xfcda
		},
		{
		0x9053,
		0xd4b3
		},
		{
		0x9054,
		0xd3b9
		},
		{
		0x9055,
		0xeade
		},
		{
		0x9059,
		0xe9ab
		},
		{
		0x905c,
		0xe1e1
		},
		{
		0x905d,
		0xd3cf
		},
		{
		0x905e,
		0xf4f6
		},
		{
		0x9060,
		0xeac0
		},
		{
		0x9061,
		0xe1cf
		},
		{
		0x9063,
		0xccba
		},
		{
		0x9069,
		0xeeea
		},
		{
		0x906d,
		0xf0e4
		},
		{
		0x906e,
		0xf3b4
		},
		{
		0x906f,
		0xd4ee
		},
		{
		0x9072,
		0xf2c0
		},
		{
		0x9075,
		0xf1e5
		},
		{
		0x9077,
		0xf4c3
		},
		{
		0x9078,
		0xe0d4
		},
		{
		0x907a,
		0xebb6
		},
		{
		0x907c,
		0xd7a1
		},
		{
		0x907d,
		0xcbe8
		},
		{
		0x9087,
		0xecc4
		},
		{
		0x9088,
		0xd8b1
		},
		{
		0x908a,
		0xdcab
		},
		{
		0x908f,
		0xd5a4
		},
		{
		0x9091,
		0xebe9
		},
		{
		0x9095,
		0xe8bb
		},
		{
		0x9099,
		0xd8d7
		},
		{
		0x90a2,
		0xfbae
		},
		{
		0x90a3,
		0xd1e1
		},
		{
		0x90a6,
		0xdbc0
		},
		{
		0x90a8,
		0xf5be
		},
		{
		0x90aa,
		0xdef7
		},
		{
		0x90af,
		0xcafb
		},
		{
		0x90b0,
		0xf7c6
		},
		{
		0x90b1,
		0xcfc8
		},
		{
		0x90b5,
		0xe1d0
		},
		{
		0x90b8,
		0xeed0
		},
		{
		0x90c1,
		0xe9f4
		},
		{
		0x90ca,
		0xcef4
		},
		{
		0x90de,
		0xd5cd
		},
		{
		0x90e1,
		0xcfdb
		},
		{
		0x90e8,
		0xddbb
		},
		{
		0x90ed,
		0xceac
		},
		{
		0x90f5,
		0xe9e8
		},
		{
		0x90fd,
		0xd4b4
		},
		{
		0x9102,
		0xe4c7
		},
		{
		0x9112,
		0xf5db
		},
		{
		0x9115,
		0xfac1
		},
		{
		0x9119,
		0xdea9
		},
		{
		0x9127,
		0xd4f8
		},
		{
		0x912d,
		0xeff7
		},
		{
		0x9132,
		0xd3b3
		},
		{
		0x9152,
		0xf1d0
		},
		{
		0x9162,
		0xf5b2
		},
		{
		0x9169,
		0xd9ae
		},
		{
		0x916a,
		0xd5ac
		},
		{
		0x916c,
		0xe2c6
		},
		{
		0x9175,
		0xfda3
		},
		{
		0x9177,
		0xfbe5
		},
		{
		0x9178,
		0xdfab
		},
		{
		0x9187,
		0xe2f5
		},
		{
		0x9189,
		0xf6ad
		},
		{
		0x918b,
		0xf5b3
		},
		{
		0x918d,
		0xf0b5
		},
		{
		0x9192,
		0xe1a5
		},
		{
		0x919c,
		0xf5dd
		},
		{
		0x91ab,
		0xeca2
		},
		{
		0x91ac,
		0xedfd
		},
		{
		0x91ae,
		0xf5b4
		},
		{
		0x91af,
		0xfbb8
		},
		{
		0x91b1,
		0xdba3
		},
		{
		0x91b4,
		0xd6ca
		},
		{
		0x91b5,
		0xcbd9
		},
		{
		0x91c0,
		0xe5d4
		},
		{
		0x91c7,
		0xf3fa
		},
		{
		0x91c9,
		0xebb8
		},
		{
		0x91d7,
		0xe1f2
		},
		{
		0x91d8,
		0xeff9
		},
		{
		0x91dc,
		0xddbc
		},
		{
		0x91dd,
		0xf6dc
		},
		{
		0x91e3,
		0xf0e5
		},
		{
		0x91e7,
		0xf4c4
		},
		{
		0x91ea,
		0xe9e9
		},
		{
		0x91f5,
		0xf3fb
		},
		{
		0x920d,
		0xd4ef
		},
		{
		0x9210,
		0xcca2
		},
		{
		0x9211,
		0xf7fe
		},
		{
		0x9212,
		0xdfbc
		},
		{
		0x9217,
		0xebcd
		},
		{
		0x921e,
		0xd0b7
		},
		{
		0x9234,
		0xd6c2
		},
		{
		0x923a,
		0xe8ad
		},
		{
		0x923f,
		0xefaf
		},
		{
		0x9240,
		0xcba5
		},
		{
		0x9245,
		0xcbe9
		},
		{
		0x9249,
		0xfae8
		},
		{
		0x9257,
		0xccc6
		},
		{
		0x925b,
		0xe6e7
		},
		{
		0x925e,
		0xeac7
		},
		{
		0x9262,
		0xdba4
		},
		{
		0x9264,
		0xcfc9
		},
		{
		0x9265,
		0xe2fc
		},
		{
		0x9266,
		0xeffa
		},
		{
		0x9280,
		0xebde
		},
		{
		0x9283,
		0xf5c8
		},
		{
		0x9285,
		0xd4de
		},
		{
		0x9291,
		0xe0d5
		},
		{
		0x9293,
		0xefb0
		},
		{
		0x9296,
		0xe2c7
		},
		{
		0x9298,
		0xd9af
		},
		{
		0x929c,
		0xf9e7
		},
		{
		0x92b3,
		0xe7e5
		},
		{
		0x92b6,
		0xcfca
		},
		{
		0x92b7,
		0xe1d1
		},
		{
		0x92b9,
		0xe2c8
		},
		{
		0x92cc,
		0xeffb
		},
		{
		0x92cf,
		0xfaf9
		},
		{
		0x92d2,
		0xdcf2
		},
		{
		0x92e4,
		0xe0a7
		},
		{
		0x92ea,
		0xf8e8
		},
		{
		0x92f8,
		0xcbea
		},
		{
		0x92fc,
		0xcbbc
		},
		{
		0x9304,
		0xd6e2
		},
		{
		0x9310,
		0xf5de
		},
		{
		0x9318,
		0xf5df
		},
		{
		0x931a,
		0xeeb6
		},
		{
		0x9324,
		0xd1c5
		},
		{
		0x9326,
		0xd0de
		},
		{
		0x9328,
		0xd9e1
		},
		{
		0x932b,
		0xe0b8
		},
		{
		0x932e,
		0xcdd1
		},
		{
		0x932f,
		0xf3b9
		},
		{
		0x9348,
		0xe7cc
		},
		{
		0x934a,
		0xd6a8
		},
		{
		0x934b,
		0xcea7
		},
		{
		0x934d,
		0xd4b5
		},
		{
		0x9354,
		0xe4c8
		},
		{
		0x935b,
		0xd3b4
		},
		{
		0x936e,
		0xebb9
		},
		{
		0x9375,
		0xcbf5
		},
		{
		0x937c,
		0xf6dd
		},
		{
		0x937e,
		0xf1a3
		},
		{
		0x938c,
		0xccc7
		},
		{
		0x9394,
		0xe9ca
		},
		{
		0x9396,
		0xe1f0
		},
		{
		0x939a,
		0xf5e0
		},
		{
		0x93a3,
		0xfbaf
		},
		{
		0x93a7,
		0xcbd1
		},
		{
		0x93ac,
		0xfbe0
		},
		{
		0x93ad,
		0xf2e5
		},
		{
		0x93b0,
		0xecf0
		},
		{
		0x93c3,
		0xf0ec
		},
		{
		0x93d1,
		0xeeeb
		},
		{
		0x93de,
		0xe9cb
		},
		{
		0x93e1,
		0xccf0
		},
		{
		0x93e4,
		0xd7af
		},
		{
		0x93f6,
		0xf3a1
		},
		{
		0x9404,
		0xfcf5
		},
		{
		0x9418,
		0xf1a4
		},
		{
		0x9425,
		0xe0d6
		},
		{
		0x942b,
		0xefb2
		},
		{
		0x9435,
		0xf4d1
		},
		{
		0x9438,
		0xf7a1
		},
		{
		0x9444,
		0xf1d1
		},
		{
		0x9451,
		0xcafc
		},
		{
		0x9452,
		0xcafd
		},
		{
		0x945b,
		0xcece
		},
		{
		0x947d,
		0xf3c8
		},
		{
		0x947f,
		0xf3ba
		},
		{
		0x9577,
		0xedfe
		},
		{
		0x9580,
		0xdaa6
		},
		{
		0x9583,
		0xe0ec
		},
		{
		0x9589,
		0xf8cd
		},
		{
		0x958b,
		0xcbd2
		},
		{
		0x958f,
		0xebce
		},
		{
		0x9591,
		0xf9d8
		},
		{
		0x9592,
		0xf9d9
		},
		{
		0x9593,
		0xcae0
		},
		{
		0x9594,
		0xdaca
		},
		{
		0x9598,
		0xcba6
		},
		{
		0x95a3,
		0xcac8
		},
		{
		0x95a4,
		0xf9ee
		},
		{
		0x95a5,
		0xdbec
		},
		{
		0x95a8,
		0xd0b1
		},
		{
		0x95ad,
		0xd5ef
		},
		{
		0x95b1,
		0xe6f3
		},
		{
		0x95bb,
		0xe7a2
		},
		{
		0x95bc,
		0xe4d9
		},
		{
		0x95c7,
		0xe4e1
		},
		{
		0x95ca,
		0xfcc4
		},
		{
		0x95d4,
		0xf9ef
		},
		{
		0x95d5,
		0xcff4
		},
		{
		0x95d6,
		0xf7e6
		},
		{
		0x95dc,
		0xcebc
		},
		{
		0x95e1,
		0xf4c5
		},
		{
		0x95e2,
		0xdca3
		},
		{
		0x961c,
		0xddbd
		},
		{
		0x9621,
		0xf4c6
		},
		{
		0x962a,
		0xf8a1
		},
		{
		0x962e,
		0xe8d6
		},
		{
		0x9632,
		0xdbc1
		},
		{
		0x963b,
		0xf0e6
		},
		{
		0x963f,
		0xe4b9
		},
		{
		0x9640,
		0xf6ed
		},
		{
		0x9642,
		0xf9ae
		},
		{
		0x9644,
		0xddbe
		},
		{
		0x964b,
		0xd7b0
		},
		{
		0x964c,
		0xd8e8
		},
		{
		0x964d,
		0xcbbd
		},
		{
		0x9650,
		0xf9da
		},
		{
		0x9662,
		0xeac2
		},
		{
		0x9663,
		0xf2e6
		},
		{
		0x9664,
		0xf0b6
		},
		{
		0x966a,
		0xdbd6
		},
		{
		0x9670,
		0xebe4
		},
		{
		0x9673,
		0xf2e7
		},
		{
		0x9675,
		0xd7d5
		},
		{
		0x9676,
		0xd4b6
		},
		{
		0x9677,
		0xf9e8
		},
		{
		0x9678,
		0xd7c1
		},
		{
		0x967d,
		0xe5d5
		},
		{
		0x9685,
		0xe9ea
		},
		{
		0x9686,
		0xd7cc
		},
		{
		0x968a,
		0xd3e9
		},
		{
		0x968b,
		0xe2c9
		},
		{
		0x968d,
		0xfcdb
		},
		{
		0x968e,
		0xcdad
		},
		{
		0x9694,
		0xccb0
		},
		{
		0x9695,
		0xeaa2
		},
		{
		0x9698,
		0xe4f6
		},
		{
		0x9699,
		0xd0c0
		},
		{
		0x969b,
		0xf0b7
		},
		{
		0x969c,
		0xeea1
		},
		{
		0x96a3,
		0xd7f6
		},
		{
		0x96a7,
		0xe2ca
		},
		{
		0x96a8,
		0xe2cb
		},
		{
		0x96aa,
		0xfacf
		},
		{
		0x96b1,
		0xebdf
		},
		{
		0x96b7,
		0xd6cb
		},
		{
		0x96bb,
		0xf4b4
		},
		{
		0x96c0,
		0xedcd
		},
		{
		0x96c1,
		0xe4d2
		},
		{
		0x96c4,
		0xeaa9
		},
		{
		0x96c5,
		0xe4ba
		},
		{
		0x96c6,
		0xf3a2
		},
		{
		0x96c7,
		0xcdd2
		},
		{
		0x96c9,
		0xf6cb
		},
		{
		0x96cb,
		0xf1e6
		},
		{
		0x96cc,
		0xedc1
		},
		{
		0x96cd,
		0xe8bc
		},
		{
		0x96ce,
		0xeed1
		},
		{
		0x96d5,
		0xf0e7
		},
		{
		0x96d6,
		0xe2cc
		},
		{
		0x96d9,
		0xe4aa
		},
		{
		0x96db,
		0xf5e1
		},
		{
		0x96dc,
		0xedda
		},
		{
		0x96e2,
		0xd7ee
		},
		{
		0x96e3,
		0xd1f1
		},
		{
		0x96e8,
		0xe9eb
		},
		{
		0x96e9,
		0xe9ec
		},
		{
		0x96ea,
		0xe0e4
		},
		{
		0x96ef,
		0xdaa7
		},
		{
		0x96f0,
		0xddd4
		},
		{
		0x96f2,
		0xeaa3
		},
		{
		0x96f6,
		0xd6c3
		},
		{
		0x96f7,
		0xd6f4
		},
		{
		0x96f9,
		0xdadf
		},
		{
		0x96fb,
		0xefb3
		},
		{
		0x9700,
		0xe2cd
		},
		{
		0x9706,
		0xeffd
		},
		{
		0x9707,
		0xf2e8
		},
		{
		0x9711,
		0xefc5
		},
		{
		0x9713,
		0xe7e7
		},
		{
		0x9716,
		0xd7fd
		},
		{
		0x9719,
		0xe7ce
		},
		{
		0x971c,
		0xdfdc
		},
		{
		0x971e,
		0xf9c7
		},
		{
		0x9727,
		0xd9f6
		},
		{
		0x9730,
		0xdfac
		},
		{
		0x9732,
		0xd6da
		},
		{
		0x9739,
		0xdca4
		},
		{
		0x973d,
		0xf0b8
		},
		{
		0x9742,
		0xd5fa
		},
		{
		0x9744,
		0xe4f7
		},
		{
		0x9748,
		0xd6c4
		},
		{
		0x9751,
		0xf4ec
		},
		{
		0x9756,
		0xeffe
		},
		{
		0x975c,
		0xf0a1
		},
		{
		0x975e,
		0xdeaa
		},
		{
		0x9761,
		0xdabc
		},
		{
		0x9762,
		0xd8fc
		},
		{
		0x9769,
		0xfad4
		},
		{
		0x976d,
		0xece5
		},
		{
		0x9774,
		0xfca8
		},
		{
		0x9777,
		0xece6
		},
		{
		0x977a,
		0xd8cb
		},
		{
		0x978b,
		0xfbb9
		},
		{
		0x978d,
		0xe4d3
		},
		{
		0x978f,
		0xcdf9
		},
		{
		0x97a0,
		0xcfd3
		},
		{
		0x97a8,
		0xcaea
		},
		{
		0x97ab,
		0xcfd4
		},
		{
		0x97ad,
		0xf8bd
		},
		{
		0x97c6,
		0xf4c7
		},
		{
		0x97cb,
		0xeadf
		},
		{
		0x97d3,
		0xf9db
		},
		{
		0x97dc,
		0xd4b7
		},
		{
		0x97f3,
		0xebe5
		},
		{
		0x97f6,
		0xe1d2
		},
		{
		0x97fb,
		0xeaa4
		},
		{
		0x9805,
		0xfaa3
		},
		{
		0x9806,
		0xe2f7
		},
		{
		0x9808,
		0xe2ce
		},
		{
		0x980a,
		0xe9f5
		},
		{
		0x980c,
		0xe1eb
		},
		{
		0x9810,
		0xe7e8
		},
		{
		0x9811,
		0xe8d7
		},
		{
		0x9812,
		0xdaf8
		},
		{
		0x9813,
		0xd4cb
		},
		{
		0x9817,
		0xf7f6
		},
		{
		0x9818,
		0xd6c5
		},
		{
		0x982d,
		0xd4e9
		},
		{
		0x9830,
		0xfafa
		},
		{
		0x9838,
		0xccf2
		},
		{
		0x9839,
		0xf7dd
		},
		{
		0x983b,
		0xdeba
		},
		{
		0x9846,
		0xcea8
		},
		{
		0x984c,
		0xf0b9
		},
		{
		0x984d,
		0xe4fe
		},
		{
		0x984e,
		0xe4c9
		},
		{
		0x9854,
		0xe4d4
		},
		{
		0x9858,
		0xeac3
		},
		{
		0x985a,
		0xefb4
		},
		{
		0x985e,
		0xd7be
		},
		{
		0x9865,
		0xfbe2
		},
		{
		0x9867,
		0xcdd3
		},
		{
		0x986b,
		0xefb5
		},
		{
		0x986f,
		0xfae9
		},
		{
		0x98a8,
		0xf9a6
		},
		{
		0x98af,
		0xdfbd
		},
		{
		0x98b1,
		0xf7c7
		},
		{
		0x98c4,
		0xf8fd
		},
		{
		0x98c7,
		0xf8fc
		},
		{
		0x98db,
		0xdeab
		},
		{
		0x98dc,
		0xdbe8
		},
		{
		0x98df,
		0xe3dd
		},
		{
		0x98e1,
		0xe1e2
		},
		{
		0x98e2,
		0xd1c6
		},
		{
		0x98ed,
		0xf6d0
		},
		{
		0x98ee,
		0xebe6
		},
		{
		0x98ef,
		0xdaf9
		},
		{
		0x98f4,
		0xecc7
		},
		{
		0x98fc,
		0xdef8
		},
		{
		0x98fd,
		0xf8e9
		},
		{
		0x98fe,
		0xe3de
		},
		{
		0x9903,
		0xcef5
		},
		{
		0x9909,
		0xfac3
		},
		{
		0x990a,
		0xe5d7
		},
		{
		0x990c,
		0xecc8
		},
		{
		0x9910,
		0xf3c9
		},
		{
		0x9913,
		0xe4bb
		},
		{
		0x9918,
		0xe6ae
		},
		{
		0x991e,
		0xefb6
		},
		{
		0x9920,
		0xdcbf
		},
		{
		0x9928,
		0xcebd
		},
		{
		0x9945,
		0xd8c3
		},
		{
		0x9949,
		0xd0cf
		},
		{
		0x994b,
		0xcffa
		},
		{
		0x994c,
		0xf3ca
		},
		{
		0x994d,
		0xe0d7
		},
		{
		0x9951,
		0xd1c7
		},
		{
		0x9952,
		0xe9ae
		},
		{
		0x9954,
		0xe8bd
		},
		{
		0x9957,
		0xfac4
		},
		{
		0x9996,
		0xe2cf
		},
		{
		0x9999,
		0xfac5
		},
		{
		0x999d,
		0xf9b8
		},
		{
		0x99a5,
		0xdce0
		},
		{
		0x99a8,
		0xfbb0
		},
		{
		0x99ac,
		0xd8a9
		},
		{
		0x99ad,
		0xe5df
		},
		{
		0x99ae,
		0xf9a7
		},
		{
		0x99b1,
		0xf6ee
		},
		{
		0x99b3,
		0xf6cc
		},
		{
		0x99b4,
		0xe2f8
		},
		{
		0x99b9,
		0xecf1
		},
		{
		0x99c1,
		0xdae0
		},
		{
		0x99d0,
		0xf1d2
		},
		{
		0x99d1,
		0xd2cc
		},
		{
		0x99d2,
		0xcfcb
		},
		{
		0x99d5,
		0xcabd
		},
		{
		0x99d9,
		0xddbf
		},
		{
		0x99dd,
		0xf6ef
		},
		{
		0x99df,
		0xdef9
		},
		{
		0x99ed,
		0xfab4
		},
		{
		0x99f1,
		0xd5ad
		},
		{
		0x99ff,
		0xf1e7
		},
		{
		0x9a01,
		0xdebe
		},
		{
		0x9a08,
		0xdcc0
		},
		{
		0x9a0e,
		0xd1c8
		},
		{
		0x9a0f,
		0xd1c9
		},
		{
		0x9a19,
		0xf8be
		},
		{
		0x9a2b,
		0xcbf6
		},
		{
		0x9a30,
		0xd4f9
		},
		{
		0x9a36,
		0xf5e2
		},
		{
		0x9a37,
		0xe1d3
		},
		{
		0x9a40,
		0xd8e9
		},
		{
		0x9a43,
		0xf8fe
		},
		{
		0x9a45,
		0xcfcc
		},
		{
		0x9a4d,
		0xfda4
		},
		{
		0x9a55,
		0xcef6
		},
		{
		0x9a57,
		0xfad0
		},
		{
		0x9a5a,
		0xccf3
		},
		{
		0x9a5b,
		0xe6be
		},
		{
		0x9a5f,
		0xf6ae
		},
		{
		0x9a62,
		0xd5f0
		},
		{
		0x9a65,
		0xd1ca
		},
		{
		0x9a69,
		0xfcbe
		},
		{
		0x9a6a,
		0xd5f1
		},
		{
		0x9aa8,
		0xcde9
		},
		{
		0x9ab8,
		0xfab5
		},
		{
		0x9ad3,
		0xe2d0
		},
		{
		0x9ad4,
		0xf4f7
		},
		{
		0x9ad8,
		0xcdd4
		},
		{
		0x9ae5,
		0xe7a3
		},
		{
		0x9aee,
		0xdba5
		},
		{
		0x9b1a,
		0xe2d1
		},
		{
		0x9b27,
		0xd7a2
		},
		{
		0x9b2a,
		0xf7e3
		},
		{
		0x9b31,
		0xeaa6
		},
		{
		0x9b3c,
		0xd0a1
		},
		{
		0x9b4f,
		0xeae0
		},
		{
		0x9b54,
		0xd8aa
		},
		{
		0x9b5a,
		0xe5e0
		},
		{
		0x9b6f,
		0xd6db
		},
		{
		0x9b8e,
		0xefc6
		},
		{
		0x9b91,
		0xf8ea
		},
		{
		0x9b9f,
		0xe4d5
		},
		{
		0x9bab,
		0xcef7
		},
		{
		0x9bae,
		0xe0d8
		},
		{
		0x9bc9,
		0xd7ef
		},
		{
		0x9bd6,
		0xf4ed
		},
		{
		0x9be4,
		0xcde6
		},
		{
		0x9be8,
		0xccf4
		},
		{
		0x9c0d,
		0xf5e3
		},
		{
		0x9c10,
		0xe4ca
		},
		{
		0x9c12,
		0xdce1
		},
		{
		0x9c15,
		0xf9c8
		},
		{
		0x9c25,
		0xfcbf
		},
		{
		0x9c32,
		0xe8a7
		},
		{
		0x9c3b,
		0xd8c4
		},
		{
		0x9c47,
		0xcbbe
		},
		{
		0x9c49,
		0xdcae
		},
		{
		0x9c57,
		0xd7f7
		},
		{
		0x9ce5,
		0xf0e8
		},
		{
		0x9ce7,
		0xddc0
		},
		{
		0x9ce9,
		0xcfcd
		},
		{
		0x9cf3,
		0xdcf3
		},
		{
		0x9cf4,
		0xd9b0
		},
		{
		0x9cf6,
		0xe6e9
		},
		{
		0x9d09,
		0xe4bc
		},
		{
		0x9d1b,
		0xeac4
		},
		{
		0x9d26,
		0xe4ec
		},
		{
		0x9d28,
		0xe4e5
		},
		{
		0x9d3b,
		0xfbf8
		},
		{
		0x9d51,
		0xccbb
		},
		{
		0x9d5d,
		0xe4bd
		},
		{
		0x9d60,
		0xcddc
		},
		{
		0x9d61,
		0xd9f7
		},
		{
		0x9d6c,
		0xdddf
		},
		{
		0x9d72,
		0xedce
		},
		{
		0x9da9,
		0xd9d0
		},
		{
		0x9daf,
		0xe5a3
		},
		{
		0x9db4,
		0xf9cd
		},
		{
		0x9dc4,
		0xcdae
		},
		{
		0x9dd7,
		0xcfce
		},
		{
		0x9df2,
		0xf6af
		},
		{
		0x9df8,
		0xfdd3
		},
		{
		0x9df9,
		0xebed
		},
		{
		0x9dfa,
		0xd6dc
		},
		{
		0x9e1a,
		0xe5a4
		},
		{
		0x9e1e,
		0xd5b6
		},
		{
		0x9e75,
		0xd6dd
		},
		{
		0x9e79,
		0xf9e9
		},
		{
		0x9e7d,
		0xe7a4
		},
		{
		0x9e7f,
		0xd6e3
		},
		{
		0x9e92,
		0xd1cb
		},
		{
		0x9e93,
		0xd6e4
		},
		{
		0x9e97,
		0xd5f2
		},
		{
		0x9e9d,
		0xdefa
		},
		{
		0x9e9f,
		0xd7f8
		},
		{
		0x9ea5,
		0xd8ea
		},
		{
		0x9eb4,
		0xcfd5
		},
		{
		0x9eb5,
		0xd8fd
		},
		{
		0x9ebb,
		0xd8ab
		},
		{
		0x9ebe,
		0xfdcb
		},
		{
		0x9ec3,
		0xfcdc
		},
		{
		0x9ecd,
		0xe0a8
		},
		{
		0x9ece,
		0xd5f3
		},
		{
		0x9ed1,
		0xfdd9
		},
		{
		0x9ed4,
		0xcca3
		},
		{
		0x9ed8,
		0xd9f9
		},
		{
		0x9edb,
		0xd3ea
		},
		{
		0x9edc,
		0xf5f5
		},
		{
		0x9ede,
		0xefc7
		},
		{
		0x9ee8,
		0xd3da
		},
		{
		0x9ef4,
		0xdabd
		},
		{
		0x9f07,
		0xe8a8
		},
		{
		0x9f08,
		0xdcaf
		},
		{
		0x9f0e,
		0xf0a3
		},
		{
		0x9f13,
		0xcdd5
		},
		{
		0x9f20,
		0xe0a9
		},
		{
		0x9f3b,
		0xdeac
		},
		{
		0x9f4a,
		0xf0ba
		},
		{
		0x9f4b,
		0xeeb1
		},
		{
		0x9f4e,
		0xeeb2
		},
		{
		0x9f52,
		0xf6cd
		},
		{
		0x9f5f,
		0xeed2
		},
		{
		0x9f61,
		0xd6c6
		},
		{
		0x9f67,
		0xe0e5
		},
		{
		0x9f6a,
		0xf3bb
		},
		{
		0x9f6c,
		0xe5e1
		},
		{
		0x9f77,
		0xe4cb
		},
		{
		0x9f8d,
		0xd7a3
		},
		{
		0x9f90,
		0xdbc2
		},
		{
		0x9f95,
		0xcafe
		},
		{
		0x9f9c,
		0xcfcf
		},
		{
		0xac18,
		0x814a
		},
		{
		0xac4b,
		0xb0c0
		},
		{
		0xac4c,
		0x8173
		},
		{
		0xac4d,
		0xb0c1
		},
		{
		0xacd5,
		0xb0eb
		},
		{
		0xacd6,
		0x81d8
		},
		{
		0xacd7,
		0xb0ec
		},
		{
		0xad61,
		0xb1b6
		},
		{
		0xad62,
		0x8289
		},
		{
		0xad63,
		0xb1b7
		},
		{
		0xad9c,
		0xb1c9
		},
		{
		0xad9d,
		0xb1ca
		},
		{
		0xada4,
		0xb1cb
		},
		{
		0xadb7,
		0xb1cc
		},
		{
		0xadd0,
		0xb1d1
		},
		{
		0xadd1,
		0xb1d2
		},
		{
		0xadd2,
		0x82dd
		},
		{
		0xadd3,
		0xb1d3
		},
		{
		0xae14,
		0xb1e1
		},
		{
		0xae84,
		0xb2a5
		},
		{
		0xae85,
		0xb2a6
		},
		{
		0xae8c,
		0xb2a7
		},
		{
		0xaf50,
		0xb2cc
		},
		{
		0xaf5c,
		0xb2cd
		},
		{
		0xaf5d,
		0xb2ce
		},
		{
		0xaf64,
		0xb2cf
		},
		{
		0xaf65,
		0xb2d0
		},
		{
		0xaf79,
		0xb2d1
		},
		{
		0xaf9c,
		0xb2d8
		},
		{
		0xafd4,
		0xb2e3
		},
		{
		0xafdc,
		0xb2e4
		},
		{
		0xafe8,
		0xb2e5
		},
		{
		0xafe9,
		0xb2e6
		},
		{
		0xb01c,
		0xb2f1
		},
		{
		0xb01d,
		0xb2f2
		},
		{
		0xb028,
		0xb2f3
		},
		{
		0xb1a8,
		0xb3f9
		},
		{
		0xb1dc,
		0xb3fd
		},
		{
		0xb1dd,
		0xb3fe
		},
		{
		0xb1de,
		0x8787
		},
		{
		0xb1df,
		0xb4a1
		},
		{
		0xb220,
		0xb4b2
		},
		{
		0xb234,
		0xb4b3
		},
		{
		0xb23c,
		0xb4b4
		},
		{
		0xb268,
		0xb4b8
		},
		{
		0xb269,
		0xb4b9
		},
		{
		0xb274,
		0xb4ba
		},
		{
		0xb275,
		0xb4bb
		},
		{
		0xb27c,
		0xb4bc
		},
		{
		0xb31c,
		0xb4f4
		},
		{
		0xb3a0,
		0xb5b1
		},
		{
		0xb3a1,
		0xb5b2
		},
		{
		0xb3fc,
		0xb5c5
		},
		{
		0xb410,
		0xb5c6
		},
		{
		0xb428,
		0xb5ca
		},
		{
		0xb429,
		0xb5cb
		},
		{
		0xb42a,
		0x89e6
		},
		{
		0xb42b,
		0xb5cc
		},
		{
		0xb434,
		0xb5cd
		},
		{
		0xb46c,
		0xb5d6
		},
		{
		0xb480,
		0xb5d7
		},
		{
		0xb481,
		0x8a79
		},
		{
		0xb482,
		0x8a7a
		},
		{
		0xb488,
		0xb5d8
		},
		{
		0xb49d,
		0xb5d9
		},
		{
		0xb4f8,
		0xb5ef
		},
		{
		0xb5d8,
		0xb6c5
		},
		{
		0xb5ec,
		0xb6c6
		},
		{
		0xb625,
		0xb6cb
		},
		{
		0xb62c,
		0xb6cc
		},
		{
		0xb634,
		0xb6cd
		},
		{
		0xb648,
		0xb6ce
		},
		{
		0xb6d4,
		0xb6d8
		},
		{
		0xb738,
		0xb6e4
		},
		{
		0xb739,
		0xb6e5
		},
		{
		0xb73a,
		0x8db6
		},
		{
		0xb73b,
		0xb6e6
		},
		{
		0xb754,
		0xb6ea
		},
		{
		0xb755,
		0xb6eb
		},
		{
		0xb7c7,
		0xb7ad
		},
		{
		0xb7c8,
		0x8e66
		},
		{
		0xb7c9,
		0xb7ae
		},
		{
		0xb851,
		0xb7cc
		},
		{
		0xb852,
		0x8ed7
		},
		{
		0xb853,
		0xb7cd
		},
		{
		0xb88d,
		0xb7d8
		},
		{
		0xb8a8,
		0xb7d9
		},
		{
		0xb904,
		0xb7ef
		},
		{
		0xb918,
		0xb7f0
		},
		{
		0xb920,
		0xb7f1
		},
		{
		0xba00,
		0xb8cf
		},
		{
		0xba01,
		0xb8d0
		},
		{
		0xba08,
		0xb8d1
		},
		{
		0xba15,
		0xb8d2
		},
		{
		0xbad8,
		0xb8fc
		},
		{
		0xbad9,
		0xb8fd
		},
		{
		0xbb28,
		0x9241
		},
		{
		0xbb29,
		0xb9a9
		},
		{
		0xbb2a,
		0x9242
		},
		{
		0xbb2b,
		0xb9aa
		},
		{
		0xbb61,
		0xb9bc
		},
		{
		0xbb62,
		0x926d
		},
		{
		0xbb63,
		0xb9bd
		},
		{
		0xbb6c,
		0xb9be
		},
		{
		0xbbb4,
		0xb9c5
		},
		{
		0xbbb5,
		0x92bd
		},
		{
		0xbbb6,
		0x92be
		},
		{
		0xbbb7,
		0xb9c6
		},
		{
		0xbbd0,
		0xb9ca
		},
		{
		0xbbd1,
		0x92d4
		},
		{
		0xbbd2,
		0x92d5
		},
		{
		0xbbd3,
		0xb9cb
		},
		{
		0xbc19,
		0x934b
		},
		{
		0xbc1a,
		0x934c
		},
		{
		0xbc5a,
		0x9381
		},
		{
		0xbc5b,
		0x9382
		},
		{
		0xbc5c,
		0x9383
		},
		{
		0xbc5d,
		0xb9f5
		},
		{
		0xbd24,
		0xbac3
		},
		{
		0xbd2c,
		0xbac4
		},
		{
		0xbd40,
		0xbac5
		},
		{
		0xbd58,
		0xbaca
		},
		{
		0xbd59,
		0xbacb
		},
		{
		0xbda4,
		0xbadc
		},
		{
		0xbdb0,
		0xbadd
		},
		{
		0xbdb8,
		0xbade
		},
		{
		0xbde9,
		0xbae3
		},
		{
		0xbe1c,
		0xbaee
		},
		{
		0xbe1d,
		0xbaef
		},
		{
		0xbe1e,
		0x9588
		},
		{
		0xbe1f,
		0xbaf0
		},
		{
		0xbe98,
		0xbbb2
		},
		{
		0xbe99,
		0xbbb3
		},
		{
		0xbea8,
		0xbbb4
		},
		{
		0xbeec,
		0xbbbe
		},
		{
		0xbf01,
		0xbbbf
		},
		{
		0xbf08,
		0xbbc0
		},
		{
		0xbf09,
		0xbbc1
		},
		{
		0xbf94,
		0xbbce
		},
		{
		0xbfb0,
		0xbbcf
		},
		{
		0xbfc5,
		0xbbd0
		},
		{
		0xc03c,
		0xbbd8
		},
		{
		0xc03d,
		0x97fc
		},
		{
		0xc03e,
		0x97fd
		},
		{
		0xc03f,
		0x97fe
		},
		{
		0xc051,
		0xbbd9
		},
		{
		0xc068,
		0xbbdd
		},
		{
		0xc069,
		0xbbde
		},
		{
		0xc185,
		0xbcd1
		},
		{
		0xc1bd,
		0xbce1
		},
		{
		0xc1f0,
		0xbceb
		},
		{
		0xc1f1,
		0xbcec
		},
		{
		0xc1f2,
		0x99db
		},
		{
		0xc1f3,
		0xbced
		},
		{
		0xc246,
		0x9a61
		},
		{
		0xc247,
		0x9a62
		},
		{
		0xc248,
		0xbda5
		},
		{
		0xc288,
		0xbdb4
		},
		{
		0xc289,
		0xbdb5
		},
		{
		0xc290,
		0xbdb6
		},
		{
		0xc345,
		0xbde0
		},
		{
		0xc3c0,
		0xbded
		},
		{
		0xc408,
		0xbdfa
		},
		{
		0xc410,
		0xbdfb
		},
		{
		0xc424,
		0xbdfc
		},
		{
		0xc43c,
		0xbea2
		},
		{
		0xc43d,
		0xbea3
		},
		{
		0xc448,
		0xbea4
		},
		{
		0xc480,
		0xbeac
		},
		{
		0xc494,
		0xbead
		},
		{
		0xc49c,
		0xbeae
		},
		{
		0xc4e9,
		0xbeb1
		},
		{
		0xc51c,
		0xbebd
		},
		{
		0xc5a9,
		0xbeed
		},
		{
		0xc768,
		0xc0ca
		},
		{
		0xc769,
		0x9fd0
		},
		{
		0xc76a,
		0x9fd1
		},
		{
		0xc76b,
		0xc0cb
		},
		{
		0xc854,
		0xc1b5
		},
		{
		0xc894,
		0xc1c4
		},
		{
		0xc8f5,
		0xc1d5
		},
		{
		0xc918,
		0xc1e0
		},
		{
		0xc92c,
		0xc1e1
		},
		{
		0xc934,
		0xc1e2
		},
		{
		0xc960,
		0xc1e7
		},
		{
		0xc961,
		0xc1e8
		},
		{
		0xc962,
		0xa295
		},
		{
		0xc963,
		0xc1e9
		},
		{
		0xc97c,
		0xc1ed
		},
		{
		0xca26,
		0xa481
		},
		{
		0xca27,
		0xa482
		},
		{
		0xca28,
		0xa483
		},
		{
		0xca29,
		0xc2bb
		},
		{
		0xca68,
		0xc2c5
		},
		{
		0xca69,
		0xa559
		},
		{
		0xca6a,
		0xa55a
		},
		{
		0xca7d,
		0xc2c6
		},
		{
		0xca84,
		0xc2c7
		},
		{
		0xca85,
		0xa579
		},
		{
		0xca86,
		0xa57a
		},
		{
		0xca98,
		0xc2c8
		},
		{
		0xcae0,
		0xc2d4
		},
		{
		0xcaf4,
		0xc2d6
		},
		{
		0xcb08,
		0xc2d7
		},
		{
		0xcb09,
		0xa69f
		},
		{
		0xcb0a,
		0xa6a0
		},
		{
		0xcb20,
		0xc2db
		},
		{
		0xcb21,
		0xc2dc
		},
		{
		0xcb64,
		0xc2e5
		},
		{
		0xcb78,
		0xc2e6
		},
		{
		0xcb79,
		0xc2e7
		},
		{
		0xcb9c,
		0xc2e8
		},
		{
		0xcbb8,
		0xc2e9
		},
		{
		0xcbd4,
		0xc2ea
		},
		{
		0xcce4,
		0xc3c6
		},
		{
		0xccfe,
		0xac41
		},
		{
		0xccff,
		0xac42
		},
		{
		0xcd00,
		0xac43
		},
		{
		0xcd01,
		0xc3c9
		},
		{
		0xcd39,
		0xc3d5
		},
		{
		0xcd78,
		0xc3dd
		},
		{
		0xcd88,
		0xc3de
		},
		{
		0xcdb0,
		0xc3e7
		},
		{
		0xcdc4,
		0xc3e8
		},
		{
		0xcdc5,
		0xada0
		},
		{
		0xceac,
		0xc4bc
		},
		{
		0xcead,
		0xc4bd
		},
		{
		0xcec1,
		0xc4be
		},
		{
		0xcf38,
		0xc4d9
		},
		{
		0xcf8c,
		0xc4e8
		},
		{
		0xcf8d,
		0xb25a
		},
		{
		0xcfa1,
		0xc4e9
		},
		{
		0xcfa8,
		0xc4ea
		},
		{
		0xcfa9,
		0xb27a
		},
		{
		0xcfb0,
		0xc4eb
		},
		{
		0xcfc4,
		0xc4ec
		},
		{
		0xd011,
		0xc4f8
		},
		{
		0xd018,
		0xc4f9
		},
		{
		0xd02d,
		0xc4fa
		},
		{
		0xd060,
		0xc5a8
		},
		{
		0xd0f8,
		0xc5cb
		},
		{
		0xd10d,
		0xc5cc
		},
		{
		0xd17c,
		0xc5e1
		},
		{
		0xd1d8,
		0xc5ef
		},
		{
		0xd207,
		0xc5f2
		},
		{
		0xd208,
		0xb881
		},
		{
		0xd209,
		0xc5f3
		},
		{
		0xd210,
		0xc5f4
		},
		{
		0xd25c,
		0xc5fe
		},
		{
		0xd2c8,
		0xc6b4
		},
		{
		0xd2c9,
		0xc6b5
		},
		{
		0xd2ca,
		0xba74
		},
		{
		0xd2cb,
		0xc6b6
		},
		{
		0xd2e4,
		0xc6ba
		},
		{
		0xd2e5,
		0xc6bb
		},
		{
		0xd3d0,
		0xc6f3
		},
		{
		0xd3d7,
		0xbd41
		},
		{
		0xd3d8,
		0xc6f4
		},
		{
		0xd3e1,
		0xc6f5
		},
		{
		0xd3e2,
		0xbd4a
		},
		{
		0xd3e3,
		0xc6f6
		},
		{
		0xd408,
		0xc7a1
		},
		{
		0xd41d,
		0xc7a2
		},
		{
		0xd494,
		0xc7b4
		},
		{
		0xd4a9,
		0xc7b5
		},
		{
		0xd4dc,
		0xc7b9
		},
		{
		0xd4dd,
		0xbf87
		},
		{
		0xd4de,
		0xbf88
		},
		{
		0xd4df,
		0xc7ba
		},
		{
		0xd514,
		0xc7c4
		},
		{
		0xd515,
		0xc7c5
		},
		{
		0xd516,
		0xc054
		},
		{
		0xd517,
		0xc7c6
		},
		{
		0xd5a5,
		0xc7e2
		},
		{
		0xd5a6,
		0xc179
		},
		{
		0xd5a7,
		0xc17a
		},
		{
		0xd62d,
		0xc8a2
		},
		{
		0xd667,
		0xc8b1
		},
		{
		0xd668,
		0xc366
		},
		{
		0xd669,
		0xc8b2
		},
		{
		0xd6b9,
		0xc8c2
		},
		{
		0xd6ba,
		0xc44d
		},
		{
		0xd6bb,
		0xc8c3
		},
		{
		0xff3c,
		0xa1ac
		},
		{
		0xff5e,
		0xa2a6
		},
		{
		0xffe0,
		0xa1cb
		},
		{
		0xffe1,
		0xa1cc
		},
		{
		0xffe2,
		0xa1fe
		},
		{
		0xffe3,
		0xa3fe
		},
		{
		0xffe5,
		0xa1cd
		},
		{
		0xffe6,
		0xa3dc
		}
	};

LOCAL_D const SCnvConversionData::SVariableByteData::SRange foreignVariableByteDataRanges[]=
	{
		{
		0x00,
		0x7f,
		0,
		0
		},
		{
		0x81,
		0xff,
		1,
		0
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange foreignToUnicodeDataRanges[]=
	{
		{
		0x00,
		0x7f,
		SCnvConversionData::SOneDirectionData::SRange::EDirect,
		0,
		0,
			{
			0
			}
		},
		{
		0xd2f0,
		0xd2f5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9826)
			}
		},
		{
		0xd2e4,
		0xd2eb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9830)
			}
		},
		{
		0xd2cd,
		0xd2d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9836)
			}
		},
		{
		0xd2c6,
		0xd2cb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9837)
			}
		},
		{
		0xd2a7,
		0xd2ab,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9857)
			}
		},
		{
		0xd1e2,
		0xd1e6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10034)
			}
		},
		{
		0xd1db,
		0xd1e0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10035)
			}
		},
		{
		0xc64d,
		0xc652,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4433)
			}
		},
		{
		0xc644,
		0xc64a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4429)
			}
		},
		{
		0xc599,
		0xc59e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4585)
			}
		},
		{
		0xc58f,
		0xc595,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4582)
			}
		},
		{
		0xc576,
		0xc57a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4580)
			}
		},
		{
		0xc56d,
		0xc572,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4573)
			}
		},
		{
		0xc563,
		0xc569,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4570)
			}
		},
		{
		0xc552,
		0xc557,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4572)
			}
		},
		{
		0xc549,
		0xc54f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4568)
			}
		},
		{
		0xc492,
		0xc49d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4723)
			}
		},
		{
		0xc487,
		0xc48c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4719)
			}
		},
		{
		0xc476,
		0xc47a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4723)
			}
		},
		{
		0xc46a,
		0xc46f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4720)
			}
		},
		{
		0xc44e,
		0xc455,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4718)
			}
		},
		{
		0xc445,
		0xc44c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4716)
			}
		},
		{
		0xc399,
		0xc39e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4873)
			}
		},
		{
		0xc38f,
		0xc396,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4870)
			}
		},
		{
		0xc384,
		0xc389,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4866)
			}
		},
		{
		0xc36f,
		0xc37a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4870)
			}
		},
		{
		0xc367,
		0xc36c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4867)
			}
		},
		{
		0xc361,
		0xc365,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4865)
			}
		},
		{
		0xc356,
		0xc35a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 4871)
			}
		},
		{
		0xc295,
		0xc29e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5017)
			}
		},
		{
		0xc28d,
		0xc294,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5016)
			}
		},
		{
		0xc281,
		0xc286,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5013)
			}
		},
		{
		0xc273,
		0xc279,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5014)
			}
		},
		{
		0xc268,
		0xc26d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5010)
			}
		},
		{
		0xc261,
		0xc265,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5006)
			}
		},
		{
		0xc24e,
		0xc253,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5008)
			}
		},
		{
		0xc247,
		0xc24b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5004)
			}
		},
		{
		0xc181,
		0xc1a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5159)
			}
		},
		{
		0xc165,
		0xc178,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5164)
			}
		},
		{
		0xc151,
		0xc157,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5164)
			}
		},
		{
		0xc146,
		0xc14b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5160)
			}
		},
		{
		0xc0c0,
		0xc0c7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 1681)
			}
		},
		{
		0xc093,
		0xc098,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5311)
			}
		},
		{
		0xc08a,
		0xc090,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5307)
			}
		},
		{
		0xc061,
		0xc07a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5309)
			}
		},
		{
		0xc055,
		0xc05a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5315)
			}
		},
		{
		0xc04d,
		0xc053,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5312)
			}
		},
		{
		0xc041,
		0xc046,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5309)
			}
		},
		{
		0xbfb0,
		0xbfb5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 1612)
			}
		},
		{
		0xbf97,
		0xbf9d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5466)
			}
		},
		{
		0xbf89,
		0xbf90,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5463)
			}
		},
		{
		0xbf81,
		0xbf86,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5461)
			}
		},
		{
		0xbf61,
		0xbf73,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5464)
			}
		},
		{
		0xbf4c,
		0xbf5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5470)
			}
		},
		{
		0xbf41,
		0xbf4b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5469)
			}
		},
		{
		0xbef6,
		0xbefc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 1742)
			}
		},
		{
		0xbe98,
		0xbea0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5629)
			}
		},
		{
		0xbe92,
		0xbe97,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5628)
			}
		},
		{
		0xbe8b,
		0xbe8f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5624)
			}
		},
		{
		0xbe81,
		0xbe85,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5618)
			}
		},
		{
		0xbe6f,
		0xbe76,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5622)
			}
		},
		{
		0xbe61,
		0xbe68,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5619)
			}
		},
		{
		0xbe4c,
		0xbe5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5625)
			}
		},
		{
		0xbe41,
		0xbe48,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5623)
			}
		},
		{
		0xbd87,
		0xbda0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5783)
			}
		},
		{
		0xbd81,
		0xbd86,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5782)
			}
		},
		{
		0xbd6d,
		0xbd7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5788)
			}
		},
		{
		0xbd67,
		0xbd6c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5787)
			}
		},
		{
		0xbd4b,
		0xbd52,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5785)
			}
		},
		{
		0xbd42,
		0xbd49,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5783)
			}
		},
		{
		0xbcad,
		0xbcb1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 1135)
			}
		},
		{
		0xbc9b,
		0xbca0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5942)
			}
		},
		{
		0xbc95,
		0xbc9a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5941)
			}
		},
		{
		0xbc8c,
		0xbc92,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5937)
			}
		},
		{
		0xbc81,
		0xbc85,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5934)
			}
		},
		{
		0xbc71,
		0xbc77,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5936)
			}
		},
		{
		0xbc66,
		0xbc6b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5932)
			}
		},
		{
		0xbc41,
		0xbc52,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 5929)
			}
		},
		{
		0xbb81,
		0xbba0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6089)
			}
		},
		{
		0xbb71,
		0xbb76,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6093)
			}
		},
		{
		0xbb69,
		0xbb6f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6088)
			}
		},
		{
		0xbb53,
		0xbb57,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6084)
			}
		},
		{
		0xbb48,
		0xbb4d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6078)
			}
		},
		{
		0xbb41,
		0xbb45,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6074)
			}
		},
		{
		0xba90,
		0xba99,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6230)
			}
		},
		{
		0xba89,
		0xba8f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6228)
			}
		},
		{
		0xba75,
		0xba7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6231)
			}
		},
		{
		0xba6f,
		0xba73,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6228)
			}
		},
		{
		0xba64,
		0xba69,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6222)
			}
		},
		{
		0xba53,
		0xba59,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6226)
			}
		},
		{
		0xba47,
		0xba4c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6223)
			}
		},
		{
		0xb9de,
		0xb9e2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 573)
			}
		},
		{
		0xb9d9,
		0xb9dd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 571)
			}
		},
		{
		0xb981,
		0xb997,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6376)
			}
		},
		{
		0xb970,
		0xb976,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6381)
			}
		},
		{
		0xb961,
		0xb96f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6380)
			}
		},
		{
		0xb951,
		0xb956,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6385)
			}
		},
		{
		0xb948,
		0xb94e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6381)
			}
		},
		{
		0xb8b9,
		0xb8bd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 277)
			}
		},
		{
		0xb888,
		0xb8a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6537)
			}
		},
		{
		0xb882,
		0xb887,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6536)
			}
		},
		{
		0xb86d,
		0xb87a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6540)
			}
		},
		{
		0xb861,
		0xb869,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6538)
			}
		},
		{
		0xb849,
		0xb85a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6544)
			}
		},
		{
		0xb841,
		0xb848,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6543)
			}
		},
		{
		0xb792,
		0xb7a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6703)
			}
		},
		{
		0xb781,
		0xb787,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6696)
			}
		},
		{
		0xb761,
		0xb775,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6698)
			}
		},
		{
		0xb74f,
		0xb755,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6702)
			}
		},
		{
		0xb741,
		0xb74e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6701)
			}
		},
		{
		0xb697,
		0xb69c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6859)
			}
		},
		{
		0xb68e,
		0xb694,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6855)
			}
		},
		{
		0xb683,
		0xb688,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6851)
			}
		},
		{
		0xb661,
		0xb670,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6847)
			}
		},
		{
		0xb649,
		0xb65a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6853)
			}
		},
		{
		0xb641,
		0xb648,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6852)
			}
		},
		{
		0xb595,
		0xb5a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7012)
			}
		},
		{
		0xb58f,
		0xb594,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7011)
			}
		},
		{
		0xb587,
		0xb58d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7006)
			}
		},
		{
		0xb576,
		0xb57a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7008)
			}
		},
		{
		0xb56f,
		0xb574,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7003)
			}
		},
		{
		0xb564,
		0xb569,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6998)
			}
		},
		{
		0xb555,
		0xb55a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7000)
			}
		},
		{
		0xb541,
		0xb54f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 6996)
			}
		},
		{
		0xb4e5,
		0xb4e9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -494)
			}
		},
		{
		0xb4dd,
		0xb4e1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -498)
			}
		},
		{
		0xb48e,
		0xb4a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7156)
			}
		},
		{
		0xb484,
		0xb48a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7153)
			}
		},
		{
		0xb46e,
		0xb478,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7155)
			}
		},
		{
		0xb467,
		0xb46d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7154)
			}
		},
		{
		0xb455,
		0xb45a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7157)
			}
		},
		{
		0xb44c,
		0xb452,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7153)
			}
		},
		{
		0xb441,
		0xb446,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7149)
			}
		},
		{
		0xb3b4,
		0xb3b8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -777)
			}
		},
		{
		0xb38d,
		0xb3a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7308)
			}
		},
		{
		0xb387,
		0xb38c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7307)
			}
		},
		{
		0xb381,
		0xb386,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7306)
			}
		},
		{
		0xb375,
		0xb37a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7312)
			}
		},
		{
		0xb369,
		0xb36e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7309)
			}
		},
		{
		0xb361,
		0xb366,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7305)
			}
		},
		{
		0xb341,
		0xb354,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7307)
			}
		},
		{
		0xb29a,
		0xb2a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7467)
			}
		},
		{
		0xb287,
		0xb299,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7466)
			}
		},
		{
		0xb281,
		0xb286,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7465)
			}
		},
		{
		0xb274,
		0xb279,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7470)
			}
		},
		{
		0xb261,
		0xb273,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7469)
			}
		},
		{
		0xb254,
		0xb259,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7474)
			}
		},
		{
		0xb249,
		0xb24f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7472)
			}
		},
		{
		0xb195,
		0xb19b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7624)
			}
		},
		{
		0xb181,
		0xb18f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7620)
			}
		},
		{
		0xb16f,
		0xb17a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7626)
			}
		},
		{
		0xb169,
		0xb16e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7625)
			}
		},
		{
		0xb161,
		0xb167,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7620)
			}
		},
		{
		0xb14f,
		0xb154,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7623)
			}
		},
		{
		0xb146,
		0xb14c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7619)
			}
		},
		{
		0xb0b0,
		0xb0b4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -1175)
			}
		},
		{
		0xb0a8,
		0xb0af,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -1176)
			}
		},
		{
		0xb09b,
		0xb0a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7775)
			}
		},
		{
		0xb093,
		0xb099,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7770)
			}
		},
		{
		0xb081,
		0xb08e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7765)
			}
		},
		{
		0xb067,
		0xb07a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7771)
			}
		},
		{
		0xb061,
		0xb066,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7770)
			}
		},
		{
		0xb04e,
		0xb05a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7776)
			}
		},
		{
		0xb048,
		0xb04d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7774)
			}
		},
		{
		0xb041,
		0xb046,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7769)
			}
		},
		{
		0xaf95,
		0xaf9a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7925)
			}
		},
		{
		0xaf8c,
		0xaf92,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7921)
			}
		},
		{
		0xaf81,
		0xaf86,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7917)
			}
		},
		{
		0xaf73,
		0xaf78,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7919)
			}
		},
		{
		0xaf61,
		0xaf6e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7913)
			}
		},
		{
		0xaf47,
		0xaf5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 7919)
			}
		},
		{
		0xae93,
		0xae98,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8071)
			}
		},
		{
		0xae88,
		0xae8e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8069)
			}
		},
		{
		0xae76,
		0xae7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8072)
			}
		},
		{
		0xae6d,
		0xae73,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8068)
			}
		},
		{
		0xae61,
		0xae66,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8065)
			}
		},
		{
		0xae4a,
		0xae5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8071)
			}
		},
		{
		0xae41,
		0xae46,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8069)
			}
		},
		{
		0xad8d,
		0xad9f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8228)
			}
		},
		{
		0xad87,
		0xad8c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8227)
			}
		},
		{
		0xad68,
		0xad72,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8225)
			}
		},
		{
		0xad61,
		0xad67,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8224)
			}
		},
		{
		0xad53,
		0xad5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8230)
			}
		},
		{
		0xad4d,
		0xad52,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8229)
			}
		},
		{
		0xad44,
		0xad4a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8225)
			}
		},
		{
		0xacd8,
		0xacf1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -43170)
			}
		},
		{
		0xacd1,
		0xacd6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -43169)
			}
		},
		{
		0xaca8,
		0xacc1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -43154)
			}
		},
		{
		0xaca1,
		0xaca6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -43153)
			}
		},
		{
		0xac81,
		0xac9d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8382)
			}
		},
		{
		0xac76,
		0xac7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8388)
			}
		},
		{
		0xac6a,
		0xac75,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8387)
			}
		},
		{
		0xac4f,
		0xac55,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8386)
			}
		},
		{
		0xac44,
		0xac49,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8382)
			}
		},
		{
		0xaba1,
		0xabf6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -31488)
			}
		},
		{
		0xab94,
		0xaba0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8541)
			}
		},
		{
		0xab8a,
		0xab90,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8539)
			}
		},
		{
		0xab81,
		0xab89,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8538)
			}
		},
		{
		0xab75,
		0xab7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8544)
			}
		},
		{
		0xab6c,
		0xab71,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8542)
			}
		},
		{
		0xab63,
		0xab69,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8538)
			}
		},
		{
		0xab52,
		0xab57,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8540)
			}
		},
		{
		0xab4a,
		0xab50,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8535)
			}
		},
		{
		0xaaa1,
		0xaaf3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -31328)
			}
		},
		{
		0xaa83,
		0xaaa0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8691)
			}
		},
		{
		0xaa72,
		0xaa78,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8695)
			}
		},
		{
		0xaa67,
		0xaa6c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8691)
			}
		},
		{
		0xaa61,
		0xaa65,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8686)
			}
		},
		{
		0xaa4f,
		0xaa53,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8688)
			}
		},
		{
		0xaa47,
		0xaa4d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8682)
			}
		},
		{
		0xa9e7,
		0xa9f5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -34163)
			}
		},
		{
		0xa9cd,
		0xa9e6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -34097)
			}
		},
		{
		0xa9b1,
		0xa9cc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -30641)
			}
		},
		{
		0xa995,
		0xa99b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8832)
			}
		},
		{
		0xa981,
		0xa98f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8828)
			}
		},
		{
		0xa968,
		0xa97a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8834)
			}
		},
		{
		0xa950,
		0xa95a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8837)
			}
		},
		{
		0xa941,
		0xa94f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8836)
			}
		},
		{
		0xa8e7,
		0xa8f5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -33927)
			}
		},
		{
		0xa8cd,
		0xa8e6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -33789)
			}
		},
		{
		0xa8b1,
		0xa8cc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -30289)
			}
		},
		{
		0xa895,
		0xa8a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8996)
			}
		},
		{
		0xa881,
		0xa894,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 8995)
			}
		},
		{
		0xa874,
		0xa87a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9001)
			}
		},
		{
		0xa861,
		0xa873,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9000)
			}
		},
		{
		0xa84c,
		0xa85a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9006)
			}
		},
		{
		0xa841,
		0xa84b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9004)
			}
		},
		{
		0xa7d4,
		0xa7d8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -29764)
			}
		},
		{
		0xa7ce,
		0xa7d3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -29716)
			}
		},
		{
		0xa7c9,
		0xa7cd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -29769)
			}
		},
		{
		0xa7bf,
		0xa7c8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -29711)
			}
		},
		{
		0xa7ab,
		0xa7b4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -29714)
			}
		},
		{
		0xa799,
		0xa7a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9164)
			}
		},
		{
		0xa793,
		0xa798,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9163)
			}
		},
		{
		0xa789,
		0xa78f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9160)
			}
		},
		{
		0xa761,
		0xa777,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9161)
			}
		},
		{
		0xa753,
		0xa75a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9167)
			}
		},
		{
		0xa74c,
		0xa752,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9165)
			}
		},
		{
		0xa741,
		0xa745,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9162)
			}
		},
		{
		0xa6dd,
		0xa6e4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -33178)
			}
		},
		{
		0xa68c,
		0xa69e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9321)
			}
		},
		{
		0xa685,
		0xa68b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9320)
			}
		},
		{
		0xa674,
		0xa67a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9325)
			}
		},
		{
		0xa66e,
		0xa673,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9324)
			}
		},
		{
		0xa661,
		0xa666,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9317)
			}
		},
		{
		0xa641,
		0xa654,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9319)
			}
		},
		{
		0xa5f2,
		0xa5f8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -41519)
			}
		},
		{
		0xa5e1,
		0xa5f1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -41520)
			}
		},
		{
		0xa5d2,
		0xa5d8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -41519)
			}
		},
		{
		0xa5c1,
		0xa5d1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -41520)
			}
		},
		{
		0xa5b0,
		0xa5b9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -33872)
			}
		},
		{
		0xa5a1,
		0xa5aa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -33841)
			}
		},
		{
		0xa592,
		0xa5a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9479)
			}
		},
		{
		0xa581,
		0xa591,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9478)
			}
		},
		{
		0xa573,
		0xa578,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9483)
			}
		},
		{
		0xa561,
		0xa572,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9482)
			}
		},
		{
		0xa553,
		0xa558,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9487)
			}
		},
		{
		0xa54b,
		0xa551,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9482)
			}
		},
		{
		0xa541,
		0xa545,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9478)
			}
		},
		{
		0xa4a1,
		0xa4fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -29552)
			}
		},
		{
		0xa484,
		0xa4a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9638)
			}
		},
		{
		0xa46e,
		0xa47a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9643)
			}
		},
		{
		0xa465,
		0xa46a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9641)
			}
		},
		{
		0xa44c,
		0xa451,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9638)
			}
		},
		{
		0xa3dd,
		0xa3fd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 23392)
			}
		},
		{
		0xa3a1,
		0xa3db,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 23392)
			}
		},
		{
		0xa397,
		0xa39b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9780)
			}
		},
		{
		0xa381,
		0xa391,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9774)
			}
		},
		{
		0xa36a,
		0xa37a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9780)
			}
		},
		{
		0xa361,
		0xa367,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9776)
			}
		},
		{
		0xa34b,
		0xa355,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9778)
			}
		},
		{
		0xa344,
		0xa34a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9777)
			}
		},
		{
		0xa296,
		0xa29d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9934)
			}
		},
		{
		0xa28e,
		0xa294,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9931)
			}
		},
		{
		0xa281,
		0xa288,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9927)
			}
		},
		{
		0xa268,
		0xa27a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9933)
			}
		},
		{
		0xa261,
		0xa267,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9932)
			}
		},
		{
		0xa248,
		0xa25a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9937)
			}
		},
		{
		0xa242,
		0xa247,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 9936)
			}
		},
		{
		0xa1b4,
		0xa1bd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, -29100)
			}
		},
		{
		0xa19b,
		0xa19f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10092)
			}
		},
		{
		0xa190,
		0xa195,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10086)
			}
		},
		{
		0xa181,
		0xa18f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10085)
			}
		},
		{
		0xa172,
		0xa177,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10088)
			}
		},
		{
		0xa169,
		0xa16f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10084)
			}
		},
		{
		0xa144,
		0xa156,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10085)
			}
		},
		{
		0xa0f2,
		0xa0f9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10147)
			}
		},
		{
		0xa0ec,
		0xa0f1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10146)
			}
		},
		{
		0xa0e2,
		0xa0e6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10137)
			}
		},
		{
		0xa0c1,
		0xa0db,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10132)
			}
		},
		{
		0xa0bb,
		0xa0c0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10131)
			}
		},
		{
		0xa0b2,
		0xa0b8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10127)
			}
		},
		{
		0xa0a6,
		0xa0ab,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10124)
			}
		},
		{
		0xa09d,
		0xa0a3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10120)
			}
		},
		{
		0xa093,
		0xa097,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10116)
			}
		},
		{
		0xa08c,
		0xa090,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10111)
			}
		},
		{
		0xa081,
		0xa085,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10106)
			}
		},
		{
		0xa06d,
		0xa07a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10112)
			}
		},
		{
		0xa061,
		0xa066,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10109)
			}
		},
		{
		0xa050,
		0xa056,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10113)
			}
		},
		{
		0xa046,
		0xa04b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10108)
			}
		},
		{
		0x9ff2,
		0x9ff6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10165)
			}
		},
		{
		0x9fec,
		0x9ff0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10159)
			}
		},
		{
		0x9fd2,
		0x9fd9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10138)
			}
		},
		{
		0x9fc9,
		0x9fcf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10136)
			}
		},
		{
		0x9fbb,
		0x9fbf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10122)
			}
		},
		{
		0x9fa8,
		0x9fae,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10113)
			}
		},
		{
		0x9f9d,
		0x9fa2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10109)
			}
		},
		{
		0x9f94,
		0x9f9a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10105)
			}
		},
		{
		0x9f89,
		0x9f8e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10101)
			}
		},
		{
		0x9f81,
		0x9f85,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10098)
			}
		},
		{
		0x9f6e,
		0x9f73,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10100)
			}
		},
		{
		0x9f65,
		0x9f6b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10096)
			}
		},
		{
		0x9f54,
		0x9f59,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10098)
			}
		},
		{
		0x9f4d,
		0x9f51,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10094)
			}
		},
		{
		0x9f42,
		0x9f47,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10088)
			}
		},
		{
		0x9ef7,
		0x9efd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10150)
			}
		},
		{
		0x9eec,
		0x9ef1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10146)
			}
		},
		{
		0x9ee3,
		0x9ee9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10142)
			}
		},
		{
		0x9ed8,
		0x9edd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10138)
			}
		},
		{
		0x9eca,
		0x9ed4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10135)
			}
		},
		{
		0x9ec2,
		0x9ec7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10132)
			}
		},
		{
		0x9eba,
		0x9ec0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10127)
			}
		},
		{
		0x9e9f,
		0x9ea5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10110)
			}
		},
		{
		0x9e97,
		0x9e9d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10106)
			}
		},
		{
		0x9e70,
		0x9e76,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10089)
			}
		},
		{
		0x9e63,
		0x9e67,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10076)
			}
		},
		{
		0x9e50,
		0x9e59,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10074)
			}
		},
		{
		0x9e48,
		0x9e4f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10073)
			}
		},
		{
		0x9de9,
		0x9dee,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10125)
			}
		},
		{
		0x9de1,
		0x9de7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10120)
			}
		},
		{
		0x9dca,
		0x9dcf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10100)
			}
		},
		{
		0x9dc1,
		0x9dc7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10096)
			}
		},
		{
		0x9db1,
		0x9dbb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10092)
			}
		},
		{
		0x9daa,
		0x9db0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10091)
			}
		},
		{
		0x9d9a,
		0x9da3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10088)
			}
		},
		{
		0x9d8a,
		0x9d8f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10080)
			}
		},
		{
		0x9d81,
		0x9d89,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10079)
			}
		},
		{
		0x9d61,
		0x9d7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10085)
			}
		},
		{
		0x9d52,
		0x9d5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10091)
			}
		},
		{
		0x9d41,
		0x9d4e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10089)
			}
		},
		{
		0x9cf2,
		0x9cfe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10155)
			}
		},
		{
		0x9ceb,
		0x9cf1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10154)
			}
		},
		{
		0x9cd8,
		0x9cea,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10153)
			}
		},
		{
		0x9cd2,
		0x9cd7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10152)
			}
		},
		{
		0x9cc8,
		0x9cce,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10149)
			}
		},
		{
		0x9ca8,
		0x9cc2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10145)
			}
		},
		{
		0x9c9e,
		0x9ca7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10144)
			}
		},
		{
		0x9c97,
		0x9c9d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10142)
			}
		},
		{
		0x9c8a,
		0x9c90,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10139)
			}
		},
		{
		0x9c81,
		0x9c89,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10138)
			}
		},
		{
		0x9c71,
		0x9c7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10144)
			}
		},
		{
		0x9c6a,
		0x9c70,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10143)
			}
		},
		{
		0x9c61,
		0x9c69,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10142)
			}
		},
		{
		0x9c55,
		0x9c5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10148)
			}
		},
		{
		0x9c4d,
		0x9c52,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10145)
			}
		},
		{
		0x9c45,
		0x9c49,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10142)
			}
		},
		{
		0x9be7,
		0x9bfd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10202)
			}
		},
		{
		0x9bb4,
		0x9be6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10201)
			}
		},
		{
		0x9ba8,
		0x9bad,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10198)
			}
		},
		{
		0x9ba1,
		0x9ba5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10194)
			}
		},
		{
		0x9b81,
		0x9b9a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10189)
			}
		},
		{
		0x9b73,
		0x9b7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10195)
			}
		},
		{
		0x9b61,
		0x9b72,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10194)
			}
		},
		{
		0x9b52,
		0x9b5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10200)
			}
		},
		{
		0x9b49,
		0x9b4f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10196)
			}
		},
		{
		0x9af4,
		0x9afa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10253)
			}
		},
		{
		0x9ae3,
		0x9ae8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10242)
			}
		},
		{
		0x9abd,
		0x9ade,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10237)
			}
		},
		{
		0x9ab5,
		0x9aba,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10233)
			}
		},
		{
		0x9aaa,
		0x9aaf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10228)
			}
		},
		{
		0x9aa0,
		0x9aa6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10225)
			}
		},
		{
		0x9a9a,
		0x9a9f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10224)
			}
		},
		{
		0x9a94,
		0x9a99,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10222)
			}
		},
		{
		0x9a8b,
		0x9a91,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10218)
			}
		},
		{
		0x9a81,
		0x9a85,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10214)
			}
		},
		{
		0x9a6f,
		0x9a75,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10218)
			}
		},
		{
		0x9a63,
		0x9a69,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10214)
			}
		},
		{
		0x9a4a,
		0x9a5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10219)
			}
		},
		{
		0x99f2,
		0x99f7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10272)
			}
		},
		{
		0x99e9,
		0x99ef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10268)
			}
		},
		{
		0x99dc,
		0x99e3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10264)
			}
		},
		{
		0x99d4,
		0x99da,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10261)
			}
		},
		{
		0x99c7,
		0x99cd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10258)
			}
		},
		{
		0x99be,
		0x99c4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10255)
			}
		},
		{
		0x99b2,
		0x99b7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10252)
			}
		},
		{
		0x99a6,
		0x99b1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10251)
			}
		},
		{
		0x9995,
		0x9999,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10242)
			}
		},
		{
		0x998a,
		0x998f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10236)
			}
		},
		{
		0x9981,
		0x9989,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10235)
			}
		},
		{
		0x996c,
		0x9971,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10238)
			}
		},
		{
		0x9964,
		0x996a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10233)
			}
		},
		{
		0x9953,
		0x9958,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10235)
			}
		},
		{
		0x994b,
		0x9951,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10230)
			}
		},
		{
		0x98f1,
		0x98f6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10277)
			}
		},
		{
		0x98e6,
		0x98ec,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10275)
			}
		},
		{
		0x98da,
		0x98df,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10272)
			}
		},
		{
		0x98d1,
		0x98d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10268)
			}
		},
		{
		0x98c6,
		0x98cb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10264)
			}
		},
		{
		0x98be,
		0x98c4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10259)
			}
		},
		{
		0x98ae,
		0x98b2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10249)
			}
		},
		{
		0x98a5,
		0x98aa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10241)
			}
		},
		{
		0x989c,
		0x98a2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10237)
			}
		},
		{
		0x9881,
		0x9896,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10233)
			}
		},
		{
		0x986b,
		0x987a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10239)
			}
		},
		{
		0x9864,
		0x986a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10237)
			}
		},
		{
		0x9852,
		0x9857,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10240)
			}
		},
		{
		0x9841,
		0x9851,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10239)
			}
		},
		{
		0x97a2,
		0x97fb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10304)
			}
		},
		{
		0x9798,
		0x979e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10301)
			}
		},
		{
		0x978d,
		0x9792,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10297)
			}
		},
		{
		0x9781,
		0x978c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10296)
			}
		},
		{
		0x9773,
		0x977a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10302)
			}
		},
		{
		0x9761,
		0x9772,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10301)
			}
		},
		{
		0x9752,
		0x975a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10307)
			}
		},
		{
		0x9741,
		0x9751,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10306)
			}
		},
		{
		0x96d2,
		0x96fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10372)
			}
		},
		{
		0x96c8,
		0x96ce,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10369)
			}
		},
		{
		0x96a1,
		0x96c2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10365)
			}
		},
		{
		0x9692,
		0x969f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10360)
			}
		},
		{
		0x968c,
		0x9691,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10358)
			}
		},
		{
		0x9681,
		0x968b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10357)
			}
		},
		{
		0x9672,
		0x967a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10363)
			}
		},
		{
		0x966c,
		0x9671,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10362)
			}
		},
		{
		0x9663,
		0x9669,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10358)
			}
		},
		{
		0x9641,
		0x9658,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10359)
			}
		},
		{
		0x95f0,
		0x95fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10425)
			}
		},
		{
		0x95e2,
		0x95ef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10424)
			}
		},
		{
		0x95dc,
		0x95e1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10422)
			}
		},
		{
		0x95d4,
		0x95da,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10417)
			}
		},
		{
		0x95ca,
		0x95ce,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10412)
			}
		},
		{
		0x95c4,
		0x95c8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10407)
			}
		},
		{
		0x95b3,
		0x95b7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10396)
			}
		},
		{
		0x9589,
		0x95ac,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10391)
			}
		},
		{
		0x9581,
		0x9587,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10388)
			}
		},
		{
		0x9570,
		0x9575,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10390)
			}
		},
		{
		0x9566,
		0x956c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10387)
			}
		},
		{
		0x9554,
		0x9559,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10390)
			}
		},
		{
		0x9548,
		0x9553,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10389)
			}
		},
		{
		0x94e6,
		0x94fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10451)
			}
		},
		{
		0x94df,
		0x94e5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10450)
			}
		},
		{
		0x94d4,
		0x94de,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10449)
			}
		},
		{
		0x94cd,
		0x94d3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10448)
			}
		},
		{
		0x94c2,
		0x94c6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10441)
			}
		},
		{
		0x94a7,
		0x94bd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10434)
			}
		},
		{
		0x949a,
		0x94a3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10432)
			}
		},
		{
		0x9493,
		0x9499,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10430)
			}
		},
		{
		0x9487,
		0x948d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10426)
			}
		},
		{
		0x9481,
		0x9486,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10425)
			}
		},
		{
		0x946e,
		0x947a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10431)
			}
		},
		{
		0x9467,
		0x946d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10430)
			}
		},
		{
		0x9461,
		0x9466,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10429)
			}
		},
		{
		0x9452,
		0x945a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10435)
			}
		},
		{
		0x9449,
		0x944e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10433)
			}
		},
		{
		0x9441,
		0x9446,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10429)
			}
		},
		{
		0x93e3,
		0x93f9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10490)
			}
		},
		{
		0x93d2,
		0x93d9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10483)
			}
		},
		{
		0x93c7,
		0x93cc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10479)
			}
		},
		{
		0x93bf,
		0x93c5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10474)
			}
		},
		{
		0x93b6,
		0x93ba,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10469)
			}
		},
		{
		0x93af,
		0x93b3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10464)
			}
		},
		{
		0x9384,
		0x93a9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10458)
			}
		},
		{
		0x9372,
		0x937a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10463)
			}
		},
		{
		0x9363,
		0x9369,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10454)
			}
		},
		{
		0x9341,
		0x9345,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10434)
			}
		},
		{
		0x92d6,
		0x92f9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10494)
			}
		},
		{
		0x92cd,
		0x92d3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10492)
			}
		},
		{
		0x92bf,
		0x92c6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10489)
			}
		},
		{
		0x92b6,
		0x92bc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10487)
			}
		},
		{
		0x929d,
		0x92af,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10484)
			}
		},
		{
		0x9281,
		0x9296,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10481)
			}
		},
		{
		0x9276,
		0x927a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10487)
			}
		},
		{
		0x926e,
		0x9275,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10486)
			}
		},
		{
		0x9265,
		0x926c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10484)
			}
		},
		{
		0x924e,
		0x9252,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10481)
			}
		},
		{
		0x9243,
		0x924a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10473)
			}
		},
		{
		0x91f8,
		0x91fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10537)
			}
		},
		{
		0x91ec,
		0x91f1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10534)
			}
		},
		{
		0x91e2,
		0x91e9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10531)
			}
		},
		{
		0x91ba,
		0x91db,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10528)
			}
		},
		{
		0x91ab,
		0x91b9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10526)
			}
		},
		{
		0x91a2,
		0x91a7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10524)
			}
		},
		{
		0x919b,
		0x919f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10520)
			}
		},
		{
		0x9181,
		0x9195,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10514)
			}
		},
		{
		0x9175,
		0x917a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10520)
			}
		},
		{
		0x9166,
		0x916f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10515)
			}
		},
		{
		0x9155,
		0x915a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10517)
			}
		},
		{
		0x914d,
		0x9153,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10512)
			}
		},
		{
		0x90d3,
		0x90f4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10563)
			}
		},
		{
		0x90c7,
		0x90d2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10562)
			}
		},
		{
		0x90c1,
		0x90c6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10561)
			}
		},
		{
		0x90bc,
		0x90c0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10559)
			}
		},
		{
		0x90b4,
		0x90ba,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10553)
			}
		},
		{
		0x90a5,
		0x90a9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10542)
			}
		},
		{
		0x909c,
		0x90a1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10534)
			}
		},
		{
		0x9093,
		0x9099,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10530)
			}
		},
		{
		0x9081,
		0x908d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10526)
			}
		},
		{
		0x906b,
		0x907a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10532)
			}
		},
		{
		0x9061,
		0x9066,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10525)
			}
		},
		{
		0x904f,
		0x9054,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10527)
			}
		},
		{
		0x9046,
		0x904c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10523)
			}
		},
		{
		0x8ff9,
		0x8ffe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10585)
			}
		},
		{
		0x8fef,
		0x8ff5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10582)
			}
		},
		{
		0x8fcf,
		0x8fe9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10578)
			}
		},
		{
		0x8fc8,
		0x8fce,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10577)
			}
		},
		{
		0x8fb5,
		0x8fc7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10576)
			}
		},
		{
		0x8faf,
		0x8fb4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10575)
			}
		},
		{
		0x8fa6,
		0x8fac,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10571)
			}
		},
		{
		0x8f9b,
		0x8fa0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10567)
			}
		},
		{
		0x8f91,
		0x8f98,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10564)
			}
		},
		{
		0x8f85,
		0x8f8a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10561)
			}
		},
		{
		0x8f76,
		0x8f7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10563)
			}
		},
		{
		0x8f69,
		0x8f6f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10560)
			}
		},
		{
		0x8f61,
		0x8f68,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10559)
			}
		},
		{
		0x8f49,
		0x8f5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10565)
			}
		},
		{
		0x8f41,
		0x8f48,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10564)
			}
		},
		{
		0x8ef7,
		0x8efe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10630)
			}
		},
		{
		0x8eee,
		0x8ef3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10628)
			}
		},
		{
		0x8ee5,
		0x8eeb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10624)
			}
		},
		{
		0x8ed8,
		0x8edf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10620)
			}
		},
		{
		0x8ecb,
		0x8ed6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10618)
			}
		},
		{
		0x8ec2,
		0x8ec7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10616)
			}
		},
		{
		0x8eba,
		0x8ec0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10611)
			}
		},
		{
		0x8eaf,
		0x8eb4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10607)
			}
		},
		{
		0x8ea6,
		0x8eac,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10603)
			}
		},
		{
		0x8e9c,
		0x8ea0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10598)
			}
		},
		{
		0x8e94,
		0x8e9a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10593)
			}
		},
		{
		0x8e81,
		0x8e8e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10589)
			}
		},
		{
		0x8e67,
		0x8e7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10595)
			}
		},
		{
		0x8e61,
		0x8e65,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10593)
			}
		},
		{
		0x8e52,
		0x8e5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10599)
			}
		},
		{
		0x8e4a,
		0x8e4f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10596)
			}
		},
		{
		0x8e42,
		0x8e48,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10591)
			}
		},
		{
		0x8df0,
		0x8df6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10645)
			}
		},
		{
		0x8de5,
		0x8dea,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10641)
			}
		},
		{
		0x8ddc,
		0x8de2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10637)
			}
		},
		{
		0x8dcc,
		0x8dd5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10634)
			}
		},
		{
		0x8dc5,
		0x8dcb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10632)
			}
		},
		{
		0x8db7,
		0x8dbe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10629)
			}
		},
		{
		0x8daf,
		0x8db5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10626)
			}
		},
		{
		0x8d89,
		0x8daa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10621)
			}
		},
		{
		0x8d81,
		0x8d85,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10618)
			}
		},
		{
		0x8d61,
		0x8d72,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10621)
			}
		},
		{
		0x8d52,
		0x8d5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10627)
			}
		},
		{
		0x8d41,
		0x8d51,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10626)
			}
		},
		{
		0x8cee,
		0x8cfe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10692)
			}
		},
		{
		0x8ce4,
		0x8ce9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10689)
			}
		},
		{
		0x8cac,
		0x8cde,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10685)
			}
		},
		{
		0x8c8e,
		0x8ca8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10683)
			}
		},
		{
		0x8c81,
		0x8c8d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10682)
			}
		},
		{
		0x8c75,
		0x8c7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10688)
			}
		},
		{
		0x8c6e,
		0x8c74,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10687)
			}
		},
		{
		0x8c68,
		0x8c6d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10686)
			}
		},
		{
		0x8c61,
		0x8c67,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10685)
			}
		},
		{
		0x8c56,
		0x8c5a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10691)
			}
		},
		{
		0x8c41,
		0x8c50,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10687)
			}
		},
		{
		0x8bec,
		0x8bfe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10753)
			}
		},
		{
		0x8bd9,
		0x8beb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10752)
			}
		},
		{
		0x8bd3,
		0x8bd8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10751)
			}
		},
		{
		0x8bcb,
		0x8bd1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10746)
			}
		},
		{
		0x8bc1,
		0x8bc5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10741)
			}
		},
		{
		0x8b81,
		0x8bb5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10730)
			}
		},
		{
		0x8b72,
		0x8b7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10736)
			}
		},
		{
		0x8b6a,
		0x8b70,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10731)
			}
		},
		{
		0x8b52,
		0x8b58,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10727)
			}
		},
		{
		0x8b48,
		0x8b4c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10723)
			}
		},
		{
		0x8b41,
		0x8b46,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10717)
			}
		},
		{
		0x8adf,
		0x8af9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10778)
			}
		},
		{
		0x8ad9,
		0x8ade,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10777)
			}
		},
		{
		0x8ad2,
		0x8ad6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10773)
			}
		},
		{
		0x8ac7,
		0x8acc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10767)
			}
		},
		{
		0x8abc,
		0x8ac2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10765)
			}
		},
		{
		0x8ab0,
		0x8ab5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10762)
			}
		},
		{
		0x8aa6,
		0x8aad,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10759)
			}
		},
		{
		0x8a9a,
		0x8a9f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10756)
			}
		},
		{
		0x8a86,
		0x8a99,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10755)
			}
		},
		{
		0x8a81,
		0x8a85,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10754)
			}
		},
		{
		0x8a66,
		0x8a78,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10759)
			}
		},
		{
		0x8a61,
		0x8a65,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10758)
			}
		},
		{
		0x8a51,
		0x8a57,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10760)
			}
		},
		{
		0x8a41,
		0x8a4b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10756)
			}
		},
		{
		0x89ef,
		0x89fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10822)
			}
		},
		{
		0x89e7,
		0x89ee,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10821)
			}
		},
		{
		0x89df,
		0x89e5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10818)
			}
		},
		{
		0x89d2,
		0x89d8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10815)
			}
		},
		{
		0x89bf,
		0x89d1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10814)
			}
		},
		{
		0x89ac,
		0x89be,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10813)
			}
		},
		{
		0x8981,
		0x8996,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10797)
			}
		},
		{
		0x8971,
		0x8976,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10801)
			}
		},
		{
		0x8966,
		0x8970,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10799)
			}
		},
		{
		0x8954,
		0x8959,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10802)
			}
		},
		{
		0x894c,
		0x8952,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10797)
			}
		},
		{
		0x88c0,
		0x88f6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10845)
			}
		},
		{
		0x88ba,
		0x88bf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10844)
			}
		},
		{
		0x88b2,
		0x88b8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10839)
			}
		},
		{
		0x8897,
		0x889b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10812)
			}
		},
		{
		0x8881,
		0x8890,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10807)
			}
		},
		{
		0x8867,
		0x886b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10804)
			}
		},
		{
		0x8856,
		0x885a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10804)
			}
		},
		{
		0x884c,
		0x8852,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10801)
			}
		},
		{
		0x8846,
		0x884b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10800)
			}
		},
		{
		0x8841,
		0x8845,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10798)
			}
		},
		{
		0x87fa,
		0x87fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10864)
			}
		},
		{
		0x87f3,
		0x87f9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10862)
			}
		},
		{
		0x87d2,
		0x87ec,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10859)
			}
		},
		{
		0x87cb,
		0x87d1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10858)
			}
		},
		{
		0x87b8,
		0x87ca,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10857)
			}
		},
		{
		0x87b2,
		0x87b7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10856)
			}
		},
		{
		0x87a9,
		0x87af,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10852)
			}
		},
		{
		0x879f,
		0x87a4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10847)
			}
		},
		{
		0x8795,
		0x879c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10844)
			}
		},
		{
		0x8788,
		0x878f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10840)
			}
		},
		{
		0x8781,
		0x8786,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10837)
			}
		},
		{
		0x8761,
		0x8773,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10840)
			}
		},
		{
		0x874b,
		0x875a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10846)
			}
		},
		{
		0x8741,
		0x874a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10845)
			}
		},
		{
		0x86ed,
		0x86f1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10902)
			}
		},
		{
		0x86d0,
		0x86e6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10897)
			}
		},
		{
		0x86bf,
		0x86c5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10890)
			}
		},
		{
		0x86b4,
		0x86b9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10886)
			}
		},
		{
		0x86ac,
		0x86b2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10881)
			}
		},
		{
		0x86a2,
		0x86a6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10876)
			}
		},
		{
		0x8681,
		0x8697,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10864)
			}
		},
		{
		0x8670,
		0x867a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10870)
			}
		},
		{
		0x8665,
		0x866b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10868)
			}
		},
		{
		0x8654,
		0x8659,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10870)
			}
		},
		{
		0x864c,
		0x8652,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10865)
			}
		},
		{
		0x85f4,
		0x85f9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10910)
			}
		},
		{
		0x85eb,
		0x85f1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10906)
			}
		},
		{
		0x85c8,
		0x85e5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10902)
			}
		},
		{
		0x859f,
		0x85b9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10890)
			}
		},
		{
		0x8595,
		0x859e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10889)
			}
		},
		{
		0x858e,
		0x8594,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10887)
			}
		},
		{
		0x8581,
		0x8587,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10884)
			}
		},
		{
		0x8572,
		0x8578,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10887)
			}
		},
		{
		0x8567,
		0x856c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10883)
			}
		},
		{
		0x8561,
		0x8566,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10881)
			}
		},
		{
		0x8556,
		0x855a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10887)
			}
		},
		{
		0x854f,
		0x8555,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10886)
			}
		},
		{
		0x854a,
		0x854e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10885)
			}
		},
		{
		0x8542,
		0x8547,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10879)
			}
		},
		{
		0x84e0,
		0x84fa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10941)
			}
		},
		{
		0x84da,
		0x84df,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10940)
			}
		},
		{
		0x84d0,
		0x84d6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10937)
			}
		},
		{
		0x84c4,
		0x84c9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10934)
			}
		},
		{
		0x84b1,
		0x84c3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10933)
			}
		},
		{
		0x84ab,
		0x84b0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10931)
			}
		},
		{
		0x84a0,
		0x84aa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10929)
			}
		},
		{
		0x849a,
		0x849f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10928)
			}
		},
		{
		0x848d,
		0x8493,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10920)
			}
		},
		{
		0x8481,
		0x8488,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10915)
			}
		},
		{
		0x8468,
		0x847a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10921)
			}
		},
		{
		0x8452,
		0x845a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10923)
			}
		},
		{
		0x8446,
		0x844b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10920)
			}
		},
		{
		0x83f6,
		0x83fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10983)
			}
		},
		{
		0x83ee,
		0x83f3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10980)
			}
		},
		{
		0x83e6,
		0x83ec,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10975)
			}
		},
		{
		0x83b3,
		0x83e1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10970)
			}
		},
		{
		0x83ad,
		0x83b2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10969)
			}
		},
		{
		0x83a7,
		0x83ac,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10967)
			}
		},
		{
		0x839f,
		0x83a5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10962)
			}
		},
		{
		0x838f,
		0x8393,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10952)
			}
		},
		{
		0x8361,
		0x8373,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10940)
			}
		},
		{
		0x8353,
		0x835a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10946)
			}
		},
		{
		0x834d,
		0x8352,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10945)
			}
		},
		{
		0x8345,
		0x834a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10941)
			}
		},
		{
		0x82ec,
		0x82fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 11001)
			}
		},
		{
		0x82de,
		0x82e5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10998)
			}
		},
		{
		0x82d6,
		0x82dc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10995)
			}
		},
		{
		0x82c9,
		0x82d0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10991)
			}
		},
		{
		0x82b7,
		0x82c8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10990)
			}
		},
		{
		0x82b1,
		0x82b6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10989)
			}
		},
		{
		0x82a6,
		0x82b0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10987)
			}
		},
		{
		0x829c,
		0x82a0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10983)
			}
		},
		{
		0x828a,
		0x8291,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10970)
			}
		},
		{
		0x8281,
		0x8288,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10968)
			}
		},
		{
		0x826f,
		0x8274,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10971)
			}
		},
		{
		0x8266,
		0x826c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10967)
			}
		},
		{
		0x8255,
		0x825a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10969)
			}
		},
		{
		0x824b,
		0x8252,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10966)
			}
		},
		{
		0x81f6,
		0x81fa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 11025)
			}
		},
		{
		0x81eb,
		0x81ef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 11020)
			}
		},
		{
		0x81d9,
		0x81e0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 11007)
			}
		},
		{
		0x81d0,
		0x81d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 11005)
			}
		},
		{
		0x81bd,
		0x81c3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10996)
			}
		},
		{
		0x81b4,
		0x81b9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10990)
			}
		},
		{
		0x81ac,
		0x81b2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10985)
			}
		},
		{
		0x819e,
		0x81a2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10973)
			}
		},
		{
		0x8186,
		0x8198,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10967)
			}
		},
		{
		0x8174,
		0x8179,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10970)
			}
		},
		{
		0x8169,
		0x8172,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10968)
			}
		},
		{
		0x8150,
		0x8156,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10965)
			}
		},
		{
		0x8145,
		0x8149,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		0,
		0,
			{
			STATIC_CAST(TUint, 10950)
			}
		},
		{
		0xfda1,
		0xfdfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_1)
			}
		},
		{
		0xfca1,
		0xfcfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_2)
			}
		},
		{
		0xfba1,
		0xfbfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_3)
			}
		},
		{
		0xfaa1,
		0xfafe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_4)
			}
		},
		{
		0xf9a1,
		0xf9fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_5)
			}
		},
		{
		0xf8a1,
		0xf8fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_6)
			}
		},
		{
		0xf7a1,
		0xf7fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_7)
			}
		},
		{
		0xf6a1,
		0xf6fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_8)
			}
		},
		{
		0xf5a1,
		0xf5fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_9)
			}
		},
		{
		0xf4a1,
		0xf4fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_10)
			}
		},
		{
		0xf3a1,
		0xf3fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_11)
			}
		},
		{
		0xf2a1,
		0xf2fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_12)
			}
		},
		{
		0xf1a1,
		0xf1fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_13)
			}
		},
		{
		0xf0a1,
		0xf0fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_14)
			}
		},
		{
		0xefa1,
		0xeffe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_15)
			}
		},
		{
		0xeea1,
		0xeefe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_16)
			}
		},
		{
		0xeda1,
		0xedfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_17)
			}
		},
		{
		0xeca1,
		0xecfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_18)
			}
		},
		{
		0xeba1,
		0xebfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_19)
			}
		},
		{
		0xeaa1,
		0xeafe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_20)
			}
		},
		{
		0xe9a1,
		0xe9fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_21)
			}
		},
		{
		0xe8a1,
		0xe8fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_22)
			}
		},
		{
		0xe7a1,
		0xe7fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_23)
			}
		},
		{
		0xe6a1,
		0xe6fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_24)
			}
		},
		{
		0xe5a1,
		0xe5fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_25)
			}
		},
		{
		0xe4a1,
		0xe4fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_26)
			}
		},
		{
		0xe3a1,
		0xe3fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_27)
			}
		},
		{
		0xe2a1,
		0xe2fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_28)
			}
		},
		{
		0xe1a1,
		0xe1fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_29)
			}
		},
		{
		0xe0a1,
		0xe0fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_30)
			}
		},
		{
		0xdfa1,
		0xdffe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_31)
			}
		},
		{
		0xdea1,
		0xdefe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_32)
			}
		},
		{
		0xdda1,
		0xddfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_33)
			}
		},
		{
		0xdca1,
		0xdcfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_34)
			}
		},
		{
		0xdba1,
		0xdbfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_35)
			}
		},
		{
		0xdaa1,
		0xdafe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_36)
			}
		},
		{
		0xd9a1,
		0xd9fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_37)
			}
		},
		{
		0xd8a1,
		0xd8fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_38)
			}
		},
		{
		0xd7a1,
		0xd7fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_39)
			}
		},
		{
		0xd6a1,
		0xd6fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_40)
			}
		},
		{
		0xd5a1,
		0xd5fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_41)
			}
		},
		{
		0xd4a1,
		0xd4fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_42)
			}
		},
		{
		0xd3a1,
		0xd3fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_43)
			}
		},
		{
		0xd2f6,
		0xd2fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_44)
			}
		},
		{
		0xd2d8,
		0xd2e3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_45)
			}
		},
		{
		0xd2ac,
		0xd2c5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_46)
			}
		},
		{
		0xd2a1,
		0xd2a6,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_47)
			}
		},
		{
		0xd1e7,
		0xd1fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_48)
			}
		},
		{
		0xd1a1,
		0xd1da,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_49)
			}
		},
		{
		0xd0a1,
		0xd0fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_50)
			}
		},
		{
		0xcfa1,
		0xcffe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_51)
			}
		},
		{
		0xcea1,
		0xcefe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_52)
			}
		},
		{
		0xcda1,
		0xcdfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_53)
			}
		},
		{
		0xcca1,
		0xccfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_54)
			}
		},
		{
		0xcba1,
		0xcbfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_55)
			}
		},
		{
		0xcaa1,
		0xcafe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_56)
			}
		},
		{
		0xc8a1,
		0xc8fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_57)
			}
		},
		{
		0xc7a1,
		0xc7fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_58)
			}
		},
		{
		0xc6a1,
		0xc6fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_59)
			}
		},
		{
		0xc59f,
		0xc5fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_60)
			}
		},
		{
		0xc581,
		0xc58e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_61)
			}
		},
		{
		0xc541,
		0xc548,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_62)
			}
		},
		{
		0xc49e,
		0xc4fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_63)
			}
		},
		{
		0xc48d,
		0xc491,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_64)
			}
		},
		{
		0xc481,
		0xc486,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_65)
			}
		},
		{
		0xc470,
		0xc475,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_66)
			}
		},
		{
		0xc461,
		0xc469,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_67)
			}
		},
		{
		0xc456,
		0xc45a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_68)
			}
		},
		{
		0xc39f,
		0xc3fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_69)
			}
		},
		{
		0xc38a,
		0xc38e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_70)
			}
		},
		{
		0xc341,
		0xc355,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_71)
			}
		},
		{
		0xc29f,
		0xc2fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_72)
			}
		},
		{
		0xc287,
		0xc28c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_73)
			}
		},
		{
		0xc26e,
		0xc272,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_74)
			}
		},
		{
		0xc254,
		0xc25a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_75)
			}
		},
		{
		0xc241,
		0xc246,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_76)
			}
		},
		{
		0xc1a1,
		0xc1fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_77)
			}
		},
		{
		0xc14c,
		0xc150,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_78)
			}
		},
		{
		0xc141,
		0xc145,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_79)
			}
		},
		{
		0xc0c8,
		0xc0fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_80)
			}
		},
		{
		0xc099,
		0xc0bf,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_81)
			}
		},
		{
		0xc081,
		0xc089,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_82)
			}
		},
		{
		0xc047,
		0xc04c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_83)
			}
		},
		{
		0xbfb6,
		0xbffe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_84)
			}
		},
		{
		0xbf9e,
		0xbfaf,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_85)
			}
		},
		{
		0xbf91,
		0xbf96,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_86)
			}
		},
		{
		0xbf74,
		0xbf7a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_87)
			}
		},
		{
		0xbea1,
		0xbef5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_88)
			}
		},
		{
		0xbe86,
		0xbe8a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_89)
			}
		},
		{
		0xbe69,
		0xbe6e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_90)
			}
		},
		{
		0xbda1,
		0xbdfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_91)
			}
		},
		{
		0xbd61,
		0xbd66,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_92)
			}
		},
		{
		0xbd53,
		0xbd5a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_93)
			}
		},
		{
		0xbcb2,
		0xbcfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_94)
			}
		},
		{
		0xbca1,
		0xbcac,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_95)
			}
		},
		{
		0xbc86,
		0xbc8b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_96)
			}
		},
		{
		0xbc6c,
		0xbc70,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_97)
			}
		},
		{
		0xbc61,
		0xbc65,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_98)
			}
		},
		{
		0xbc53,
		0xbc5a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_99)
			}
		},
		{
		0xbba1,
		0xbbfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_100)
			}
		},
		{
		0xbb61,
		0xbb68,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_101)
			}
		},
		{
		0xbb4e,
		0xbb52,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_102)
			}
		},
		{
		0xba9a,
		0xbafe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_103)
			}
		},
		{
		0xba81,
		0xba88,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_104)
			}
		},
		{
		0xba6a,
		0xba6e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_105)
			}
		},
		{
		0xba4d,
		0xba52,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_106)
			}
		},
		{
		0xba41,
		0xba46,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_107)
			}
		},
		{
		0xb9e3,
		0xb9fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_108)
			}
		},
		{
		0xb998,
		0xb9d8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_109)
			}
		},
		{
		0xb941,
		0xb947,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_110)
			}
		},
		{
		0xb8be,
		0xb8fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_111)
			}
		},
		{
		0xb8a1,
		0xb8b8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_112)
			}
		},
		{
		0xb7a1,
		0xb7fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_113)
			}
		},
		{
		0xb788,
		0xb791,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_114)
			}
		},
		{
		0xb776,
		0xb77a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_115)
			}
		},
		{
		0xb756,
		0xb75a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_116)
			}
		},
		{
		0xb69d,
		0xb6fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_117)
			}
		},
		{
		0xb689,
		0xb68d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_118)
			}
		},
		{
		0xb671,
		0xb67a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_119)
			}
		},
		{
		0xb5a1,
		0xb5fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_120)
			}
		},
		{
		0xb581,
		0xb586,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_121)
			}
		},
		{
		0xb56a,
		0xb56e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_122)
			}
		},
		{
		0xb550,
		0xb554,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_123)
			}
		},
		{
		0xb4ea,
		0xb4fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_124)
			}
		},
		{
		0xb4a1,
		0xb4dc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_125)
			}
		},
		{
		0xb461,
		0xb466,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_126)
			}
		},
		{
		0xb447,
		0xb44b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_127)
			}
		},
		{
		0xb3b9,
		0xb3fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_128)
			}
		},
		{
		0xb3a1,
		0xb3b3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_129)
			}
		},
		{
		0xb36f,
		0xb374,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_130)
			}
		},
		{
		0xb355,
		0xb35a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_131)
			}
		},
		{
		0xb2a1,
		0xb2fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_132)
			}
		},
		{
		0xb241,
		0xb248,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_133)
			}
		},
		{
		0xb19c,
		0xb1fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_134)
			}
		},
		{
		0xb190,
		0xb194,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_135)
			}
		},
		{
		0xb155,
		0xb15a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_136)
			}
		},
		{
		0xb141,
		0xb145,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_137)
			}
		},
		{
		0xb0b5,
		0xb0fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_138)
			}
		},
		{
		0xb0a1,
		0xb0a7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_139)
			}
		},
		{
		0xaf9b,
		0xafa0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_140)
			}
		},
		{
		0xaf87,
		0xaf8b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_141)
			}
		},
		{
		0xaf41,
		0xaf46,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_142)
			}
		},
		{
		0xae99,
		0xaea0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_143)
			}
		},
		{
		0xae81,
		0xae87,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_144)
			}
		},
		{
		0xae67,
		0xae6c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_145)
			}
		},
		{
		0xad81,
		0xad86,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_146)
			}
		},
		{
		0xad73,
		0xad7a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_147)
			}
		},
		{
		0xac61,
		0xac69,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_148)
			}
		},
		{
		0xac56,
		0xac5a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_149)
			}
		},
		{
		0xac4a,
		0xac4e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_150)
			}
		},
		{
		0xab41,
		0xab49,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_151)
			}
		},
		{
		0xaa6d,
		0xaa71,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_152)
			}
		},
		{
		0xaa54,
		0xaa5a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_153)
			}
		},
		{
		0xaa41,
		0xaa46,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_154)
			}
		},
		{
		0xa9f6,
		0xa9fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_155)
			}
		},
		{
		0xa99c,
		0xa9b0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_156)
			}
		},
		{
		0xa990,
		0xa994,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_157)
			}
		},
		{
		0xa961,
		0xa967,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_158)
			}
		},
		{
		0xa8f6,
		0xa8fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_159)
			}
		},
		{
		0xa8a8,
		0xa8af,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_160)
			}
		},
		{
		0xa7d9,
		0xa7ef,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_161)
			}
		},
		{
		0xa7b5,
		0xa7be,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_162)
			}
		},
		{
		0xa7a1,
		0xa7aa,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_163)
			}
		},
		{
		0xa781,
		0xa788,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_164)
			}
		},
		{
		0xa746,
		0xa74b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_165)
			}
		},
		{
		0xa69f,
		0xa6dc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_166)
			}
		},
		{
		0xa667,
		0xa66d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_167)
			}
		},
		{
		0xa655,
		0xa65a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_168)
			}
		},
		{
		0xa546,
		0xa54a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_169)
			}
		},
		{
		0xa452,
		0xa45a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_170)
			}
		},
		{
		0xa441,
		0xa44b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_171)
			}
		},
		{
		0xa39c,
		0xa3a0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_172)
			}
		},
		{
		0xa392,
		0xa396,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_173)
			}
		},
		{
		0xa356,
		0xa35a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_174)
			}
		},
		{
		0xa29e,
		0xa2e8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_175)
			}
		},
		{
		0xa289,
		0xa28d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_176)
			}
		},
		{
		0xa1be,
		0xa1fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_177)
			}
		},
		{
		0xa1a0,
		0xa1b3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_178)
			}
		},
		{
		0xa196,
		0xa19a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_179)
			}
		},
		{
		0xa161,
		0xa168,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_180)
			}
		},
		{
		0xa0fa,
		0xa0fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_181)
			}
		},
		{
		0xa0e7,
		0xa0eb,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_182)
			}
		},
		{
		0xa0dc,
		0xa0e1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_183)
			}
		},
		{
		0xa0ac,
		0xa0b1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_184)
			}
		},
		{
		0xa098,
		0xa09c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_185)
			}
		},
		{
		0xa086,
		0xa08b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_186)
			}
		},
		{
		0xa067,
		0xa06c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_187)
			}
		},
		{
		0xa041,
		0xa045,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_188)
			}
		},
		{
		0x9ff7,
		0x9ffe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_189)
			}
		},
		{
		0x9fda,
		0x9feb,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_190)
			}
		},
		{
		0x9fc0,
		0x9fc8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_191)
			}
		},
		{
		0x9faf,
		0x9fba,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_192)
			}
		},
		{
		0x9fa3,
		0x9fa7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_193)
			}
		},
		{
		0x9f8f,
		0x9f93,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_194)
			}
		},
		{
		0x9f74,
		0x9f7a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_195)
			}
		},
		{
		0x9f48,
		0x9f4c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_196)
			}
		},
		{
		0x9ef2,
		0x9ef6,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_197)
			}
		},
		{
		0x9ede,
		0x9ee2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_198)
			}
		},
		{
		0x9ea6,
		0x9eb9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_199)
			}
		},
		{
		0x9e81,
		0x9e96,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_200)
			}
		},
		{
		0x9e68,
		0x9e6f,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_201)
			}
		},
		{
		0x9e41,
		0x9e47,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_202)
			}
		},
		{
		0x9def,
		0x9dfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_203)
			}
		},
		{
		0x9dd0,
		0x9de0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_204)
			}
		},
		{
		0x9dbc,
		0x9dc0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_205)
			}
		},
		{
		0x9da4,
		0x9da9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_206)
			}
		},
		{
		0x9d90,
		0x9d99,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_207)
			}
		},
		{
		0x9cc3,
		0x9cc7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_208)
			}
		},
		{
		0x9c91,
		0x9c96,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_209)
			}
		},
		{
		0x9bae,
		0x9bb3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_210)
			}
		},
		{
		0x9b9b,
		0x9ba0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_211)
			}
		},
		{
		0x9b41,
		0x9b48,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_212)
			}
		},
		{
		0x9ae9,
		0x9af3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_213)
			}
		},
		{
		0x9ab0,
		0x9ab4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_214)
			}
		},
		{
		0x9a86,
		0x9a8a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_215)
			}
		},
		{
		0x9a76,
		0x9a7a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_216)
			}
		},
		{
		0x9a6a,
		0x9a6e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_217)
			}
		},
		{
		0x9a41,
		0x9a49,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_218)
			}
		},
		{
		0x99f8,
		0x99fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_219)
			}
		},
		{
		0x99e4,
		0x99e8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_220)
			}
		},
		{
		0x99ce,
		0x99d3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_221)
			}
		},
		{
		0x99b8,
		0x99bd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_222)
			}
		},
		{
		0x999a,
		0x99a5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_223)
			}
		},
		{
		0x9990,
		0x9994,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_224)
			}
		},
		{
		0x9972,
		0x997a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_225)
			}
		},
		{
		0x9941,
		0x994a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_226)
			}
		},
		{
		0x98f7,
		0x98fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_227)
			}
		},
		{
		0x98e0,
		0x98e5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_228)
			}
		},
		{
		0x98cc,
		0x98d0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_229)
			}
		},
		{
		0x98b3,
		0x98bd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_230)
			}
		},
		{
		0x9897,
		0x989b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_231)
			}
		},
		{
		0x9793,
		0x9797,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_232)
			}
		},
		{
		0x96c3,
		0x96c7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_233)
			}
		},
		{
		0x95cf,
		0x95d3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_234)
			}
		},
		{
		0x95b8,
		0x95c3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_235)
			}
		},
		{
		0x95ad,
		0x95b2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_236)
			}
		},
		{
		0x9576,
		0x957a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_237)
			}
		},
		{
		0x9561,
		0x9565,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_238)
			}
		},
		{
		0x9541,
		0x9547,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_239)
			}
		},
		{
		0x94c7,
		0x94cc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_240)
			}
		},
		{
		0x948e,
		0x9492,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_241)
			}
		},
		{
		0x93fa,
		0x93fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_242)
			}
		},
		{
		0x93da,
		0x93e2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_243)
			}
		},
		{
		0x93cd,
		0x93d1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_244)
			}
		},
		{
		0x93aa,
		0x93ae,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_245)
			}
		},
		{
		0x936a,
		0x9371,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_246)
			}
		},
		{
		0x9346,
		0x935a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_247)
			}
		},
		{
		0x92fa,
		0x92fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_248)
			}
		},
		{
		0x92c7,
		0x92cc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_249)
			}
		},
		{
		0x92b0,
		0x92b5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_250)
			}
		},
		{
		0x9297,
		0x929c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_251)
			}
		},
		{
		0x9253,
		0x925a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_252)
			}
		},
		{
		0x91f2,
		0x91f7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_253)
			}
		},
		{
		0x91dc,
		0x91e1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_254)
			}
		},
		{
		0x9196,
		0x919a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_255)
			}
		},
		{
		0x9170,
		0x9174,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_256)
			}
		},
		{
		0x9161,
		0x9165,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_257)
			}
		},
		{
		0x9141,
		0x914c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_258)
			}
		},
		{
		0x90f5,
		0x90fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_259)
			}
		},
		{
		0x90aa,
		0x90b3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_260)
			}
		},
		{
		0x908e,
		0x9092,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_261)
			}
		},
		{
		0x9055,
		0x905a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_262)
			}
		},
		{
		0x9041,
		0x9045,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_263)
			}
		},
		{
		0x8fea,
		0x8fee,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_264)
			}
		},
		{
		0x8fa1,
		0x8fa5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_265)
			}
		},
		{
		0x8f8b,
		0x8f90,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_266)
			}
		},
		{
		0x8f70,
		0x8f75,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_267)
			}
		},
		{
		0x8ee0,
		0x8ee4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_268)
			}
		},
		{
		0x8eb5,
		0x8eb9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_269)
			}
		},
		{
		0x8ea1,
		0x8ea5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_270)
			}
		},
		{
		0x8e8f,
		0x8e93,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_271)
			}
		},
		{
		0x8df7,
		0x8dfe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_272)
			}
		},
		{
		0x8deb,
		0x8def,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_273)
			}
		},
		{
		0x8dd6,
		0x8ddb,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_274)
			}
		},
		{
		0x8dbf,
		0x8dc4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_275)
			}
		},
		{
		0x8d73,
		0x8d7a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_276)
			}
		},
		{
		0x8cdf,
		0x8ce3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_277)
			}
		},
		{
		0x8c51,
		0x8c55,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_278)
			}
		},
		{
		0x8bc6,
		0x8bca,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_279)
			}
		},
		{
		0x8bb6,
		0x8bc0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_280)
			}
		},
		{
		0x8b61,
		0x8b69,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_281)
			}
		},
		{
		0x8b4d,
		0x8b51,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_282)
			}
		},
		{
		0x8afa,
		0x8afe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_283)
			}
		},
		{
		0x8acd,
		0x8ad1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_284)
			}
		},
		{
		0x8ab6,
		0x8abb,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_285)
			}
		},
		{
		0x8aa0,
		0x8aa5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_286)
			}
		},
		{
		0x8a4c,
		0x8a50,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_287)
			}
		},
		{
		0x89d9,
		0x89de,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_288)
			}
		},
		{
		0x8997,
		0x89ab,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_289)
			}
		},
		{
		0x8961,
		0x8965,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_290)
			}
		},
		{
		0x8941,
		0x894b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_291)
			}
		},
		{
		0x88f7,
		0x88fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_292)
			}
		},
		{
		0x889c,
		0x88b1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_293)
			}
		},
		{
		0x8891,
		0x8896,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_294)
			}
		},
		{
		0x886c,
		0x887a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_295)
			}
		},
		{
		0x8861,
		0x8866,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_296)
			}
		},
		{
		0x87ed,
		0x87f2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_297)
			}
		},
		{
		0x8790,
		0x8794,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_298)
			}
		},
		{
		0x8774,
		0x877a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_299)
			}
		},
		{
		0x86f2,
		0x86fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_300)
			}
		},
		{
		0x86e7,
		0x86ec,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_301)
			}
		},
		{
		0x86c6,
		0x86cf,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_302)
			}
		},
		{
		0x86ba,
		0x86be,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_303)
			}
		},
		{
		0x86a7,
		0x86ab,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_304)
			}
		},
		{
		0x8698,
		0x86a1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_305)
			}
		},
		{
		0x8641,
		0x864b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_306)
			}
		},
		{
		0x85fa,
		0x85fe,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_307)
			}
		},
		{
		0x85e6,
		0x85ea,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_308)
			}
		},
		{
		0x85ba,
		0x85c7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_309)
			}
		},
		{
		0x8588,
		0x858d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_310)
			}
		},
		{
		0x856d,
		0x8571,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_311)
			}
		},
		{
		0x84ca,
		0x84cf,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_312)
			}
		},
		{
		0x8494,
		0x8499,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_313)
			}
		},
		{
		0x8461,
		0x8467,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_314)
			}
		},
		{
		0x844c,
		0x8451,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_315)
			}
		},
		{
		0x8441,
		0x8445,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_316)
			}
		},
		{
		0x8394,
		0x839e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_317)
			}
		},
		{
		0x8381,
		0x838e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_318)
			}
		},
		{
		0x8374,
		0x837a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_319)
			}
		},
		{
		0x82e6,
		0x82eb,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_320)
			}
		},
		{
		0x82d1,
		0x82d5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_321)
			}
		},
		{
		0x82a1,
		0x82a5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_322)
			}
		},
		{
		0x8292,
		0x829b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_323)
			}
		},
		{
		0x8275,
		0x827a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_324)
			}
		},
		{
		0x8261,
		0x8265,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_325)
			}
		},
		{
		0x8241,
		0x824a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_326)
			}
		},
		{
		0x81f0,
		0x81f5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_327)
			}
		},
		{
		0x81e1,
		0x81ea,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_328)
			}
		},
		{
		0x81c4,
		0x81cf,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_329)
			}
		},
		{
		0x81a3,
		0x81ab,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_330)
			}
		},
		{
		0x8199,
		0x819d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_331)
			}
		},
		{
		0x8181,
		0x8185,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_332)
			}
		},
		{
		0x8161,
		0x8168,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_333)
			}
		},
		{
		0x814a,
		0x814f,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		0,
		0,
			{
			UData_SIndexedTable16(indexedTable16_foreignToUnicode_334)
			}
		},
		{
		0x8141,
		0xd2ef,
		SCnvConversionData::SOneDirectionData::SRange::EKeyedTable1616,
		0,
		0,
			{
			UData_SKeyedTable1616(keyedTable1616_foreignToUnicode_1)
			}
		}
	};

LOCAL_D const SCnvConversionData::SOneDirectionData::SRange unicodeToForeignDataRanges[]=
	{
		{
		0x0000,
		0x007f,
		SCnvConversionData::SOneDirectionData::SRange::EDirect,
		1,
		0,
			{
			0
			}
		},
		{
		0xff3d,
		0xff5d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -23392)
			}
		},
		{
		0xff01,
		0xff3b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -23392)
			}
		},
		{
		0xf952,
		0xf957,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9826)
			}
		},
		{
		0xf94a,
		0xf951,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9830)
			}
		},
		{
		0xf939,
		0xf943,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9836)
			}
		},
		{
		0xf933,
		0xf938,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9837)
			}
		},
		{
		0xf928,
		0xf92c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9857)
			}
		},
		{
		0xf914,
		0xf918,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10034)
			}
		},
		{
		0xf90e,
		0xf913,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10035)
			}
		},
		{
		0xd79e,
		0xd7a3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4433)
			}
		},
		{
		0xd791,
		0xd797,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4429)
			}
		},
		{
		0xd782,
		0xd787,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4585)
			}
		},
		{
		0xd775,
		0xd77b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4582)
			}
		},
		{
		0xd75a,
		0xd75e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4580)
			}
		},
		{
		0xd74a,
		0xd74f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4573)
			}
		},
		{
		0xd73d,
		0xd743,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4570)
			}
		},
		{
		0xd72e,
		0xd733,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4572)
			}
		},
		{
		0xd721,
		0xd727,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4568)
			}
		},
		{
		0xd705,
		0xd710,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4723)
			}
		},
		{
		0xd6f6,
		0xd6fb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4719)
			}
		},
		{
		0xd6e9,
		0xd6ed,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4723)
			}
		},
		{
		0xd6da,
		0xd6df,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4720)
			}
		},
		{
		0xd6bc,
		0xd6c3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4718)
			}
		},
		{
		0xd6b1,
		0xd6b8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4716)
			}
		},
		{
		0xd6a2,
		0xd6a7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4873)
			}
		},
		{
		0xd695,
		0xd69c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4870)
			}
		},
		{
		0xd686,
		0xd68b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4866)
			}
		},
		{
		0xd675,
		0xd680,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4870)
			}
		},
		{
		0xd66a,
		0xd66f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4867)
			}
		},
		{
		0xd662,
		0xd666,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4865)
			}
		},
		{
		0xd65d,
		0xd661,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -4871)
			}
		},
		{
		0xd62e,
		0xd637,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5017)
			}
		},
		{
		0xd625,
		0xd62c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5016)
			}
		},
		{
		0xd616,
		0xd61b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5013)
			}
		},
		{
		0xd609,
		0xd60f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5014)
			}
		},
		{
		0xd5fa,
		0xd5ff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5010)
			}
		},
		{
		0xd5ef,
		0xd5f3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5006)
			}
		},
		{
		0xd5de,
		0xd5e3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5008)
			}
		},
		{
		0xd5d3,
		0xd5d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5004)
			}
		},
		{
		0xd5a8,
		0xd5c7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5159)
			}
		},
		{
		0xd591,
		0xd5a4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5164)
			}
		},
		{
		0xd57d,
		0xd583,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5164)
			}
		},
		{
		0xd56e,
		0xd573,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5160)
			}
		},
		{
		0xd552,
		0xd557,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5311)
			}
		},
		{
		0xd545,
		0xd54b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5307)
			}
		},
		{
		0xd51e,
		0xd537,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5309)
			}
		},
		{
		0xd518,
		0xd51d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5315)
			}
		},
		{
		0xd50d,
		0xd513,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5312)
			}
		},
		{
		0xd4fe,
		0xd503,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5309)
			}
		},
		{
		0xd4f1,
		0xd4f7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5466)
			}
		},
		{
		0xd4e0,
		0xd4e7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5463)
			}
		},
		{
		0xd4d6,
		0xd4db,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5461)
			}
		},
		{
		0xd4b9,
		0xd4cb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5464)
			}
		},
		{
		0xd4aa,
		0xd4b8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5470)
			}
		},
		{
		0xd49e,
		0xd4a8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5469)
			}
		},
		{
		0xd495,
		0xd49d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5629)
			}
		},
		{
		0xd48e,
		0xd493,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5628)
			}
		},
		{
		0xd483,
		0xd487,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5624)
			}
		},
		{
		0xd473,
		0xd477,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5618)
			}
		},
		{
		0xd465,
		0xd46c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5622)
			}
		},
		{
		0xd454,
		0xd45b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5619)
			}
		},
		{
		0xd445,
		0xd453,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5625)
			}
		},
		{
		0xd438,
		0xd43f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5623)
			}
		},
		{
		0xd41e,
		0xd437,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5783)
			}
		},
		{
		0xd417,
		0xd41c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5782)
			}
		},
		{
		0xd409,
		0xd416,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5788)
			}
		},
		{
		0xd402,
		0xd407,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5787)
			}
		},
		{
		0xd3e4,
		0xd3eb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5785)
			}
		},
		{
		0xd3d9,
		0xd3e0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5783)
			}
		},
		{
		0xd3d1,
		0xd3d6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5942)
			}
		},
		{
		0xd3ca,
		0xd3cf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5941)
			}
		},
		{
		0xd3bd,
		0xd3c3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5937)
			}
		},
		{
		0xd3af,
		0xd3b3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5934)
			}
		},
		{
		0xd3a1,
		0xd3a7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5936)
			}
		},
		{
		0xd392,
		0xd397,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5932)
			}
		},
		{
		0xd36a,
		0xd37b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -5929)
			}
		},
		{
		0xd34a,
		0xd369,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6089)
			}
		},
		{
		0xd33e,
		0xd343,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6093)
			}
		},
		{
		0xd331,
		0xd337,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6088)
			}
		},
		{
		0xd317,
		0xd31b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6084)
			}
		},
		{
		0xd306,
		0xd30b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6078)
			}
		},
		{
		0xd2fb,
		0xd2ff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6074)
			}
		},
		{
		0xd2e6,
		0xd2ef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6230)
			}
		},
		{
		0xd2dd,
		0xd2e3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6228)
			}
		},
		{
		0xd2cc,
		0xd2d1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6231)
			}
		},
		{
		0xd2c3,
		0xd2c7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6228)
			}
		},
		{
		0xd2b2,
		0xd2b7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6222)
			}
		},
		{
		0xd2a5,
		0xd2ab,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6226)
			}
		},
		{
		0xd296,
		0xd29b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6223)
			}
		},
		{
		0xd269,
		0xd27f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6376)
			}
		},
		{
		0xd25d,
		0xd263,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6381)
			}
		},
		{
		0xd24d,
		0xd25b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6380)
			}
		},
		{
		0xd242,
		0xd247,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6385)
			}
		},
		{
		0xd235,
		0xd23b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6381)
			}
		},
		{
		0xd211,
		0xd229,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6537)
			}
		},
		{
		0xd20a,
		0xd20f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6536)
			}
		},
		{
		0xd1f9,
		0xd206,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6540)
			}
		},
		{
		0xd1eb,
		0xd1f3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6538)
			}
		},
		{
		0xd1d9,
		0xd1ea,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6544)
			}
		},
		{
		0xd1d0,
		0xd1d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6543)
			}
		},
		{
		0xd1c1,
		0xd1cf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6703)
			}
		},
		{
		0xd1a9,
		0xd1af,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6696)
			}
		},
		{
		0xd18b,
		0xd19f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6698)
			}
		},
		{
		0xd17d,
		0xd183,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6702)
			}
		},
		{
		0xd16e,
		0xd17b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6701)
			}
		},
		{
		0xd162,
		0xd167,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6859)
			}
		},
		{
		0xd155,
		0xd15b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6855)
			}
		},
		{
		0xd146,
		0xd14b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6851)
			}
		},
		{
		0xd120,
		0xd12f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6847)
			}
		},
		{
		0xd10e,
		0xd11f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6853)
			}
		},
		{
		0xd105,
		0xd10c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6852)
			}
		},
		{
		0xd0f9,
		0xd104,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7012)
			}
		},
		{
		0xd0f2,
		0xd0f7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7011)
			}
		},
		{
		0xd0e5,
		0xd0eb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7006)
			}
		},
		{
		0xd0d6,
		0xd0da,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7008)
			}
		},
		{
		0xd0ca,
		0xd0cf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7003)
			}
		},
		{
		0xd0ba,
		0xd0bf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6998)
			}
		},
		{
		0xd0ad,
		0xd0b2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7000)
			}
		},
		{
		0xd095,
		0xd0a3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -6996)
			}
		},
		{
		0xd082,
		0xd094,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7156)
			}
		},
		{
		0xd075,
		0xd07b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7153)
			}
		},
		{
		0xd061,
		0xd06b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7155)
			}
		},
		{
		0xd059,
		0xd05f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7154)
			}
		},
		{
		0xd04a,
		0xd04f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7157)
			}
		},
		{
		0xd03d,
		0xd043,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7153)
			}
		},
		{
		0xd02e,
		0xd033,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7149)
			}
		},
		{
		0xd019,
		0xd02c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7308)
			}
		},
		{
		0xd012,
		0xd017,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7307)
			}
		},
		{
		0xd00b,
		0xd010,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7306)
			}
		},
		{
		0xd005,
		0xd00a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7312)
			}
		},
		{
		0xcff6,
		0xcffb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7309)
			}
		},
		{
		0xcfea,
		0xcfef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7305)
			}
		},
		{
		0xcfcc,
		0xcfdf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7307)
			}
		},
		{
		0xcfc5,
		0xcfcb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7467)
			}
		},
		{
		0xcfb1,
		0xcfc3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7466)
			}
		},
		{
		0xcfaa,
		0xcfaf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7465)
			}
		},
		{
		0xcfa2,
		0xcfa7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7470)
			}
		},
		{
		0xcf8e,
		0xcfa0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7469)
			}
		},
		{
		0xcf86,
		0xcf8b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7474)
			}
		},
		{
		0xcf79,
		0xcf7f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7472)
			}
		},
		{
		0xcf5d,
		0xcf63,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7624)
			}
		},
		{
		0xcf45,
		0xcf53,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7620)
			}
		},
		{
		0xcf39,
		0xcf44,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7626)
			}
		},
		{
		0xcf32,
		0xcf37,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7625)
			}
		},
		{
		0xcf25,
		0xcf2b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7620)
			}
		},
		{
		0xcf16,
		0xcf1b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7623)
			}
		},
		{
		0xcf09,
		0xcf0f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7619)
			}
		},
		{
		0xcefa,
		0xceff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7775)
			}
		},
		{
		0xceed,
		0xcef3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7770)
			}
		},
		{
		0xced6,
		0xcee3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7765)
			}
		},
		{
		0xcec2,
		0xced5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7771)
			}
		},
		{
		0xcebb,
		0xcec0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7770)
			}
		},
		{
		0xceae,
		0xceba,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7776)
			}
		},
		{
		0xcea6,
		0xceab,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7774)
			}
		},
		{
		0xce9a,
		0xce9f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7769)
			}
		},
		{
		0xce8a,
		0xce8f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7925)
			}
		},
		{
		0xce7d,
		0xce83,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7921)
			}
		},
		{
		0xce6e,
		0xce73,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7917)
			}
		},
		{
		0xce62,
		0xce67,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7919)
			}
		},
		{
		0xce4a,
		0xce57,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7913)
			}
		},
		{
		0xce36,
		0xce49,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -7919)
			}
		},
		{
		0xce1a,
		0xce1f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8071)
			}
		},
		{
		0xce0d,
		0xce13,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8069)
			}
		},
		{
		0xcdfe,
		0xce02,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8072)
			}
		},
		{
		0xcdf1,
		0xcdf7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8068)
			}
		},
		{
		0xcde2,
		0xcde7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8065)
			}
		},
		{
		0xcdd1,
		0xcde1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8071)
			}
		},
		{
		0xcdc6,
		0xcdcb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8069)
			}
		},
		{
		0xcdb1,
		0xcdc3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8228)
			}
		},
		{
		0xcdaa,
		0xcdaf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8227)
			}
		},
		{
		0xcd89,
		0xcd93,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8225)
			}
		},
		{
		0xcd81,
		0xcd87,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8224)
			}
		},
		{
		0xcd79,
		0xcd80,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8230)
			}
		},
		{
		0xcd72,
		0xcd77,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8229)
			}
		},
		{
		0xcd65,
		0xcd6b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8225)
			}
		},
		{
		0xcd3f,
		0xcd5b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8382)
			}
		},
		{
		0xcd3a,
		0xcd3e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8388)
			}
		},
		{
		0xcd2d,
		0xcd38,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8387)
			}
		},
		{
		0xcd11,
		0xcd17,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8386)
			}
		},
		{
		0xcd02,
		0xcd07,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8382)
			}
		},
		{
		0xccf1,
		0xccfd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8541)
			}
		},
		{
		0xcce5,
		0xcceb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8539)
			}
		},
		{
		0xccdb,
		0xcce3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8538)
			}
		},
		{
		0xccd5,
		0xccda,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8544)
			}
		},
		{
		0xccca,
		0xcccf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8542)
			}
		},
		{
		0xccbd,
		0xccc3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8538)
			}
		},
		{
		0xccae,
		0xccb3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8540)
			}
		},
		{
		0xcca1,
		0xcca7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8535)
			}
		},
		{
		0xcc76,
		0xcc93,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8691)
			}
		},
		{
		0xcc69,
		0xcc6f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8695)
			}
		},
		{
		0xcc5a,
		0xcc5f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8691)
			}
		},
		{
		0xcc4f,
		0xcc53,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8686)
			}
		},
		{
		0xcc3f,
		0xcc43,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8688)
			}
		},
		{
		0xcc31,
		0xcc37,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8682)
			}
		},
		{
		0xcc15,
		0xcc1b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8832)
			}
		},
		{
		0xcbfd,
		0xcc0b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8828)
			}
		},
		{
		0xcbea,
		0xcbfc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8834)
			}
		},
		{
		0xcbd5,
		0xcbdf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8837)
			}
		},
		{
		0xcbc5,
		0xcbd3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8836)
			}
		},
		{
		0xcbb9,
		0xcbc4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8996)
			}
		},
		{
		0xcba4,
		0xcbb7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -8995)
			}
		},
		{
		0xcb9d,
		0xcba3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9001)
			}
		},
		{
		0xcb89,
		0xcb9b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9000)
			}
		},
		{
		0xcb7a,
		0xcb88,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9006)
			}
		},
		{
		0xcb6d,
		0xcb77,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9004)
			}
		},
		{
		0xcb65,
		0xcb6c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9164)
			}
		},
		{
		0xcb5e,
		0xcb63,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9163)
			}
		},
		{
		0xcb51,
		0xcb57,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9160)
			}
		},
		{
		0xcb2a,
		0xcb40,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9161)
			}
		},
		{
		0xcb22,
		0xcb29,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9167)
			}
		},
		{
		0xcb19,
		0xcb1f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9165)
			}
		},
		{
		0xcb0b,
		0xcb0f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9162)
			}
		},
		{
		0xcaf5,
		0xcb07,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9321)
			}
		},
		{
		0xcaed,
		0xcaf3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9320)
			}
		},
		{
		0xcae1,
		0xcae7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9325)
			}
		},
		{
		0xcada,
		0xcadf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9324)
			}
		},
		{
		0xcac6,
		0xcacb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9317)
			}
		},
		{
		0xcaa8,
		0xcabb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9319)
			}
		},
		{
		0xca99,
		0xcaa7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9479)
			}
		},
		{
		0xca87,
		0xca97,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9478)
			}
		},
		{
		0xca7e,
		0xca83,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9483)
			}
		},
		{
		0xca6b,
		0xca7c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9482)
			}
		},
		{
		0xca62,
		0xca67,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9487)
			}
		},
		{
		0xca55,
		0xca5b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9482)
			}
		},
		{
		0xca47,
		0xca4b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9478)
			}
		},
		{
		0xca2a,
		0xca46,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9638)
			}
		},
		{
		0xca19,
		0xca25,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9643)
			}
		},
		{
		0xca0e,
		0xca13,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9641)
			}
		},
		{
		0xc9f2,
		0xc9f7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9638)
			}
		},
		{
		0xc9cb,
		0xc9cf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9780)
			}
		},
		{
		0xc9af,
		0xc9bf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9774)
			}
		},
		{
		0xc99e,
		0xc9ae,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9780)
			}
		},
		{
		0xc991,
		0xc997,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9776)
			}
		},
		{
		0xc97d,
		0xc987,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9778)
			}
		},
		{
		0xc975,
		0xc97b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9777)
			}
		},
		{
		0xc964,
		0xc96b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9934)
			}
		},
		{
		0xc959,
		0xc95f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9931)
			}
		},
		{
		0xc948,
		0xc94f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9927)
			}
		},
		{
		0xc935,
		0xc947,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9933)
			}
		},
		{
		0xc92d,
		0xc933,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9932)
			}
		},
		{
		0xc919,
		0xc92b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9937)
			}
		},
		{
		0xc912,
		0xc917,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -9936)
			}
		},
		{
		0xc907,
		0xc90b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10092)
			}
		},
		{
		0xc8f6,
		0xc8fb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10086)
			}
		},
		{
		0xc8e6,
		0xc8f4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10085)
			}
		},
		{
		0xc8da,
		0xc8df,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10088)
			}
		},
		{
		0xc8cd,
		0xc8d3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10084)
			}
		},
		{
		0xc8a9,
		0xc8bb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10085)
			}
		},
		{
		0xc895,
		0xc89c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10147)
			}
		},
		{
		0xc88e,
		0xc893,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10146)
			}
		},
		{
		0xc87b,
		0xc87f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10137)
			}
		},
		{
		0xc855,
		0xc86f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10132)
			}
		},
		{
		0xc84e,
		0xc853,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10131)
			}
		},
		{
		0xc841,
		0xc847,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10127)
			}
		},
		{
		0xc832,
		0xc837,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10124)
			}
		},
		{
		0xc825,
		0xc82b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10120)
			}
		},
		{
		0xc817,
		0xc81b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10116)
			}
		},
		{
		0xc80b,
		0xc80f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10111)
			}
		},
		{
		0xc7fb,
		0xc7ff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10106)
			}
		},
		{
		0xc7ed,
		0xc7fa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10112)
			}
		},
		{
		0xc7de,
		0xc7e3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10109)
			}
		},
		{
		0xc7d1,
		0xc7d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10113)
			}
		},
		{
		0xc7c2,
		0xc7c7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10108)
			}
		},
		{
		0xc7a7,
		0xc7ab,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10165)
			}
		},
		{
		0xc79b,
		0xc79f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10159)
			}
		},
		{
		0xc76c,
		0xc773,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10138)
			}
		},
		{
		0xc761,
		0xc767,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10136)
			}
		},
		{
		0xc751,
		0xc758,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -1681)
			}
		},
		{
		0xc745,
		0xc749,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10122)
			}
		},
		{
		0xc729,
		0xc72f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10113)
			}
		},
		{
		0xc71a,
		0xc71f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10109)
			}
		},
		{
		0xc70d,
		0xc713,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10105)
			}
		},
		{
		0xc6fe,
		0xc703,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10101)
			}
		},
		{
		0xc6f3,
		0xc6f7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10098)
			}
		},
		{
		0xc6e2,
		0xc6e7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10100)
			}
		},
		{
		0xc6d5,
		0xc6db,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10096)
			}
		},
		{
		0xc6c6,
		0xc6cb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10098)
			}
		},
		{
		0xc6bb,
		0xc6bf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10094)
			}
		},
		{
		0xc6aa,
		0xc6af,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10088)
			}
		},
		{
		0xc69d,
		0xc6a3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10150)
			}
		},
		{
		0xc68e,
		0xc693,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10146)
			}
		},
		{
		0xc681,
		0xc687,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10142)
			}
		},
		{
		0xc672,
		0xc677,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10138)
			}
		},
		{
		0xc661,
		0xc66b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10135)
			}
		},
		{
		0xc656,
		0xc65b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10132)
			}
		},
		{
		0xc649,
		0xc64f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10127)
			}
		},
		{
		0xc61d,
		0xc623,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10110)
			}
		},
		{
		0xc611,
		0xc617,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10106)
			}
		},
		{
		0xc5fc,
		0xc601,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -1612)
			}
		},
		{
		0xc5d9,
		0xc5df,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10089)
			}
		},
		{
		0xc5c4,
		0xc5ca,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -1742)
			}
		},
		{
		0xc5bf,
		0xc5c3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10076)
			}
		},
		{
		0xc5aa,
		0xc5b3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10074)
			}
		},
		{
		0xc5a1,
		0xc5a8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10073)
			}
		},
		{
		0xc576,
		0xc57b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10125)
			}
		},
		{
		0xc569,
		0xc56f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10120)
			}
		},
		{
		0xc53e,
		0xc543,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10100)
			}
		},
		{
		0xc531,
		0xc537,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10096)
			}
		},
		{
		0xc51d,
		0xc527,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10092)
			}
		},
		{
		0xc515,
		0xc51b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10091)
			}
		},
		{
		0xc502,
		0xc50b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10088)
			}
		},
		{
		0xc4ea,
		0xc4ef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10080)
			}
		},
		{
		0xc4e0,
		0xc4e8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10079)
			}
		},
		{
		0xc4c6,
		0xc4df,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10085)
			}
		},
		{
		0xc4bd,
		0xc4c5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10091)
			}
		},
		{
		0xc4aa,
		0xc4b7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10089)
			}
		},
		{
		0xc49d,
		0xc4a9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10155)
			}
		},
		{
		0xc495,
		0xc49b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10154)
			}
		},
		{
		0xc481,
		0xc493,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10153)
			}
		},
		{
		0xc47a,
		0xc47f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10152)
			}
		},
		{
		0xc46d,
		0xc473,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10149)
			}
		},
		{
		0xc449,
		0xc463,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10145)
			}
		},
		{
		0xc43e,
		0xc447,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10144)
			}
		},
		{
		0xc435,
		0xc43b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10142)
			}
		},
		{
		0xc425,
		0xc42b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10139)
			}
		},
		{
		0xc41b,
		0xc423,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10138)
			}
		},
		{
		0xc411,
		0xc41a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10144)
			}
		},
		{
		0xc409,
		0xc40f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10143)
			}
		},
		{
		0xc3ff,
		0xc407,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10142)
			}
		},
		{
		0xc3f9,
		0xc3fe,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10148)
			}
		},
		{
		0xc3ee,
		0xc3f3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10145)
			}
		},
		{
		0xc3e3,
		0xc3e7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10142)
			}
		},
		{
		0xc3c1,
		0xc3d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10202)
			}
		},
		{
		0xc38d,
		0xc3bf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10201)
			}
		},
		{
		0xc37e,
		0xc383,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10198)
			}
		},
		{
		0xc373,
		0xc377,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10194)
			}
		},
		{
		0xc34e,
		0xc367,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10189)
			}
		},
		{
		0xc346,
		0xc34d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10195)
			}
		},
		{
		0xc333,
		0xc344,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10194)
			}
		},
		{
		0xc32a,
		0xc332,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10200)
			}
		},
		{
		0xc31d,
		0xc323,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10196)
			}
		},
		{
		0xc301,
		0xc307,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10253)
			}
		},
		{
		0xc2e5,
		0xc2ea,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10242)
			}
		},
		{
		0xc2ba,
		0xc2db,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10237)
			}
		},
		{
		0xc2ae,
		0xc2b3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10233)
			}
		},
		{
		0xc29e,
		0xc2a3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10228)
			}
		},
		{
		0xc291,
		0xc297,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10225)
			}
		},
		{
		0xc28a,
		0xc28f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10224)
			}
		},
		{
		0xc282,
		0xc287,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10222)
			}
		},
		{
		0xc275,
		0xc27b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10218)
			}
		},
		{
		0xc267,
		0xc26b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10214)
			}
		},
		{
		0xc259,
		0xc25f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10218)
			}
		},
		{
		0xc249,
		0xc24f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10214)
			}
		},
		{
		0xc235,
		0xc245,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10219)
			}
		},
		{
		0xc212,
		0xc217,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10272)
			}
		},
		{
		0xc205,
		0xc20b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10268)
			}
		},
		{
		0xc1f4,
		0xc1fb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10264)
			}
		},
		{
		0xc1e9,
		0xc1ef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10261)
			}
		},
		{
		0xc1d9,
		0xc1df,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10258)
			}
		},
		{
		0xc1cd,
		0xc1d3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10255)
			}
		},
		{
		0xc1be,
		0xc1c3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10252)
			}
		},
		{
		0xc1b1,
		0xc1bc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10251)
			}
		},
		{
		0xc197,
		0xc19b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10242)
			}
		},
		{
		0xc186,
		0xc18b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10236)
			}
		},
		{
		0xc17c,
		0xc184,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10235)
			}
		},
		{
		0xc16a,
		0xc16f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10238)
			}
		},
		{
		0xc15d,
		0xc163,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10233)
			}
		},
		{
		0xc14e,
		0xc153,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10235)
			}
		},
		{
		0xc141,
		0xc147,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10230)
			}
		},
		{
		0xc11c,
		0xc120,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -1135)
			}
		},
		{
		0xc116,
		0xc11b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10277)
			}
		},
		{
		0xc109,
		0xc10f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10275)
			}
		},
		{
		0xc0fa,
		0xc0ff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10272)
			}
		},
		{
		0xc0ed,
		0xc0f3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10268)
			}
		},
		{
		0xc0de,
		0xc0e3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10264)
			}
		},
		{
		0xc0d1,
		0xc0d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10259)
			}
		},
		{
		0xc0b7,
		0xc0bb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10249)
			}
		},
		{
		0xc0a6,
		0xc0ab,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10241)
			}
		},
		{
		0xc099,
		0xc09f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10237)
			}
		},
		{
		0xc07a,
		0xc08f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10233)
			}
		},
		{
		0xc06a,
		0xc079,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10239)
			}
		},
		{
		0xc061,
		0xc067,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10237)
			}
		},
		{
		0xc052,
		0xc057,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10240)
			}
		},
		{
		0xc040,
		0xc050,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10239)
			}
		},
		{
		0xbfe2,
		0xc03b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10304)
			}
		},
		{
		0xbfd5,
		0xbfdb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10301)
			}
		},
		{
		0xbfc6,
		0xbfcb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10297)
			}
		},
		{
		0xbfb9,
		0xbfc4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10296)
			}
		},
		{
		0xbfb1,
		0xbfb8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10302)
			}
		},
		{
		0xbf9e,
		0xbfaf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10301)
			}
		},
		{
		0xbf95,
		0xbf9d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10307)
			}
		},
		{
		0xbf83,
		0xbf93,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10306)
			}
		},
		{
		0xbf56,
		0xbf82,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10372)
			}
		},
		{
		0xbf49,
		0xbf4f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10369)
			}
		},
		{
		0xbf1e,
		0xbf3f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10365)
			}
		},
		{
		0xbf0a,
		0xbf17,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10360)
			}
		},
		{
		0xbf02,
		0xbf07,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10358)
			}
		},
		{
		0xbef6,
		0xbf00,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10357)
			}
		},
		{
		0xbeed,
		0xbef5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10363)
			}
		},
		{
		0xbee6,
		0xbeeb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10362)
			}
		},
		{
		0xbed9,
		0xbedf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10358)
			}
		},
		{
		0xbeb8,
		0xbecf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10359)
			}
		},
		{
		0xbea9,
		0xbeb7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10425)
			}
		},
		{
		0xbe9a,
		0xbea7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10424)
			}
		},
		{
		0xbe92,
		0xbe97,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10422)
			}
		},
		{
		0xbe85,
		0xbe8b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10417)
			}
		},
		{
		0xbe76,
		0xbe7a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10412)
			}
		},
		{
		0xbe6b,
		0xbe6f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10407)
			}
		},
		{
		0xbe4f,
		0xbe53,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10396)
			}
		},
		{
		0xbe20,
		0xbe43,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10391)
			}
		},
		{
		0xbe15,
		0xbe1b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10388)
			}
		},
		{
		0xbe06,
		0xbe0b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10390)
			}
		},
		{
		0xbdf9,
		0xbdff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10387)
			}
		},
		{
		0xbdea,
		0xbdef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10390)
			}
		},
		{
		0xbddd,
		0xbde8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10389)
			}
		},
		{
		0xbdb9,
		0xbdd1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10451)
			}
		},
		{
		0xbdb1,
		0xbdb7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10450)
			}
		},
		{
		0xbda5,
		0xbdaf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10449)
			}
		},
		{
		0xbd9d,
		0xbda3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10448)
			}
		},
		{
		0xbd8b,
		0xbd8f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10441)
			}
		},
		{
		0xbd69,
		0xbd7f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10434)
			}
		},
		{
		0xbd5a,
		0xbd63,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10432)
			}
		},
		{
		0xbd51,
		0xbd57,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10430)
			}
		},
		{
		0xbd41,
		0xbd47,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10426)
			}
		},
		{
		0xbd3a,
		0xbd3f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10425)
			}
		},
		{
		0xbd2d,
		0xbd39,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10431)
			}
		},
		{
		0xbd25,
		0xbd2b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10430)
			}
		},
		{
		0xbd1e,
		0xbd23,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10429)
			}
		},
		{
		0xbd15,
		0xbd1d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10435)
			}
		},
		{
		0xbd0a,
		0xbd0f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10433)
			}
		},
		{
		0xbcfe,
		0xbd03,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10429)
			}
		},
		{
		0xbcdd,
		0xbcf3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10490)
			}
		},
		{
		0xbcc5,
		0xbccc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10483)
			}
		},
		{
		0xbcb6,
		0xbcbb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10479)
			}
		},
		{
		0xbca9,
		0xbcaf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10474)
			}
		},
		{
		0xbc9b,
		0xbc9f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10469)
			}
		},
		{
		0xbc8f,
		0xbc93,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10464)
			}
		},
		{
		0xbc5e,
		0xbc83,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10458)
			}
		},
		{
		0xbc51,
		0xbc59,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10463)
			}
		},
		{
		0xbc39,
		0xbc3f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10454)
			}
		},
		{
		0xbc1b,
		0xbc1f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -573)
			}
		},
		{
		0xbc14,
		0xbc18,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -571)
			}
		},
		{
		0xbc03,
		0xbc07,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10434)
			}
		},
		{
		0xbbd4,
		0xbbf7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10494)
			}
		},
		{
		0xbbc9,
		0xbbcf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10492)
			}
		},
		{
		0xbbb8,
		0xbbbf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10489)
			}
		},
		{
		0xbbad,
		0xbbb3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10487)
			}
		},
		{
		0xbb91,
		0xbba3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10484)
			}
		},
		{
		0xbb72,
		0xbb87,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10481)
			}
		},
		{
		0xbb6d,
		0xbb71,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10487)
			}
		},
		{
		0xbb64,
		0xbb6b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10486)
			}
		},
		{
		0xbb59,
		0xbb60,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10484)
			}
		},
		{
		0xbb3f,
		0xbb43,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10481)
			}
		},
		{
		0xbb2c,
		0xbb33,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10473)
			}
		},
		{
		0xbb21,
		0xbb27,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10537)
			}
		},
		{
		0xbb12,
		0xbb17,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10534)
			}
		},
		{
		0xbb05,
		0xbb0c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10531)
			}
		},
		{
		0xbada,
		0xbafb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10528)
			}
		},
		{
		0xbac9,
		0xbad7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10526)
			}
		},
		{
		0xbabe,
		0xbac3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10524)
			}
		},
		{
		0xbab3,
		0xbab7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10520)
			}
		},
		{
		0xba93,
		0xbaa7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10514)
			}
		},
		{
		0xba8d,
		0xba92,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10520)
			}
		},
		{
		0xba79,
		0xba82,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10515)
			}
		},
		{
		0xba6a,
		0xba6f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10517)
			}
		},
		{
		0xba5d,
		0xba63,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10512)
			}
		},
		{
		0xba16,
		0xba37,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10563)
			}
		},
		{
		0xba09,
		0xba14,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10562)
			}
		},
		{
		0xba02,
		0xba07,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10561)
			}
		},
		{
		0xb9fb,
		0xb9ff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10559)
			}
		},
		{
		0xb9ed,
		0xb9f3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10553)
			}
		},
		{
		0xb9d3,
		0xb9d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10542)
			}
		},
		{
		0xb9ce,
		0xb9d2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -277)
			}
		},
		{
		0xb9c2,
		0xb9c7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10534)
			}
		},
		{
		0xb9b5,
		0xb9bb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10530)
			}
		},
		{
		0xb99f,
		0xb9ab,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10526)
			}
		},
		{
		0xb98f,
		0xb99e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10532)
			}
		},
		{
		0xb97e,
		0xb983,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10525)
			}
		},
		{
		0xb96e,
		0xb973,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10527)
			}
		},
		{
		0xb961,
		0xb967,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10523)
			}
		},
		{
		0xb952,
		0xb957,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10585)
			}
		},
		{
		0xb945,
		0xb94b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10582)
			}
		},
		{
		0xb921,
		0xb93b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10578)
			}
		},
		{
		0xb919,
		0xb91f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10577)
			}
		},
		{
		0xb905,
		0xb917,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10576)
			}
		},
		{
		0xb8fe,
		0xb903,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10575)
			}
		},
		{
		0xb8f1,
		0xb8f7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10571)
			}
		},
		{
		0xb8e2,
		0xb8e7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10567)
			}
		},
		{
		0xb8d5,
		0xb8dc,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10564)
			}
		},
		{
		0xb8c6,
		0xb8cb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10561)
			}
		},
		{
		0xb8b9,
		0xb8bd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10563)
			}
		},
		{
		0xb8a9,
		0xb8af,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10560)
			}
		},
		{
		0xb8a0,
		0xb8a7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10559)
			}
		},
		{
		0xb88e,
		0xb89f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10565)
			}
		},
		{
		0xb885,
		0xb88c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10564)
			}
		},
		{
		0xb87d,
		0xb884,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10630)
			}
		},
		{
		0xb872,
		0xb877,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10628)
			}
		},
		{
		0xb865,
		0xb86b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10624)
			}
		},
		{
		0xb854,
		0xb85b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10620)
			}
		},
		{
		0xb845,
		0xb850,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10618)
			}
		},
		{
		0xb83a,
		0xb83f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10616)
			}
		},
		{
		0xb82d,
		0xb833,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10611)
			}
		},
		{
		0xb81e,
		0xb823,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10607)
			}
		},
		{
		0xb811,
		0xb817,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10603)
			}
		},
		{
		0xb802,
		0xb806,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10598)
			}
		},
		{
		0xb7f5,
		0xb7fb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10593)
			}
		},
		{
		0xb7de,
		0xb7eb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10589)
			}
		},
		{
		0xb7ca,
		0xb7dd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10595)
			}
		},
		{
		0xb7c2,
		0xb7c6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10593)
			}
		},
		{
		0xb7b9,
		0xb7c1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10599)
			}
		},
		{
		0xb7ae,
		0xb7b3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10596)
			}
		},
		{
		0xb7a1,
		0xb7a7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10591)
			}
		},
		{
		0xb785,
		0xb78b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10645)
			}
		},
		{
		0xb776,
		0xb77b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10641)
			}
		},
		{
		0xb769,
		0xb76f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10637)
			}
		},
		{
		0xb756,
		0xb75f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10634)
			}
		},
		{
		0xb74d,
		0xb753,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10632)
			}
		},
		{
		0xb73c,
		0xb743,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10629)
			}
		},
		{
		0xb731,
		0xb737,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10626)
			}
		},
		{
		0xb706,
		0xb727,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10621)
			}
		},
		{
		0xb6fb,
		0xb6ff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10618)
			}
		},
		{
		0xb6de,
		0xb6ef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10621)
			}
		},
		{
		0xb6d5,
		0xb6dd,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10627)
			}
		},
		{
		0xb6c3,
		0xb6d3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10626)
			}
		},
		{
		0xb6b2,
		0xb6c2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10692)
			}
		},
		{
		0xb6a5,
		0xb6aa,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10689)
			}
		},
		{
		0xb669,
		0xb69b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10685)
			}
		},
		{
		0xb649,
		0xb663,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10683)
			}
		},
		{
		0xb63b,
		0xb647,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10682)
			}
		},
		{
		0xb635,
		0xb63a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10688)
			}
		},
		{
		0xb62d,
		0xb633,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10687)
			}
		},
		{
		0xb626,
		0xb62b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10686)
			}
		},
		{
		0xb61e,
		0xb624,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10685)
			}
		},
		{
		0xb619,
		0xb61d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10691)
			}
		},
		{
		0xb600,
		0xb60f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10687)
			}
		},
		{
		0xb5ed,
		0xb5ff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10753)
			}
		},
		{
		0xb5d9,
		0xb5eb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10752)
			}
		},
		{
		0xb5d2,
		0xb5d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10751)
			}
		},
		{
		0xb5c5,
		0xb5cb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10746)
			}
		},
		{
		0xb5b6,
		0xb5ba,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10741)
			}
		},
		{
		0xb56b,
		0xb59f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10730)
			}
		},
		{
		0xb562,
		0xb56a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10736)
			}
		},
		{
		0xb555,
		0xb55b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10731)
			}
		},
		{
		0xb539,
		0xb53f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10727)
			}
		},
		{
		0xb52b,
		0xb52f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10723)
			}
		},
		{
		0xb51e,
		0xb523,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10717)
			}
		},
		{
		0xb4f9,
		0xb513,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10778)
			}
		},
		{
		0xb4f2,
		0xb4f7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10777)
			}
		},
		{
		0xb4e7,
		0xb4eb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10773)
			}
		},
		{
		0xb4d6,
		0xb4db,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10767)
			}
		},
		{
		0xb4c9,
		0xb4cf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10765)
			}
		},
		{
		0xb4ba,
		0xb4bf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10762)
			}
		},
		{
		0xb4ad,
		0xb4b4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10759)
			}
		},
		{
		0xb49e,
		0xb4a3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10756)
			}
		},
		{
		0xb489,
		0xb49c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10755)
			}
		},
		{
		0xb483,
		0xb487,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10754)
			}
		},
		{
		0xb46d,
		0xb47f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10759)
			}
		},
		{
		0xb467,
		0xb46b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10758)
			}
		},
		{
		0xb459,
		0xb45f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10760)
			}
		},
		{
		0xb445,
		0xb44f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10756)
			}
		},
		{
		0xb435,
		0xb444,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10822)
			}
		},
		{
		0xb42c,
		0xb433,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10821)
			}
		},
		{
		0xb421,
		0xb427,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10818)
			}
		},
		{
		0xb411,
		0xb417,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10815)
			}
		},
		{
		0xb3fd,
		0xb40f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10814)
			}
		},
		{
		0xb3e9,
		0xb3fb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10813)
			}
		},
		{
		0xb3ae,
		0xb3c3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10797)
			}
		},
		{
		0xb3a2,
		0xb3a7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10801)
			}
		},
		{
		0xb395,
		0xb39f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10799)
			}
		},
		{
		0xb386,
		0xb38b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10802)
			}
		},
		{
		0xb379,
		0xb37f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10797)
			}
		},
		{
		0xb31d,
		0xb353,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10845)
			}
		},
		{
		0xb316,
		0xb31b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10844)
			}
		},
		{
		0xb309,
		0xb30f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10839)
			}
		},
		{
		0xb2f7,
		0xb2fb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 494)
			}
		},
		{
		0xb2eb,
		0xb2ef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 498)
			}
		},
		{
		0xb2d3,
		0xb2d7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10812)
			}
		},
		{
		0xb2b8,
		0xb2c7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10807)
			}
		},
		{
		0xb29b,
		0xb29f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10804)
			}
		},
		{
		0xb28a,
		0xb28e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10804)
			}
		},
		{
		0xb27d,
		0xb283,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10801)
			}
		},
		{
		0xb276,
		0xb27b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10800)
			}
		},
		{
		0xb26f,
		0xb273,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10798)
			}
		},
		{
		0xb26a,
		0xb26e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10864)
			}
		},
		{
		0xb261,
		0xb267,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10862)
			}
		},
		{
		0xb23d,
		0xb257,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10859)
			}
		},
		{
		0xb235,
		0xb23b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10858)
			}
		},
		{
		0xb221,
		0xb233,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10857)
			}
		},
		{
		0xb21a,
		0xb21f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10856)
			}
		},
		{
		0xb20d,
		0xb213,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10852)
			}
		},
		{
		0xb1fe,
		0xb203,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10847)
			}
		},
		{
		0xb1f1,
		0xb1f8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10844)
			}
		},
		{
		0xb1e0,
		0xb1e7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10840)
			}
		},
		{
		0xb1d6,
		0xb1db,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10837)
			}
		},
		{
		0xb1b9,
		0xb1cb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10840)
			}
		},
		{
		0xb1a9,
		0xb1b8,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10846)
			}
		},
		{
		0xb19e,
		0xb1a7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10845)
			}
		},
		{
		0xb183,
		0xb187,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10902)
			}
		},
		{
		0xb161,
		0xb177,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10897)
			}
		},
		{
		0xb149,
		0xb14f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10890)
			}
		},
		{
		0xb13a,
		0xb13f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10886)
			}
		},
		{
		0xb12d,
		0xb133,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10881)
			}
		},
		{
		0xb11e,
		0xb122,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10876)
			}
		},
		{
		0xb0f1,
		0xb107,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10864)
			}
		},
		{
		0xb0e6,
		0xb0f0,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10870)
			}
		},
		{
		0xb0d9,
		0xb0df,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10868)
			}
		},
		{
		0xb0ca,
		0xb0cf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10870)
			}
		},
		{
		0xb0bd,
		0xb0c3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10865)
			}
		},
		{
		0xb0ab,
		0xb0af,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 777)
			}
		},
		{
		0xb092,
		0xb097,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10910)
			}
		},
		{
		0xb085,
		0xb08b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10906)
			}
		},
		{
		0xb05e,
		0xb07b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10902)
			}
		},
		{
		0xb029,
		0xb043,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10890)
			}
		},
		{
		0xb01e,
		0xb027,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10889)
			}
		},
		{
		0xb015,
		0xb01b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10887)
			}
		},
		{
		0xb005,
		0xb00b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10884)
			}
		},
		{
		0xaff9,
		0xafff,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10887)
			}
		},
		{
		0xafea,
		0xafef,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10883)
			}
		},
		{
		0xafe2,
		0xafe7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10881)
			}
		},
		{
		0xafdd,
		0xafe1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10887)
			}
		},
		{
		0xafd5,
		0xafdb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10886)
			}
		},
		{
		0xafcf,
		0xafd3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10885)
			}
		},
		{
		0xafc1,
		0xafc6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10879)
			}
		},
		{
		0xaf9d,
		0xafb7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10941)
			}
		},
		{
		0xaf96,
		0xaf9b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10940)
			}
		},
		{
		0xaf89,
		0xaf8f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10937)
			}
		},
		{
		0xaf7a,
		0xaf7f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10934)
			}
		},
		{
		0xaf66,
		0xaf78,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10933)
			}
		},
		{
		0xaf5e,
		0xaf63,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10931)
			}
		},
		{
		0xaf51,
		0xaf5b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10929)
			}
		},
		{
		0xaf4a,
		0xaf4f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10928)
			}
		},
		{
		0xaf35,
		0xaf3b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10920)
			}
		},
		{
		0xaf24,
		0xaf2b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10915)
			}
		},
		{
		0xaf11,
		0xaf23,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10921)
			}
		},
		{
		0xaefd,
		0xaf05,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10923)
			}
		},
		{
		0xaeee,
		0xaef3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10920)
			}
		},
		{
		0xaedd,
		0xaee5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10983)
			}
		},
		{
		0xaed2,
		0xaed7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10980)
			}
		},
		{
		0xaec5,
		0xaecb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10975)
			}
		},
		{
		0xae8d,
		0xaebb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10970)
			}
		},
		{
		0xae86,
		0xae8b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10969)
			}
		},
		{
		0xae7e,
		0xae83,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10967)
			}
		},
		{
		0xae71,
		0xae77,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10962)
			}
		},
		{
		0xae57,
		0xae5b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10952)
			}
		},
		{
		0xae1d,
		0xae2f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10940)
			}
		},
		{
		0xae15,
		0xae1c,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10946)
			}
		},
		{
		0xae0e,
		0xae13,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10945)
			}
		},
		{
		0xae02,
		0xae07,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10941)
			}
		},
		{
		0xade5,
		0xadf7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -11001)
			}
		},
		{
		0xadd4,
		0xaddb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10998)
			}
		},
		{
		0xadc9,
		0xadcf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10995)
			}
		},
		{
		0xadb8,
		0xadbf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10991)
			}
		},
		{
		0xada5,
		0xadb6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10990)
			}
		},
		{
		0xad9e,
		0xada3,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10989)
			}
		},
		{
		0xad91,
		0xad9b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10987)
			}
		},
		{
		0xad83,
		0xad87,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10983)
			}
		},
		{
		0xad64,
		0xad6b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10970)
			}
		},
		{
		0xad59,
		0xad60,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10968)
			}
		},
		{
		0xad4a,
		0xad4f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10971)
			}
		},
		{
		0xad3d,
		0xad43,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10967)
			}
		},
		{
		0xad2e,
		0xad33,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10969)
			}
		},
		{
		0xad21,
		0xad28,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10966)
			}
		},
		{
		0xad07,
		0xad0b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -11025)
			}
		},
		{
		0xacf7,
		0xacfb,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -11020)
			}
		},
		{
		0xacd8,
		0xacdf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -11007)
			}
		},
		{
		0xaccd,
		0xacd4,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -11005)
			}
		},
		{
		0xacb1,
		0xacb7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10996)
			}
		},
		{
		0xaca2,
		0xaca7,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10990)
			}
		},
		{
		0xac95,
		0xac9b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10985)
			}
		},
		{
		0xac7b,
		0xac7f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10973)
			}
		},
		{
		0xac5d,
		0xac6f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10967)
			}
		},
		{
		0xac4e,
		0xac53,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10970)
			}
		},
		{
		0xac41,
		0xac4a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10968)
			}
		},
		{
		0xac25,
		0xac2b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10965)
			}
		},
		{
		0xac19,
		0xac1d,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 1175)
			}
		},
		{
		0xac10,
		0xac17,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 1176)
			}
		},
		{
		0xac0b,
		0xac0f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, -10950)
			}
		},
		{
		0x33ba,
		0x33bf,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 29716)
			}
		},
		{
		0x33b0,
		0x33b9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 29711)
			}
		},
		{
		0x3399,
		0x33a2,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 29714)
			}
		},
		{
		0x3390,
		0x3394,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 29764)
			}
		},
		{
		0x3380,
		0x3384,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 29769)
			}
		},
		{
		0x3260,
		0x327b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 30289)
			}
		},
		{
		0x3200,
		0x321b,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 30641)
			}
		},
		{
		0x3131,
		0x318e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 29552)
			}
		},
		{
		0x30a1,
		0x30f6,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 31488)
			}
		},
		{
		0x3041,
		0x3093,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 31328)
			}
		},
		{
		0x3008,
		0x3011,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 29100)
			}
		},
		{
		0x2543,
		0x254a,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 33178)
			}
		},
		{
		0x24d0,
		0x24e9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 33789)
			}
		},
		{
		0x249c,
		0x24b5,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 34097)
			}
		},
		{
		0x2474,
		0x2482,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 34163)
			}
		},
		{
		0x2460,
		0x246e,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 33927)
			}
		},
		{
		0x2170,
		0x2179,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 33841)
			}
		},
		{
		0x2160,
		0x2169,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 33872)
			}
		},
		{
		0x0436,
		0x044f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 43170)
			}
		},
		{
		0x0430,
		0x0435,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 43169)
			}
		},
		{
		0x0416,
		0x042f,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 43154)
			}
		},
		{
		0x0410,
		0x0415,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 43153)
			}
		},
		{
		0x03c3,
		0x03c9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 41519)
			}
		},
		{
		0x03b1,
		0x03c1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 41520)
			}
		},
		{
		0x03a3,
		0x03a9,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 41519)
			}
		},
		{
		0x0391,
		0x03a1,
		SCnvConversionData::SOneDirectionData::SRange::EOffset,
		2,
		0,
			{
			STATIC_CAST(TUint, 41520)
			}
		},
		{
		0xf958,
		0xfa0b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_1)
			}
		},
		{
		0xf944,
		0xf949,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_2)
			}
		},
		{
		0xf92d,
		0xf932,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_3)
			}
		},
		{
		0xf919,
		0xf927,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_4)
			}
		},
		{
		0xf900,
		0xf90d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_5)
			}
		},
		{
		0xd798,
		0xd79d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_6)
			}
		},
		{
		0xd788,
		0xd790,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_7)
			}
		},
		{
		0xd77c,
		0xd781,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_8)
			}
		},
		{
		0xd75f,
		0xd774,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_9)
			}
		},
		{
		0xd750,
		0xd759,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_10)
			}
		},
		{
		0xd744,
		0xd749,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_11)
			}
		},
		{
		0xd734,
		0xd73c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_12)
			}
		},
		{
		0xd728,
		0xd72d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_13)
			}
		},
		{
		0xd711,
		0xd720,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_14)
			}
		},
		{
		0xd6fc,
		0xd704,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_15)
			}
		},
		{
		0xd6ee,
		0xd6f5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_16)
			}
		},
		{
		0xd6e0,
		0xd6e8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_17)
			}
		},
		{
		0xd6c4,
		0xd6d9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_18)
			}
		},
		{
		0xd6a8,
		0xd6b0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_19)
			}
		},
		{
		0xd69d,
		0xd6a1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_20)
			}
		},
		{
		0xd68c,
		0xd694,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_21)
			}
		},
		{
		0xd681,
		0xd685,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_22)
			}
		},
		{
		0xd670,
		0xd674,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_23)
			}
		},
		{
		0xd638,
		0xd65c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_24)
			}
		},
		{
		0xd61c,
		0xd624,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_25)
			}
		},
		{
		0xd610,
		0xd615,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_26)
			}
		},
		{
		0xd600,
		0xd608,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_27)
			}
		},
		{
		0xd5f4,
		0xd5f9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_28)
			}
		},
		{
		0xd5e4,
		0xd5ee,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_29)
			}
		},
		{
		0xd5d8,
		0xd5dd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_30)
			}
		},
		{
		0xd5c8,
		0xd5d2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_31)
			}
		},
		{
		0xd584,
		0xd590,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_32)
			}
		},
		{
		0xd574,
		0xd57c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_33)
			}
		},
		{
		0xd558,
		0xd56d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_34)
			}
		},
		{
		0xd54c,
		0xd551,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_35)
			}
		},
		{
		0xd538,
		0xd544,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_36)
			}
		},
		{
		0xd504,
		0xd50c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_37)
			}
		},
		{
		0xd4f8,
		0xd4fd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_38)
			}
		},
		{
		0xd4e8,
		0xd4f0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_39)
			}
		},
		{
		0xd4cc,
		0xd4d5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_40)
			}
		},
		{
		0xd488,
		0xd48d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_41)
			}
		},
		{
		0xd478,
		0xd482,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_42)
			}
		},
		{
		0xd46d,
		0xd472,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_43)
			}
		},
		{
		0xd45c,
		0xd464,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_44)
			}
		},
		{
		0xd440,
		0xd444,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_45)
			}
		},
		{
		0xd3ec,
		0xd401,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_46)
			}
		},
		{
		0xd3c4,
		0xd3c9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_47)
			}
		},
		{
		0xd3b4,
		0xd3bc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_48)
			}
		},
		{
		0xd3a8,
		0xd3ae,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_49)
			}
		},
		{
		0xd398,
		0xd3a0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_50)
			}
		},
		{
		0xd37c,
		0xd391,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_51)
			}
		},
		{
		0xd344,
		0xd349,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_52)
			}
		},
		{
		0xd338,
		0xd33d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_53)
			}
		},
		{
		0xd31c,
		0xd330,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_54)
			}
		},
		{
		0xd30c,
		0xd316,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_55)
			}
		},
		{
		0xd300,
		0xd305,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_56)
			}
		},
		{
		0xd2f0,
		0xd2fa,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_57)
			}
		},
		{
		0xd2d2,
		0xd2dc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_58)
			}
		},
		{
		0xd2b8,
		0xd2c2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_59)
			}
		},
		{
		0xd2ac,
		0xd2b1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_60)
			}
		},
		{
		0xd29c,
		0xd2a4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_61)
			}
		},
		{
		0xd280,
		0xd295,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_62)
			}
		},
		{
		0xd264,
		0xd268,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_63)
			}
		},
		{
		0xd248,
		0xd24c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_64)
			}
		},
		{
		0xd23c,
		0xd241,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_65)
			}
		},
		{
		0xd22a,
		0xd234,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_66)
			}
		},
		{
		0xd1f4,
		0xd1f8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_67)
			}
		},
		{
		0xd1b0,
		0xd1c0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_68)
			}
		},
		{
		0xd1a0,
		0xd1a8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_69)
			}
		},
		{
		0xd184,
		0xd18a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_70)
			}
		},
		{
		0xd168,
		0xd16d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_71)
			}
		},
		{
		0xd15c,
		0xd161,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_72)
			}
		},
		{
		0xd14c,
		0xd154,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_73)
			}
		},
		{
		0xd130,
		0xd145,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_74)
			}
		},
		{
		0xd0ec,
		0xd0f1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_75)
			}
		},
		{
		0xd0db,
		0xd0e4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_76)
			}
		},
		{
		0xd0d0,
		0xd0d5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_77)
			}
		},
		{
		0xd0c0,
		0xd0c9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_78)
			}
		},
		{
		0xd0b3,
		0xd0b9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_79)
			}
		},
		{
		0xd0a4,
		0xd0ac,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_80)
			}
		},
		{
		0xd07c,
		0xd081,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_81)
			}
		},
		{
		0xd06c,
		0xd074,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_82)
			}
		},
		{
		0xd050,
		0xd058,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_83)
			}
		},
		{
		0xd044,
		0xd049,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_84)
			}
		},
		{
		0xd034,
		0xd03c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_85)
			}
		},
		{
		0xcffc,
		0xd004,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_86)
			}
		},
		{
		0xcff0,
		0xcff5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_87)
			}
		},
		{
		0xcfe0,
		0xcfe9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_88)
			}
		},
		{
		0xcf80,
		0xcf85,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_89)
			}
		},
		{
		0xcf64,
		0xcf78,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_90)
			}
		},
		{
		0xcf54,
		0xcf5c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_91)
			}
		},
		{
		0xcf2c,
		0xcf31,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_92)
			}
		},
		{
		0xcf1c,
		0xcf24,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_93)
			}
		},
		{
		0xcf10,
		0xcf15,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_94)
			}
		},
		{
		0xcf00,
		0xcf08,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_95)
			}
		},
		{
		0xcef4,
		0xcef9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_96)
			}
		},
		{
		0xcee4,
		0xceec,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_97)
			}
		},
		{
		0xcea0,
		0xcea5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_98)
			}
		},
		{
		0xce90,
		0xce99,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_99)
			}
		},
		{
		0xce84,
		0xce89,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_100)
			}
		},
		{
		0xce74,
		0xce7c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_101)
			}
		},
		{
		0xce68,
		0xce6d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_102)
			}
		},
		{
		0xce58,
		0xce61,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_103)
			}
		},
		{
		0xce20,
		0xce35,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_104)
			}
		},
		{
		0xce14,
		0xce19,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_105)
			}
		},
		{
		0xce03,
		0xce0c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_106)
			}
		},
		{
		0xcdf8,
		0xcdfd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_107)
			}
		},
		{
		0xcde8,
		0xcdf0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_108)
			}
		},
		{
		0xcdcc,
		0xcdd0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_109)
			}
		},
		{
		0xcd94,
		0xcda9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_110)
			}
		},
		{
		0xcd6c,
		0xcd71,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_111)
			}
		},
		{
		0xcd5c,
		0xcd64,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_112)
			}
		},
		{
		0xcd18,
		0xcd2c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_113)
			}
		},
		{
		0xcd08,
		0xcd10,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_114)
			}
		},
		{
		0xccec,
		0xccf0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_115)
			}
		},
		{
		0xccd0,
		0xccd4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_116)
			}
		},
		{
		0xccc4,
		0xccc9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_117)
			}
		},
		{
		0xccb4,
		0xccbc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_118)
			}
		},
		{
		0xcca8,
		0xccad,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_119)
			}
		},
		{
		0xcc94,
		0xcca0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_120)
			}
		},
		{
		0xcc70,
		0xcc75,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_121)
			}
		},
		{
		0xcc60,
		0xcc68,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_122)
			}
		},
		{
		0xcc54,
		0xcc59,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_123)
			}
		},
		{
		0xcc44,
		0xcc4e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_124)
			}
		},
		{
		0xcc38,
		0xcc3e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_125)
			}
		},
		{
		0xcc1c,
		0xcc30,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_126)
			}
		},
		{
		0xcc0c,
		0xcc14,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_127)
			}
		},
		{
		0xcbe0,
		0xcbe9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_128)
			}
		},
		{
		0xcb58,
		0xcb5d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_129)
			}
		},
		{
		0xcb41,
		0xcb50,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_130)
			}
		},
		{
		0xcb10,
		0xcb18,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_131)
			}
		},
		{
		0xcae8,
		0xcaec,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_132)
			}
		},
		{
		0xcacc,
		0xcad9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_133)
			}
		},
		{
		0xcabc,
		0xcac5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_134)
			}
		},
		{
		0xca5c,
		0xca61,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_135)
			}
		},
		{
		0xca4c,
		0xca54,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_136)
			}
		},
		{
		0xca14,
		0xca18,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_137)
			}
		},
		{
		0xc9f8,
		0xca0d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_138)
			}
		},
		{
		0xc9d0,
		0xc9f1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_139)
			}
		},
		{
		0xc9c0,
		0xc9ca,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_140)
			}
		},
		{
		0xc998,
		0xc99d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_141)
			}
		},
		{
		0xc988,
		0xc990,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_142)
			}
		},
		{
		0xc96c,
		0xc974,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_143)
			}
		},
		{
		0xc950,
		0xc958,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_144)
			}
		},
		{
		0xc90c,
		0xc911,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_145)
			}
		},
		{
		0xc8fc,
		0xc906,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_146)
			}
		},
		{
		0xc8e0,
		0xc8e5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_147)
			}
		},
		{
		0xc8d4,
		0xc8d9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_148)
			}
		},
		{
		0xc8bc,
		0xc8cc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_149)
			}
		},
		{
		0xc89d,
		0xc8a8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_150)
			}
		},
		{
		0xc880,
		0xc88d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_151)
			}
		},
		{
		0xc870,
		0xc87a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_152)
			}
		},
		{
		0xc848,
		0xc84d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_153)
			}
		},
		{
		0xc838,
		0xc840,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_154)
			}
		},
		{
		0xc82c,
		0xc831,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_155)
			}
		},
		{
		0xc81c,
		0xc824,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_156)
			}
		},
		{
		0xc810,
		0xc816,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_157)
			}
		},
		{
		0xc800,
		0xc80a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_158)
			}
		},
		{
		0xc7e4,
		0xc7ec,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_159)
			}
		},
		{
		0xc7d8,
		0xc7dd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_160)
			}
		},
		{
		0xc7c8,
		0xc7d0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_161)
			}
		},
		{
		0xc7ac,
		0xc7c1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_162)
			}
		},
		{
		0xc7a0,
		0xc7a6,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_163)
			}
		},
		{
		0xc774,
		0xc79a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_164)
			}
		},
		{
		0xc759,
		0xc760,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_165)
			}
		},
		{
		0xc74a,
		0xc750,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_166)
			}
		},
		{
		0xc730,
		0xc744,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_167)
			}
		},
		{
		0xc720,
		0xc728,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_168)
			}
		},
		{
		0xc714,
		0xc719,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_169)
			}
		},
		{
		0xc704,
		0xc70c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_170)
			}
		},
		{
		0xc6f8,
		0xc6fd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_171)
			}
		},
		{
		0xc6e8,
		0xc6f2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_172)
			}
		},
		{
		0xc6dc,
		0xc6e1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_173)
			}
		},
		{
		0xc6cc,
		0xc6d4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_174)
			}
		},
		{
		0xc6c0,
		0xc6c5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_175)
			}
		},
		{
		0xc6b0,
		0xc6ba,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_176)
			}
		},
		{
		0xc6a4,
		0xc6a9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_177)
			}
		},
		{
		0xc694,
		0xc69c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_178)
			}
		},
		{
		0xc688,
		0xc68d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_179)
			}
		},
		{
		0xc678,
		0xc680,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_180)
			}
		},
		{
		0xc66c,
		0xc671,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_181)
			}
		},
		{
		0xc65c,
		0xc660,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_182)
			}
		},
		{
		0xc650,
		0xc655,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_183)
			}
		},
		{
		0xc624,
		0xc648,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_184)
			}
		},
		{
		0xc618,
		0xc61c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_185)
			}
		},
		{
		0xc602,
		0xc610,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_186)
			}
		},
		{
		0xc5e0,
		0xc5fb,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_187)
			}
		},
		{
		0xc5cb,
		0xc5d8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_188)
			}
		},
		{
		0xc5b4,
		0xc5be,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_189)
			}
		},
		{
		0xc57c,
		0xc5a0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_190)
			}
		},
		{
		0xc570,
		0xc575,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_191)
			}
		},
		{
		0xc544,
		0xc568,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_192)
			}
		},
		{
		0xc538,
		0xc53d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_193)
			}
		},
		{
		0xc528,
		0xc530,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_194)
			}
		},
		{
		0xc50c,
		0xc514,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_195)
			}
		},
		{
		0xc4f0,
		0xc501,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_196)
			}
		},
		{
		0xc4b8,
		0xc4bc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_197)
			}
		},
		{
		0xc474,
		0xc479,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_198)
			}
		},
		{
		0xc464,
		0xc46c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_199)
			}
		},
		{
		0xc42c,
		0xc434,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_200)
			}
		},
		{
		0xc3f4,
		0xc3f8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_201)
			}
		},
		{
		0xc3e8,
		0xc3ed,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_202)
			}
		},
		{
		0xc3d8,
		0xc3e2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_203)
			}
		},
		{
		0xc384,
		0xc38c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_204)
			}
		},
		{
		0xc378,
		0xc37d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_205)
			}
		},
		{
		0xc368,
		0xc372,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_206)
			}
		},
		{
		0xc324,
		0xc329,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_207)
			}
		},
		{
		0xc308,
		0xc31c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_208)
			}
		},
		{
		0xc2eb,
		0xc300,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_209)
			}
		},
		{
		0xc2dc,
		0xc2e4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_210)
			}
		},
		{
		0xc2b4,
		0xc2b9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_211)
			}
		},
		{
		0xc2a4,
		0xc2ad,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_212)
			}
		},
		{
		0xc298,
		0xc29d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_213)
			}
		},
		{
		0xc27c,
		0xc281,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_214)
			}
		},
		{
		0xc26c,
		0xc274,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_215)
			}
		},
		{
		0xc260,
		0xc266,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_216)
			}
		},
		{
		0xc250,
		0xc258,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_217)
			}
		},
		{
		0xc218,
		0xc234,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_218)
			}
		},
		{
		0xc20c,
		0xc211,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_219)
			}
		},
		{
		0xc1fc,
		0xc204,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_220)
			}
		},
		{
		0xc1e0,
		0xc1e8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_221)
			}
		},
		{
		0xc1d4,
		0xc1d8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_222)
			}
		},
		{
		0xc1c4,
		0xc1cc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_223)
			}
		},
		{
		0xc19c,
		0xc1b0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_224)
			}
		},
		{
		0xc18c,
		0xc196,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_225)
			}
		},
		{
		0xc170,
		0xc17b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_226)
			}
		},
		{
		0xc164,
		0xc169,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_227)
			}
		},
		{
		0xc154,
		0xc15c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_228)
			}
		},
		{
		0xc148,
		0xc14d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_229)
			}
		},
		{
		0xc121,
		0xc140,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_230)
			}
		},
		{
		0xc110,
		0xc115,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_231)
			}
		},
		{
		0xc100,
		0xc108,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_232)
			}
		},
		{
		0xc0f4,
		0xc0f9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_233)
			}
		},
		{
		0xc0e4,
		0xc0ec,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_234)
			}
		},
		{
		0xc0d8,
		0xc0dd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_235)
			}
		},
		{
		0xc0bc,
		0xc0d0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_236)
			}
		},
		{
		0xc0ac,
		0xc0b6,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_237)
			}
		},
		{
		0xc0a0,
		0xc0a5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_238)
			}
		},
		{
		0xc090,
		0xc098,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_239)
			}
		},
		{
		0xc058,
		0xc060,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_240)
			}
		},
		{
		0xbfdc,
		0xbfe1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_241)
			}
		},
		{
		0xbfcc,
		0xbfd4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_242)
			}
		},
		{
		0xbf50,
		0xbf55,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_243)
			}
		},
		{
		0xbf40,
		0xbf48,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_244)
			}
		},
		{
		0xbf18,
		0xbf1d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_245)
			}
		},
		{
		0xbee0,
		0xbee5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_246)
			}
		},
		{
		0xbed0,
		0xbed8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_247)
			}
		},
		{
		0xbe8c,
		0xbe91,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_248)
			}
		},
		{
		0xbe7b,
		0xbe84,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_249)
			}
		},
		{
		0xbe70,
		0xbe75,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_250)
			}
		},
		{
		0xbe54,
		0xbe6a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_251)
			}
		},
		{
		0xbe44,
		0xbe4e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_252)
			}
		},
		{
		0xbe0c,
		0xbe14,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_253)
			}
		},
		{
		0xbe00,
		0xbe05,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_254)
			}
		},
		{
		0xbdf0,
		0xbdf8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_255)
			}
		},
		{
		0xbdd2,
		0xbddc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_256)
			}
		},
		{
		0xbd90,
		0xbd9c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_257)
			}
		},
		{
		0xbd80,
		0xbd8a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_258)
			}
		},
		{
		0xbd64,
		0xbd68,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_259)
			}
		},
		{
		0xbd48,
		0xbd50,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_260)
			}
		},
		{
		0xbd10,
		0xbd14,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_261)
			}
		},
		{
		0xbd04,
		0xbd09,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_262)
			}
		},
		{
		0xbcf4,
		0xbcfd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_263)
			}
		},
		{
		0xbccd,
		0xbcdc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_264)
			}
		},
		{
		0xbcbc,
		0xbcc4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_265)
			}
		},
		{
		0xbcb0,
		0xbcb5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_266)
			}
		},
		{
		0xbca0,
		0xbca8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_267)
			}
		},
		{
		0xbc94,
		0xbc9a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_268)
			}
		},
		{
		0xbc84,
		0xbc8e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_269)
			}
		},
		{
		0xbc40,
		0xbc50,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_270)
			}
		},
		{
		0xbc20,
		0xbc38,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_271)
			}
		},
		{
		0xbc08,
		0xbc13,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_272)
			}
		},
		{
		0xbbf8,
		0xbc02,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_273)
			}
		},
		{
		0xbbc0,
		0xbbc8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_274)
			}
		},
		{
		0xbba4,
		0xbbac,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_275)
			}
		},
		{
		0xbb88,
		0xbb90,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_276)
			}
		},
		{
		0xbb44,
		0xbb58,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_277)
			}
		},
		{
		0xbb34,
		0xbb3e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_278)
			}
		},
		{
		0xbb18,
		0xbb20,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_279)
			}
		},
		{
		0xbb0d,
		0xbb11,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_280)
			}
		},
		{
		0xbafc,
		0xbb04,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_281)
			}
		},
		{
		0xbac4,
		0xbac8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_282)
			}
		},
		{
		0xbab8,
		0xbabd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_283)
			}
		},
		{
		0xbaa8,
		0xbab2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_284)
			}
		},
		{
		0xba83,
		0xba8c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_285)
			}
		},
		{
		0xba70,
		0xba78,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_286)
			}
		},
		{
		0xba64,
		0xba69,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_287)
			}
		},
		{
		0xba38,
		0xba5c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_288)
			}
		},
		{
		0xb9f4,
		0xb9fa,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_289)
			}
		},
		{
		0xb9d8,
		0xb9ec,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_290)
			}
		},
		{
		0xb9c8,
		0xb9cd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_291)
			}
		},
		{
		0xb9bc,
		0xb9c1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_292)
			}
		},
		{
		0xb9ac,
		0xb9b4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_293)
			}
		},
		{
		0xb984,
		0xb98e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_294)
			}
		},
		{
		0xb974,
		0xb97d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_295)
			}
		},
		{
		0xb968,
		0xb96d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_296)
			}
		},
		{
		0xb958,
		0xb960,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_297)
			}
		},
		{
		0xb94c,
		0xb951,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_298)
			}
		},
		{
		0xb93c,
		0xb944,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_299)
			}
		},
		{
		0xb8f8,
		0xb8fd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_300)
			}
		},
		{
		0xb8e8,
		0xb8f0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_301)
			}
		},
		{
		0xb8dd,
		0xb8e1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_302)
			}
		},
		{
		0xb8cc,
		0xb8d4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_303)
			}
		},
		{
		0xb8be,
		0xb8c5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_304)
			}
		},
		{
		0xb8b0,
		0xb8b8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_305)
			}
		},
		{
		0xb878,
		0xb87c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_306)
			}
		},
		{
		0xb86c,
		0xb871,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_307)
			}
		},
		{
		0xb85c,
		0xb864,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_308)
			}
		},
		{
		0xb840,
		0xb844,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_309)
			}
		},
		{
		0xb834,
		0xb839,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_310)
			}
		},
		{
		0xb824,
		0xb82c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_311)
			}
		},
		{
		0xb818,
		0xb81d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_312)
			}
		},
		{
		0xb807,
		0xb810,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_313)
			}
		},
		{
		0xb7fc,
		0xb801,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_314)
			}
		},
		{
		0xb7ec,
		0xb7f4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_315)
			}
		},
		{
		0xb7b4,
		0xb7b8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_316)
			}
		},
		{
		0xb7a8,
		0xb7ad,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_317)
			}
		},
		{
		0xb78c,
		0xb7a0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_318)
			}
		},
		{
		0xb77c,
		0xb784,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_319)
			}
		},
		{
		0xb770,
		0xb775,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_320)
			}
		},
		{
		0xb760,
		0xb768,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_321)
			}
		},
		{
		0xb744,
		0xb74c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_322)
			}
		},
		{
		0xb728,
		0xb730,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_323)
			}
		},
		{
		0xb700,
		0xb705,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_324)
			}
		},
		{
		0xb6f0,
		0xb6fa,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_325)
			}
		},
		{
		0xb6ab,
		0xb6b1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_326)
			}
		},
		{
		0xb69c,
		0xb6a4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_327)
			}
		},
		{
		0xb664,
		0xb668,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_328)
			}
		},
		{
		0xb610,
		0xb618,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_329)
			}
		},
		{
		0xb5cc,
		0xb5d1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_330)
			}
		},
		{
		0xb5bb,
		0xb5c4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_331)
			}
		},
		{
		0xb5a0,
		0xb5b5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_332)
			}
		},
		{
		0xb55c,
		0xb561,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_333)
			}
		},
		{
		0xb540,
		0xb554,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_334)
			}
		},
		{
		0xb530,
		0xb538,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_335)
			}
		},
		{
		0xb524,
		0xb52a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_336)
			}
		},
		{
		0xb514,
		0xb51d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_337)
			}
		},
		{
		0xb4ec,
		0xb4f1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_338)
			}
		},
		{
		0xb4dc,
		0xb4e6,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_339)
			}
		},
		{
		0xb4d0,
		0xb4d5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_340)
			}
		},
		{
		0xb4c0,
		0xb4c8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_341)
			}
		},
		{
		0xb4b5,
		0xb4b9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_342)
			}
		},
		{
		0xb4a4,
		0xb4ac,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_343)
			}
		},
		{
		0xb460,
		0xb466,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_344)
			}
		},
		{
		0xb450,
		0xb458,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_345)
			}
		},
		{
		0xb418,
		0xb420,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_346)
			}
		},
		{
		0xb3c4,
		0xb3e8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_347)
			}
		},
		{
		0xb3a8,
		0xb3ad,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_348)
			}
		},
		{
		0xb38c,
		0xb394,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_349)
			}
		},
		{
		0xb380,
		0xb385,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_350)
			}
		},
		{
		0xb354,
		0xb378,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_351)
			}
		},
		{
		0xb310,
		0xb315,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_352)
			}
		},
		{
		0xb2fc,
		0xb308,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_353)
			}
		},
		{
		0xb2f0,
		0xb2f6,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_354)
			}
		},
		{
		0xb2d8,
		0xb2ea,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_355)
			}
		},
		{
		0xb2c8,
		0xb2d2,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_356)
			}
		},
		{
		0xb2a0,
		0xb2b7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_357)
			}
		},
		{
		0xb28f,
		0xb29a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_358)
			}
		},
		{
		0xb284,
		0xb289,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_359)
			}
		},
		{
		0xb258,
		0xb260,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_360)
			}
		},
		{
		0xb214,
		0xb219,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_361)
			}
		},
		{
		0xb204,
		0xb20c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_362)
			}
		},
		{
		0xb1f9,
		0xb1fd,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_363)
			}
		},
		{
		0xb1e8,
		0xb1f0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_364)
			}
		},
		{
		0xb1cc,
		0xb1d5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_365)
			}
		},
		{
		0xb188,
		0xb19d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_366)
			}
		},
		{
		0xb178,
		0xb182,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_367)
			}
		},
		{
		0xb150,
		0xb160,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_368)
			}
		},
		{
		0xb140,
		0xb148,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_369)
			}
		},
		{
		0xb134,
		0xb139,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_370)
			}
		},
		{
		0xb123,
		0xb12c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_371)
			}
		},
		{
		0xb108,
		0xb11d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_372)
			}
		},
		{
		0xb0e0,
		0xb0e5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_373)
			}
		},
		{
		0xb0d0,
		0xb0d8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_374)
			}
		},
		{
		0xb0c4,
		0xb0c9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_375)
			}
		},
		{
		0xb0b0,
		0xb0bc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_376)
			}
		},
		{
		0xb098,
		0xb0aa,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_377)
			}
		},
		{
		0xb08c,
		0xb091,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_378)
			}
		},
		{
		0xb07c,
		0xb084,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_379)
			}
		},
		{
		0xb044,
		0xb05d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_380)
			}
		},
		{
		0xb00c,
		0xb014,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_381)
			}
		},
		{
		0xb000,
		0xb004,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_382)
			}
		},
		{
		0xaff0,
		0xaff8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_383)
			}
		},
		{
		0xafc7,
		0xafce,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_384)
			}
		},
		{
		0xafb8,
		0xafc0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_385)
			}
		},
		{
		0xaf90,
		0xaf95,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_386)
			}
		},
		{
		0xaf80,
		0xaf88,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_387)
			}
		},
		{
		0xaf3c,
		0xaf49,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_388)
			}
		},
		{
		0xaf2c,
		0xaf34,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_389)
			}
		},
		{
		0xaf06,
		0xaf10,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_390)
			}
		},
		{
		0xaef4,
		0xaefc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_391)
			}
		},
		{
		0xaee6,
		0xaeed,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_392)
			}
		},
		{
		0xaed8,
		0xaedc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_393)
			}
		},
		{
		0xaecc,
		0xaed1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_394)
			}
		},
		{
		0xaebc,
		0xaec4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_395)
			}
		},
		{
		0xae78,
		0xae7d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_396)
			}
		},
		{
		0xae5c,
		0xae70,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_397)
			}
		},
		{
		0xae30,
		0xae56,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_398)
			}
		},
		{
		0xae08,
		0xae0d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_399)
			}
		},
		{
		0xadf8,
		0xae01,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_400)
			}
		},
		{
		0xaddc,
		0xade4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_401)
			}
		},
		{
		0xadc0,
		0xadc8,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_402)
			}
		},
		{
		0xad88,
		0xad90,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_403)
			}
		},
		{
		0xad6c,
		0xad82,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_404)
			}
		},
		{
		0xad50,
		0xad58,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_405)
			}
		},
		{
		0xad44,
		0xad49,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_406)
			}
		},
		{
		0xad34,
		0xad3c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_407)
			}
		},
		{
		0xad29,
		0xad2d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_408)
			}
		},
		{
		0xad0c,
		0xad20,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_409)
			}
		},
		{
		0xacfc,
		0xad06,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_410)
			}
		},
		{
		0xace0,
		0xacf6,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_411)
			}
		},
		{
		0xacb8,
		0xaccc,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_412)
			}
		},
		{
		0xaca8,
		0xacb0,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_413)
			}
		},
		{
		0xac9c,
		0xaca1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_414)
			}
		},
		{
		0xac80,
		0xac94,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_415)
			}
		},
		{
		0xac70,
		0xac7a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_416)
			}
		},
		{
		0xac54,
		0xac5c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_417)
			}
		},
		{
		0xac2c,
		0xac40,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_418)
			}
		},
		{
		0xac1e,
		0xac24,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_419)
			}
		},
		{
		0xac00,
		0xac0a,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_420)
			}
		},
		{
		0x9b41,
		0x9b45,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_421)
			}
		},
		{
		0x97ff,
		0x9803,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_422)
			}
		},
		{
		0x965b,
		0x965f,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_423)
			}
		},
		{
		0x931e,
		0x9322,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_424)
			}
		},
		{
		0x91cb,
		0x91d1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_425)
			}
		},
		{
		0x9149,
		0x914e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_426)
			}
		},
		{
		0x907f,
		0x9084,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_427)
			}
		},
		{
		0x901d,
		0x9023,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_428)
			}
		},
		{
		0x8f1b,
		0x8f1f,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_429)
			}
		},
		{
		0x8cbf,
		0x8cc4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_430)
			}
		},
		{
		0x8ca7,
		0x8cac,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_431)
			}
		},
		{
		0x8301,
		0x8305,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_432)
			}
		},
		{
		0x7d42,
		0x7d46,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_433)
			}
		},
		{
		0x7d17,
		0x7d1b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_434)
			}
		},
		{
		0x7d04,
		0x7d08,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_435)
			}
		},
		{
		0x79bd,
		0x79c1,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_436)
			}
		},
		{
		0x795a,
		0x795e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_437)
			}
		},
		{
		0x701a,
		0x701f,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_438)
			}
		},
		{
		0x6df7,
		0x6dfb,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_439)
			}
		},
		{
		0x6dc3,
		0x6dc7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_440)
			}
		},
		{
		0x6cbb,
		0x6cbf,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_441)
			}
		},
		{
		0x6c92,
		0x6c96,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_442)
			}
		},
		{
		0x6b61,
		0x6b66,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_443)
			}
		},
		{
		0x67cf,
		0x67d4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_444)
			}
		},
		{
		0x672a,
		0x672e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_445)
			}
		},
		{
		0x6664,
		0x6669,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_446)
			}
		},
		{
		0x61c7,
		0x61cb,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_447)
			}
		},
		{
		0x5f69,
		0x5f6d,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_448)
			}
		},
		{
		0x5c38,
		0x5c3c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_449)
			}
		},
		{
		0x5c07,
		0x5c0b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_450)
			}
		},
		{
		0x5be4,
		0x5be9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_451)
			}
		},
		{
		0x5bc2,
		0x5bc7,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_452)
			}
		},
		{
		0x5ba2,
		0x5ba6,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_453)
			}
		},
		{
		0x5b95,
		0x5b9c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_454)
			}
		},
		{
		0x596a,
		0x596e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_455)
			}
		},
		{
		0x540c,
		0x5411,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_456)
			}
		},
		{
		0x53ef,
		0x53f3,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_457)
			}
		},
		{
		0x53e9,
		0x53ed,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_458)
			}
		},
		{
		0x53e1,
		0x53e5,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_459)
			}
		},
		{
		0x5236,
		0x523b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_460)
			}
		},
		{
		0x5167,
		0x516e,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_461)
			}
		},
		{
		0x5143,
		0x5149,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_462)
			}
		},
		{
		0x4f4d,
		0x4f51,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_463)
			}
		},
		{
		0x4f0d,
		0x4f11,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_464)
			}
		},
		{
		0x4ed4,
		0x4ed9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_465)
			}
		},
		{
		0x4e07,
		0x4e0b,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_466)
			}
		},
		{
		0x33c0,
		0x33ca,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_467)
			}
		},
		{
		0x33a3,
		0x33af,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_468)
			}
		},
		{
		0x3388,
		0x338f,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_469)
			}
		},
		{
		0x25a3,
		0x25a9,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_470)
			}
		},
		{
		0x250c,
		0x2542,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_471)
			}
		},
		{
		0x2227,
		0x222c,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_472)
			}
		},
		{
		0x2190,
		0x2199,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_473)
			}
		},
		{
		0x00b6,
		0x00ba,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_474)
			}
		},
		{
		0x00b0,
		0x00b4,
		SCnvConversionData::SOneDirectionData::SRange::EIndexedTable16,
		2,
		0,
			{
			UData_SIndexedTable16(indexedTable16_unicodeToForeign_475)
			}
		},
		{
		0x00a1,
		0xffe6,
		SCnvConversionData::SOneDirectionData::SRange::EKeyedTable1616,
		2,
		0,
			{
			UData_SKeyedTable1616(keyedTable1616_unicodeToForeign_1)
			}
		}
	};

GLDEF_D const SCnvConversionData conversionData=
	{
	SCnvConversionData::EFixedBigEndian,
		{
		ARRAY_LENGTH(foreignVariableByteDataRanges),
		foreignVariableByteDataRanges
		},
		{
		ARRAY_LENGTH(foreignToUnicodeDataRanges),
		foreignToUnicodeDataRanges
		},
		{
		ARRAY_LENGTH(unicodeToForeignDataRanges),
		unicodeToForeignDataRanges
		},
	NULL,
	NULL
	};

